-- MySQL dump 10.13  Distrib 5.1.69, for redhat-linux-gnu (x86_64)
--
-- ------------------------------------------------------
-- Server version	5.1.69

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `child`
--

CREATE DATABASE IF NOT EXISTS bedtime;
USE bedtime;

DROP TABLE IF EXISTS `child`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `child` (
  `user_id` mediumint(9) NOT NULL AUTO_INCREMENT COMMENT 'glue record between tables',
  `name` varchar(32) NOT NULL COMMENT 'The child''s name. Why are you even looking this up?',
  `description` varchar(128) DEFAULT NULL COMMENT 'Description',
  PRIMARY KEY (`user_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='maps child name to description and ID';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `device`
--

DROP TABLE IF EXISTS `device`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `device` (
  `mac` bigint(24) NOT NULL COMMENT 'MAC address. Select with select hex(mac). Insert like values (x''00FF3A55FFDD'')',
  `description` varchar(128) DEFAULT NULL COMMENT 'Description',
  `user_id` mediumint(9) NOT NULL DEFAULT '0' COMMENT 'ID of the child using the device',
  `first_seen` datetime NOT NULL,
  `ip` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`mac`,`user_id`),
  UNIQUE KEY `mac_UNIQUE` (`mac`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='maps device MAC address to user ID and description';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `ground`
--

DROP TABLE IF EXISTS `ground`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ground` (
  `user_id` mediumint(9) NOT NULL COMMENT 'ID of the miscreant',
  `start` datetime NOT NULL COMMENT 'time their punishment starts',
  `end` datetime NOT NULL COMMENT 'time they are off the hook again',
  PRIMARY KEY (`user_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Rules in this table take precedence of bedtimes and rewards';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `manufacturers`
--

DROP TABLE IF EXISTS `manufacturers`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `manufacturers` (
  `mac` bigint(20) NOT NULL COMMENT 'MAC address to look up',
  `short` varchar(16) NOT NULL COMMENT 'short name of the manufacturer',
  `description` varchar(32) DEFAULT NULL COMMENT 'The long description',
  PRIMARY KEY (`mac`),
  UNIQUE KEY `mac_UNIQUE` (`mac`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Lookup table to find manufacturer from MAC';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `manufacturers`
--

LOCK TABLES `manufacturers` WRITE;
/*!40000 ALTER TABLE `manufacturers` DISABLE KEYS */;
INSERT INTO `manufacturers` VALUES (352321536,'Datapoin','DATAPOINT CORPORATION'),(0,'00:00:00','Officially Xerox, but 0:0:0:0:0:'),(16777216,'Xerox','XEROX CORPORATION'),(33554432,'Xerox','XEROX CORPORATION'),(50331648,'Xerox','XEROX CORPORATION'),(67108864,'Xerox','XEROX CORPORATION'),(83886080,'Xerox','XEROX CORPORATION'),(100663296,'Xerox','XEROX CORPORATION'),(117440512,'Xerox','XEROX CORPORATION'),(134217728,'Xerox','XEROX CORPORATION'),(150994944,'Xerox','XEROX CORPORATION'),(167772160,'OmronTat','OMRON TATEISI ELECTRONICS CO.'),(184549376,'Matrix','MATRIX CORPORATION'),(201326592,'Cisco','CISCO SYSTEMS, INC.'),(218103808,'Fibronic','FIBRONICS LTD.'),(234881024,'Fujitsu','FUJITSU LIMITED'),(251658240,'Next','NEXT, INC.'),(268435456,'Hughes',''),(285212672,'Tektrnix',''),(301989888,'Informat','INFORMATION TECHNOLOGY LIMITED'),(318767104,'Camex',''),(335544320,'Netronix',''),(369098752,'DuPontPi','DU PONT PIXEL SYSTEMS     .'),(385875968,'Tekelec',''),(402653184,'WebsterC','WEBSTER COMPUTER CORPORATION'),(419430400,'AppliedD','APPLIED DYNAMICS INTERNATIONAL'),(436207616,'AMD',''),(452984832,'Novell','NOVELL INC.'),(469762048,'BellTech','BELL TECHNOLOGIES'),(486539264,'Cabletro','CABLETRON SYSTEMS, INC.'),(503316480,'TelsistI','TELSIST INDUSTRIA ELECTRONICA'),(520093696,'Telco','Telco Systems, Inc.'),(536870912,'DIAB',''),(553648128,'SC&C',''),(570425344,'VisualTe','VISUAL TECHNOLOGY INC.'),(587202560,'AbbIndus','ABB INDUSTRIAL SYSTEMS AB'),(603979776,'Olicom',''),(620756992,'Ramtek','RAMTEK CORP.'),(637534208,'Sha-Ken','SHA-KEN CO., LTD.'),(654311424,'JapanRad','JAPAN RADIO COMPANY'),(671088640,'Prodigy','PRODIGY SYSTEMS CORPORATION'),(687865856,'ImcNetwo','IMC NETWORKS CORP.'),(704643072,'Trw-Sedd','TRW - SEDD/INP'),(721420288,'CrispAut','CRISP AUTOMATION, INC'),(738197504,'Autotote','AUTOTOTE LIMITED'),(754974720,'Chromati','CHROMATICS INC'),(771751936,'SocieteE','SOCIETE EVIRA'),(788529152,'Timeplex','TIMEPLEX INC.'),(805306368,'VgLabora','VG LABORATORY SYSTEMS LTD'),(822083584,'QpsxComm','QPSX COMMUNICATIONS PTY LTD'),(838860800,'Marconi','Marconi plc'),(855638016,'EganMach','EGAN MACHINERY COMPANY'),(872415232,'NetworkR','NETWORK RESOURCES CORPORATION'),(889192448,'Spectrag','SPECTRAGRAPHICS CORPORATION'),(905969664,'Atari','ATARI CORPORATION'),(922746880,'OxfordMe','OXFORD METRICS LIMITED'),(939524096,'CssLabs','CSS LABS'),(956301312,'Toshiba','TOSHIBA CORPORATION'),(973078528,'Chyron','CHYRON CORPORATION'),(989855744,'IControl','i Controls, Inc.'),(1006632960,'Auspex','AUSPEX SYSTEMS INC.'),(1023410176,'AT&T',''),(1040187392,'Simpact',''),(1056964608,'Syntrex','SYNTREX, INC.'),(1073741824,'Applicon','APPLICON, INC.'),(1090519040,'Ice','ICE CORPORATION'),(1107296256,'MetierMa','METIER MANAGEMENT SYSTEMS LTD.'),(1124073472,'MicroTec','MICRO TECHNOLOGY'),(1140850688,'Castelle','CASTELLE CORPORATION'),(1157627904,'FordAero','FORD AEROSPACE & COMM. CORP.'),(1174405120,'ISC-BR',''),(1191182336,'NicoletI','NICOLET INSTRUMENTS CORP.'),(1207959552,'SeikoEps','SEIKO EPSON CORPORATION'),(1224736768,'ApricotC','APRICOT COMPUTERS, LTD'),(1241513984,'AdcCoden','ADC CODENOLL TECHNOLOGY CORP.'),(1258291200,'APT',''),(1275068416,'Nec','NEC CORPORATION'),(1291845632,'Dci','DCI CORPORATION'),(1308622848,'Ampex','AMPEX CORPORATION'),(1325400064,'Logicraf','LOGICRAFT, INC.'),(1342177280,'Radisys','RADISYS CORPORATION'),(1358954496,'HobElect','HOB ELECTRONIC GMBH & CO. KG'),(1375731712,'Intrusio','Intrusion.com, Inc.'),(1392508928,'Compucor','COMPUCORP'),(1409286144,'Modicon','MODICON, INC.'),(1426063360,'AT&T',''),(1442840576,'DrBStruc','DR. B. STRUCK'),(1459617792,'Scitex','SCITEX CORPORATION LTD.'),(1476395008,'RacoreCo','RACORE COMPUTER PRODUCTS INC.'),(1493172224,'Hellige','HELLIGE GMBH'),(1509949440,'Syskonne','SysKonnect GmbH'),(1526726656,'EltecEle','ELTEC ELEKTRONIK AG'),(1543503872,'Telemati','TELEMATICS INTERNATIONAL INC.'),(1560281088,'CsTeleco','CS TELECOM'),(1577058304,'UscInfor','USC INFORMATION SCIENCES INST'),(1593835520,'Sumitomo','SUMITOMO ELECTRIC IND., LTD.'),(1610612736,'KontronE','KONTRON ELEKTRONIK GMBH'),(1627389952,'GatewayC','GATEWAY COMMUNICATIONS'),(1644167168,'Hneywell','Honeywell'),(1660944384,'HP',''),(1677721600,'Yokogawa','YOKOGAWA DIGITAL COMPUTER CORP'),(1694498816,'NetworkG','Network General Corporation'),(1711276032,'Talaris','TALARIS SYSTEMS, INC.'),(1728053248,'Soft*Rit','SOFT * RITE, INC.'),(1744830464,'Rosemoun','ROSEMOUNT CONTROLS'),(1761607680,'SGI',''),(1778384896,'Computer','COMPUTER CONSOLES INC.'),(1795162112,'MIPS',''),(1811939328,'Private',''),(1828716544,'CrayComm','CRAY COMMUNICATIONS, LTD.'),(1845493760,'Artisoft','ARTISOFT, INC.'),(1862270976,'Madge','Madge Ltd.'),(1879048192,'Hcl','HCL LIMITED'),(1895825408,'Adra','ADRA SYSTEMS INC.'),(1912602624,'Miniware','MINIWARE TECHNOLOGY'),(1929379840,'Siecor','SIECOR CORPORATION'),(1946157056,'Ricoh','RICOH COMPANY LTD.'),(1962934272,'NortelNe','Nortel Networks'),(1979711488,'AbekasVi','ABEKAS VIDEO SYSTEM'),(1996488704,'Interpha','INTERPHASE CORPORATION'),(2013265920,'Labtam','LABTAM LIMITED'),(2030043136,'Networth','NETWORTH INCORPORATED'),(2046820352,'Ardent',''),(2063597568,'Research','RESEARCH MACHINES'),(2080374784,'Ampere','AMPERE INCORPORATED'),(2097152000,'Cray',''),(2113929216,'Clustrix','CLUSTRIX CORPORATION'),(2130706432,'Linotype','LINOTYPE-HELL AG'),(2147483648,'CrayComm','CRAY COMMUNICATIONS A/S'),(2164260864,'BayNetwo','BAY NETWORKS'),(2181038080,'LectraSy','LECTRA SYSTEMES SA'),(2197815296,'TadpoleT','TADPOLE TECHNOLOGY PLC'),(2214592512,'Supernet',''),(2231369728,'Canon','CANON INC.'),(2248146944,'Megahert','MEGAHERTZ CORPORATION'),(2264924160,'Hitachi','HITACHI, LTD.'),(2281701376,'BrocadeC','Brocade Communications Systems, '),(2298478592,'Cayman','CAYMAN SYSTEMS INC.'),(2315255808,'Datahous','DATAHOUSE INFORMATION SYSTEMS'),(2332033024,'Infotron',''),(2348810240,'AlloyCom','Alloy Computer Products (Austral'),(2365587456,'Cryptek','Cryptek Inc.'),(2382364672,'Solbourn','SOLBOURNE COMPUTER, INC.'),(2399141888,'Raytheon',''),(2415919104,'Microcom',''),(2432696320,'Anritsu','ANRITSU CORPORATION'),(2449473536,'CogentDa','COGENT DATA TECHNOLOGIES'),(2466250752,'Proteon','PROTEON INC.'),(2483027968,'AsanteTe','ASANTE TECHNOLOGIES'),(2499805184,'SonyTekt','SONY TEKTRONIX CORP.'),(2516582400,'MarconiE','MARCONI ELECTRONICS LTD.'),(2533359616,'Emc','EMC Corporation'),(2550136832,'Crosscom','CROSSCOMM CORPORATION'),(2566914048,'Mtx','MTX, INC.'),(2583691264,'RcComput','RC COMPUTER A/S'),(2600468480,'Informat','INFORMATION INTERNATIONAL, INC'),(2617245696,'RolmMil-','ROLM MIL-SPEC COMPUTERS'),(2634022912,'LocusCom','LOCUS COMPUTING CORPORATION'),(2650800128,'MarliSA','MARLI S.A.'),(2667577344,'Amerista','AMERISTAR TECHNOLOGIES INC.'),(2684354560,'SanyoEle','SANYO Electric Co., Ltd.'),(2701131776,'Marquett','MARQUETTE ELECTRIC CO.'),(2717908992,'BayNetwo','BAY NETWORKS'),(2734686208,'NAT',''),(2751463424,'AcornCom','ACORN COMPUTERS LIMITED'),(2768240640,'CSC',''),(2785017856,'NetworkG','NETWORK GENERAL CORPORATION'),(2801795072,'NCD',''),(2818572288,'StratusC','STRATUS COMPUTER INC.'),(2835349504,'NetSys','Network Systems'),(2852126720,'Xerox','XEROX CORPORATION'),(2868903936,'LogicMod','LOGIC MODELING CORPORATION'),(2885681152,'ConwareC','CONWARE COMPUTER CONSULTING'),(2902458368,'BrukerIn','BRUKER INSTRUMENTS INC.'),(2919235584,'Dassault','DASSAULT ELECTRONIQUE'),(2936012800,'NuclearD','NUCLEAR DATA INSTRUMENTATION'),(2952790016,'Rnd-RadN','RND-RAD NETWORK DEVICES'),(2969567232,'AlphaMic','ALPHA MICROSYSTEMS INC.'),(2986344448,'Televide','TELEVIDEO SYSTEMS, INC.'),(3003121664,'Cimlinc','CIMLINC INCORPORATED'),(3019898880,'EdimaxCo','EDIMAX COMPUTER COMPANY'),(3036676096,'Databili','DATABILITY SOFTWARE SYS. INC.'),(3053453312,'Micro-Ma','MICRO-MATIC RESEARCH'),(3070230528,'DoveComp','DOVE COMPUTER CORPORATION'),(3087007744,'Seikosha','SEIKOSHA CO., LTD.'),(3103784960,'Mcdonnel','MCDONNELL DOUGLAS COMPUTER SYS'),(3120562176,'Siig','SIIG, INC.'),(3137339392,'Tri-Data',''),(3154116608,'Rockwell','Rockwell Automation'),(3170893824,'Mitsubis','MITSUBISHI CABLE COMPANY'),(3187671040,'NtiGroup','THE NTI GROUP'),(3204448256,'Symmetri','SYMMETRIC COMPUTER SYSTEMS'),(3221225472,'WesternD','WESTERN DIGITAL CORPORATION'),(3238002688,'Madge','Madge Ltd.'),(3254779904,'Informat','INFORMATION PRESENTATION TECH.'),(3271557120,'HarrisCo','HARRIS CORP COMPUTER SYS DIV'),(3288334336,'WatersDi','WATERS DIV. OF MILLIPORE'),(3305111552,'Farallon','FARALLON COMPUTING/NETOPIA'),(3321888768,'Eon','EON SYSTEMS'),(3338665984,'Arix','ARIX CORPORATION'),(3355443200,'AltosCom','ALTOS COMPUTER SYSTEMS'),(3372220416,'Emulex','Emulex Corporation'),(3388997632,'ArrisInt','ARRIS International'),(3405774848,'Compu-Sh','COMPU-SHACK ELECTRONIC GMBH'),(3422552064,'Densan','DENSAN CO., LTD.'),(3439329280,'AlliedTe','Allied Telesis Labs Ltd'),(3456106496,'Megadata','MEGADATA CORP.'),(3472883712,'HayesMic','HAYES MICROCOMPUTER PRODUCTS'),(3489660928,'Develcon','DEVELCON ELECTRONICS LTD.'),(3506438144,'Adaptec','ADAPTEC INCORPORATED'),(3523215360,'Sbe','SBE, INC.'),(3539992576,'WangLabo','WANG LABORATORIES INC.'),(3556769792,'PureData','PURE DATA LTD.'),(3573547008,'Microgno','MICROGNOSIS INTERNATIONAL'),(3590324224,'PunchLin','PUNCH LINE HOLDING'),(3607101440,'Dartmout','DARTMOUTH COLLEGE'),(3623878656,'Novell','NOVELL, INC.'),(3640655872,'NipponTe','NIPPON TELEGRAPH & TELEPHONE'),(3657433088,'Atex',''),(3674210304,'BritishT','British Telecommunications plc'),(3690987520,'HayesMic','HAYES MICROCOMPUTER PRODUCTS'),(3707764736,'Gould',''),(3724541952,'Unigraph',''),(3741319168,'BellHowe','BELL & HOWELL PUB SYS DIV'),(3758096384,'Quadram','QUADRAM CORP.'),(3774873600,'Hitachi',''),(3791650816,'AcerTech','ACER TECHNOLOGIES CORP.'),(3808428032,'Integrat','INTEGRATED MICRO PRODUCTS LTD'),(3825205248,'In2Group','IN2 GROUPE INTERTECHNIQUE'),(3841982464,'Sigmex','SIGMEX LTD.'),(3858759680,'AptorPro','APTOR PRODUITS DE COMM INDUST'),(3875536896,'StarGate','STAR GATE TECHNOLOGIES'),(3892314112,'AcctonTe','ACCTON TECHNOLOGY CORP.'),(3909091328,'Isicad','ISICAD, INC.'),(3925868544,'Upnod','UPNOD AB'),(3942645760,'Matsushi','MATSUSHITA COMM. IND. CO. LTD.'),(3959422976,'Micropro','MICROPROCESS'),(3976200192,'April',''),(3992977408,'NetworkD','NETWORK DESIGNERS, LTD.'),(4009754624,'Kti',''),(4026531840,'SamsungE','SAMSUNG ELECTRONICS CO., LTD.'),(4043309056,'MagnaCom','MAGNA COMPUTER CORPORATION'),(4060086272,'SpiderCo','SPIDER COMMUNICATIONS'),(4076863488,'GandalfD','GANDALF DATA LIMITED'),(4093640704,'AlliedTe','Allied Telesis'),(4110417920,'DiamondS','DIAMOND SALES LIMITED'),(4127195136,'Madge',''),(4143972352,'YouthKee','YOUTH KEEP ENTERPRISE CO LTD'),(4160749568,'DigitalE','DIGITAL EQUIPMENT CORPORATION'),(4177526784,'Quotron','QUOTRON SYSTEMS INC.'),(4194304000,'Microsag','MICROSAGE COMPUTER SYSTEMS INC'),(4211081216,'RechnerZ','RECHNER ZUR KOMMUNIKATION'),(4227858432,'Meiko',''),(4244635648,'HighLeve','HIGH LEVEL HARDWARE'),(4261412864,'Annapoli','ANNAPOLIS MICRO SYSTEMS'),(4278190080,'CamtecEl','CAMTEC ELECTRONICS LTD.'),(4294967296,'EquipTra','EQUIP`TRANS'),(4311744512,'Private',''),(4328521728,'3com','3COM CORPORATION'),(4345298944,'3com','3COM CORPORATION'),(4362076160,'Dvico','DVICO Co., Ltd.'),(4378853376,'Beckhoff','Beckhoff Automation GmbH'),(4395630592,'TewsDate','Tews Datentechnik GmbH'),(4412407808,'Leiser','Leiser GmbH'),(4429185024,'AvlabTec','AVLAB Technology, Inc.'),(4445962240,'NaganoJa','Nagano Japan Radio Co., Ltd.'),(4462739456,'CisTechn','CIS TECHNOLOGY INC.'),(4479516672,'SpaceCyb','Space CyberLink, Inc.'),(4496293888,'SystemTa','System Talks Inc.'),(4513071104,'Coreco','CORECO, INC.'),(4529848320,'Bri-Link','Bri-Link Technologies Co., Ltd'),(4546625536,'BrocadeC','Brocade Communications Systems, '),(4563402752,'GothamNe','Gotham Networks'),(4580179968,'Idigm','iDigm Inc.'),(4596957184,'SharkMul','Shark Multimedia Inc.'),(4613734400,'Olympus','OLYMPUS CORPORATION'),(4630511616,'KandaTsu','KANDA TSUSHIN KOGYO CO., LTD.'),(4647288832,'Extratec','EXTRATECH CORPORATION'),(4664066048,'Netspect','Netspect Technologies, Inc.'),(4680843264,'Canal+','CANAL +'),(4697620480,'EzDigita','EZ Digital Co., Ltd.'),(4714397696,'RtunetAu','RTUnet (Australia)'),(4731174912,'Hoffmann','Hoffmann und Burmeister GbR'),(4747952128,'UnizoneT','Unizone Technologies, Inc.'),(4764729344,'Universa','Universal Talkware Corporation'),(4781506560,'Centilli','Centillium Communications'),(4798283776,'Precidia','Precidia Technologies, Inc.'),(4815060992,'RcNetwor','RC Networks, Inc.'),(4831838208,'Oscilloq','OSCILLOQUARTZ S.A.'),(4848615424,'Watchgua','Watchguard Technologies, Inc.'),(4865392640,'TrendCom','Trend Communications, Ltd.'),(4882169856,'DigitalE','DIGITAL ELECTRONICS CORP.'),(4898947072,'Acer','Acer Incorporated'),(4915724288,'YaesuMus','YAESU MUSEN CO., LTD.'),(4932501504,'PacLabs','PAC Labs'),(4949278720,'OpenNetw','OPEN Networks Pty Ltd'),(4966055936,'Enjoyweb','EnjoyWeb, Inc.'),(4982833152,'Dfi','DFI Inc.'),(4999610368,'Telemati','Telematica Sistems Inteligente'),(5016387584,'Telenet','TELENET Co., Ltd.'),(5033164800,'AravoxTe','Aravox Technologies, Inc.'),(5049942016,'KomodoTe','Komodo Technology'),(5066719232,'PcPartne','PC Partner Ltd.'),(5083496448,'Twinhead','Twinhead International Corp'),(5100273664,'ExtremeN','Extreme Networks'),(5117050880,'BoschSec','Bosch Security Systems, Inc.'),(5133828096,'Dranetz-','Dranetz - BMI'),(5150605312,'KyowaEle','KYOWA Electronic Instruments C'),(5167382528,'Selectro','Selectron Systems AG'),(5184159744,'Kdc','KDC Corp.'),(5200936960,'Cybertan','CyberTAN Technology, Inc.'),(5217714176,'ItFarm','IT Farm Corporation'),(5234491392,'XaviTech','XAVi Technologies Corp.'),(5251268608,'PointMul','Point Multimedia Systems'),(5268045824,'ShelcadC','SHELCAD COMMUNICATIONS, LTD.'),(5284823040,'Bna','BNA SYSTEMS'),(5301600256,'Tiw','TIW SYSTEMS'),(5318377472,'Riscstat','RiscStation Ltd.'),(5335154688,'AscomTat','Ascom Tateco AB'),(5351931904,'Neighbor','Neighbor World Co., Ltd.'),(5368709120,'Sendtek','Sendtek Corporation'),(5385486336,'CablePri','CABLE PRINT'),(5402263552,'Cisco','CISCO SYSTEMS, INC.'),(5419040768,'Cisco','CISCO SYSTEMS, INC.'),(5435817984,'Emc','EMC Corporation'),(5452595200,'Winsyste','WINSYSTEMS, INC.'),(5469372416,'TescoCon','Tesco Controls, Inc.'),(5486149632,'ZhoneTec','Zhone Technologies'),(5502926848,'X-Traweb','X-traWeb Inc.'),(5519704064,'TDTTrans','T.D.T. Transfer Data Test GmbH'),(5536481280,'Sony','Sony Corporation'),(5553258496,'Ennovate','Ennovate Networks, Inc.'),(5570035712,'Berkeley','Berkeley Process Control'),(5586812928,'ShinKinE','Shin Kin Enterprises Co., Ltd'),(5603590144,'WinEnter','WIN Enterprises, Inc.'),(5620367360,'Adtran','ADTRAN INC'),(5637144576,'GilatCom','GILAT COMMUNICATIONS, LTD.'),(5653921792,'Ensemble','Ensemble Communications'),(5670699008,'Chromate','CHROMATEK INC.'),(5687476224,'ArchtekT','ARCHTEK TELECOM CORPORATION'),(5704253440,'G3m','G3M Corporation'),(5721030656,'PromiseT','Promise Technology, Inc.'),(5737807872,'Firewire','FIREWIREDIRECT.COM, INC.'),(5754585088,'Syswave','SYSWAVE CO., LTD'),(5771362304,'ElectroI','Electro Industries/Gauge Tech'),(5788139520,'S1','S1 Corporation'),(5804916736,'DigitalV','Digital Video Broadcasting'),(5821693952,'ItaltelS','ITALTEL S.p.A/RF-UP-I'),(5838471168,'Cadant','CADANT INC.'),(5855248384,'Oracle','Oracle Corporation'),(5872025600,'BestTech','BEST TECHNOLOGY CO., LTD.'),(5888802816,'DigitalD','DIGITAL DESIGN GmbH'),(5905580032,'Elmex','ELMEX Co., LTD.'),(5922357248,'MetaMach','Meta Machine Technology'),(5939134464,'CygnetTe','Cygnet Technologies, Inc.'),(5955911680,'Cisco','CISCO SYSTEMS, INC.'),(5972688896,'Cisco','CISCO SYSTEMS, INC.'),(5989466112,'Airswitc','AirSwitch Corporation'),(6006243328,'TcGroup','TC GROUP A/S'),(6023020544,'HiokiEE','HIOKI E.E. CORPORATION'),(6039797760,'Vitana','VITANA CORPORATION'),(6056574976,'Celestix','Celestix Networks Pte Ltd.'),(6073352192,'Alitec',''),(6090129408,'Lightchi','LightChip, Inc.'),(6106906624,'Foxconn',''),(6123683840,'Carrierc','CarrierComm Inc.'),(6140461056,'Conklin','Conklin Corporation'),(6157238272,'Inkel','Inkel Corp.'),(6174015488,'EseEmbed','ESE Embedded System Engineer`g'),(6190792704,'AlliedDa','Allied Data Technologies'),(6207569920,'Technola','TechnoLand Co., LTD.'),(6224347136,'Amcc',''),(6241124352,'Cyberopt','CyberOptics Corporation'),(6257901568,'RadiantC','Radiant Communications Corp.'),(6274678784,'OrientSi','Orient Silver Enterprises'),(6291456000,'Edsl',''),(6308233216,'Margi','MARGI Systems, Inc.'),(6325010432,'Wireless','WIRELESS TECHNOLOGY, INC.'),(6341787648,'ChengduM','Chengdu Maipu Electric Industria'),(6358564864,'Heidelbe','Heidelberger Druckmaschinen AG'),(6375342080,'Ag-E','AG-E GmbH'),(6392119296,'Thermoqu','ThermoQuest'),(6408896512,'AdtekSys','ADTEK System Science Co., Ltd.'),(6425673728,'Experien','Experience Music Project'),(6442450944,'Aopen','AOpen, Inc.'),(6459228160,'NortelNe','Nortel Networks'),(6476005376,'DicaTech','DICA TECHNOLOGIES AG'),(6492782592,'AniteTel','ANITE TELECOMS'),(6509559808,'SiebMeye','SIEB & MEYER AG'),(6526337024,'HitachiA','Hitachi Aloka Medical, Ltd.'),(6543114240,'UweDisch','Uwe Disch'),(6559891456,'I2se','I2SE GmbH'),(6576668672,'LxcoTech','LXCO Technologies ag'),(6593445888,'Refracti','Refraction Technology, Inc.'),(6610223104,'RoiCompu','ROI COMPUTER AG'),(6627000320,'Netlinks','NetLinks Co., Ltd.'),(6643777536,'MegaVisi','Mega Vision'),(6660554752,'AudesiTe','AudeSi Technologies'),(6677331968,'Logitec','Logitec Corporation'),(6694109184,'Kenetec','Kenetec, Inc.'),(6710886400,'Smk-M',''),(6727663616,'SyredDat','SYRED Data Systems'),(6744440832,'TexasDig','Texas Digital Systems'),(6761218048,'HanbyulT','Hanbyul Telecom Co., Ltd.'),(6777995264,'CapitalE','Capital Equipment Corporation'),(6794772480,'SenaTech','Sena Technologies, Inc.'),(6811549696,'Cisco','CISCO SYSTEMS, INC.'),(6828326912,'Cisco','CISCO SYSTEMS, INC.'),(6845104128,'DarimVis','Darim Vision'),(6861881344,'HeiseiEl','HeiSei Electronics'),(6878658560,'Leunig','LEUNIG GmbH'),(6895435776,'KyotoMic','Kyoto Microcomputer Co., Ltd.'),(6912212992,'JdsUniph','JDS Uniphase Inc.'),(6928990208,'E-Contro','E-Control Systems, Inc.'),(6945767424,'EssTechn','ESS Technology, Inc.'),(6962544640,'Readynet',''),(6979321856,'Infinili','Infinilink Corporation'),(6996099072,'Mag-Tek','Mag-Tek, Inc.'),(7012876288,'Logical','Logical Co., Ltd.'),(7029653504,'GenesysL','GENESYS LOGIC, INC.'),(7046430720,'Microlin','Microlink Corporation'),(7063207936,'Nextcomm','Nextcomm, Inc.'),(7079985152,'Scientif','Scientific-Atlanta Arcodan A/S'),(7096762368,'UnexTech','UNEX TECHNOLOGY CORPORATION'),(7113539584,'Welltech','Welltech Computer Co., Ltd.'),(7130316800,'Bmw','BMW AG'),(7147094016,'AirspanC','Airspan Communications, Ltd.'),(7163871232,'MainStre','Main Street Networks'),(7180648448,'SitaraNe','Sitara Networks, Inc.'),(7197425664,'CoachMas','Coach Master International  d.b.'),(7214202880,'TrexEnte','Trex Enterprises'),(7230980096,'EmersonN','Emerson Network Power'),(7247757312,'FulltekT','Fulltek Technology Co., Ltd.'),(7264534528,'GeneralB','General Bandwidth'),(7281311744,'DigitalP','Digital Processing Systems, Inc.'),(7298088960,'Precisio','Precision Electronic Manufacturi'),(7314866176,'Wayport','Wayport, Inc.'),(7331643392,'TurinNet','Turin Networks, Inc.'),(7348420608,'SaejinT&','SAEJIN T&M Co., Ltd.'),(7365197824,'Centos','Centos, Inc.'),(7381975040,'Netsensi','Netsensity, Inc.'),(7398752256,'SkfCondi','SKF Condition Monitoring'),(7415529472,'Ic-Net','IC-Net, Inc.'),(7432306688,'Frequent','Frequentis'),(7449083904,'Brains','Brains Corporation'),(7465861120,'Peterson','Peterson Electro-Musical Product'),(7482638336,'Gigalink','Gigalink Co., Ltd.'),(7499415552,'Teleforc','Teleforce Co., Ltd.'),(7516192768,'Compulab','CompuLab, Ltd.'),(7532969984,'VitesseS','Vitesse Semiconductor Corporatio'),(7549747200,'ArkResea','ARK Research Corp.'),(7566524416,'Acromag','Acromag, Inc.'),(7583301632,'Neowave','NeoWave, Inc.'),(7600078848,'SimplerN','Simpler Networks'),(7616856064,'QuarryTe','Quarry Technologies'),(7633633280,'Cisco','CISCO SYSTEMS, INC.'),(7650410496,'ThomasCo','THOMAS CONRAD CORP.'),(7667187712,'Cisco','CISCO SYSTEMS, INC.'),(7683964928,'GeocastN','Geocast Network Systems, Inc.'),(7700742144,'Evr',''),(7717519360,'JapanTot','Japan Total Design Communication'),(7734296576,'Artem',''),(7751073792,'CustomMi','Custom Micro Products, Ltd.'),(7767851008,'AlphaDat','Alpha Data Parallel Systems, Ltd'),(7784628224,'Vitalpoi','VitalPoint, Inc.'),(7801405440,'ConetCom','CoNet Communications, Inc.'),(7818182656,'Inxtron','inXtron, Inc.'),(7834959872,'Paxcomm','PAXCOMM, Inc.'),(7851737088,'LeisureT','Leisure Time, Inc.'),(7868514304,'HaedongI','HAEDONG INFO & COMM CO., LTD'),(7885291520,'Manrolan','manroland AG'),(7902068736,'F5Networ','F5 Networks, Inc.'),(7918845952,'Teltroni','Teltronics, Inc.'),(7935623168,'Sigma','Sigma, Inc.'),(7952400384,'Wincomm','WINCOMM Corporation'),(7969177600,'FreecomT','Freecom Technologies GmbH'),(7985954816,'Activete','Activetelco'),(8002732032,'AvailNet','Avail Networks'),(8019509248,'Trango','Trango Systems, Inc.'),(8036286464,'IsdnComm','ISDN Communications, Ltd.'),(8053063680,'Fast','Fast Systems, Inc.'),(8069840896,'KinpoEle','Kinpo Electronics, Inc.'),(8086618112,'AndoElec','Ando Electric Corporation'),(8103395328,'Siemens','Siemens AG'),(8120172544,'Sitera','Sitera, Inc.'),(8136949760,'Supernet','Supernet, Inc.'),(8153726976,'Hewlett-','Hewlett-Packard Company'),(8170504192,'Hewlett-','Hewlett-Packard Company'),(8187281408,'Force10N','Force10 Networks, Inc.'),(8204058624,'LittonMa','Litton Marine Systems B.V.'),(8220835840,'Cirilium','Cirilium Corp.'),(8237613056,'C-Com','C-COM Corporation'),(8254390272,'Ericsson','Ericsson Group'),(8271167488,'Seta','SETA Corp.'),(8287944704,'ComtrolE','Comtrol Europe, Ltd.'),(8304721920,'CamtelTe','Camtel Technology Corp.'),(8321499136,'Tridium','Tridium, Inc.'),(8338276352,'Innovati','Innovative Concepts, Inc.'),(8355053568,'MarkOfUn','Mark of the Unicorn, Inc.'),(8371830784,'Qps','QPS, Inc.'),(8388608000,'Enterasy','Enterasys Networks'),(8405385216,'ErimSA','ERIM S.A.'),(8422162432,'Associat','Association of Musical Electroni'),(8438939648,'ImageDis','Image Display Systems, Inc.'),(8455716864,'TexioTec','Texio Technology Corporation'),(8472494080,'Teraglob','TeraGlobal Communications Corp.'),(8489271296,'Compaq',''),(8506048512,'DotopTec','DoTop Technology, Inc.'),(8522825728,'Keyence','Keyence Corporation'),(8539602944,'DigitalV','Digital Voice Systems, Inc.'),(8556380160,'DigitalE','DIGITAL EQUIPMENT CORPORATION'),(8573157376,'DataDire','Data Direct Networks, Inc.'),(8589934592,'NetSys','Net & Sys Co., Ltd.'),(8606711808,'IfmElect','IFM Electronic gmbh'),(8623489024,'AminoCom','Amino Communications, Ltd.'),(8640266240,'Woonsang','Woonsang Telecom, Inc.'),(8657043456,'Novell',''),(8673820672,'HitachiD','Hitachi Denshi, Ltd.'),(8690597888,'TelitalR','Telital R&D Denmark A/S'),(8707375104,'Visiongl','VisionGlobal Network Corp.'),(8724152320,'UnifyNet','Unify Networks, Inc.'),(8740929536,'Shenzhen','Shenzhen SED Information Technol'),(8757706752,'Gefran','Gefran Spa'),(8774483968,'NativeNe','Native Networks, Inc.'),(8791261184,'Metro-Op','Metro-Optix'),(8808038400,'Micronpc','Micronpc.com'),(8824815616,'EciTelec','ECI Telecom, Ltd'),(8841592832,'Aatr',''),(8858370048,'Fenecom',''),(8875147264,'NatureWo','Nature Worldwide Technology Corp'),(8891924480,'Sierraco','SierraCom'),(8908701696,'SDEL','S.D.E.L.'),(8925478912,'Dtvro',''),(8942256128,'CotasCom','Cotas Computer Technology A/B'),(8959033344,'Cisco','CISCO SYSTEMS, INC.'),(8975810560,'Cisco','CISCO SYSTEMS, INC.'),(8992587776,'Advanced','Advanced Scientific Corp'),(9009364992,'ParalonT','Paralon Technologies'),(9026142208,'ZumaNetw','Zuma Networks'),(9042919424,'Kollmorg','Kollmorgen-Servotronix'),(9059696640,'NetworkE','Network Elements, Inc.'),(9076473856,'DataGene','Data General Communication Ltd.'),(9093251072,'SimtelSR','SIMTEL S.R.L.'),(9110028288,'Aculab','Aculab PLC'),(9126805504,'CanonFin','CANON FINETECH INC.'),(9143582720,'DspAppli','DSP Application, Ltd.'),(9160359936,'Chromisy','Chromisys, Inc.'),(9177137152,'Clicktv',''),(9193914368,'C-Cor',''),(9210691584,'OneStop','One Stop Systems'),(9227468800,'Xesystem','XESystems, Inc.'),(9244246016,'EsdElect','ESD Electronic System Design Gmb'),(9261023232,'Necsom','Necsom, Ltd.'),(9277800448,'Adtec','Adtec Corporation'),(9294577664,'AsoundEl','Asound Electronic'),(9311354880,'Saxa','SAXA, Inc.'),(9328132096,'AbbBomem','ABB Bomem, Inc.'),(9344909312,'Agere','Agere Systems'),(9361686528,'TeacR&D','TEAC Corp. R& D'),(9378463744,'P-Cube','P-Cube, Ltd.'),(9395240960,'Intersof','Intersoft Electronics'),(9412018176,'Axis',''),(9428795392,'Avision','Avision, Inc.'),(9445572608,'MantraCo','Mantra Communications, Inc.'),(9462349824,'Imperial','Imperial Technology, Inc.'),(9479127040,'ParagonN','Paragon Networks International'),(9495904256,'Init','INIT GmbH'),(9512681472,'CosmoRes','Cosmo Research Corp.'),(9529458688,'SeromeTe','Serome Technology, Inc.'),(9546235904,'Visicom',''),(9563013120,'ZskStick','ZSK Stickmaschinen GmbH'),(9579790336,'Ericsson',''),(9596567552,'Creative','Creative Technology, Ltd.'),(9613344768,'Cisco','Cisco Systems, Inc.'),(9630121984,'SeltaTel','Selta Telematica S.p.a'),(9646899200,'CompalEl','Compal Electronics, Inc.'),(9663676416,'Seedek','Seedek Co., Ltd.'),(9680453632,'AmerCom','Amer.com'),(9697230848,'Videofra','Videoframe Systems'),(9714008064,'Raysis','Raysis Co., Ltd.'),(9730785280,'SurecomT','SURECOM Technology Co.'),(9747562496,'Lampus','Lampus Co, Ltd.'),(9764339712,'All-WinT','All-Win Tech Co., Ltd.'),(9781116928,'GreatDra','Great Dragon Information Technol'),(9797894144,'Pilz','Pilz GmbH & Co.'),(9814671360,'AvivInfo','Aviv Infocom Co, Ltd.'),(9831448576,'Cisco','CISCO SYSTEMS, INC.'),(9848225792,'Cisco','CISCO SYSTEMS, INC.'),(9865003008,'Sibyte','SiByte, Inc.'),(9881780224,'Mannesma','Mannesman Dematic Colby Pty. Ltd'),(9898557440,'Datacard','Datacard Group'),(9915334656,'IpmDatac','IPM Datacom S.R.L.'),(9932111872,'GeyserNe','Geyser Networks, Inc.'),(9948889088,'SomaNetw','Soma Networks, Inc.'),(9965666304,'Carrier','Carrier Corporation'),(9982443520,'Televide','Televideo, Inc.'),(9999220736,'Worldgat','WorldGate'),(10015997952,'Ibm','IBM Corp'),(10032775168,'AlphaPro','Alpha Processor, Inc.'),(10049552384,'Microcom','Microcom Corp.'),(10066329600,'FlyingPa','Flying Packets Communications'),(10083106816,'TsannKue','Tsann Kuen China (Shanghai)Enter'),(10099884032,'CatenaNe','Catena Networks'),(10116661248,'Cambridg','Cambridge Silicon Radio'),(10133438464,'SciKunsh','SCI Systems (Kunshan) Co., Ltd.'),(10150215680,'CalixNet','Calix Networks'),(10166992896,'HighTech','High Technology Ltd'),(10183770112,'NortelNe','Nortel Networks'),(10200547328,'Accordio','Accordion Networks, Inc.'),(10217324544,'Tilgin','Tilgin AB'),(10234101760,'SoyoGrou','Soyo Group Soyo Com Tech Co., Lt'),(10250878976,'UpsManuf','UPS Manufacturing SRL'),(10267656192,'Audioram','AudioRamp.com'),(10284433408,'Virditec','Virditech Co. Ltd.'),(10301210624,'Thermalo','Thermalogic Corporation'),(10317987840,'NodeRunn','NODE RUNNER, INC.'),(10334765056,'HarrisGo','Harris Government Communications'),(10351542272,'Nadatel','Nadatel Co., Ltd'),(10368319488,'CocessTe','Cocess Telecom Co., Ltd.'),(10385096704,'BcmCompu','BCM Computers Co., Ltd.'),(10401873920,'PhilipsC','Philips CFT'),(10418651136,'AdeptTel','Adept Telecom'),(10435428352,'NegenAcc','NeGeN Access, Inc.'),(10452205568,'SenaoInt','Senao International Co., Ltd.'),(10468982784,'Crewave','Crewave Co., Ltd.'),(10485760000,'ZhoneTec','Zhone Technologies'),(10502537216,'Cc&CTech','CC&C Technologies, Inc.'),(10519314432,'Coriolis','Coriolis Networks'),(10536091648,'TommyTec','Tommy Technologies Corp.'),(10552868864,'SmartTec','SMART Technologies, Inc.'),(10569646080,'PrimaxEl','Primax Electronics Ltd.'),(10586423296,'CashSyst','Cash Systemes Industrie'),(10603200512,'SamsungE','Samsung Electro-Mechanics Co., L'),(10619977728,'ControlA','Control Applications, Ltd.'),(10636754944,'IoiTechn','IOI Technology Corporation'),(10653532160,'AmplifyN','Amplify Net, Inc.'),(10670309376,'Trilithi','Trilithic, Inc.'),(10687086592,'Cisco','CISCO SYSTEMS, INC.'),(10703863808,'Cisco','CISCO SYSTEMS, INC.'),(10720641024,'Ask-Tech','ask-technologies.com'),(10737418240,'MuNet','Mu Net, Inc.'),(10754195456,'Madge','Madge Ltd.'),(10770972672,'Viaclix','ViaClix, Inc.'),(10787749888,'Spectrum','Spectrum Controls, Inc.'),(10804527104,'ArevaT&D','AREVA T&D'),(10821304320,'Riversto','Riverstone Networks'),(10838081536,'OccamNet','Occam Networks'),(10854858752,'Adapcom',''),(10871635968,'GlobalVi','GLOBAL VILLAGE COMMUNICATION'),(10888413184,'DneTechn','DNE Technologies'),(10905190400,'AmbitMic','Ambit Microsystems Corporation'),(10921967616,'VdslOy','VDSL Systems OY'),(10938744832,'Micrel-S','Micrel-Synergy Semiconductor'),(10955522048,'MovitaTe','Movita Technologies, Inc.'),(10972299264,'Rapid5Ne','Rapid 5 Networks, Inc.'),(10989076480,'Globetek','Globetek, Inc.'),(11005853696,'Woorigis','Woorigisool, Inc.'),(11022630912,'OpenNetw','Open Network Co., Ltd.'),(11039408128,'LogicInn','Logic Innovations, Inc.'),(11056185344,'SolidDat','Solid Data Systems'),(11072962560,'TokyoSok','Tokyo Sokushin Co., Ltd.'),(11089739776,'IpAccess','IP.Access Limited'),(11106516992,'Lectron','Lectron Co,. Ltd.'),(11123294208,'C-CorNet','C-COR.net'),(11140071424,'Broadfra','Broadframe Corporation'),(11156848640,'Apex','Apex, Inc.'),(11173625856,'StorageA','Storage Apps'),(11190403072,'KreatelC','Kreatel Communications AB'),(11207180288,'3com',''),(11223957504,'Merix','Merix Corp.'),(11240734720,'Informat','Information Equipment Co., Ltd.'),(11257511936,'L-3Commu','L-3 Communication Aviation Recor'),(11274289152,'Flatstac','Flatstack Ltd.'),(11291066368,'WorldWid','World Wide Packets'),(11307843584,'Hilscher','Hilscher GmbH'),(11324620800,'AbbSwitz','ABB Switzerland Ltd, Power Syste'),(11341398016,'AddpacTe','AddPac Technology Co., Ltd.'),(11358175232,'Hewlett-','Hewlett-Packard Company'),(11374952448,'Effinet','Effinet Systems Co., Ltd.'),(11391729664,'VivaceNe','Vivace Networks'),(11408506880,'AirLinkT','Air Link Technology'),(11425284096,'RacomSRO','RACOM, s.r.o.'),(11442061312,'Plcom','PLcom Co., Ltd.'),(11458838528,'CtcUnion','CTC Union Technologies Co., Ltd.'),(11475615744,'3parData','3PAR data'),(11492392960,'Hoya','HOYA Corporation'),(11509170176,'ScannexE','Scannex Electronics Ltd.'),(11525947392,'Telecruz','TeleCruz Technology, Inc.'),(11542724608,'HokubuCo','Hokubu Communication & Industria'),(11559501824,'Anritsu','Anritsu, Ltd.'),(11576279040,'Cablevis','Cablevision'),(11593056256,'Intel','Intel Corporation'),(11609833472,'Daphne',''),(11626610688,'Avnet','Avnet, Inc.'),(11643387904,'Acrosser','Acrosser Technology Co., Ltd.'),(11660165120,'Watanabe','Watanabe Electric Industry Co., '),(11676942336,'WhiKonsu','WHI KONSULT AB'),(11693719552,'Cisco','CISCO SYSTEMS, INC.'),(11710496768,'Cisco','CISCO SYSTEMS, INC.'),(11727273984,'Continuo','Continuous Computing Corp'),(11744051200,'Lvl7','LVL 7 Systems, Inc.'),(11760828416,'Bionet','Bionet Co., Ltd.'),(11777605632,'TotsuEng','Totsu Engineering, Inc.'),(11794382848,'Dotrocke','dotRocket, Inc.'),(11811160064,'BencentT','Bencent Tzeng Industry Co., Ltd.'),(11827937280,'Innovati','Innovative Electronic Designs, I'),(11844714496,'NetVisio','Net Vision Telecom'),(11861491712,'Arelnet','Arelnet Ltd.'),(11878268928,'VectorIn','Vector International BVBA'),(11895046144,'EvertzMi','Evertz Microsystems Ltd.'),(11911823360,'DataTrac','Data Track Technology PLC'),(11928600576,'AlpsElec','ALPS ELECTRIC Co., Ltd.'),(11945377792,'Technoco','Technocom Communications Technol'),(11962155008,'Mellanox','Mellanox Technologies'),(11978932224,'Endpoint','EndPoints, Inc.'),(11995709440,'Tristate','TriState Ltd.'),(12012486656,'MCCI','M.C.C.I'),(12029263872,'Teledrea','TeleDream, Inc.'),(12046041088,'Foxjet','FoxJet, Inc.'),(12062818304,'ZygateCo','ZyGate Communications, Inc.'),(12079595520,'Comdial','Comdial Corporation'),(12096372736,'Vivotek','Vivotek, Inc.'),(12113149952,'Workstat','Workstation AG'),(12129927168,'Netbotz','NetBotz, Inc.'),(12146704384,'PdaPerip','PDA Peripherals, Inc.'),(12163481600,'Acr',''),(12180258816,'Nice','NICE Systems'),(12197036032,'Empeg','EMPEG Ltd'),(12213813248,'BrecisCo','BRECIS Communications Corporatio'),(12230590464,'Reliable','Reliable Controls'),(12247367680,'ExioComm','ExiO Communications, Inc.'),(12264144896,'Netsec',''),(12280922112,'FujitsuG','Fujitsu General Limited'),(12297699328,'BromaxCo','Bromax Communications, Ltd.'),(12314476544,'Astrodes','Astrodesign, Inc.'),(12331253760,'NetCom','Net Com Systems, Inc.'),(12348030976,'Etas','ETAS GmbH'),(12364808192,'Integrat','Integrated Network Corporation'),(12381585408,'NdcInfar','NDC Infared Engineering'),(12398362624,'Lite-OnC','LITE-ON Communications, Inc.'),(12415139840,'JcHyun','JC HYUN Systems, Inc.'),(12431917056,'Timeware','Timeware Ltd.'),(12448694272,'GouldIns','Gould Instrument Systems, Inc.'),(12465471488,'Cab','CAB GmbH & Co KG'),(12482248704,'ED&A','E.D.&A.'),(12499025920,'CsSystem','CS Systemes De Securite - C3S'),(12515803136,'FocusEnh','Focus Enhancements'),(12532580352,'PicoComm','Pico Communications'),(12549357568,'Maschoff','Maschoff Design Engineering'),(12566134784,'DxoTelec','DXO Telecom Co., Ltd.'),(12582912000,'NokiaDan','Nokia Danmark A/S'),(12599689216,'CccNetwo','CCC Network Systems Group Ltd.'),(12616466432,'AmeOptim','AME Optimedia Technology Co., Lt'),(12633243648,'Pinetron','Pinetron Co., Ltd.'),(12650020864,'Edevice','eDevice, Inc.'),(12666798080,'MediaSer','Media Serve Co., Ltd.'),(12683575296,'Pctel','PCTEL, Inc.'),(12700352512,'ViveSyne','VIVE Synergies, Inc.'),(12717129728,'EquipeCo','Equipe Communications'),(12733906944,'Arm',''),(12750684160,'SeakrEng','SEAKR Engineering, Inc.'),(12767461376,'MimosBer','MIMOS Berhad'),(12784238592,'DxAntenn','DX Antenna Co., Ltd.'),(12801015808,'Baumulle','Baumuller Aulugen-Systemtechnik '),(12817793024,'Cisco','CISCO SYSTEMS, INC.'),(12834570240,'Cisco','CISCO SYSTEMS, INC.'),(12851347456,'Viditec','Viditec, Inc.'),(12868124672,'HandanBr','Handan BroadInfoCom'),(12884901888,'Barracud','Barracuda Networks, Inc.'),(12901679104,'AvantasN','Avantas Networks Corporation'),(12918456320,'CharlesI','Charles Industries, Ltd.'),(12935233536,'JamaElec','JAMA Electronics Co., Ltd.'),(12952010752,'PacificB','Pacific Broadband Communications'),(12968787968,'MscVertr','MSC Vertriebs GmbH'),(12985565184,'FusionIn','Fusion In Tech Co., Ltd.'),(13002342400,'SecureWo','Secure Works, Inc.'),(13019119616,'AmCommun','AM Communications, Inc.'),(13035896832,'TexcelTe','Texcel Technology PLC'),(13052674048,'ArgusTec','Argus Technologies'),(13069451264,'HunterTe','Hunter Technology, Inc.'),(13086228480,'Telesoft','Telesoft Technologies Ltd.'),(13103005696,'UniwillC','Uniwill Computer Corp.'),(13119782912,'CoreComm','Core Communications Co., Ltd.'),(13136560128,'DigitalC','Digital China (Shanghai) Network'),(13153337344,'ItxE-Glo','ITX E-Globaledge Corporation'),(13170114560,'MicroTec','Micro Technology Co., Ltd.'),(13186891776,'Tr-Syste','TR-Systemtechnik GmbH'),(13203668992,'AccessMe','Access Media SPA'),(13220446208,'Teleware','Teleware Network Systems'),(13237223424,'Cidco','Cidco Incorporated'),(13254000640,'NobellCo','Nobell Communications, Inc.'),(13270777856,'Merlin','Merlin Systems, Inc.'),(13287555072,'Cyras','Cyras Systems, Inc.'),(13304332288,'Infineon','Infineon AG'),(13321109504,'BeijingB','Beijing Broad Telecom Ltd., Chin'),(13337886720,'Cellvisi','Cellvision Systems, Inc.'),(13354663936,'SvenskaH','Svenska Hardvarufabriken AB'),(13371441152,'TaiwanCo','Taiwan Commate Computer, Inc.'),(13388218368,'Optranet','Optranet, Inc.'),(13404995584,'Condev','Condev Ltd.'),(13421772800,'Xpeed','Xpeed, Inc.'),(13438550016,'RecoRese','Reco Research Co., Ltd.'),(13455327232,'Idis','IDIS Co., Ltd.'),(13472104448,'CornetTe','Cornet Technology, Inc.'),(13488881664,'SanyoCon','SANYO Consumer Electronics Co., '),(13505658880,'ArimaCom','Arima Computer Corp.'),(13522436096,'IwasakiI','Iwasaki Information Systems Co.,'),(13539213312,'ActL','ACT`L'),(13555990528,'MaceGrou','Mace Group, Inc.'),(13572767744,'F3','F3, Inc.'),(13589544960,'UnidataC','UniData Communication Systems, I'),(13606322176,'GaiDaten','GAI Datenfunksysteme GmbH'),(13623099392,'AbbSwitz','ABB Switzerland Ltd'),(13639876608,'IbaseTec','IBASE Technology, Inc.'),(13656653824,'ScopeInf','Scope Information Management, Lt'),(13673431040,'GlobalSu','Global Sun Technology, Inc.'),(13690208256,'Imagenic','Imagenics, Co., Ltd.'),(13706985472,'Cisco','CISCO SYSTEMS, INC.'),(13723762688,'Cisco','CISCO SYSTEMS, INC.'),(13740539904,'Digitel','Digitel Co., Ltd.'),(13757317120,'NewportE','Newport Electronics'),(13774094336,'MiraeTec','Mirae Technology'),(13790871552,'ZetesTec','Zetes Technologies'),(13807648768,'Vaone','Vaone, Inc.'),(13824425984,'OakTechn','Oak Technology'),(13841203200,'Eurologi','Eurologic Systems, Ltd.'),(13857980416,'SiliconW','Silicon Wave, Inc.'),(13874757632,'TamiTech','TAMI Tech Co., Ltd.'),(13891534848,'Daiden','Daiden Co., Ltd.'),(13908312064,'IlshinLa','ILSHin Lab'),(13925089280,'Tateyama','Tateyama System Laboratory Co., '),(13941866496,'BigbandN','BigBand Networks, Ltd.'),(13958643712,'FlowareW','Floware Wireless Systems, Ltd.'),(13975420928,'AxonDigi','Axon Digital Design'),(13992198144,'NortelNe','Nortel Networks'),(14008975360,'MartinPr','Martin Professional A/S'),(14025752576,'Tietech','Tietech.Co., Ltd.'),(14042529792,'RoutrekN','Routrek Networks Corporation'),(14059307008,'HitachiK','Hitachi Kokusai Electric, Inc.'),(14076084224,'Intel','Intel Corporation'),(14092861440,'NorscanI','Norscan Instruments, Ltd.'),(14109638656,'Vidicode','Vidicode Datacommunicatie B.V.'),(14126415872,'Rias','RIAS Corporation'),(14143193088,'NortelNe','Nortel Networks'),(14159970304,'Shanghai','Shanghai DigiVision Technology C'),(14176747520,'ChiaroNe','Chiaro Networks, Ltd.'),(14193524736,'PosData','Pos Data Company, Ltd.'),(14210301952,'Sur-Gard','Sur-Gard Security'),(14227079168,'Bticino','BTICINO SPA'),(14243856384,'Diebold','Diebold, Inc.'),(14260633600,'Colubris','Colubris Networks'),(14277410816,'Mitac','Mitac, Inc.'),(14294188032,'FiberLog','Fiber Logic Communications'),(14310965248,'Terabeam','TeraBeam Internet Systems'),(14327742464,'WincorNi','Wincor Nixdorf International Gmb'),(14344519680,'Intervoi','Intervoice-Brite, Inc.'),(14361296896,'HanyangD','Hanyang Digitech Co., Ltd.'),(14378074112,'Digitals','DigitalSis'),(14394851328,'Photron','Photron Limited'),(14411628544,'Bridgewa','BridgeWave Communications'),(14428405760,'SaintSon','Saint Song Corp.'),(14445182976,'BosungHi','Bosung Hi-Net Co., Ltd.'),(14461960192,'Metropol','Metropolitan Area Networks, Inc.'),(14478737408,'PrÃ¼ftech','PrÃ¼ftechnik Condition Monitorin'),(14495514624,'PacInter','PAC Interactive Technology, Inc.'),(14512291840,'Widcomm','Widcomm, Inc.'),(14529069056,'VodtelCo','Vodtel Communications, Inc.'),(14545846272,'Miraesys','Miraesys Co., Ltd.'),(14562623488,'ScenixSe','Scenix Semiconductor, Inc.'),(14579400704,'KiraInfo','Kira Information & Communication'),(14596177920,'AsmPacif','ASM Pacific Technology'),(14612955136,'JasmineN','Jasmine Networks, Inc.'),(14629732352,'Embedone','Embedone Co., Ltd.'),(14646509568,'NipponAn','Nippon Antenna Co., Ltd.'),(14663286784,'Mainnet','Mainnet, Ltd.'),(14680064000,'Cisco','CISCO SYSTEMS, INC.'),(14696841216,'Cisco','CISCO SYSTEMS, INC.'),(14713618432,'Runtop','Runtop, Inc.'),(14730395648,'NiconPty','Nicon Systems (Pty) Limited'),(14747172864,'Telsey','Telsey SPA'),(14763950080,'Nxtv','NXTV, Inc.'),(14780727296,'AcomzNet','Acomz Networks Corp.'),(14797504512,'Ulan',''),(14814281728,'AselsanA','Aselsan A.S'),(14831058944,'ControlM','Control Microsystems'),(14847836160,'Netmedia','NetMedia, Inc.'),(14864613376,'Graphtec','Graphtec Technology, Inc.'),(14881390592,'GigabitW','Gigabit Wireless'),(14898167808,'Humax','HUMAX Co., Ltd.'),(14914945024,'Proscend','Proscend Communications, Inc.'),(14931722240,'TaiyoYud','Taiyo Yuden Co., Ltd.'),(14948499456,'IdecIzum','IDEC IZUMI Corporation'),(14965276672,'CoaxMedi','Coax Media'),(14982053888,'Stellcom',''),(14998831104,'PortechC','PORTech Communications, Inc.'),(15015608320,'AtherosC','Atheros Communications, Inc.'),(15032385536,'SshCommu','SSH Communications Security Corp'),(15049162752,'Ingenico','Ingenico International'),(15065939968,'A-One','A-One Co., Ltd.'),(15082717184,'MeteraNe','Metera Networks, Inc.'),(15099494400,'Aeta',''),(15116271616,'ActelisN','Actelis Networks, Inc.'),(15133048832,'HoNet','Ho Net, Inc.'),(15149826048,'BlazeNet','Blaze Network Products'),(15166603264,'Fastfame','Fastfame Technology Co., Ltd.'),(15183380480,'Plantron','Plantronics'),(15200157696,'AmericaO','America Online, Inc.'),(15216934912,'Plus-One','PLUS-ONE I&T, Inc.'),(15233712128,'TotalImp','Total Impact'),(15250489344,'PcsReven','PCS Revenue Control Systems, Inc'),(15267266560,'Atoga','Atoga Systems, Inc.'),(15284043776,'Weinsche','Weinschel Corporation'),(15300820992,'DigitalV','Digital Video Communications, In'),(15317598208,'Advanced','Advanced Digital Broadcast, Ltd.'),(15334375424,'HyundaiT','Hyundai Teletek Co., Ltd.'),(15351152640,'AppleCom','Apple Computer, Inc.'),(15367929856,'ConnectO','Connect One'),(15384707072,'Californ','California Amplifier'),(15401484288,'EzCast','EZ Cast Co., Ltd.'),(15418261504,'Watchfro','Watchfront Limited'),(15435038720,'Wisi',''),(15451815936,'DongjuIn','Dongju Informations & Communicat'),(15468593152,'Siconnec','SiConnect'),(15485370368,'NetchipT','NetChip Technology, Inc.'),(15502147584,'Optimigh','OptiMight Communications, Inc.'),(15518924800,'Qisda','Qisda Corporation'),(15535702016,'TeraSyst','Tera System Co., Ltd.'),(15552479232,'Cisco','CISCO SYSTEMS, INC.'),(15569256448,'Cisco','CISCO SYSTEMS, INC.'),(15586033664,'HiperInf','HIPER Information & Communicatio'),(15602810880,'Catapult','Catapult Communications'),(15619588096,'Mavix','MAVIX, Ltd.'),(15636365312,'Imation','Imation Corp.'),(15653142528,'Medea','Medea Corporation'),(15669919744,'TraxitTe','Traxit Technology, Inc.'),(15686696960,'UnixtarT','Unixtar Technology, Inc.'),(15703474176,'IdotComp','IDOT Computers, Inc.'),(15720251392,'AxcentMe','AXCENT Media AG'),(15737028608,'Watlow',''),(15753805824,'BridgeIn','Bridge Information Systems'),(15770583040,'FroniusS','Fronius Schweissmaschinen'),(15787360256,'EmersonE','Emerson Energy Systems AB'),(15804137472,'AlliedAd','Allied Advanced Manufacturing Pt'),(15820914688,'ParageaC','Paragea Communications'),(15837691904,'XsenseTe','Xsense Technology Corp.'),(15854469120,'Hospira','Hospira Inc.'),(15871246336,'Radware',''),(15888023552,'IaLink','IA Link Systems Co., Ltd.'),(15904800768,'Macrotek','Macrotek International Corp.'),(15921577984,'EntraTec','Entra Technology Co.'),(15938355200,'Qsi','QSI Corporation'),(15955132416,'Zaccess','ZACCESS Systems'),(15971909632,'NetkitSo','NetKit Solutions, LLC'),(15988686848,'HualongT','Hualong Telecom Co., Ltd.'),(16005464064,'Oracle','Oracle Corporation'),(16022241280,'SignalCo','Signal Communications Limited'),(16039018496,'Cot','COT GmbH'),(16055795712,'Omniclus','OmniCluster Technologies, Inc.'),(16072572928,'Netility',''),(16089350144,'Centerpo','Centerpoint Broadband Technologi'),(16106127360,'Rftnc','RFTNC Co., Ltd.'),(16122904576,'PacketDy','Packet Dynamics Ltd'),(16139681792,'Solphone','Solphone K.K.'),(16156459008,'Micronik','Micronik Multimedia'),(16173236224,'TomraAsa','Tomra Systems ASA'),(16190013440,'Mobotix','Mobotix AG'),(16206790656,'Icue','ICUE Systems, Inc.'),(16223567872,'HopfElek','hopf Elektronik GmbH'),(16240345088,'CmlEmerg','CML Emergency Services'),(16257122304,'Tecom','TECOM Co., Ltd.'),(16273899520,'Mts','MTS Systems Corp.'),(16290676736,'NipponDe','Nippon Systems Development Co., '),(16307453952,'Momentum','Momentum Computer, Inc.'),(16324231168,'Cloverte','Clovertech, Inc.'),(16341008384,'EtenTech','ETEN Technologies, Inc.'),(16357785600,'Muxcom','Muxcom, Inc.'),(16374562816,'Koankeis','KOANKEISO Co., Ltd.'),(16391340032,'Takaya','Takaya Corporation'),(16408117248,'Crossbea','Crossbeam Systems, Inc.'),(16424894464,'Internet','Internet Energy Systems, Inc.'),(16441671680,'Alloptic','Alloptic, Inc.'),(16458448896,'Advanced','Advanced Communications Co., Ltd'),(16475226112,'Radvisio','RADVision, Ltd.'),(16492003328,'NextnetW','NextNet Wireless, Inc.'),(16508780544,'ImpathNe','iMPath Networks, Inc.'),(16525557760,'Secheron','Secheron SA'),(16542334976,'Takamisa','Takamisawa Cybernetics Co., Ltd.'),(16559112192,'ApogeeEl','Apogee Electronics Corp.'),(16575889408,'LexarMed','Lexar Media, Inc.'),(16592666624,'Comark','Comark Corp.'),(16609443840,'OtcWirel','OTC Wireless'),(16626221056,'Desana','Desana Systems'),(16642998272,'Motorola','Motorola, Inc.'),(16659775488,'WinmateC','Winmate Communication, Inc.'),(16676552704,'Comspace','Comspace Corporation'),(16693329920,'Cisco','CISCO SYSTEMS, INC.'),(16710107136,'Cisco','CISCO SYSTEMS, INC.'),(16726884352,'Hermsted','Hermstedt SG'),(16743661568,'Entone','Entone, Inc.'),(16760438784,'Logostek','Logostek Co. Ltd.'),(16777216000,'Waveleng','Wavelength Digital Limited'),(16793993216,'AkaraCan','Akara Canada, Inc.'),(16810770432,'MegaSyst','Mega System Technologies, Inc.'),(16827547648,'Atrica',''),(16844324864,'IcgResea','ICG Research, Inc.'),(16861102080,'Shinkawa','Shinkawa Electric Co., Ltd.'),(16877879296,'Mknet','MKNet Corporation'),(16894656512,'Oneline','Oneline AG'),(16911433728,'RedfernB','Redfern Broadband Networks'),(16928210944,'CicadaSe','Cicada Semiconductor, Inc.'),(16944988160,'SenecaNe','Seneca Networks'),(16961765376,'DazzleMu','Dazzle Multimedia, Inc.'),(16978542592,'Netburne','NetBurner'),(16995319808,'Chip2chi','Chip2Chip'),(17012097024,'AllegroN','Allegro Networks, Inc.'),(17028874240,'Plast-Co','Plast-Control GmbH'),(17045651456,'Sancastl','SanCastle Technologies, Inc.'),(17062428672,'Pleiades','Pleiades Communications, Inc.'),(17079205888,'TimetraN','TiMetra Networks'),(17095983104,'Enegate','ENEGATE Co.,Ltd.'),(17112760320,'Intertex','Intertex Data AB'),(17129537536,'Cisco','CISCO SYSTEMS, INC.'),(17146314752,'Cisco','CISCO SYSTEMS, INC.'),(17163091968,'Microsof','Microsoft Corporation'),(17179869184,'LexmarkI','LEXMARK INTERNATIONAL, INC.'),(17196646400,'OsakiEle','Osaki Electric Co., Ltd.'),(17213423616,'NexsanTe','Nexsan Technologies, Ltd.'),(17230200832,'Nexsi','Nexsi Corporation'),(17246978048,'MakinoMi','Makino Milling Machine Co., Ltd.'),(17263755264,'AcnTechn','ACN Technologies'),(17280532480,'FaMetabo','Fa. Metabox AG'),(17297309696,'TopconPo','Topcon Positioning Systems, Inc.'),(17314086912,'SankoEle','Sanko Electronics Co., Ltd.'),(17330864128,'CratosNe','Cratos Networks'),(17347641344,'Sage','Sage Systems'),(17364418560,'3comEuro','3com Europe Ltd.'),(17381195776,'KannoWor','Kanno Works, Ltd.'),(17397972992,'Avaya','Avaya, Inc.'),(17414750208,'Avm','AVM GmbH'),(17431527424,'AsusNetw','Asus Network Technologies, Inc.'),(17448304640,'Spinnake','Spinnaker Networks, Inc.'),(17465081856,'InkraNet','Inkra Networks, Inc.'),(17481859072,'Wavesmit','WaveSmith Networks, Inc.'),(17498636288,'SnomTech','SNOM Technology AG'),(17515413504,'UmezawaM','Umezawa Musen Denki Co., Ltd.'),(17532190720,'Rasteme','Rasteme Systems Co., Ltd.'),(17548967936,'ParksCom','Parks S/A Comunicacoes Digitais'),(17565745152,'Elau','ELAU AG'),(17582522368,'Teltroni','Teltronic S.A.U.'),(17599299584,'Fibercyc','Fibercycle Networks, Inc.'),(17616076800,'InesTest','Ines Test and Measurement GmbH &'),(17632854016,'Bridgewo','Bridgeworks Ltd.'),(17649631232,'Ipdialog','ipDialog, Inc.'),(17666408448,'CoregaOf','Corega of America'),(17683185664,'ShikokuI','Shikoku Instrumentation Co., Ltd'),(17699962880,'SonyComp','Sony Computer Entertainment, Inc'),(17716740096,'SlimDevi','Slim Devices, Inc.'),(17733517312,'OcularNe','Ocular Networks'),(17750294528,'GordonKa','Gordon Kapes, Inc.'),(17767071744,'Intel','Intel Corporation'),(17783848960,'TmcSRL','TMC s.r.l.'),(17800626176,'Atmel','Atmel Corporation'),(17817403392,'Autosys',''),(17834180608,'Cisco','CISCO SYSTEMS, INC.'),(17850957824,'Cisco','CISCO SYSTEMS, INC.'),(17867735040,'Pixord','Pixord Corporation'),(17884512256,'Wireless','Wireless Networks, Inc.'),(17901289472,'ItAccess','IT Access Co., Ltd.'),(17918066688,'Minet','Minet, Inc.'),(17934843904,'Sarian','Sarian Systems, Ltd.'),(17951621120,'NetousTe','Netous Technologies, Ltd.'),(17968398336,'Internat','International Communications Pro'),(17985175552,'Netgem',''),(18001952768,'Globalst','GlobalStreams, Inc.'),(18018729984,'VoyetraT','Voyetra Turtle Beach, Inc.'),(18035507200,'Cyberboa','Cyberboard A/S'),(18052284416,'Accelent','Accelent Systems, Inc.'),(18069061632,'ComptekI','Comptek International, Inc.'),(18085838848,'ElansatT','ELANsat Technologies, Inc.'),(18102616064,'PowinInf','Powin Information Technology, In'),(18119393280,'NortelNe','Nortel Networks'),(18136170496,'RoscoEnt','Rosco Entertainment Technology, '),(18152947712,'Intellig','Intelligent Telecommunications, '),(18169724928,'LavaComp','Lava Computer Mfg., Inc.'),(18186502144,'Sonos','SONOS Co., Ltd.'),(18203279360,'Indel','INDEL AG'),(18220056576,'Telencom','Telencomm'),(18236833792,'EsteemWi','ESTeem Wireless Modems, Inc'),(18253611008,'Cyberpix','cyberPIXIE, Inc.'),(18270388224,'HalfDome','Half Dome Systems, Inc.'),(18287165440,'Nact',''),(18303942656,'AgilentT','Agilent Technologies, Inc.'),(18320719872,'WesternM','Western Multiplex Corporation'),(18337497088,'LmsSkala','LMS Skalar Instruments GmbH'),(18354274304,'Cyzentec','CYZENTECH Co., Ltd.'),(18371051520,'Acrowave','Acrowave Systems Co., Ltd.'),(18387828736,'Polaroid','Polaroid Corporation'),(18404605952,'Mapletre','Mapletree Networks'),(18421383168,'IpolicyN','iPolicy Networks, Inc.'),(18438160384,'Nvidia',''),(18454937600,'Jenoptik',''),(18471714816,'Cisco','CISCO SYSTEMS, INC.'),(18488492032,'Cisco','CISCO SYSTEMS, INC.'),(18505269248,'Leukhard','Leukhardt Systemelektronik GmbH'),(18522046464,'DmdCompu','DMD Computers SRL'),(18538823680,'Medrad','Medrad, Inc.'),(18555600896,'Rocketlo','RocketLogix, Inc.'),(18572378112,'Yottayot','YottaYotta, Inc.'),(18589155328,'Quadriga','Quadriga UK'),(18605932544,'AntaraNe','ANTARA.net'),(18622709760,'CambiumN','Cambium Networks Limited'),(18639486976,'Universa','Universal Access Technology, Inc'),(18656264192,'FusionX','Fusion X Co., Ltd.'),(18673041408,'Veristar','Veristar Corporation'),(18689818624,'LinksysG','The Linksys Group, Inc.'),(18706595840,'TechsanE','Techsan Electronics Co., Ltd.'),(18723373056,'Mobiwave','Mobiwave Pte Ltd'),(18740150272,'BekaElek','BEKA Elektronik'),(18756927488,'Polytrax','PolyTrax Information Technology '),(18773704704,'AvalueTe','Avalue Technology, Inc.'),(18790481920,'KnilinkT','Knilink Technology, Inc.'),(18807259136,'EpoxComp','EPOX Computer Co., Ltd.'),(18824036352,'DakosDat','DAKOS Data & Communication Co., '),(18840813568,'BoschSec','Bosch Security Systems'),(18857590784,'Fantasma','Fantasma Networks, Inc.'),(18874368000,'ISTIsdn-','i.s.t isdn-support technik GmbH'),(18891145216,'Armitel','ARMITEL Co.'),(18907922432,'WuhanRes','Wuhan Research Institute of MII'),(18924699648,'Vivity','Vivity, Inc.'),(18941476864,'Innocom','Innocom, Inc.'),(18958254080,'NaviniNe','Navini Networks'),(18975031296,'PalmWire','Palm Wireless, Inc.'),(18991808512,'CyberTec','Cyber Technology Co., Ltd.'),(19008585728,'Cisco','CISCO SYSTEMS, INC.'),(19025362944,'Cisco','CISCO SYSTEMS, INC.'),(19042140160,'DigitelI','Digitel S/A Industria Eletronica'),(19058917376,'Ipunplug','ipUnplugged AB'),(19075694592,'Iprad',''),(19092471808,'Telelynx','Telelynx, Inc.'),(19109249024,'Photonex','Photonex Corporation'),(19126026240,'Legrand',''),(19142803456,'3Com','3 Com Corporation'),(19159580672,'3Com','3 Com Corporation'),(19176357888,'Scalant','Scalant Systems, Inc.'),(19193135104,'GStarTec','G. Star Technology Corporation'),(19209912320,'Radius','Radius Co., Ltd.'),(19226689536,'Axxessit','AXXESSIT ASA'),(19243466752,'Schlumbe','Schlumberger'),(19260243968,'Skidata','Skidata AG'),(19277021184,'Pelco',''),(19293798400,'SiquraBV','Siqura B.V.'),(19310575616,'ChrMayr','Chr. Mayr GmbH & Co. KG'),(19327352832,'BrocadeC','Brocade Communications Systems, '),(19344130048,'Econolit','Econolite Control Products, Inc.'),(19360907264,'Medialog','Medialogic Corp.'),(19377684480,'DeltronT','Deltron Technology, Inc.'),(19394461696,'Amann','Amann GmbH'),(19411238912,'Picoligh','PicoLight'),(19428016128,'IttcUniv','ITTC, University of Kansas'),(19444793344,'CogencyS','Cogency Semiconductor, Inc.'),(19461570560,'Eurother','Eurotherm Controls'),(19478347776,'YafoNetw','YAFO Networks, Inc.'),(19495124992,'TemiaVer','Temia Vertriebs GmbH'),(19511902208,'Poscon','Poscon Corporation'),(19528679424,'NaynaNet','Nayna Networks, Inc.'),(19545456640,'ToneComm','Tone Commander Systems, Inc.'),(19562233856,'OhmTechL','Ohm Tech Labs, Inc.'),(19579011072,'Td','TD Systems Corporation'),(19595788288,'OpticalA','Optical Access'),(19612565504,'Technovi','Technovision, Inc.'),(19629342720,'HiveInte','Hive Internet, Ltd.'),(19646119936,'Tsinghua','Tsinghua Unisplendour Co., Ltd.'),(19662897152,'Breezeco','Breezecom, Ltd.'),(19679674368,'TejasNet','Tejas Networks India Limited'),(19696451584,'ExtremeN','Extreme Networks'),(19713228800,'Macrosys','MacroSystem Digital Video AG'),(19730006016,'MahiNetw','Mahi Networks'),(19746783232,'Chino','Chino Corporation'),(19763560448,'Cisco','CISCO SYSTEMS, INC.'),(19780337664,'Cisco','CISCO SYSTEMS, INC.'),(19797114880,'Surgient','Surgient Networks, Inc.'),(19813892096,'IpanemaT','Ipanema Technologies'),(19830669312,'Wirelink','Wirelink Co., Ltd.'),(19847446528,'Freescal','Freescale Semiconductor'),(19864223744,'VerityIn','Verity Instruments, Inc.'),(19881000960,'PathwayC','Pathway Connectivity'),(19897778176,'LSIJapan','L.S.I. Japan Co., Ltd.'),(19914555392,'Microchi','Microchip Technology, Inc.'),(19931332608,'Netenabl','NetEnabled, Inc.'),(19948109824,'BarcoPro','Barco Projection Systems NV'),(19964887040,'SafTehni','SAF Tehnika Ltd.'),(19981664256,'Fabiatec','FabiaTech Corporation'),(19998441472,'Broadmax','Broadmax Technologies, Inc.'),(20015218688,'Sandstre','SandStream Technologies, Inc.'),(20031995904,'Jetstrea','Jetstream Communications'),(20048773120,'Comverse','Comverse Network Systems, Inc.'),(20065550336,'Ibm','IBM Corp'),(20082327552,'MalibuNe','Malibu Networks'),(20099104768,'Sullair','Sullair Corporation'),(20115881984,'DigitalF','Digital Fountain, Inc.'),(20132659200,'Elesign','ELESIGN Co., Ltd.'),(20149436416,'SignalTe','Signal Technology, Inc.'),(20166213632,'EssegiSr','ESSEGI SRL'),(20182990848,'Videotek','Videotek, Inc.'),(20199768064,'Ciac',''),(20216545280,'Equitrac','Equitrac Corporation'),(20233322496,'StratexN','Stratex Networks, Inc.'),(20250099712,'AmbIT','AMB i.t. Holding'),(20266876928,'Kumahira','Kumahira Co., Ltd.'),(20283654144,'SISoubou','S.I. Soubou, Inc.'),(20300431360,'KddMedia','KDD Media Will Corporation'),(20317208576,'Bardac','Bardac Corporation'),(20333985792,'Giantec','Giantec, Inc.'),(20350763008,'Motorola','Motorola Mobility, Inc.'),(20367540224,'Optxcon','OptXCon, Inc.'),(20384317440,'Versalog','VersaLogic Corp.'),(20401094656,'Cisco','CISCO SYSTEMS, INC.'),(20417871872,'Cisco','CISCO SYSTEMS, INC.'),(20434649088,'Magnipix','Magnipix, Inc.'),(20451426304,'CastorIn','CASTOR Informatique'),(20468203520,'AllenHea','Allen & Heath Limited'),(20484980736,'AseTechn','ASE Technologies, USA'),(20501757952,'YamahaMo','Yamaha Motor Co., Ltd.'),(20518535168,'Netmount',''),(20535312384,'LibaMasc','LIBA Maschinenfabrik GmbH'),(20552089600,'MicroEle','Micro Electron Co., Ltd.'),(20568866816,'Freems','FreeMs Corp.'),(20585644032,'TdsoftCo','Tdsoft Communication, Ltd.'),(20602421248,'PeekTraf','Peek Traffic B.V.'),(20619198464,'Informed','Informedia Research Group'),(20635975680,'PatriaAi','Patria Ailon'),(20652752896,'SeagateT','Seagate Technology'),(20669530112,'Softlink','Softlink s.r.o.'),(20686307328,'DrewTech','Drew Technologies, Inc.'),(20703084544,'AdconTel','Adcon Telemetry GmbH'),(20719861760,'Toyokeik','Toyokeiki Co., Ltd.'),(20736638976,'ProviewE','Proview Electronics Co., Ltd.'),(20753416192,'HitachiI','Hitachi Information & Communicat'),(20770193408,'TakagiIn','Takagi Industrial Co., Ltd.'),(20786970624,'OmitecIn','Omitec Instrumentation Ltd.'),(20803747840,'Ipwirele','IPWireless, Inc.'),(20820525056,'TitanEle','Titan Electronics, Inc.'),(20837302272,'RelaxTec','Relax Technology, Inc.'),(20854079488,'TellusGr','Tellus Group Corp.'),(20870856704,'NortelNe','Nortel Networks'),(20887633920,'Cisco','CISCO SYSTEMS, INC.'),(20904411136,'Cisco','CISCO SYSTEMS, INC.'),(20921188352,'TeracomT','Teracom Telematica Ltda.'),(20937965568,'ProcketN','Procket Networks'),(20954742784,'Infinior','Infinior Microsystems'),(20971520000,'SmcNetwo','SMC Networks, Inc.'),(20988297216,'AcctonTe','Accton Technology Corp.'),(21005074432,'Daeryung','Daeryung Ind., Inc.'),(21021851648,'Glonet','Glonet Systems, Inc.'),(21038628864,'BanyanNe','Banyan Network Private Limited'),(21055406080,'Lightpoi','Lightpointe Communications, Inc'),(21072183296,'Ier','IER, Inc.'),(21088960512,'Infinisw','Infiniswitch Corporation'),(21105737728,'Hewlett-','Hewlett-Packard Company'),(21122514944,'PaxonetC','Paxonet Communications, Inc.'),(21139292160,'MemoboxS','Memobox SA'),(21156069376,'BillionE','Billion Electric Co., Ltd.'),(21172846592,'LincolnE','Lincoln Electric Company'),(21189623808,'Polestar','Polestar Corp.'),(21206401024,'Internat','International Computers, Ltd'),(21223178240,'Wherenet',''),(21239955456,'Polycom',''),(21256732672,'FsForth-','FS FORTH-SYSTEME GmbH'),(21273509888,'Infinite','Infinite Electronics Inc.'),(21290287104,'Snowshor','SnowShore Networks, Inc.'),(21307064320,'Amphus',''),(21323841536,'OmegaBan','Omega Band, Inc.'),(21340618752,'Qualicab','QUALICABLE TV Industria E Com., '),(21357395968,'XteraCom','Xtera Communications, Inc.'),(21374173184,'NbsTechn','NBS Technologies Inc.'),(21390950400,'Commtech','Commtech, Inc.'),(21407727616,'StratusC','Stratus Computer (DE), Inc.'),(21424504832,'JapanCon','Japan Control Engineering Co., L'),(21441282048,'PelagoNe','Pelago Networks'),(21458059264,'Acronet','Acronet Co., Ltd.'),(21474836480,'Cisco','CISCO SYSTEMS, INC.'),(21491613696,'Cisco','CISCO SYSTEMS, INC.'),(21508390912,'AppleCom','APPLE COMPUTER'),(21525168128,'Iconag',''),(21541945344,'NarayInf','Naray Information & Communicatio'),(21558722560,'Integrat','Systems Integration Solutions, I'),(21575499776,'ReddoNet','Reddo Networks AB'),(21592276992,'FineAppl','Fine Appliance Corp.'),(21609054208,'Inetcam','Inetcam, Inc.'),(21625831424,'AvocNish','AVOC Nishimura Ltd.'),(21642608640,'Ics','ICS Spa'),(21659385856,'Sicom','SICOM Systems, Inc.'),(21676163072,'NetworkP','Network Photonics, Inc.'),(21692940288,'Midstrea','Midstream Technologies, Inc.'),(21709717504,'3ware','3ware, Inc.'),(21726494720,'TanakaS/','Tanaka S/S Ltd.'),(21743271936,'Infinite','Infinite Shanghai Communication '),(21760049152,'Compleme','Complementary Technologies Ltd'),(21776826368,'Meshnetw','MeshNetworks, Inc.'),(21793603584,'VtlinxMu','VTLinx Multimedia Systems, Inc.'),(21810380800,'Kdt','KDT Systems Co., Ltd.'),(21827158016,'Nuark','Nuark Co., Ltd.'),(21843935232,'SmartMod','SMART Modular Technologies'),(21860712448,'Shellcom','Shellcomm, Inc.'),(21877489664,'Jupiters','Jupiters Technology'),(21894266880,'SiemensB','Siemens Building Technologies AG'),(21911044096,'3comEuro','3Com Europe Ltd.'),(21927821312,'MagicCon','Magic Control Technology Corpora'),(21944598528,'XnetTech','Xnet Technology Corp.'),(21961375744,'Airocon','Airocon, Inc.'),(21978152960,'BrocadeC','Brocade Communications Systems, '),(21994930176,'TaijinMe','Taijin Media Co., Ltd.'),(22011707392,'Smartron','Smartronix, Inc.'),(22028484608,'ControlM','Control Microsystems'),(22045261824,'Lea*D','LEA*D Corporation, Inc.'),(22062039040,'AvlList','AVL List GmbH'),(22078816256,'BtlSyste','BTL System (HK) Limited'),(22095593472,'PuretekI','Puretek Industrial Co., Ltd.'),(22112370688,'Ipas','IPAS GmbH'),(22129147904,'SjTek','SJ Tek Co. Ltd'),(22145925120,'NewFocus','New Focus, Inc.'),(22162702336,'Shanghai','Shanghai Broadan Communication T'),(22179479552,'IkegamiT','Ikegami Tsushinki Co., Ltd.'),(22196256768,'Horiba','HORIBA, Ltd.'),(22213033984,'SupremeM','Supreme Magic Corporation'),(22229811200,'ZoltrixI','Zoltrix International Limited'),(22246588416,'CintaNet','Cinta Networks'),(22263365632,'LevitonN','Leviton Network Solutions'),(22280142848,'Andiamo','Andiamo Systems, Inc.'),(22296920064,'Cisco','CISCO SYSTEMS, INC.'),(22313697280,'Cisco','CISCO SYSTEMS, INC.'),(22330474496,'BrocadeC','Brocade Communications Systems, '),(22347251712,'Northsta','Northstar Engineering Ltd.'),(22364028928,'ChipPc','Chip PC Ltd.'),(22380806144,'DanamCom','Danam Communications, Inc.'),(22397583360,'NetsTech','Nets Technology Co., Ltd.'),(22414360576,'Merilus','Merilus, Inc.'),(22431137792,'ABrandNe','A Brand New World in Sweden AB'),(22447915008,'Willowgl','Willowglen Services Pte Ltd'),(22464692224,'HarbourN','Harbour Networks Ltd., Co. Beiji'),(22481469440,'Xircom',''),(22498246656,'Agere','Agere Systems'),(22515023872,'KidSyste','KID Systeme GmbH'),(22531801088,'Visionte','VisionTek, Inc.'),(22548578304,'Fast','FAST Corporation'),(22565355520,'Advanced','Advanced Systems Co., Ltd.'),(22582132736,'Otari','Otari, Inc.'),(22598909952,'IqWirele','IQ Wireless GmbH'),(22615687168,'ValleyTe','Valley Technologies, Inc.'),(22632464384,'Internet','Internet Photonics'),(22649241600,'KddiNetw','KDDI Network & Solultions Inc.'),(22666018816,'StarentN','Starent Networks'),(22682796032,'Disco','Disco Corporation'),(22699573248,'SaliraOp','Salira Optical Network Systems'),(22716350464,'ArioData','Ario Data Networks, Inc.'),(22733127680,'EatonAut','Eaton Automation AG'),(22749904896,'RfInnova','RF Innovations Pty Ltd'),(22766682112,'BransTec','Brans Technologies, Inc.'),(22783459328,'Philips',''),(22800236544,'Private',''),(22817013760,'VcommsCo','Vcomms Connect Limited'),(22833790976,'FSElektr','F & S Elektronik Systeme GmbH'),(22850568192,'XycotecC','Xycotec Computer GmbH'),(22867345408,'Dvc','DVC Company, Inc.'),(22884122624,'Rangesta','Rangestar Wireless'),(22900899840,'JapanCas','Japan Cash Machine Co., Ltd.'),(22917677056,'360','360 Systems'),(22934454272,'AgileTv','Agile TV Corporation'),(22951231488,'Synchron','Synchronous, Inc.'),(22968008704,'Intracom','Intracom S.A.'),(22984785920,'PowerDsi','Power Dsine Ltd.'),(23001563136,'CharlesI','Charles Industries, Ltd.'),(23018340352,'Kowa','Kowa Company, Ltd.'),(23035117568,'D-Link','D-Link Systems, Inc.'),(23051894784,'Cisco','CISCO SYSTEMS, INC.'),(23068672000,'Cisco','CISCO SYSTEMS, INC.'),(23085449216,'LeaderCo','LEADER COMM.CO., LTD'),(23102226432,'NacImage','nac Image Technology, Inc.'),(23119003648,'DigitalV','Digital View Limited'),(23135780864,'J-Works','J-Works, Inc.'),(23152558080,'Tsinghua','Tsinghua Bitway Co., Ltd.'),(23169335296,'TailynCo','Tailyn Communication Company Ltd'),(23186112512,'SecuiCom','Secui.com Corporation'),(23202889728,'Etymonic','Etymonic Design, Inc.'),(23219666944,'Piltofis','Piltofish Networks AB'),(23236444160,'Vmware','VMware, Inc.'),(23253221376,'HeuftSys','Heuft Systemtechnik GmbH'),(23269998592,'CPTechno','C.P. Technology Co., Ltd.'),(23286775808,'HungChan','Hung Chang Co., Ltd.'),(23303553024,'Pacific','Pacific Corporation'),(23320330240,'National','National Enhance Technology, Inc'),(23337107456,'Innomedi','Innomedia Technologies Pvt. Ltd.'),(23353884672,'Baydel','Baydel Ltd.'),(23370661888,'SeiwaEle','Seiwa Electronics Co.'),(23387439104,'Deonet','Deonet Co., Ltd.'),(23404216320,'Cisco','CISCO SYSTEMS, INC.'),(23420993536,'Cisco','CISCO SYSTEMS, INC.'),(23437770752,'Cds-Elec','CDS-Electronics BV'),(23454547968,'NsmTechn','NSM Technology Ltd.'),(23471325184,'SmInform','SM Information & Communication'),(23488102400,'Private',''),(23504879616,'Universa','Universal Control Solution Corp.'),(23521656832,'Overture','Overture Networks'),(23538434048,'ChungNam','Chung Nam Electronic Co., Ltd.'),(23555211264,'RcoSecur','RCO Security AB'),(23571988480,'SunCommu','Sun Communications, Inc.'),(23588765696,'Eckelman','Eckelmann Steuerungstechnik GmbH'),(23605542912,'AcqisTec','Acqis Technology'),(23622320128,'Fibrolan','FibroLAN Ltd.'),(23639097344,'Snell',''),(23655874560,'Clearcub','ClearCube Technology'),(23672651776,'Imagecom','ImageCom Limited'),(23689428992,'Absolute','AbsoluteValue Systems, Inc.'),(23706206208,'JuniperN','Juniper Networks, Inc.'),(23722983424,'LucentTe','Lucent Technologies'),(23739760640,'Locus','Locus, Incorporated'),(23756537856,'Sensoria','Sensoria Corp.'),(23773315072,'National','National Datacomputer'),(23790092288,'Netcom','Netcom Co., Ltd.'),(23806869504,'Ipmental','IPmental, Inc.'),(23823646720,'Opentech','Opentech Inc.'),(23840423936,'LynxPhot','Lynx Photonic Networks, Inc.'),(23857201152,'Flextron','Flextronics International GmbH &'),(23873978368,'Clcsoft','CLCsoft co.'),(23890755584,'Swissvoi','Swissvoice Ltd.'),(23907532800,'ActiveSi','Active Silicon Ltd'),(23924310016,'Pultek','Pultek Corp.'),(23941087232,'GrammarE','Grammar Engine Inc.'),(23957864448,'IxxatAut','IXXAT Automation GmbH'),(23974641664,'Alesis','Alesis Corporation'),(23991418880,'Genotech','Genotech Co., Ltd.'),(24008196096,'EagleTra','Eagle Traffic Control Systems'),(24024973312,'CronosSR','CRONOS S.r.l.'),(24041750528,'DrsTestA','DRS Test and Energy Management o'),(24058527744,'Cisco','CISCO SYSTEMS, INC.'),(24075304960,'Cisco','CISCO SYSTEMS, INC.'),(24092082176,'Kleinkne','Kleinknecht GmbH, Ing. BÃ¼ro'),(24108859392,'DanielCo','Daniel Computing Systems, Inc.'),(24125636608,'Zinwell','Zinwell Corporation'),(24142413824,'YottaNet','Yotta Networks, Inc.'),(24159191040,'Mobiline','MOBILINE Kft.'),(24175968256,'Zenocom',''),(24192745472,'CeloxNet','CELOX Networks'),(24209522688,'Qei','QEI, Inc.'),(24226299904,'LucidVoi','Lucid Voice Ltd.'),(24243077120,'Kott',''),(24259854336,'ExtronEl','Extron Electronics'),(24276631552,'Hyperchi','Hyperchip, Inc.'),(24293408768,'WyleElec','WYLE ELECTRONICS'),(24310185984,'Princeto','Princeton Networks, Inc.'),(24326963200,'MooreInd','Moore Industries International I'),(24343740416,'CyberFon','Cyber Fone, Inc.'),(24360517632,'Northern','Northern Digital, Inc.'),(24377294848,'TopspinC','Topspin Communications, Inc.'),(24394072064,'Mediapor','Mediaport USA'),(24410849280,'Innoscan','InnoScan Computing A/S'),(24427626496,'KoreaCom','Korea Computer Technology Co., L'),(24444403712,'AsbTechn','ASB Technology BV'),(24461180928,'Medison','Medison Co., Ltd.'),(24477958144,'Asahi-En','Asahi-Engineering Co., Ltd.'),(24494735360,'Aceex','Aceex Corporation'),(24511512576,'Broadcom','Broadcom Technologies'),(24528289792,'InsysMic','INSYS Microelectronics GmbH'),(24545067008,'ArborTec','Arbor Technology Corp.'),(24561844224,'Electron','Electronic Design Associates, In'),(24578621440,'Airvana','Airvana, Inc.'),(24595398656,'AreaNetw','Area Netwoeks, Inc.'),(24612175872,'Myspace','Myspace AB'),(24628953088,'Resorsys','Resorsys Ltd.'),(24645730304,'RoaxBv','ROAX BV'),(24662507520,'Kongsber','Kongsberg Seatex AS'),(24679284736,'JustezyT','JustEzy Technology, Inc.'),(24696061952,'DigitalN','Digital Network Alacarte Co., Lt'),(24712839168,'A-KyungM','A-Kyung Motion, Inc.'),(24729616384,'Soronti','Soronti, Inc.'),(24746393600,'PacificI','Pacific Instruments, Inc.'),(24763170816,'Telect','Telect, Inc.'),(24779948032,'FlagaHf','Flaga HF'),(24796725248,'TrizComm','Triz Communications'),(24813502464,'I/F-Com','I/F-COM A/S'),(24830279680,'Verytech',''),(24847056896,'LgInnote','LG Innotek Co., Ltd.'),(24863834112,'HitronTe','Hitron Technology, Inc.'),(24880611328,'RoisTech','ROIS Technologies, Inc.'),(24897388544,'SumtelCo','Sumtel Communications, Inc.'),(24914165760,'Denon','Denon, Ltd.'),(24930942976,'ProlinkM','Prolink Microsystems Corporation'),(24947720192,'ThunderR','Thunder River Technologies, Inc.'),(24964497408,'Solinet','Solinet Systems'),(24981274624,'Metavect','Metavector Technologies'),(24998051840,'DapTechn','DAP Technologies'),(25014829056,'Eproduct','eProduction Solutions, Inc.'),(25031606272,'Futuresm','FutureSmart Networks, Inc.'),(25048383488,'Speedcom','Speedcom Wireless'),(25065160704,'L-3Linka','L-3 Linkabit'),(25081937920,'VistaIma','Vista Imaging, Inc.'),(25098715136,'Arescom','Arescom, Inc.'),(25115492352,'TechnoVa','Techno Valley, Inc.'),(25132269568,'ApexAuto','Apex Automationstechnik'),(25149046784,'PsiNente','PSI Nentec GmbH'),(25165824000,'Cisco','CISCO SYSTEMS, INC.'),(25182601216,'Cisco','CISCO SYSTEMS, INC.'),(25199378432,'GiFoneKo','Gi Fone Korea, Inc.'),(25216155648,'Electron','Electronic Innovation, Inc.'),(25232932864,'Empirix','Empirix Corp.'),(25249710080,'TrellisP','Trellis Photonics, Ltd.'),(25266487296,'CreativN','Creativ Network Technologies'),(25283264512,'Lightsan','LightSand Communications, Inc.'),(25300041728,'RedLionC','Red Lion Controls Inc.'),(25316818944,'Renishaw','Renishaw PLC'),(25333596160,'Egenera','Egenera, Inc.'),(25350373376,'NetrakeA','Netrake an AudioCodes Company'),(25367150592,'Turbowav','TurboWave, Inc.'),(25383927808,'UnicessN','Unicess Network, Inc.'),(25400705024,'Rednix',''),(25417482240,'BlueRidg','Blue Ridge Networks, Inc.'),(25434259456,'Mosaic','Mosaic Systems Inc.'),(25451036672,'Techniku','Technikum Joanneum GmbH'),(25467813888,'BewatorG','BEWATOR Group'),(25484591104,'AdoirDig','ADOIR Digital Technology'),(25501368320,'Satec',''),(25518145536,'Vrcom','Vrcom, Inc.'),(25534922752,'PowerR','Power R, Inc.'),(25551699968,'Webyn',''),(25568477184,'SystemBa','System Base Co., Ltd.'),(25585254400,'Geospace','Geospace Technologies'),(25602031616,'YoungCha','Young Chang Co. Ltd.'),(25618808832,'AnalogDe','Analog Devices, Inc.'),(25635586048,'RealTime','Real Time Access, Inc.'),(25652363264,'Toa','TOA Corporation'),(25669140480,'Ipoptica','IPOptical, Inc.'),(25685917696,'Sharegat','ShareGate, Inc.'),(25702694912,'SchenckP','Schenck Pegasus Corp.'),(25719472128,'Packetli','PacketLight Networks Ltd.'),(25736249344,'Traficon','Traficon N.V.'),(25753026560,'SnsSolut','SNS Solutions, Inc.'),(25769803776,'ToshibaT','Toshiba Teli Corporation'),(25786580992,'Otanikei','Otanikeiki Co., Ltd.'),(25803358208,'Cirkitec','Cirkitech Electronics Co.'),(25820135424,'BakerHug','Baker Hughes Inc.'),(25836912640,'@TrackCo','@Track Communications, Inc.'),(25853689856,'InncomIn','Inncom International, Inc.'),(25870467072,'Rapidwan','RapidWAN, Inc.'),(25887244288,'OmniDire','Omni Directional Control Technol'),(25904021504,'At-SkySa','At-Sky SAS'),(25920798720,'Crosspor','Crossport Systems'),(25937575936,'Blue2spa','Blue2space'),(25954353152,'EmersonN','Emerson Network Power'),(25971130368,'MelcoInd','Melco Industries, Inc.'),(25987907584,'Wave7Opt','Wave7 Optics'),(26004684800,'Igys','IGYS Systems, Inc.'),(26021462016,'NaradNet','Narad Networks Inc'),(26038239232,'AbeonaNe','Abeona Networks Inc'),(26055016448,'ZeusWire','Zeus Wireless, Inc.'),(26071793664,'Accusys','Accusys, Inc.'),(26088570880,'Kawasaki','Kawasaki Microelectronics Incorp'),(26105348096,'PrismHol','Prism Holdings'),(26122125312,'KimotoEl','Kimoto Electric Co., Ltd.'),(26138902528,'TelNet','Tel Net Co., Ltd.'),(26155679744,'Redswitc','Redswitch Inc.'),(26172456960,'Digipowe','DigiPower Manufacturing Inc.'),(26189234176,'Connecti','Connection Technology Systems'),(26206011392,'Zetari','Zetari Inc.'),(26222788608,'Notebook','Notebook Development Lab.  Lenov'),(26239565824,'HoshinoM','Hoshino Metal Industries, Ltd.'),(26256343040,'MipTelec','MIP Telecom, Inc.'),(26273120256,'Maxan','Maxan Systems'),(26289897472,'VisionCo','Vision Components GmbH'),(26306674688,'SerialSy','Serial System Ltd.'),(26323451904,'Hinox','Hinox, Co., Ltd.'),(26340229120,'ChungFuC','Chung Fu Chen Yeh Enterprise Cor'),(26357006336,'MgeUpsFr','MGE UPS Systems France'),(26373783552,'GentnerC','Gentner Communications Corp.'),(26390560768,'LinksysG','The Linksys Group, Inc.'),(26407337984,'Mwe','MWE GmbH'),(26424115200,'UniwideT','Uniwide Technologies, Inc.'),(26440892416,'Cisco','CISCO SYSTEMS, INC.'),(26457669632,'Ibm','IBM Corp'),(26474446848,'Cisco','CISCO SYSTEMS, INC.'),(26491224064,'Intraser','INTRASERVER TECHNOLOGY'),(26508001280,'BivioNet','Bivio Networks'),(26524778496,'Touchsta','TouchStar Technologies, L.L.C.'),(26541555712,'AristosL','Aristos Logic Corp.'),(26558332928,'Pivotech','Pivotech Systems Inc.'),(26575110144,'AdtranzS','Adtranz Sweden'),(26591887360,'Calix',''),(26608664576,'MescoEng','Mesco Engineering GmbH'),(26625441792,'CrossMat','Cross Match Technologies GmbH'),(26642219008,'GteAirfo','GTE Airfone Inc.'),(26658996224,'Packetai','PacketAir Networks, Inc.'),(26675773440,'JedaiBro','Jedai Broadband Networks'),(26692550656,'Toptrend','Toptrend-Meta Information (ShenZ'),(26709327872,'SungjinC','Sungjin C&C Co., Ltd.'),(26726105088,'Newtec',''),(26742882304,'DuraMicr','Dura Micro, Inc.'),(26759659520,'Arcturus','Arcturus Networks Inc.'),(26776436736,'Intrinsy','Intrinsyc Software International'),(26793213952,'Microwav','Microwave Data Systems Inc.'),(26809991168,'Opthos','Opthos Inc.'),(26826768384,'EverexCo','Everex Communications Inc.'),(26843545600,'WhiteRoc','White Rock Networks'),(26860322816,'Itcn',''),(26877100032,'Genetel','Genetel Systems Inc.'),(26893877248,'SonoComp','SONO Computer Co., Ltd.'),(26910654464,'Neix','Neix,Inc'),(26927431680,'MeiseiEl','Meisei Electric Co. Ltd.'),(26944208896,'Shenzhen','ShenZhen XunBao Network Technolo'),(26960986112,'EtraliSA','Etrali S.A.'),(26977763328,'Seedswar','Seedsware, Inc.'),(26994540544,'3mDeutsc','3M Deutschland GmbH'),(27011317760,'Honeywel','Honeywell Co., Ltd. (KOREA)'),(27028094976,'Alexon','Alexon Co., Ltd.'),(27044872192,'InvictaN','Invicta Networks, Inc.'),(27061649408,'Sencore',''),(27078426624,'BroadNet','Broad Net Technology Inc.'),(27095203840,'Pro-Nets','PRO-NETS Technology Corporation'),(27111981056,'TiburonN','Tiburon Networks, Inc.'),(27128758272,'AspenNet','Aspen Networks Inc.'),(27145535488,'Cisco','CISCO SYSTEMS, INC.'),(27162312704,'Cisco','CISCO SYSTEMS, INC.'),(27179089920,'Winpresa','Winpresa Building Automation Tec'),(27195867136,'Yipee','Yipee, Inc.'),(27212644352,'Tactel','Tactel AB'),(27229421568,'MarketCe','Market Central, Inc.'),(27246198784,'HelmutFi','Helmut Fischer GmbH Institut fÃ¼'),(27262976000,'EalApeld','EAL (Apeldoorn) B.V.'),(27279753216,'Strix','Strix Systems'),(27296530432,'DellComp','Dell Computer Corp.'),(27313307648,'Malachit','Malachite Technologies, Inc.'),(27330084864,'Heidelbe','Heidelberg Web Systems'),(27346862080,'Photuris','Photuris, Inc.'),(27363639296,'EciTelec','ECI Telecom - NGTS Ltd.'),(27380416512,'Nadex','NADEX Co., Ltd.'),(27397193728,'NiaHomeT','NIA Home Technologies Corp.'),(27413970944,'MbmTechn','MBM Technology Ltd.'),(27430748160,'HumanTec','Human Technology Co., Ltd.'),(27447525376,'Fostex','Fostex Corporation'),(27464302592,'SunnyGik','Sunny Giken, Inc.'),(27481079808,'RovingNe','Roving Networks'),(27497857024,'TrippLit','Tripp Lite'),(27514634240,'ViconInd','Vicon Industries Inc.'),(27531411456,'Datasoun','Datasound Laboratories Ltd'),(27548188672,'Infinico','InfiniCon Systems, Inc.'),(27564965888,'Sysmex','Sysmex Corporation'),(27581743104,'Robinson','Robinson Corporation'),(27598520320,'Compupri','Compuprint S.P.A.'),(27615297536,'DeltaEle','Delta Electronics, Inc.'),(27632074752,'KoreaDat','Korea Data Systems'),(27648851968,'Upponett','Upponetti Oy'),(27665629184,'Softing','Softing AG'),(27682406400,'Netezza',''),(27699183616,'TkhSecur','TKH Security Solutions USA'),(27715960832,'Spectrum','Spectrum Control, Inc.'),(27732738048,'Banderac','Banderacom, Inc.'),(27749515264,'NovraTec','Novra Technologies Inc.'),(27766292480,'Sick','SICK AG'),(27783069696,'MarantzB','Marantz Brand Company'),(27799846912,'Konami','Konami Corporation'),(27816624128,'Jmp','JMP Systems'),(27833401344,'ToplinkC','Toplink C&C Corporation'),(27850178560,'Cisco','CISCO SYSTEMS, INC.'),(27866955776,'Takasago','Takasago Ltd.'),(27883732992,'Wincom','WinCom Systems, Inc.'),(27900510208,'Digeo','Digeo, Inc.'),(27917287424,'CardAcce','Card Access, Inc.'),(27934064640,'GoepelEl','Goepel Electronic GmbH'),(27950841856,'Convedia',''),(27967619072,'BravaraC','Bravara Communications, Inc.'),(27984396288,'Biacore','Biacore AB'),(28001173504,'Netnearu','NetNearU Corporation'),(28017950720,'Zardcom','ZARDCOM Co., Ltd.'),(28034727936,'Omnitron','Omnitron Systems Technology, Inc'),(28051505152,'TelwaysC','Telways Communication Co., Ltd.'),(28068282368,'YlezTech','yLez Technologies Pte Ltd'),(28085059584,'Neuronne','NeuronNet Co. Ltd. R&D Center'),(28101836800,'Airrunne','AirRunner Technologies, Inc.'),(28118614016,'3com','3Com Corporation'),(28135391232,'Sepaton','SEPATON, Inc.'),(28152168448,'Hid','HID Corporation'),(28168945664,'Telemoni','Telemonitor, Inc.'),(28185722880,'EuracomC','Euracom Communication GmbH'),(28202500096,'PtInovac','PT Inovacao'),(28219277312,'Intruver','Intruvert Networks, Inc.'),(28236054528,'FlexusCo','Flexus Computer Technology, Inc.'),(28252831744,'Mobillia','Mobillian Corporation'),(28269608960,'EnsureTe','Ensure Technologies, Inc.'),(28286386176,'AdventNe','Advent Networks'),(28303163392,'RDCenter','R & D Center'),(28319940608,'Egnite','egnite GmbH'),(28336717824,'VidaDesi','Vida Design Co.'),(28353495040,'ETel','e & Tel'),(28370272256,'AvtAudio','AVT Audio Video Technologies Gmb'),(28387049472,'Transmod','Transmode Systems AB'),(28403826688,'Petards','Petards Ltd'),(28420603904,'Uniqa','UNIQA, Inc.'),(28437381120,'KuokoaNe','Kuokoa Networks'),(28454158336,'MxImagin','Mx Imaging'),(28470935552,'CelsianT','Celsian Technologies, Inc.'),(28487712768,'Microtun','Microtune, Inc.'),(28504489984,'Bitran','Bitran Corporation'),(28521267200,'Innowell','INNOWELL Corp.'),(28538044416,'Pinon','PINON Corp.'),(28554821632,'Artistic','Artistic Licence Engineering Ltd'),(28571598848,'Primario','Primarion'),(28588376064,'KcTechno','KC Technology, Inc.'),(28605153280,'Universa','Universal Instruments Corp.'),(28621930496,'VtMiltop','VT Miltope'),(28638707712,'W-Link','W-Link Systems, Inc.'),(28655484928,'Intersof','Intersoft Co.'),(28672262144,'KbElectr','KB Electronics Ltd.'),(28689039360,'Himachal','Himachal Futuristic Communicatio'),(28705816576,'XaltedNe','Xalted Networks'),(28722593792,'ComtechE','Comtech EF Data Corp.'),(28739371008,'Sonicwal','Sonicwall'),(28756148224,'Linxtek','Linxtek Co.'),(28772925440,'Diagraph','Diagraph Corporation'),(28789702656,'VorneInd','Vorne Industries, Inc.'),(28806479872,'SourcePh','Source Photonics, Inc.'),(28823257088,'Nir-OrIs','Nir-Or Israel Ltd.'),(28840034304,'Telem','TELEM GmbH'),(28856811520,'Bandspee','Bandspeed Pty Ltd'),(28873588736,'A5tek','A5TEK Corp.'),(28890365952,'Westwave','Westwave Communications'),(28907143168,'AtiTechn','ATI Technologies Inc.'),(28923920384,'Macrolin','Macrolink, Inc.'),(28940697600,'Bntechno','BNTECHNOLOGY Co., Ltd.'),(28957474816,'BaumerOp','Baumer Optronic GmbH'),(28974252032,'AccellaT','Accella Technologies Co., Ltd.'),(28991029248,'UnitedIn','United Internetworks, Inc.'),(29007806464,'Cisco','CISCO SYSTEMS, INC.'),(29024583680,'Smartmat','Smartmatic Corporation'),(29041360896,'Schindle','Schindler Elevator Ltd.'),(29058138112,'Piolink','Piolink Inc.'),(29074915328,'InnoviTe','INNOVI Technologies Limited'),(29091692544,'Lesswire','lesswire AG'),(29108469760,'RfnetTec','RFNET Technologies Pte Ltd (S)'),(29125246976,'Sumitomo','Sumitomo Metal Micro Devices, In'),(29142024192,'Technica','Technical Marketing Research, In'),(29158801408,'American','American Computer & Digital Comp'),(29175578624,'JotronEl','Jotron Electronics A/S'),(29192355840,'JmiElect','JMI Electronics Co., Ltd.'),(29209133056,'LeafImag','Leaf Imaging Ltd.'),(29225910272,'Dateno',''),(29242687488,'ThalesAv','Thales Avionics In-Flight System'),(29259464704,'ElgarEle','Elgar Electronics Corp.'),(29276241920,'TahoeNet','Tahoe Networks, Inc.'),(29293019136,'TundraSe','Tundra Semiconductor Corp.'),(29309796352,'AlphaTel','Alpha Telecom, Inc. U.S.A.'),(29326573568,'Interact','Interactive Objects, Inc.'),(29343350784,'Diamond','Diamond Systems Corp.'),(29360128000,'Cisco','CISCO SYSTEMS, INC.'),(29376905216,'Cisco','CISCO SYSTEMS, INC.'),(29393682432,'MapleOpt','Maple Optical Systems'),(29410459648,'Ipm-NetS','IPM-Net S.p.A.'),(29427236864,'ItranCom','ITRAN Communications Ltd.'),(29444014080,'Ichips','ICHIPS Co., Ltd.'),(29460791296,'SyabasTe','Syabas Technology (Amquest)'),(29477568512,'AtTLabor','AT & T Laboratories - Cambridge '),(29494345728,'FlashTec','Flash Technology'),(29511122944,'Aidonic','AIDONIC Corporation'),(29527900160,'Mat','MAT Co., Ltd.'),(29544677376,'TechnoTr','Techno Trade s.a'),(29561454592,'CeemaxTe','Ceemax Technology Co., Ltd.'),(29578231808,'Quantita','Quantitative Imaging Corporation'),(29595009024,'CitelTec','Citel Technologies Ltd.'),(29611786240,'FujianNe','Fujian Newland Computer Ltd. Co.'),(29628563456,'Dongyang','DongYang Telecom Co., Ltd.'),(29645340672,'BitBlitz','Bit Blitz Communications Inc.'),(29662117888,'OpticalN','Optical Network Testing, Inc.'),(29678895104,'Intime','Intime Corp.'),(29695672320,'Elzet80M','ELZET80 Mikrocomputer GmbH&Co. K'),(29712449536,'GlobalDa','Global Data'),(29729226752,'Harris','Harris Corporation'),(29746003968,'InaraNet','Inara Networks'),(29762781184,'Shenyang','Shenyang Neu-era Information & T'),(29779558400,'Maxxan','Maxxan Systems, Inc.'),(29796335616,'Digeo','Digeo, Inc.'),(29813112832,'Optillio','Optillion'),(29829890048,'PlatysCo','Platys Communications'),(29846667264,'Acceligh','AcceLight Networks'),(29863444480,'PrimeEle','Prime Electronics & Satellitics '),(29880221696,'Alps','ALPS Co,. Ltd.'),(29896998912,'Cisco','CISCO SYSTEMS, INC.'),(29913776128,'Alps','ALPS Co,. Ltd.'),(29930553344,'CpuTechn','CPU Technology, Inc.'),(29947330560,'MitsuiZo','Mitsui Zosen Systems Research In'),(29964107776,'IpSquare','IP SQUARE Co, Ltd.'),(29980884992,'HitachiP','Hitachi Printing Solutions, Ltd.'),(29997662208,'Fnet','Fnet Co., Ltd.'),(30014439424,'ComjetIn','Comjet Information Systems Corp.'),(30031216640,'Ambrado','Ambrado, Inc'),(30047993856,'Sheba','Sheba Systems Co., Ltd.'),(30064771072,'Zettamed','Zettamedia Korea'),(30081548288,'Cisco','RACAL-DATACOM'),(30098325504,'VarianMe','Varian Medical Systems'),(30115102720,'CseeTran','CSEE Transport'),(30131879936,'Alps','ALPS Co,. Ltd.'),(30148657152,'EndressH','Endress & Hauser GmbH & Co'),(30165434368,'Sanritz','Sanritz Corporation'),(30182211584,'Interali','Interalia Inc.'),(30198988800,'Bitrage','Bitrage Inc.'),(30215766016,'Westerst','Westerstrand Urfabrik AB'),(30232543232,'UnicomAu','Unicom Automation Co., Ltd.'),(30249320448,'Novabase','Novabase SGPS, SA'),(30266097664,'Sva-Intr','SVA-Intrusion.com Co. Ltd.'),(30282874880,'Cisco','CISCO SYSTEMS, INC.'),(30299652096,'Cisco','CISCO SYSTEMS, INC.'),(30316429312,'Fujant','Fujant, Inc.'),(30333206528,'Adax','Adax, Inc.'),(30349983744,'Acterna',''),(30366760960,'JalInfor','JAL Information Technology'),(30383538176,'IpOne','IP One, Inc.'),(30400315392,'Brightco','Brightcom'),(30417092608,'GeneralR','General Research of Electronics,'),(30433869824,'JSMarine','J & S Marine Ltd.'),(30450647040,'WielandE','Wieland Electric GmbH'),(30467424256,'Icantek','iCanTek Co., Ltd.'),(30484201472,'Mobiis','Mobiis Co., Ltd.'),(30500978688,'Finedigi','Finedigital Inc.'),(30517755904,'CdviAmer','CDVI Americas Ltd'),(30534533120,'At&TFixe','AT&T Fixed Wireless Services'),(30551310336,'SatelsaS','Satelsa Sistemas Y Aplicaciones '),(30568087552,'Tri-MEng','Tri-M Engineering / Nupak Dev. C'),(30584864768,'European','European Systems Integration'),(30601641984,'Trutzsch','Trutzschler GmbH & Co. KG'),(30618419200,'FormacEl','Formac Elektronik GmbH'),(30635196416,'Nielsen','The Nielsen Company'),(30651973632,'ElconSys','ELCON Systemtechnik GmbH'),(30668750848,'Telemax','Telemax Co., Ltd.'),(30685528064,'Bematech','Bematech International Corp.'),(30702305280,'Shenzhen','Shenzhen Gongjin Electronics Co.'),(30719082496,'ZiHk','Zi Corporation (HK) Ltd.'),(30735859712,'NeoTelec','Neo Telecom'),(30752636928,'KistlerI','Kistler Instrumente AG'),(30769414144,'Innovanc','Innovance Networks'),(30786191360,'JungMyun','Jung Myung Telecom Co., Ltd.'),(30802968576,'Fabricom',''),(30819745792,'Cnsystem','CNSystems'),(30836523008,'NorthNod','North Node AB'),(30853300224,'Intransa','Intransa, Inc.'),(30870077440,'Hutchiso','Hutchison OPTEL Telecom Technolo'),(30886854656,'Ophir-Sp','Ophir-Spiricon LLC'),(30903631872,'AaeonTec','AAEON Technology Inc.'),(30920409088,'Dancontr','DANCONTROL Engineering'),(30937186304,'Onstor','ONStor, Inc.'),(30953963520,'FlarionT','Flarion Technologies, Inc.'),(30970740736,'DataVide','Data Video Technologies Co., Ltd'),(30987517952,'Soriya','Soriya Co. Ltd.'),(31004295168,'YoungTec','Young Technology Co., Ltd.'),(31021072384,'ScottyGr','Scotty Group Austria Gmbh'),(31037849600,'Inventel','Inventel Systemes'),(31054626816,'Tenovis','Tenovis GmbH & Co KG'),(31071404032,'TelecomD','Telecom Design'),(31088181248,'NanjingP','Nanjing Postel Telecommunication'),(31104958464,'ChinaGre','China Great-Wall Computer Shenzh'),(31121735680,'WoojyunS','Woojyun Systec Co., Ltd.'),(31138512896,'Buffalo','Buffalo Inc.'),(31155290112,'SierraAu','Sierra Automated Systems'),(31172067328,'CurrentT','Current Technologies, LLC'),(31188844544,'ChelsioC','Chelsio Communications'),(31205621760,'Unico','Unico, Inc.'),(31222398976,'RadlanCo','Radlan Computer Communications L'),(31239176192,'Turck','TURCK, Inc.'),(31255953408,'Mecalc',''),(31272730624,'ImagingS','The Imaging Source Europe'),(31289507840,'Cenix','CENiX Inc.'),(31306285056,'CarlVale','Carl Valentin GmbH'),(31323062272,'Daihen','Daihen Corporation'),(31339839488,'Beicom','Beicom Inc.'),(31356616704,'ZebraTec','Zebra Technologies Corp.'),(31373393920,'Ipfront','IPFRONT Inc'),(31390171136,'Cisco','CISCO SYSTEMS, INC.'),(31406948352,'Cisco','CISCO SYSTEMS, INC.'),(31423725568,'M-U-T','m-u-t AG'),(31440502784,'RhythmWa','Rhythm Watch Co., Ltd.'),(31457280000,'BeijingQ','Beijing Qxcomm Technology Co., L'),(31474057216,'XyterraC','Xyterra Computing, Inc.'),(31490834432,'Lafon',''),(31507611648,'JuyoungT','Juyoung Telecom'),(31524388864,'TopcallI','Topcall International AG'),(31541166080,'Dragonwa','Dragonwave'),(31557943296,'BorisMan','Boris Manufacturing Corp.'),(31574720512,'AirProdu','Air Products and Chemicals, Inc.'),(31591497728,'GibsonGu','Gibson Guitars'),(31608274944,'EastmanK','Eastman Kodak Company'),(31625052160,'Cellerit','Celleritas Inc.'),(31641829376,'AmetekPo','Ametek Power Instruments'),(31658606592,'VcsVideo','VCS Video Communication Systems '),(31675383808,'TomisInf','TOMIS Information & Telecom Corp'),(31692161024,'Logitech','Logitech Europe SA'),(31708938240,'GroupSen','Group Sense Limited'),(31725715456,'Sunniwel','Sunniwell Cyber Tech. Co., Ltd.'),(31742492672,'Youngwoo','YoungWoo Telecom Co. Ltd.'),(31759269888,'JadeQuan','Jade Quantum Technologies, Inc.'),(31776047104,'ChouChin','Chou Chin Industrial Co., Ltd.'),(31792824320,'YuxingEl','Yuxing Electronics Company Limit'),(31809601536,'Danfoss','Danfoss A/S'),(31826378752,'Italiana','Italiana Macchi SpA'),(31843155968,'Nexteye','NEXTEYE Co., Ltd.'),(31859933184,'Stralfor','Stralfors AB'),(31876710400,'Daehanet','Daehanet, Inc.'),(31893487616,'Flexligh','Flexlight Networks'),(31910264832,'Sinetica','Sinetica Corporation Limited'),(31927042048,'Synoptic','Synoptics Limited'),(31943819264,'Locusnet','Locusnetworks Corporation'),(31960596480,'Embedded','Embedded System Corporation'),(31977373696,'AlcatelS','Alcatel Shanghai Bell Co., Ltd.'),(31994150912,'AscomPow','Ascom Powerline Communications L'),(32010928128,'Guangzho','GuangZhou Thinker Technology Co.'),(32027705344,'ValenceS','Valence Semiconductor, Inc.'),(32044482560,'FederalA','Federal APD'),(32061259776,'Motah','Motah Ltd.'),(32078036992,'Gerstel','GERSTEL GmbH & Co. KG'),(32094814208,'SungilTe','Sungil Telecom Co., Ltd.'),(32111591424,'Infoware','Infoware System Co., Ltd.'),(32128368640,'Millimet','Millimetrix Broadband Networks'),(32145145856,'Westermo','Westermo Teleindustri AB'),(32161923072,'Cisco','CISCO SYSTEMS, INC.'),(32178700288,'Elrest','Elrest GmbH'),(32195477504,'JCommuni','J Communications Co., Ltd.'),(32212254720,'Bluegiga','Bluegiga Technologies OY'),(32229031936,'Itron','Itron Inc.'),(32245809152,'Oracle','Oracle Corporation'),(32262586368,'SyncomNe','SynCom Network, Inc.'),(32279363584,'Cisco','CISCO SYSTEMS, INC.'),(32296140800,'Cisco','CISCO SYSTEMS, INC.'),(32312918016,'Wireless','Wireless Networks Inc.'),(32329695232,'IdeaSyst','Idea System Co., Ltd.'),(32346472448,'Clipcomm','Clipcomm, Inc.'),(32363249664,'Dongwon','DONGWON SYSTEMS'),(32380026880,'MentorDa','Mentor Data System Inc.'),(32396804096,'WegenerC','Wegener Communications, Inc.'),(32413581312,'Elektron','Elektronikspecialisten i Borlang'),(32430358528,'Netengin','NetEngines Ltd.'),(32447135744,'GarzFric','Garz & Friche GmbH'),(32463912960,'EmkayInn','Emkay Innovative Products'),(32480690176,'Tri-MTec','Tri-M Technologies (s) Limited'),(32497467392,'Internat','International Data Communication'),(32514244608,'SÃ¼tronEl','SÃ¼tron Electronic GmbH'),(32531021824,'ShinSate','Shin Satellite Public Company Li'),(32547799040,'SimpleDe','Simple Devices, Inc.'),(32564576256,'Elitegro','Elitegroup Computer System Co. ('),(32581353472,'Lsi','LSI Systems, Inc.'),(32598130688,'Netpower','Netpower Co., Ltd.'),(32614907904,'SeleaSrl','Selea SRL'),(32631685120,'TippingPoint','TippingPoint Technologies, Inc.'),(32648462336,'Verint','Verint Systems Inc'),(32665239552,'AuroraNe','Aurora Networks'),(32682016768,'GoldenEl','Golden Electronics Technology Co'),(32698793984,'Musashi','Musashi Co., Ltd.'),(32715571200,'Ilinx','Ilinx Co., Ltd.'),(32732348416,'ActionDi','Action Digital Inc.'),(32749125632,'E-Watch','e-Watch Inc.'),(32765902848,'ViasysHe','VIASYS Healthcare GmbH'),(32782680064,'Opteon','Opteon Corporation'),(32799457280,'OsitisSo','Ositis Software, Inc.'),(32816234496,'GnNetcom','GN Netcom Ltd.'),(32833011712,'YDK','Y.D.K Co. Ltd.'),(32849788928,'HomeAuto','Home Automation, Inc.'),(32866566144,'A-Z','A-Z Inc.'),(32883343360,'HaierGro','Haier Group Technologies Ltd.'),(32900120576,'Novasoni','Novasonics'),(32916897792,'QuantumD','Quantum Data Inc.'),(32933675008,'SamsungE','Samsung Electronics Co.,Ltd'),(32950452224,'Eolring',''),(32967229440,'Pentacon','Pentacon GmbH Foto-und Feinwerkt'),(32984006656,'Britestr','Britestream Networks, Inc.'),(33000783872,'N-Tron','N-TRON Corporation'),(33017561088,'OfficeDe','Office Details, Inc.'),(33034338304,'EquatorT','Equator Technologies'),(33051115520,'Transacc','Transaccess S.A.'),(33067892736,'Cisco','CISCO SYSTEMS, INC.'),(33084669952,'Cisco','CISCO SYSTEMS, INC.'),(33101447168,'AnyOneWi','Any One Wireless Ltd.'),(33118224384,'TelecomT','Telecom Technology Ltd.'),(33135001600,'SamuraiI','Samurai Ind. Prods Eletronicos L'),(33151778816,'Corvalen','Corvalent Corporation'),(33168556032,'Ginganet','Ginganet Corporation'),(33185333248,'Utstarco','UTStarcom, Inc.'),(33202110464,'Candera','Candera Inc.'),(33218887680,'Identix','Identix Inc.'),(33235664896,'Radionet','Radionet Ltd.'),(33252442112,'Datalogi','DataLogic SpA'),(33269219328,'Armillai','Armillaire Technologies, Inc.'),(33285996544,'Netzerve','NetZerver Inc.'),(33302773760,'Overture','Overture Networks, Inc.'),(33319550976,'NetsysTe','Netsys Telecom'),(33336328192,'Thomson',''),(33353105408,'Jean','JEAN Co. Ltd.'),(33369882624,'Gcom','Gcom, Inc.'),(33386659840,'VdsVossk','VDS Vosskuhler GmbH'),(33403437056,'Synectic','Synectics Systems Limited'),(33420214272,'Brain21','Brain21, Inc.'),(33436991488,'TechnolS','Technol Seven Co., Ltd.'),(33453768704,'CreatixP','Creatix Polymedia Ges Fur Kommun'),(33470545920,'FreeboxS','Freebox SA'),(33487323136,'KabaBenz','Kaba Benzing GmbH'),(33504100352,'Nmtel','NMTEL Co., Ltd.'),(33520877568,'Cabletim','Cabletime Limited'),(33537654784,'Anoto','Anoto AB'),(33554432000,'AutomatE','Automat Engenharia de AutomaÃ§Ã£'),(33571209216,'Spectrum','Spectrum Signal Processing Inc.'),(33587986432,'LogopakS','Logopak Systeme GmbH & Co. KG'),(33604763648,'StorkPri','Stork Prints B.V.'),(33621540864,'Zhejiang','Zhejiang Yutong Network Communic'),(33638318080,'3eTechno','3e Technologies Int;., Inc.'),(33655095296,'Commil','Commil Ltd.'),(33671872512,'CaporisN','Caporis Networks AG'),(33688649728,'Hitron','Hitron Systems Inc.'),(33705426944,'Spliceco','Splicecom'),(33722204160,'NeuroTel','Neuro Telecom Co., Ltd.'),(33738981376,'KiranaNe','Kirana Networks, Inc.'),(33755758592,'Atek','Atek Co, Ltd.'),(33772535808,'CradleTe','Cradle Technologies'),(33789313024,'Ecopilt','eCopilt AB'),(33806090240,'Vbrick','Vbrick Systems Inc.'),(33822867456,'Palm','Palm Inc.'),(33839644672,'WisCommu','WIS Communications Co. Ltd.'),(33856421888,'Bitworks','Bitworks, Inc.'),(33873199104,'NavcomTe','Navcom Technology, Inc.'),(33889976320,'Softradi','SoftRadio Co., Ltd.'),(33906753536,'Coup','Coup Corporation'),(33923530752,'Edgeflow','edgeflow Canada Inc.'),(33940307968,'Freewave','FreeWave Technologies'),(33957085184,'Edgewave',''),(33973862400,'Intel','Intel Corporation'),(33990639616,'Massana','Massana, Inc.'),(34007416832,'Cisco','CISCO SYSTEMS, INC.'),(34024194048,'Cisco','CISCO SYSTEMS, INC.'),(34040971264,'Altera','Altera Corporation'),(34057748480,'TelcoInf','telco Informationssysteme GmbH'),(34074525696,'Lockheed','Lockheed Martin Tactical Systems'),(34091302912,'Logisync','LogiSync LLC'),(34108080128,'Teraburs','TeraBurst Networks Inc.'),(34124857344,'Ioa','IOA Corporation'),(34141634560,'Thinkeng','Thinkengine Networks'),(34158411776,'Eletex','Eletex Co., Ltd.'),(34175188992,'Bridgeco','Bridgeco Co AG'),(34191966208,'QqestSof','Qqest Software Systems'),(34208743424,'Galtroni','Galtronics'),(34225520640,'Itdevice','ITDevices, Inc.'),(34242297856,'Sensapho','Sensaphone'),(34259075072,'Itt','ITT Co., Ltd.'),(34275852288,'GigaStre','Giga Stream UMTS Technologies Gm'),(34292629504,'Adept','Adept Systems Inc.'),(34309406720,'Lanergy','LANergy Ltd.'),(34326183936,'Rigaku','Rigaku Corporation'),(34342961152,'GluonNet','Gluon Networks'),(34359738368,'Multitec','MULTITECH SYSTEMS, INC.'),(34376515584,'Highspee','HighSpeed Surfing Inc.'),(34393292800,'Hewlett-','Hewlett-Packard Company'),(34410070016,'CosTron','Cos Tron'),(34426847232,'Ica','ICA Inc.'),(34443624448,'Techno-H','Techno-Holon Corporation'),(34460401664,'Raonet','Raonet Systems, Inc.'),(34477178880,'AccessDe','Access Devices Limited'),(34493956096,'PptVisio','PPT Vision, Inc.'),(34510733312,'Systemon','Systemonic AG'),(34527510528,'Espera-W','Espera-Werke GmbH'),(34544287744,'BirkaBpa','Birka BPA Informationssystem AB'),(34561064960,'VdaElett','VDA Elettronica spa'),(34577842176,'Toshiba',''),(34594619392,'Motorola','Motorola Mobility, Inc.'),(34611396608,'Proximio','Proximion Fiber Optics AB'),(34628173824,'KeyTechn','Key Technology, Inc.'),(34644951040,'Voix','VOIX Corporation'),(34661728256,'Gm-2','GM-2 Corporation'),(34678505472,'Diskbank','Diskbank, Inc.'),(34695282688,'TilTechn','TIL Technologies'),(34712059904,'Cats','CATS Co., Ltd.'),(34728837120,'Bluetags','Bluetags A/S'),(34745614336,'Emergeco','EmergeCore Networks LLC'),(34762391552,'Pixelwor','Pixelworks, Inc.'),(34779168768,'Banksys',''),(34795945984,'SanradIn','Sanrad Intelligence Storage Comm'),(34812723200,'Windigo','Windigo Systems'),(34829500416,'@PosCom','@pos.com'),(34846277632,'Ipsil','Ipsil, Incorporated'),(34863054848,'Repeatit','Repeatit AB'),(34879832064,'PouYuenT','Pou Yuen Tech Corp. Ltd.'),(34896609280,'Cisco','CISCO SYSTEMS, INC.'),(34913386496,'Cisco','CISCO SYSTEMS, INC.'),(34930163712,'InproCom','InPro Comm'),(34946940928,'Texa','Texa Corp.'),(34963718144,'NuanceDo','Nuance Document Imaging'),(34980495360,'AcmePack','Acme Packet'),(34997272576,'Colorado','Colorado Med Tech'),(35014049792,'AdbBroad','ADB Broadband Italia'),(35030827008,'KoeiEngi','Koei Engineering Ltd.'),(35047604224,'AvalNaga','Aval Nagasaki Corporation'),(35064381440,'Powerwal','Powerwallz Network Security'),(35081158656,'Wooksung','Wooksung Electronics, Inc.'),(35097935872,'Homag','Homag AG'),(35114713088,'IndusTeq','Indus Teqsite Private Limited'),(35131490304,'Multiton','Multitone Electronics PLC'),(35148267520,'Cisco','CISCO SYSTEMS, INC.'),(35165044736,'Cisco','CISCO SYSTEMS, INC.'),(35181821952,'Cisco','CISCO SYSTEMS, INC.'),(35198599168,'Cisco',''),(35668361216,'Divergen','DivergeNet, Inc.'),(35685138432,'Qualstar','Qualstar Corporation'),(35701915648,'ArizonaI','Arizona Instrument Corp.'),(35718692864,'Canadian','Canadian Bank Note Company, Ltd.'),(35735470080,'Davolink','Davolink Co. Inc.'),(35752247296,'Schleich','Schleicher GmbH & Co. Relaiswerk'),(35769024512,'Netronix','Netronix, Inc.'),(35785801728,'Nasa-God','NASA-Goddard Space Flight Center'),(35802578944,'Gamatron','Gamatronic Electronic Industries'),(35819356160,'PolarisN','Polaris Networks, Inc.'),(35836133376,'Novatech','Novatechnology Inc.'),(35852910592,'Shenzhen','ShenZhen Unitone Electronics Co.'),(35869687808,'Intigate','IntiGate Inc.'),(35886465024,'HanbitEl','Hanbit Electronics Co., Ltd.'),(35903242240,'Shanghai','Shanghai Dare Technologies Co. L'),(35920019456,'Aastra',''),(35936796672,'Pco','PCO AG'),(35953573888,'PicanolN','Picanol N.V.'),(35970351104,'Lodgenet','LodgeNet Entertainment Corp.'),(35987128320,'Softener','SoftEnergy Co., Ltd.'),(36003905536,'NecElumi','NEC Eluminant Technologies, Inc.'),(36020682752,'Entrisph','Entrisphere Inc.'),(36037459968,'FasySPA','Fasy S.p.A.'),(36054237184,'Jascom','JASCOM CO., LTD'),(36071014400,'DsxAcces','DSX Access Systems, Inc.'),(36087791616,'UptimeDe','Uptime Devices'),(36104568832,'Puroptix',''),(36121346048,'Command-','Command-e Technology Co.,Ltd.'),(36138123264,'Securito','Securiton Gmbh'),(36154900480,'Mipsys',''),(36171677696,'PlasmonL','Plasmon LMS'),(36188454912,'Missouri','Missouri FreeNet'),(36205232128,'Hyglo','Hyglo AB'),(36222009344,'Resource','Resources Computer Network Ltd.'),(36238786560,'Rasvia','Rasvia Systems, Inc.'),(36255563776,'Northdat','NORTHDATA Co., Ltd.'),(36272340992,'Sorenson','Sorenson Communications'),(36289118208,'Daptechn','DapTechnology B.V.'),(36305895424,'DellComp','Dell Computer Corp.'),(36322672640,'AcorpEle','Acorp Electronics Corp.'),(36339449856,'Sdsystem',''),(36356227072,'Liebert-','Liebert-Hiross Spa'),(36373004288,'Benchmar','Benchmark Storage Innovations'),(36389781504,'Cem','CEM Corporation'),(36406558720,'Wipotec','Wipotec GmbH'),(36423335936,'RtxTelec','RTX Telecom A/S'),(36440113152,'Cisco','CISCO SYSTEMS, INC.'),(36456890368,'Cisco','CISCO SYSTEMS, INC.'),(36473667584,'BonElect','Bon Electro-Telecom Inc.'),(36490444800,'SpaunEle','SPAUN electronic GmbH & Co. KG'),(36507222016,'Broadtel','BroadTel Canada Communications i'),(36523999232,'DigitalH','DIGITAL HANDS CO.,LTD.'),(36540776448,'Sigma','SIGMA CORPORATION'),(36557553664,'Hewlett-','Hewlett-Packard Company'),(36574330880,'IndexBra','Index Braille AB'),(36591108096,'EmsDrTho','EMS Dr. Thomas WÃ¼nsche'),(36607885312,'HansungT','Hansung Teliann, Inc.'),(36624662528,'Maschine','Maschinenfabrik Reinhausen GmbH'),(36641439744,'OullimIn','OULLIM Information Technology In'),(36658216960,'Echostar','Echostar Technologies Corp'),(36674994176,'Minds@Wo','Minds@Work'),(36691771392,'TropicNe','Tropic Networks Inc.'),(36708548608,'QuantaNe','Quanta Network Systems Inc.'),(36725325824,'Sigma-Li','Sigma-Links Inc.'),(36742103040,'NihonCom','Nihon Computer Co., Ltd.'),(36758880256,'Advanced','ADVANCED DIGITAL TECHNOLOGY'),(36775657472,'Avilinks','AVILINKS SA'),(36792434688,'Lyan','Lyan Inc.'),(36809211904,'EmSoluti','EM Solutions'),(36825989120,'LeInform','LE INFORMATION COMMUNICATION INC'),(36842766336,'Innovisi','InnoVISION Multimedia Ltd.'),(36859543552,'DircTech','DIRC Technologie GmbH & Co.KG'),(36876320768,'Printron','Printronix, Inc.'),(36893097984,'QuakeTec','Quake Technologies'),(36909875200,'GigabitO','Gigabit Optics Corporation'),(36926652416,'Netbind','Netbind, Inc.'),(36943429632,'AlcatelM','Alcatel Microelectronics'),(36960206848,'IcpElect','ICP Electronics Inc.'),(36976984064,'ElecsInd','Elecs Industry Co., Ltd.'),(36993761280,'Uhd-Elek','UHD-Elektronik'),(37010538496,'BeijingE','Beijing Enter-Net co.LTD'),(37027315712,'EfmNetwo','EFM Networks'),(37044092928,'StotzFei','Stotz Feinmesstechnik GmbH'),(37060870144,'CnetTech','CNet Technology Inc.'),(37077647360,'AdiEngin','ADI Engineering, Inc.'),(37094424576,'Cisco','CISCO SYSTEMS, INC.'),(37111201792,'Cisco','CISCO SYSTEMS, INC.'),(37127979008,'Peninsul','Peninsula Systems Inc.'),(37144756224,'Multiwar','Multiware & Image Co., Ltd.'),(37161533440,'Ilogic','iLogic Inc.'),(37178310656,'Systec','Systec Co., Ltd.'),(37195087872,'Sangsang','SangSang Technology, Inc.'),(37211865088,'Karam',''),(37228642304,'Enerlinx','EnerLinx.com, Inc.'),(37245419520,'Eltromat','Eltromat GmbH'),(37262196736,'Toyo-Lin','Toyo-Linx Co., Ltd.'),(37278973952,'Packetfr','PacketFront Network Products AB'),(37295751168,'Novatec','Novatec Corporation'),(37312528384,'BktelCom','BKtel communications GmbH'),(37329305600,'Proquent','ProQuent Systems'),(37346082816,'Shenzhen','SHENZHEN COMPASS TECHNOLOGY DEVE'),(37362860032,'Fastwel',''),(37379637248,'Syspol',''),(37396414464,'TaiGuenE','TAI GUEN ENTERPRISE CO., LTD'),(37413191680,'Routefre','RouteFree, Inc.'),(37429968896,'Hit','HIT Incorporated'),(37446746112,'EFJohnso','E.F. Johnson'),(37463523328,'KaonMedi','KAON MEDIA Co., Ltd.'),(37480300544,'Erskine','Erskine Systems Ltd'),(37497077760,'Netexcel','NetExcell'),(37513854976,'Ilevo','Ilevo AB'),(37530632192,'Tepg-Us',''),(37547409408,'XenpakMs','XENPAK MSA Group'),(37564186624,'AptusEle','Aptus Elektronik AB'),(37580963840,'Asa','ASA SYSTEMS'),(37597741056,'AvistarC','Avistar Communications Corporati'),(37614518272,'Cisco','CISCO SYSTEMS, INC.'),(37631295488,'Contex','Contex A/S'),(37648072704,'Hikari','Hikari Co.,Ltd.'),(37664849920,'Liontech','Liontech Co., Ltd.'),(37681627136,'PhilipsC','Philips Consumer Communications'),(37698404352,'Hewlett-','Hewlett-Packard Company'),(37715181568,'Sonetico','Soneticom, Inc.'),(37731958784,'Technisa','TechniSat Digital GmbH'),(37748736000,'TwinhanT','TwinHan Technology Co.,Ltd'),(37765513216,'ZetaBroa','Zeta Broadband Inc.'),(37782290432,'Remotec','Remotec, Inc.'),(37799067648,'With-Net','With-Net Inc'),(37815844864,'Ipmobile','IPMobileNet Inc.'),(37832622080,'NipponKo','Nippon Koei Power Systems Co., L'),(37849399296,'MusashiE','Musashi Engineering Co., LTD.'),(37866176512,'Karel','KAREL INC.'),(37882953728,'ZoomNetw','ZOOM Networks Inc.'),(37899730944,'Hercules','Hercules Technologies S.A.S.'),(37916508160,'Ineoques','IneoQuest Technologies, Inc'),(37933285376,'Vanguard','Vanguard Networks Solutions, LLC'),(37950062592,'Hassnet','HASSNET Inc.'),(37966839808,'How','HOW CORPORATION'),(37983617024,'DowkeyMi','Dowkey Microwave'),(38000394240,'Mitadens','Mitadenshi Co.,LTD'),(38017171456,'Sofaware','SofaWare Technologies Ltd.'),(38033948672,'Corrigen','Corrigent Systems'),(38050725888,'Wiznet',''),(38067503104,'TelenaCo','Telena Communications, Inc.'),(38084280320,'3up','3UP Systems'),(38101057536,'Alistel','Alistel Inc.'),(38117834752,'AtoTechn','ATO Technology Ltd.'),(38134611968,'Barix','Barix AG'),(38151389184,'Cisco','CISCO SYSTEMS, INC.'),(38168166400,'Cisco','CISCO SYSTEMS, INC.'),(38184943616,'Envenerg','Envenergy Inc'),(38201720832,'Idk','IDK Corporation'),(38218498048,'Littlefe','Littlefeet'),(38235275264,'ShiContr','SHI ControlSystems,Ltd.'),(38252052480,'ExcelMas','Excel Master Ltd.'),(38268829696,'Nextgig',''),(38285606912,'MotionCo','Motion Control Engineering, Inc'),(38302384128,'Romwin','ROMWin Co.,Ltd.'),(38319161344,'OpticalZ','Optical Zonu Corporation'),(38335938560,'St&TInst','ST&T Instrument Corp.'),(38352715776,'LogicPro','Logic Product Development'),(38369492992,'DibalSA','DIBAL,S.A.'),(38386270208,'NextGene','Next Generation Systems, Inc.'),(38403047424,'Voltaire',''),(38419824640,'C&STechn','C&S Technology'),(38436601856,'Wany',''),(38453379072,'Bluetake','Bluetake Technology Co., Ltd.'),(38470156288,'Yestechn','YESTECHNOLOGY Co.,Ltd.'),(38486933504,'Sumitomo','Sumitomo Electric System Solutio'),(38503710720,'HitachiS','Hitachi Ltd, Semiconductor & Int'),(38520487936,'UtcCcs','UTC CCS'),(38537265152,'EmersonN','Emerson Network Power'),(38554042368,'KarlEBri','Karl E.Brinkmann GmbH'),(38570819584,'Sonosite','SonoSite, Inc.'),(38587596800,'Gigaphot','Gigaphoton Inc.'),(38604374016,'Bluekore','BlueKorea Co., Ltd.'),(38621151232,'UnikC&C','UNIK C&C Co.,Ltd.'),(38637928448,'TrilogyC','Trilogy Communications Ltd'),(38654705664,'Tmt',''),(38671482880,'Shenzhen','Shenzhen Shixuntong Information '),(38688260096,'RedlineC','Redline Communications Inc.'),(38705037312,'Panasas','Panasas, Inc'),(38721814528,'MondialE','MONDIAL electronic'),(38738591744,'ItecTech','iTEC Technologies Ltd.'),(38755368960,'EsteemNe','Esteem Networks'),(38772146176,'Chrysali','Chrysalis Development'),(38788923392,'VtechTec','VTech Technology Corp.'),(38805700608,'TelenorC','Telenor Connect A/S'),(38822477824,'SnedfarT','SnedFar Technology Co., Ltd.'),(38839255040,'MtlInstr','MTL  Instruments PLC'),(38856032256,'Mayekawa','Mayekawa Mfg. Co. Ltd.'),(38872809472,'LeaderEl','LEADER ELECTRONICS CORP.'),(38889586688,'HelixTec','Helix Technology Inc.'),(38906363904,'Fortinet','Fortinet Inc.'),(38923141120,'SimpleAc','Simple Access Inc.'),(38939918336,'Cisco','CISCO SYSTEMS, INC.'),(38956695552,'Cisco','CISCO SYSTEMS, INC.'),(38973472768,'Systemk','SystemK Corporation'),(38990249984,'Computro','COMPUTROLS INC.'),(39007027200,'Cas','CAS Corp.'),(39023804416,'ListmanH','Listman Home Technologies, Inc.'),(39040581632,'WemTechn','WEM Technology Inc'),(39057358848,'SamsungT','SAMSUNG TECHWIN CO.,LTD'),(39074136064,'MdsGatew','MDS Gateways'),(39090913280,'MacatOpt','Macat Optics & Electronics Co., '),(39107690496,'DigitalG','Digital Generation Inc.'),(39124467712,'Cachevis','CacheVision, Inc'),(39141244928,'ProteamC','Proteam Computer Corporation'),(39158022144,'Firstech','Firstech Technology Corp.'),(39174799360,'A&D','A&D Co., Ltd.'),(39191576576,'EpoxComp','EpoX COMPUTER CO.,LTD.'),(39208353792,'Planmeca','Planmeca Oy'),(39225131008,'TstBiome','TST Biometrics GmbH'),(39241908224,'HeamanSy','Heaman System Co., Ltd'),(39258685440,'Telebau','Telebau GmbH'),(39275462656,'VsnSyste','VSN Systemen BV'),(39292239872,'YodaComm','YODA COMMUNICATIONS, INC.'),(39309017088,'Toyokeik','TOYOKEIKI CO.,LTD.'),(39325794304,'Telecore',''),(39342571520,'SanyoInd','Sanyo Industries (UK) Limited'),(39359348736,'Mytecs','MYTECS Co.,Ltd.'),(39376125952,'IqstorNe','iQstor Networks, Inc.'),(39392903168,'Hitpoint','Hitpoint Inc.'),(39409680384,'Htc','HTC Corporation'),(39426457600,'B&TechSy','B&Tech System Inc.'),(39443234816,'AkomTech','Akom Technology Corporation'),(39460012032,'Aeroconc','AeroConcierge Inc.'),(39476789248,'FutureIn','Future Internet, Inc.'),(39493566464,'Omnilux',''),(39510343680,'Ophit','Ophit Co.Ltd.'),(39527120896,'Dream-Mu','Dream-Multimedia-Tv GmbH'),(39543898112,'Sandvine','Sandvine Incorporated'),(39560675328,'Ipetroni','Ipetronik GmbH & Co. KG'),(39577452544,'Inventec','Inventec Appliance Corp'),(39594229760,'AllotCom','Allot Communications'),(39611006976,'Shibasok','ShibaSoku Co.,Ltd.'),(39627784192,'MolexFib','Molex Fiber Optics'),(39644561408,'HyundaiN','HYUNDAI NETWORKS INC.'),(39661338624,'JacquesT','Jacques Technologies P/L'),(39678115840,'Newisys','Newisys,Inc.'),(39694893056,'C&ITechn','C&I Technologies'),(39711670272,'Double-W','Double-Win Enterpirse CO., LTD'),(39728447488,'Agfeo','AGFEO GmbH & Co. KG'),(39745224704,'AlliedTe','Allied Telesis K.K.'),(39762001920,'Wireless','Wireless Technologies, Inc'),(39778779136,'Cisco','CISCO SYSTEMS, INC.'),(39795556352,'Cisco','CISCO SYSTEMS, INC.'),(39812333568,'Palmmicr','Palmmicro Communications Inc'),(39829110784,'ClusterL','Cluster Labs GmbH'),(39845888000,'Aztek','Aztek, Inc.'),(39862665216,'VistaCon','Vista Control Systems, Corp.'),(39879442432,'GlyphTec','Glyph Technologies Inc.'),(39896219648,'HomenetC','Homenet Communications'),(39912996864,'Fillfact','FillFactory NV'),(39929774080,'Communic','Communication Weaver Co.,Ltd.'),(39946551296,'Braintre','Braintree Communications Pty Ltd'),(39963328512,'BartechI','BARTECH SYSTEMS INTERNATIONAL, I'),(39980105728,'Elmegt','elmegt GmbH & Co. KG'),(39996882944,'Independ','Independent Storage Corporation'),(40013660160,'ApogeeIm','Apogee Imaging Systems'),(40030437376,'Auerswal','Auerswald GmbH & Co. KG'),(40047214592,'LinkageS','Linkage System Integration Co.Lt'),(40063991808,'AmitSpol','AMiT spol. s. r. o.'),(40080769024,'YoungGen','Young Generation International C'),(40097546240,'NetworkG','Network Systems Group, Ltd. (NSG'),(40114323456,'Supercal','Supercaller, Inc.'),(40131100672,'Intelnet','INTELNET S.A.'),(40147877888,'Sitecsof','Sitecsoft'),(40164655104,'Racewood','RACEWOOD TECHNOLOGY'),(40181432320,'Netgear','Netgear, Inc.'),(40198209536,'PhilipsM','Philips Medical Systems - Cardia'),(40214986752,'Dialogue','Dialogue Technology Corp.'),(40231763968,'Masstech','Masstech Group Inc.'),(40248541184,'Telebyte','Telebyte, Inc.'),(40265318400,'Yozan','YOZAN Inc.'),(40282095616,'Switchge','Switchgear and Instrumentation L'),(40298872832,'SonitorT','Sonitor Technologies AS'),(40315650048,'Dominion','Dominion Lasercom Inc.'),(40332427264,'Hi-Techn','Hi-Techniques, Inc.'),(40349204480,'HyunjuCo','HyunJu Computer Co., Ltd.'),(40365981696,'ThalesNa','Thales Navigation'),(40382758912,'Tachyon','Tachyon, Inc'),(40399536128,'Technove','TECHNOVENTURE, INC.'),(40416313344,'MeretOpt','Meret Optical Communications'),(40433090560,'Cloverle','Cloverleaf Communications Inc.'),(40449867776,'Ibm','IBM Corp'),(40466644992,'ImediaSe','Imedia Semiconductor Corp.'),(40483422208,'Powernet','Powernet Technologies Corp.'),(40500199424,'GiantEle','GIANT ELECTRONICS LTD.'),(40516976640,'BeijingZ','Beijing Zhongqing Elegant Tech. '),(40533753856,'Vibratio','Vibration Research Corporation'),(40550531072,'TimeMana','Time Management, Inc.'),(40567308288,'Secureba','Securebase,Inc'),(40584085504,'LentenTe','Lenten Technology Co., Ltd.'),(40600862720,'InnopiaT','Innopia Technologies, Inc.'),(40617639936,'FsonaCom','fSONA Communications Corporation'),(40634417152,'Datasoft','Datasoft ISDN Systems GmbH'),(40651194368,'BrunnerE','Brunner Elektronik AG'),(40667971584,'AijiSyst','AIJI System Co., Ltd.'),(40684748800,'Advanced','Advanced Television Systems Comm'),(40701526016,'LouisDes','Louis Design Labs.'),(40718303232,'Cisco','CISCO SYSTEMS, INC.'),(40735080448,'Cisco','CISCO SYSTEMS, INC.'),(40751857664,'SecwellN','SecWell Networks Oy'),(40768634880,'ImiTechn','IMI TECHNOLOGY CO., LTD'),(40785412096,'Vsecure2','Vsecure 2000 LTD.'),(40802189312,'PowerZen','Power Zenith Inc.'),(40818966528,'NewportN','Newport Networks'),(40835743744,'LoeweOpt','Loewe Opta GmbH'),(40852520960,'Globalto','GlobalTop Technology, Inc.'),(40869298176,'MycasaNe','MyCasa Network Inc.'),(40886075392,'AutoTele','Auto Telecom Company'),(40902852608,'Metalink','Metalink LTD.'),(40919629824,'NishiNip','NISHI NIPPON ELECTRIC WIRE & CAB'),(40936407040,'NudianEl','Nudian Electron Co., Ltd.'),(40953184256,'Vividlog','VividLogic Inc.'),(40969961472,'Equallog','EqualLogic Inc'),(40986738688,'Entropic','Entropic Communications, Inc.'),(41003515904,'OptionWi','Option Wireless Sweden'),(41020293120,'Velocity','Velocity Semiconductor'),(41037070336,'Ipcas','ipcas GmbH'),(41053847552,'Cetacean','Cetacean Networks'),(41070624768,'AcksysCo','ACKSYS Communications & systems'),(41087401984,'GeFanucA','GE Fanuc Automation Manufacturin'),(41104179200,'Interepo','InterEpoch Technology,INC.'),(41120956416,'Visteon','Visteon Corporation'),(41137733632,'CronyxEn','Cronyx Engineering'),(41154510848,'CastleTe','Castle Technology Ltd'),(41171288064,'Rdi',''),(41188065280,'NortelNe','Nortel Networks'),(41204842496,'Capinfo','Capinfo Company Limited'),(41221619712,'CpGeorge','CP GEORGES RENAULT'),(41238396928,'Elmo','ELMO COMPANY, LIMITED'),(41255174144,'WesternT','Western Telematic Inc.'),(41271951360,'NavalRes','Naval Research Laboratory'),(41288728576,'Haliplex','Haliplex Communications'),(41305505792,'Testech','Testech, Inc.'),(41322283008,'Videx','VIDEX INC.'),(41339060224,'Microtec','Microtechno Corporation'),(41355837440,'Telewise','Telewise Communications, Inc.'),(41372614656,'Interfac','Interface Co., Ltd.'),(41389391872,'LeadflyT','Leadfly Techologies Corp. Ltd.'),(41406169088,'Hartec','HARTEC Corporation'),(41422946304,'HansungE','HANSUNG ELETRONIC INDUSTRIES DEV'),(41439723520,'IgnisOpt','Ignis Optics, Inc.'),(41456500736,'BangOluf','Bang & Olufsen A/S'),(41473277952,'Eastmode','Eastmode Pte Ltd'),(41490055168,'IkanosCo','Ikanos Communications'),(41506832384,'DataComm','Data Comm for Business, Inc.'),(41523609600,'Netcontr','Netcontrol Oy'),(41540386816,'Lanvoice',''),(41557164032,'HyundaiS','HYUNDAI SYSCOMM, INC.'),(41573941248,'OkanoEle','OKANO ELECTRIC CO.,LTD'),(41590718464,'E-Generi','e-generis'),(41607495680,'Onkyo','Onkyo Corporation'),(41624272896,'Kanemats','Kanematsu Electronics, Ltd.'),(41641050112,'L&F','L&F Inc.'),(41657827328,'Mcm','MCM Systems Ltd'),(41674604544,'KisanTel','KISAN TELECOM CO., LTD.'),(41691381760,'3jTech','3J Tech. Co., Ltd.'),(41708158976,'Cisco','CISCO SYSTEMS, INC.'),(41724936192,'Cisco','CISCO SYSTEMS, INC.'),(41741713408,'Entise','Entise Systems'),(41758490624,'ActionIm','Action Imaging Solutions'),(41775267840,'MakuInfo','MAKU Informationstechik GmbH'),(41792045056,'Mathstar','MathStar, Inc.'),(41808822272,'DigitalS','Digital Safety Technologies, Inc'),(41825599488,'EpygiTec','Epygi Technologies, Ltd.'),(41842376704,'Mamiya-O','Mamiya-OP Co.,Ltd.'),(41859153920,'Nintendo','Nintendo Co., Ltd.'),(41875931136,'6wind',''),(41892708352,'Proces-D','PROCES-DATA A/S'),(41909485568,'Onity','Onity, Inc.'),(41926262784,'Netas',''),(41943040000,'Medicore','Medicore Co., Ltd'),(41959817216,'KingeneT','KINGENE Technology Corporation'),(41976594432,'Visionic','Visionics Corporation'),(41993371648,'Movistec',''),(42010148864,'Sinagawa','SINAGAWA TSUSHIN KEISOU SERVICE'),(42026926080,'Bluewinc','BlueWINC Co., Ltd.'),(42043703296,'Imaxnetw','iMaxNetworks(Shenzhen)Limited.'),(42060480512,'Hbrain',''),(42077257728,'Moog','Moog GmbH'),(42094034944,'HudsonSo','HUDSON SOFT CO.,LTD.'),(42110812160,'Spacebri','SpaceBridge Semiconductor Corp.'),(42127589376,'Iad','iAd GmbH'),(42144366592,'SolacomT','Solacom Technologies Inc.'),(42161143808,'SeranoaN','SERANOA NETWORKS INC'),(42177921024,'MaiLogic','Mai Logic Inc.'),(42194698240,'WesternD','Western DataCom Co., Inc.'),(42211475456,'Transtec','Transtech Networks'),(42228252672,'SignalCo','Signal Communication, Inc.'),(42245029888,'KncOne','KNC One GmbH'),(42261807104,'DcSecuri','DC Security Products'),(42278584320,'FÃ¤ltComm','FÃ¤lt Communications AB'),(42295361536,'Neoscale','Neoscale Systems, Inc'),(42312138752,'ControlM','Control Module Inc.'),(42328915968,'Espace',''),(42345693184,'GalaxisT','Galaxis Technology AG'),(42362470400,'MavinTec','Mavin Technology Inc.'),(42379247616,'SamjinIn','Samjin Information & Communicati'),(42396024832,'VestelKo','Vestel Komunikasyon Sanayi ve Ti'),(42412802048,'XemicsSA','XEMICS S.A.'),(42429579264,'GemtekTe','Gemtek Technology Co., Ltd.'),(42446356480,'SinbonEl','Sinbon Electronics Co., Ltd.'),(42463133696,'AngelIgl','Angel Iglesias S.A.'),(42479910912,'KTechInf','K Tech Infosystem Inc.'),(42496688128,'Hottinge','Hottinger Baldwin Messtechnik Gm'),(42513465344,'CyberSwi','Cyber Switching Inc.'),(42530242560,'AdcTecho','ADC Techonology'),(42547019776,'Cisco','CISCO SYSTEMS, INC.'),(42563796992,'Cisco','CISCO SYSTEMS, INC.'),(42580574208,'Yem','YEM Inc.'),(42597351424,'Humandat','HuMANDATA LTD.'),(42614128640,'Daktroni','Daktronics, Inc.'),(42630905856,'Cipherop','CipherOptics'),(42647683072,'MeikyoEl','MEIKYO ELECTRIC CO.,LTD'),(42664460288,'VoceraCo','Vocera Communications'),(42681237504,'ShimizuT','Shimizu Technology Inc.'),(42698014720,'YamakiEl','Yamaki Electric Corporation'),(42714791936,'CohuElec','Cohu, Inc., Electronics Division'),(42731569152,'WellComm','WELL Communication Corp.'),(42748346368,'AlconLab','Alcon Laboratories, Inc.'),(42765123584,'EmersonN','Emerson Network Power Co.,Ltd'),(42781900800,'Shenzhen','Shenzhen Eastern Digital Tech Lt'),(42798678016,'SedADivi','SED, a division of Calian'),(42815455232,'UnimoTec','UNIMO TECHNOLOGY CO., LTD.'),(42832232448,'ArtJapan','ART JAPAN CO., LTD.'),(42865786880,'PhilipsP','Philips Patient Monitoring'),(42882564096,'Ipflex','IPFLEX Inc.'),(42899341312,'Ubinetic','Ubinetics Limited'),(42916118528,'DaisyTec','Daisy Technologies, Inc.'),(42932895744,'XNet2000','X.net 2000 GmbH'),(42949672960,'Mediatek','Mediatek Corp.'),(42966450176,'Sohoware','SOHOware, Inc.'),(42983227392,'Annso','ANNSO CO., LTD.'),(43000004608,'EndesaSe','ENDESA SERVICIOS, S.L.'),(43016781824,'3com','3Com Ltd'),(43033559040,'Widax','Widax Corp.'),(43050336256,'TeledexL','Teledex LLC'),(43067113472,'Webwayon','WebWayOne Ltd'),(43083890688,'AlpineEl','ALPINE ELECTRONICS, INC.'),(43100667904,'TaracomI','TaraCom Integrated Products, Inc'),(43117445120,'Sunix','SUNIX Co., Ltd.'),(43134222336,'Sealevel','Sealevel Systems, Inc.'),(43150999552,'Scientif','Scientific Research Corporation'),(43167776768,'FciDeuts','FCI Deutschland GmbH'),(43184553984,'InvivoRe','Invivo Research Inc.'),(43201331200,'IlryungT','Ilryung Telesys, Inc'),(43218108416,'FastMedi','FAST media integrations AG'),(43234885632,'ExpetTec','ExPet Technologies, Inc'),(43251662848,'AzylexTe','Azylex Technology, Inc'),(43268440064,'Honeywel','Honeywell Video Systems'),(43285217280,'TecoAS','TECO a.s.'),(43301994496,'SiliconD','Silicon Data, Inc'),(43318771712,'LassenRe','Lassen Research'),(43335548928,'NestarCo','NESTAR COMMUNICATIONS, INC'),(43352326144,'Vichel','Vichel Inc.'),(43369103360,'ValerePo','Valere Power, Inc.'),(43385880576,'Imerge','Imerge Ltd'),(43402657792,'StreamLa','Stream Labs'),(43419435008,'BridgeIn','Bridge Information Co., Ltd.'),(43436212224,'OpticalC','Optical Communications Products '),(43452989440,'Red-MPro','Red-M Products Limited'),(43469766656,'ArtWareT','ART WARE Telecommunication Co., '),(43486543872,'SvaNetwo','SVA Networks, Inc.'),(43503321088,'IntegraT','Integra Telecom Co. Ltd'),(43520098304,'Amperion','Amperion Inc'),(43536875520,'ParamaNe','Parama Networks Inc'),(43553652736,'OctaveCo','Octave Communications'),(43570429952,'CeragonN','CERAGON NETWORKS'),(43587207168,'CeiaSPA','CEIA S.p.A.'),(43603984384,'AppleCom','Apple Computer, Inc.'),(43620761600,'Motorola',''),(43637538816,'PanDacom','Pan Dacom Networking AG'),(43654316032,'Qsi','QSI Systems Inc.'),(43671093248,'Etherstu','Etherstuff'),(43687870464,'ActiveTc','Active Tchnology Corporation'),(43704647680,'CabotCom','Cabot Communications Limited'),(43721424896,'MapleNet','MAPLE NETWORKS CO., LTD'),(43738202112,'Artnix','Artnix Inc.'),(43754979328,'JohnsonC','Johnson Controls-ASG'),(43771756544,'HcvConsu','HCV Consulting'),(43788533760,'Xsido','Xsido Corporation'),(43805310976,'Emulex','Emulex Corporation'),(43822088192,'Identica','Identicard Systems Incorporated'),(43838865408,'Xilinx',''),(43855642624,'SynelecT','Synelec Telecom Multimedia'),(43872419840,'ProceraN','Procera Networks, Inc.'),(43889197056,'ApaniNet','Apani Networks'),(43905974272,'LopaInfo','LoPA Information Technology'),(43922751488,'J-ThreeI','J-THREE INTERNATIONAL Holding Co'),(43939528704,'GctSemic','GCT Semiconductor, Inc'),(43956305920,'Enerpoin','Enerpoint Ltd.'),(43973083136,'EloSiste','Elo Sistemas Eletronicos S.A.'),(43989860352,'EadsTele','EADS Telecom'),(44006637568,'DataEast','Data East Corporation'),(44023414784,'CrownAud','Crown Audio -- Harmanm Internati'),(44040192000,'Cisco','CISCO SYSTEMS, INC.'),(44056969216,'Cisco','CISCO SYSTEMS, INC.'),(44073746432,'Chunghwa','Chunghwa Telecom Co., Ltd.'),(44090523648,'AveryDen','Avery Dennison Deutschland GmbH'),(44107300864,'Audio-Te','Audio-Technica Corp.'),(44124078080,'AroWeldi','ARO WELDING TECHNOLOGIES SAS'),(44140855296,'AlliedVi','Allied Vision Technologies'),(44157632512,'Albatron','Albatron Technology'),(44174409728,'F5Networ','F5 Networks, Inc.'),(44191186944,'Targa','Targa Systems Ltd.'),(44207964160,'Datapowe','DataPower Technology, Inc.'),(44224741376,'Molecula','Molecular Devices Corporation'),(44241518592,'Noritz','Noritz Corporation'),(44258295808,'UnitekEl','UNITEK Electronics INC.'),(44275073024,'BrainBox','Brain Boxes Limited'),(44291850240,'Remotek','REMOTEK CORPORATION'),(44308627456,'Gyrosign','GyroSignal Technology Co., Ltd.'),(44325404672,'Asiarf','AsiaRF Ltd.'),(44342181888,'Intronic','Intronics, Incorporated'),(44358959104,'LagunaHi','Laguna Hills, Inc.'),(44375736320,'Markem','MARKEM Corporation'),(44392513536,'HitachiM','HITACHI Maxell Ltd.'),(44409290752,'Hewlett-','Hewlett-Packard Company - Standa'),(44426067968,'FreyerSi','Freyer & Siegel Elektronik GmbH '),(44442845184,'HwServer','HW server'),(44459622400,'Greennet','GreenNET Technologies Co.,Ltd.'),(44476399616,'Power-On','Power-One as'),(44493176832,'CarelSPA','Carel s.p.a.'),(44509954048,'Fingerte','FingerTec Worldwide Sdn Bhd'),(44526731264,'3com','3COM Corporation'),(44543508480,'Almedio','almedio inc.'),(44560285696,'Autostar','Autostar Technology Pte Ltd'),(44577062912,'Cellinx','Cellinx Systems Inc.'),(44593840128,'CrinisNe','Crinis Networks, Inc.'),(44610617344,'Dhd','DHD GmbH'),(44627394560,'EracomTe','Eracom Technologies'),(44644171776,'Gentechm','GentechMedia.co.,ltd.'),(44660948992,'Mitsubis','MITSUBISHI ELECTRIC SYSTEM & SER'),(44677726208,'Ongcorp',''),(44694503424,'Solarfla','SolarFlare Communications, Inc.'),(44711280640,'SunnyBel','SUNNY bell Technology Co., Ltd.'),(44728057856,'SvmMicro','SVM Microwaves s.r.o.'),(44744835072,'TadiranT','Tadiran Telecom Business Systems'),(44761612288,'Walchem','Walchem Corporation'),(44778389504,'EksElekt','EKS Elektronikservice GmbH'),(44795166720,'Harmonic','Harmonic, Inc'),(44811943936,'ZyflexTe','ZyFLEX Technologies Inc'),(44828721152,'MplsForu','MPLS Forum'),(44845498368,'AvrioTec','Avrio Technologies, Inc'),(44862275584,'Stec','STEC, INC.'),(44879052800,'Scientif','Scientific Atlanta'),(44895830016,'Manticom','Manticom Networks Inc.'),(44912607232,'Caterpil','Caterpillar, Inc'),(44929384448,'BeidaJad','Beida Jade Bird Huaguang Technol'),(44946161664,'Bluewire','Bluewire Technologies LLC'),(44962938880,'Olitec',''),(44979716096,'AlliedTe','Allied Telesis K.K. corega divis'),(44996493312,'Kyoritsu','Kyoritsu Electric Co., Ltd.'),(45013270528,'Corneliu','Cornelius Consult'),(45030047744,'Tecton','Tecton Ltd'),(45046824960,'Valo','Valo, Inc.'),(45063602176,'Advantag','The Advantage Group'),(45080379392,'TeradonI','Teradon Industries, Inc'),(45097156608,'Telkonet','Telkonet Inc.'),(45113933824,'TeimaAud','TEIMA Audiotex S.L.'),(45130711040,'TatsutaS','TATSUTA SYSTEM ELECTRONICS CO.,L'),(45147488256,'SaltoSL','SALTO SYSTEMS S.L.'),(45164265472,'RainsunE','Rainsun Enterprise Co., Ltd.'),(45181042688,'PlatC2','PLAT`C2,Inc'),(45197819904,'Lenze',''),(45214597120,'Integrat','Integrated Micromachines Inc.'),(45231374336,'Incypher','InCypher S.A.'),(45248151552,'Creval','Creval Systems, Inc.'),(45264928768,'Cisco','CISCO SYSTEMS, INC.'),(45281705984,'Cisco','CISCO SYSTEMS, INC.'),(45298483200,'Guardwar','Guardware Systems Ltd.'),(45315260416,'Eurother','EUROTHERM LIMITED'),(45332037632,'Invacom','Invacom Ltd'),(45348814848,'AskaInte','Aska International Inc.'),(45365592064,'BaysideI','Bayside Interactive, Inc.'),(45382369280,'Hemocue','HemoCue AB'),(45399146496,'Presonus','Presonus Corporation'),(45415923712,'W2Networ','W2 Networks, Inc.'),(45432700928,'Shanghai','ShangHai cellink CO., LTD'),(45449478144,'AppleCom','Apple Computer, Inc.'),(45466255360,'MewtelTe','MEWTEL TECHNOLOGY INC.'),(45483032576,'Sonicblu','SONICblue, Inc.'),(45499809792,'M+FGwinn','M+F Gwinner GmbH & Co'),(45516587008,'CalampWi','Calamp Wireless Networks Inc'),(45533364224,'AiptekIn','Aiptek International Inc'),(45550141440,'TbGroup','TB Group Inc'),(45566918656,'ServerTe','Server Technology, Inc.'),(45583695872,'KingYoun','King Young Technology Co. Ltd.'),(45600473088,'Broadweb','BroadWeb Corportation'),(45617250304,'Pannaway','Pannaway Technologies, Inc.'),(45634027520,'CedarPoi','Cedar Point Communications'),(45650804736,'VVS','V V S Limited'),(45667581952,'Systek','SYSTEK INC.'),(45684359168,'Shimafuj','SHIMAFUJI ELECTRIC CO.,LTD.'),(45701136384,'Shanghai','SHANGHAI SURVEILLANCE TECHNOLOGY'),(45717913600,'MaxlinkI','MAXLINK INDUSTRIES LIMITED'),(45734690816,'Hochiki','Hochiki Corporation'),(45751468032,'FeiElect','FEI Electron Optics'),(45768245248,'EpipePty','ePipe Pty. Ltd.'),(45785022464,'BrooksAu','Brooks Automation GmbH'),(45801799680,'AltigenC','AltiGen Communications Inc.'),(45818576896,'ToyotaTe','Toyota Technical Development Cor'),(45835354112,'Terratec','TerraTec Electronic GmbH'),(45852131328,'Stargame','Stargames Corporation'),(45868908544,'Rosemoun','Rosemount Process Analytical'),(45885685760,'Pipal','Pipal Systems'),(45902462976,'LoytecEl','LOYTEC electronics GmbH'),(45919240192,'Genetec','GENETEC Corporation'),(45936017408,'FresnelW','Fresnel Wireless Systems'),(45952794624,'FaGira','Fa. GIRA'),(45969571840,'EticTele','ETIC Telecommunications'),(45986349056,'DigitalE','Digital Electronic Network'),(46003126272,'Compunet','COMPUNETIX, INC'),(46019903488,'Cisco','CISCO SYSTEMS, INC.'),(46036680704,'Cisco','CISCO SYSTEMS, INC.'),(46053457920,'AsteraTe','Astera Technologies Corp.'),(46070235136,'ArconTec','Arcon Technology Limited'),(46087012352,'TaiwanSe','Taiwan Secom Co,. Ltd'),(46103789568,'Seabridg','Seabridge Ltd.'),(46120566784,'Rupprech','Rupprecht & Patashnick Co.'),(46137344000,'OpnetTec','OPNET Technologies CO., LTD.'),(46154121216,'HirotaSs','HIROTA SS'),(46170898432,'FuyohVid','Fuyoh Video Industry CO., LTD.'),(46187675648,'Futurete','Futuretel'),(46204452864,'Fiberhom','FiberHome Telecommunication Tech'),(46221230080,'EmTechni','eM Technics Co., Ltd.'),(46238007296,'DaewooTe','Daewoo Teletech Co., Ltd'),(46254784512,'ColorKin','Color Kinetics'),(46271561728,'Overture','Overture Networks.'),(46288338944,'Unicatio','Unication Group'),(46305116160,'ZpsysPla','ZPSYS CO.,LTD. (Planning&Managem'),(46321893376,'Zambeel','Zambeel Inc'),(46338670592,'Yokoyama','YOKOYAMA SHOKAI CO.,Ltd.'),(46355447808,'XpakMsaG','XPAK MSA Group'),(46372225024,'WinnowNe','Winnow Networks, Inc.'),(46389002240,'SunrichT','Sunrich Technology Limited'),(46405779456,'Radiante','RADIANTECH, INC.'),(46422556672,'Provideo','PROVIDEO Multimedia Co. Ltd.'),(46439333888,'NiigataD','Niigata Develoment Center,  F.I.'),(46456111104,'Mws',''),(46472888320,'Jepico','JEPICO Corporation'),(46489665536,'Initech','INITECH Co., Ltd'),(46506442752,'Corebell','CoreBell Systems Inc.'),(46523219968,'Brainchi','Brainchild Electronic Co., Ltd.'),(46539997184,'Beamreac','BeamReach Networks'),(46556774400,'OriginEl','Origin ELECTRIC CO.,LTD.'),(46573551616,'IpcservT','IPCserv Technology Corp.'),(46590328832,'SonyEric','Sony Ericsson Mobile Communicati'),(46607106048,'Vindicat','Vindicator Technologies'),(46623883264,'Skypilot','SkyPilot Network, Inc'),(46640660480,'Ruggedco','RuggedCom Inc.'),(46657437696,'Allworx','Allworx Corp.'),(46674214912,'HappyCom','Happy Communication Co., Ltd.'),(46690992128,'Gennum','Gennum Corporation'),(46707769344,'FujitsuS','Fujitsu Softek'),(46724546560,'EgTechno','EG Technology'),(46741323776,'Binatone','Binatone Electronics Internation'),(46758100992,'YangMeiT','YANG MEI TECHNOLOGY CO., LTD'),(46774878208,'Wistron','Wistron Corp.'),(46791655424,'Scottcar','ScottCare Corporation'),(46808432640,'Elitegro','Elitegroup Computer System Co. ('),(46825209856,'EliopSA','ELIOP S.A.'),(46841987072,'CathayRo','Cathay Roxus Information Technol'),(46858764288,'AirvastT','AirVast Technology Inc.'),(46875541504,'AdamElek','ADAM ELEKTRONIK LTD. ÅžTI'),(46892318720,'Shenzhen','Shenzhen Tp-Link Technology Co; '),(46909095936,'KoatsuGa','Koatsu Gas Kogyo Co., Ltd.'),(46925873152,'Harting','HARTING Systems GmbH & Co KG'),(46942650368,'GcdHard-','GCD Hard- & Software GmbH'),(46959427584,'OtrumAsa','OTRUM ASA'),(46976204800,'Shin-OhE','SHIN-OH ELECTRONICS CO., LTD. R&'),(46992982016,'ClarityD','Clarity Design, Inc.'),(47009759232,'Neoaxiom','NeoAxiom Corp.'),(47026536448,'Cisco','CISCO SYSTEMS, INC.'),(47043313664,'Cisco','CISCO SYSTEMS, INC.'),(47060090880,'AirgoNet','Airgo Networks, Inc.'),(47076868096,'EmersonC','Emerson Climate Technologies Ret'),(47093645312,'Broadcom','Broadcom Corp.'),(47110422528,'American','American Telecare Inc.'),(47127199744,'Hiconnec','HiConnect, Inc.'),(47143976960,'Traverse','Traverse Technologies Australia'),(47160754176,'Ambri','Ambri Limited'),(47177531392,'CoreTecC','Core Tec Communications, LLC'),(47194308608,'VikingEl','Viking Electronic Services'),(47211085824,'Novapal','NovaPal Ltd'),(47227863040,'Kilchher','Kilchherr Elektronik AG'),(47244640256,'FujianSt','FUJIAN START COMPUTER EQUIPMENT '),(47261417472,'DaiichiE','DAIICHI ELECTRONICS CO., LTD.'),(47278194688,'Dallmeie','Dallmeier electronic'),(47294971904,'Taekwang','Taekwang Industrial Co., Ltd'),(47311749120,'Volktek','Volktek Corporation'),(47328526336,'PacificB','Pacific Broadband Networks'),(47345303552,'Motorola','Motorola Mobility, Inc.'),(47362080768,'VoxpathN','Voxpath Networks'),(47378857984,'PillarDa','Pillar Data Systems'),(47395635200,'Ifoundry','Ifoundry Systems Singapore'),(47412412416,'DbmOptic','dBm Optics'),(47429189632,'Corrent','Corrent Corporation'),(47445966848,'Agile','Agile Systems Inc.'),(47462744064,'Air2u','Air2U, Inc.'),(47479521280,'TrapezeN','Trapeze Networks'),(47496298496,'BoschRex','Bosch Rexroth'),(47513075712,'11waveTe','11wave Technonlogy Co.,Ltd'),(47529852928,'HimejiAb','HIMEJI ABC TRADING CO.,LTD.'),(47546630144,'NuriTele','NURI Telecom Co., Ltd.'),(47563407360,'Zetron','ZETRON INC'),(47580184576,'Viewsoni','ViewSonic Corporation'),(47596961792,'Platypus','Platypus Technology'),(47613739008,'Communic','Communication Machinery Corporat'),(47630516224,'MksInstr','MKS Instruments'),(47647293440,'Private',''),(47664070656,'VernierN','Vernier Networks, Inc.'),(47680847872,'Industri','Industrial Defender, Inc.'),(47697625088,'Systroni','Systronix, Inc.'),(47714402304,'SibcoBv','SIBCO bv'),(47731179520,'Layerzer','LayerZero Power Systems, Inc.'),(47747956736,'KappaOpt','KAPPA opto-electronics GmbH'),(47764733952,'IConComp','I CON Computer Co.'),(47781511168,'Hirata','Hirata corporation'),(47798288384,'G-StarCo','G-Star Communications Inc.'),(47815065600,'Environm','Environmental Systems and Servic'),(47831842816,'SiemensS','Siemens Subscriber Networks'),(47848620032,'Airlogic',''),(47865397248,'Aeluros',''),(47882174464,'Wetek','Wetek Corporation'),(47898951680,'Scion','Scion Corporation'),(47915728896,'Quatech','Quatech Inc.'),(47932506112,'LsLgIndu','LS(LG) Industrial Systems co.,Lt'),(47949283328,'Howtel','HOWTEL Co., Ltd.'),(47966060544,'Hostnet','HOSTNET CORPORATION'),(47982837760,'EikiIndu','Eiki Industrial Co. Ltd.'),(47999614976,'Danfoss','Danfoss Inc.'),(48016392192,'Cal-Comp','Cal-Comp Electronics (Thailand) '),(48033169408,'Bplan','bplan GmbH'),(48049946624,'BeijingG','Beijing Gongye Science & Technol'),(48066723840,'YantaiZh','Yantai ZhiYang Scientific and te'),(48083501056,'Vormetri','VORMETRIC, INC.'),(48100278272,'VivatoTe','Vivato Technologies'),(48117055488,'Shanghai','ShangHai Broadband Technologies '),(48133832704,'QuadBitS','Quad Bit System co., Ltd.'),(48150609920,'Producti','Productivity Systems, Inc.'),(48167387136,'Manufact','MANUFACTURE DES MONTRES ROLEX SA'),(48184164352,'KnÃ¼rr','KnÃ¼rr GmbH'),(48200941568,'KeisokuG','Keisoku Giken Co.,Ltd.'),(48217718784,'Qustream','QuStream Corporation'),(48234496000,'Devolo','devolo AG'),(48251273216,'CygnalIn','Cygnal Integrated Products, Inc.'),(48268050432,'ContalOk','CONTAL OK Ltd.'),(48284827648,'Bittware','BittWare, Inc'),(48301604864,'Antholog','Anthology Solutions Inc.'),(48318382080,'Oclaro',''),(48335159296,'IngBÃ¼roD','Ing. BÃ¼ro Dr. Beutlhauser'),(48351936512,'Commax','commax Co., Ltd.'),(48368713728,'Microsca','Microscan Systems, Inc.'),(48385490944,'ConcordI','Concord IDea Corp.'),(48402268160,'Cisco','CISCO SYSTEMS, INC.'),(48419045376,'Cisco','CISCO SYSTEMS, INC.'),(48435822592,'Advanced','Advanced Energy'),(48452599808,'Sofrel',''),(48469377024,'Rf-LinkS','RF-Link System Inc.'),(48486154240,'Visimetr','Visimetrics (UK) Ltd'),(48502931456,'Visiowav','VISIOWAVE SA'),(48519708672,'ClarionM','Clarion (M) Sdn Bhd'),(48536485888,'Emuzed',''),(48553263104,'Vertexrs','VertexRSI, General Dynamics SatC'),(48570040320,'Verifone','Verifone, INC.'),(48586817536,'Oxygnet',''),(48603594752,'MicetekI','Micetek International Inc.'),(48620371968,'JoymaxEl','JOYMAX ELECTRONICS CO. LTD.'),(48637149184,'Initium','INITIUM Co., Ltd.'),(48653926400,'Bitmicro','BiTMICRO Networks, Inc.'),(48670703616,'Adinstru','ADInstruments'),(48687480832,'Cybernet','Cybernetics'),(48704258048,'SiliconL','Silicon Laboratories'),(48721035264,'Astronau','Astronautics C.A  LTD'),(48737812480,'Scriptpr','ScriptPro, LLC'),(48754589696,'Hyperedg','HyperEdge'),(48771366912,'RinconRe','Rincon Research Corporation'),(48788144128,'Newtech','Newtech Co.,Ltd'),(48804921344,'Fujitsu','FUJITSU LIMITED'),(48821698560,'AudioEng','Audio Engineering Society Inc.'),(48838475776,'Cisco','CISCO SYSTEMS, INC.'),(48855252992,'Cisco','CISCO SYSTEMS, INC.'),(48872030208,'Friedric','Friedrich LÃ¼tze GmbH & Co. KG'),(48888807424,'Ib-Mohne','ib-mohnen KG'),(48905584640,'Kaleides','Kaleidescape'),(48922361856,'KiebackP','Kieback & Peter GmbH & Co KG'),(48939139072,'SyACSrl','Sy.A.C. srl'),(48955916288,'Teralink','Teralink Communications'),(48972693504,'TopviewT','Topview Technology Corporation'),(48989470720,'Addvalue','Addvalue Communications Pte Ltd'),(49006247936,'FrankeFi','Franke Finland Oy'),(49023025152,'Asiarock','Asiarock Incorporation'),(49039802368,'WistronN','Wistron Neweb Corp.'),(49056579584,'Sychip','Sychip Inc.'),(49073356800,'Solectro','SOLECTRON JAPAN NAKANIIDA'),(49090134016,'NeffInst','Neff Instrument Corp.'),(49106911232,'MediaStr','Media Streaming Networks Inc'),(49123688448,'LoadTech','Load Technology, Inc.'),(49140465664,'Litchfie','Litchfield Communications Inc.'),(49157242880,'Lawo','Lawo AG'),(49174020096,'KodeosCo','Kodeos Communications'),(49190797312,'Kingwave','Kingwave Technology Co., Ltd.'),(49207574528,'Iosoft','Iosoft Ltd.'),(49224351744,'Et&TTech','ET&T Technology Co. Ltd.'),(49241128960,'Cogent','Cogent Systems, Inc.'),(49257906176,'Taifatec','TAIFATECH INC.'),(49274683392,'X-Com','X-COM, Inc.'),(49291460608,'L-3Linka','L-3 Linkabit'),(49308237824,'Test-Um','Test-Um Inc.'),(49325015040,'TelexCom','Telex Communications'),(49341792256,'SolomonE','SOLOMON EXTREME INTERNATIONAL LT'),(49358569472,'Saginomi','SAGINOMIYA Seisakusho Inc.'),(49375346688,'AlignEng','Align Engineering LLC'),(49392123904,'LyciumNe','Lycium Networks'),(49408901120,'Kaparel','Kaparel Corporation'),(49425678336,'Grandstr','Grandstream Networks, Inc.'),(49442455552,'Datawatt','DATAWATT B.V.'),(49459232768,'Bodet',''),(49476009984,'Cisco','CISCO SYSTEMS, INC.'),(49492787200,'ArubaNet','Aruba Networks'),(49509564416,'American','American Reliance Inc.'),(49526341632,'Vidisco','Vidisco ltd.'),(49543118848,'TopGloba','Top Global Technology, Ltd.'),(49559896064,'Miteq','MITEQ Inc.'),(49576673280,'KerajetS','KERAJET, S.A.'),(49593450496,'Flextron','Flextronics'),(49610227712,'AvvioNet','Avvio Networks'),(49627004928,'Ascent','Ascent Corporation'),(49643782144,'AkitaEle','AKITA ELECTRONICS SYSTEMS CO.,LT'),(49660559360,'AdvaOpti','ADVA Optical Networking Ltd.'),(49677336576,'AglaiaGe','Aglaia Gesellschaft fÃ¼r Bildver'),(49694113792,'AscomDan','Ascom Danmark A/S'),(49710891008,'RitterEl','Ritter Elektronik'),(49727668224,'DigitalM','Digital Monitoring Products, Inc'),(49744445440,'EbetGami','eBet Gaming Systems Pty Ltd'),(49761222656,'Innotrac','Innotrac Diagnostics Oy'),(49777999872,'Matsushi','Matsushita Electric Industrial C'),(49794777088,'Nicetech','NiceTechVision'),(49811554304,'Sensable','SensAble Technologies, Inc.'),(49828331520,'Shanghai','Shanghai Ulink Telecom Equipment'),(49845108736,'SiriusSy','Sirius System Co, Ltd.'),(49861885952,'TribeamT','TriBeam Technologies, Inc.'),(49878663168,'TwinmosT','TwinMOS Technologies Inc.'),(49895440384,'YasingTe','Yasing Technology Corp.'),(49912217600,'NeueElsa','Neue ELSA GmbH'),(49928994816,'T&LInfor','T&L Information Inc.'),(49945772032,'Syscom','SYSCOM Ltd.'),(49962549248,'Sumitomo','Sumitomo Electric Networks, Inc'),(49979326464,'SiemensI','Siemens AG, I&S'),(49996103680,'ShironSa','Shiron Satellite Communications '),(50012880896,'QuasarCi','Quasar Cipta Mandiri, PT'),(50029658112,'Miyakawa','Miyakawa Electric Works Ltd.'),(50046435328,'MarantiN','Maranti Networks'),(50063212544,'HanbackE','HANBACK ELECTRONICS CO., LTD.'),(50079989760,'Cloudshi','CloudShield Technologies, Inc.'),(50096766976,'Aiphone','Aiphone co.,Ltd'),(50113544192,'Advantec','Advantech Technology (CHINA) Co.'),(50130321408,'3com','3Com Ltd'),(50147098624,'Pc-Pos','PC-PoS Inc.'),(50163875840,'VitalsSy','Vitals System Inc.'),(50180653056,'WoojuCom','WOOJU COMMUNICATIONS Co,.Ltd'),(50197430272,'SysnetTe','Sysnet Telematica srl'),(50214207488,'SuperSta','Super Star Technology Co., Ltd.'),(50230984704,'Smallbig','SMALLBIG TECHNOLOGY'),(50247761920,'RitTechn','RiT technologies Ltd.'),(50264539136,'RdcSemic','RDC Semiconductor Inc.,'),(50281316352,'NstorTec','nStor Technologies, Inc.'),(50298093568,'Metallig','Metalligence Technology Corp.'),(50314870784,'Micro','Micro Systems Co.,Ltd.'),(50331648000,'KihokuEl','Kihoku Electronic Co.'),(50348425216,'Imsys','Imsys AB'),(50365202432,'Harmonic','Harmonic, Inc'),(50381979648,'Etin','Etin Systems Co., Ltd'),(50398756864,'EnGarde','En Garde Systems, Inc.'),(50415534080,'Connexio','Connexionz Limited'),(50432311296,'Cisco','CISCO SYSTEMS, INC.'),(50449088512,'Cisco','CISCO SYSTEMS, INC.'),(50465865728,'ChinaIwn','China IWNComm Co., Ltd.'),(50482642944,'BayMicro','Bay Microsystems, Inc.'),(50499420160,'CorinexC','Corinex Communication Corp.'),(50516197376,'Multiple','Multiplex, Inc.'),(50532974592,'Biotroni','BIOTRONIK GmbH & Co'),(50549751808,'SmcNetwo','SMC Networks, Inc.'),(50566529024,'Isac','ISAC, Inc.'),(50583306240,'IcetSPA','ICET S.p.A.'),(50600083456,'AirflowN','AirFlow Networks'),(50616860672,'Electrol','Electroline Equipment'),(50633637888,'DatavanI','DATAVAN International Corporatio'),(50650415104,'FagorAut','Fagor Automation , S. Coop'),(50667192320,'JusanSA','JUSAN, S.A.'),(50683969536,'Hewlett-','Hewlett-Packard Company'),(50700746752,'Free2mov','Free2move AB'),(50717523968,'AgfaNdt','AGFA NDT INC.'),(50734301184,'XimetaTe','XiMeta Technology Americas Inc.'),(50751078400,'Aeronix','Aeronix, Inc.'),(50767855616,'RemoproT','Remopro Technology Inc.'),(50784632832,'Cd3o',''),(50801410048,'BeijingW','Beijing Wise Technology & Scienc'),(50818187264,'Nvergenc','Nvergence, Inc.'),(50834964480,'PaxtonAc','Paxton Access Ltd'),(50851741696,'DormaTim','DORMA Time + Access GmbH'),(50868518912,'Industri','Industrial Scientific Corp.'),(50885296128,'GeneralH','General Hydrogen'),(50902073344,'Eyecross','EyeCross Co.,Inc.'),(50918850560,'DellEsgP','Dell ESG PCBA Test'),(50935627776,'Akcp',''),(50952404992,'TohokuRi','TOHOKU RICOH Co., LTD.'),(50969182208,'Teldix','TELDIX GmbH'),(50985959424,'Shenzhen','Shenzhen RouterD Networks Limite'),(51002736640,'Serconet','SercoNet Ltd.'),(51019513856,'NokiaNet','Nokia NET Product Operations'),(51036291072,'Lumenera','Lumenera Corporation'),(51053068288,'KeyStrea','Key Stream Co., Ltd.'),(51069845504,'Hosiden','Hosiden Corporation'),(51086622720,'HimsInte','HIMS International Corporation'),(51103399936,'DatelEle','Datel Electronics'),(51120177152,'ComfluxT','COMFLUX TECHNOLOGY INC.'),(51136954368,'Aoip',''),(51153731584,'Actel','Actel Corporation'),(51170508800,'ZultysTe','Zultys Technologies'),(51187286016,'Systegra','Systegra AG'),(51204063232,'NipponEl','NIPPON ELECTRIC INSTRUMENT, INC.'),(51220840448,'Elm','ELM Inc.'),(51237617664,'Jet','inc.jet, Incorporated'),(51254394880,'Code','Code Corporation'),(51271172096,'MotexPro','MoTEX Products Co., Ltd.'),(51287949312,'LapLaser','LAP Laser Applikations'),(51304726528,'Chih-Kan','Chih-Kan Technology Co., Ltd.'),(51321503744,'Bae','BAE SYSTEMS'),(51338280960,'Private',''),(51355058176,'Shanghai','Shanghai Sibo Telecom Technology'),(51371835392,'Nitgen','Nitgen Co., Ltd'),(51388612608,'Nidek','NIDEK CO.,LTD'),(51405389824,'Infinera',''),(51422167040,'Gemstone','Gemstone communications, Inc.'),(51438944256,'ExemysSr','EXEMYS SRL'),(51455721472,'D-NetInt','D-NET International Corporation'),(51472498688,'Cisco','CISCO SYSTEMS, INC.'),(51489275904,'Cisco','CISCO SYSTEMS, INC.'),(51506053120,'CastelBr','CASTEL Broadband Limited'),(51522830336,'Berkeley','Berkeley Camera Engineering'),(51539607552,'BebIndus','BEB Industrie-Elektronik AG'),(51556384768,'Abatron','Abatron AG'),(51573161984,'AbbOy','ABB Oy'),(51589939200,'HdmiLice','HDMI Licensing, LLC'),(51606716416,'Tecnova',''),(51623493632,'RpaReser','RPA Reserch Co., Ltd.'),(51640270848,'NixvuePt','Nixvue Systems  Pte Ltd'),(51657048064,'Iftest','Iftest AG'),(51673825280,'HumexTec','HUMEX Technologies Corp.'),(51690602496,'HitachiI','Hitachi IE Systems Co., Ltd'),(51707379712,'Guangdon','Guangdong Province Electronic Te'),(51724156928,'Broadbus','Broadbus Technologies'),(51740934144,'ApproTec','APPRO TECHNOLOGY INC.'),(51757711360,'Communic','Communications & Power Industrie'),(51774488576,'Xtremesp','XtremeSpectrum, Inc.'),(51791265792,'Techno-O','Techno-One Co., Ltd'),(51808043008,'Pni','PNI Corporation'),(51824820224,'NipponDe','NIPPON DEMPA CO.,LTD.'),(51841597440,'Micro-Op','Micro-Optronic-Messtechnik GmbH'),(51858374656,'Mediaq',''),(51875151872,'Diagnost','Diagnostic Instruments, Inc.'),(51891929088,'Cyberpow','CyberPower Systems, Inc.'),(51908706304,'Concorde','Concorde Microsystems Inc.'),(51925483520,'AjaVideo','AJA Video Systems Inc'),(51942260736,'ZenisuKe','Zenisu Keisoku Inc.'),(51959037952,'TelioCom','Telio Communications GmbH'),(51975815168,'QuestTec','Quest Technical Solutions Inc.'),(51992592384,'Oracom','ORACOM Co, Ltd.'),(52009369600,'Microweb','MicroWeb Co., Ltd.'),(52026146816,'MettlerF','Mettler & Fuchs AG'),(52042924032,'GlobalCa','Global Cache'),(52059701248,'Glimmerg','Glimmerglass Networks'),(52076478464,'FiWin','Fi WIn, Inc.'),(52093255680,'FacultyO','Faculty of Science and Technolog'),(52110032896,'DoubleDE','Double D Electronics Ltd'),(52126810112,'BeijingL','Beijing Lanchuan Tech. Co., Ltd.'),(52143587328,'Anator',''),(52160364544,'AlliedTe','Allied Telesis Labs, Inc.'),(52177141760,'WeintekL','Weintek Labs. Inc.'),(52193918976,'Sammy','Sammy Corporation'),(52210696192,'Rifatron',''),(52227473408,'Vmware','VMware, Inc.'),(52244250624,'OcttelCo','OCTTEL Communication Co., Ltd.'),(52261027840,'EliasTec','ELIAS Technology, Inc.'),(52277805056,'Enwiser','Enwiser Inc.'),(52294582272,'Fullwave','FullWave Technology Co., Ltd.'),(52311359488,'OpenetIn','Openet information technology(sh'),(52328136704,'Seorimte','SeorimTechnology Co.,Ltd.'),(52344913920,'Cisco','CISCO SYSTEMS, INC.'),(52361691136,'Cisco','CISCO SYSTEMS, INC.'),(52378468352,'AvionicD','Avionic Design Development GmbH'),(52395245568,'Compucas','Compucase Enterprise Co. Ltd.'),(52412022784,'Vixen','Vixen Co., Ltd.'),(52428800000,'KavoDent','KaVo Dental GmbH & Co. KG'),(52445577216,'SharpTak','SHARP TAKAYA ELECTRONICS INDUSTR'),(52462354432,'Geomatio','Geomation, Inc.'),(52479131648,'Telcobri','TelcoBridges Inc.'),(52495908864,'Sentinel','Sentinel Wireless Inc.'),(52512686080,'Oxance',''),(52529463296,'OrionEle','Orion Electric Co., Ltd.'),(52546240512,'Mediacho','MediaChorus, Inc.'),(52563017728,'Glsystec','Glsystech Co., Ltd.'),(52579794944,'CrestAud','Crest Audio'),(52596572160,'CogentDe','Cogent Defence & Security Networ'),(52613349376,'AltechCo','Altech Controls'),(52630126592,'Cisco-Li','Cisco-Linksys'),(52646903808,'Routerbo','Routerboard.com'),(52663681024,'RalinkTe','Ralink Technology, Corp.'),(52680458240,'Automate','Automated Interfaces, Inc.'),(52697235456,'Animatio','Animation Technologies Inc.'),(52714012672,'AlliedTe','Allied Telesyn Inc.'),(52730789888,'SkTelete','SK Teletech(R&D Planning Team)'),(52747567104,'Qostek','QoStek Corporation'),(52764344320,'Dangaard','Dangaard Telecom RTC Division A/'),(52781121536,'CygnusMi','Cygnus Microsystems (P) Limited'),(52797898752,'CheopsEl','Cheops Elektronik'),(52814675968,'ArcorAg&','Arcor AG&Co.'),(52831453184,'Curtiss-','Curtiss-Wright Controls Avionics'),(52848230400,'WinbestT','Winbest Technology CO,LT'),(52865007616,'UdtechJa','UDTech Japan Corporation'),(52881784832,'SeagateT','Seagate Technology'),(52898562048,'Scientif','Scientific Technologies Inc.'),(52915339264,'Roll','Roll Systems Inc.'),(52932116480,'Private',''),(52948893696,'Pedestal','Pedestal Networks, Inc'),(52965670912,'Microlin','Microlink Communications Inc.'),(52982448128,'MegatelC','Megatel Computer (1986) Corp.'),(52999225344,'MackieEn','MACKIE Engineering Services Belg'),(53016002560,'M&S','M&S Systems'),(53032779776,'IndymeEl','Indyme Electronics, Inc.'),(53049556992,'IbsmmEmb','IBSmm Embedded Electronics Consu'),(53066334208,'HanwangT','HANWANG TECHNOLOGY CO.,LTD'),(53083111424,'GtnBV','GTN Systems B.V.'),(53099888640,'ChicTech','CHIC TECHNOLOGY (CHINA) CORP.'),(53116665856,'CalypsoM','Calypso Medical'),(53133443072,'Avtec','Avtec, Inc.'),(53150220288,'Acm','ACM Systems'),(53166997504,'AcTechDb','AC Tech corporation DBA Advanced'),(53183774720,'AbbCewe-','ABB AB, Cewe-Control'),(53200551936,'ZenithEl','Zenith Electronics Corporation'),(53217329152,'X2MsaGro','X2 MSA Group'),(53234106368,'SuninTel','Sunin Telecom'),(53250883584,'ProntoNe','Pronto Networks Inc'),(53267660800,'OyoElect','OYO ELECTRIC CO.,LTD'),(53284438016,'Sigmatel','SigmaTel, Inc.'),(53301215232,'National','National Radio Astronomy Observa'),(53317992448,'Mbari',''),(53334769664,'KurzIndu','Kurz Industrie-Elektronik GmbH'),(53351546880,'ElgatoLl','Elgato Systems LLC'),(53368324096,'Edwards','Edwards Ltd.'),(53385101312,'AsustekC','ASUSTEK COMPUTER INC.'),(53401878528,'AmtekSys','Amtek system co.,LTD.'),(53418655744,'Acc','ACC GmbH'),(53435432960,'Wybron','Wybron, Inc'),(53452210176,'Tempearl','Tempearl Industrial Co., Ltd.'),(53468987392,'TelsonEl','TELSON ELECTRONICS CO., LTD'),(53485764608,'Rivertec','RIVERTEC CORPORATION'),(53502541824,'Oriental','Oriental integrated electronics.'),(53519319040,'Micro-St','MICRO-STAR INTERNATIONAL CO., LT'),(53536096256,'LifeRaci','Life Racing Ltd'),(53552873472,'In-TechE','In-Tech Electronics Limited'),(53569650688,'ExtelCom','Extel Communications P/L'),(53586427904,'Datarius','DaTARIUS Technologies GmbH'),(53603205120,'AlphaPro','ALPHA PROJECT Co.,Ltd.'),(53619982336,'Internet','Internet Information Image Inc.'),(53636759552,'TeikokuE','TEIKOKU ELECTRIC MFG. CO., LTD'),(53653536768,'Tellium','Tellium Incorporated'),(53670313984,'Synertro','synertronixx GmbH'),(53687091200,'Opelcomm','Opelcomm Inc.'),(53703868416,'Schneide','Schneider Electric (Australia)'),(53720645632,'NetworkT','NETWORK TECHNOLOGIES INC'),(53737422848,'LogicalS','Logical Solutions'),(53754200064,'Eazix','Eazix, Inc.'),(53770977280,'Cisco','CISCO SYSTEMS, INC.'),(53787754496,'Cisco','CISCO SYSTEMS, INC.'),(53804531712,'Amd',''),(53821308928,'ApacheMi','Apache Micro Peripherals, Inc.'),(53838086144,'AcElectr','AC Electric Vehicles, Ltd.'),(53854863360,'Bose','Bose Corporation'),(53871640576,'ConnectT','Connect Tech Inc'),(53888417792,'Kodicom','KODICOM CO.,LTD.'),(53905195008,'MatrixVi','MATRIX VISION GmbH'),(53921972224,'MentorEn','Mentor Engineering Inc'),(53938749440,'NergalSR','Nergal s.r.l.'),(53955526656,'Octasic','Octasic Inc.'),(53972303872,'Riverhea','Riverhead Networks Inc.'),(53989081088,'Wolfvisi','WolfVision Gmbh'),(54005858304,'Xeline','Xeline Co., Ltd.'),(54022635520,'UnitedEl','United Electronic Industries, In'),(54039412736,'Primenet',''),(54056189952,'Oqo','OQO, Inc.'),(54072967168,'NvAdbTtv','NV ADB TTV Technologies SA'),(54089744384,'LetekCom','LETEK Communications Inc.'),(54106521600,'HitelLin','HITEL LINK Co.,Ltd'),(54123298816,'HitechEl','Hitech Electronics Corp.'),(54140076032,'EeSoluti','EE Solutions, Inc'),(54156853248,'ChonghoI','Chongho information & communicat'),(54173630464,'Ubeeairw','UbeeAirWalk, Inc.'),(54190407680,'Memoryli','MemoryLink Corp.'),(54207184896,'Nke','NKE Corporation'),(54223962112,'Storcase','StorCase Technology, Inc.'),(54240739328,'Sigmacom','SIGMACOM Co., LTD.'),(54257516544,'Harmonic','Harmonic Video Network'),(54274293760,'RanchoTe','Rancho Technology, Inc.'),(54291070976,'Promptte','Prompttec Product Management Gmb'),(54307848192,'NamanNz','Naman NZ LTd'),(54324625408,'Mintera','Mintera Corporation'),(54341402624,'MetroSuz','Metro (Suzhou) Technologies Co.,'),(54358179840,'GarudaNe','Garuda Networks Corporation'),(54374957056,'Ebtron','Ebtron Inc.'),(54391734272,'CubicTra','Cubic Transportation Systems Inc'),(54408511488,'CommendI','COMMEND International'),(54425288704,'CitizenW','Citizen Watch Co., Ltd.'),(54442065920,'BtuInter','BTU International'),(54458843136,'AilocomO','Ailocom Oy'),(54475620352,'TriTerm','TRI TERM CO.,LTD.'),(54492397568,'StarSemi','Star Semiconductor Corporation'),(54509174784,'SallandE','Salland Engineering (Europe) BV'),(54525952000,'Comstar','Comstar Co., Ltd.'),(54542729216,'Round','ROUND Co.,Ltd.'),(54559506432,'Autocell','AutoCell Laboratories, Inc.'),(54576283648,'PremierT','Premier Technolgies, Inc'),(54593060864,'NanjingS','NANJING SEU MOBILE & INTERNET TE'),(54609838080,'NanjingH','Nanjing Huazhuo Electronics Co.,'),(54626615296,'Medion','MEDION AG'),(54643392512,'Lea',''),(54660169728,'Jamex','Jamex, Inc.'),(54676946944,'Iskraeme','ISKRAEMECO'),(54693724160,'Iscutum',''),(54710501376,'Interfac','Interface Masters, Inc'),(54727278592,'Innomina','Innominate Security Technologies'),(54744055808,'HolySton','Holy Stone Ent. Co., Ltd.'),(54760833024,'GeneraOy','Genera Oy'),(54777610240,'CooperIn','Cooper Industries Inc.'),(54794387456,'Controln','ControlNet (India) Private Limit'),(54811164672,'Bewan','BeWAN systems'),(54827941888,'Tiptel','Tiptel AG'),(54844719104,'Nextlink','Nextlink Co., Ltd.'),(54861496320,'Ka-RoEle','Ka-Ro electronics GmbH'),(54878273536,'Intellig','Intelligent Computer Solutions I'),(54895050752,'Xytronix','Xytronix Research & Design, Inc.'),(54911827968,'IlwooDat','ILWOO DATA & TECHNOLOGY CO.,LTD'),(54928605184,'HgstAWes','HGST a Western Digital Company'),(54945382400,'DesignCo','Design Combus Ltd'),(54962159616,'Aeroscou','Aeroscout Ltd.'),(54978936832,'Iec-Tc57','IEC - TC57'),(54995714048,'Cisco','CISCO SYSTEMS, INC.'),(55012491264,'Cisco','CISCO SYSTEMS, INC.'),(55029268480,'Symetrix',''),(55046045696,'SfomTech','SFOM Technology Corp.'),(55062822912,'Schaffne','Schaffner EMV AG'),(55079600128,'PrettlEl','Prettl Elektronik Radeberg GmbH'),(55096377344,'Positron','Positron Public Safety Systems i'),(55113154560,'Passave','Passave Inc.'),(55129931776,'PartnerT','PARTNER TECH'),(55146708992,'Nallatec','Nallatech Ltd'),(55163486208,'MKJuchhe','M. K. Juchheim GmbH & Co'),(55180263424,'Itcare','Itcare Co., Ltd'),(55197040640,'Freehand','FreeHand Systems, Inc.'),(55213817856,'BrocadeC','Brocade Communications Systems, '),(55230595072,'BecsTech','BECS Technology, Inc'),(55247372288,'AosTechn','AOS Technologies AG'),(55264149504,'AbbStotz','ABB STOTZ-KONTAKT GmbH'),(55280926720,'PulnixAm','PULNiX America, Inc'),(55297703936,'TrekDiag','Trek Diagnostics Inc.'),(55314481152,'OpenGrou','The Open Group'),(55331258368,'Rolls-Ro','Rolls-Royce'),(55348035584,'OptionIn','Option International N.V.'),(55364812800,'Neurocom','NeuroCom International, Inc.'),(55381590016,'Motorola','Motorola Mobility, Inc.'),(55398367232,'MeruNetw','Meru Networks Inc'),(55415144448,'Mediatek','MediaTek Inc.'),(55431921664,'Guangzho','GuangZhou AnJuBao Co., Ltd'),(55448698880,'Bloomber','BLOOMBERG L.P.'),(55465476096,'AphonaKo','aphona Kommunikationssysteme'),(55482253312,'CnmpNetw','CNMP Networks, Inc.'),(55499030528,'Spectrac','Spectracom Corp.'),(55515807744,'RealDigi','Real Digital Media'),(55532584960,'Jp-Embed','jp-embedded'),(55549362176,'OpenNetw','Open Networks Engineering Ltd'),(55566139392,'MN','M & N GmbH'),(55582916608,'Intel','Intel Corporation'),(55599693824,'GamesaEÃ³','GAMESA EÃ³lica'),(55616471040,'CallImag','CALL IMAGE SA'),(55633248256,'Akatsuki','AKATSUKI ELECTRIC MFG.CO.,LTD.'),(55650025472,'Infoexpr','InfoExpress'),(55666802688,'SitecomE','Sitecom Europe BV'),(55683579904,'NortelNe','Nortel Networks'),(55700357120,'NortelNe','Nortel Networks'),(55717134336,'IttFlygt','ITT Flygt AB'),(55733911552,'Digital','Digital Systems Corp'),(55750688768,'KoreaNet','Korea Network Systems'),(55767465984,'S2ioTech','S2io Technologies Corp'),(55784243200,'HyundaiI','Hyundai ImageQuest Co.,Ltd.'),(55801020416,'GrandEle','Grand Electronic Co., Ltd'),(55817797632,'Mro-Tek','MRO-TEK LIMITED'),(55834574848,'SeawayNe','Seaway Networks Inc.'),(55851352064,'P&EMicro','P&E Microcomputer Systems, Inc.'),(55868129280,'NecAcces','NEC AccessTechnica, Ltd.'),(55884906496,'Matrics','Matrics, Inc.'),(55901683712,'FoxboroE','Foxboro Eckardt Development GmbH'),(55918460928,'Cybernet','cybernet manufacturing inc.'),(55935238144,'Compulog','Compulogic Limited'),(55952015360,'CalrecAu','Calrec Audio Ltd'),(55968792576,'Abovecab','AboveCable, Inc.'),(55985569792,'YuehuaZh','Yuehua(Zhuhai) Electronic CO. LT'),(56002347008,'Projecti','Projectiondesign as'),(56019124224,'Buffalo','Buffalo Inc.'),(56035901440,'MdiSecur','MDI Security Systems'),(56052678656,'Itsuppor','ITSupported, LLC'),(56069455872,'Inqnet','Inqnet Systems, Inc.'),(56086233088,'Finlux','Finlux Ltd'),(56103010304,'Embedtro','Embedtronics Oy'),(56119787520,'Dentsply','DENTSPLY - Gendex'),(56136564736,'Axell','AXELL Corporation'),(56153341952,'WilhelmR','Wilhelm Rutenbeck GmbH&Co.KG'),(56170119168,'VtechInn','Vtech Innovation LP dba Advanced'),(56186896384,'VoipacSR','Voipac s.r.o.'),(56203673600,'UhsPty','UHS Systems Pty Ltd'),(56220450816,'TurboNet','Turbo Networks Co.Ltd'),(56237228032,'Mega-Tre','Mega-Trend Electronics CO., LTD.'),(56254005248,'RobeShow','ROBE Show lighting'),(56270782464,'MustekSy','Mustek System Inc.'),(56287559680,'KyotoEle','Kyoto Electronics Manufacturing '),(56304336896,'AmesysDe','Amesys Defense'),(56321114112,'High-Tek','HIGH-TEK HARNESS ENT. CO., LTD.'),(56337891328,'ControlT','Control Techniques'),(56354668544,'AvDigita','AV Digital'),(56371445760,'Asahikas','ASAHIKASEI TECHNOSYSTEM CO.,LTD.'),(56388222976,'Wiscore','WISCORE Inc.'),(56405000192,'Unitroni','Unitronics LTD'),(56421777408,'SmartSol','Smart Solution, Inc'),(56438554624,'SentecE&','SENTEC E&E CO., LTD.'),(56455331840,'Sanden','SANDEN CORPORATION'),(56472109056,'Primagra','Primagraphics Limited'),(56488886272,'Microple','MICROPLEX Printware AG'),(56505663488,'Cisco','CISCO SYSTEMS, INC.'),(56522440704,'Cisco','CISCO SYSTEMS, INC.'),(56539217920,'Scanmati','Scanmatic AS'),(56555995136,'RacalIns','Racal Instruments'),(56572772352,'Patapsco','Patapsco Designs Ltd'),(56589549568,'NctDeuts','NCT Deutschland GmbH'),(56606326784,'Matsushi','Matsushita Avionics Systems Corp'),(56623104000,'AinCommT','AIN Comm.Tech.Co., LTD'),(56639881216,'IcefyreS','IceFyre Semiconductor'),(56656658432,'Compelle','Compellent Technologies, Inc.'),(56673435648,'Dispense','DispenseSource, Inc.'),(56690212864,'Prediwav','Prediwave Corp.'),(56706990080,'ShellInt','Shell International Exploration '),(56723767296,'PacInter','PAC International Ltd'),(56740544512,'WuHanRou','Wu Han Routon Electronic Co., Lt'),(56757321728,'Wiplug',''),(56774098944,'Nissin','NISSIN INC.'),(56790876160,'NetworkE','Network Electronics'),(56807653376,'Microsof','Microsoft Corp.'),(56824430592,'Microele','Microelectronics Technology Inc.'),(56841207808,'ITechDyn','i.Tech Dynamic Ltd'),(56857985024,'Hammerhe','Hammerhead Systems, Inc.'),(56874762240,'ApluxCom','APLUX Communications Ltd.'),(56891539456,'VtiInstr','VTI Instruments Corporation'),(56908316672,'VerintLo','Verint Loronix Video Solutions'),(56925093888,'SiemensI','Siemens AG ICM MP UC RD IT KLF1'),(56941871104,'NewbestD','Newbest Development Limited'),(56958648320,'DrsTacti','DRS Tactical Systems Inc.'),(56975425536,'AudioBu-','Audio BU - Logitech'),(56992202752,'TottoriS','Tottori SANYO Electric Co., Ltd.'),(57008979968,'ParkerSs','Parker SSD Drives'),(57025757184,'Collex',''),(57042534400,'AewinTec','AEWIN Technologies Co., Ltd.'),(57059311616,'TritonOf','Triton Systems of Delaware, Inc.'),(57076088832,'SteagEta','Steag ETA-Optik'),(57092866048,'RokuLlc','Roku, LLC'),(57109643264,'OutlineE','Outline Electronics Ltd.'),(57126420480,'Ninelane','Ninelanes'),(57143197696,'Ndr','NDR Co.,LTD.'),(57159974912,'Kenwood','Kenwood Corporation'),(57176752128,'GalazarN','Galazar Networks'),(57193529344,'Divr','DIVR Systems, Inc.'),(57210306560,'ComartSy','Comart system'),(57227083776,'Beijing5','Beijing 5w Communication Corp.'),(57243860992,'3com','3Com Ltd'),(57260638208,'SanycomT','SANYCOM Technology Co.,Ltd'),(57277415424,'DellEsgP','Dell ESG PCBA Test'),(57294192640,'FujitsuI','Fujitsu I-Network Systems Limite'),(57310969856,'Private',''),(57327747072,'Amity','Amity Systems, Inc.'),(57344524288,'Tiesse','Tiesse SpA'),(57361301504,'SmartEmp','Smart Empire Investments Limited'),(57378078720,'RobertBo','Robert Bosch GmbH, VT-ATMO'),(57394855936,'RaritanC','Raritan Computer, Inc'),(57411633152,'NecPerso','NEC Personal Products'),(57428410368,'Minds','Minds Inc'),(57445187584,'Ibm','IBM Corp'),(57461964800,'Giga-Byt','Giga-Byte Technology Co., Ltd.'),(57478742016,'Funkwerk','Funkwerk Dabendorf GmbH'),(57495519232,'DentInst','DENT Instruments, Inc.'),(57512296448,'ComagHan','COMAG Handels AG'),(57529073664,'Cisco','CISCO SYSTEMS, INC.'),(57545850880,'Cisco','CISCO SYSTEMS, INC.'),(57562628096,'Ericsson',''),(57579405312,'Vinci','Vinci Systems, Inc.'),(57596182528,'Tmt&D','TMT&D Corporation'),(57612959744,'RedwoodT','Redwood Technologies LTD'),(57629736960,'Mita-Tek','Mita-Teknik A/S'),(57646514176,'M-Audio',''),(57663291392,'K-TechDe','K-Tech Devices Corp.'),(57680068608,'K-Patent','K-Patents Oy'),(57696845824,'Ember','Ember Corporation'),(57713623040,'Datamax','Datamax Corporation'),(57730400256,'Boca','boca systems'),(57747177472,'2wire','2Wire, Inc'),(57763954688,'Technica','Technical Support, Inc.'),(57780731904,'SandNetw','Sand Network Systems, Inc.'),(57797509120,'KobianPt','Kobian Pte Ltd - Taiwan Branch'),(57814286336,'HokutoDe','Hokuto Denshi Co,. Ltd.'),(57831063552,'Falconst','FalconStor Software'),(57847840768,'Engineer','Engineering & Security'),(57864617984,'DynamicS','Dynamic Solutions Co,.Ltd.'),(57881395200,'DigattoA','DiGATTO Asia Pacific Pte Ltd'),(57898172416,'Consensy','Consensys Computers Inc.'),(57914949632,'Codian','Codian Ltd'),(57931726848,'Afco','Afco Systems'),(57948504064,'Axiowave','Axiowave Networks, Inc.'),(57965281280,'MidasCom','MIDAS  COMMUNICATION TECHNOLOGIE'),(57982058496,'OnlineDe','Online Development Inc'),(57998835712,'Pepperl+','Pepperl+Fuchs GmbH'),(58015612928,'PhsSrl','PHS srl'),(58032390144,'Sanmina-','Sanmina-SCI Hungary  Ltd.'),(58049167360,'Makus','Makus Inc.'),(58065944576,'Tapwave','Tapwave, Inc.'),(58082721792,'Huber+Su','Huber + Suhner AG'),(58099499008,'Elitegro','Elitegroup Computer System Co. ('),(58116276224,'D-Link','D-Link Corporation'),(58133053440,'BilsTech','Bils Technology Inc'),(58149830656,'WinnersE','Winners Electronics Co., Ltd.'),(58166607872,'T&D','T&D Corporation'),(58183385088,'Shanghai','Shanghai Wedone Digital Ltd. CO.'),(58200162304,'ProsoftT','Prosoft Technology, Inc'),(58216939520,'KodenEle','Koden Electronics Co., Ltd.'),(58233716736,'KingTsus','King Tsushin Kogyo Co., LTD.'),(58250493952,'FactumEl','Factum Electronics AB'),(58267271168,'EclipseH','Eclipse (HQ Espana) S.L.'),(58284048384,'ArimaCom','Arima Communication Corporation'),(58300825600,'AppleCom','Apple Computer'),(58317602816,'AfarComm','AFAR Communications,Inc'),(58334380032,'Opti-Cel','Opti-cell, Inc.'),(58351157248,'VteraTec','Vtera Technology Inc.'),(58367934464,'TroposNe','Tropos Networks, Inc.'),(58384711680,'SWACSchm','S.W.A.C. Schmitt-Walter Automati'),(58401488896,'OrbitalS','Orbital Sciences Corp.; Launch S'),(58418266112,'Infotec','INFOTEC LTD'),(58435043328,'HeraeusE','Heraeus Electro-Nite Internation'),(58451820544,'Elan','Elan GmbH & Co KG'),(58468597760,'Hewlett-','Hewlett-Packard Company'),(58485374976,'TokudenO','TOKUDEN OHIZUMI SEISAKUSYO Co.,L'),(58502152192,'RfMicroD','RF Micro Devices'),(58518929408,'NedapNV','NEDAP N.V.'),(58535706624,'MiraeIts','MIRAE ITS Co.,LTD.'),(58552483840,'InfrantT','Infrant Technologies, Inc.'),(58569261056,'Emerging','Emerging Technologies Limited'),(58586038272,'DoschAma','DOSCH & AMAND SYSTEMS AG'),(58602815488,'Fabric7','Fabric7 Systems, Inc'),(58619592704,'Universa','Universal Switching Corporation'),(58636369920,'Private',''),(58653147136,'Teletron','Teletronics Technology Corporati'),(58669924352,'TEAMSL','T.E.A.M. S.L.'),(58686701568,'SATehnol','S.A.Tehnology co.,Ltd.'),(58703478784,'ParkerHa','Parker Hannifin GmbH Electromech'),(58720256000,'JapanCbm','Japan CBM Corporation'),(58737033216,'Dataprob','Dataprobe, Inc.'),(58753810432,'SamsungH','SAMSUNG HEAVY INDUSTRIES CO., LT'),(58770587648,'PlexusUk','Plexus Corp (UK) Ltd'),(58787364864,'Olym-Tec','Olym-tech Co.,Ltd.'),(58804142080,'JapanNet','Japan Network Service Co., Ltd.'),(58820919296,'Ammasso','Ammasso, Inc.'),(58837696512,'SdoCommu','SDO Communication Corperation'),(58854473728,'Netasq',''),(58871250944,'Globalsa','GLOBALSAT TECHNOLOGY CORPORATION'),(58888028160,'Broadcom','Broadcom Corporation'),(58904805376,'SankoEle','SANKO ELECTRIC CO,.LTD'),(58921582592,'Schiller','SCHILLER AG'),(58938359808,'PcEngine','PC Engines GmbH'),(58955137024,'OcÃ©Docum','OcÃ© Document Technologies GmbH'),(58971914240,'NipponDe','Nippon Dentsu Co.,Ltd.'),(58988691456,'Cisco','CISCO SYSTEMS, INC.'),(59005468672,'Cisco','CISCO SYSTEMS, INC.'),(59022245888,'BelFuseE','Bel Fuse Europe Ltd.,UK'),(59039023104,'TektoneS','TekTone Sound & Signal Mfg., Inc'),(59055800320,'SpagatAs','Spagat AS'),(59072577536,'Safeweb','SafeWeb Inc'),(59089354752,'Private',''),(59106131968,'FirstCom','First Communication, Inc.'),(59122909184,'Emcore','Emcore Corporation'),(59139686400,'Echostar','EchoStar Global B.V.'),(59156463616,'Digirose','DigiRose Technology Co., Ltd.'),(59173240832,'CosmicEn','COSMIC ENGINEERING INC.'),(59190018048,'Airmagne','AirMagnet, Inc'),(59206795264,'ThalesEl','THALES Elektronik Systeme GmbH'),(59223572480,'TaitElec','Tait Electronics'),(59240349696,'Petcomko','Petcomkorea Co., Ltd.'),(59257126912,'Neosmart','NEOSMART Corp.'),(59273904128,'GroupeTx','GROUPE TXCOM'),(59290681344,'DynavacT','Dynavac Technology Pte Ltd'),(59307458560,'Cidra','Cidra Corp.'),(59324235776,'Tetratec','TetraTec Instruments GmbH'),(59341012992,'Stryker','Stryker Corporation'),(59357790208,'SimradOp','Simrad Optronics ASA'),(59374567424,'SamwooTe','SAMWOO Telecommunication Co.,Ltd'),(59391344640,'Symantec','Symantec Corporation'),(59408121856,'ORiteTec','O`RITE TECHNOLOGY CO.,LTD'),(59424899072,'Iti','ITI    LTD'),(59441676288,'Bright',''),(59458453504,'Bbn',''),(59475230720,'AntonPaa','Anton Paar GmbH'),(59492007936,'AlliedTe','ALLIED TELESIS K.K.'),(59508785152,'AirwaveT','AIRWAVE TECHNOLOGIES INC.'),(59525562368,'Vac',''),(59542339584,'ProfiloT','Profilo Telra Elektronik Sanayi '),(59559116800,'Joyteck','Joyteck Co., Ltd.'),(59575894016,'JapanIma','Japan Image & Network Inc.'),(59592671232,'Icpdas','ICPDAS Co.,LTD'),(59609448448,'ControlP','Control Products, Inc.'),(59626225664,'CmzSiste','CMZ Sistemi Elettronici'),(59643002880,'AtSweden','AT Sweden AB'),(59659780096,'Diginics','DIGINICS, Inc.'),(59676557312,'SamsungT','Samsung Thales'),(59693334528,'YoungboE','YOUNGBO ENGINEERING CO.,LTD'),(59710111744,'Snap-OnO','Snap-on OEM Group'),(59726888960,'NasacoEl','Nasaco Electronics Pte. Ltd'),(59743666176,'Napatech','Napatech Aps'),(59760443392,'KingtelT','Kingtel Telecommunication Corp.'),(59777220608,'Compxs','CompXs Limited'),(59793997824,'Cisco','CISCO SYSTEMS, INC.'),(59810775040,'Cisco','CISCO SYSTEMS, INC.'),(59827552256,'AndrewRf','Andrew RF Power Amplifier Group'),(59844329472,'SocCoopB','Soc. Coop. Bilanciai'),(59861106688,'QcomTech','QCOM TECHNOLOGY INC.'),(59877883904,'Ionix','IONIX INC.'),(59894661120,'Private',''),(59911438336,'AsmaxSol','Asmax Solutions'),(59928215552,'Watertek','Watertek Co.'),(59944992768,'Teletron','Teletronics International Inc.'),(59961769984,'Technolo','Technology Thesaurus Corp.'),(59978547200,'SpaceDyn','Space Dynamics Lab'),(59995324416,'OrgaKart','ORGA Kartensysteme GmbH'),(60012101632,'Nds','NDS Limited'),(60028878848,'MicroCon','Micro Control Systems Ltd.'),(60045656064,'Komax','Komax AG'),(60062433280,'Itfor','ITFOR Inc.'),(60079210496,'HugesHi-','Huges Hi-Tech Inc.,'),(60095987712,'Hauppaug','Hauppauge Computer Works, Inc.'),(60112764928,'Chenming','CHENMING MOLD INDUSTRY CORP.'),(60129542144,'Atrie',''),(60146319360,'AsipTech','ASIP Technologies Inc.'),(60163096576,'Advantec','Advantech AMT Inc.'),(60179873792,'Emulex',''),(60196651008,'Cma/Micr','CMA/Microdialysis AB'),(60213428224,'Wireless','WIRELESS MATRIX CORP.'),(60230205440,'TeamSimo','Team Simoco Ltd'),(60246982656,'SonyEric','Sony Ericsson Mobile Communicati'),(60263759872,'CiscoLin','Cisco Linksys LLC'),(60280537088,'Shenzhen','Shenzhen Coship Software Co.,LTD'),(60297314304,'SakumaDe','SAKUMA DESIGN OFFICE'),(60314091520,'NetacTec','Netac Technology Co., Ltd.'),(60330868736,'Intel','Intel Corporation'),(60347645952,'HeschSch','Hesch SchrÃ¶der GmbH'),(60364423168,'EsaElett','ESA elettronica S.P.A.'),(60381200384,'Ermme',''),(60397977600,'C-Guys','C-guys, Inc.'),(60414754816,'BdtBÃ¼roU','BDT BÃ¼ro und Datentechnik GmbH '),(60431532032,'Adaptive','Adaptive Micro Systems Inc.'),(60448309248,'Accu-Sor','Accu-Sort Systems inc.'),(60465086464,'Visionar','Visionary Solutions, Inc.'),(60481863680,'Tadlys','Tadlys LTD'),(60498640896,'Southwin','SouthWing S.L.'),(60515418112,'Private',''),(60532195328,'MyaTechn','MyA Technology'),(60548972544,'Logicacm','LogicaCMG Pty Ltd'),(60565749760,'JpsCommu','JPS Communications'),(60582526976,'Iav','IAV GmbH'),(60599304192,'Hach','Hach Company'),(60616081408,'ArionTec','ARION Technology Inc.'),(60632858624,'Qlogic','QLogic Corporation'),(60649635840,'TclNetwo','TCL Networks Equipment Co., Ltd.'),(60666413056,'AccessAm','ACCESS Systems Americas, Inc.'),(60683190272,'MtuFried','MTU Friedrichshafen GmbH'),(60699967488,'Private',''),(60716744704,'Incipien','Incipient, Inc.'),(60733521920,'HuwellTe','Huwell Technology Inc.'),(60750299136,'HannaeTe','Hannae Technology Co., Ltd'),(60767076352,'GincomTe','Gincom Technology Corp.'),(60783853568,'CrereNet','Crere Networks, Inc.'),(60800630784,'DynamicR','Dynamic Ratings P/L'),(60817408000,'ShesterC','Shester Communications Inc'),(60834185216,'Private',''),(60850962432,'SafariTe','Safari Technologies'),(60867739648,'Netcodec','Netcodec co.'),(60884516864,'HyundaiD','Hyundai Digital Technology Co.,L'),(60901294080,'EdimaxTe','Edimax Technology Co., Ltd.'),(60918071296,'RocheDia','Roche Diagnostics GmbH'),(60934848512,'AerasNet','AERAS Networks, Inc.'),(60951625728,'OlympusS','Olympus Soft Imaging Solutions G'),(60968402944,'KontronM','Kontron Medical'),(60985180160,'ShukoEle','Shuko Electronics Co.,Ltd'),(61001957376,'NexgenCi','NexGen City, LP'),(61018734592,'Intel','Intel Corp'),(61035511808,'Heinesys','HEINESYS, Inc.'),(61052289024,'HarmsWen','Harms & Wende GmbH & Co.KG'),(61069066240,'Cisco','CISCO SYSTEMS, INC.'),(61085843456,'Cisco','CISCO SYSTEMS, INC.'),(61102620672,'CirrusLo','Cirrus Logic'),(61119397888,'HawkingT','Hawking Technologies, Inc.'),(61136175104,'Transact','Transact Technologies Inc'),(61152952320,'TelevicN','Televic N.V.'),(61169729536,'SunOptro','Sun Optronics Inc'),(61186506752,'Soronti','Soronti, Inc.'),(61203283968,'NortelNe','Nortel Networks'),(61220061184,'NihonMec','NIHON MECHATRONICS CO.,LTD.'),(61236838400,'MoticInc','Motic Incoporation Ltd.'),(61253615616,'G-TekEle','G-Tek Electronics Sdn. Bhd.'),(61270392832,'Digital5','Digital 5, Inc.'),(61287170048,'BeijingN','Beijing Newtry Electronic Techno'),(61303947264,'NiigataS','Niigata Seimitsu Co.,Ltd.'),(61320724480,'NciSyste','NCI System Co.,Ltd.'),(61337501696,'LipmanTr','Lipman TransAction Solutions'),(61354278912,'ForswayS','Forsway Scandinavia AB'),(61371056128,'Changchu','Changchun Huayu WEBPAD Co.,LTD'),(61387833344,'AtriumCA','atrium c and i'),(61404610560,'Bermai','Bermai Inc.'),(61421387776,'Numesa','Numesa Inc.'),(61438164992,'Waveplus','Waveplus Technology Co., Ltd.'),(61454942208,'Trajet','Trajet GmbH'),(61471719424,'ThomsonT','Thomson Telecom Belgium'),(61488496640,'TecnaEle','tecna elettronica srl'),(61505273856,'Optium','Optium Corporation'),(61522051072,'AvTech','AV TECH CORPORATION'),(61538828288,'Alphacel','AlphaCell Wireless Ltd.'),(61555605504,'Auvitran',''),(61572382720,'4g','4G Systems GmbH & Co. KG'),(61589159936,'IworldNe','Iworld Networking, Inc.'),(61605937152,'Sonos','Sonos, Inc.'),(61622714368,'SagemSa','SAGEM SA'),(61639491584,'Telefiel','TELEFIELD inc.'),(61656268800,'Parkervi','ParkerVision - Direct2Data'),(61673046016,'Motorola','Motorola Mobility, Inc.'),(61689823232,'TriplePl','Triple Play Technologies A/S'),(61706600448,'Raisecom','Raisecom Technology'),(61723377664,'Activ-Ne','activ-net GmbH & Co. KG'),(61740154880,'360sunDi','360SUN Digital Broadband Corpora'),(61756932096,'Microtro','MICROTROL LIMITED'),(61773709312,'NortelNe','Nortel Networks'),(61790486528,'LemkeDia','Lemke Diagnostics GmbH'),(61807263744,'Elphel','Elphel, Inc'),(61824040960,'Transcor','TransCore'),(61840818176,'HitachiA','Hitachi Advanced Digital, Inc.'),(61857595392,'EltisMic','Eltis Microelectronics Ltd.'),(61874372608,'E-TopNet','E-TOP Network Technology Inc.'),(61891149824,'ChinaEle','China Electric Power Research In'),(61907927040,'3com','3Com Ltd'),(61924704256,'JanitzaE','Janitza electronics GmbH'),(61941481472,'DeviceDr','Device Drivers Limited'),(61958258688,'MurataMa','Murata Manufacturing Co., Ltd.'),(61975035904,'Micrelec','MICRELEC  ELECTRONICS S.A'),(61991813120,'IrisBerh','IRIS Corporation Berhad'),(62008590336,'In2Netwo','in2 Networks'),(62025367552,'GemstarT','Gemstar Technology Development L'),(62042144768,'CtsElect','CTS electronics'),(62058921984,'Tpack','Tpack A/S'),(62075699200,'SolarTel','Solar Telecom. Tech'),(62092476416,'NewYorkA','New York Air Brake Corp.'),(62109253632,'GemsocIn','GEMSOC INNOVISION INC.'),(62126030848,'Decru','Decru, Inc.'),(62142808064,'Amtelco',''),(62159585280,'AmpleCom','Ample Communications Inc.'),(62176362496,'GemwonCo','GemWon Communications Co., Ltd.'),(62193139712,'Toshiba',''),(62209916928,'TelevesS','Televes S.A.'),(62226694144,'Electron','Electronics Line 3000 Ltd.'),(62243471360,'IonsignO','ionSign Oy'),(62260248576,'Hewlett-','Hewlett-Packard Company'),(62277025792,'ThomsonT','Thomson Technology Inc'),(62293803008,'Devicesc','Devicescape Software, Inc.'),(62310580224,'Commtech','Commtech Wireless'),(62327357440,'Cisco','CISCO SYSTEMS, INC.'),(62344134656,'Cisco','CISCO SYSTEMS, INC.'),(62360911872,'Catalyst','Catalyst Enterprises, Inc.'),(62377689088,'AlcatelN','Alcatel North America'),(62394466304,'AdpGause','adp Gauselmann GmbH'),(62411243520,'Videotro','VIDEOTRON CORP.'),(62428020736,'Clematic',''),(62444797952,'AvaraTec','Avara Technologies Pty. Ltd.'),(62461575168,'AstarteT','Astarte Technology Co, Ltd.'),(62478352384,'SiemensA','Siemens AG A&D ET'),(62495129600,'InProgre','Systems in Progress Holding GmbH'),(62511906816,'Sparklan','SparkLAN Communications, Inc.'),(62528684032,'Sercomm','Sercomm Corp.'),(62545461248,'Ponico','PONICO CORP.'),(62562238464,'NavicoAu','Navico Auckland Ltd'),(62579015680,'OpenTele','Open Telecom'),(62595792896,'MilÃ©nio3','MilÃ©nio 3 Sistemas ElectrÃ³nico'),(62612570112,'MaasInte','Maas International BV'),(62629347328,'FujiyaDe','Fujiya Denki Seisakusho Co.,Ltd.'),(62646124544,'CubicDef','Cubic Defense Applications, Inc.'),(62662901760,'Ultracke','Ultracker Technology CO., Inc'),(62679678976,'HmeClear','HME Clear-Com LTD.'),(62696456192,'Spectrum','Spectrum Digital, Inc'),(62713233408,'BoeTechn','BOE TECHNOLOGY GROUP CO.,LTD'),(62730010624,'AmbitMic','Ambit Microsystems Corporation'),(62746787840,'Benchmar','Benchmark Electronics'),(62763565056,'TiscaliU','Tiscali UK Ltd'),(62780342272,'Topfield','Topfield Co., Ltd'),(62797119488,'TemicSds','TEMIC SDS GmbH'),(62813896704,'Netklass','NetKlass Technology Inc.'),(62830673920,'FormosaT','Formosa Teletek Corporation'),(62847451136,'Mcafee','McAfee, Inc'),(62864228352,'Cncr-ItH','CNCR-IT CO.,LTD,HangZhou P.R.CHI'),(62881005568,'Certance','Certance Inc.'),(62897782784,'Blip','BLIP Systems'),(62914560000,'AsustekC','ASUSTEK COMPUTER INC.'),(62931337216,'EndaceTe','Endace Technology'),(62948114432,'UnitedTe','United Technologists Europe Limi'),(62964891648,'Shanghai','Shanghai Xun Shi Communications '),(62981668864,'Scalent','Scalent Systems, Inc.'),(62998446080,'Cray','Cray Inc'),(63015223296,'MintronE','MINTRON ENTERPRISE CO., LTD.'),(63032000512,'Metanoia','Metanoia Technologies, Inc.'),(63048777728,'GawellTe','GAWELL TECHNOLOGIES CORP.'),(63065554944,'Castel',''),(63082332160,'Solution','Solutions Radio BV'),(63099109376,'Newcotec','Newcotech,Ltd'),(63115886592,'Micro-Re','Micro-Research Finland Oy'),(63132663808,'Hewlett-','Hewlett-Packard'),(63149441024,'Guangzho','GUANGZHOU GAOKE COMMUNICATIONS T'),(63166218240,'EcastleE','Ecastle Electronics Co., Ltd.'),(63182995456,'Riverbed','Riverbed Technology, Inc.'),(63199772672,'Knovativ','Knovative, Inc.'),(63216549888,'Iiga','Iiga co.,Ltd'),(63233327104,'Hashimot','HASHIMOTO Electronics Industry C'),(63250104320,'HanmiSem','HANMI SEMICONDUCTOR CO., LTD.'),(63266881536,'EverbeeN','Everbee Networks'),(63283658752,'ParagonF','Paragon Fidelity GmbH'),(63300435968,'BurdickA','Burdick, a Quinton Compny'),(63317213184,'B&BElect','B&B Electronics Manufacturing Co'),(63333990400,'Remsdaq','Remsdaq Limited'),(63350767616,'NortelNe','Nortel Networks'),(63367544832,'MynahTec','MYNAH Technologies'),(63384322048,'Lowrance','Lowrance Electronics, Inc.'),(63401099264,'LogicCon','Logic Controls, Inc.'),(63417876480,'IskraTra','Iskra Transmission d.d.'),(63434653696,'DigitalM','Digital Multitools Inc'),(63451430912,'AsixElec','ASIX ELECTRONICS CORP.'),(63468208128,'Motorola','Motorola Korea'),(63484985344,'Zoran','Zoran Corporation'),(63501762560,'YokoTech','YOKO Technology Corp.'),(63518539776,'Wtss','WTSS Inc'),(63535316992,'VinesysT','VineSys Technology'),(63552094208,'TableauL','Tableau, LLC'),(63568871424,'Skov','SKOV A/S'),(63585648640,'SITTISPA','S.I.T.T.I. S.p.A.'),(63602425856,'Profibus','PROFIBUS Nutzerorganisation e.V.'),(63619203072,'Privaris','Privaris, Inc.'),(63635980288,'OsakaMic','Osaka Micro Computer.'),(63652757504,'Filtroni','Filtronic plc'),(63669534720,'Epicente','Epicenter, Inc.'),(63686311936,'CresittI','CRESITT INDUSTRIE'),(63703089152,'Copan','COPAN Systems Inc.'),(63719866368,'Cisco','CISCO SYSTEMS, INC.'),(63736643584,'Cisco','CISCO SYSTEMS, INC.'),(63753420800,'Aktino','Aktino, Inc.'),(63770198016,'Aksys','Aksys, Ltd.'),(63786975232,'C-TechUn','C-TECH UNITED CORP.'),(63803752448,'Xincom','XiNCOM Corp.'),(63820529664,'Tellion','Tellion INC.'),(63837306880,'Shure','SHURE INCORPORATED'),(63854084096,'Remec','REMEC, Inc.'),(63870861312,'PlxTechn','PLX Technology'),(63887638528,'Mcharge',''),(63904415744,'Extremes','ExtremeSpeed Inc.'),(63921192960,'CustomEn','Custom Engineering S.p.A.'),(63937970176,'ChiyuTec','Chiyu Technology Co.,Ltd'),(63954747392,'BoeTechn','BOE TECHNOLOGY GROUP CO.,LTD'),(63971524608,'Bitwalle','bitWallet, Inc.'),(63988301824,'Adimos','Adimos Systems LTD'),(64005079040,'AacElect','AAC ELECTRONICS CORP.'),(64021856256,'Zioncom',''),(64038633472,'WaytechD','WayTech Development, Inc.'),(64055410688,'ShadongL','Shadong Luneng Jicheng Electroni'),(64072187904,'Sandmart','Sandmartin(zhong shan)Electronic'),(64088965120,'Orban',''),(64105742336,'NokiaDan','Nokia Danmark A/S'),(64122519552,'MucoIndu','Muco Industrie BV'),(64139296768,'Private',''),(64156073984,'Festo','Festo AG & Co. KG'),(64172851200,'Ezquest','EZQUEST INC.'),(64189628416,'Infinico','Infinico Corporation'),(64206405632,'Smarthom','Smarthome'),(64223182848,'KasdaDig','Kasda Digital Technology Co.,Ltd'),(64239960064,'IpacTech','iPAC Technology Co., Ltd.'),(64256737280,'E-TenInf','E-TEN Information Systems Co., L'),(64273514496,'VulcanPo','Vulcan Portals Inc'),(64290291712,'SbcAsi','SBC ASI'),(64307068928,'ReaElekt','REA Elektronik GmbH'),(64323846144,'OptowayT','Optoway Technology Incorporation'),(64340623360,'MaceyEnt','Macey Enterprises'),(64357400576,'JtagTech','JTAG Technologies B.V.'),(64374177792,'Fujinon','FUJINON CORPORATION'),(64390955008,'EndrunTe','EndRun Technologies LLC'),(64407732224,'Megasolu','Megasolution,Inc.'),(64424509440,'Legra','Legra Systems, Inc.'),(64441286656,'Digitalk','DIGITALKS INC'),(64458063872,'Digicube','Digicube Technology Co., Ltd'),(64474841088,'Com&C','COM&C CO., LTD'),(64491618304,'Cim-Usa','cim-usa inc'),(64508395520,'3bSystem','3B SYSTEM INC.'),(64525172736,'NortelNe','Nortel Networks'),(64541949952,'Mangrove','Mangrove Systems, Inc.'),(64558727168,'IndagonO','Indagon Oy'),(64575504384,'Private',''),(64592281600,'ClearEdg','Clear Edge Networks'),(64609058816,'KentimaT','Kentima Technologies AB'),(64625836032,'Synchron','SYNCHRONIC ENGINEERING'),(64642613248,'HuntElec','Hunt Electronic Co., Ltd.'),(64659390464,'Wavespli','WaveSplitter Technologies, Inc.'),(64676167680,'RealIdTe','Real ID Technology Co., Ltd.'),(64692944896,'Rdm','RDM Corporation'),(64709722112,'Prodrive','Prodrive B.V.'),(64726499328,'Panasoni','Panasonic Europe Ltd.'),(64743276544,'Nisca','Nisca corporation'),(64760053760,'Mindray','Mindray Co., Ltd.'),(64776830976,'Kjaerulf','Kjaerulff1 A/S'),(64793608192,'JayHowTe','JAY HOW TECHNOLOGY CO.,'),(64810385408,'InstaEle','Insta Elektro GmbH'),(64827162624,'Industri','Industrial Control Systems'),(64843939840,'BostonSc','Boston Scientific'),(64860717056,'GamingSu','Gaming Support B.V.'),(64877494272,'Ego','Ego Systems Inc.'),(64894271488,'Digitall','DigitAll World Co., Ltd'),(64911048704,'CosmoTec','Cosmo Techs Co., Ltd.'),(64927825920,'ChengduK','Chengdu KT Electric Co.of High &'),(64944603136,'DellEsgP','Dell ESG PCBA Test'),(64961380352,'Hewlett-','Hewlett-Packard Company'),(64978157568,'Scientif','Scientific Atlanta, Inc'),(64994934784,'Helius','Helius, Inc.'),(65011712000,'Cisco','CISCO SYSTEMS, INC.'),(65028489216,'Cisco','CISCO SYSTEMS, INC.'),(65045266432,'Aimvalle','AimValley B.V.'),(65062043648,'Worldacc','WorldAccxx  LLC'),(65078820864,'TealElec','TEAL Electronics, Inc.'),(65095598080,'Itronix','Itronix Corporation'),(65112375296,'Augmenti','Augmentix Corporation'),(65129152512,'Cablewar','Cableware Electronics'),(65145929728,'Greenbel','GREENBELL SYSTEMS'),(65162706944,'Uplogix','Uplogix, Inc.'),(65179484160,'Chung-Hs','CHUNG-HSIN ELECTRIC & MACHINERY '),(65196261376,'Megapowe','Megapower International Corp.'),(65213038592,'W-LinxTe','W-LINX TECHNOLOGY CO., LTD.'),(65229815808,'RazaMicr','Raza Microelectronics Inc'),(65246593024,'AlliedVi','Allied Vision Technologies Canad'),(65263370240,'LootomTe','Lootom Telcovideo Network Wuxi C'),(65280147456,'Duali','DUALi Inc.'),(65296924672,'Cisco','CISCO SYSTEMS, INC.'),(65313701888,'Cisco','CISCO SYSTEMS, INC.'),(65330479104,'Accurate','Accurate Techhnologies, Inc.'),(65347256320,'Xambala','Xambala Incorporated'),(65364033536,'Netstar',''),(65380810752,'IrisSens','IRIS SENSORS'),(65397587968,'Hisharp',''),(65414365184,'FujiSyst','Fuji System Machines Co., Ltd.'),(65431142400,'Endeleo','Endeleo Limited'),(65447919616,'D-Link','D-Link Corporation'),(65464696832,'Cardione','CardioNet, Inc'),(65481474048,'BigBearN','Big Bear Networks'),(65498251264,'OpticalI','Optical Internetworking Forum'),(65515028480,'Zipher','Zipher Ltd'),(65531805696,'Xalyo','Xalyo Systems'),(65548582912,'Wasabi','Wasabi Systems Inc.'),(65565360128,'Tivella','Tivella Inc.'),(65582137344,'Stretch','Stretch, Inc.'),(65598914560,'Sinar','SINAR AG'),(65615691776,'Robox','ROBOX SPA'),(65632468992,'Polypix','Polypix Inc.'),(65649246208,'Northove','Northover Solutions Limited'),(65666023424,'Kyushu-K','Kyushu-kyohan co.,ltd'),(65682800640,'Oracle','Oracle Corporation'),(65699577856,'Elextech','Elextech INC'),(65716355072,'Talkswit','TalkSwitch'),(65733132288,'Cellink',''),(65749909504,'CadmusTe','Cadmus Technology Ltd'),(65766686720,'Streamsc','StreamScale Limited'),(65783463936,'Azul','Azul Systems, Inc.'),(65800241152,'YorkRefr','YORK Refrigeration, Marine & Con'),(65817018368,'Solarfla','Solarflare Communications Inc'),(65833795584,'Entrelog','Entrelogic Corporation'),(65850572800,'Datawire','Datawire Communication Networks '),(65867350016,'Continuu','Continuum Photonics Inc'),(65884127232,'Cablelog','CABLELOGIC Co., Ltd.'),(65900904448,'AdderTec','Adder Technology Limited'),(65917681664,'PhonakCo','Phonak Communications AG'),(65934458880,'PeribitN','Peribit Networks'),(65951236096,'DeltaInf','Delta Information Systems, Inc.'),(65968013312,'DayOneDi','Day One Digital Media Limited'),(65984790528,'GenexisB','Genexis BV'),(66001567744,'Veo',''),(66018344960,'NicetyTe','Nicety Technologies Inc. (NTS)'),(66035122176,'Lifetron','Lifetron Co.,Ltd'),(66051899392,'Hewlett-','Hewlett-Packard Company'),(66068676608,'AlcatelB','Alcatel Bell Space N.V.'),(66085453824,'ObzervTe','Obzerv Technologies'),(66102231040,'D&RElect','D&R Electronica Weesp BV'),(66119008256,'Icube','icube Corp.'),(66135785472,'Cisco-Li','Cisco-Linksys'),(66152562688,'WestInst','West Instruments'),(66169339904,'VavicNet','Vavic Network Technology, Inc.'),(66186117120,'SewEurod','SEW Eurodrive GmbH & Co. KG'),(66202894336,'NortelNe','Nortel Networks'),(66219671552,'Gateware','GateWare Communications GmbH'),(66236448768,'Addi-Dat','ADDI-DATA GmbH'),(66253225984,'MidasEng','Midas Engineering'),(66270003200,'Bbox',''),(66286780416,'FtaCommu','FTA Communication Technologies'),(66303557632,'WintecIn','Wintec Industries, inc.'),(66320334848,'SanmeiEl','Sanmei Electronics Co.,Ltd'),(66337112064,'Sandburs','Sandburst'),(66353889280,'RsAutoma','RS Automation Co., Ltd'),(66370666496,'QamcomTe','Qamcom Technology AB'),(66387443712,'FirstSil','First Silicon Solutions'),(66404220928,'DigitalK','Digital Keystone, Inc.'),(66420998144,'Dentum','DENTUM CO.,LTD'),(66437775360,'Datacap','Datacap Systems Inc'),(66454552576,'Bluetoot','Bluetooth Interest Group Inc.'),(66471329792,'BeijingN','BeiJing NuQX Technology CO.,LTD'),(66488107008,'ArceSist','Arce Sistemas, S.A.'),(66504884224,'Acti','ACTi Corporation'),(66521661440,'Xirrus',''),(66538438656,'AblerexE','Ablerex Electronics Co., LTD'),(66555215872,'Ubstorag','UBSTORAGE Co.,Ltd.'),(66571993088,'TrinityS','Trinity Security Systems,Inc.'),(66588770304,'PalPacif','PAL Pacific Inc.'),(66605547520,'MortaraI','Mortara Instrument, Inc.'),(66622324736,'Brainium','Brainium Technologies Inc.'),(66639101952,'AstuteNe','Astute Networks, Inc.'),(66655879168,'Addo-Jap','ADDO-Japan Corporation'),(66672656384,'Research','Research In Motion Limited'),(66689433600,'MaxcessI','Maxcess International'),(66706210816,'Ametek','AMETEK, Inc.'),(66722988032,'Winnerte','Winnertec System Co., Ltd.'),(66739765248,'Wideview',''),(66756542464,'OrionMul','Orion MultiSystems Inc'),(66773319680,'Gigawave','Gigawavetech Pte Ltd'),(66790096896,'FastTv-S','FAST TV-Server AG'),(66806874112,'Dongyang','DONGYANG TELECOM CO.,LTD.'),(66823651328,'Cisco','CISCO SYSTEMS, INC.'),(66840428544,'Cisco','CISCO SYSTEMS, INC.'),(66857205760,'Aerotele','Aerotelecom Co.,Ltd.'),(66873982976,'Microhar','Microhard Systems Inc.'),(66890760192,'Landis+G','Landis+Gyr Ltd.'),(66907537408,'GenexisB','Genexis BV'),(66924314624,'ElecomLa','ELECOM Co.,LTD Laneed Division'),(66941091840,'Telco','Telco Systems, Inc.'),(66957869056,'Avanex','Avanex Corporation'),(66974646272,'Avamax','Avamax Co. Ltd.'),(66991423488,'ApacOpto','APAC opto Electronics Inc.'),(67008200704,'Synchron','Synchrony, Inc.'),(67024977920,'RossVide','Ross Video Limited'),(67041755136,'Panduit','Panduit Corp'),(67058532352,'Displayl','DisplayLink (UK) Ltd'),(67075309568,'Murrelek','Murrelektronik GmbH'),(67092086784,'Motorola','Motorola Mobility, Inc.'),(67108864000,'CanonKor','CANON KOREA BUSINESS SOLUTIONS I'),(67125641216,'Gigabit','Gigabit Systems Inc.'),(67142418432,'2xwirele','2xWireless'),(67159195648,'AlphaNet','Alpha Networks Inc.'),(67175972864,'Sprecher','Sprecher Automation GmbH'),(67192750080,'BwaTechn','BWA Technology GmbH'),(67209527296,'S2Securi','S2 Security Corporation'),(67226304512,'RaptorNe','Raptor Networks Technology'),(67243081728,'Photomet','Photometrics, Inc.'),(67259858944,'PcFabrik','PC Fabrik'),(67276636160,'NexusTec','Nexus Technologies'),(67293413376,'KyushuEl','Kyushu Electronics Systems Inc.'),(67310190592,'Ieee8021','IEEE 802.11'),(67326967808,'FmnCommu','FMN communications GmbH'),(67343745024,'E2oCommu','E2O Communications'),(67360522240,'Dialog','Dialog Inc.'),(67377299456,'CompalEl','Compal Electronics,INC.'),(67394076672,'Cognio','Cognio Inc.'),(67410853888,'Broadban','Broadband Pacenet (India) Pvt. L'),(67427631104,'Actionte','Actiontec Electronics, Inc'),(67444408320,'Timespac','Timespace Technology'),(67461185536,'Netgear','NETGEAR Inc'),(67477962752,'Europlex','Europlex Technologies'),(67494739968,'CaviumNe','Cavium Networks'),(67511517184,'Callurl','CallURL Inc.'),(67528294400,'Adaptive','Adaptive Instruments'),(67545071616,'Tevebox','Tevebox AB'),(67561848832,'NokiaSie','Nokia Siemens Networks GmbH & Co'),(67578626048,'OnkeyTec','Onkey Technologies, Inc.'),(67595403264,'MrvCommu','MRV Communications (Networks) LT'),(67612180480,'E-W/You','e-w/you Inc.'),(67628957696,'DgtSpZOO','DGT Sp. z o.o.'),(67645734912,'Delcomp',''),(67662512128,'Wave','WAVE Corporation'),(67679289344,'Uniwell','Uniwell Corporation'),(67696066560,'Palmpalm','PalmPalm Technology, Inc.'),(67712843776,'Nst','NST co.,LTD.'),(67729620992,'Keymed','KeyMed Ltd'),(67746398208,'EurocomI','Eurocom Industries A/S'),(67763175424,'DionicaR','Dionica R&D Ltd.'),(67779952640,'ChantryN','Chantry Networks'),(67796729856,'Allnet','Allnet GmbH'),(67813507072,'A-JinTec','A-JIN TECHLINE CO, LTD'),(67830284288,'3com','3Com Ltd'),(67847061504,'Netopia','Netopia, Inc.'),(67863838720,'NortelNe','Nortel Networks'),(67880615936,'KikusuiE','Kikusui Electronics Corp.'),(67897393152,'Datawind','Datawind Research'),(67914170368,'Astri',''),(67930947584,'AppliedW','Applied Wireless Identifications'),(67947724800,'EwaTechn','EWA Technologies, Inc.'),(67964502016,'Digium',''),(67981279232,'Soundcra','Soundcraft'),(67998056448,'Schwecha','Schwechat - RISE'),(68014833664,'Sarotech','Sarotech Co., Ltd'),(68031610880,'HarmanMu','Harman Music Group'),(68048388096,'Force','Force, Inc.'),(68065165312,'FlexdslT','FlexDSL Telecommunications AG'),(68081942528,'Yazaki','YAZAKI CORPORATION'),(68098719744,'WestellT','Westell Technologies'),(68115496960,'UedaJapa','Ueda Japan  Radio Co., Ltd.'),(68132274176,'Sordin','SORDIN AB'),(68149051392,'SonyEric','Sony Ericsson Mobile Communicati'),(68165828608,'SolomonT','SOLOMON Technology Corp.'),(68182605824,'Ncomputi','NComputing Co.,Ltd.'),(68199383040,'IdDigita','ID DIGITAL CORPORATION'),(68216160256,'Hangzhou','Hangzhou H3C Technologies Co., L'),(68232937472,'DammCell','Damm Cellular Systems A/S'),(68249714688,'Pantech','Pantech Co.,Ltd'),(68266491904,'MercuryS','MERCURY SECURITY CORPORATION'),(68283269120,'Mbtech','MBTech Systems, Inc.'),(68300046336,'LutronEl','Lutron Electronics Co., Inc.'),(68316823552,'Lobos','Lobos, Inc.'),(68333600768,'GwTechno','GW TECHNOLOGIES CO.,LTD.'),(68350377984,'Giga-Byt','Giga-Byte Technology Co.,LTD.'),(68367155200,'CylonCon','Cylon Controls'),(68383932416,'Arkus','ARKUS Inc.'),(68400709632,'AnamElec','Anam Electronics Co., Ltd'),(68417486848,'Xtec','XTec, Incorporated'),(68434264064,'ThalesE-','Thales e-Transactions GmbH'),(68451041280,'Sunray','Sunray Co. Ltd.'),(68467818496,'Nex-GPte','nex-G Systems Pte.Ltd'),(68484595712,'LoudTech','Loud Technologies Inc.'),(68501372928,'JungMyou','Jung Myoung Communications&Techn'),(68518150144,'Gunterma','Guntermann & Drunck GmbH'),(68534927360,'Gn&S','GN&S company'),(68551704576,'DarfonEl','Darfon Electronics Corp.'),(68568481792,'Cisco','CISCO SYSTEMS, INC.'),(68585259008,'Cisco','CISCO SYSTEMS, INC.'),(68602036224,'Valcrete','Valcretec, Inc.'),(68618813440,'Optinel','Optinel Systems, Inc.'),(68635590656,'NipponDe','Nippon Denso Industry Co., Ltd.'),(68652367872,'MeritLi-','Merit Li-Lin Ent.'),(68669145088,'Glorytek','Glorytek Network Inc.'),(68685922304,'G-ProCom','G-PRO COMPUTER'),(68702699520,'Control4',''),(68719476736,'CableTel','CABLE TELEVISION LABORATORIES, I'),(68736253952,'Citel',''),(68753031168,'Actia',''),(68769808384,'Imatron','IMATRON, INC.'),(68786585600,'Brantley','THE BRANTLEY COILE COMPANY,INC'),(68803362816,'UecComme','UEC COMMERCIAL'),(68820140032,'ThalesCo','Thales Contact Solutions Ltd.'),(68836917248,'Cisco','CISCO SYSTEMS, INC.'),(68853694464,'Vienna','VIENNA SYSTEMS CORPORATION'),(68870471680,'HoroQuar','HORO QUARTZ'),(68887248896,'Williams','WILLIAMS COMMUNICATIONS GROUP'),(68904026112,'Cisco','CISCO SYSTEMS, INC.'),(68920803328,'Ito','ITO CO., LTD.'),(68937580544,'Cisco','CISCO SYSTEMS, INC.'),(68954357760,'MicroLin','MICRO LINEAR COPORATION'),(68971134976,'Industri','INDUSTRIAL CPU SYSTEMS'),(68987912192,'Initio','INITIO CORPORATION'),(69004689408,'Cisco','CISCO SYSTEMS, INC.'),(69021466624,'Processo','PROCESSOR SYSTEMS (I) PVT LTD'),(69038243840,'KontronA','Kontron America, Inc.'),(69055021056,'Cisco','CISCO SYSTEMS, INC.'),(69071798272,'Oomon','OOmon Inc.'),(69088575488,'TSqware','T.SQWARE'),(69105352704,'BoschAcc','Bosch Access Systems GmbH'),(69122129920,'Broadcom','BROADCOM CORPORATION'),(69138907136,'SironaDe','SIRONA DENTAL SYSTEMS GmbH & Co.'),(69155684352,'Picturet','PictureTel Corp.'),(69172461568,'CornetTe','CORNET TECHNOLOGY, INC.'),(69189238784,'OhmTechn','OHM TECHNOLOGIES INTL, LLC'),(69206016000,'WinbondE','WINBOND ELECTRONICS CORP.'),(69222793216,'Matsushi','MATSUSHITA ELECTRONIC INSTRUMENT'),(69239570432,'Cisco','CISCO SYSTEMS, INC.'),(69256347648,'HandHeld','Hand Held Products Inc'),(69273124864,'EncantoN','ENCANTO NETWORKS, INC.'),(69289902080,'SatcomMe','SatCom Media Corporation'),(69306679296,'NetworkE','Network Equipment Technologies'),(69323456512,'NagoyaEl','NAGOYA ELECTRIC WORKS CO., LTD'),(69340233728,'Grayhill','Grayhill, Inc'),(69357010944,'Accelera','ACCELERATED NETWORKS, INC.'),(69373788160,'L-3Commu','L-3 COMMUNICATIONS EAST'),(69390565376,'Computer','COMPUTER TECHNICA, INC.'),(69407342592,'Cisco','CISCO SYSTEMS, INC.'),(69424119808,'ZfMicros','ZF MICROSYSTEMS, INC.'),(69440897024,'UmaxData','UMAX DATA SYSTEMS, INC.'),(69457674240,'LasatNet','Lasat Networks A/S'),(69474451456,'HitachiS','HITACHI SOFTWARE ENGINEERING'),(69491228672,'NetworkT','NETWORK SYSTEMS & TECHNOLOGIES P'),(69508005888,'Cisco','CISCO SYSTEMS, INC.'),(69524783104,'Eion','EION Inc.'),(69541560320,'Objectiv','OBJECTIVE COMMUNICATIONS, INC.'),(69558337536,'AltaTech','ALTA TECHNOLOGY'),(69575114752,'Accessla','ACCESSLAN COMMUNICATIONS, INC.'),(69591891968,'GnpCompu','GNP Computers'),(69608669184,'Elitegro','ELITEGROUP COMPUTER SYSTEMS CO.,'),(69625446400,'Inter-Te','INTER-TEL INTEGRATED SYSTEMS'),(69642223616,'CyqVeTec','CYQ`ve Technology Co., Ltd.'),(69659000832,'MicroRes','MICRO RESEARCH INSTITUTE, INC.'),(69675778048,'Vectron','Vectron Systems AG'),(69692555264,'DiamondN','DIAMOND NETWORK TECH'),(69709332480,'HippiNet','HIPPI NETWORKING FORUM'),(69726109696,'IcEnsemb','IC ENSEMBLE, INC.'),(69742886912,'Phasecom','PHASECOM, LTD.'),(69759664128,'Netschoo','NETSCHOOLS CORPORATION'),(69776441344,'Tollgrad','TOLLGRADE COMMUNICATIONS, INC.'),(69793218560,'Intermec','INTERMEC CORPORATION'),(69809995776,'BristolB','BRISTOL BABCOCK, INC.'),(69826772992,'Alacrite','Alacritech, Inc.'),(69843550208,'A2','A2 CORPORATION'),(69860327424,'Innolabs','InnoLabs Corporation'),(69877104640,'NortelNe','Nortel Networks'),(69893881856,'AlcornMc','ALCORN MCBRIDE INC.'),(69910659072,'EchoElet','ECHO ELETRIC CO. LTD.'),(69927436288,'HtrcAuto','HTRC AUTOMATION, INC.'),(69944213504,'Shoretel','ShoreTel, Inc'),(69960990720,'Parvus','The Parvus Corporation'),(69977767936,'3com','3COM CORPORATION'),(69994545152,'Teledyne','Teledyne LeCroy, Inc'),(70011322368,'SurtecIn','SURTEC INDUSTRIES, INC.'),(70028099584,'Ceologic',''),(70044876800,'Oracle','Oracle Corporation'),(70061654016,'Rion','RION CO., LTD.'),(70078431232,'Cmicro','CMICRO CORPORATION'),(70095208448,'Mettler-','METTLER-TOLEDO (ALBSTADT) GMBH'),(70111985664,'Computer','COMPUTER TECHNOLOGY CORP.'),(70128762880,'Cisco','CISCO SYSTEMS, INC.'),(70145540096,'FujitsuM','FUJITSU MICROELECTRONICS, INC.'),(70162317312,'Sodick','SODICK CO., LTD.'),(70179094528,'RebelCom','Rebel.com, Inc.'),(70195871744,'Arrowpoi','ArrowPoint Communications'),(70212648960,'DiabloRe','DIABLO RESEARCH CO. LLC'),(70229426176,'3com','3COM CORPORATION'),(70246203392,'NetInsig','NET INSIGHT AB'),(70262980608,'QuantumD','QUANTUM DESIGNS (H.K.) LTD.'),(70279757824,'DraegerM','Draeger Medical'),(70296535040,'Hekimian','HEKIMIAN LABORATORIES, INC.'),(70313312256,'ZodiacDa','ZODIAC DATA SYSTEMS'),(70330089472,'Billiont','BILLIONTON SYSTEMS, INC.'),(70346866688,'Hostlink','HOSTLINK CORP.'),(70363643904,'NxServer','NX SERVER, ILNC.'),(70380421120,'Starguid','STARGUIDE DIGITAL NETWORKS'),(70397198336,'DnpgLlc','DNPG, LLC'),(70413975552,'Radyne','RADYNE CORPORATION'),(70430752768,'Advanced','ADVANCED CONTROL SYSTEMS, INC.'),(70447529984,'Ericsson',''),(70464307200,'ComosTel','COMOS TELECOM'),(70481084416,'HeliossC','HELIOSS COMMUNICATIONS, INC.'),(70497861632,'DigitalM','DIGITAL MICROWAVE CORPORATION'),(70514638848,'SonusNet','SONUS NETWORKS, INC.'),(70531416064,'Ednt','EDNT GmbH'),(70548193280,'Axxceler','Axxcelera Broadband Wireless'),(70564970496,'TadiranC','TADIRAN COM. LTD.'),(70581747712,'TrentonT','TRENTON TECHNOLOGY INC.'),(70598524928,'CaradonT','CARADON TREND LTD.'),(70615302144,'Advanet','ADVANET INC.'),(70632079360,'GvnTechn','GVN TECHNOLOGIES, INC.'),(70648856576,'Technobo','Technobox, Inc.'),(70665633792,'AtenInte','ATEN INTERNATIONAL CO., LTD.'),(70682411008,'Maxtor','Maxtor Corporation'),(70699188224,'Eurem','EUREM GmbH'),(70715965440,'SafDrive','SAF DRIVE SYSTEMS, LTD.'),(70732742656,'NueraCom','NUERA COMMUNICATIONS, INC.'),(70749519872,'Cisco','CISCO SYSTEMS, INC.'),(70766297088,'Ambicom','AmbiCom, Inc.'),(70783074304,'Cisco','CISCO SYSTEMS, INC.'),(70799851520,'P-Com','P-COM, INC.'),(70816628736,'AuroraCo','AURORA COMMUNICATIONS, LTD.'),(70833405952,'Bachmann','BACHMANN ELECTRONIC GmbH'),(70850183168,'Crestron','CRESTRON ELECTRONICS, INC.'),(70866960384,'Metawave','METAWAVE COMMUNICATIONS'),(70883737600,'Dps','DPS, INC.'),(70900514816,'JnaTelec','JNA TELECOMMUNICATIONS LIMITED'),(70917292032,'Hewlett-','HEWLETT-PACKARD COMPANY'),(70934069248,'K-BotCom','K-BOT COMMUNICATIONS'),(70950846464,'PolarisC','POLARIS COMMUNICATIONS, INC.'),(70967623680,'AttoTech','ATTO Technology, Inc.'),(70984400896,'Xstreami','Xstreamis PLC'),(71001178112,'American','AMERICAN NETWORKS INC.'),(71017955328,'Websonic',''),(71034732544,'Teralogi','TeraLogic, Inc.'),(71051509760,'Laserani','LASERANIMATION SOLLINGER GmbH'),(71068286976,'FujitsuT','FUJITSU TELECOMMUNICATIONS EUROP'),(71085064192,'JohnsonC','Johnson Controls, Inc.'),(71101841408,'HughSymo','HUGH SYMONS CONCEPT Technologies'),(71118618624,'Raptor','RAPTOR SYSTEMS'),(71135395840,'Cimetric','CIMETRICS, INC.'),(71152173056,'NoWiresN','NO WIRES NEEDED BV'),(71168950272,'Netcore','NETCORE INC.'),(71185727488,'CmsCompu','CMS COMPUTERS, LTD.'),(71202504704,'Performa','Performance Analysis Broadband, '),(71219281920,'Thomson','Thomson Inc.'),(71236059136,'Tracewel','TRACEWELL SYSTEMS, INC.'),(71252836352,'WinnetMe','WinNet Metropolitan Communicatio'),(71269613568,'StarnetT','STARNET TECHNOLOGIES, INC.'),(71286390784,'Innomedi','InnoMedia, Inc.'),(71303168000,'Netline',''),(71319945216,'Emulex','Emulex Corporation'),(71336722432,'M-System','M-SYSTEM CO., LTD.'),(71353499648,'Clarinet','CLARINET SYSTEMS, INC.'),(71370276864,'Aware','AWARE, INC.'),(71387054080,'Pavo','PAVO, INC.'),(71403831296,'InnovexT','INNOVEX TECHNOLOGIES, INC.'),(71420608512,'KendinSe','KENDIN SEMICONDUCTOR, INC.'),(71437385728,'Tns',''),(71454162944,'Omnitron','OMNITRONIX, INC.'),(71470940160,'Xircom',''),(71487717376,'OxfordIn','OXFORD INSTRUMENTS'),(71504494592,'Cisco','CISCO SYSTEMS, INC.'),(71521271808,'UnexTech','UNEX TECHNOLOGY CORPORATION'),(71538049024,'Reliance','RELIANCE COMPUTER CORP.'),(71554826240,'AdhocTec','ADHOC TECHNOLOGIES'),(71571603456,'Media4','MEDIA4, INC.'),(71588380672,'KoitoEle','KOITO ELECTRIC INDUSTRIES, LTD.'),(71605157888,'ImciTech','IMCI TECHNOLOGIES'),(71621935104,'Softroni','SOFTRONICS USB, INC.'),(71638712320,'ShinkoEl','SHINKO ELECTRIC INDUSTRIES CO.'),(71655489536,'Tac','TAC SYSTEMS, INC.'),(71672266752,'Meridian','MERIDIAN TECHNOLOGY CORP.'),(71689043968,'For-A','FOR-A CO., LTD.'),(71705821184,'Coactive','COACTIVE AESTHETICS'),(71722598400,'NokiaMul','NOKIA MULTIMEDIA TERMINALS'),(71739375616,'Atmosphe','ATMOSPHERE NETWORKS'),(71756152832,'AcctonTe','ACCTON TECHNOLOGY CORPORATION'),(71772930048,'EntrataC','ENTRATA COMMUNICATIONS CORP.'),(71789707264,'CoyoteTe','COYOTE TECHNOLOGIES, LLC'),(71806484480,'Ishigaki','ISHIGAKI COMPUTER SYSTEM CO.'),(71823261696,'Maxtor','MAXTOR CORP.'),(71840038912,'Martinho','MARTINHO-DAVIS SYSTEMS, INC.'),(71856816128,'DataInfo','DATA & INFORMATION TECHNOLOGY'),(71873593344,'AastraTe','Aastra Telecom'),(71890370560,'Telecomm','THE TELECOMMUNICATION TECHNOLOGY'),(71907147776,'MarchNet','MARCH NETWORKS CORPORATION'),(71923924992,'Interair','InterAir Wireless'),(71940702208,'Arma','ARMA, Inc.'),(71957479424,'OiElectr','OI ELECTRIC CO., LTD.'),(71974256640,'Willnet','WILLNET, INC.'),(71991033856,'Csi-Cont','CSI-CONTROL SYSTEMS'),(72007811072,'MediaLin','MEDIA LINKS CO., LTD.'),(72024588288,'Protocol','PROTOCOL TECHNOLOGIES, INC.'),(72041365504,'Universa','Universal Global Scientific Indu'),(72058142720,'DataTran','DATA TRANSMISSION NETWORK'),(72074919936,'Communic','COMMUNICATIONS ELECTRONICS SECUR'),(72091697152,'Mitsubis','MITSUBISHI ELECTRONICS LOGISTIC '),(72108474368,'Telco','Telco Systems, Inc.'),(72125251584,'FacitKK','FACIT K.K.'),(72142028800,'ClpCompu','CLP COMPUTER LOGISTIK PLANUNG Gm'),(72158806016,'Interfac','INTERFACE CONCEPT'),(72175583232,'Volamp','VOLAMP, LTD.'),(72192360448,'Fiberlan','FIBERLANE COMMUNICATIONS'),(72209137664,'Witcom','WITCOM, LTD.'),(72225914880,'TopLayer','Top Layer Networks, Inc.'),(72242692096,'NittoTsu','NITTO TSUSHINKI CO., LTD'),(72259469312,'GripsEle','GRIPS ELECTRONIC GMBH'),(72276246528,'StorageC','STORAGE COMPUTER CORPORATION'),(72293023744,'ImasdeCa','IMASDE CANARIAS, S.A.'),(72309800960,'Itt-A/Cd','ITT - A/CD'),(72326578176,'ArgosyRe','ARGOSY RESEARCH INC.'),(72343355392,'Calista',''),(72360132608,'IbmJapan','IBM JAPAN, FUJISAWA MT+D'),(72376909824,'Kollmorg','Kollmorgen Corp'),(72393687040,'Netscreen','Now part of Juniper Networks'),(72410464256,'Micro-St','MICRO-STAR INTERNATIONAL CO., LT'),(72427241472,'EnableSe','ENABLE SEMICONDUCTOR, INC.'),(72444018688,'Internat','INTERNATIONAL DATACASTING CORPOR'),(72460795904,'RiseComp','RISE COMPUTER INC.'),(72477573120,'Oracle','Oracle Corporation'),(72494350336,'SITech','S.I. TECH, INC.'),(72511127552,'Arraycom','ArrayComm, Inc.'),(72527904768,'Hewlett-','Hewlett-Packard Company'),(72544681984,'Nsi','NSI CORPORATION'),(72561459200,'Solectro','SOLECTRON TEXAS'),(72578236416,'AppliedI','APPLIED INTELLIGENT SYSTEMS, INC'),(72595013632,'Breezeco','BreezeCom'),(72611790848,'Telocity','TELOCITY, INCORPORATED'),(72628568064,'Raidtec','RAIDTEC LTD.'),(72645345280,'AdeptTec','ADEPT TECHNOLOGY'),(72662122496,'Selsius','SELSIUS SYSTEMS, INC.'),(72678899712,'RpcgLlc','RPCG, LLC'),(72695676928,'Sundance','SUNDANCE TECHNOLOGY, INC.'),(72712454144,'CtiProdu','CTI PRODUCTS, INC.'),(72729231360,'Dbtel','DBTEL INCORPORATED'),(72762785792,'I-O','I-O CORPORATION'),(72779563008,'Antec',''),(72796340224,'NexcomIn','Nexcom International Co., Ltd.'),(72813117440,'Vertical','Vertical Communications'),(72829894656,'Amherst','AMHERST SYSTEMS, INC.'),(72846671872,'Cisco','CISCO SYSTEMS, INC.'),(72863449088,'IriichiT','IRIICHI TECHNOLOGIES Inc.'),(72880226304,'TexioTec','TEXIO TECHNOLOGY CORPORATION'),(72897003520,'Unique','UNIQUE SYSTEMS, INC.'),(72913780736,'Apple','Apple, Inc'),(72930557952,'ZidaTech','ZIDA TECHNOLOGIES LIMITED'),(72947335168,'Broadban','BROADBAND NETWORKS, INC.'),(72964112384,'Cocom','COCOM A/S'),(72980889600,'DigitalE','DIGITAL EQUIPMENT CORPORATION'),(72997666816,'Cisco','CISCO SYSTEMS, INC.'),(73014444032,'Schneide','Schneider Electric'),(73031221248,'CetTechn','CET Technologies Pte Ltd'),(73047998464,'AuroraMu','Aurora Multimedia Corp.'),(73064775680,'Kawamura','kawamura electric inc.'),(73081552896,'Telexy',''),(73098330112,'SunplusT','Sunplus Technology Co., Ltd.'),(73115107328,'SiemensN','Siemens NV (Belgium)'),(73131884544,'RgbNetwo','RGB Networks Inc.'),(73148661760,'OrbitalD','Orbital Data Corporation'),(73165438976,'Micro-St','Micro-Star International'),(73182216192,'Hewlett-','Hewlett-Packard Company'),(73198993408,'Franklin','Franklin Technology Systems'),(73215770624,'AtmarkTe','Atmark Techno, Inc.'),(73232547840,'Sanblaze','SANBlaze Technology, Inc.'),(73249325056,'Tsurusak','Tsurusaki Sealand Transportation'),(73266102272,'Netplat','netplat,Inc.'),(73282879488,'MaxannaT','Maxanna Technology Co., Ltd.'),(73299656704,'Intel','Intel Corporation'),(73316433920,'Honeywel','Honeywell CMSS'),(73333211136,'Fraunhof','Fraunhofer FOKUS'),(73349988352,'Everfocu','EverFocus Electronics Corp.'),(73366765568,'EpinTech','EPIN Technologies, Inc.'),(73383542784,'CoteauVe','COTEAU VERT CO., LTD.'),(73400320000,'Cesnet',''),(73417097216,'BlxIcDes','BLX IC Design Corp., Ltd.'),(73433874432,'Solteras','Solteras, Inc.'),(73450651648,'Motorola','Motorola Mobility, Inc.'),(73467428864,'TargaDiv','Targa Systems Div L-3 Communicat'),(73484206080,'PleoraTe','Pleora Technologies Inc.'),(73500983296,'Hectrix','Hectrix Limited'),(73517760512,'EpsgEthe','EPSG (Ethernet Powerlink Standar'),(73534537728,'DoremiLa','Doremi Labs, Inc.'),(73551314944,'Cisco','CISCO SYSTEMS, INC.'),(73568092160,'Cisco','CISCO SYSTEMS, INC.'),(73584869376,'Cimsys','CIMSYS Inc'),(73601646592,'Appointe','Appointech, Inc.'),(73618423808,'AppleCom','Apple Computer'),(73635201024,'Ibm','IBM Corp'),(73651978240,'Venstar','Venstar Inc.'),(73668755456,'Tasi','TASI, Inc'),(73685532672,'Streamit',''),(73702309888,'Paradise','Paradise Datacom Ltd.'),(73719087104,'NikoNv','Niko NV'),(73735864320,'Netmodul','NetModule AG'),(73752641536,'Izt','IZT GmbH'),(73769418752,'Ipulse','iPulse Systems'),(73786195968,'Ceicom',''),(73802973184,'AsustekC','ASUSTek Computer Inc.'),(73819750400,'AlliedTe','Allied Telesis (Hong Kong) Ltd.'),(73836527616,'Unatech','UNATECH. CO.,LTD'),(73853304832,'Synology','Synology Incorporated'),(73870082048,'SiemensA','Siemens Austria SIMEA'),(73886859264,'Mediacel','MediaCell, Inc.'),(73903636480,'Grandeye','Grandeye Ltd'),(73920413696,'Goodrich','Goodrich Sensor Systems'),(73937190912,'AichiEle','AICHI ELECTRIC CO., LTD.'),(73953968128,'Taishin','TAISHIN CO., LTD.'),(73970745344,'StoeberA','STOEBER ANTRIEBSTECHNIK GmbH + C'),(73987522560,'Shinbora','SHINBORAM'),(74004299776,'Micronet','Micronet Communications Inc.'),(74021076992,'Micronas','Micronas GmbH'),(74037854208,'KnSoltec','KN SOLTEC CO.,LTD.'),(74054631424,'Jl','JL Corporation'),(74071408640,'AlcatelD','Alcatel DI'),(74088185856,'Nanometr','Nanometrics Inc.'),(74104963072,'Goodman','GoodMan Corporation'),(74121740288,'E-Smartc','e-SMARTCOM  INC.'),(74138517504,'DellEsgP','Dell ESG PCBA Test'),(74155294720,'Assuranc','Assurance Technology Corp'),(74172071936,'Valuepoi','ValuePoint Networks'),(74188849152,'Telecard','Telecard-Pribor Ltd'),(74205626368,'Secom-In','Secom-Industry co.LTD.'),(74222403584,'ProlonCo','Prolon Control Systems'),(74239180800,'Proliphi','Proliphix Inc.'),(74255958016,'KayabaIn','KAYABA INDUSTRY Co,.Ltd.'),(74272735232,'Francoty','Francotyp-Postalia GmbH'),(74289512448,'Caffeina','caffeina applied research ltd.'),(74306289664,'AtsumiEl','Atsumi Electric Co.,LTD.'),(74323066880,'690885On','690885 Ontario Inc.'),(74339844096,'UsDigita','US Digital Television, Inc'),(74356621312,'Belkin','Belkin Corporation'),(74373398528,'Mykotron','Mykotronx'),(74390175744,'Eidsvoll','Eidsvoll Electronics AS'),(74406952960,'TridentT','Trident Tek, Inc.'),(74423730176,'WebproTe','Webpro Technologies Inc.'),(74440507392,'Sevis','Sevis Systems'),(74457284608,'PharosNz','Pharos Systems NZ'),(74474061824,'OfNetwor','OF Networks Co., Ltd.'),(74490839040,'NortelNe','Nortel Networks'),(74507616256,'MatisseN','MATISSE NETWORKS INC'),(74524393472,'IvoclarV','Ivoclar Vivadent AG'),(74541170688,'Elitegro','Elitegroup Computer System Co. ('),(74557947904,'Cisco','CISCO SYSTEMS, INC.'),(74574725120,'Cisco','CISCO SYSTEMS, INC.'),(74591502336,'Prominen','ProMinent Dosiertechnik GmbH'),(74608279552,'ItxSecur','ITX Security Co., Ltd.'),(74625056768,'Artdio','ARTDIO Company Co., LTD'),(74641833984,'Netstrea','NetStreams, LLC'),(74658611200,'StarMicr','STAR MICRONICS CO.,LTD.'),(74675388416,'SystemDe','SYSTEM SPA DEPT. ELECTRONICS'),(74692165632,'AcardTec','ACARD Technology Corp.'),(74708942848,'ZnyxNetw','Znyx Networks'),(74725720064,'TaelimEl','Taelim Electronics Co., Ltd.'),(74742497280,'Integrat','Integrated System Solution Corp.'),(74759274496,'Homelogi','HomeLogic LLC'),(74776051712,'EmsSatco','EMS Satcom'),(74792828928,'Domo','Domo Ltd'),(74809606144,'DigitalD','Digital Data Communications Asia'),(74826383360,'NanwangM','Nanwang Multimedia Inc.,Ltd'),(74843160576,'American','American Time and Signal'),(74859937792,'Peplink','PePLink Ltd.'),(74876715008,'Netforyo','Netforyou Co., LTD.'),(74893492224,'GscSrl','GSC SRL'),(74910269440,'DexterCo','DEXTER Communications, Inc.'),(74927046656,'Cotron','COTRON CORPORATION'),(74943823872,'SmartSto','SMART Storage Systems'),(74960601088,'WibhuTec','Wibhu Technologies, Inc.'),(74977378304,'Pathscal','PathScale, Inc.'),(74994155520,'Intellam','Intellambda Systems, Inc.'),(75010932736,'CoaxialN','Coaxial Networks, Inc.'),(75027709952,'ChironTe','Chiron Technology Ltd'),(75044487168,'Singular','Singular Technology Co. Ltd.'),(75061264384,'SingimIn','Singim International Corp.'),(75078041600,'BÃ¼chiLab','BÃ¼chi  Labortechnik AG'),(75094818816,'E-ZyNet','e-zy.net'),(75111596032,'ZmdAmeri','ZMD America, Inc.'),(75128373248,'ProgenyA','Progeny, A division of Midmark C'),(75145150464,'NeotuneI','Neotune Information Technology C'),(75161927680,'Motorola','Motorola Mobility, Inc.'),(75178704896,'Interene','InterEnergy Co.Ltd,'),(75195482112,'ImiNorgr','IMI Norgren Ltd'),(75212259328,'Datalogi','Datalogic ADC, Inc.'),(75229036544,'HumoLabo','Humo Laboratory,Ltd.'),(75245813760,'Hewlett-','Hewlett-Packard Company'),(75262590976,'Prime','Prime Systems, Inc.'),(75279368192,'Category','Category Solutions, Inc'),(75296145408,'Enterasy','Enterasys'),(75312922624,'Aerotech','Aerotech Inc'),(75329699840,'Viewtran','Viewtran Technology Limited'),(75346477056,'Alcatel-','Alcatel-Lucent, Enterprise Busin'),(75363254272,'Missouri','Missouri Department of Transport'),(75380031488,'Hanchang','Hanchang System Corp.'),(75396808704,'Halytech','Halytech Mace'),(75413585920,'EutechIn','EUTECH INSTRUMENTS PTE. LTD.'),(75430363136,'DigitalD','Digital Design Corporation'),(75447140352,'Cts-Clim','CTS-Clima Temperatur Systeme Gmb'),(75463917568,'Cisco','CISCO SYSTEMS, INC.'),(75480694784,'Cisco','CISCO SYSTEMS, INC.'),(75497472000,'ChiMeiCo','Chi Mei Communication Systems, I'),(75514249216,'D-Link','D-Link Corporation'),(75531026432,'Actualit','Actuality Systems, Inc.'),(75547803648,'Monitori','Monitoring Technologies Limited'),(75564580864,'PrismMed','Prism Media Products Limited'),(75581358080,'2wcom','2wcom Systems GmbH'),(75598135296,'AlkeriaS','Alkeria srl'),(75614912512,'Telesyne','Telesynergy Research Inc.'),(75631689728,'Ep&TEner','EP&T Energy'),(75648466944,'DiginfoT','Diginfo Technology Corporation'),(75665244160,'Solectro','Solectron Brazil'),(75682021376,'NokiaDan','Nokia Danmark A/S'),(75698798592,'VtechEng','Vtech Engineering Canada Ltd'),(75715575808,'VisionNe','VISION NETWARE CO.,LTD'),(75732353024,'Manufact','Manufacturing Technology Inc'),(75749130240,'Lanready','LanReady Technologies Inc.'),(75765907456,'JstreamT','JStream Technologies Inc.'),(75782684672,'FortunaE','Fortuna Electronic Corp.'),(75799461888,'SypixxNe','Sypixx Networks'),(75816239104,'InfilcoD','Infilco Degremont Inc.'),(75833016320,'QuestTec','Quest Technologies'),(75849793536,'Moimston','MOIMSTONE Co., LTD'),(75866570752,'Uniclass','Uniclass Technology, Co., LTD'),(75883347968,'Trustabl','TRUSTABLE TECHNOLOGY CO.,LTD.'),(75900125184,'SimtecEl','Simtec Electronics'),(75916902400,'Shanghai','Shanghai Ruijie Technology'),(75933679616,'Motorola','Motorola Mobility, Inc.'),(75950456832,'Medialin','Medialink-i,Inc'),(75967234048,'Fortelin','Fortelink Inc.'),(75984011264,'Blueexpe','BlueExpert Technology Corp.'),(76000788480,'2001Tech','2001 Technology Inc.'),(76017565696,'Yoshimiy','YOSHIMIYA CO.,LTD.'),(76034342912,'Westermo','Westermo Teleindustri AB'),(76051120128,'Shenzhen','Shenzhen Powercom Co.,Ltd'),(76067897344,'OpenInte','Open Systems International'),(76084674560,'OctalixB','Octalix B.V.'),(76101451776,'Liebherr','Liebherr - Elektronik GmbH'),(76118228992,'InnerRan','Inner Range Pty. Ltd.'),(76135006208,'ElexolPt','Elexol Pty Ltd'),(76151783424,'Cisco','CISCO SYSTEMS, INC.'),(76168560640,'Cisco','CISCO SYSTEMS, INC.'),(76185337856,'Bombardi','Bombardier Transportation'),(76202115072,'AgpTelec','AGP Telecom Co. Ltd'),(76218892288,'AesysSPA','AESYS S.p.A.'),(76235669504,'AdayTech','Aday Technology Inc'),(76252446720,'4pMobile','4P MOBILE DATA PROCESSING'),(76269223936,'UnitedFi','United Fiber Optic Communication'),(76286001152,'Transcei','Transceiving System Technology C'),(76302778368,'Terminal','Terminales de Telecomunicacion T'),(76319555584,'TenTechn','TEN Technology'),(76336332800,'SeagateT','Seagate Technology'),(76353110016,'Raymarin','Raymarine UK Ltd'),(76369887232,'Powercom','Powercom Co., Ltd.'),(76386664448,'Mtt','MTT Corporation'),(76403441664,'LongRang','Long Range Systems, Inc.'),(76420218880,'Jacobson','Jacobsons AB'),(76436996096,'Guangzho','Guangzhou Jinpeng Group Co.,Ltd.'),(76453773312,'AxsunTec','Axsun Technologies'),(76470550528,'Ubisense','Ubisense Limited'),(76487327744,'ThraneTh','Thrane & Thrane A/S'),(76504104960,'Tandberg','Tandberg Data ASA'),(76520882176,'SoftImag','Soft Imaging System GmbH'),(76537659392,'Percepti','Perception Digital Ltd'),(76554436608,'Nextgent','NextGenTel Holding ASA'),(76571213824,'Netenric','NetEnrich, Inc'),(76587991040,'Hangzhou','Hangzhou Sunyard System Engineer'),(76604768256,'Handera','HandEra, Inc.'),(76621545472,'Ewerks','eWerks Inc'),(76638322688,'AsustekC','ASUSTek Computer Inc.'),(76655099904,'Tivo',''),(76671877120,'VivaasTe','Vivaas Technology Inc.'),(76688654336,'Land-Cel','Land-Cellular Corporation'),(76705431552,'GlunzJen','Glunz & Jensen'),(76722208768,'FromusTe','FROMUS TEC. Co., Ltd.'),(76738985984,'Eurilogi','EURILOGIC'),(76755763200,'CurrentE','Current Energy'),(76772540416,'U-MediaC','U-MEDIA Communications, Inc.'),(76789317632,'ArcelikA','Arcelik A.S'),(76806094848,'HuaJungC','Hua Jung Components Co., Ltd.'),(76822872064,'Thomson','Thomson, Inc.'),(76839649280,'DanelecE','Danelec Electronics A/S'),(76856426496,'Kcodes','KCodes Corporation'),(76873203712,'Scientif','Scientific Atlanta'),(76889980928,'Worldsat','WORLDSAT - Texas de France'),(76906758144,'TixiCom','Tixi.Com'),(76923535360,'Starnex','STARNEX CO., LTD.'),(76940312576,'Iwics','IWICS Inc.'),(76957089792,'Innovati','Innovative Integration'),(76973867008,'Avix','AVIX INC.'),(76990644224,'802Globa','802 Global'),(77007421440,'Estari','Estari, Inc.'),(77024198656,'ConitecD','Conitec Datensysteme GmbH'),(77040975872,'Wideful','Wideful Limited'),(77057753088,'Qinetiq','QinetiQ Ltd'),(77074530304,'Institut','Institute of Network Technologie'),(77091307520,'Neomedia','NeoMedia Europe AG'),(77108084736,'Woori-Ne','woori-net'),(77124861952,'AskeyCom','ASKEY COMPUTER CORP.'),(77141639168,'AsiaPaci','Asia Pacific Microsystems , Inc.'),(77158416384,'Shenzhen','Shenzhen Forward Industry Co., L'),(77175193600,'Airaya','AIRAYA Corp'),(77191970816,'NortelNe','Nortel Networks'),(77208748032,'Rane','Rane Corporation'),(77225525248,'Heidelbe','Heidelberg Engineering GmbH'),(77242302464,'HartingE','HARTING Electric Gmbh & Co.KG'),(77259079680,'Korg','KORG INC.'),(77275856896,'KeiyoSys','Keiyo System Research, Inc.'),(77292634112,'DigitroT','Digitro Tecnologia Ltda'),(77309411328,'Cisco','CISCO SYSTEMS, INC.'),(77326188544,'Cisco','CISCO SYSTEMS, INC.'),(77342965760,'DecraneA','Decrane Aerospace - Audio Intern'),(77359742976,'Activnet','ActivNetworks'),(77376520192,'U10Netwo','u10 Networks, Inc.'),(77393297408,'Terrasat','Terrasat Communications, Inc.'),(77410074624,'IquestNz','iQuest (NZ) Ltd'),(77426851840,'HeadStro','Head Strong International Limite'),(77443629056,'GantnerI','Gantner Instruments GmbH'),(77460406272,'Fastrax','Fastrax Ltd'),(77477183488,'EmersonC','Emerson Climate Technologies Gmb'),(77493960704,'Chinasys','Chinasys Technologies Limited'),(77510737920,'Ce-Infos','CE-Infosys Pte Ltd'),(77527515136,'Advanced','Advanced Telecommunication Techn'),(77544292352,'Abocom',''),(77561069568,'Ieee8023','IEEE 802.3'),(77577846784,'Wideray','WideRay Corp'),(77594624000,'Protechn','Protechna Herbst GmbH & Co. KG'),(77611401216,'Plus','PLUS  Corporation'),(77628178432,'Metrohm','Metrohm AG'),(77644955648,'KoenigBa','Koenig & Bauer AG'),(77661732864,'IstorNet','iStor Networks, Inc.'),(77678510080,'IcpInter','ICP Internet Communication Payme'),(77695287296,'Cisco-Li','Cisco-Linksys, LLC'),(77712064512,'Aruze','ARUZE Corporation'),(77728841728,'AheadCom','Ahead Communication Systems Inc'),(77745618944,'TechnoSo','Techno Soft Systemnics Inc.'),(77762396160,'SoundDev','Sound Devices, LLC'),(77779173376,'ParrotSA','PARROT S.A.'),(77795950592,'Netfabri','Netfabric Corporation'),(77812727808,'JuniperN','Juniper Networks, Inc.'),(77829505024,'HardingI','Harding Instruments'),(77846282240,'Cadco','Cadco Systems'),(77863059456,'BBraunMe','B.Braun Melsungen AG'),(77879836672,'SkardinU','Skardin (UK) Ltd'),(77896613888,'Pixim',''),(77913391104,'Nexql','NexQL Corporation'),(77930168320,'Motorola','Motorola Mobility, Inc.'),(77946945536,'JapanDir','Japan Direx Corporation'),(77963722752,'Franklin','Franklin Electric Co., Inc.'),(77980499968,'Data','Data Ltd.'),(77997277184,'Broadeas','BroadEasy Technologies Co.,Ltd'),(78014054400,'VtechTel','VTech Telecommunications Ltd.'),(78030831616,'Virbiage','Virbiage Pty Ltd'),(78047608832,'SoenenCo','Soenen Controls N.V.'),(78064386048,'Sinett','SiNett Corporation'),(78081163264,'SignalTe','Signal Technology - AISD'),(78097940480,'SaneiEle','Sanei Electric Inc.'),(78114717696,'PicasoIn','Picaso Infocommunication CO., LT'),(78131494912,'MotionCo','Motion Control Systems, Inc.'),(78148272128,'LewizCom','LeWiz Communications Inc.'),(78165049344,'JrcTokki','JRC TOKKI Co.,Ltd.'),(78181826560,'CamilleB','Camille Bauer'),(78198603776,'Andrew','Andrew Corporation'),(78215380992,'Consentr','ConSentry Networks'),(78232158208,'TexasIns','Texas Instruments'),(78248935424,'SetaboxT','SetaBox Technology Co., Ltd.'),(78265712640,'SNet','S Net Systems Inc.'),(78282489856,'Posystec','Posystech Inc., Co.'),(78299267072,'KeroAps','KeRo Systems ApS'),(78316044288,'SecondRu','Second Rule LLC'),(78332821504,'Ges',''),(78349598720,'EruneTec','ERUNE technology Co., Ltd.'),(78366375936,'DellEsgP','Dell ESG PCBA Test'),(78383153152,'AmoiElec','AMOI ELECTRONICS CO.,LTD'),(78399930368,'A2iMarke','a2i marketing center'),(78416707584,'Millenni','Millennial Net'),(78433484800,'Cisco','CISCO SYSTEMS, INC.'),(78450262016,'Cisco','CISCO SYSTEMS, INC.'),(78467039232,'Zellwege','Zellweger Analytics, Inc.'),(78483816448,'TOMTechn','T.O.M TECHNOLOGY INC..'),(78500593664,'SamsungE','Samsung Electronics Co., Ltd.'),(78517370880,'EmcKashy','EMC Corporation (Kashya)'),(78534148096,'DeltaEle','Delta Elettronica S.p.A.'),(78550925312,'Dedicate','Dedicated Devices, Inc.'),(78567702528,'TexasIns','Texas Instruments'),(78584479744,'Bbwm','BBWM Corporation'),(78601256960,'InduconB','Inducon BV'),(78618034176,'XacAutom','XAC AUTOMATION CORP.'),(78634811392,'PentairT','Pentair Thermal Management'),(78651588608,'TokyoAir','Tokyo Aircaft Instrument Co., Lt'),(78668365824,'Silink',''),(78685143040,'Citronix','Citronix, LLC'),(78701920256,'Audiodev','AudioDev AB'),(78718697472,'SpectraT','Spectra Technologies Holdings Co'),(78735474688,'Neteffec','NetEffect Incorporated'),(78752251904,'LgInform','LG INFORMATION & COMM.'),(78769029120,'Leapcomm','LeapComm Communication Technolog'),(78785806336,'ActivisP','Activis Polska'),(78802583552,'ThermoEl','THERMO ELECTRON KARLSRUHE'),(78819360768,'Microsof','Microsoft Corporation'),(78836137984,'KaimeiEl','KAIMEI ELECTRONI'),(78852915200,'GreenHil','Green Hills Software, Inc.'),(78869692416,'Cybernet','CyberNet Inc.'),(78886469632,'Caen',''),(78903246848,'Awind','AWIND Inc.'),(78920024064,'StantonM','Stanton Magnetics,inc.'),(78936801280,'Adaptix','Adaptix, Inc'),(78953578496,'NokiaDan','Nokia Danmark A/S'),(78970355712,'DataVoic','Data Voice Technologies GmbH'),(78987132928,'DaumElec','daum electronic gmbh'),(79003910144,'Enerdyne','Enerdyne Technologies, Inc.'),(79020687360,'Swisscom','Swisscom Hospitality Services SA'),(79037464576,'Panasoni','Panasonic Corporation'),(79054241792,'IpsDOO','IPS d.o.o.'),(79071019008,'ValueEle','Value Electronics'),(79087796224,'Optoelec','OPTOELECTRONICS Co., Ltd.'),(79104573440,'Ascalade','Ascalade Communications Limited'),(79121350656,'Visonic','Visonic Ltd.'),(79138127872,'Universi','University of California, Berkel'),(79154905088,'SeidelEl','Seidel Elektronik GmbH Nfg.KG'),(79171682304,'RaysonTe','Rayson Technology Co., Ltd.'),(79188459520,'NgesDenr','NGES Denro Systems'),(79205236736,'Measurem','Measurement Computing Corp'),(79222013952,'ReduxCom','Redux Communications Ltd.'),(79238791168,'Stoke','Stoke Inc'),(79255568384,'NitLab','NIT lab'),(79272345600,'Sentilla','Sentilla Corporation'),(79289122816,'CgPowerI','CG Power Systems Ireland Limited'),(79305900032,'KorenixT','Korenix Technologies Co., Ltd.'),(79322677248,'Internat','International Bar Code'),(79339454464,'Hewlett-','Hewlett-Packard Company'),(79356231680,'SanyuInd','Sanyu Industry Co.,Ltd.'),(79373008896,'ViaNetwo','VIA Networking Technologies, Inc'),(79389786112,'Swegon','SWEGON AB'),(79406563328,'Mobilear','MobileAria'),(79423340544,'DigitalL','Digital Lifestyles Group, Inc.'),(79440117760,'Cisco','CISCO SYSTEMS, INC.'),(79456894976,'Cisco','CISCO SYSTEMS, INC.'),(79473672192,'MarchNet','March Networks S.p.A.'),(79490449408,'Qovia',''),(79507226624,'NortelNe','Nortel Networks'),(79524003840,'Lab33Srl','Lab33 Srl'),(79540781056,'Gizmondo','Gizmondo Europe Ltd'),(79557558272,'Endevco','ENDEVCO CORP'),(79574335488,'DigitalE','Digital Everywhere Unterhaltungs'),(79591112704,'2wire','2Wire, Inc'),(79607889920,'AdvanceS','Advance Sterilization Products'),(79624667136,'Motorola','Motorola Mobility, Inc.'),(79641444352,'SensoryN','Sensory Networks Inc'),(79658221568,'Woodward','Woodward Governor'),(79674998784,'StbDaten','STB Datenservice GmbH'),(79691776000,'Q-FreeAs','Q-Free ASA'),(79708553216,'Montilio',''),(79725330432,'KyowaEle','KYOWA Electric & Machinery Corp.'),(79742107648,'KwsCompu','KWS Computersysteme GmbH'),(79758884864,'GriffinT','Griffin Technology'),(79775662080,'GeEnergy','GE Energy'),(79792439296,'Sumitomo','SUMITOMO ELECTRIC DEVICE INNOVAT'),(79809216512,'Aiware','Aiware Inc.'),(79825993728,'Addlogix',''),(79842770944,'O2micro','O2Micro, Inc.'),(79859548160,'MicoElec','MICO ELECTRIC(SHENZHEN) LIMITED'),(79876325376,'KtechTel','Ktech Telecommunications Inc'),(79893102592,'IrtElect','IRT Electronics Pty Ltd'),(79909879808,'E2sElect','E2S Electronic Engineering Solut'),(79926657024,'Yulinet',''),(79943434240,'FirstInt','First International Computer do '),(79960211456,'SurfComm','Surf Communications Inc.'),(79976988672,'Rae','RAE Systems'),(79993765888,'Neomerid','NeoMeridian Sdn Bhd'),(80010543104,'Bluepack','BluePacket Communications Co., L'),(80027320320,'Vita',''),(80044097536,'TrustInt','Trust International B.V.'),(80060874752,'Thingmag','ThingMagic, LLC'),(80077651968,'Stargen','Stargen, Inc.'),(80094429184,'DolbyAus','Dolby Australia'),(80111206400,'IsrTechn','ISR TECHNOLOGIES Inc'),(80127983616,'Intec','intec GmbH'),(80144760832,'3com','3Com Ltd'),(80161538048,'Iee','IEE, Inc.'),(80178315264,'Wilife','WiLife, Inc.'),(80195092480,'Ontimete','ONTIMETEK INC.'),(80211869696,'Ids','IDS GmbH'),(80228646912,'HlsHard-','HLS HARD-LINE Solutions Inc.'),(80245424128,'ElproTec','ELPRO Technologies'),(80262201344,'EforeOyj','Efore Oyj   (Plc)'),(80278978560,'DaiNippo','Dai Nippon Printing Co., Ltd'),(80295755776,'Avolites','AVOLITES LTD.'),(80312532992,'AdvanceW','Advance Wireless Technology Corp'),(80329310208,'WorkMicr','Work Microwave GmbH'),(80346087424,'Vialta','Vialta, Inc.'),(80362864640,'SantaBar','Santa Barbara Infrared, Inc.'),(80379641856,'PtwFreib','PTW Freiburg'),(80396419072,'G2Micros','G2 Microsystems'),(80413196288,'FusionDi','Fusion Digital Technology'),(80429973504,'Fsi','FSI Systems, Inc.'),(80446750720,'Telecomm','Telecommunications Industry Asso'),(80463527936,'EcholabL','Echolab LLC'),(80480305152,'AvantecM','Avantec Manufacturing Limited'),(80497082368,'Astek','Astek Corporation'),(80513859584,'Arcadyan','Arcadyan Technology Corporation'),(80530636800,'Hotlava','HotLava Systems, Inc.'),(80547414016,'CheckPoi','Check Point Software Technologie'),(80564191232,'ApexElec','Apex Electronics Factory'),(80580968448,'WitSA','WIT S.A.'),(80597745664,'Viseon','Viseon, Inc.'),(80614522880,'V-ShowTe','V-Show  Technology (China) Co.,L'),(80631300096,'TgcAmeri','TGC America, Inc'),(80648077312,'SecurayT','SECURAY Technologies Ltd.Co.'),(80664854528,'PerfectT','Perfect tech'),(80681631744,'Motorola','Motorola Mobility, Inc.'),(80698408960,'Mechatro','Mechatronic Brick Aps'),(80715186176,'Css','CSS Inc.'),(80731963392,'Bitatek','Bitatek CO., LTD'),(80748740608,'Asem','ASEM SpA'),(80765517824,'Advanced','Advanced Cybernetics Group'),(80782295040,'AcctonTe','Accton Technology Corporation'),(80799072256,'Gossen-M','Gossen-Metrawatt-GmbH'),(80815849472,'TexasIns','Texas Instruments Inc'),(80832626688,'TexasIns','Texas Instruments'),(80849403904,'Zetta','Zetta Systems, Inc.'),(80866181120,'Princeto','Princeton Technology, Ltd'),(80882958336,'MotionRe','Motion Reality Inc.'),(80899735552,'JiangsuY','Jiangsu Yitong High-Tech Co.,Ltd'),(80916512768,'InventoN','Invento Networks, Inc.'),(80933289984,'Internat','International Games System Co., '),(80950067200,'Cisco','CISCO SYSTEMS, INC.'),(80966844416,'Cisco','CISCO SYSTEMS, INC.'),(80983621632,'ZiehlInd','ZIEHL industrie-elektronik GmbH '),(81000398848,'SuncorpI','SunCorp Industrial Limited'),(81017176064,'ShengquI','Shengqu Information Technology ('),(81033953280,'RadioCom','Radio Components Sweden AB'),(81050730496,'Novomati','Novomatic AG'),(81067507712,'Codan','Codan Limited'),(81084284928,'AlliantN','Alliant Networks, Inc'),(81101062144,'AlaxalaN','ALAXALA Networks Corporation'),(81117839360,'Agat-Rt','Agat-RT, Ltd.'),(81134616576,'ZiehlInd','ZIEHL industrie-electronik GmbH '),(81151393792,'TimeAmer','Time America, Inc.'),(81168171008,'SpectecC','SPECTEC COMPUTER CO., LTD.'),(81184948224,'Projecte','Projectek Networking Electronics'),(81201725440,'Fraunhof','Fraunhofer IMS'),(81218502656,'Abbey','Abbey Systems Ltd'),(81235279872,'Trane',''),(81252057088,'PdhSolut','PDH Solutions, LLC'),(81268834304,'Movacolo','Movacolor b.v.'),(81285611520,'AvgAdvan','AVG Advanced Technologies'),(81302388736,'SonyEric','Sony Ericsson Mobile Communicati'),(81319165952,'Oneacces','OneAccess SA'),(81335943168,'IntelCor','Intel Corporate'),(81352720384,'Ifotec',''),(81369497600,'BrocadeC','Brocade Communications Systems, '),(81386274816,'Connectb','connectBlue AB'),(81403052032,'BelcoInt','Belco International Co.,Ltd.'),(81419829248,'ImardaNe','Imarda New Zealand Limited'),(81436606464,'Mdk','MDK CO.,LTD.'),(81453383680,'XiamenXi','Xiamen Xinglian Electronics Co.,'),(81470160896,'WniResou','WNI Resources, LLC'),(81486938112,'UryuSeis','URYU SEISAKU, LTD.'),(81503715328,'Thx','THX LTD'),(81520492544,'SamsungE','Samsung Electronics'),(81537269760,'PlanetSy','PLANET System Co.,LTD'),(81554046976,'OptimusI','OPTIMUS IC S.A.'),(81570824192,'LenovoMo','Lenovo Mobile Communication Tech'),(81587601408,'LelyIndu','Lely Industries N.V.'),(81604378624,'It-Facto','IT-FACTORY, INC.'),(81621155840,'Irongate','IronGate S.L.'),(81637933056,'IntelCor','Intel Corporate'),(81654710272,'Gateconn','GateConnect'),(81671487488,'Flaircom','Flaircomm Technologies Co. LTD'),(81688264704,'Epicom','Epicom, Inc.'),(81705041920,'AlwaysOn','Always On Wireless'),(81721819136,'Paravirt','Paravirtual Corporation'),(81738596352,'NuveraFu','Nuvera Fuel Cells'),(81755373568,'OceanBro','Ocean Broadband Networks'),(81772150784,'Nortel',''),(81788928000,'MextalBV','Mextal B.V.'),(81805705216,'HfSystem','HF System Corporation'),(81822482432,'GalileoA','GALILEO AVIONICA'),(81839259648,'Focusrit','Focusrite Audio Engineering Limi'),(81856036864,'EgemenBi','EGEMEN Bilgisayar Muh San ve Tic'),(81872814080,'Cisco-Li','Cisco-Linksys, LLC'),(81889591296,'ArrisInt','ARRIS International'),(81906368512,'AmediaNe','Amedia Networks Inc.'),(81923145728,'Guangzho','GuangZhou Post & Telecom Equipme'),(81939922944,'Asiamajo','Asiamajor Inc.'),(81956700160,'SonyComp','SONY Computer Entertainment inc,'),(81973477376,'L-S-BBro','L-S-B Broadcast Technologies Gmb'),(81990254592,'GnNetcom','GN Netcom as'),(82007031808,'Dgstatio','DGSTATION Co., Ltd.'),(82023809024,'Cisco','CISCO SYSTEMS, INC.'),(82040586240,'Cisco','CISCO SYSTEMS, INC.'),(82057363456,'BecellIn','BeCell Innovations Corp.'),(82074140672,'Litetouc','LiteTouch, Inc.'),(82090917888,'Scanvaeg','Scanvaegt International A/S'),(82107695104,'PeikerAc','Peiker acustic GmbH & Co. KG'),(82124472320,'Nxtphase','NxtPhase T&D, Corp.'),(82141249536,'IntelCor','Intel Corporate'),(82158026752,'Hewlett-','Hewlett-Packard Company'),(82174803968,'DaqElect','DAQ Electronics, Inc.'),(82191581184,'Cap','Cap Co., Ltd.'),(82208358400,'Schneide','Schneider Electric Ultra Termina'),(82225135616,'Cortina','Cortina Systems Inc'),(82241912832,'Ecm','ECM Systems Ltd'),(82258690048,'DataAcqu','Data Acquisitions limited'),(82275467264,'WestechK','Westech Korea Inc.,'),(82292244480,'Vsst','VSST Co., LTD'),(82309021696,'Sitronic','Sitronics Telecom Solutions'),(82325798912,'PhoenixD','Phoenix Digital'),(82342576128,'MazBrand','MAZ Brandenburg GmbH'),(82359353344,'IwiseCom','iWise Communications'),(82376130560,'ItianCop','ITian Coporation'),(82392907776,'Interact','Interactek'),(82409684992,'EuroProt','EURO PROTECTION SURVEILLANCE'),(82426462208,'Cellpoin','CellPoint Connect'),(82443239424,'BeijingT','Beijing Topsec Network Security '),(82460016640,'Baudtec','BaudTec Corporation'),(82476793856,'Arkados','Arkados, Inc.'),(82493571072,'VsIndust','VS Industry Berhad'),(82510348288,'Tianjin7','Tianjin 712 Communication Broadc'),(82527125504,'OrientPo','Orient Power Home Network Ltd.'),(82543902720,'Freseniu','FRESENIUS-VIAL'),(82560679936,'CcvDeuts','CCV Deutschland GmbH'),(82577457152,'Vadatech','VadaTech Inc.'),(82594234368,'SpeedDra','Speed Dragon Multimedia Limited'),(82611011584,'Quintron','QUINTRON SYSTEMS INC.'),(82627788800,'MicroMem','Micro Memory Curtiss Wright Co'),(82644566016,'Metaswit','MetaSwitch'),(82661343232,'Eppendor','Eppendorf Instrumente GmbH'),(82678120448,'AdElSRL','AD.EL s.r.l.'),(82694897664,'Shandong','Shandong New Beiyang Information'),(82711674880,'VisionRe','Vision Research, Inc.'),(82728452096,'Matsushi','Matsushita Electronic Components'),(82745229312,'FargoEle','Fargo Electronics Inc.'),(82762006528,'Eaton','Eaton Corporation'),(82778783744,'D-Link','D-Link Corporation'),(82795560960,'Bluetree','BlueTree Wireless Data Inc.'),(82812338176,'ArtilaEl','Artila Electronics Co., Ltd.'),(82829115392,'ZyxelCom','ZyXEL Communications Corporation'),(82845892608,'Engim','Engim, Inc.'),(82862669824,'Togolden','ToGoldenNet Technology Inc.'),(82879447040,'YdtTechn','YDT Technology International'),(82896224256,'IneproBv','Inepro BV'),(82913001472,'Valox','Valox Systems, Inc.'),(82929778688,'TranzeoW','Tranzeo Wireless Technologies In'),(82946555904,'SilverSp','Silver Spring Networks, Inc'),(82963333120,'NilesAud','Niles Audio Corporation'),(82980110336,'Naztec','Naztec, Inc.'),(82996887552,'HydacFil','HYDAC Filtertechnik GMBH'),(83013664768,'ZcomaxTe','Zcomax Technologies, Inc.'),(83030441984,'TomenCyb','TOMEN Cyber-business Solutions, '),(83047219200,'FlirRadi','FLIR Radiation Inc'),(83063996416,'SoyalTec','Soyal Technology Co., Ltd.'),(83080773632,'Realm','Realm Systems, Inc.'),(83097550848,'Protelev','ProTelevision Technologies A/S'),(83114328064,'ProjectT','Project T&E Limited'),(83131105280,'Panellin','PanelLink Cinema, LLC'),(83147882496,'Onsite','OnSite Systems, Inc.'),(83164659712,'NttpcCom','NTTPC Communications, Inc.'),(83181436928,'Eab/Rwi/','EAB/RWI/K'),(83198214144,'Cisco','CISCO SYSTEMS, INC.'),(83214991360,'Cisco','CISCO SYSTEMS, INC.'),(83231768576,'Biospace','Biospace Co., Ltd.'),(83248545792,'Shinheun','ShinHeung Precision Co., Ltd.'),(83265323008,'Verascap','Verascape, Inc.'),(83282100224,'Paradigm','Paradigm Technology Inc..'),(83298877440,'Nortel',''),(83315654656,'Neturity','Neturity Technologies Inc.'),(83332431872,'Narayon','Narayon. Co., Ltd.'),(83349209088,'SaabDanm','Saab Danmark A/S'),(83365986304,'HondaEle','Honda Electron Co., LED.'),(83382763520,'HachLang','Hach Lange Sarl'),(83399540736,'E-Tec',''),(83416317952,'Tomtom',''),(83433095168,'Tentacul','Tentaculus AB'),(83449872384,'Techmetr','Techmetro Corp.'),(83466649600,'Packetmo','PacketMotion, Inc.'),(83483426816,'NokiaDan','Nokia Danmark A/S'),(83500204032,'Motorola','Motorola Mobility, Inc.'),(83516981248,'DellEsgP','Dell ESG PCBA Test'),(83533758464,'BlwaveEl','BLwave Electronics Co., Ltd'),(83550535680,'AtherosC','Atheros Communications, Inc.'),(83567312896,'American','American Security Products Co.'),(83584090112,'TaborEle','Tabor Electronics Ltd.'),(83600867328,'SamsungE','Samsung Electronics CO., LTD'),(83617644544,'QsanTech','Qsan Technology, Inc.'),(83634421760,'PonderIn','PONDER INFORMATION INDUSTRIES LT'),(83651198976,'NetvoxTe','Netvox Technology Co., Ltd.'),(83667976192,'Movon','Movon Corporation'),(83684753408,'Kaicom','Kaicom co., Ltd.'),(83701530624,'Dynalab','Dynalab, Inc.'),(83718307840,'CoredgeN','CorEdge Networks, Inc.'),(83735085056,'Cisco','CISCO SYSTEMS, INC.'),(83751862272,'Cisco','CISCO SYSTEMS, INC.'),(83768639488,'Chips','CHIPS & Systems, Inc.'),(83785416704,'CetaceaN','Cetacea Networks Corporation'),(83802193920,'Applicat','Application Technologies and Eng'),(83818971136,'Advanced','Advanced Motion Controls'),(83835748352,'Add-OnTe','Add-On Technology Co., LTD.'),(83852525568,'Abb/Tota','ABB Inc./Totalflow'),(83869302784,'27mTechn','27M Technologies AB'),(83886080000,'WimediaA','WiMedia Alliance'),(83902857216,'RedesDeT','Redes de TelefonÃ­a MÃ³vil S.A.'),(83919634432,'QingdaoG','QINGDAO GOERTEK ELECTRONICS CO.,'),(83936411648,'PhantomT','Phantom Technologies LLC'),(83953188864,'Kumyoung','Kumyoung.Co.Ltd'),(83969966080,'Kinghold',''),(83986743296,'FoabElek','FOAB Elektronik AB'),(84003520512,'Asiarock','Asiarock Incorporation'),(84020297728,'TermtekC','Termtek Computer Co., Ltd'),(84037074944,'Ouen','OUEN CO.,LTD.'),(84053852160,'RuckusWi','Ruckus Wireless'),(84070629376,'Panta','Panta Systems, Inc.'),(84087406592,'Infohand','Infohand Co.,Ltd'),(84104183808,'Congatec','congatec AG'),(84120961024,'AcbelPol','Acbel Polytech Inc.'),(84137738240,'Oracle','Oracle Corporation'),(84154515456,'Traffics','TrafficSim Co.,Ltd'),(84171292672,'Stac','STAC Corporation.'),(84188069888,'K-Ubique','K-ubique ID Corp.'),(84204847104,'Ioimage','ioIMAGE Ltd.'),(84221624320,'ExaveraT','Exavera Technologies, Inc.'),(84238401536,'MarvellH','Marvell Hispana S.L.'),(84255178752,'CiaraTec','Ciara Technologies Inc.'),(84271955968,'Electron','Electronics Design Services, Co.'),(84288733184,'Algosyst','ALGOSYSTEM Co., Ltd.'),(84305510400,'CrowElec','Crow Electronic Engeneering'),(84322287616,'Maxstrea','MaxStream, Inc'),(84339064832,'SiemensC','Siemens Com CPE Devices'),(84355842048,'KeyeyeCo','KeyEye Communications'),(84372619264,'GeneralS','General Solutions, LTD.'),(84389396480,'Extricom','Extricom Ltd'),(84406173696,'Battelle','BATTELLE MEMORIAL INSTITUTE'),(84422950912,'TanisysT','Tanisys Technology'),(84439728128,'Sony','Sony Corporation'),(84456505344,'AlsTec','ALS  & TEC Ltd.'),(84473282560,'Telemoti','Telemotive AG'),(84490059776,'Sunmyung','Sunmyung Electronics Co., LTD'),(84506836992,'Sendo','Sendo Ltd'),(84523614208,'Radiance','Radiance Technologies, Inc.'),(84540391424,'NumaTech','NUMA Technology,Inc.'),(84557168640,'Jablotro','Jablotron'),(84573945856,'Intellig','Intelligent Control Systems (Asi'),(84590723072,'Carallon','Carallon Limited'),(84607500288,'EcomComm','Ecom Communications Technology C'),(84624277504,'AppearTv','Appear TV'),(84641054720,'Wavesat',''),(84657831936,'SlingMed','Sling Media, Inc.'),(84674609152,'Scantech','Scantech ID'),(84691386368,'RycoElec','RyCo Electronic Systems Limited'),(84708163584,'Bm','BM SPA'),(84724940800,'Readylin','ReadyLinks Inc'),(84741718016,'Smartvue','Smartvue Corporation'),(84758495232,'Artimi','Artimi Ltd'),(84775272448,'HymatomS','HYMATOM SA'),(84792049664,'VirtualC','Virtual Conexions'),(84808826880,'MediaSys','Media System Planning Corp.'),(84825604096,'TrixTecn','Trix Tecnologia Ltda.'),(84842381312,'AsokaUsa','Asoka USA Corporation'),(84859158528,'Wacom','WACOM Co.,Ltd'),(84875935744,'Cisco','CISCO SYSTEMS, INC.'),(84892712960,'Cisco','CISCO SYSTEMS, INC.'),(84909490176,'Lightron','LIGHTRON FIBER-OPTIC DEVICES INC'),(84926267392,'Opengear','OpenGear, Inc'),(84943044608,'Ionos','IONOS Co.,Ltd.'),(84959821824,'AdbBroad','ADB Broadband Italia'),(84976599040,'BeyondAc','Beyond Achieve Enterprises Ltd.'),(84993376256,'PicoDigi','Pico Digital'),(85010153472,'ZenitelN','Zenitel Norway AS'),(85026930688,'TallMapl','Tall Maple Systems'),(85043707904,'Mti','MTI co. LTD'),(85060485120,'IntelCor','Intel Corporate'),(85077262336,'4accessC','4Access Communications'),(85094039552,'T+Medica','t+ Medical Ltd'),(85110816768,'KirkTele','KIRK telecom A/S'),(85127593984,'PageIber','PAGE IBERICA, S.A.'),(85144371200,'Micro-St','MICRO-STAR INTERNATIONAL CO., LT'),(85161148416,'AsustekC','ASUSTek COMPUTER INC.'),(85177925632,'Ruggedco','RuggedCom'),(85194702848,'TiiNetwo','TII NETWORK TECHNOLOGIES, INC.'),(85211480064,'SpidcomT','SPIDCOM Technologies SA'),(85228257280,'Princeto','Princeton Instruments'),(85245034496,'MatrixPr','Matrix Product Development, Inc.'),(85261811712,'Diskware','Diskware Co., Ltd'),(85278588928,'ShoeiEle','SHOEI Electric Co.,Ltd'),(85295366144,'Ibtek','IBTEK INC.'),(85312143360,'AbbottDi','Abbott Diagnostics'),(85328920576,'Adapt4Ll','Adapt4, LLC'),(85345697792,'Ryvor','Ryvor Corp.'),(85362475008,'MurataMa','Murata Manufacturing Co., Ltd.'),(85379252224,'Iprobe','Iprobe AB'),(85396029440,'Geovisio','GeoVision Inc.'),(85412806656,'CoviTech','CoVi Technologies, Inc.'),(85429583872,'Yangjae','YANGJAE SYSTEMS CORP.'),(85446361088,'Tenosys','TENOSYS, INC.'),(85463138304,'Technolu','Technolution'),(85479915520,'Halcro',''),(85496692736,'IntelCor','Intel Corporate'),(85513469952,'Veriwave','VeriWave, Inc.'),(85530247168,'Kamstrup','Kamstrup A/S'),(85547024384,'Sysmaste','Sysmaster Corporation'),(85563801600,'SunbaySo','Sunbay Software AG'),(85580578816,'Psia',''),(85597356032,'JbxDesig','JBX Designs Inc.'),(85614133248,'KingjonD','Kingjon Digital Technology Co.,L'),(85630910464,'Wavefron','Wavefront Semiconductor'),(85647687680,'AmodTech','AMOD Technology Co., Ltd.'),(85664464896,'Klas','Klas Ltd'),(85681242112,'Giga-Byt','Giga-byte Communications Inc.'),(85698019328,'PsitekPt','Psitek (Pty) Ltd'),(85714796544,'Akimbi','Akimbi Systems'),(85731573760,'Cintech',''),(85748350976,'SmcNetwo','SMC Networks, Inc.'),(85765128192,'DexSecur','Dex Security Solutions'),(85781905408,'Cavera','Cavera Systems'),(85798682624,'Lifesize','LifeSize Communications, Inc'),(85815459840,'RkcInstr','RKC INSTRUMENT INC.'),(85832237056,'Sicortex','SiCortex, Inc'),(85849014272,'NokiaDan','Nokia Danmark A/S'),(85865791488,'Grandtec','GRANDTEC ELECTRONIC CORP.'),(85882568704,'Dage-Mti','Dage-MTI of MC, Inc.'),(85899345920,'MinervaK','MINERVA KOREA CO., LTD'),(85916123136,'Rivertre','Rivertree Networks Corp.'),(85932900352,'Kk-Elect','kk-electronic a/s'),(85949677568,'RenasisL','Renasis, LLC'),(85966454784,'Motorola','Motorola Mobility, Inc.'),(85983232000,'Openib','OpenIB, Inc.'),(86000009216,'GoNetwor','Go Networks'),(86016786432,'SperianP','Sperian Protection Instrumentati'),(86033563648,'Eka','Eka Systems Inc.'),(86050340864,'MagnetiM','MAGNETI MARELLI   S.E. S.p.A.'),(86067118080,'Wepio','WEPIO Co., Ltd.'),(86083895296,'FirstInt','FIRST INTERNATIONAL COMPUTER, IN'),(86100672512,'GkbCctv','GKB CCTV CO., LTD.'),(86117449728,'Nortel',''),(86134226944,'Nortel',''),(86151004160,'FederalS','Federal State Unitary Enterprise'),(86167781376,'SuzhouKe','Suzhou Keda Technology CO.,Ltd'),(86184558592,'Deutschm','Deutschmann Automation GmbH & Co'),(86201335808,'S-TecEle','S-TEC electronics AG'),(86218113024,'TrebingH','Trebing & Himstedt ProzeÃŸautoma'),(86234890240,'Jumpnode','Jumpnode Systems LLC.'),(86251667456,'IntecAut','Intec Automation Inc.'),(86268444672,'ScoscheI','Scosche Industries, Inc.'),(86285221888,'RseInfor','RSE Informations Technologie Gmb'),(86301999104,'C4line',''),(86318776320,'Sidsa',''),(86335553536,'Deicy','DEICY CORPORATION'),(86352330752,'Cisco','CISCO SYSTEMS, INC.'),(86369107968,'Cisco','CISCO SYSTEMS, INC.'),(86385885184,'LustAntr','Lust Antriebstechnik GmbH'),(86402662400,'PASemi','P.A. Semi, Inc.'),(86419439616,'Sunkwang','SunKwang Electronics Co., Ltd'),(86436216832,'G-LinksN','G-Links networking company'),(86452994048,'TotalWir','Total Wireless Technologies Pte.'),(86469771264,'DellEsgP','Dell ESG PCBA Test'),(86486548480,'J-SNeuro','J-S Co. NEUROCOM'),(86503325696,'MerryEle','Merry Electrics CO., LTD.'),(86520102912,'Galactic','Galactic Computing Corp.'),(86536880128,'NlTechno','NL Technology'),(86553657344,'Jazzmuta','JazzMutant'),(86570434560,'Vocollec','Vocollect, Inc'),(86587211776,'VCenterT','V Center Technologies Co., Ltd.'),(86603988992,'Elitegro','Elitegroup Computer System Co., '),(86620766208,'EdataCom','Edata Communication Inc.'),(86637543424,'KonceptI','Koncept International, Inc.'),(86654320640,'Toradex','Toradex AG'),(86671097856,'77Elektr','77 Elektronika Kft.'),(86687875072,'Wildpack','WildPackets'),(86704652288,'Vipower','ViPowER, Inc'),(86721429504,'PdlElect','PDL Electronics Ltd'),(86738206720,'Tarallax','Tarallax Wireless, Inc.'),(86754983936,'EmpowerT','Empower Technologies(Canada) Inc'),(86771761152,'Keri','Keri Systems, Inc'),(86788538368,'Citycom','CityCom Corp.'),(86805315584,'QwertyEl','Qwerty Elektronik AB'),(86822092800,'Gstelete','GSTeletech Co.,Ltd.'),(86838870016,'Hewlett-','Hewlett-Packard Company'),(86855647232,'BlonderT','Blonder Tongue Laboratories, Inc'),(86872424448,'RaytalkI','RAYTALK INTERNATIONAL SRL'),(86889201664,'Sensovat','Sensovation AG'),(86905978880,'Rheinmet','Rheinmetall Canada Inc.'),(86922756096,'Aevoe','Aevoe Inc.'),(86939533312,'AirlinkC','AirLink Communications, Inc.'),(86956310528,'HotwayTe','Hotway Technology Corporation'),(86973087744,'Atomic','ATOMIC Corporation'),(86989864960,'Innovati','Innovation Sound Technology Co.,'),(87006642176,'Atto','ATTO CORPORATION'),(87023419392,'Consultr','Consultronics Europe Ltd'),(87040196608,'Grundfos','Grundfos Holding'),(87056973824,'Telefon-','Telefon-Gradnja d.o.o.'),(87073751040,'Supervis','SuperVision Solutions LLC'),(87090528256,'Boaz','BOAZ Inc.'),(87107305472,'Inventec','Inventec Multimedia & Telecom Co'),(87124082688,'SichuanC','Sichuan Changhong Electric Ltd.'),(87140859904,'TaiwanTh','Taiwan Thick-Film Ind. Corp.'),(87157637120,'Hifn','Hifn, Inc.'),(87174414336,'GeneralM','General Meters Corp.'),(87191191552,'Intellig','Intelligent Systems'),(87207968768,'Srisa',''),(87224745984,'Oracle','Oracle Corporation'),(87241523200,'Heim','Heim Systems GmbH'),(87258300416,'AppleCom','Apple Computer Inc.'),(87275077632,'Calculex','CALCULEX,INC.'),(87291854848,'Advantec','ADVANTECH TECHNOLOGIES CO.,LTD'),(87308632064,'Symwave',''),(87325409280,'CoderEle','Coder Electronics Corporation'),(87342186496,'EdgeProd','Edge Products'),(87358963712,'T-VipsAs','T-VIPS AS'),(87375740928,'HsAutoma','HS Automatic ApS'),(87392518144,'Moram','Moram Co., Ltd.'),(87409295360,'NeratecS','Neratec Solutions AG'),(87426072576,'Seekerne','SeekerNet Inc.'),(87442849792,'Intronic','Intronics B.V.'),(87459627008,'WjCommun','WJ Communications, Inc.'),(87476404224,'Ibm','IBM Corp'),(87493181440,'Aditec','ADITEC CO. LTD'),(87509958656,'KyoceraW','Kyocera Wireless Corp.'),(87526735872,'Corona','CORONA CORPORATION'),(87543513088,'Digiwell','Digiwell Technology, inc'),(87560290304,'IdcsNV','IDCS N.V.'),(87577067520,'Cryptoso','Cryptosoft'),(87593844736,'NovoNord','Novo Nordisk A/S'),(87610621952,'Kleinhen','Kleinhenz Elektronik GmbH'),(87627399168,'Arrowspa','ArrowSpan Inc.'),(87644176384,'CelplanI','CelPlan International, Inc.'),(87660953600,'Cisco','CISCO SYSTEMS, INC.'),(87677730816,'Cisco','CISCO SYSTEMS, INC.'),(87694508032,'Anagran','Anagran, Inc.'),(87711285248,'Netgear','Netgear Inc.'),(87728062464,'RfTechno','RF Technologies'),(87744839680,'HStoll','H. Stoll GmbH & Co. KG'),(87761616896,'Kohler','Kohler Co'),(87778394112,'ProkomSo','Prokom Software SA'),(87795171328,'EasternA','Eastern Asia Technology Limited'),(87811948544,'ChinaBro','China Broadband Wireless IP Stan'),(87828725760,'Bookham','Bookham Inc'),(87845502976,'K40Elect','K40 Electronics'),(87862280192,'WilineNe','Wiline Networks, Inc.'),(87879057408,'Multicom','MultiCom Industries Limited'),(87895834624,'Nertec','Nertec  Inc.'),(87912611840,'Shenzhen','ShenZhen TP-LINK Technologies Co'),(87929389056,'NecMagnu','NEC Magnus Communications,Ltd.'),(87946166272,'Eubus','Eubus GmbH'),(87962943488,'Iteris','Iteris, Inc.'),(87979720704,'3com','3Com Ltd'),(87996497920,'AeonDigi','Aeon Digital International'),(88013275136,'Innerwir','InnerWireless'),(88030052352,'ThomsonT','Thomson Telecom Belgium'),(88046829568,'Hitachi-','Hitachi-LG Data Storage Korea, I'),(88063606784,'Multilin','Multilink Inc'),(88080384000,'AuroraNe','Aurora Networks'),(88097161216,'Exs','eXS Inc.'),(88113938432,'CermateT','Cermate Technologies Inc.'),(88130715648,'Giga-Byt','Giga-Byte'),(88147492864,'EchoDigi','Echo Digital Audio Corporation'),(88164270080,'American','American Technology Integrators'),(88181047296,'Akorri',''),(88197824512,'B1540210','B15402100 - JANDEI, S.L.'),(88214601728,'ElinEbgT','Elin Ebg Traction Gmbh'),(88231378944,'GloboEle','Globo Electronic GmbH & Co. KG'),(88248156160,'Fortress','Fortress Technologies'),(88264933376,'CubicDef','Cubic Defense Simulation Systems'),(88281710592,'TelePowe','Tele Power Inc.'),(88298487808,'Protroni','Protronic (Far East) Ltd.'),(88315265024,'Asp','ASP Corporation'),(88332042240,'DanielsE','Daniels Electronics Ltd. dbo Cod'),(88348819456,'LiteonMo','Liteon, Mobile Media Solution SB'),(88365596672,'Systimax','Systimax Solutions'),(88382373888,'Esu','ESU AG'),(88399151104,'2wire','2Wire, Inc.'),(88415928320,'Phonic','Phonic Corp.'),(88432705536,'ZhiyuanE','ZHIYUAN Eletronics co.,ltd.'),(88449482752,'VikingDe','Viking Design Technology'),(88466259968,'Helicomm','Helicomm Inc'),(88483037184,'Motorola','Motorola Mobility, Inc.'),(88499814400,'NokotaCo','Nokota Communications, LLC'),(88516591616,'Hf','HF Company'),(88533368832,'SoundId','Sound ID Inc.'),(88550146048,'Ubone','UbONE Co., Ltd'),(88566923264,'SystemAn','System and Chips, Inc.'),(88583700480,'Accsense','Accsense, Inc.'),(88600477696,'Synchron','Synchronous Communication Corp'),(88617254912,'CoreMicr','Core Micro Systems Inc.'),(88634032128,'VitelecB','Vitelec BV'),(88650809344,'HonHaiPr','Hon Hai Precision Ind. Co., Ltd.'),(88667586560,'GemtekTe','Gemtek Technology Co., Ltd.'),(88684363776,'Teraneti','Teranetics, Inc.'),(88701140992,'NokiaDan','Nokia Danmark A/S'),(88717918208,'Cisco','CISCO SYSTEMS, INC.'),(88734695424,'Cisco','CISCO SYSTEMS, INC.'),(88751472640,'AshlyAud','Ashly Audio, Inc.'),(88768249856,'SenhaiEl','Senhai Electronic Technology Co.'),(88785027072,'Bountifu','Bountiful WiFi'),(88801804288,'GassnerW','Gassner Wiege- und MeÃŸtechnik G'),(88818581504,'Wizlogic','Wizlogics Co., Ltd.'),(88835358720,'DatasymP','Datasym POS Inc.'),(88852135936,'NaeilCom','Naeil Community'),(88868913152,'Avitec','Avitec AB'),(88885690368,'Mcubelog','mCubelogics Corporation'),(88902467584,'Corestar','CoreStar International Corp'),(88919244800,'GeneralD','General Dynamics United Kingdom '),(88936022016,'Physiome','PHYSIOMETRIX,INC'),(88952799232,'EnswerTe','Enswer Technology Inc.'),(88969576448,'ArInfote','AR Infotek Inc.'),(88986353664,'Hill-Rom',''),(89003130880,'MstarSem','MSTAR SEMICONDUCTOR'),(89019908096,'CarversS','Carvers SA de CV'),(89036685312,'OpenInte','Open Interface North America'),(89053462528,'Synectic','SYNECTIC TELECOM EXPORTS PVT. LT'),(89070239744,'Incnetwo','incNETWORKS, Inc'),(89087016960,'WinkComm','Wink communication technology CO'),(89103794176,'Cisco-Li','Cisco-Linksys LLC'),(89120571392,'Symstrea','Symstream Technology Group Ltd'),(89137348608,'USRoboti','U.S. Robotics Corporation'),(89154125824,'Hewlett-','Hewlett-Packard Company'),(89170903040,'SeagateT','Seagate Technology'),(89187680256,'Vitelcom','Vitelcom Mobile Technology'),(89204457472,'AliveTec','Alive Technologies Pty Ltd'),(89221234688,'Quixant','Quixant Ltd'),(89238011904,'Nortel',''),(89254789120,'Contempo','Contemporary Research Corp'),(89271566336,'BrocadeC','Brocade Communications Systems, '),(89288343552,'KeyRadio','Key Radio Systems Limited'),(89305120768,'Lifesync','LifeSync Corporation'),(89321897984,'Zetec','Zetec, Inc.'),(89338675200,'Digitalz','DigitalZone Co., Ltd.'),(89355452416,'Nf','NF CORPORATION'),(89372229632,'InvisioC','INVISIO Communications'),(89389006848,'Bti','BTI Systems Inc.'),(89405784064,'Trendnet',''),(89422561280,'KyudenTe','Kyuden Technosystems Corporation'),(89439338496,'Sepsa',''),(89456115712,'KTechnol','K Technology Corporation'),(89472892928,'DatangTe','Datang Telecom Technology CO. , '),(89489670144,'Jeongmin','Jeongmin Electronics Co.,Ltd.'),(89506447360,'Datastor','Datastore Technology Corp'),(89523224576,'Bio-Logi','bio-logic SA'),(89540001792,'IpFabric','IP Fabrics, Inc.'),(89556779008,'Huntleig','Huntleigh Healthcare'),(89573556224,'ElmaTren','Elma Trenew Electronic GmbH'),(89590333440,'Communic','Communication System Design & Ma'),(89607110656,'Covergen','Covergence Inc.'),(89623887872,'SageInst','Sage Instruments Inc.'),(89640665088,'Hi-PTech','HI-P Tech Corporation'),(89657442304,'LetS','LET`S Corporation'),(89674219520,'DataDisp','Data Display AG'),(89690996736,'Datacom','datacom systems inc.'),(89707773952,'Mm-Lab','mm-lab GmbH'),(89724551168,'Infinias','infinias, LLC'),(89741328384,'Alticast',''),(89758105600,'AimInfra','AIM Infrarotmodule GmbH'),(89774882816,'Stolinx','Stolinx,. Inc'),(89791660032,'Motorola','Motorola Mobility, Inc.'),(89808437248,'NortechI','Nortech International'),(89825214464,'SDigmSaf','S Digm Inc. (Safe Paradigm Inc.)'),(89841991680,'Awarepoi','AwarePoint Corporation'),(89858768896,'AcroTele','Acro Telecom'),(89875546112,'Airak','Airak, Inc.'),(89892323328,'WesternD','Western Digital Technologies, In'),(89909100544,'TzeroTec','TZero Technologies, Inc.'),(89925877760,'Business','Business Security OL AB'),(89942654976,'Cisco','CISCO SYSTEMS, INC.'),(89959432192,'Cisco','CISCO SYSTEMS, INC.'),(89976209408,'Vixs','ViXS Systems Inc'),(89992986624,'DektecDi','DekTec Digital Video B.V.'),(90009763840,'OsiSecur','OSI Security Devices'),(90026541056,'JuniperN','Juniper Networks, Inc.'),(90043318272,'Crevis','CREVIS Co., LTD'),(90060095488,'Scientif','Scientific Atlanta'),(90076872704,'VantageC','Vantage Controls'),(90093649920,'AsgaSA','AsGa S.A.'),(90110427136,'Technica','Technical Solutions Inc.'),(90127204352,'Extandon','Extandon, Inc.'),(90143981568,'ThecusTe','Thecus Technology Corp.'),(90160758784,'ArtechEl','Artech Electronics'),(90177536000,'PreciseA','Precise Automation, Inc.'),(90194313216,'IntelCor','Intel Corporate'),(90211090432,'Lexbox',''),(90227867648,'BetaTech','BETA tech'),(90244644864,'Proficom','PROFIcomms s.r.o.'),(90261422080,'GamePlus','GAME PLUS CO., LTD.'),(90278199296,'Actionte','Actiontec Electronics, Inc'),(90294976512,'NeoPhoto','Neo Photonics'),(90311753728,'Renaissa','Renaissance Learning Inc'),(90328530944,'GlobalTa','Global Target Enterprise Inc'),(90345308160,'PlusTech','Plus Technology Co., Ltd'),(90362085376,'Sonoa','Sonoa Systems, Inc'),(90378862592,'SageInfo','SAGE INFOTECH LTD.'),(90395639808,'Avm','AVM GmbH'),(90412417024,'HoanaMed','Hoana Medical, Inc.'),(90429194240,'Openbrai','OPENBRAIN TECHNOLOGIES CO., LTD.'),(90445971456,'Mingjong',''),(90462748672,'Techsphe','Techsphere Co., Ltd'),(90479525888,'DataCent','Data Center Systems'),(90496303104,'ZurichUn','Zurich University of Applied Sci'),(90513080320,'EfsSas','EFS sas'),(90529857536,'HuZhouNa','Hu Zhou NAVA Networks&Electronic'),(90546634752,'Leipold+','Leipold+Co.GmbH'),(90563411968,'Uriel','URIEL SYSTEMS INC.'),(90580189184,'IntelCor','Intel Corporate'),(90596966400,'Shenzhen','Shenzhen 10MOONS Technology Deve'),(90613743616,'Storeage','StoreAge Networking Technologies'),(90630520832,'HunterEn','Hunter Engineering Company'),(90647298048,'Isilon','Isilon Systems Inc.'),(90664075264,'Leneco',''),(90680852480,'M2i','M2I CORPORATION'),(90697629696,'Ethernet','Ethernet Powerlink Standardizati'),(90714406912,'Multivis','Multivision Intelligent Surveill'),(90731184128,'Radiocra','Radiocrafts AS'),(90747961344,'Horoquar','Horoquartz'),(90764738560,'DeaSecur','Dea Security'),(90781515776,'MeteorCo','Meteor Communications Corporatio'),(90798292992,'Numatics','Numatics, Inc.'),(90815070208,'Chamberl','Chamberlain Access Solutions'),(90831847424,'RemoteTe','Remote Technologies Inc'),(90848624640,'BalboaIn','Balboa Instruments'),(90865401856,'BeaconMe','Beacon Medical Products LLC d.b.'),(90882179072,'N3','N3 Corporation'),(90898956288,'Nokia','Nokia GmbH'),(90915733504,'Cisco','CISCO SYSTEMS, INC.'),(90932510720,'Cisco','CISCO SYSTEMS, INC.'),(90949287936,'TenxNetw','TenX Networks, LLC'),(90966065152,'Packetho','PacketHop, Inc.'),(90982842368,'Motorola','Motorola Mobility, Inc.'),(90999619584,'Emc','EMC Corporation'),(91016396800,'Kocom',''),(91033174016,'Consumer','Consumer Technologies Group, LLC'),(91049951232,'Nadam','NADAM.CO.,LTD'),(91066728448,'ABeltrÃ³n','A BeltrÃ³nica-Companhia de Comun'),(91083505664,'Ote','OTE Spa'),(91100282880,'Powertec','Powertech co.,Ltd'),(91117060096,'VentusNe','Ventus Networks'),(91133837312,'Rfid','RFID, Inc.'),(91150614528,'Technodr','Technodrive SRL'),(91167391744,'Shenzhen','Shenzhen Syscan Technology Co.,L'),(91184168960,'EmhMeter','EMH metering GmbH & Co. KG'),(91200946176,'Kprotech','Kprotech Co., Ltd.'),(91217723392,'ElimProd','ELIM PRODUCT CO.'),(91234500608,'Q-MaticS','Q-Matic Sweden AB'),(91251277824,'AlcatelA','Alcatel Alenia Space Italia'),(91268055040,'Nortel',''),(91284832256,'Stratali','StrataLight Communications, Inc.'),(91301609472,'Microhar','MICROHARD S.R.L.'),(91318386688,'Aberdeen','Aberdeen Test Center'),(91335163904,'ComSAT','coM.s.a.t. AG'),(91351941120,'Seecode','SEECODE Co., Ltd.'),(91368718336,'ItgWorld','ITG Worldwide Sdn Bhd'),(91385495552,'AizenSol','AiZen Solutions Inc.'),(91402272768,'CubeTech','CUBE TECHNOLOGIES'),(91419049984,'DixtalBi','Dixtal Biomedica Ind. Com. Ltda'),(91435827200,'WanshihE','WANSHIH ELECTRONIC CO., LTD'),(91452604416,'WondePro','Wonde Proud Technology Co., Ltd'),(91469381632,'Saunders','Saunders Electronics'),(91486158848,'Netronom','Netronome Systems, Inc.'),(91502936064,'Iec',''),(91519713280,'OneRfTec','one RF Technology'),(91536490496,'NitsTech','Nits Technology Inc'),(91553267712,'Radiopul','RadioPulse Inc.'),(91570044928,'Wi-Gear','Wi-Gear Inc.'),(91586822144,'Cytyc','Cytyc Corporation'),(91603599360,'AtalumWi','Atalum Wireless S.A.'),(91620376576,'Dfm','DFM GmbH'),(91637153792,'SagemCom','SAGEM COMMUNICATION'),(91653931008,'Olivetti',''),(91670708224,'Foxconn',''),(91687485440,'Securapl','Securaplane Technologies, Inc.'),(91704262656,'Dainippo','DAINIPPON PHARMACEUTICAL CO., LT'),(91721039872,'Sampo','Sampo Corporation'),(91737817088,'DresserW','Dresser Wayne'),(91754594304,'Microsof','Microsoft Corporation'),(91771371520,'MorganSt','Morgan Stanley'),(91788148736,'Greenpea','GreenPeak Technologies'),(91804925952,'Hewlett-','Hewlett-Packard Company'),(91821703168,'Jjplus','JJPlus Corporation'),(91838480384,'Cisco','CISCO SYSTEMS, INC.'),(91855257600,'Cisco','CISCO SYSTEMS, INC.'),(91872034816,'Behringe','BEHRINGER Spezielle Studiotechni'),(91888812032,'XiamenYe','XIAMEN YEALINK NETWORK TECHNOLOG'),(91905589248,'A-FirstT','A-First Technology Co., Ltd.'),(91922366464,'Radwin','RADWIN Inc.'),(91939143680,'Dilithiu','Dilithium Networks'),(91955920896,'PecoIi','PECO II, Inc.'),(91972698112,'Dg2lTech','DG2L Technologies Pvt. Ltd.'),(91989475328,'Perfisan','Perfisans Networks Corp.'),(92006252544,'SaneSyst','SANE SYSTEM CO., LTD'),(92023029760,'Ubiquiti','Ubiquiti Networks Inc.'),(92039806976,'AWCommun','A. W. Communication Systems Ltd'),(92056584192,'XiranetC','Xiranet Communications GmbH'),(92073361408,'SymbolTe','Symbol TechnologiesWholly owned '),(92090138624,'Nolan','Nolan Systems'),(92106915840,'Red-Lemo','Red-Lemon'),(92123693056,'NewsoftT','NewSoft  Technology Corporation'),(92140470272,'HorizonS','Horizon Semiconductors Ltd.'),(92157247488,'NevisNet','Nevis Networks Inc.'),(92174024704,'Labitec-','LABiTec - Labor Biomedical Techn'),(92190801920,'AlliedTe','Allied Telesis'),(92207579136,'Audio/Vi','Audio / Video Innovations'),(92224356352,'Lunatone','Lunatone Industrielle Elektronik'),(92241133568,'TelefinS','Telefin S.p.A.'),(92257910784,'LeuzeEle','Leuze electronic GmbH + Co. KG'),(92274688000,'DaveNetw','Dave Networks, Inc.'),(92291465216,'Posdata','POSDATA CO., LTD.'),(92308242432,'WeidmÃ¼ll','WeidmÃ¼ller Interface GmbH & Co.'),(92325019648,'ChuangIn','ChuanG International Holding CO.'),(92341796864,'U-Way','U-WAY CORPORATION'),(92358574080,'Makus','MAKUS Inc.'),(92375351296,'PulseEig','Pulse Eight Limited'),(92392128512,'Ivt','IVT corporation'),(92408905728,'SchenckP','Schenck Process GmbH'),(92425682944,'Aonvisio','Aonvision Technolopy Corp.'),(92442460160,'XiamenOv','Xiamen Overseas Chinese Electron'),(92459237376,'Takenaka','Takenaka Seisakusho Co.,Ltd'),(92476014592,'BaldaSol','Balda Solution Malaysia Sdn Bhd'),(92492791808,'D-MaxTec','D-MAX Technology Co.,Ltd'),(92509569024,'SurecomT','SURECOM Technology Corp.'),(92526346240,'ParkAir','Park Air Systems Ltd'),(92543123456,'LiabAps','Liab ApS'),(92559900672,'Jennic','Jennic Ltd'),(92576677888,'Plustek','Plustek.INC'),(92593455104,'NttAdvan','NTT Advanced Technology Corporat'),(92610232320,'Hectroni','Hectronic GmbH'),(92627009536,'Rlw','RLW Inc.'),(92643786752,'FacomUkM','Facom UK Ltd (Melksham)'),(92660563968,'U4eaTech','U4EA Technologies Inc.'),(92677341184,'Bixolon','BIXOLON CO.,LTD'),(92694118400,'QuesterT','Quester Tangent Corporation'),(92710895616,'ArrisInt','ARRIS International'),(92727672832,'AetaAudi','AETA AUDIO SYSTEMS'),(92744450048,'Kolektor','Kolektor group'),(92761227264,'SamsungE','Samsung Electronics Co., LTD'),(92778004480,'Motorola','Motorola Mobility, Inc.'),(92794781696,'Nortel',''),(92811558912,'B-KyungS','B-KYUNG SYSTEM Co.,Ltd.'),(92828336128,'MinicomA','Minicom Advanced Systems ltd'),(92845113344,'MadCatzI','Mad Catz Interactive Inc'),(92861890560,'Terascal','Terascala, Inc.'),(92878667776,'NokiaDan','Nokia Danmark A/S'),(92895444992,'Eca-Sint','ECA-SINTERS'),(92912222208,'ArrisInt','ARRIS International'),(92928999424,'ArrisInt','ARRIS International'),(92945776640,'ArrisInt','ARRIS International'),(92962553856,'Dci','DCI Co., Ltd.'),(92979331072,'DigitalE','Digital Electronics Products Ltd'),(92996108288,'Robatech','Robatech AG'),(93012885504,'Motorola','Motorola Mobility, Inc.'),(93029662720,'KwangWoo','KWANG WOO I&C CO.,LTD'),(93046439936,'Rextechn','Rextechnik International Co.,'),(93063217152,'ProSound','PRO CO SOUND INC'),(93079994368,'Capelon','Capelon AB'),(93096771584,'Accedian','Accedian Networks'),(93113548800,'KyungIl','kyung il'),(93130326016,'Azurewav','AzureWave Technologies, Inc.'),(93147103232,'Autotele','AUTOTELENET CO.,LTD'),(93163880448,'Ambient','Ambient Corporation'),(93180657664,'Advanced','Advanced Industrial Computer, In'),(93197434880,'Caretech','Caretech AB'),(93214212096,'PolymapW','Polymap  Wireless LLC'),(93230989312,'CiNetwor','CI Network Corp.'),(93247766528,'Shinmayw','ShinMaywa Industries, Ltd.'),(93264543744,'Toshiba',''),(93281320960,'Tahoe',''),(93298098176,'SamsungE','Samsung Electronics Co., Ltd.'),(93314875392,'Iba','iba AG'),(93331652608,'SmaSolar','SMA Solar Technology AG'),(93348429824,'Develco',''),(93365207040,'Group4Te','Group 4 Technology Ltd'),(93381984256,'Iqua','Iqua Ltd.'),(93398761472,'Technico','technicob'),(93415538688,'DigitalT','DIGITAL TELEMEDIA CO.,LTD.'),(93432315904,'SonyComp','SONY Computer Entertainment inc,'),(93449093120,'3mGerman','3M Germany'),(93465870336,'RufTelem','Ruf Telematik AG'),(93482647552,'Flovel','FLOVEL CO., LTD.'),(93499424768,'DellEsgP','Dell ESG PCBA Test'),(93516201984,'Cisco','CISCO SYSTEMS, INC.'),(93532979200,'Cisco','CISCO SYSTEMS, INC.'),(93549756416,'Flexipan','FlexiPanel Ltd'),(93566533632,'Gumstix','Gumstix, Inc'),(93583310848,'Terareco','TeraRecon, Inc.'),(93600088064,'SurfComm','Surf Communication Solutions Ltd'),(93616865280,'Uquest','UQUEST, LTD.'),(93633642496,'Exartech','Exartech International Corp.'),(93650419712,'ArrisInt','ARRIS International'),(93667196928,'ArrisInt','ARRIS International'),(93683974144,'ArrisInt','ARRIS International'),(93700751360,'ArrisGro','ARRIS Group, Inc.'),(93717528576,'Xantech','Xantech Corporation'),(93734305792,'Pantech&','Pantech&Curitel Communications, '),(93751083008,'Emitor','Emitor AB'),(93767860224,'Nicevt',''),(93784637440,'OslinkSp','OSLiNK Sp. z o.o.'),(93801414656,'Reti','Reti Corporation'),(93818191872,'Interlin','Interlink Electronics'),(93834969088,'PkcElect','PKC Electronics Oy'),(93851746304,'IritelAD','IRITEL A.D.'),(93868523520,'Canesta','Canesta Inc.'),(93885300736,'Kt&C','KT&C Co., Ltd.'),(93902077952,'IpContro','IP Control Systems Ltd.'),(93918855168,'NokiaDan','Nokia Danmark A/S'),(93935632384,'ClivetSP','Clivet S.p.A.'),(93952409600,'St-Erics','ST-Ericsson'),(93969186816,'Picochip','Picochip Ltd'),(93985964032,'DrIngHer','Dr.Ing. Herbert Knauer GmbH'),(94002741248,'DreamTec','Dream Technologies Corporation'),(94019518464,'ZimmerEl','Zimmer Elektromedizin'),(94036295680,'Cheertek','Cheertek Inc.'),(94053072896,'MobileTe','MOBILE TECHNIKA Inc.'),(94069850112,'QuantecT','Quantec Tontechnik'),(94086627328,'Nortel',''),(94103404544,'D-Link','D-Link Corporation'),(94120181760,'Tellumat','Tellumat (Pty) Ltd'),(94136958976,'Zte','ZTE CORPORATION'),(94153736192,'BocaDevi','Boca Devices LLC'),(94170513408,'FulcrumM','Fulcrum Microsystems, Inc.'),(94187290624,'OmnexCon','Omnex Control Systems'),(94204067840,'NecTokin','NEC TOKIN Corporation'),(94220845056,'EgoBv','EGO BV'),(94237622272,'KylinkCo','KYLINK Communications Corp.'),(94254399488,'AsustekC','ASUSTek COMPUTER INC.'),(94271176704,'Peltor','PELTOR AB'),(94287953920,'Eventide',''),(94304731136,'Sustaina','Sustainable Energy Systems'),(94321508352,'ScienceA','SCIENCE AND ENGINEERING SERVICES'),(94338285568,'Wintecro','Wintecronics Ltd.'),(94355062784,'Kingtron','Kingtronics Industrial Co. Ltd.'),(94371840000,'Cisco','CISCO SYSTEMS, INC.'),(94388617216,'Cisco','CISCO SYSTEMS, INC.'),(94405394432,'SetexSch','setex schermuly textile computer'),(94422171648,'Littelfu','Littelfuse Startco'),(94438948864,'Complete','Complete Media Systems'),(94455726080,'Schillin','SCHILLING ROBOTICS LLC'),(94472503296,'NovatelW','Novatel Wireless, Inc.'),(94489280512,'Cellebri','CelleBrite Mobile Synchronizatio'),(94506057728,'Buffalo','Buffalo Inc.'),(94522834944,'CeyonTec','CEYON TECHNOLOGY CO.,LTD.'),(94539612160,'Coolksky','COOLKSKY Co., LTD'),(94556389376,'Sigpro',''),(94573166592,'Yorkvill','YORKVILLE SOUND INC.'),(94589943808,'IdealInd','Ideal Industries'),(94606721024,'CurvesIn','Curves International Inc.'),(94623498240,'SequansC','Sequans Communications'),(94640275456,'UnitechE','Unitech electronics co., ltd.'),(94657052672,'SweexEur','SWEEX Europe BV'),(94673829888,'TvworksL','TVWorks LLC'),(94690607104,'LplDevel','LPL  DEVELOPMENT S.A. DE C.V'),(94707384320,'BeHere','Be Here Corporation'),(94724161536,'OpticaTe','Optica Technologies Inc.'),(94740938752,'BadgerMe','BADGER METER INC'),(94757715968,'CarinaTe','Carina Technology'),(94774493184,'AlteconS','Altecon Srl'),(94791270400,'OtsukaEl','Otsuka Electronics Co., Ltd.'),(94808047616,'Librestr','LibreStream Technologies Inc.'),(94824824832,'Picoseco','Picosecond Pulse Labs'),(94841602048,'Nittan','Nittan Company, Limited'),(94858379264,'BrowanCo','BROWAN COMMUNICATION INC.'),(94875156480,'Msi',''),(94891933696,'Hivion','HIVION Co., Ltd.'),(94908710912,'Lancelan','Lancelan Technologies S.L.'),(94925488128,'Dametric','Dametric AB'),(94942265344,'Micronet','Micronet Corporation'),(94959042560,'E:Cue',''),(94975819776,'Innovati','Innovative Wireless Technologies'),(94992596992,'Woojinne','Woojinnet'),(95009374208,'Sunwavet','SUNWAVETEC Co., Ltd.'),(95026151424,'SonyEric','Sony Ericsson Mobile Communicati'),(95042928640,'Colorado','Colorado Vnet'),(95059705856,'Bbh','BBH SYSTEMS GMBH'),(95076483072,'Interval','Interval Media'),(95093260288,'Teneros','Teneros, Inc.'),(95110037504,'Impinj','Impinj, Inc.'),(95126814720,'Motorola','Motorola Mobility, Inc.'),(95143591936,'Embedded','embedded-logic DESIGN AND MORE G'),(95160369152,'UltraEle','Ultra Electronics Manufacturing '),(95177146368,'Nivus','Nivus GmbH'),(95193923584,'AntikCom','Antik computers & communications'),(95210700800,'TogamiEl','Togami Electric Mfg.co.,Ltd.'),(95227478016,'Xanboo',''),(95244255232,'Stnet','STNet Co., Ltd.'),(95261032448,'SpaceShu','Space Shuttle Hi-Tech Co., Ltd.'),(95277809664,'GeutebrÃ¼','GeutebrÃ¼ck GmbH'),(95294586880,'VativTec','Vativ Technologies'),(95311364096,'Xteam',''),(95328141312,'SamsungE','SAMSUNG ELECTRONICS CO., LTD.'),(95344918528,'OxfordDi','Oxford Diagnostics Ltd.'),(95361695744,'Mathtech','Mathtech, Inc.'),(95378472960,'Hewlett-','Hewlett-Packard Company'),(95395250176,'QuantaCo','Quanta Computer Inc.'),(95412027392,'Citel','CITEL SpA'),(95428804608,'Tecom','TECOM Co., Ltd.'),(95445581824,'Ubiquam','UBIQUAM Co.,Ltd'),(95462359040,'YvesTech','YVES TECHNOLOGY CO., LTD.'),(95479136256,'Vertexrs','VertexRSI/General Dynamics'),(95495913472,'ReboxBV','Rebox B.V.'),(95512690688,'Tsinghua','Tsinghua Tongfang Legend Silicon'),(95529467904,'Xensourc','Xensource, Inc.'),(95546245120,'Crete','CReTE SYSTEMS Inc.'),(95563022336,'Asmobile','Asmobile Communication Inc.'),(95579799552,'Universa','Universal Global Scientific Indu'),(95596576768,'Pangolin',''),(95613353984,'Sunhillo','Sunhillo Corporation'),(95630131200,'Lite-OnT','LITE-ON Technology Corp.'),(95646908416,'PowerDis','Power Distribution, Inc.'),(95663685632,'Cisco','CISCO SYSTEMS, INC.'),(95680462848,'Cisco','CISCO SYSTEMS, INC.'),(95697240064,'Ssd','SSD Company Limited'),(95714017280,'Setone','SetOne GmbH'),(95730794496,'Vibratio','Vibration Technology Limited'),(95747571712,'QuorionD','Quorion Data Systems GmbH'),(95764348928,'PlanetIn','PLANET INT Co., Ltd'),(95781126144,'AlcatelN','Alcatel North America IP Divisio'),(95797903360,'NokiaDan','Nokia Danmark A/S'),(95814680576,'WorldEth','World Ethnic Broadcastin Inc.'),(95831457792,'HerleyGe','Herley General Microwave Israel.'),(95848235008,'Exeo','Exeo Systems'),(95865012224,'HoatechT','Hoatech Technologies, Inc.'),(95881789440,'LegoSyst','LEGO System A/S IE Electronics D'),(95898566656,'Flex-PIn','Flex-P Industries Sdn. Bhd.'),(95915343872,'FuhoTech','FUHO TECHNOLOGY Co., LTD'),(95932121088,'Nintendo','Nintendo Co., Ltd.'),(95948898304,'Aegate','Aegate Ltd'),(95965675520,'Fusionte','Fusiontech Technologies Inc.'),(95982452736,'ZMPRadwa','Z.M.P. RADWAG'),(95999229952,'HarmanSp','Harman Specialty Group'),(96016007168,'GripAudi','Grip Audio'),(96032784384,'Trackflo','Trackflow Ltd'),(96049561600,'Airdefen','AirDefense, Inc.'),(96066338816,'Precisio','Precision I/O'),(96083116032,'Fairmoun','Fairmount Automation'),(96099893248,'Nortel',''),(96116670464,'Novatium','Novatium Solutions (P) Ltd'),(96133447680,'LiyuhTec','Liyuh Technology Ltd.'),(96150224896,'KbtMobil','KBT Mobile'),(96167002112,'Prod-El','Prod-El SpA'),(96183779328,'CellonFr','Cellon France'),(96200556544,'Quantier','Quantier Communication Inc.'),(96217333760,'A-TecSub','A-TEC Subsystem INC.'),(96234110976,'EishinEl','Eishin Electronics'),(96250888192,'MrvCommu','MRV Communication (Networks) LTD'),(96267665408,'Tps',''),(96284442624,'SamsungE','Samsung Electronics'),(96301219840,'SamsungE','Samsung Electonics Digital Video'),(96317997056,'YulongCo','Yulong Computer Telecommunicatio'),(96334774272,'Arbitron','Arbitron Inc.'),(96351551488,'IntelCor','Intel Corporate'),(96368328704,'Sknet','SKNET Corporation'),(96385105920,'SymphoxI','Symphox Information Co.'),(96401883136,'ZenwayEn','Zenway enterprise ltd'),(96418660352,'Bury','Bury GmbH & Co. KG'),(96435437568,'EurocbPh','EuroCB (Phils.), Inc.'),(96452214784,'Motorola','Motorola Mobility, Inc.'),(96468992000,'IntelCor','Intel Corporate'),(96485769216,'Bihl+Wie','Bihl + Wiedemann GmbH'),(96502546432,'Shenzhen','SHENZHEN BAOAN GAOKE ELECTRONICS'),(96519323648,'EonCommu','eOn Communications'),(96536100864,'Skyworth','Skyworth Overseas Dvelopment Ltd'),(96552878080,'Haver&Bo','Haver&Boecker'),(96569655296,'IrexTech','iRex Technologies BV'),(96586432512,'Sky-Line','Sky-Line Information Co., Ltd.'),(96603209728,'Diboss','DIBOSS.CO.,LTD'),(96619986944,'Bluebird','Bluebird Soft Inc.'),(96636764160,'BallyGam','Bally Gaming + Systems'),(96653541376,'VectorIn','Vector Informatik GmbH'),(96670318592,'ProDex','Pro Dex, Inc'),(96687095808,'WebioInt','WEBIO International Co.,.Ltd.'),(96703873024,'Donjin','Donjin Co.,Ltd.'),(96720650240,'ElisaOyj','Elisa Oyj'),(96737427456,'KarlStor','Karl Storz Imaging'),(96754204672,'ChubbCsc','Chubb CSC-Vendor AP'),(96770981888,'Serveren','ServerEngines LLC'),(96787759104,'PilkorEl','Pilkor Electronics Co., Ltd'),(96804536320,'Id-Confi','id-Confirm Inc'),(96821313536,'Paralan','Paralan Corporation'),(96838090752,'DslPartn','DSL Partner AS'),(96854867968,'Korwin','KORWIN CO., Ltd.'),(96871645184,'Vimicro','Vimicro corporation'),(96888422400,'GnNetcom','GN Netcom as'),(96905199616,'J-TekInc','J-TEK INCORPORATION'),(96921976832,'Moser-Ba','Moser-Baer AG'),(96938754048,'Scientif','Scientific-Atlanta, Inc.'),(96955531264,'Powerlin','PowerLink Technology Inc.'),(96972308480,'Sennheis','Sennheiser Communications A/S'),(96989085696,'AvcTechn','AVC Technology (International) L'),(97005862912,'QdiTechn','QDI Technology (H.K.) Limited'),(97022640128,'Nec','NEC Corporation'),(97039417344,'T&AMobil','T&A Mobile Phones'),(97056194560,'TonicDvb','Tonic DVB Marketing Ltd'),(97072971776,'Quadrics','Quadrics Ltd'),(97089748992,'AlstomTr','Alstom Transport'),(97106526208,'Cisco','CISCO SYSTEMS, INC.'),(97123303424,'Cisco','CISCO SYSTEMS, INC.'),(97140080640,'TvOne','TV One Ltd'),(97156857856,'VimtronE','Vimtron Electronics Co., Ltd.'),(97173635072,'Auto-Mas','Auto-Maskin'),(97190412288,'3leafNet','3Leaf Networks'),(97207189504,'Centrali','CentraLite Systems, Inc.'),(97223966720,'Ingeteam','Ingeteam Transmission&Distributi'),(97240743936,'Ezurio','Ezurio Ltd'),(97257521152,'Tandberg','Tandberg Storage ASA'),(97274298368,'DovadoFz','Dovado FZ-LLC'),(97291075584,'AwetaG&P','AWETA G&P'),(97307852800,'Cwt','CWT CO., LTD.'),(97324630016,'2ei',''),(97341407232,'KeiCommu','Kei Communication Technology Inc'),(97358184448,'Pbi-Dans','PBI-Dansensor A/S'),(97374961664,'TohoTech','Toho Technology Corp.'),(97391738880,'Bt-Links','BT-Links Company Limited'),(97408516096,'Inventel',''),(97425293312,'Shenzhen','Shenzhen Union Networks Equipmen'),(97442070528,'Vk','VK Corporation'),(97458847744,'Kbs',''),(97475624960,'Drivecam','DriveCam Inc'),(97492402176,'Photonic','Photonicbridges (China) Co., Ltd'),(97509179392,'Private',''),(97525956608,'Motorola','Motorola Mobility, Inc.'),(97542733824,'Cisco-Li','Cisco-Linksys'),(97559511040,'SeoulCom','Seoul Commtech'),(97576288256,'SonyEric','Sony Ericsson Mobile Communicati'),(97593065472,'Procurve','ProCurve Networking'),(97609842688,'Weathern','WEATHERNEWS INC.'),(97626619904,'Law-Chai','Law-Chain Computer Technology Co'),(97643397120,'NokiaDan','Nokia Danmark A/S'),(97660174336,'AtiIndus','ATI Industrial Automation'),(97676951552,'Infranet','INFRANET, Inc.'),(97693728768,'PalodexG','PaloDEx Group Oy'),(97710505984,'Semtech','Semtech Corporation'),(97727283200,'Eleksen','Eleksen Ltd'),(97744060416,'Avtec','Avtec Systems Inc'),(97760837632,'Ba','BA Systems Inc'),(97777614848,'SirfTech','SiRF Technology, Inc.'),(97794392064,'Shenzhen','Shenzhen Xing Feng Industry Co.,'),(97811169280,'NorthAtl','North Atlantic Industries'),(97827946496,'Cisco','CISCO SYSTEMS, INC.'),(97844723712,'Cisco','CISCO SYSTEMS, INC.'),(97861500928,'NatSeatt','NAT Seattle, Inc.'),(97878278144,'Nortel',''),(97895055360,'AppleCom','Apple Computer'),(97911832576,'XcuteMob','Xcute Mobile Corp.'),(97928609792,'HijiHigh','HIJI HIGH-TECH CO., LTD.'),(97945387008,'HonHaiPr','Hon Hai Precision Ind. Co., Ltd.'),(97962164224,'HonHaiPr','Hon Hai Precision Ind. Co., Ltd.'),(97978941440,'AtechEle','ATech elektronika d.o.o.'),(97995718656,'ZatAS','ZAT a.s.'),(98012495872,'Caspian',''),(98029273088,'Wistron','Wistron Corporation'),(98046050304,'CompalCo','Compal Communications, Inc.'),(98062827520,'Synccom','Synccom Co., Ltd'),(98079604736,'TdaTechP','TDA Tech Pty Ltd'),(98096381952,'Sunways','Sunways AG'),(98113159168,'Senea','Senea AB'),(98129936384,'NingboBi','NINGBO BIRD CO.,LTD.'),(98146713600,'Futronic','Futronic Technology Co. Ltd.'),(98163490816,'SamsungE','Samsung Electronics Co., Ltd.'),(98180268032,'Archos',''),(98197045248,'Gigabeam','Gigabeam Corporation'),(98213822464,'Fast','FAST Inc'),(98230599680,'Lundinov','Lundinova AB'),(98247376896,'3com','3Com Ltd'),(98264154112,'Silicons','SiliconStor, Inc.'),(98280931328,'American','American Fibertek, Inc.'),(98297708544,'AskeyCom','ASKEY COMPUTER CORP.'),(98314485760,'Vanguard','VANGUARD SECURITY ENGINEERING CO'),(98331262976,'FordleyD','FORDLEY DEVELOPMENT LIMITED'),(98348040192,'Giga-Byt','GIGA-BYTE TECHNOLOGY CO.,LTD.'),(98364817408,'DynamixP','Dynamix Promotions Limited'),(98381594624,'SigmaDes','Sigma Designs, Inc.'),(98398371840,'TibaMedi','Tiba Medical Inc'),(98415149056,'IntelCor','Intel Corporate'),(98431926272,'IntelCor','Intel Corporate'),(98448703488,'Elitegro','Elitegroup Computer Systems Co.,'),(98465480704,'DigitalS','Digital Safety Technologies, Inc'),(98482257920,'Royaldig','RoyalDigital Inc.'),(98499035136,'KokoFitn','Koko Fitness, Inc.'),(98515812352,'Dell',''),(98532589568,'Omnisens','OmniSense, LLC'),(98549366784,'DmobileS','Dmobile System Co., Ltd.'),(98566144000,'CastInfo','CAST Information Co., Ltd'),(98582921216,'Eidicom','Eidicom Co., Ltd.'),(98599698432,'DalianGo','Dalian Golden Hualu Digital Tech'),(98616475648,'VideoPro','Video Products Group'),(98633252864,'L-3Commu','L-3 Communications, Aviation Rec'),(98650030080,'Aviqtech','AVIQTECH TECHNOLOGY CO., LTD.'),(98666807296,'CetrtaPo','CETRTA POT, d.o.o., Kranj'),(98683584512,'EciTelec','ECI Telecom Ltd.'),(98700361728,'Shenzhen','SHENZHEN MTC CO.,LTD.'),(98717138944,'Tohken','TOHKEN CO.,LTD.'),(98733916160,'JatyElec','Jaty Electronics'),(98750693376,'AlpsElec','Alps Electric Co., Ltd'),(98767470592,'WaminOpt','Wamin Optocomm Mfg Corp'),(98784247808,'Motorola','Motorola Mobility, Inc.'),(98801025024,'Kde','KDE, Inc.'),(98817802240,'OsungMid','Osung Midicom Co., Ltd'),(98834579456,'MosdanIn','MOSDAN Internation Co.,Ltd'),(98851356672,'ShincoEl','Shinco Electronics Group Co.,Ltd'),(98868133888,'MethodeE','Methode Electronics'),(98884911104,'Techfait','Techfaith Wireless Communication'),(98901688320,'Ingrid','InGrid, Inc'),(98918465536,'Hewlett-','Hewlett-Packard Company'),(98935242752,'ExaltCom','Exalt Communications'),(98952019968,'InewDigi','INEW DIGITAL COMPANY'),(98968797184,'Contela','Contela, Inc.'),(98985574400,'TwigCom','Twig Com Ltd.'),(99002351616,'DustNetw','Dust Networks Inc.'),(99019128832,'Cisco','CISCO SYSTEMS, INC.'),(99035906048,'Cisco','CISCO SYSTEMS, INC.'),(99052683264,'Casa','Casa Systems Inc.'),(99069460480,'GeHealth','GE Healthcare Bio-Sciences AB'),(99086237696,'IscoInte','ISCO International'),(99103014912,'TigerNet','Tiger NetCom'),(99119792128,'BrContro','BR Controls Nederland bv'),(99136569344,'Qstik',''),(99153346560,'QnoTechn','Qno Technology Inc.'),(99170123776,'LeicaGeo','Leica Geosystems AG'),(99186900992,'VanscoEl','Vansco Electronics Oy'),(99203678208,'Audiocod','AudioCodes USA, Inc'),(99220455424,'Winegard','Winegard Company'),(99237232640,'Innovati','Innovation Lab Corp.'),(99254009856,'NtMicros','NT MicroSystems, Inc.'),(99270787072,'Digit',''),(99287564288,'TheoBenn','Theo Benning GmbH & Co. KG'),(99304341504,'Imv','IMV Corporation'),(99321118720,'ImageSen','Image Sensing Systems, Inc.'),(99337895936,'FitreSPA','FITRE S.p.A.'),(99354673152,'Hanazede','Hanazeder Electronic GmbH'),(99371450368,'SummitDa','Summit Data Communications'),(99388227584,'StuderPr','Studer Professional Audio GmbH'),(99405004800,'LiquidCo','Liquid Computing'),(99421782016,'M2cElect','m2c Electronic Technology Ltd.'),(99438559232,'ThermoRa','Thermo Ramsey Italia s.r.l.'),(99455336448,'SelexCom','Selex Communications'),(99472113664,'Ubicod','Ubicod Co.LTD'),(99488890880,'ProwareT','Proware Technology Corp.(By Unif'),(99505668096,'GlobalTe','Global Technologies Inc.'),(99522445312,'TaejinIn','TAEJIN INFOTECH'),(99539222528,'AxcenPho','Axcen Photonics Corporation'),(99555999744,'Fxc','FXC Inc.'),(99572776960,'Neulion','NeuLion Incorporated'),(99589554176,'Automati','Automation Electronics'),(99606331392,'AsustekC','ASUSTek COMPUTER INC.'),(99623108608,'Science-','Science-Technical Center \"RISSA\"'),(99639885824,'Sfr',''),(99656663040,'AdcTelec','ADC Telecommunications'),(99673440256,'Private',''),(99690217472,'Iitron','iiTron Inc.'),(99706994688,'Industri','Industrie Dial Face S.p.A.'),(99723771904,'Internat','International Business Machines'),(99740549120,'BrightHe','Bright Headphone Electronics Com'),(99757326336,'Reach','Reach Systems Inc.'),(99774103552,'Cisco','Cisco Systems, Inc.'),(99790880768,'ExtremeE','Extreme Engineering Solutions'),(99807657984,'Neology',''),(99824435200,'Leucotro','LeucotronEquipamentos Ltda.'),(99841212416,'Belkin','Belkin Corporation'),(99857989632,'BluberiG','Bluberi Gaming Technologies Inc'),(99874766848,'Defidev',''),(99891544064,'Fujitsu','FUJITSU LIMITED'),(99908321280,'DeckSrl','Deck Srl'),(99925098496,'Araneo','Araneo Ltd.'),(99941875712,'Innotz','INNOTZ CO., Ltd'),(99958652928,'Freedom9','Freedom9 Inc.'),(99975430144,'Trimble',''),(99992207360,'Neokoros','Neokoros Brasil Ltda'),(100008984576,'HyundaeY','HYUNDAE YONG-O-SA CO.,LTD'),(100025761792,'Socomec',''),(100042539008,'NokiaDan','Nokia Danmark A/S'),(100059316224,'Millipor','Millipore'),(100076093440,'DynamicN','DYNAMIC NETWORK FACTORY, INC.'),(100092870656,'Parama-T','Parama-tech Co.,Ltd.'),(100109647872,'Icatch','iCatch Inc.'),(100126425088,'GsiGroup','GSI Group, MicroE Systems'),(100143202304,'Online','Online Corporation'),(100159979520,'Dags','DAGS, Inc'),(100176756736,'NforeTec','nFore Technology Inc.'),(100193533952,'ArkinoHi','Arkino HiTOP Corporation Limited'),(100210311168,'GeSecuri','GE Security'),(100227088384,'VinciLab','Vinci Labs Oy'),(100243865600,'RixTechn','RIX TECHNOLOGY LIMITED'),(100260642816,'Thruvisi','ThruVision Ltd'),(100277420032,'Cisco','CISCO SYSTEMS, INC.'),(100294197248,'Cisco','CISCO SYSTEMS, INC.'),(100310974464,'AcsSolut','ACS Solutions Switzerland Ltd.'),(100327751680,'Sharp','SHARP CORPORATION'),(100344528896,'DongseoS','Dongseo system.'),(100361306112,'Zed-3',''),(100378083328,'Xenolink','XENOLINK Communications Co., Ltd'),(100394860544,'NaitoDen','Naito Densei Machida MFG.CO.,LTD'),(100411637760,'Zksoftwa','ZKSoftware Inc.'),(100428414976,'SolarTec','Solar Technology, Inc.'),(100445192192,'Essentia','Essentia S.p.A.'),(100461969408,'Atmedia','ATMedia GmbH'),(100478746624,'Nortel',''),(100495523840,'AccenseT','Accense Technology, Inc.'),(100512301056,'Earforce','Earforce AS'),(100529078272,'Zinwave','Zinwave Ltd'),(100545855488,'Cymphoni','Cymphonix Corp'),(100562632704,'AvagoTec','Avago Technologies'),(100579409920,'Kiyon','Kiyon, Inc.'),(100596187136,'Pivot3','Pivot3, Inc.'),(100612964352,'Core','CORE CORPORATION'),(100629741568,'DucatiSi','DUCATI SISTEMI'),(100646518784,'PaxCompu','PAX Computer Technology(Shenzhen'),(100663296000,'ArtiIndu','Arti Industrial Electronics Ltd.'),(100680073216,'ApdCommu','APD Communications Ltd'),(100696850432,'AstroStr','ASTRO Strobel Kommunikationssyst'),(100713627648,'Laketune','Laketune Technologies Co. Ltd'),(100730404864,'Elesta','Elesta GmbH'),(100747182080,'TteGerma','TTE Germany GmbH'),(100763959296,'MesoScal','Meso Scale Diagnostics, LLC'),(100780736512,'Obsidian','Obsidian Research Corporation'),(100797513728,'CentralM','Central Music Co.'),(100814290944,'Quicktel',''),(100831068160,'AssaAblo','ASSA ABLOY AB'),(100847845376,'AzaleaNe','Azalea Networks inc'),(100864622592,'Smartlin','Smartlink Network Systems Limite'),(100881399808,'IdtInter','IDT International Limited'),(100898177024,'MeshcomT','Meshcom Technologies Inc.'),(100914954240,'Worldsma','Worldsmart Retech'),(100931731456,'AppliedB','Applied Biosystems B.V.'),(100948508672,'Greyston','Greystone Data System, Inc.'),(100965285888,'Lobenn','LoBenn Inc.'),(100982063104,'TexasIns','Texas Instruments'),(100998840320,'Motorola','Motorola Mobility, Inc.'),(101015617536,'SparrEle','Sparr Electronics Ltd'),(101032394752,'Wisembed',''),(101049171968,'BrotherB','Brother, Brother & Sons ApS'),(101065949184,'PhilipsL','Philips Lighting BV'),(101082726400,'Zenitron','Zenitron Corporation'),(101099503616,'DartsTec','DARTS TECHNOLOGIES CORP.'),(101116280832,'Teledyne','Teledyne Technologies Incorporat'),(101133058048,'Independ','Independent Witness, Inc'),(101149835264,'Checkpoi','Checkpoint Systems, Inc.'),(101166612480,'GunneboC','Gunnebo Cash Automation AB'),(101183389696,'NingboYi','NINGBO YIDONG ELECTRONIC CO.,LTD'),(101200166912,'HyundaiD','HYUNDAI DIGITECH Co, Ltd.'),(101216944128,'Lintech','LinTech GmbH'),(101233721344,'FalcomWi','Falcom Wireless Comunications Gm'),(101250498560,'Tigi','Tigi Corporation'),(101267275776,'Cisco','CISCO SYSTEMS, INC.'),(101284052992,'Cisco','CISCO SYSTEMS, INC.'),(101300830208,'Rittmeye','Rittmeyer AG'),(101317607424,'TelsyEle','Telsy Elettronica S.p.A.'),(101334384640,'AzonicTe','Azonic Technology Co., LTD'),(101351161856,'Smartire','SmarTire Systems Inc.'),(101367939072,'D-Link','D-Link Corporation'),(101384716288,'ChantSin','Chant Sincere CO., LTD.'),(101401493504,'DepragSc','DEPRAG SCHULZ GMBH u. CO.'),(101418270720,'Kelman','Kelman Limited'),(101435047936,'Sirit','Sirit Inc'),(101451825152,'Apricorn',''),(101468602368,'Robotech','RoboTech srl'),(101485379584,'3soft','3soft inc.'),(101502156800,'Camrivox','Camrivox Ltd.'),(101518934016,'MixSRL','MIX s.r.l.'),(101535711232,'Hewlett-','Hewlett-Packard Company'),(101552488448,'RalinkTe','Ralink Technology Corp'),(101569265664,'YosinEle','YOSIN ELECTRONICS CO., LTD.'),(101586042880,'MobileCo','Mobile Computing Promotion Conso'),(101602820096,'Edm','EDM Corporation'),(101619597312,'Sentivis','Sentivision'),(101636374528,'Elab-Exp','elab-experience inc.'),(101653151744,'Nintendo','Nintendo Co., Ltd.'),(101669928960,'ONeilPro','O`Neil Product Development Inc.'),(101686706176,'Acenet','AceNet Corporation'),(101703483392,'Gai-Tron','GAI-Tronics'),(101720260608,'Enermet',''),(101737037824,'NokiaDan','Nokia Danmark A/S'),(101753815040,'AcistMed','ACIST Medical Systems, Inc.'),(101770592256,'SkTelesy','SK Telesys'),(101787369472,'AftekInf','Aftek Infosys Limited'),(101804146688,'RemoteSe','Remote Security Systems, LLC'),(101820923904,'Peerless','Peerless Systems Corporation'),(101837701120,'Aquantia',''),(101854478336,'TonzeTec','Tonze Technology Co.'),(101871255552,'Novatron','NOVATRON CO., LTD.'),(101888032768,'GambroLu','Gambro Lundia AB'),(101904809984,'Sedo','SEDO CO., LTD.'),(101921587200,'SyrinxIn','Syrinx Industrial Electronics'),(101938364416,'Touchtun','Touchtunes Music Corporation'),(101955141632,'Tibetsys','Tibetsystem'),(101971918848,'TratecTe','Tratec Telecom B.V.'),(101988696064,'Coherent','Coherent Research Limited'),(102005473280,'Puretech','PureTech Systems, Inc.'),(102022250496,'CmPrecis','CM Precision Technology LTD.'),(102039027712,'AdbBroad','ADB Broadband Italia'),(102055804928,'KtfTechn','KTF Technologies Inc.'),(102072582144,'QuantaMi','Quanta Microsystems, INC.'),(102089359360,'Sonicwal','SonicWALL'),(102106136576,'CrossMat','Cross Match Technologies Inc'),(102122913792,'MaraCons','MARA Systems Consulting AB'),(102139691008,'KyoceraD','KYOCERA Document Solutions Inc.'),(102156468224,'SamsungE','Samsung Electronics Co., Ltd.'),(102173245440,'Qisda','Qisda Corporation'),(102190022656,'JuniperN','Juniper Networks'),(102206799872,'Alcatel-','Alcatel-Lucent'),(102223577088,'CecWirel','CEC Wireless R&D Ltd.'),(102240354304,'ScreenSe','Screen Service Spa'),(102257131520,'Imca-Gmb','iMCA-GmbH'),(102273908736,'OpticomC','Opticom Communications, LLC'),(102290685952,'Nortel',''),(102307463168,'Thinlinx','THINLINX PTY LTD'),(102324240384,'Etymotic','Etymotic Research, Inc.'),(102341017600,'MonsoonM','Monsoon Multimedia, Inc'),(102357794816,'SamsungE','Samsung Electronics Co., Ltd.'),(102374572032,'Bluechip','Bluechips Microhouse Co.,Ltd.'),(102391349248,'IonGeoph','ION Geophysical Corporation Inc.'),(102408126464,'MagnumSe','Magnum Semiconductor, Inc.'),(102424903680,'Aai','AAI Corporation'),(102441680896,'SpansLog','Spans Logic'),(102458458112,'CankoTec','CANKO TECHNOLOGIES INC.'),(102475235328,'Daemyung','DAEMYUNG ZERO1'),(102492012544,'ClipsalA','Clipsal Australia'),(102508789760,'Advantag','Advantage Six Ltd'),(102525566976,'Cisco','CISCO SYSTEMS, INC.'),(102542344192,'Cisco','CISCO SYSTEMS, INC.'),(102559121408,'DacosTec','DACOS Technologies Co., Ltd.'),(102575898624,'Motorola','Motorola Mobility, Inc.'),(102592675840,'TexasIns','Texas Instruments'),(102609453056,'TexasIns','Texas Instruments'),(102626230272,'TexasIns','Texas Instruments'),(102643007488,'TexasIns','Texas Instruments'),(102659784704,'TexasIns','Texas Instruments'),(102676561920,'TexasIns','Texas Instruments'),(102693339136,'TexasIns','Texas Instruments'),(102710116352,'TexasIns','Texas Instruments'),(102726893568,'TexasIns','Texas Instruments'),(102743670784,'TexasIns','Texas Instruments'),(102760448000,'Woojooit','WooJooIT Ltd.'),(102777225216,'Motorola','Motorola Mobility, Inc.'),(102794002432,'Ibm','IBM Corp'),(102810779648,'SzcomBro','SZCOM Broadband Network Technolo'),(102827556864,'RenuElec','Renu Electronics Pvt Ltd'),(102844334080,'AppleCom','Apple Computer'),(102861111296,'HarrisCo','Harris Corparation'),(102877888512,'ZeronAll','ZERON ALLIANCE'),(102894665728,'LigNeopt','LIG NEOPTEK'),(102911442944,'PyramidM','Pyramid Meriden Inc.'),(102928220160,'CemSolut','CEM Solutions Pvt Ltd'),(102944997376,'MotechIn','Motech Industries Inc.'),(102961774592,'ForcomSp','Forcom Sp. z o.o.'),(102978551808,'Microsof','Microsoft Corporation'),(102995329024,'Fa',''),(103012106240,'Suprema','Suprema Inc.'),(103028883456,'AmuletHo','Amulet Hotkey'),(103045660672,'TalosSys','TALOS SYSTEM INC.'),(103062437888,'Playline','PLAYLINE Co.,Ltd.'),(103079215104,'Unigrand','UNIGRAND LTD'),(103095992320,'Actionte','Actiontec Electronics, Inc'),(103112769536,'AlphaNet','Alpha Networks Inc.'),(103129546752,'ArcsoftS','ArcSoft Shanghai Co. LTD'),(103146323968,'E-TekDig','E-TEK DIGITAL TECHNOLOGY LIMITED'),(103163101184,'BeijingI','Beijing InHand Networking Techno'),(103179878400,'HokkeiIn','Hokkei Industries Co., Ltd.'),(103196655616,'Fanstel','Fanstel Corp.'),(103213432832,'Sightlog','SightLogix, Inc.'),(103230210048,'Cresyn',''),(103246987264,'Meraki','Meraki, Inc.'),(103263764480,'Brillian','Brilliant Telecommunications'),(103280541696,'Optelian','Optelian Access Networks'),(103297318912,'Terabyte','Terabytes Server Storage Tech Co'),(103314096128,'Avega','Avega Systems'),(103330873344,'NokiaDan','Nokia Danmark A/S'),(103347650560,'IptradeS','IPTrade S.A.'),(103364427776,'NeurosTe','Neuros Technology International,'),(103381204992,'BeijingX','Beijing Xinwei Telecom Technolog'),(103397982208,'SonyEric','Sony Ericsson Mobile Communicati'),(103414759424,'Mitutoyo','Mitutoyo Corporation'),(103431536640,'GzTechno','GZ Technologies, Inc.'),(103448313856,'Ubixon','Ubixon Co., Ltd.'),(103465091072,'DEShawRe','D. E. Shaw Research, LLC'),(103481868288,'Cisco','CISCO SYSTEMS, INC.'),(103498645504,'Cisco','CISCO SYSTEMS, INC.'),(103515422720,'Avermedi','AVerMedia Information Inc.'),(103532199936,'TaijinMe','TaiJin Metal Co., Ltd.'),(103548977152,'Exterity','Exterity Limited'),(103565754368,'AsiaElec','ASIA ELECTRONICS CO.,LTD'),(103582531584,'GdxTechn','GDX Technologies Ltd.'),(103599308800,'Palmmicr','Palmmicro Communications'),(103616086016,'W5networ','w5networks'),(103632863232,'Sindoric','SINDORICOH'),(103649640448,'CecTelec','CEC TELECOM CO.,LTD.'),(103666417664,'DeltaEle','Delta Electronics, Inc.'),(103683194880,'KimaldiE','Kimaldi Electronics, S.L.'),(103699972096,'Private',''),(103716749312,'CaleAcce','Cale Access AB'),(103733526528,'NecUnifi','NEC UNIFIED SOLUTIONS NEDERLAND '),(103750303744,'E2vTechn','e2v technologies (UK) ltd.'),(103767080960,'Gatsomet','Gatsometer'),(103783858176,'TaiwanVi','Taiwan Video & Monitor'),(103800635392,'Softier',''),(103817412608,'AscendNe','Ascend Networks, Inc.'),(103834189824,'ArtecDes','Artec Design'),(103850967040,'Xstreamh','XStreamHD, LLC'),(103867744256,'TexasIns','Texas Instruments'),(103884521472,'TexasIns','Texas Instruments'),(103901298688,'TexasIns','Texas Instruments'),(103918075904,'TexasIns','Texas Instruments'),(103934853120,'TexasIns','Texas Instruments'),(103951630336,'TexasIns','Texas Instruments'),(103968407552,'Thoratec','Thoratec / ITC'),(103985184768,'Reliance','Reliance Electric Limited'),(104001961984,'Universa','Universal ABIT Co., Ltd.'),(104018739200,'Panacces','PanAccess Communications,Inc.'),(104035516416,'Cisco-Li','Cisco-Linksys LLC'),(104052293632,'WestellT','Westell Technologies'),(104069070848,'Cenits','CENITS Co., Ltd.'),(104085848064,'EncoreSo','Encore Software Limited'),(104102625280,'VertexLi','Vertex Link Corporation'),(104119402496,'Digilent','Digilent, Inc'),(104136179712,'2wire','2Wire, Inc'),(104152956928,'3Phoenix','3 Phoenix, Inc.'),(104169734144,'HighTech','High Tech Computer Corp'),(104186511360,'NokiaDan','Nokia Danmark A/S'),(104203288576,'Dawevisi','Dawevision Ltd'),(104220065792,'HeadsUpT','Heads Up Technologies, Inc.'),(104236843008,'Pulsar-T','Pulsar-Telecom LLC.'),(104253620224,'CryptoSA','Crypto S.A.'),(104270397440,'AcenetTe','AceNet Technology Inc.'),(104287174656,'VecimaNe','Vecima Networks Inc.'),(104303951872,'PigeonPo','Pigeon Point Systems LLC'),(104320729088,'Catcher','Catcher, Inc.'),(104337506304,'LasVegas','Las Vegas Gaming, Inc.'),(104354283520,'BogenCom','Bogen Communications'),(104371060736,'Netgear','Netgear Inc.'),(104387837952,'LianheTe','Lianhe Technologies, Inc.'),(104404615168,'8WaysTec','8 Ways Technology Corp.'),(104421392384,'SecfoneK','Secfone Kft'),(104438169600,'Swsoft',''),(104454946816,'Storlink','StorLink Semiconductors, Inc.'),(104471724032,'AteraNet','Atera Networks LTD.'),(104488501248,'Argard','Argard Co., Ltd'),(104505278464,'Aeromari','Aeromaritime Systembau GmbH'),(104522055680,'Eyefi','EyeFi, Inc'),(104538832896,'Unilever','Unilever R&D'),(104555610112,'Tagmaste','TagMaster AB'),(104572387328,'Strawber','Strawberry Linux Co.,Ltd.'),(104589164544,'Ucontrol','uControl, Inc.'),(104605941760,'NetworkC','Network Chemistry, Inc'),(104622718976,'EdsLabPt','EDS Lab Pte Ltd'),(104639496192,'TaiguenT','TAIGUEN TECHNOLOGY (SHEN-ZHEN) C'),(104656273408,'Nexterm','Nexterm Inc.'),(104673050624,'Tac','TAC Inc.'),(104689827840,'SimTechn','SIM Technology Group Shanghai Si'),(104706605056,'Ooma','Ooma, Inc.'),(104723382272,'SeagateT','Seagate Technology'),(104740159488,'Veritech','Veritech Electronics Limited'),(104756936704,'Eaton','Eaton Corporation'),(104773713920,'SiemensH','Siemens Healthcare Diagnostics M'),(104790491136,'LeutronV','Leutron Vision'),(104807268352,'Datalogi','Datalogic ADC'),(104824045568,'Scientif','Scientific Atlanta, A Cisco Comp'),(104840822784,'Kingjim',''),(104857600000,'GlobalLi','Global Link Digital Technology C'),(104874377216,'SambuCom','Sambu Communics CO., LTD.'),(104891154432,'Neonode','Neonode AB'),(104907931648,'Zhenjian','Zhenjiang Sapphire Electronic In'),(104924708864,'3com','3Com Ltd'),(104941486080,'SethaInd','Setha Industria Eletronica LTDA'),(104958263296,'E28Shang','E28 Shanghai Limited'),(104975040512,'Hewlett-','Hewlett-Packard Company'),(104991817728,'Expertis','Expertise Engineering'),(105008594944,'Cisco','CISCO SYSTEMS, INC.'),(105025372160,'Cisco','CISCO SYSTEMS, INC.'),(105042149376,'AnaciseT','AnaCise Testnology Pte Ltd'),(105058926592,'Wowwee','WowWee Ltd.'),(105075703808,'Amplex','Amplex A/S'),(105092481024,'Mackware','Mackware GmbH'),(105109258240,'Dsys',''),(105126035456,'Wiremold',''),(105142812672,'4nsys','4NSYS Co. Ltd.'),(105159589888,'Intercro','INTERCROSS, LLC'),(105176367104,'Armorlin','Armorlink shanghai Co. Ltd'),(105193144320,'RgbSpect','RGB Spectrum'),(105209921536,'Zodianet',''),(105226698752,'MaximInt','Maxim Integrated Products'),(105243475968,'BuyangEl','Buyang Electronics Industrial Co'),(105260253184,'HuaweiTe','Huawei Technologies Co., Ltd.'),(105277030400,'Formosa2','FORMOSA21 INC.'),(105293807616,'FonTechn','Fon Technology S.L.'),(105310584832,'Avigilon','Avigilon Corporation'),(105327362048,'El-Tech','EL-TECH, INC.'),(105344139264,'Metasyst','Metasystem SpA'),(105360916480,'GotiveAS','GOTIVE a.s.'),(105377693696,'WinnetSo','WinNet Solutions Limited'),(105394470912,'Infinova','Infinova LLC'),(105411248128,'DellEsgP','Dell ESG PCBA Test'),(105428025344,'MobileAc','Mobile Action Technology Inc.'),(105444802560,'NokiaDan','Nokia Danmark A/S'),(105461579776,'Ekahau','Ekahau, Inc.'),(105478356992,'Montgome','Montgomery Technology, Inc.'),(105495134208,'Radiocom','RadioCOM, s.r.o.'),(105511911424,'Zhongsha','Zhongshan General K-mate Electro'),(105528688640,'Ads-Tec','ads-tec GmbH'),(105545465856,'Shenzhen','SHENZHEN PHOTON BROADBAND TECHNO'),(105562243072,'Zimocom',''),(105579020288,'HansunTe','Hansun Technologies Inc.'),(105595797504,'GreatWel','Great Well Electronic LTD'),(105612574720,'Jess-Lin','JESS-LINK PRODUCTS Co., LTD'),(105629351936,'Kingstat','KINGSTATE ELECTRONICS CORPORATIO'),(105646129152,'Shenzhen','ShenZhen jieshun Science&Technol'),(105662906368,'HanaMicr','HANA Micron Inc.'),(105679683584,'Thomson','Thomson Inc.'),(105696460800,'Weldex','Weldex Corporation'),(105713238016,'Navcast','Navcast Inc.'),(105730015232,'Omnikey','OMNIKEY GmbH.'),(105746792448,'Lenntek','Lenntek Corporation'),(105763569664,'CiermaAs','Cierma Ascenseurs'),(105780346880,'TiqitCom','Tiqit Computers, Inc.'),(105797124096,'XipTechn','XIP Technology AB'),(105813901312,'ZippyTec','ZIPPY TECHNOLOGY CORP.'),(105830678528,'Motorola','Motorola Mobility, Inc.'),(105847455744,'AdigitTe','ADigit Technologies Corp.'),(105864232960,'Persiste','Persistent Systems, LLC'),(105881010176,'YoggieSe','Yoggie Security Systems LTD.'),(105897787392,'AnnealTe','AnNeal Technology Inc.'),(105914564608,'Ethernet','Ethernet Direct Corporation'),(105931341824,'ProtecFi','Protec Fire Detection plc'),(105948119040,'BeijingL','BEIJING LHWT MICROELECTRONICS IN'),(105964896256,'Shanghai','Shanghai Jiao Da HISYS Technolog'),(105981673472,'NidecSan','NIDEC SANKYO CORPORATION'),(105998450688,'Tvt','TVT CO.,LTD'),(106015227904,'SamsungE','Samsung Electronics Co., Ltd.'),(106032005120,'Nortel',''),(106048782336,'Ibm','IBM Corp'),(106065559552,'AdeunisR','ADEUNIS RF'),(106082336768,'TecWizho','TEC WizHome Co., Ltd.'),(106099113984,'DawonMed','Dawon Media Inc.'),(106115891200,'MagnaCar','Magna Carta'),(106132668416,'S3c','S3C, Inc.'),(106149445632,'D3LedLlc','D3 LED, LLC'),(106166222848,'NewVoice','New Voice International AG'),(106183000064,'Cisco','CISCO SYSTEMS, INC.'),(106199777280,'Cisco','CISCO SYSTEMS, INC.'),(106216554496,'EliwellC','Eliwell Controls srl'),(106233331712,'ZaoNvpBo','ZAO NVP Bolid'),(106250108928,'Shenzhen','SHENZHEN DVBWORLD TECHNOLOGY CO.'),(106266886144,'Ansa','ANSA Corporation'),(106283663360,'EssenceT','Essence Technology Solution, Inc'),(106300440576,'Motorola','Motorola Mobility, Inc.'),(106317217792,'AlmitecI','Almitec InformÃ¡tica e ComÃ©rcio'),(106333995008,'Firetide','Firetide, Inc'),(106350772224,'Cs','CS Corporation'),(106367549440,'RabaTech','Raba Technologies LLC'),(106384326656,'NokiaDan','Nokia Danmark A/S'),(106401103872,'OpwFuelM','OPW Fuel Management Systems'),(106417881088,'RealTime','Real Time Automation'),(106434658304,'Isonas','ISONAS Inc.'),(106451435520,'EopsTech','EOps Technology Limited'),(106468212736,'Viprinet','Viprinet GmbH'),(106484989952,'Tecobest','Tecobest Technology Limited'),(106501767168,'AxiohmSa','AXIOHM SAS'),(106518544384,'EraeElec','Erae Electronics Industry Co., L'),(106535321600,'Dreamtec','Dreamtech Co., Ltd'),(106552098816,'BaldorEl','Baldor Electric Company'),(106568876032,'AtroadAT','AtRoad,  A Trimble Company'),(106585653248,'SiemensH','Siemens Home & Office Comm. Devi'),(106602430464,'High-Gai','High-Gain Antennas LLC'),(106619207680,'Teamcast',''),(106635984896,'UnifiedD','Unified Display Interface SIG'),(106652762112,'Reigncom',''),(106669539328,'Swirlnet','Swirlnet A/S'),(106686316544,'JavadNav','Javad Navigation Systems Inc.'),(106703093760,'ArchMete','ARCH METER Corporation'),(106719870976,'Santosha','Santosha Internatonal, Inc'),(106736648192,'AmberWir','AMBER wireless GmbH'),(106753425408,'EplTechn','EPL Technology Ltd'),(106770202624,'Prostar','Prostar Co., Ltd.'),(106786979840,'Silicond','Silicondust Engineering Ltd'),(106803757056,'IntelCor','Intel Corporate'),(106820534272,'Morey','The Morey Corporation'),(106837311488,'Anaveo',''),(106854088704,'VerkerkS','Verkerk Service Systemen'),(106870865920,'TopdataS','Topdata Sistemas de Automacao Lt'),(106887643136,'Visualga','Visualgate Systems, Inc.'),(106904420352,'Yiguang',''),(106921197568,'Adhoco','Adhoco AG'),(106937974784,'Computer','Computer Hardware Design SIA'),(106954752000,'CameoCom','Cameo Communications, INC.'),(106971529216,'Hacetron','Hacetron Corporation'),(106988306432,'Numata','Numata Corporation'),(107005083648,'Alltec','Alltec GmbH'),(107021860864,'BrovisWi','BroVis Wireless Networks'),(107038638080,'WeldingT','Welding Technology Corporation'),(107055415296,'Accutech','Accutech Ultrasystems Co., Ltd.'),(107072192512,'Videolog','Videology Imaging Solutions, Inc'),(107088969728,'EscapeCo','Escape Communications, Inc.'),(107105746944,'Joytoto','JOYTOTO Co., Ltd.'),(107122524160,'Chunichi','Chunichi Denshi Co.,LTD.'),(107139301376,'BeijingT','Beijing Tianyu Communication Equ'),(107156078592,'AsustekC','ASUSTek COMPUTER INC.'),(107172855808,'EoTechni','EO TECHNICS Co., Ltd.'),(107189633024,'Shenzhen','Shenzhen Streaming Video Technol'),(107206410240,'ThomsonT','Thomson Telecom Belgium'),(107223187456,'Kameleon','Kameleon Technologies'),(107239964672,'Cisco-Li','Cisco-Linksys LLC'),(107256741888,'Vvond','VVOND, Inc.'),(107273519104,'YushinPr','Yushin Precision Equipment Co.,L'),(107290296320,'ComproTe','Compro Technology'),(107307073536,'AltecEle','Altec Electronic AG'),(107323850752,'OptimalT','Optimal Technologies Internation'),(107340627968,'Hewlett-','Hewlett-Packard Company'),(107357405184,'Powerqua','PowerQuattro Co.'),(107374182400,'Intelliv','Intelliverese - DBA Voicecom'),(107390959616,'F1media',''),(107407736832,'Cambridg','Cambridge Consultants Ltd'),(107424514048,'BigfootN','Bigfoot Networks Inc'),(107441291264,'WbElectr','WB Electronics Sp. z o.o.'),(107458068480,'SchrackS','SCHRACK Seconet AG'),(107474845696,'Cisco','CISCO SYSTEMS, INC.'),(107491622912,'Cisco','CISCO SYSTEMS, INC.'),(107508400128,'Duaxes','Duaxes Corporation'),(107525177344,'Devi-Dan','DEVI - Danfoss A/S'),(107541954560,'Hasware','HASWARE INC.'),(107558731776,'Southern','Southern Vision Systems, Inc.'),(107575508992,'EncoreEl','Encore Electronics, Inc.'),(107592286208,'Ieee1394','IEEE 1394c'),(107609063424,'AtechTec','Atech Technology Co., Ltd.'),(107625840640,'Advansus','Advansus Corp.'),(107642617856,'KnickEle','Knick Elektronische Messgeraete '),(107659395072,'JustInMo','Just In Mobile Information Techn'),(107676172288,'Welcat','Welcat Inc'),(107692949504,'Chuang-Y','Chuang-Yi Network Equipment Co.L'),(107709726720,'Winix','Winix Co., Ltd'),(107726503936,'Tecom','TECOM Co., Ltd.'),(107743281152,'Paytec','PayTec AG'),(107760058368,'Posiflex','Posiflex Inc.'),(107776835584,'Interact','Interactive Wear AG'),(107793612800,'Astel','ASTEL Inc.'),(107810390016,'Irlink',''),(107827167232,'SputnikE','Sputnik Engineering AG'),(107843944448,'Sensicas','Sensicast Systems'),(107860721664,'Nintendo','Nintendo Co., Ltd.'),(107877498880,'Beyondwi','Beyondwiz Co., Ltd.'),(107894276096,'Microlin','Microlink communications Inc.'),(107911053312,'KumeElec','KUME electric Co.,Ltd.'),(107927830528,'Elitegro','Elitegroup Computer System Co.'),(107944607744,'CmComand','CM Comandos Lineares'),(107961384960,'PhonexKo','Phonex Korea Co., LTD.'),(107978162176,'LbnlEngi','LBNL  Engineering'),(107994939392,'Intelici','Intelicis Corporation'),(108011716608,'Bitsgen','BitsGen Co., Ltd.'),(108028493824,'Imcosys','ImCoSys Ltd'),(108045271040,'SiemensT','Siemens AG, Transportation Syste'),(108062048256,'2m2bMont','2M2B Montadora de Maquinas Bahia'),(108078825472,'AntiopeA','Antiope Associates'),(108095602688,'AclaraRf','Aclara RF Systems Inc.'),(108112379904,'Motorola','Motorola Mobility, Inc.'),(108129157120,'Nokia','Nokia Corporation'),(108145934336,'Spectral','Spectral Instruments, Inc.'),(108162711552,'Cisco','CISCO SYSTEMS, INC.'),(108179488768,'Cisco','CISCO SYSTEMS, INC.'),(108196265984,'Balluff','Balluff GmbH'),(108213043200,'GudeAnal','Gude Analog- und Digialsysteme G'),(108229820416,'Strix','Strix Systems, Inc.'),(108246597632,'TrendonT','TRENDON TOUCH TECHNOLOGY CORP.'),(108263374848,'DÃ¼rrDent','DÃœRR DENTAL AG'),(108280152064,'Sterlite','STERLITE OPTICAL TECHNOLOGIES LI'),(108296929280,'Commerce','CommerceGuard AB'),(108313706496,'UmbCommu','UMB Communications Co., Ltd.'),(108330483712,'Gigamips',''),(108347260928,'Oesoluti','OESOLUTIONS'),(108364038144,'WiliboxD','Wilibox Deliberant Group LLC'),(108380815360,'Highpoin','HighPoint Technologies Incorpora'),(108397592576,'GmcGuard','GMC Guardian Mobility Corp.'),(108414369792,'AdbBroad','ADB Broadband Italia'),(108431147008,'RdiTechn','RDI technology(Shenzhen) Co.,LTD'),(108447924224,'Rackable','Rackable Systems'),(108464701440,'PitneyBo','Pitney Bowes, Inc'),(108481478656,'OnSoftwa','ON SOFTWARE INTERNATIONAL LIMITE'),(108498255872,'Belden',''),(108515033088,'FossilPa','Fossil Partners, L.P.'),(108531810304,'Ten-Tec','Ten-Tec Inc.'),(108548587520,'CianetIn','Cianet Industria e Comercio S/A'),(108565364736,'Scientif','Scientific Atlanta, A Cisco Comp'),(108582141952,'Airespid','AireSpider Networks'),(108598919168,'TentelCo','TENTEL  COMTECH CO., LTD.'),(108615696384,'Testo','TESTO AG'),(108632473600,'SagemCom','SAGEM COMMUNICATION'),(108649250816,'FujianSt','Fujian Stelcom information & Tec'),(108666028032,'AvagoTec','Avago Technologies Sdn Bhd'),(108682805248,'UltraEle','Ultra Electronics - TCS (Tactica'),(108699582464,'NokiaDan','Nokia Danmark A/S'),(108716359680,'HarmanMu','Harman Multimedia'),(108733136896,'NetconsS','NETCONS, s.r.o.'),(108749914112,'Acogito','ACOGITO Co., Ltd'),(108766691328,'Chainlea','Chainleader Communications Corp.'),(108783468544,'Leaf','Leaf Corporation.'),(108800245760,'Cisco','CISCO SYSTEMS, INC.'),(108817022976,'Cisco','CISCO SYSTEMS, INC.'),(108833800192,'SaafnetC','Saafnet Canada Inc.'),(108850577408,'Bluetoot','Bluetooth SIG, Inc.'),(108867354624,'Staccato','Staccato Communications Inc.'),(108884131840,'JenaerAn','Jenaer Antriebstechnik GmbH'),(108900909056,'D-Link','D-Link Corporation'),(108917686272,'Innotech','Innotech Corporation'),(108934463488,'Shenzhen','ShenZhen XinHuaTong Opto Electro'),(108951240704,'Motorola','Motorola Mobility, Inc.'),(108968017920,'Valemoun','Valemount Networks Corporation'),(108984795136,'Docomo','DoCoMo Systems, Inc.'),(109001572352,'Blaupunk','Blaupunkt  Embedded Systems GmbH'),(109018349568,'Commerci','Commerciant, LP'),(109035126784,'SonyEric','Sony Ericsson Mobile Communicati'),(109051904000,'Doorking','Doorking Inc.'),(109068681216,'YuhuaTel','YuHua TelTech (ShangHai) Co., Lt'),(109085458432,'Asiarock','Asiarock Technology Limited'),(109102235648,'TeldatSp','TELDAT Sp.J.'),(109119012864,'DigitalV','Digital Video Networks(Shanghai)'),(109135790080,'Nortel',''),(109152567296,'Mikrom','MikroM GmbH'),(109169344512,'Danpex','Danpex Corporation'),(109186121728,'Etrovisi','ETROVISION TECHNOLOGY'),(109202898944,'RaybitKo','Raybit Systems Korea, Inc'),(109219676160,'MetacomP','Metacom (Pty) Ltd.'),(109236453376,'Sensopar','SensoPart GmbH'),(109253230592,'Z-Com','Z-Com, Inc.'),(109270007808,'Guangzho','Guangzhou Unicomp Technology Co.'),(109286785024,'PlexusXi','Plexus (Xiamen) Co.,ltd'),(109303562240,'Zeugma','Zeugma Systems'),(109320339456,'Abocom','AboCom Systems, Inc.'),(109337116672,'BeijingH','Beijing Huisen networks technolo'),(109353893888,'XipherTe','Xipher Technologies, LLC'),(109370671104,'Aerohive','Aerohive Networks, Inc.'),(109387448320,'Datum','Datum Systems, Inc.'),(109404225536,'NokiaDan','Nokia Danmark A/S'),(109421002752,'Mazet','MAZeT GmbH'),(109437779968,'Picotest','Picotest Corp.'),(109454557184,'RiedelCo','Riedel Communications GmbH'),(109471334400,'HonHaiPr','Hon Hai Precision Ind. Co., Ltd'),(109488111616,'HonHaiPr','Hon Hai Precision Ind. Co., Ltd'),(109504888832,'Plantron','PLANTRONICS, INC.'),(109521666048,'Gridpoin','Gridpoint Systems'),(109538443264,'Vivox','Vivox Inc'),(109555220480,'Smardtv',''),(109571997696,'CctR&D','CCT R&D Limited'),(109588774912,'Estic','ESTIC Corporation'),(109605552128,'ItWatchd','IT Watchdogs, Inc'),(109622329344,'ChengHon','Cheng Hongjian'),(109639106560,'Panasoni','Panasonic Mobile Communications '),(109655883776,'Wi2wi','Wi2Wi, Inc'),(109672660992,'Sonitrol','Sonitrol Corporation'),(109689438208,'Northrop','Northrop Grumman Systems Corp.'),(109706215424,'NoveraOp','Novera Optics Korea, Inc.'),(109722992640,'Ixsea',''),(109739769856,'OceanOpt','Ocean Optics, Inc.'),(109756547072,'Oticon','Oticon A/S'),(109773324288,'AlcatelB','Alcatel Bell N.V.'),(109790101504,'ElmData','ELM DATA Co., Ltd.'),(109806878720,'Avinfo',''),(109823655936,'Adtran','ADTRAN INC.'),(109840433152,'Changshu','Changshu Switchgear MFG. Co.,Ltd'),(109857210368,'JorjinTe','Jorjin Technologies Inc.'),(109873987584,'JurongHi','Jurong Hi-Tech (Suzhou)Co.ltd'),(109890764800,'Turboche','TurboChef Technologies Inc.'),(109907542016,'SoftDevi','Soft Device Sdn Bhd'),(109924319232,'Sato','SATO CORPORATION'),(109941096448,'FujitsuT','Fujitsu Technology Solutions'),(109957873664,'Edo-Evi',''),(109974650880,'Diversif','Diversified Technical Systems, I'),(109991428096,'Ctring',''),(110008205312,'Vizio','VIZIO, Inc.'),(110024982528,'Nifty',''),(110041759744,'Dkt','DKT A/S'),(110058536960,'NihonDat','NIHON DATA SYSTENS, INC.'),(110075314176,'LgInform','LG INFORMATION & COMM.'),(110092091392,'OrdynTec','ORDYN TECHNOLOGIES'),(110108868608,'AsteelEl','asteel electronique atlantique'),(110125645824,'AustarTe','Austar Technology (hang zhou) Co'),(110142423040,'Radarfin','RadarFind Corporation'),(110159200256,'Motorola','Motorola Mobility, Inc.'),(110175977472,'Itu-T',''),(110192754688,'WiquestC','WiQuest Communications'),(110209531904,'Cisco','CISCO SYSTEMS, INC.'),(110226309120,'Cisco','CISCO SYSTEMS, INC.'),(110243086336,'Raycom','Raycom CO ., LTD'),(110259863552,'Gsp','GSP SYSTEMS Inc.'),(110276640768,'BobstSa','BOBST SA'),(110293417984,'HoplingT','Hopling Technologies b.v.'),(110310195200,'RigolTec','Rigol Technologies, Inc.'),(110326972416,'HanyangS','HanYang System'),(110343749632,'Arrow7','Arrow7 Corporation'),(110360526848,'Xynetsof','XYnetsoft Co.,Ltd'),(110377304064,'Stanford','Stanford Research Systems'),(110394081280,'Videocas','VideoCast Ltd.'),(110410858496,'FamarFue','Famar Fueguina S.A.'),(110427635712,'EuroEmme','Euro Emme s.r.l.'),(110444412928,'NokiaDan','Nokia Danmark A/S'),(110461190144,'Boundary','Boundary Devices'),(110477967360,'Dell','Dell Inc.'),(110494744576,'ParadoxS','Paradox Security Systems Ltd'),(110511521792,'Hewlett-','Hewlett-Packard Company'),(110528299008,'ElectroC','ELECTRO CHANCE SRL'),(110545076224,'NewMedia','New Media Life'),(110561853440,'AltaiTec','Altai Technologies Limited'),(110578630656,'CitiwayT','Citiway technology Co.,ltd'),(110595407872,'Motorola','Motorola Mobility, Inc.'),(110612185088,'AlpsElec','Alps Electric Co., Ltd'),(110628962304,'Equustek','Equustek Solutions, Inc.'),(110645739520,'Qualitro','Qualitrol'),(110662516736,'Infocryp','Infocrypt Inc.'),(110679293952,'SonyComp','SONY Computer Entertainment inc,'),(110696071168,'Zte','ZTE Corporation'),(110712848384,'Cambridg','Cambridge Industries(Group) Co.,'),(110729625600,'Anydata','AnyDATA Corporation'),(110746402816,'S&CElect','S&C ELECTRIC COMPANY'),(110763180032,'Broadata','Broadata Communications, Inc'),(110779957248,'ZyxelCom','ZyXEL Communications Corporation'),(110796734464,'RcgHk','RCG (HK) Ltd'),(110813511680,'ChengduE','Chengdu ethercom information tec'),(110830288896,'Progress','Progressive Gaming International'),(110847066112,'SalicruS','SALICRU, S.A.'),(110863843328,'Cathexis',''),(110880620544,'IntelCor','Intel Corporate'),(110897397760,'IntelCor','Intel Corporate'),(110914174976,'TrakMicr','TRAK Microwave'),(110930952192,'IcxTechn','ICX Technologies'),(110947729408,'IpInnova','IP Innovations, Inc.'),(110964506624,'LsCableA','LS Cable and System Ltd.'),(110981283840,'Fortunet','FORTUNETEK CO., LTD'),(110998061056,'Maxfor',''),(111014838272,'Zeutsche','Zeutschel GmbH'),(111031615488,'Welltran','Welltrans O&E Technology Co. , L'),(111048392704,'Micro-St','MICRO-STAR INTERNATIONAL CO., LT'),(111065169920,'EnensysT','ENENSYS Technologies'),(111081947136,'Fei-Zyfe','FEI-Zyfer, Inc.'),(111098724352,'Mobitek',''),(111115501568,'Thomson','Thomson Inc.'),(111132278784,'Tp-LinkT','TP-LINK Technologies Co., Ltd.'),(111149056000,'Nortel',''),(111165833216,'JuniperN','Juniper Networks'),(111182610432,'AppleCom','Apple Computer Inc.'),(111199387648,'2wire','2Wire, Inc'),(111216164864,'LynxStud','Lynx Studio Technology, Inc.'),(111232942080,'ToyoMedi','TOYO MEDIC CO.,LTD.'),(111249719296,'Cisco','CISCO SYSTEMS, INC.'),(111266496512,'Cisco','CISCO SYSTEMS, INC.'),(111283273728,'S-Inform','S-Information Technolgy, Co., Lt'),(111300050944,'Teramage','TeraMage Technologies Co., Ltd.'),(111316828160,'Pyronix','Pyronix Ltd'),(111333605376,'Sagamore','Sagamore Systems, Inc.'),(111350382592,'Axesstel','Axesstel Inc.'),(111367159808,'CarloGav','CARLO GAVAZZI CONTROLS SPA-Contr'),(111383937024,'Shenzhen','SHENZHEN LINNKING ELECTRONICS CO'),(111400714240,'Unionman','UNIONMAN TECHNOLOGY CO.,LTD'),(111417491456,'StarComm','Star Communication Network Techn'),(111434268672,'Teradyne','Teradyne K.K.'),(111451045888,'Cetis','Cetis, Inc'),(111467823104,'Converge','Convergens Oy Ltd'),(111484600320,'Imaginat','Imagination Technologies Ltd'),(111501377536,'AcconetP','Acconet (PTE) Ltd'),(111518154752,'OnsetCom','Onset Computer Corporation'),(111534931968,'Embedded','Embedded Systems Design, Inc.'),(111551709184,'Tdk-Lamb','TDK-Lambda'),(111568486400,'CableVis','Cable Vision Electronics CO., LT'),(111585263616,'Bskyb','BSkyB Ltd'),(111602040832,'PtUfoaks','PT. Ufoakses Sukses Luarbiasa'),(111618818048,'Nintendo','Nintendo Co., Ltd.'),(111635595264,'Shenzhen','SHENZHEN SEECOMM TECHNOLOGY CO.,'),(111652372480,'Finnzyme','Finnzymes'),(111669149696,'Matrix','MATRIX INC.'),(111685926912,'SmithsMe','Smiths Medical'),(111702704128,'SecureCa','SECURE CARE PRODUCTS, INC'),(111719481344,'AngelEle','Angel Electronics Co., Ltd.'),(111736258560,'InterayS','Interay Solutions BV'),(111753035776,'Optibase','OPTIBASE LTD'),(111769812992,'Opvista','OpVista, Inc.'),(111786590208,'ArecontV','Arecont Vision'),(111803367424,'Simoco','Simoco Ltd.'),(111820144640,'Wayfarer','Wayfarer Transit Systems Ltd'),(111836921856,'Adaptive','Adaptive Micro-Ware Inc.'),(111853699072,'BonaTech','BONA TECHNOLOGY INC.'),(111870476288,'Swe-Dish','Swe-Dish Satellite Systems AB'),(111887253504,'Handheld','HandHeld entertainment, Inc.'),(111904030720,'ChengUei','Cheng Uei Precision Industry Co.'),(111920807936,'Sistemas','Sistemas Avanzados de Control, S'),(111937585152,'LucentTr','LUCENT TRANS ELECTRONICS CO.,LTD'),(111954362368,'Google','Google Inc.'),(111971139584,'Essilor',''),(111987916800,'WanlidaG','Wanlida Group Co., LTD'),(112004694016,'XinHuaCo','Xin Hua Control Engineering Co.,'),(112021471232,'GemaltoE','gemalto e-Payment'),(112038248448,'NokiaDan','Nokia Danmark A/S'),(112055025664,'TeakTech','Teak Technologies, Inc.'),(112071802880,'Advanced','Advanced Simulation Technology i'),(112088580096,'Computer','Computer Engineering Limited'),(112105357312,'GentexCo','Gentex Corporation/Electro-Acous'),(112122134528,'Motorola','Motorola Mobility, Inc.'),(112138911744,'Gt&TEngi','GT&T Engineering Pte Ltd'),(112155688960,'PchomeOn','PChome Online Inc.'),(112172466176,'ArubaNet','Aruba Networks'),(112189243392,'CoastalE','Coastal Environmental Systems'),(112206020608,'Cmotech','CMOTECH Co. Ltd.'),(112222797824,'IndacBV','Indac B.V.'),(112239575040,'Eq-3Entw','eQ-3 Entwicklung GmbH'),(112256352256,'IceQube','Ice Qube, Inc'),(112273129472,'GalaxyTe','Galaxy Telecom Technologies Ltd'),(112289906688,'DeltaDor','DELTA DORE'),(112306683904,'Deltanod','Deltanode Solutions AB'),(112323461120,'Ubistar',''),(112340238336,'AswtTaiw','ASWT Co., LTD. Taiwan Branch H.K'),(112357015552,'JohnsonO','Johnson Outdoors Marine Electron'),(112373792768,'Arcadyan','Arcadyan Technology Corporation'),(112390569984,'AyecomTe','Ayecom Technology Co., Ltd.'),(112407347200,'Satec','SATEC Co.,LTD'),(112424124416,'NavvoGro','The Navvo Group'),(112440901632,'ZiovaCop','Ziova Coporation'),(112457678848,'Cisco','CISCO SYSTEMS, INC.'),(112474456064,'Cisco','CISCO SYSTEMS, INC.'),(112491233280,'ScanCoin','SCAN COIN Industries AB'),(112508010496,'ActivaMu','ACTIVA MULTIMEDIA'),(112524787712,'AsiCommu','ASI Communications, Inc.'),(112541564928,'KonkaGro','Konka Group Co., Ltd.'),(112558342144,'Bartec','BARTEC GmbH'),(112575119360,'Aipermon','Aipermon GmbH & Co. KG'),(112591896576,'Lear','Lear Corporation'),(112608673792,'Sanmina-','Sanmina-SCI'),(112625451008,'MertenGm','Merten GmbH&CoKG'),(112642228224,'Dongahel','Dongahelecomm'),(112659005440,'DoahElec','Doah Elecom Inc.'),(112675782656,'Technowa','Technowave Ltd.'),(112692559872,'AjinVisi','Ajin Vision Co.,Ltd'),(112709337088,'FasterTe','Faster Technology LLC'),(112726114304,'Intelbra','intelbras'),(112742891520,'A-FourTe','A-FOUR TECH CO., LTD.'),(112759668736,'Inocova','INOCOVA Co.,Ltd'),(112776445952,'Techcity','Techcity Technology co., Ltd.'),(112793223168,'LogicalL','Logical Link Communications'),(112810000384,'Jwtradin','JWTrading Co., Ltd'),(112826777600,'GnNetcom','GN Netcom as'),(112843554816,'DigitalM','Digital Multimedia Technology Co'),(112860332032,'Agami','Agami Systems, Inc.'),(112877109248,'Takacom','Takacom Corporation'),(112893886464,'MicroVis','Micro Vision Co.,LTD'),(112910663680,'Qumranet','Qumranet Inc.'),(112927440896,'Hewlett-','Hewlett-Packard Company'),(112944218112,'Crossbow','Crossbow Technology, Inc'),(112960995328,'Giga-Byt','GIGA-BYTE TECHNOLOGY CO.,LTD.'),(112977772544,'Nti/Linm','NTI AG / LinMot'),(112994549760,'Avm','AVM GmbH'),(113011326976,'PheenetT','PheeNet Technology Corp.'),(113028104192,'AlfredMa','Alfred Mann Foundation'),(113044881408,'Meshlinx','Meshlinx Wireless Inc.'),(113061658624,'Zylaya',''),(113078435840,'HipShing','Hip Shing Electronics Ltd.'),(113095213056,'Aca-Digi','ACA-Digital Corporation'),(113111990272,'Viewtel','ViewTel Co,. Ltd.'),(113128767488,'MatrixDe','Matrix Design Group, LLC'),(113145544704,'CcvDeuts','CCV Deutschland GmbH - Celectron'),(113162321920,'Ircona',''),(113179099136,'KoreaEle','Korea Electric Power Data Networ'),(113195876352,'NetcareS','NetCare Service Co., Ltd.'),(113212653568,'EuchnerG','Euchner GmbH+Co. KG'),(113229430784,'Mobinnov','Mobinnova Corp.'),(113246208000,'ThincomT','Thincom Technology Co.,Ltd'),(113262985216,'Kitworks','KitWorks.fi Ltd.'),(113279762432,'WaveElec','Wave Electronics Co.,Ltd.'),(113296539648,'Pacstar','PacStar Corp.'),(113313316864,'DataRobo','Data Robotics, Incorporated'),(113330094080,'ElsterSo','Elster Solutions, LLC,'),(113346871296,'Ibm','IBM Corp'),(113363648512,'Seluxit',''),(113380425728,'Motorola','Motorola Mobility, Inc.'),(113397202944,'Infinite','Infinite QL Sdn Bhd'),(113413980160,'WeltecEn','Weltec Enterprise Co., Ltd.'),(113430757376,'WuhanYan','Wuhan Yangtze Optical Technology'),(113447534592,'Tranzas','Tranzas, Inc.'),(113464311808,'Universa','Universal Global Scientific Indu'),(113481089024,'Cisco','CISCO SYSTEMS, INC.'),(113497866240,'Cisco','CISCO SYSTEMS, INC.'),(113514643456,'ImproTec','Impro Technologies'),(113531420672,'MiTelSRL','MI.TEL s.r.l.'),(113548197888,'Cisco-Li','Cisco-Linksys, LLC'),(113564975104,'Diostech','Diostech Co., Ltd.'),(113581752320,'MosartSe','Mosart Semiconductor Corp.'),(113598529536,'GemtekTe','Gemtek Technology Co., Ltd.'),(113615306752,'ProcareI','Procare International Co'),(113632083968,'SonyEric','Sony Ericsson Mobile Communicati'),(113648861184,'SdtInfor','SDT information Technology Co.,L'),(113665638400,'Motorola','Motorola Mobility, Inc.'),(113682415616,'Ubtos',''),(113699192832,'Telecomu','TELECOMUNICATION TECHNOLOGIES LT'),(113715970048,'LismoreI','Lismore Instruments Limited'),(113732747264,'Teleco','Teleco, Inc.'),(113749524480,'Hirschma','Hirschmann Multimedia B.V.'),(113766301696,'Cyber-Bl','cyber-blue(HK)Ltd'),(113783078912,'LnSritha','LN Srithai Comm Ltd.'),(113799856128,'GciScien','GCI Science&Technology Co.,Ltd.'),(113816633344,'Sony','Sony Corporation'),(113833410560,'Zelax',''),(113850187776,'ProbaBui','PROBA Building Automation Co.,LT'),(113866964992,'PegasusT','Pegasus Technologies Inc.'),(113883742208,'VOneMult','V One Multimedia Pte Ltd'),(113900519424,'NvMichel','NV Michel Van de Wiele'),(113917296640,'Advanced','AdvancedIO Systems Inc'),(113934073856,'CanholdI','Canhold International Limited'),(113950851072,'Venergy','Venergy,Co,Ltd'),(113967628288,'NokiaDan','Nokia Danmark A/S'),(113984405504,'SamsungE','Samsung Electronics Co., Ltd.'),(114001182720,'ChunilEl','CHUNIL ELECTRIC IND., CO.'),(114017959936,'Astaro','Astaro AG'),(114034737152,'AvecsBer','AVECS Bergen GmbH'),(114051514368,'3wayNetw','3Way Networks Ltd'),(114068291584,'Nortel',''),(114085068800,'TrÃ³picoS','TrÃ³pico Sistemas e Telecomunica'),(114101846016,'Fusiondy','FusionDynamic Ltd.'),(114118623232,'AsustekC','ASUSTek COMPUTER INC.'),(114135400448,'ErcoLeuc','ERCO Leuchten GmbH'),(114152177664,'Votronic','Votronic GmbH'),(114168954880,'HisenseM','Hisense Mobile Communications Te'),(114185732096,'EclerSA','ECLER S.A.'),(114202509312,'Fitivisi','fitivision technology Inc.'),(114219286528,'AsotelCo','Asotel Communication Limited Tai'),(114236063744,'SmartyHz','Smarty (HZ) Information Electron'),(114252840960,'Skyworth','Skyworth Digital technology(shen'),(114269618176,'AdecPart','ADEC & Parter AG'),(114286395392,'Righthan','RightHand Technologies, Inc.'),(114303172608,'SkipperW','Skipper Wireless, Inc.'),(114319949824,'IconDigi','ICON Digital International Limit'),(114336727040,'A-Link','A-Link Ltd'),(114353504256,'Dell','Dell Inc'),(114370281472,'Cisco','CISCO SYSTEMS, INC.'),(114387058688,'Cisco','CISCO SYSTEMS, INC.'),(114403835904,'Delorme',''),(114420613120,'FutureUn','Future University-Hakodate'),(114437390336,'BrnPhoen','BRN Phoenix'),(114454167552,'Telefunk','Telefunken Radio Communication S'),(114470944768,'TorianWi','Torian Wireless'),(114487721984,'MamiyaDi','Mamiya Digital Imaging Co., Ltd.'),(114504499200,'FujianSt','FUJIAN STAR-NET COMMUNICATION CO'),(114521276416,'Analogic','Analogic Corp.'),(114538053632,'EwingsSR','eWings s.r.l.'),(114554830848,'Corelatu','Corelatus AB'),(114571608064,'Motorola','Motorola Mobility, Inc.'),(114588385280,'SavantLl','Savant Systems LLC'),(114605162496,'BlusensT','BLUSENS TECHNOLOGY'),(114621939712,'SignalNe','Signal Networks Pvt. Ltd.,'),(114638716928,'AsiaPaci','Asia Pacific Satellite Industrie'),(114655494144,'CyberSol','Cyber Solutions Inc.'),(114672271360,'Visionit','VISIONITE INC.'),(114689048576,'Ffei','FFEI Ltd.'),(114705825792,'HomeNetw','Home Network System'),(114722603008,'TexasIns','Texas Instruments'),(114739380224,'EthosNet','Ethos Networks LTD.'),(114756157440,'Anseri','Anseri Corporation'),(114772934656,'Pmc',''),(114789711872,'CatonOve','Caton Overseas Limited'),(114806489088,'FontalTe','Fontal Technology Incorporation'),(114823266304,'U4eaTech','U4EA Technologies Ltd'),(114840043520,'Impatica','Impatica Inc.'),(114856820736,'Computer','COMPUTER HI-TECH INC.'),(114873597952,'TrumpfLa','TRUMPF Laser Marking Systems AG'),(114890375168,'JoybienT','JOYBIEN TECHNOLOGIES CO., LTD.'),(114907152384,'3com','3Com Ltd'),(114923929600,'Yec','YEC Co.,Ltd.'),(114940706816,'Scientif','Scientific-Atlanta, Inc'),(114957484032,'2wire','2Wire, Inc'),(114974261248,'Breaking','BreakingPoint Systems, Inc.'),(114991038464,'MicroCon','Micro Control Designs'),(115007815680,'Unipoint',''),(115024592896,'IslInstr','ISL (Instrumentation Scientifiqu'),(115041370112,'Suzuken','SUZUKEN CO.,LTD'),(115058147328,'Tilera','Tilera Corporation'),(115074924544,'AutocomP','Autocom Products Ltd'),(115091701760,'Celestia','Celestial Semiconductor, Ltd'),(115108478976,'TidelEng','Tidel Engineering LP'),(115125256192,'Yupiteru','YUPITERU CORPORATION'),(115142033408,'CTElettr','C.T. ELETTRONICA'),(115158810624,'AlbisTec','Albis Technologies AG'),(115175587840,'Fargo','FARGO CO., LTD.'),(115192365056,'Eletroni','Eletronica Nitron Ltda'),(115209142272,'Vamp','Vamp Ltd.'),(115225919488,'IpoxTech','iPOX Technology Co., Ltd.'),(115242696704,'KmcChain','KMC CHAIN INDUSTRIAL CO., LTD.'),(115259473920,'JiagnsuA','JIAGNSU AETNA ELECTRIC CO.,LTD'),(115276251136,'Christie','Christie Digital Systems, Inc.'),(115293028352,'Alsterae','AlsterAero GmbH'),(115309805568,'Internat','International Broadband Electric'),(115326582784,'Biz-2-Me','Biz-2-Me Inc.'),(115343360000,'Motorola','Motorola Mobility, Inc.'),(115360137216,'NokiaDan','Nokia Danmark A/S'),(115376914432,'Pepwave','PePWave Ltd'),(115393691648,'Motorola','Motorola Mobility, Inc.'),(115410468864,'Interact','Interactivetv Pty Limited'),(115427246080,'Mytholog','Mythology Tech Express Inc.'),(115444023296,'EdgeAcce','EDGE ACCESS INC'),(115460800512,'Cisco','CISCO SYSTEMS, INC.'),(115477577728,'Cisco','CISCO SYSTEMS, INC.'),(115494354944,'MedicisT','Medicis Technologies Corporation'),(115511132160,'MvoxTech','Mvox Technologies Inc.'),(115527909376,'AtlantaA','Atlanta Advanced Communications '),(115544686592,'AztekNet','Aztek Networks, Inc.'),(115561463808,'SiemensE','Siemens Enterprise Communication'),(115578241024,'Nintendo','Nintendo Co., Ltd.'),(115595018240,'RadioTer','Radio Terminal Systems Pty Ltd'),(115611795456,'AlliedTe','Allied Telesis K.K.'),(115628572672,'KeumbeeE','Keumbee Electronics Co.,Ltd.'),(115645349888,'Incotec','INCOTEC GmbH'),(115662127104,'Shenztec','Shenztech Ltd'),(115678904320,'Loopcomm','Loopcomm Technology, Inc.'),(115695681536,'Alcatel-','Alcatel - IPD'),(115712458752,'Embedded','Embedded Artists AB'),(115729235968,'Dynavisi','Dynavisions Schweiz AG'),(115746013184,'Samyoung','Samyoung Electronics'),(115762790400,'Handream','Handreamnet'),(115779567616,'Pentaone','PENTAONE. CO., LTD.'),(115796344832,'Woven','Woven Systems, Inc.'),(115813122048,'Datascha','dataschalt e+a GmbH'),(115829899264,'CopleyCo','Copley Controls Corporation'),(115846676480,'Aeroviro','AeroVIronment (AV Inc)'),(115863453696,'WelchAll','Welch Allyn, Inc.'),(115880230912,'Joby','Joby Inc.'),(115897008128,'Moduslin','ModusLink Corporation'),(115913785344,'Evolis',''),(115930562560,'Sofacrea','SOFACREAL'),(115947339776,'Wizyoung','Wizyoung Tech.'),(115964116992,'NeopostT','Neopost Technologies'),(115980894208,'AppliedR','Applied Radio Technologies'),(115997671424,'Ed','ED Co.Ltd'),(116014448640,'ActionTe','Action Technology (SZ) Co., Ltd'),(116031225856,'Affinity','Affinity International S.p.a'),(116048003072,'Ymc','YMC AG'),(116064780288,'Ateliers','Ateliers R. LAUMONIER'),(116081557504,'Mendocin','Mendocino Software'),(116098334720,'DanfossD','Danfoss Drives A/S'),(116115111936,'MatrixTe','Matrix Telecom Pvt. Ltd.'),(116131889152,'Intellig','Intelligent Distributed Controls'),(116148666368,'Phidgets','Phidgets Inc.'),(116165443584,'Cisco','CISCO SYSTEMS, INC.'),(116182220800,'Cisco','CISCO SYSTEMS, INC.'),(116198998016,'InotecOr','InoTec GmbH Organisationssysteme'),(116215775232,'Petratec',''),(116232552448,'Shenzhen','ShenZhen Kang Hui Technology Co.'),(116249329664,'D-Link','D-Link Corporation'),(116266106880,'Apprion',''),(116282884096,'IcronTec','Icron Technologies Corporation'),(116299661312,'CarexLig','Carex Lighting Equipment Factory'),(116316438528,'Voxtel','Voxtel, Inc.'),(116333215744,'Celtro','Celtro Ltd.'),(116349992960,'PaloAlto','Palo Alto Networks'),(116366770176,'TsukenEl','Tsuken Electric Ind. Co.,Ltd'),(116383547392,'IeeeI&MS','IEEE I&M Society TC9'),(116400324608,'E-TreesJ','e-trees Japan, Inc.'),(116417101824,'Siemens','Siemens AG,'),(116433879040,'Coherent',''),(116450656256,'PhoenixI','Phoenix International Co., Ltd'),(116467433472,'HartComm','HART Communication Foundation'),(116484210688,'Delta-Da','DELTA - Danish Electronics, Ligh'),(116500987904,'TpineTec','TPine Technology'),(116517765120,'IntelCor','Intel Corporate'),(116534542336,'PalitMic','Palit Microsystems ( H.K.) Ltd.'),(116551319552,'Simpleco','SimpleComTools'),(116568096768,'QuantaCo','Quanta Computer Inc.'),(116584873984,'Nortel',''),(116601651200,'Ron-Tele','RON-Telecom ZAO'),(116618428416,'MerlinCs','Merlin CSI'),(116635205632,'PolygonJ','POLYGON, JSC'),(116651982848,'Avantis','Avantis.Co.,Ltd'),(116668760064,'Cisco','CISCO SYSTEMS, INC.'),(116685537280,'Cisco','CISCO SYSTEMS, INC.'),(116702314496,'AtronEle','ATRON electronic GmbH'),(116719091712,'Med-Eng','Med-Eng Systems Inc.'),(116735868928,'SinkyoEl','Sinkyo Electron Inc'),(116752646144,'Netgear','NETGEAR Inc.'),(116769423360,'Solitech','Solitech Inc.'),(116786200576,'NeuralIm','Neural Image. Co. Ltd.'),(116802977792,'Qlogic','QLogic Corporation'),(116819755008,'NokiaDan','Nokia Danmark A/S'),(116836532224,'FocusSys','Focus System Inc.'),(116853309440,'Chongqin','ChongQing JINOU Science & Techno'),(116870086656,'TsubataE','Tsubata Engineering Co.,Ltd. (He'),(116886863872,'Computec','Computec Oy'),(116903641088,'CompalIn','COMPAL INFORMATION (KUNSHAN) CO.'),(116920418304,'Proxicas','Proxicast'),(116937195520,'Sims','SIMS Corp.'),(116953972736,'Yi-Qing','Yi-Qing CO., LTD'),(116970749952,'Software','Software Technologies Group,Inc.'),(116987527168,'Eurotel','EuroTel Spa'),(117004304384,'Curtis','Curtis, Inc.'),(117021081600,'Procurve','ProCurve Networking by HP'),(117037858816,'NetworkA','Network Automation mxc AB'),(117054636032,'GeneralI','General Infinity Co.,Ltd.'),(117071413248,'WiseBlue','Wise & Blue'),(117088190464,'BeijingD','Beijing DG Telecommunications eq'),(117104967680,'Sandisk','SanDisk Corporation'),(117121744896,'AbbAsDiv','ABB AS, Division Automation Prod'),(117138522112,'BlueoneT','Blueone Technology Co.,Ltd'),(117155299328,'Futarque','Futarque A/S'),(117172076544,'Shenzhen','Shenzhen Lantech Electronics Co.'),(117188853760,'RobertsR','Roberts Radio limited'),(117205630976,'W&WCommu','W&W Communications, Inc.'),(117222408192,'Sanion','SANION Co., Ltd.'),(117239185408,'Signtech',''),(117255962624,'ArecaTec','Areca Technology Corporation'),(117272739840,'NavmanNe','Navman New Zealand'),(117289517056,'Avaya','Avaya Inc.'),(117306294272,'NizhnyNo','Nizhny Novgorod Factory named af'),(117323071488,'VectorTe','Vector Technology Corp.'),(117339848704,'Motorola','Motorola Mobility, Inc.'),(117356625920,'Cisco','CISCO SYSTEMS, INC.'),(117373403136,'Cisco','CISCO SYSTEMS, INC.'),(117390180352,'HurcoAut','Hurco Automation Ltd.'),(117406957568,'TehutiNe','Tehuti Networks Ltd.'),(117423734784,'Semindia','SEMINDIA SYSTEMS PRIVATE LIMITED'),(117440512000,'AceCadEn','ACE CAD Enterprise Co., Ltd.'),(117457289216,'SonyEric','Sony Ericsson Mobile Communicati'),(117474066432,'ApolloIm','Apollo Imaging Technologies, Inc'),(117490843648,'2wire','2Wire, Inc.'),(117507620864,'Azuretec','Azuretec Co., Ltd.'),(117524398080,'Vololink','Vololink Pty Ltd'),(117541175296,'Bpl','BPL Limited'),(117557952512,'AlienTec','Alien Technology'),(117574729728,'Navigon','NAVIGON AG'),(117591506944,'DigitalA','Digital Acoustics, LLC'),(117608284160,'JhtOptoe','JHT Optoelectronics Co.,Ltd.'),(117625061376,'AppleCom','Apple Computer Inc.'),(117641838592,'Isaaclan','IsaacLandKorea Co., Ltd,'),(117658615808,'ChinaGri','China Gridcom Co., Ltd'),(117675393024,'Sennheis','Sennheiser electronic GmbH & Co.'),(117692170240,'Ubiquisy','Ubiquisys Ltd'),(117708947456,'Modnnet','Modnnet Co., Ltd'),(117725724672,'Equaline','Equaline Corporation'),(117742501888,'Powerwav','Powerwave Technologies Sweden AB'),(117759279104,'SwyxSolu','Swyx Solutions AG'),(117776056320,'LookxDig','LookX Digital Media BV'),(117792833536,'Midtroni','Midtronics, Inc.'),(117809610752,'Anue','Anue Systems, Inc.'),(117826387968,'Teletrak','Teletrak Ltd'),(117843165184,'IriUbite','IRI Ubiteq, INC.'),(117859942400,'Telular','Telular Corp.'),(117876719616,'SicepSPA','Sicep s.p.a.'),(117893496832,'DtlBroad','DTL Broadcast Ltd'),(117910274048,'Miralink','MiraLink Corporation'),(117927051264,'Hypermed','Hypermedia Systems'),(117943828480,'Ripcode','Ripcode, Inc.'),(117960605696,'IntelCor','Intel Corporate'),(117977382912,'Hewlett-','Hewlett-Packard Company'),(117994160128,'Faiveley','FAIVELEY TRANSPORT'),(118010937344,'Nintendo','Nintendo Co., Ltd.'),(118027714560,'Tintomet','The Tintometer Ltd'),(118044491776,'ARCambri','A & R Cambridge'),(118061268992,'CxrAnder','CXR Anderson Jacobson'),(118078046208,'Beckmann','Beckmann GmbH'),(118094823424,'TmnTechn','TMN Technologies Telecomunicacoe'),(118111600640,'Lord','LORD Corporation'),(118128377856,'DataqIns','DATAQ Instruments, Inc.'),(118145155072,'TaiwanSe','Taiwan Semiconductor Co., Ltd.'),(118161932288,'Finsoft','Finsoft Ltd'),(118178709504,'ScanEngi','Scan Engineering Telecom'),(118195486720,'ManDiese','MAN Diesel SE'),(118212263936,'BoschAcc','Bosch Access Systems GmbH'),(118229041152,'Deepsoun','Deepsound Tech. Co., Ltd'),(118245818368,'DivinetA','Divinet Access Technologies Ltd'),(118262595584,'EmzaVisu','EMZA Visual Sense Ltd.'),(118279372800,'2mElectr','2M Electronic A/S'),(118296150016,'NecAcces','NEC AccessTechnica, Ltd.'),(118312927232,'JmicronT','JMicron Technology Corp.'),(118329704448,'Electron','Electronic Computer Systems, Inc'),(118346481664,'HuluSwed','Hulu Sweden AB'),(118363258880,'Cisco','CISCO SYSTEMS, INC.'),(118380036096,'Cisco','CISCO SYSTEMS, INC.'),(118396813312,'Efkon','EFKON AG'),(118413590528,'L-Acoust','l-acoustics'),(118430367744,'JcDecaux','JC Decaux SA DNT'),(118447144960,'TEMASPA','T.E.M.A. S.p.A.'),(118463922176,'VideoSrl','VIDEO SYSTEMS SRL'),(118480699392,'GeneralS','General Sensing'),(118497476608,'ViolinTe','Violin Technologies'),(118514253824,'SamsungE','Samsung Electronics Co., Ltd.'),(118531031040,'KsSystem','KS System GmbH'),(118547808256,'ApolloFi','Apollo Fire Detectors Ltd'),(118564585472,'Hose-Mcc','Hose-McCann Communications'),(118581362688,'SatelSpZ','SATEL sp. z o.o.'),(118598139904,'NovusSec','Novus Security Sp. z o.o.'),(118614917120,'AskeyCom','ASKEY  COMPUTER  CORP'),(118631694336,'Calyptec','Calyptech Pty Ltd'),(118648471552,'Awox',''),(118665248768,'Ã…mic','Ã…mic AB'),(118682025984,'IdsImagi','IDS Imaging Development Systems '),(118698803200,'FlexitGr','Flexit Group GmbH'),(118715580416,'SAEAfiki','S.A.E Afikim'),(118732357632,'Myungmin','MyungMin Systems, Inc.'),(118749134848,'Intotech','intotech inc.'),(118765912064,'LoricaSo','Lorica Solutions'),(118782689280,'Ubi&Mobi','UBI&MOBI,.Inc'),(118799466496,'BrotherI','BROTHER INDUSTRIES, LTD.'),(118816243712,'XenicsNv','XenICs nv'),(118833020928,'Telchemy','Telchemy, Incorporated'),(118849798144,'CurtissW','Curtiss Wright Controls Embedded'),(118866575360,'Icontrol','iControl Incorporated'),(118883352576,'MicroCon','Micro Control Systems, Inc'),(118900129792,'NokiaDan','Nokia Danmark A/S'),(118916907008,'BharatEl','BHARAT ELECTRONICS'),(118933684224,'WistronN','Wistron Neweb Corp.'),(118950461440,'Intellec','Intellect International NV'),(118967238656,'Condalo','Condalo GmbH'),(118984015872,'Airvod','Airvod Limited'),(119000793088,'ZfElectr','ZF Electronics GmbH'),(119017570304,'BirdElec','Bird Electronic Corp.'),(119034347520,'AltaHeig','Alta Heights Technology Corp.'),(119051124736,'BluewayE','BLUEWAY ELECTRONIC CO;LTD'),(119067901952,'Elitegro','Elitegroup Computer System Co.'),(119084679168,'Nortel',''),(119101456384,'Rftech','RFTech Co.,Ltd'),(119118233600,'SilverPe','Silver Peak Systems, Inc.'),(119135010816,'FmcKongs','FMC Kongsberg Subsea AS'),(119151788032,'IcopDigi','ICOP Digital'),(119168565248,'SagemCom','SAGEM COMMUNICATION'),(119185342464,'JuniperN','Juniper Networks'),(119202119680,'HoluxTec','HOLUX Technology, Inc.'),(119218896896,'Integrat','Integrated Control Technology Li'),(119235674112,'Mobisolu','Mobisolution Co.,Ltd'),(119252451328,'Ultratec','Ultratec, Inc.'),(119269228544,'Convergi','Converging Systems Inc.'),(119286005760,'StratoRe','Strato Rechenzentrum AG'),(119302782976,'Starvedi','StarVedia Technology Inc.'),(119319560192,'Miura','MIURA CO.,LTD'),(119336337408,'FsnDispl','FSN DISPLAY INC'),(119353114624,'BeijingR','Beijing Run Technology LTD. Comp'),(119369891840,'PempekPt','PEMPEK SYSTEMS PTY LTD'),(119386669056,'KingtekC','KINGTEK CCTV ALLIANCE CO., LTD.'),(119403446272,'Daviscom','DAVISCOMMS (S) PTE LTD'),(119420223488,'Measurem','Measurement Devices Ltd'),(119437000704,'Dataupia','Dataupia Corporation'),(119453777920,'IdentecS','IDENTEC SOLUTIONS'),(119470555136,'Sogestma','SOGESTMATIC'),(119487332352,'Ultra-XA','ULTRA-X ASIA PACIFIC Inc.'),(119504109568,'Panasoni','Panasonic Corp. AVC Company'),(119520886784,'Cisco','CISCO SYSTEMS, INC.'),(119537664000,'Cisco','CISCO SYSTEMS, INC.'),(119554441216,'KelvinHu','Kelvin Hughes Ltd'),(119571218432,'Scientif','Scientific Atlanta, A Cisco Comp'),(119587995648,'Dvtel','DVTel LTD'),(119604772864,'Edgewate','Edgewater Computer Systems'),(119621550080,'Utstarco','UTStarcom Inc'),(119638327296,'ValeoVec','Valeo VECS'),(119655104512,'Vencer','Vencer Co., Ltd.'),(119671881728,'Motorola','Motorola Mobility, Inc.'),(119688658944,'Renkus-H','Renkus-Heinz, Inc.'),(119705436160,'IskraSis','Iskra Sistemi d.d.'),(119722213376,'TelenotE','TELENOT ELECTRONIC GmbH'),(119738990592,'Vialogy',''),(119755767808,'Ahnlab','AhnLab,Inc.'),(119772545024,'HealthHe','Health Hero Network, Inc.'),(119789322240,'TownetSr','TOWNET SRL'),(119806099456,'802autom','802automation Limited'),(119822876672,'Vr','VR AG'),(119839653888,'PostekEl','Postek Electronics Co., Ltd.'),(119856431104,'Ultratro','Ultratronik GmbH'),(119873208320,'Broadcom','Broadcom Corporation'),(119889985536,'Nintendo','Nintendo Co., Ltd.'),(119906762752,'DmpElect','DMP Electronics INC.'),(119923539968,'NetioTec','Netio Technologies Co., Ltd'),(119940317184,'BrocadeC','Brocade Communications Systems, '),(119957094400,'NokiaDan','Nokia Danmark A/S'),(119973871616,'Blossoms','Blossoms Digital Technology Co.,'),(119990648832,'ValuePla','Value Platforms Limited'),(120007426048,'NanjingS','Nanjing SilverNet Software Co., '),(120024203264,'KworldCo','KWORLD COMPUTER CO., LTD'),(120040980480,'Transrad','TRANSRADIO SenderSysteme Berlin '),(120057757696,'KenwinIn','KENWIN INDUSTRIAL(HK) LTD.'),(120074534912,'TellinkS','Tellink Sistemas de Telecomunica'),(120091312128,'ConwiseT','CONWISE Technology Corporation L'),(120108089344,'LundIpPr','Lund IP Products AB'),(120124866560,'Digitrax','Digitrax Inc.'),(120141643776,'Intellit','Intellitect Water Ltd'),(120158420992,'GINMbh','G.i.N. mbH'),(120175198208,'AlpsElec','Alps Electric Co., Ltd'),(120191975424,'AsustekC','ASUSTek COMPUTER INC.'),(120208752640,'Dignsys','Dignsys Inc.'),(120225529856,'Zavio','Zavio Inc.'),(120242307072,'Millenni','Millennia Media inc.'),(120259084288,'EntryPoi','Entry Point, LLC'),(120275861504,'AbbOyDri','ABB Oy Drives'),(120292638720,'PanoLogi','Pano Logic'),(120309415936,'BettyTvT','Betty TV Technology AG'),(120326193152,'Airgain','Airgain, Inc.'),(120342970368,'NoninMed','Nonin Medical Inc.'),(120359747584,'SiemensN','Siemens Numerical Control Ltd., '),(120376524800,'Cwlinux','Cwlinux Limited'),(120393302016,'Echo360','Echo360, Inc.'),(120410079232,'SaeElect','SAE Electronic Co.,Ltd.'),(120426856448,'Shenzhen','Shenzhen AEE Technology Co.,Ltd.'),(120443633664,'Smartant','SmartAnt Telecom'),(120460410880,'Tanita','TANITA Corporation'),(120477188096,'G-Techno','G-Technology, Inc.'),(120493965312,'Cisco','CISCO SYSTEMS, INC.'),(120510742528,'Cisco','CISCO SYSTEMS, INC.'),(120527519744,'Cisco-Li','Cisco-Linksys, LLC'),(120544296960,'Motorola','Motorola Mobility, Inc.'),(120561074176,'Motorola','Motorola Mobility, Inc.'),(120577851392,'OptsysTe','OPTSYS TECHNOLOGY CO., LTD.'),(120594628608,'Vmware','VMware, Inc'),(120611405824,'Txp','TXP Corporation'),(120628183040,'Thyssenk','ThyssenKrupp Elevator'),(120644960256,'Nortel',''),(120661737472,'SicertSR','Sicert S.r.L.'),(120678514688,'SecunetS','secunet Security Networks AG'),(120695291904,'ThomasIn','Thomas Instrumentation, Inc'),(120712069120,'Hypersto','Hyperstone GmbH'),(120728846336,'CenterCo','Center Communication Systems Gmb'),(120745623552,'Chenzhou','CHENZHOU GOSPELL DIGITAL TECHNOL'),(120762400768,'Emtrion','emtrion GmbH'),(120779177984,'QuestRet','Quest Retail Technology Pty Ltd'),(120795955200,'ClbBenel','CLB Benelux'),(120812732416,'Nucsafe','Nucsafe Inc.'),(120829509632,'AerisEle','Aeris Elettronica s.r.l.'),(120846286848,'Dell','Dell Inc'),(120863064064,'FormosaW','Formosa Wireless Systems Corp.'),(120879841280,'HonHaiPr','Hon Hai Precision Ind. Co.,Ltd.'),(120896618496,'HonHaiPr','Hon Hai Precision Ind. Co.,Ltd.'),(120913395712,'SunellEl','Sunell Electronics Co.'),(120930172928,'Sphairon','Sphairon Technologies GmbH'),(120946950144,'CoreDigi','CORE DIGITAL ELECTRONICS CO., LT'),(120963727360,'Envisaco','Envisacor Technologies Inc.'),(120980504576,'AlertmeC','Alertme.com Limited'),(120997281792,'Synapse',''),(121014059008,'Flexradi','FlexRadio Systems'),(121030836224,'HpnSuppl','HPN Supply Chain'),(121047613440,'Pfister','Pfister GmbH'),(121064390656,'ModeLigh','Mode Lighting (UK ) Ltd.'),(121081167872,'MobileXp','Mobile XP Technology Co., LTD'),(121097945088,'Telian','Telian Corporation'),(121114722304,'Sutron',''),(121131499520,'HueyChia','HUEY CHIAO INTERNATIONAL CO., LT'),(121148276736,'NokiaDan','Nokia Danmark A/S'),(121165053952,'InewitNv','iNEWiT NV'),(121181831168,'Callpod','Callpod, Inc.'),(121198608384,'Bio-RadL','Bio-Rad Laboratories, Inc.'),(121215385600,'SNetsyst','S Netsystems Inc.'),(121232162816,'ElementL','Element Labs, Inc.'),(121248940032,'AmroadTe','AmRoad Technology Inc.'),(121265717248,'SeonDesi','Seon Design Inc.'),(121282494464,'Wavestor','WaveStorm'),(121299271680,'Eckey','ECKey Corporation'),(121316048896,'Internat','International Police Technologie'),(121332826112,'Vdg-Secu','VDG-Security bv'),(121349603328,'ScemtecT','scemtec Transponder Technology G'),(121366380544,'Parallel','Parallels, Inc.'),(121383157760,'SamsungE','Samsung Electronics Co.,Ltd'),(121399934976,'BoschSec','Bosch Security Systems BV'),(121416712192,'ChenbroM','Chenbro Micom Co., Ltd.'),(121433489408,'Qtum',''),(121450266624,'Hangzhou','Hangzhou Hollysys Automation Co.'),(121467043840,'Widefi','WiDeFi, Inc.'),(121483821056,'ZoltanTe','Zoltan Technology Inc.'),(121500598272,'Avm','AVM GmbH'),(121517375488,'Gener8','Gener8, Inc.'),(121534152704,'Petrotes','Petrotest Instruments'),(121550929920,'ZeemoteT','Zeemote Technology Inc. (part of'),(121567707136,'TasaInte','TASA International Limited'),(121584484352,'Macab','MACAB AB'),(121601261568,'TclTechn','TCL Technoly Electronics(Huizhou'),(121618038784,'CelenoCo','Celeno Communications'),(121634816000,'Visionee','VISIONEE SRL'),(121651593216,'SynergyL','Synergy Lighting Controls'),(121668370432,'Hillston','Hillstone Networks Inc'),(121685147648,'Shenzhen','Shenzhen Kaifa Technology Co.'),(121701924864,'Pado','Pado Systems, Inc.'),(121718702080,'Cisco','CISCO SYSTEMS, INC.'),(121735479296,'Cisco','CISCO SYSTEMS, INC.'),(121752256512,'DevonIt','DEVON IT'),(121769033728,'Advanced','Advanced Relay Corporation'),(121785810944,'ChubbEle','Chubb Electronic Security System'),(121802588160,'Integrat','Integrated Medical Systems, Inc.'),(121819365376,'LeicaMic','Leica Microsystems'),(121836142592,'AstonFra','ASTON France'),(121852919808,'WinlandE','Winland Electronics, Inc.'),(121869697024,'CspFront','CSP Frontier Technologies,Inc.'),(121886474240,'GalaxyMi','Galaxy  Microsystems LImited'),(121903251456,'LgElectr','LG Electronics Inc'),(121920028672,'Truen',''),(121936805888,'Landis+G','Landis+Gyr'),(121953583104,'Joescan','JoeScan, Inc.'),(121970360320,'Ucamp','UCAMP CO.,LTD'),(121987137536,'PumpkinN','Pumpkin Networks, Inc.'),(122003914752,'AnhuiSun','Anhui Sun Create Electronics Co.'),(122020691968,'PacketVi','Packet Vision Ltd'),(122037469184,'WeissEng','Weiss Engineering Ltd.'),(122054246400,'Covax','COVAX  Co. Ltd'),(122071023616,'JabilCir','Jabil Circuit (Guangzhou) Limite'),(122087800832,'Kyohrits','KYOHRITSU ELECTRONIC INDUSTRY CO'),(122104578048,'NewburyN','Newbury Networks, Inc.'),(122121355264,'Emfit','Emfit Ltd'),(122138132480,'Novacomm','NOVACOMM LTDA'),(122154909696,'Emergent','Emergent Electronics'),(122171686912,'MayerCie','Mayer & Cie GmbH & Co KG'),(122188464128,'AristaNe','Arista Networks, Inc.'),(122205241344,'SyswanTe','Syswan Technologies Inc.'),(122222018560,'Rf','RF Systems GmbH'),(122238795776,'Wandswor','The Wandsworth Group Ltd'),(122255572992,'Prodys',''),(122272350208,'WyplaySa','WYPLAY SAS'),(122289127424,'Cohesive','Cohesive Financial Technologies '),(122305904640,'Perfecto','Perfectone Netware Company Ltd'),(122322681856,'Castlene','Castlenet Technology Inc.'),(122339459072,'Perq','PERQ SYSTEMS CORPORATION'),(122356236288,'Excelpoi','Excelpoint Manufacturing Pte Ltd'),(122373013504,'Toshiba',''),(122389790720,'CheckPoi','Check Point Software Technologie'),(122406567936,'NewBusin','New Business Division/Rhea-Infor'),(122423345152,'NextgenV','NextGen Venturi LTD'),(122440122368,'GenewTec','Genew Technologies'),(122456899584,'NewLevel','New Level Telecom Co., Ltd.'),(122473676800,'StlSolut','STL Solution Co.,Ltd.'),(122490454016,'Eunicorn',''),(122507231232,'Cranite','Cranite Systems, Inc.'),(122524008448,'Uriver','Uriver Inc.'),(122540785664,'Transyst','TRANSYSTEM INC.'),(122557562880,'ForceCom','Force Communications, Inc.'),(122574340096,'Cirrasca','Cirrascale Corporation'),(122591117312,'MjInnova','MJ Innovations Ltd.'),(122607894528,'DialTech','DIAL TECHNOLOGY LTD.'),(122624671744,'MesaImag','Mesa Imaging'),(122641448960,'Alcatel-','Alcatel-Lucent IPD'),(122658226176,'Advanced','Advanced Electronic Design, Inc.'),(122675003392,'Empacket','Empacket Corporation'),(122691780608,'Gefen','Gefen Inc.'),(122708557824,'Tervela',''),(122725335040,'Exadigm','ExaDigm Inc'),(122742112256,'Li-CorBi','LI-COR Biosciences'),(122758889472,'Opticomm','Opticomm Corporation'),(122775666688,'Linkwise','Linkwise Technology Pte Ltd'),(122792443904,'EnzytekT','Enzytek Technology Inc.,'),(122809221120,'LuckyTec','LUCKY TECHNOLOGY (HK) COMPANY LI'),(122825998336,'ShunraSo','Shunra Software Ltd.'),(122842775552,'NokiaDan','Nokia Danmark A/S'),(122859552768,'FeigElec','FEIG ELECTRONIC GmbH'),(122876329984,'Nortel',''),(122893107200,'Liecthi','Liecthi AG'),(122909884416,'Dualtech','Dualtech IT AB'),(122926661632,'Razorstr','Razorstream, LLC'),(122943438848,'Producti','Production Resource Group, LLC'),(122960216064,'AkamaiTe','AKAMAI TECHNOLOGIES, INC.'),(122976993280,'AdbBroad','ADB Broadband Italia'),(122993770496,'Terra',''),(123010547712,'SonyEric','Sony Ericsson Mobile Communicati'),(123027324928,'Zygo','Zygo Corporation'),(123044102144,'Win4net',''),(123060879360,'Internat','International Quartz Limited'),(123077656576,'AirtiesW','AirTies Wireless Networks'),(123094433792,'Audiomat','Audiomatica Srl'),(123111211008,'BellonPt','Bellon Pty Ltd'),(123127988224,'MeyerSou','Meyer Sound Laboratories, Inc.'),(123144765440,'QniqTech','Qniq Technology Corp.'),(123161542656,'WuhanTel','Wuhan Telecommunication Devices '),(123178319872,'Wichorus','WiChorus, Inc.'),(123195097088,'PlatoNet','Plato Networks Inc.'),(123211874304,'Cisco','CISCO SYSTEMS, INC.'),(123228651520,'Cisco','CISCO SYSTEMS, INC.'),(123245428736,'Bpt','BPT SPA'),(123262205952,'Apple','APPLE, INC'),(123278983168,'IridiumS','Iridium Satellite LLC'),(123295760384,'NeihuaNe','Neihua Network Technology Co.,LT'),(123312537600,'DuzonCnt','Duzon CNT Co., Ltd.'),(123329314816,'UscDigia','USC DigiArk Corporation'),(123346092032,'Cbc','CBC Co., Ltd'),(123362869248,'KwangSun','KWANG SUNG ELECTRONICS CO., LTD.'),(123379646464,'Verscien','VerScient, Inc.'),(123396423680,'Musician','MusicianLink'),(123413200896,'Castgrab','CastGrabber, LLC'),(123429978112,'EzzeMobi','Ezze Mobile Tech., Inc.'),(123446755328,'Nintendo','Nintendo Co., Ltd.'),(123463532544,'IntelCor','Intel Corporate'),(123480309760,'IntelCor','Intel Corporate'),(123497086976,'Motorola','Motorola Mobility, Inc.'),(123513864192,'PartIiRe','Part II Research, Inc.'),(123530641408,'Pace','Pace plc'),(123547418624,'Hewlett-','Hewlett-Packard Company'),(123564195840,'3com','3COM LTD'),(123580973056,'Prostor','ProStor Systems'),(123597750272,'Rembrand','Rembrandt Technologies, LLC d/b/'),(123614527488,'Industro','INDUSTRONIC Industrie-Electronic'),(123631304704,'KaiseEle','Kaise Electronic Technology Co.,'),(123648081920,'Shanghai','Shanghai Gaozhi Science & Techno'),(123664859136,'ForthPub','Forth Corporation Public Company'),(123681636352,'Research','Research In Motion Limited'),(123698413568,'Alektron','Alektrona Corporation'),(123715190784,'ByTechde','By Techdesign'),(123731968000,'Limetek',''),(123748745216,'Circleon','Circleone Co.,Ltd.'),(123765522432,'WavesAud','Waves Audio LTD'),(123782299648,'KingCham','King Champion (Hong Kong) Limite'),(123799076864,'ZpEngine','ZP Engineering SEL'),(123815854080,'NokiaDan','Nokia Danmark A/S'),(123832631296,'Zeevee','ZeeVee, Inc.'),(123849408512,'NokiaDan','Nokia Danmark A/S'),(123866185728,'Harman/B','Harman/Becker Automotive Systems'),(123882962944,'BlueantW','BlueAnt Wireless'),(123899740160,'Globalto','GlobalTop Technology Inc.'),(123916517376,'ExeginTe','Exegin Technologies Limited'),(123933294592,'Carpoint','CARPOINT CO.,LTD'),(123950071808,'CustomCo','Custom Computer Services, Inc.'),(123966849024,'CowbellE','COWBELL ENGINEERING CO., LTD.'),(123983626240,'Interact','Interactive Multimedia eXchange '),(124000403456,'BelkinIn','Belkin International Inc.'),(124017180672,'DasanTps','DASAN TPS'),(124033957888,'IndraSis','INDRA SISTEMAS, S.A.'),(124050735104,'AtteroTe','Attero Tech, LLC.'),(124067512320,'Optimedi','Optimedical Systems'),(124084289536,'ElesyJsc','EleSy JSC'),(124101066752,'MbsElect','MBS Electronic Systems GmbH'),(124117843968,'Innes',''),(124134621184,'RoconRes','Rocon PLC Research Centre'),(124151398400,'Cummins','Cummins Inc'),(124168175616,'GalaxyTe','Galaxy Technology Limited'),(124184952832,'Scientif','Scientific-Atlanta, Inc'),(124201730048,'Nortel',''),(124218507264,'Mobileso','Mobilesoft (Aust.) Pty Ltd'),(124235284480,'Environn','ENVIRONNEMENT SA'),(124252061696,'Sharp','SHARP Corporation'),(124268838912,'PrimaxEl','Primax Electronics LTD'),(124285616128,'D-Link','D-Link Corporation'),(124302393344,'SupoxTec','SUPoX Technology Co. , LTD.'),(124319170560,'TenlonTe','Tenlon Technology Co.,Ltd.'),(124335947776,'EvsBroad','EVS BROADCAST EQUIPMENT'),(124352724992,'MediaTec','Media Technology Systems Inc'),(124369502208,'Wiseblue','Wiseblue Technology Limited'),(124386279424,'Cisco','CISCO SYSTEMS, INC.'),(124403056640,'Audiosci','AudioScience'),(124419833856,'ParadeTe','Parade Technologies, Ltd.'),(124436611072,'Cisco','CISCO SYSTEMS, INC.'),(124453388288,'AlarmCom','Alarm.com'),(124470165504,'Motorola','Motorola Mobility, Inc.'),(124486942720,'SuminetC','Suminet Communication Technologi'),(124503719936,'Universa','Universal Electronics'),(124520497152,'Quartics','Quartics Inc'),(124537274368,'NaperaNe','Napera Networks Inc'),(124554051584,'BrivoLlc','Brivo Systems, LLC'),(124570828800,'NeptuneD','Neptune Digital'),(124587606016,'Cybertec','Cybertech Telecom Development'),(124604383232,'DesignSo','Design Solutions Inc.'),(124621160448,'ZipitWir','Zipit Wireless, Inc.'),(124637937664,'Ilight',''),(124654714880,'HmElectr','HM Electronics, Inc.'),(124671492096,'Shenzhen','Shenzhen Sang Fei Consumer Commu'),(124688269312,'JiangsuY','JIANGSU YINHE ELECTRONICS CO., L'),(124705046528,'Dell','Dell Inc'),(124721823744,'DavisIns','Davis Instruments, Inc.'),(124738600960,'PowerSta','Power Standards Lab'),(124755378176,'Mobileco','MobileCompia'),(124772155392,'SonyComp','Sony Computer Entertainment inc.'),(124788932608,'AgaphaTe','Agapha Technology co., Ltd.'),(124805709824,'Tp-LinkT','TP-LINK Technologies Co., Ltd.'),(124822487040,'Lighthau','LightHaus Logic, Inc.'),(124839264256,'Analogue','Analogue & Micro Ltd'),(124856041472,'Rohm','ROHM CO., LTD.'),(124872818688,'Nextgtv',''),(124889595904,'Speradto','SPERADTONE INFORMATION TECHNOLOG'),(124906373120,'Shenzhen','Shenzhen Dolphin Electronic Co.,'),(124923150336,'Efixo',''),(124939927552,'DigitalS','Digital Sky Corporation'),(124956704768,'PowerInn','Power Innovation GmbH'),(124973481984,'Arcadyan','Arcadyan Technology Corporation'),(124990259200,'Ovislink','OvisLink S.A.'),(125007036416,'SangeanE','Sangean Electronics Inc.'),(125023813632,'GennetSA','Gennet s.a.'),(125040590848,'Inter-M','Inter-M Corporation'),(125057368064,'KyushuTe','KYUSHU TEN CO.,LTD'),(125074145280,'SiauliuT','Siauliu Tauro Televizoriai, JSC'),(125090922496,'Comtrend','COMTREND CO.'),(125107699712,'AlcadSl','Alcad SL'),(125124476928,'FossAnal','Foss Analytical A/S'),(125141254144,'Sensus',''),(125158031360,'AclaraPo','Aclara Power-Line Systems Inc.'),(125174808576,'SamsungE','Samsung Electronics Co.,Ltd'),(125191585792,'Rockridg','Rockridgesound Technology Co.'),(125208363008,'Nac-Inte','NAC-INTERCOM'),(125225140224,'SonyEric','Sony Ericsson Mobile Communicati'),(125241917440,'Doro','Doro AB'),(125258694656,'Shenzhen','SHENZHEN BUL-TECH CO.,LTD.'),(125275471872,'WuhanPon','Wuhan Pont Technology CO. , LTD'),(125292249088,'Wavetren','Wavetrend Technologies (Pty) Lim'),(125309026304,'Pylone','Pylone, Inc.'),(125325803520,'RuckusWi','Ruckus Wireless'),(125342580736,'Quantumv','QuantumVision Corporation'),(125359357952,'YxWirele','YX Wireless S.A.'),(125376135168,'HighproI','HIGHPRO INTERNATIONAL R&D CO,.LT'),(125392912384,'LongkayC','Longkay Communication & Technolo'),(125409689600,'Maverick','Maverick Systems Inc.'),(125426466816,'SyrisTec','SYRIS Technology Corp'),(125443244032,'Viconics','Viconics Electronics Inc.'),(125460021248,'Electron','ELECTRONICS CORPORATION OF INDIA'),(125476798464,'Thales-P','Thales-Panda Transportation Syst'),(125493575680,'SeagateT','Seagate Technology'),(125510352896,'Moohadig','MOOHADIGITAL CO., LTD'),(125527130112,'MhAcoust','mh acoustics LLC'),(125543907328,'NokiaDan','Nokia Danmark A/S'),(125560684544,'Muscle','Muscle Corporation'),(125577461760,'Avidyne','Avidyne Corporation'),(125594238976,'SakaTech','SAKA TECHNO SCIENCE CO.,LTD'),(125611016192,'MitronPt','Mitron Pty Ltd'),(125627793408,'LivingIn','Living Independently Group, Inc.'),(125644570624,'HardyIns','Hardy Instruments'),(125661347840,'Nortel',''),(125678125056,'Shenzhen','Shenzhen G-link Digital Technolo'),(125694902272,'Krohne',''),(125711679488,'Cisco','CISCO SYSTEMS, INC.'),(125728456704,'Cisco','CISCO SYSTEMS, INC.'),(125745233920,'Covote','Covote GmbH & Co KG'),(125762011136,'Sensor-T','Sensor-Technik Wiedemann GmbH'),(125778788352,'Innovati','Innovation Wireless Inc.'),(125795565568,'Carestre','Carestream Health, Inc.'),(125812342784,'GridConn','Grid Connect Inc.'),(125829120000,'Alcatel-','Alcatel-Lucent'),(125845897216,'Adaptive','Adaptive Recognition Hungary, In'),(125862674432,'TcmMobil','TCM Mobile LLC'),(125879451648,'AppleCom','Apple Computer Inc.'),(125896228864,'Spinetix','SPINETIX SA'),(125913006080,'BabcockW','Babcock & Wilcox Power Generatio'),(125929783296,'DefzoneB','Defzone B.V.'),(125946560512,'S&OElect','S&O Electronics (Malaysia) Sdn. '),(125963337728,'SunnicTe','Sunnic Technology & Merchandise '),(125980114944,'Zantaz','ZANTAZ, Inc'),(125996892160,'KramerEl','Kramer Electronics Ltd.'),(126013669376,'CaetecMe','CAETEC Messtechnik'),(126030446592,'Cq','CQ Inc'),(126047223808,'MitraEne','Mitra Energy & Infrastructure'),(126064001024,'2wire','2Wire Inc.'),(126080778240,'TecvanIn','Tecvan InformÃ¡tica Ltda'),(126097555456,'TomCommu','Tom Communication Industrial Co.'),(126114332672,'ControlD','Control Dynamics Pty. Ltd.'),(126131109888,'ComingMe','COMING MEDIA CORP.'),(126147887104,'Overspee','OverSpeed SARL'),(126164664320,'AsustekC','ASUSTek COMPUTER INC.'),(126181441536,'Bij','BIJ Corporation'),(126198218752,'InphaseT','InPhase Technologies'),(126214995968,'MieleCie','Miele & Cie. KG'),(126231773184,'AdamComm','Adam Communications Systems Int '),(126248550400,'Microwav','Microwave Radio Communications'),(126265327616,'HyundaiT','Hyundai Telecom'),(126282104832,'Amec',''),(126298882048,'ThomsonT','Thomson Telecom Belgium'),(126315659264,'Knorr-Br','Knorr-Bremse IT-Services GmbH'),(126332436480,'AlphaNet','Alpha Networks Inc.'),(126349213696,'Motorola','Motorola (formerly Netopia, Inc'),(126365990912,'Clariphy','ClariPhy Communications, Inc.'),(126382768128,'Confidan','Confidant International LLC'),(126399545344,'NokiaDan','Nokia Danmark A/S'),(126416322560,'Chainzon','Chainzone Technology Co., Ltd'),(126433099776,'Cisco','CISCO SYSTEMS, INC.'),(126449876992,'Cisco','CISCO SYSTEMS, INC.'),(126466654208,'Wistron','Wistron Corporation'),(126483431424,'Buffalo','Buffalo Inc.'),(126500208640,'TianjinC','Tianjin China-Silicon Microelect'),(126516985856,'Radiosca','Radioscape PLC'),(126533763072,'Eyeheigh','Eyeheight Ltd.'),(126550540288,'Nsgate',''),(126567317504,'InvengoI','Invengo Information Technology C'),(126584094720,'Signamax','SIGNAMAX LLC'),(126600871936,'Wideband','Wideband Semiconductor, Inc.'),(126617649152,'IceEnerg','Ice Energy, Inc.'),(126634426368,'AbeElett','ABE Elettronica S.p.A.'),(126651203584,'Giga-Byt','GIGA-BYTE TECHNOLOGY CO.,LTD.'),(126667980800,'Cisco-Li','Cisco-Linksys, LLC'),(126684758016,'TekronIn','Tekron International Ltd'),(126701535232,'BeijingH','Beijing Huahuan Eletronics Co.,L'),(126718312448,'Guangzho','GUANGZHOU GATEWAY ELECTRONICS CO'),(126735089664,'GnGnNetc','GN A/S (GN Netcom A/S)'),(126751866880,'Emitech','Emitech Corporation'),(126768644096,'Gateway','Gateway, Inc.'),(126785421312,'CallDire','Call Direct Cellular Solutions'),(126802198528,'ShinwaIn','Shinwa Industries(China) Ltd.'),(126818975744,'VigtechL','VigTech Labs Sdn Bhd'),(126835752960,'Clearwir','Clearwire'),(126852530176,'Vaultsto','VaultStor Corporation'),(126869307392,'Techtrex','TechTrex Inc'),(126886084608,'AdbBroad','ADB Broadband Italia'),(126902861824,'LaCrosse','La Crosse Technology LTD'),(126919639040,'Raytek','Raytek GmbH'),(126936416256,'Alereon','Alereon, Inc.'),(126953193472,'Purewave','PureWave Networks'),(126969970688,'EmcoFlow','EMCO Flow Systems'),(126986747904,'Digitize','Digitize, Inc'),(127003525120,'Micro-St','MICRO-STAR INT`L CO.,LTD.'),(127020302336,'Modacom',''),(127037079552,'ClimaxTe','Climax Technology Co., Ltd'),(127053856768,'Flash','Flash, Inc.'),(127070633984,'Watchgua','WatchGuard Video'),(127087411200,'AlertusT','Alertus Technologies LLC'),(127104188416,'NokiaDan','Nokia Danmark A/S'),(127120965632,'CyanOpti','Cyan Optic, Inc.'),(127137742848,'GodexInt','GODEX INTERNATIONAL CO., LTD'),(127154520064,'HokuyoAu','Hokuyo Automatic Co., Ltd.'),(127171297280,'Rockwell','Rockwell Automation'),(127188074496,'ArtjoyIn','ARTJOY INTERNATIONAL LIMITED'),(127204851712,'AxionTec','AXION TECHNOLOGIES'),(127221628928,'MattRPTr','MATT   R.P.Traczynscy Sp.J.'),(127238406144,'HengYuEl','Heng Yu Electronic Manufacturing'),(127255183360,'Cisco','CISCO SYSTEMS, INC.'),(127271960576,'Cisco','CISCO SYSTEMS, INC.'),(127288737792,'Sabioso',''),(127305515008,'Hangzhou','Hangzhou System Technology CO., '),(127322292224,'WbElectr','WB Electronics'),(127339069440,'MediaNum','Media Numerics Limited'),(127355846656,'Seamless','Seamless Internet'),(127372623872,'Takahata','Takahata Electronics Co.,Ltd'),(127389401088,'CastlesT','Castles Technology, Co., LTD'),(127406178304,'Draytek','DrayTek Corp.'),(127422955520,'Swissqua','SwissQual License AG'),(127439732736,'GigamonL','Gigamon Systems LLC'),(127456509952,'Sinotech','Sinotech Engineering Consultants'),(127473287168,'ChangTse','CHANG TSENG TECHNOLOGY CO., LTD'),(127490064384,'Nortel',''),(127506841600,'FujianHe','FuJian HengTong Information Tech'),(127523618816,'Crescend','Crescendo Networks'),(127540396032,'Hokkaido','HOKKAIDO ELECTRIC ENGINEERING CO'),(127557173248,'HpnSuppl','HPN Supply Chain'),(127573950464,'KumhoEng','KUMHO ENG CO.,LTD'),(127590727680,'JuniperN','Juniper networks'),(127607504896,'Bestcomm','BestComm Networks, Inc.'),(127624282112,'TendrilN','Tendril Networks, Inc.'),(127641059328,'Intoto','Intoto Inc.'),(127657836544,'Wellspri','Wellspring Wireless'),(127674613760,'Sony','Sony Corporation'),(127691390976,'DynamicS','Dynamic System Electronics Corp.'),(127708168192,'Nintendo','Nintendo Co., Ltd.'),(127724945408,'Versamed','Versamed Inc.'),(127741722624,'Motorola','Motorola Mobility, Inc.'),(127758499840,'Radiient','Radiient Technologies, Inc.'),(127775277056,'EnphaseE','Enphase Energy'),(127792054272,'Audinate','Audinate Pty L'),(127808831488,'XortecOy','XORTEC OY'),(127825608704,'RikorTv','RIKOR TV, Ltd'),(127842385920,'Aioi','AIOI Systems Co., Ltd.'),(127859163136,'BeijingJ','Beijing Jiaxun Feihong Electrici'),(127875940352,'Snr','SNR Inc.'),(127892717568,'L-3Commu','L-3 Communications Geneva Aerosp'),(127909494784,'Navionic','Navionics Research Inc., dba SCA'),(127926272000,'Gainspan','GainSpan Corp.'),(127943049216,'PavElect','PAV Electronics Limited'),(127959826432,'ExÃ©nsDev','ExÃ©ns Development Oy'),(127976603648,'HetraSec','Hetra Secure Solutions'),(127993380864,'ArrisGro','ARRIS Group, Inc.'),(128010158080,'ArrisGro','ARRIS Group, Inc.'),(128026935296,'ArrisGro','ARRIS Group, Inc.'),(128043712512,'ArrisGro','ARRIS Group, Inc.'),(128060489728,'ArrisGro','ARRIS Group, Inc.'),(128077266944,'ArrisGro','ARRIS Group, Inc.'),(128094044160,'ArrisGro','ARRIS Group, Inc.'),(128110821376,'ArrisGro','ARRIS Group, Inc.'),(128127598592,'ArrisGro','ARRIS Group, Inc.'),(128144375808,'ArrisGro','ARRIS Group, Inc.'),(128161153024,'Algolith',''),(128177930240,'Microsof','Microsoft Corporation'),(128194707456,'HonHaiPr','Hon Hai Precision Ind.Co.,Ltd.'),(128211484672,'Mikroele','Mikroelektronika spol. s r. o.'),(128228261888,'C-Bel','C-BEL Corporation'),(128245039104,'Hangzhou','HangZhou DeChangLong Tech&Info C'),(128261816320,'DatHK','DAT H.K. LIMITED'),(128278593536,'Zhejiang','Zhejiang Broadcast&Television Te'),(128295370752,'SunitecE','Sunitec Enterprise Co., Ltd.'),(128312147968,'IntelCor','Intel Corporate'),(128328925184,'IntelCor','Intel Corporate'),(128345702400,'Radionor','Radionor Communications'),(128362479616,'Intuicom',''),(128379256832,'Visionee','Visioneered Image Systems'),(128396034048,'Cisco','CISCO SYSTEMS, INC.'),(128412811264,'Cisco','CISCO SYSTEMS, INC.'),(128429588480,'MarineSo','Marine Sonic Technology, Ltd.'),(128446365696,'NikkoDen','Nikko Denki Tsushin Corporation('),(128463142912,'NokiaDan','Nokia Danmark A/S'),(128479920128,'Commtest','Commtest Instruments Ltd'),(128496697344,'DinecInt','DINEC International'),(128513474560,'Marusys',''),(128530251776,'GridNet','Grid Net, Inc.'),(128547028992,'Nextvisi','NEXTVISION SISTEMAS DIGITAIS DE '),(128563806208,'Trimm','TRIMM, INC.'),(128580583424,'Vidient','Vidient Systems, Inc.'),(128597360640,'Intego','Intego Systems, Inc.'),(128614137856,'Netflix','Netflix, Inc.'),(128630915072,'SbsScien','SBS Science & Technology Co., Lt'),(128647692288,'Magellan','Magellan Technology Pty Limited'),(128664469504,'Sunshine','Sunshine Co,LTD'),(128681246720,'SamsungE','Samsung Electronics Co.,Ltd'),(128698023936,'RStahlSc','R. STAHL SchaltgerÃ¤te GmbH'),(128714801152,'WebproVi','Webpro Vision Technology Corpora'),(128731578368,'Cybiotro','Cybiotronics (Far East) Limited'),(128748355584,'FujianLa','Fujian LANDI Commercial Equipmen'),(128765132800,'Netcleus','NETCLEUS Systems Corporation'),(128781910016,'Ksic',''),(128798687232,'NokiaDan','Nokia Danmark A/S'),(128815464448,'Palm','Palm, Inc'),(128832241664,'NetworkC','Network Critical Solutions Ltd'),(128849018880,'ShantouI','Shantou Institute of Ultrasonic '),(128865796096,'RenesasT','Renesas Technology Sales Co., Lt'),(128882573312,'SougouKe','Sougou Keikaku Kougyou Co.,Ltd.'),(128899350528,'Licomm','LiComm Co., Ltd.'),(128916127744,'HansonRe','Hanson Research Corporation'),(128932904960,'XseedTec','Xseed Technologies & Computing'),(128949682176,'Wibrain',''),(128966459392,'WinyTech','Winy Technology Co., Ltd.'),(128983236608,'CentecNe','Centec Networks Inc'),(129000013824,'Zefatek','ZEFATEK Co.,LTD'),(129016791040,'SybaTech','Syba Tech Limited'),(129033568256,'Hewlett-','Hewlett-Packard Company'),(129050345472,'Sherwood','Sherwood Information Partners, I'),(129067122688,'Micran','Micran Ltd.'),(129083899904,'MaxiView','MAXI VIEW HOLDINGS LIMITED'),(129100677120,'BriotInt','Briot International'),(129117454336,'Shenzhen','ShenZhen Huawei Communication Te'),(129134231552,'EleluxIn','ELELUX INTERNATIONAL LTD'),(129151008768,'Ecolab',''),(129167785984,'Cisco','CISCO SYSTEMS, INC.'),(129184563200,'Cisco','CISCO SYSTEMS, INC.'),(129201340416,'BeechHil','Beech Hill Electronics'),(129218117632,'Keytroni','Keytronix'),(129234894848,'StnBv','STN BV'),(129251672064,'RadioAct','Radio Activity srl'),(129268449280,'Gtri',''),(129285226496,'BestSour','Best Source Taiwan Inc.'),(129302003712,'DigitalS','Digital Stream Technology, Inc.'),(129318780928,'SwsAustr','SWS Australia Pty Limited'),(129335558144,'EastCoas','East Coast Datacom, Inc.'),(129352335360,'Honeywel','Honeywell Life Safety'),(129369112576,'Nortel',''),(129385889792,'Intertai','Intertain Inc.'),(129402667008,'Qisda','Qisda Co.'),(129419444224,'ArvooIma','ARVOO Imaging Products BV'),(129436221440,'Electron','Electronic Educational Devices, '),(129452998656,'Zhejiang','Zhejiang Bell Technology Co.,ltd'),(129469775872,'IntekDig','Intek Digital Inc'),(129486553088,'Digifrie','Digifriends Co. Ltd'),(129503330304,'SbnTech','SBN TECH Co.,Ltd.'),(129520107520,'Lumexis','Lumexis Corporation'),(129536884736,'Hyperthe','Hypertherm Inc'),(129553661952,'Netgear','Netgear Inc.'),(129570439168,'RadioDes','Radio Systems Design, Inc.'),(129587216384,'Cyverse','CyVerse Corporation'),(129603993600,'Stim',''),(129620770816,'SirtiSPA','SIRTI S.p.A.'),(129637548032,'DimotoPt','DiMoto Pty Ltd'),(129654325248,'Shireen','Shireen Inc'),(129671102464,'Infomark','INFOMARK CO.,LTD.'),(129687879680,'Zensys',''),(129704656896,'Inventec','Inventec Corporation'),(129721434112,'Cryptome','CryptoMetrics'),(129738211328,'Nintendo','Nintendo Co., Ltd.'),(129754988544,'Ipte',''),(129771765760,'Universa','Universal Global Scientific Indu'),(129788542976,'Bluecard','Bluecard Software Technology Co.'),(129805320192,'ComsysCo','Comsys Communication Ltd.'),(129822097408,'NokiaDan','Nokia Danmark A/S'),(129838874624,'NokiaDan','Nokia Danmark A/S'),(129855651840,'LyngboxM','Lyngbox Media AB'),(129872429056,'AlpsElec','Alps Electric Co., Ltd'),(129889206272,'Kmw','KMW Inc.'),(129905983488,'Trellisw','TrellisWare Technologies, Inc.'),(129922760704,'Shanghai','Shanghai DareGlobal Technologies'),(129939537920,'Microwav','Microwave Communication & Compon'),(129956315136,'Teltonik','Teltonika'),(129973092352,'AisinAw','AISIN AW CO.,LTD.'),(129989869568,'Santec',''),(130006646784,'SonyEric','Sony Ericsson Mobile Communicati'),(130023424000,'Motorola','Motorola Mobility, Inc.'),(130040201216,'PtHariff','PT. Hariff Daya Tunggal Engineer'),(130056978432,'Wi-Links',''),(130073755648,'Cisco','CISCO SYSTEMS, INC.'),(130090532864,'Cisco','CISCO SYSTEMS, INC.'),(130107310080,'CityThea','City Theatrical'),(130124087296,'HonHaiPr','Hon Hai Precision Ind.Co., Ltd.'),(130140864512,'WelkinSc','Welkin Sciences, LLC'),(130157641728,'DakoEdv-','DAKO EDV-Ingenieur- und Systemha'),(130174418944,'Dell','Dell Inc.'),(130191196160,'Battisto','BATTISTONI RESEARCH'),(130207973376,'Converte','Converter Industry Srl'),(130224750592,'AppleCom','Apple Computer Inc'),(130241527808,'FurtherT','Further Tech Co., LTD'),(130258305024,'ToyoElec','TOYO ELECTRIC Corporation'),(130275082240,'Cowon','COWON SYSTEMS,Inc.'),(130291859456,'BallyWul','Bally Wulff Entertainment GmbH'),(130308636672,'AlcomaSp','ALCOMA, spol. s r.o.'),(130325413888,'D-Link','D-Link Corporation'),(130342191104,'SiliconT','Silicon Turnkey Express, LLC'),(130358968320,'Motorola','Motorola Mobility, Inc.'),(130375745536,'Unitron','Unitron Company, Inc.'),(130392522752,'RbGenera','RB GeneralEkonomik'),(130409299968,'HolosysD','Holosys d.o.o.'),(130426077184,'Computim','COmputime Ltd.'),(130442854400,'Kwikbyte','KwikByte, LLC'),(130459631616,'DigitalL','Digital Lighting Systems, Inc'),(130476408832,'Itec','ITEC GmbH'),(130493186048,'Siemon',''),(130509963264,'Vibro-Me','Vibro-Meter SA'),(130526740480,'IntelCor','Intel Corporate'),(130543517696,'IntelCor','Intel Corporate'),(130560294912,'ResolEle','RESOL Elektronische Regelungen G'),(130577072128,'IntelCor','Intel Corporate'),(130593849344,'QuantaCo','Quanta Computer'),(130610626560,'Thomson','Thomson Inc.'),(130627403776,'BeijingB','Beijing Bluexon Technology Co.,L'),(130644180992,'CiscoSpv','Cisco SPVTG'),(130660958208,'CarbonMo','Carbon Mountain LLC'),(130677735424,'ItR&DCen','IT R&D Center'),(130694512640,'Shenzhen','Shenzhen First Mile Communicatio'),(130711289856,'Magna-Po','Magna-Power Electronics, Inc.'),(130728067072,'CobhamDe','Cobham Defence Communications Lt'),(130744844288,'Igeacare','Igeacare Solutions Inc.'),(130761621504,'Pcs',''),(130778398720,'Zte','ZTE CORPORATION'),(130795175936,'SagemCom','SAGEM COMMUNICATION'),(130811953152,'LgElectr','LG Electronics'),(130828730368,'ThermoFi','Thermo Fisher Scientific'),(130845507584,'Air2app',''),(130862284800,'OwitekTe','Owitek Technology Ltd.,'),(130879062016,'Cisco','CISCO SYSTEMS, INC.'),(130895839232,'Cisco','CISCO SYSTEMS, INC.'),(130912616448,'RISRL','R.I.CO. S.r.l.'),(130929393664,'Taiwick','Taiwick Limited'),(130946170880,'SamsungE','Samsung Electronics Co.,Ltd'),(130962948096,'Nortel',''),(130979725312,'CbmOfAme','CBM of America'),(130996502528,'LastMile','Last Mile Ltd.'),(131013279744,'CnbTechn','CNB Technology Inc.'),(131030056960,'Sandisk','SanDisk Corporation'),(131046834176,'Lan/ManS','LAN/MAN Standards Association (L'),(131063611392,'PikaTech','Pika Technologies Inc.'),(131080388608,'Lagotek','Lagotek Corporation'),(131097165824,'Mel','MEL Co.,Ltd.'),(131113943040,'Realease','Realease Limited'),(131130720256,'AndorSys','ANDOR SYSTEM SUPPORT CO., LTD.'),(131147497472,'Crfs','CRFS Limited'),(131164274688,'Ecopy','eCopy, Inc'),(131181051904,'InfraAcc','Infra Access Korea Co., Ltd.'),(131197829120,'AsustekC','ASUSTek COMPUTER INC.'),(131214606336,'Motorola','Motorola Mobility, Inc.'),(131231383552,'Hunkeler','Hunkeler AG'),(131248160768,'Canon','CANON INC.'),(131264937984,'Elitegro','Elitegroup Computer Systems Co'),(131281715200,'KiminEle','KIMIN Electronic Co., Ltd.'),(131298492416,'JeulinSA','JEULIN S.A.'),(131315269632,'Ciritech','CiriTech Systems Inc'),(131332046848,'Supercom','SUPERCOM TECHNOLOGY CORPORATION'),(131348824064,'Sigmalin','SIGMALINK'),(131365601280,'Sepura','Sepura Plc'),(131382378496,'MediumLi','Medium Link System Technology CO'),(131399155712,'Greenlin','GreenLine Communications'),(131415932928,'Vantanol','Vantanol Industrial Corporation'),(131432710144,'Hamilton','HAMILTON Bonaduz AG'),(131449487360,'San-Eish','San-Eisha, Ltd.'),(131466264576,'Fidustro','Fidustron INC'),(131483041792,'RecallTe','Recall Technologies, Inc.'),(131499819008,'DdmHopt+','ddm hopt + schuler Gmbh + Co. KG'),(131516596224,'Visionee','Visioneering Systems, Inc.'),(131533373440,'Xln-T',''),(131550150656,'Brunata','Brunata a/s'),(131566927872,'Symx','Symx Systems, Inc.'),(131583705088,'NokiaDan','Nokia Danmark A/S'),(131600482304,'NokiaDan','Nokia Danmark A/S'),(131617259520,'Robotous','ROBOTOUS, Inc.'),(131634036736,'BestItWo','Best IT World (India) Pvt. Ltd.'),(131650813952,'Actionte','ActionTec Electronics, Inc'),(131667591168,'DatangMo','Datang Mobile Communications Equ'),(131684368384,'Nintendo','Nintendo Co., Ltd.'),(131701145600,'E-SenzaT','E-Senza Technologies GmbH'),(131717922816,'Telewell','TeleWell Oy'),(131734700032,'Armadeus','Armadeus Systems'),(131751477248,'Wingtech','Wingtech Group Limited'),(131768254464,'Continen','Continental Automotive Systems'),(131785031680,'OphirOpt','Ophir Optronics Ltd'),(131801808896,'ImesdEle','ImesD Electronica S.L.'),(131818586112,'Cryptsof','Cryptsoft Pty Ltd'),(131835363328,'LgInnote','LG innotek'),(131852140544,'PrimexWi','Primex Wireless'),(131868917760,'UnifatTe','UNIFAT TECHNOLOGY LTD.'),(131885694976,'EverSpar','Ever Sparkle Technologies Ltd'),(131902472192,'TagHeuer','TAG Heuer SA'),(131919249408,'Tbtech','TBTech, Co., Ltd.'),(131936026624,'Fortis','Fortis, Inc.'),(131952803840,'SingFaiT','Sing Fai Technology Limited'),(131969581056,'HighDens','High Density Devices AS'),(131986358272,'Blueligh','BLUELIGHT TECHNOLOGY INC.'),(132003135488,'WintechA','WINTECH AUTOMATION CO.,LTD.'),(132019912704,'Cisco','CISCO SYSTEMS, INC.'),(132036689920,'Cisco','CISCO SYSTEMS, INC.'),(132053467136,'HaasAuto','Haas Automation Inc.'),(132070244352,'Microchi','Microchip Technology Inc.'),(132087021568,'3comEuro','3COM EUROPE LTD'),(132103798784,'Apple','Apple, Inc'),(132120576000,'Kozio','Kozio, Inc.'),(132137353216,'Celio','Celio Corp'),(132154130432,'MiddleAt','Middle Atlantic Products Inc'),(132170907648,'ObviusHo','Obvius Holdings LLC'),(132187684864,'2wire',''),(132204462080,'RapidMob','Rapid Mobile (Pty) Ltd'),(132221239296,'Dell','Dell Inc'),(132238016512,'Nortel',''),(132254793728,'\"Rpc\"Ene','\"RPC \"Energoautomatika\" Ltd'),(132271570944,'Cdvi',''),(132288348160,'Kyland',''),(132305125376,'BisaTech','BISA Technologies (Hong Kong) Li'),(132321902592,'PhilipsE','PHILIPS ELECTRONICS UK LTD'),(132338679808,'Ingespac','Ingespace'),(132355457024,'Keyproce','Keyprocessor B.V.'),(132372234240,'RayShine','Ray Shine Video Technology Inc'),(132389011456,'DotTechn','Dot Technology Int`l Co., Ltd.'),(132405788672,'DobleEng','Doble Engineering'),(132422565888,'Tekon-Au','Tekon-Automatics'),(132439343104,'AlentecO','Alentec & Orion AB'),(132456120320,'H-Stream','H-Stream Wireless, Inc.'),(132472897536,'DigitalU','Digital United Inc.'),(132489674752,'Mitsubis','Mitsubishi Precision Co.,LTd.'),(132506451968,'Wesemann','Wesemann Elektrotechniek B.V.'),(132523229184,'GikenTra','Giken Trastem Co., Ltd.'),(132540006400,'SonyEric','Sony Ericsson Mobile Communicati'),(132556783616,'WaskoSA','WASKO S.A.'),(132573560832,'Byd','BYD COMPANY LIMITED'),(132590338048,'MasterIn','Master Industrialization Center '),(132607115264,'UrmetDom','Urmet Domus SpA'),(132623892480,'SamsungE','Samsung Electronics Co.,Ltd'),(132640669696,'SamsungE','Samsung Electronics Co.,Ltd'),(132657446912,'T&WElect','T&W Electronics (ShenZhen) Co.,L'),(132674224128,'AcsSolut','ACS Solutions France'),(132691001344,'Cisco-Li','Cisco-Linksys, LLC'),(132707778560,'Shenzhen','Shenzhen Advanced Video Info-Tec'),(132724555776,'Epic','Epic Systems Inc'),(132741332992,'Mytek',''),(132758110208,'Stonerid','Stoneridge Electronics AB'),(132774887424,'SensorSw','Sensor Switch, Inc.'),(132791664640,'Talk-A-P','Talk-A-Phone Co.'),(132808441856,'CompalIn','COMPAL INFORMATION (KUNSHAN) CO.'),(132825219072,'Adventiq','Adventiq Ltd.'),(132841996288,'Etl','ETL Systems Ltd'),(132858773504,'Cantroni','Cantronic International Limited'),(132875550720,'GigafinN','Gigafin Networks'),(132892327936,'Servimat',''),(132909105152,'MicroMot','Micro Motion Inc'),(132925882368,'From2',''),(132942659584,'L-3Commu','L-3 Communications Display Syste'),(132959436800,'HitekAut','Hitek Automated Inc.'),(132976214016,'Cisco','CISCO SYSTEMS, INC.'),(132992991232,'Cisco','CISCO SYSTEMS, INC.'),(133009768448,'Emfinity','Emfinity Inc.'),(133026545664,'PascomKo','Pascom Kommunikations systeme Gm'),(133043322880,'Protei','PROTEI Ltd.'),(133060100096,'TrioMoti','Trio Motion Technology Ltd'),(133076877312,'Jsc\"Mass','JSC \"MASSA-K\"'),(133093654528,'Microbit','Microbit 2.0 AB'),(133110431744,'LevelSRO','LEVEL s.r.o.'),(133127208960,'Mueller-','Mueller-Elektronik GmbH & Co. KG'),(133143986176,'NokiaDan','Nokia Danmark A/S'),(133160763392,'NokiaDan','Nokia Danmark A/S'),(133177540608,'Pixelmet','Pixelmetrix Corporation Pte Ltd'),(133194317824,'Num','NUM AG'),(133211095040,'Granch','Granch Ltd.'),(133227872256,'ItasTech','iTAS Technology Corp.'),(133244649472,'Integrat','Integrated Dispatch Solutions'),(133261426688,'AzteqMob','AZTEQ Mobile'),(133278203904,'Risco','RISCO LTD'),(133294981120,'Jastec','JASTEC CO., LTD.'),(133311758336,'Nortel',''),(133328535552,'FederalS','Federal State Unitary Enterprise'),(133345312768,'Intellig','Intelligent Digital Services Gmb'),(133362089984,'L3Commun','L3 Communications - Telemetry We'),(133378867200,'JapanKya','Japan Kyastem Co., Ltd'),(133395644416,'SelectEn','Select Engineered Systems'),(133412421632,'ToledoDo','TOLEDO DO BRASIL INDUSTRIA DE BA'),(133429198848,'Openmoko','OPENMOKO, INC.'),(133445976064,'JuniperN','Juniper Networks'),(133462753280,'SAS','S.& A.S. Ltd.'),(133479530496,'Nexg',''),(133496307712,'Bioscryp','Bioscrypt Inc'),(133513084928,'Wistron','Wistron Corporation'),(133529862144,'Idx','IDX Company, Ltd.'),(133546639360,'HakusanM','Hakusan.Mfg.Co,.Ltd'),(133563416576,'Ben-RiEl','BEN-RI ELECTRONICA S.A.'),(133580193792,'Prominve','Prominvest'),(133596971008,'Royaltek','RoyalTek Company Ltd.'),(133613748224,'KobishiE','KOBISHI ELECTRIC Co.,Ltd.'),(133630525440,'AtlasMat','Atlas Material Testing Technolog'),(133647302656,'AstecTec','Astec Technology Co., Ltd'),(133664079872,'EdimaxTe','Edimax Technology Co. Ltd.'),(133680857088,'Logitech','Logitech Europe SA'),(133697634304,'InnerMon','Inner Mongolia Yin An Science & '),(133714411520,'SourcePh','Source Photonics, Inc.'),(133731188736,'Interaco','Interacoustics'),(133747965952,'Digitvie','DIGITVIEW TECHNOLOGY CO., LTD.'),(133764743168,'Mbs','MBS GmbH'),(133781520384,'Cisco','CISCO SYSTEMS, INC.'),(133798297600,'Cisco','CISCO SYSTEMS, INC.'),(133815074816,'HpnSuppl','HPN Supply Chain'),(133831852032,'Hewlett-','Hewlett-Packard Company'),(133848629248,'Accm',''),(133865406464,'OrangeLo','Orange Logic'),(133882183680,'Starbrid','Starbridge Networks'),(133898960896,'Electro-','Electro-Optical Imaging, Inc.'),(133915738112,'Triangle','Triangle Research Int`l Pte Ltd'),(133932515328,'Berker','Berker GmbH & Co. KG'),(133949292544,'Travelpi','Travelping'),(133966069760,'Radiocom','Radiocomp'),(133982846976,'Nintendo','Nintendo Co., Ltd.'),(133999624192,'Netgear','Netgear Inc.'),(134016401408,'LungHwaE','Lung Hwa Electronics Co., Ltd.'),(134033178624,'Air802Ll','AIR802 LLC'),(134049955840,'BellwinI','Bellwin Information Co. Ltd.,'),(134066733056,'GenesisI','Genesis I&C'),(134083510272,'Positron',''),(134100287488,'Construc','Construcciones y Auxiliar de Fer'),(134117064704,'HonHaiPr','Hon Hai Precision Ind.Co., Ltd.'),(134133841920,'IntelCor','Intel Corporate'),(134150619136,'IntelCor','Intel Corporate'),(134167396352,'Qbit','Qbit GmbH'),(134184173568,'Rp-Techn','RP-Technik e.K.'),(134200950784,'Avm','AVM GmbH'),(134217728000,'Speakerc','Speakercraft Inc.'),(134234505216,'RuckusWi','Ruckus Wireless'),(134251282432,'Ethersta','Etherstack plc'),(134268059648,'EntesEle','ENTES ELEKTRONIK'),(134284836864,'GeTransp','GE Transportation Systems'),(134301614080,'Enterasy','Enterasys'),(134318391296,'Nortel',''),(134335168512,'McsLogic','MCS Logic Inc.'),(134351945728,'Mojix','Mojix Inc.'),(134368722944,'EurosatD','Eurosat Distribution Ltd'),(134385500160,'Albentia','Albentia Systems S.A.'),(134402277376,'LineageP','Lineage Power'),(134419054592,'RosemanE','Roseman Engineering Ltd'),(134435831808,'Segnetic','Segnetics LLC'),(134452609024,'ConmedLi','ConMed Linvatec'),(134469386240,'Thinkwar','Thinkware Co. Ltd.'),(134486163456,'Swissdis','Swissdis AG'),(134502940672,'HdCommun','HD Communications Corp'),(134519717888,'UvtUnter','UVT Unternehmensberatung fur Ver'),(134536495104,'GemacGes','GEMAC Gesellschaft fÃ¼r Mikroele'),(134553272320,'LorexTec','Lorex Technology Inc.'),(134570049536,'Honeywel','Honeywell Security (China) Co., '),(134586826752,'DigitalF','DIGITAL FORECAST'),(134603603968,'PhonikIn','Phonik Innovation Co.,LTD'),(134620381184,'EmhEnerg','EMH Energiemesstechnik GmbH'),(134637158400,'Kronback','Kronback Tracers'),(134653935616,'Beckwith','Beckwith Electric Co.'),(134670712832,'Apple','Apple, Inc.'),(134687490048,'NokiaDan','Nokia Danmark A/S'),(134704267264,'NokiaDan','Nokia Danmark A/S'),(134721044480,'DynaTech','Dyna Technology Co.,Ltd.'),(134737821696,'Blatand','Blatand GmbH'),(134754598912,'Compass','COMPASS SYSTEMS CORP.'),(134771376128,'TalentCo','Talent Communication Networks In'),(134788153344,'Jsc\"Stil','JSC \"Stilsoft\"'),(134804930560,'JscGoodw','JSC Goodwin-Europa'),(134821707776,'BeijingA','Beijing Autelan Technology Inc.'),(134838484992,'KoreaEle','KOREA ELECTRIC TERMINAL CO., LTD'),(134855262208,'PlanarLl','PLANAR LLC'),(134872039424,'Hitachi','Hitachi,Ltd.'),(134888816640,'Martinss','Martinsson Elektronik AB'),(134905593856,'PingoodT','Pingood Technology Co., Ltd.'),(134922371072,'Packetfl','PacketFlux Technologies, Inc.'),(134939148288,'LgElectr','LG Electronics'),(134955925504,'Cisco','CISCO SYSTEMS, INC.'),(134972702720,'Cisco','CISCO SYSTEMS, INC.'),(134989479936,'VtechEng','Vtech Engineering Corporation'),(135006257152,'FujianSu','Fujian Sunnada Communication Co.'),(135023034368,'BotikTec','Botik Technologies LTD'),(135039811584,'XgTechno','xG Technology, Inc.'),(135056588800,'QingdaoH','QingDao Hiphone Technology Co,.L'),(135073366016,'Teraview','Teraview Technology Co., Ltd.'),(135090143232,'EigenDev','Eigen Development'),(135106920448,'GibahnMe','GiBahn Media'),(135123697664,'Airlogic','AirLogic Systems Inc.'),(135140474880,'HeolDesi','HEOL DESIGN'),(135157252096,'BlueFoxP','Blue Fox Porini Textile'),(135174029312,'LodamEle','Lodam Electronics A/S'),(135190806528,'Wiwide','WiWide Inc.'),(135207583744,'Technexi','TechNexion Ltd.'),(135224360960,'Witelcom','Witelcom AS'),(135241138176,'Embedded','embedded wireless GmbH'),(135257915392,'Motorola','Motorola Mobility, Inc.'),(135274692608,'Phabrix','Phabrix Limited'),(135291469824,'LucasBv','Lucas Holding bv'),(135308247040,'AccelSem','Accel Semiconductor Corp'),(135325024256,'Cal-Comp','Cal-Comp Electronics & Communica'),(135341801472,'Teleplan','Teleplan Technology Services Sdn'),(135358578688,'GigleSem','Gigle Semiconductor'),(135375355904,'AprivaIs','Apriva ISS, LLC'),(135392133120,'Digecor',''),(135408910336,'Skydigit','Skydigital Inc.'),(135425687552,'FmsForce','FMS Force Measuring Systems AG'),(135442464768,'Signalio','Signalion GmbH'),(135459241984,'EllionDi','Ellion Digital Inc.'),(135476019200,'CacheIq','Cache IQ'),(135492796416,'Ccs','CCS Inc.'),(135509573632,'Ingenieu','Ingenieurbuero Stark GmbH und Ko'),(135526350848,'MetrisUs','Metris USA Inc.'),(135543128064,'Shanghai','Shanghai Bellmann Digital Source'),(135559905280,'Actionte','Actiontec Electronics, Inc'),(135576682496,'DbsLodgi','DBS Lodging Technologies, LLC'),(135593459712,'Videoiq','VideoIQ, Inc.'),(135610236928,'Xiotech','Xiotech Corporation'),(135627014144,'LascarEl','Lascar Electronics Ltd'),(135643791360,'SagemCom','SAGEM COMMUNICATION'),(135660568576,'Aprotech','APROTECH CO.LTD'),(135677345792,'BertanaS','BERTANA SRL'),(135694123008,'Daiichi-','DAIICHI-DENTSU LTD.'),(135710900224,'Seronics','SERONICS co.ltd'),(135727677440,'NortelNe','Nortel Networks'),(135744454656,'Posbro',''),(135761231872,'Ledco',''),(135778009088,'Cisco','CISCO SYSTEMS, INC.'),(135794786304,'Cisco','CISCO SYSTEMS, INC.'),(135811563520,'ThomsonT','Thomson Telecom Belgium'),(135828340736,'A10Netwo','A10 Networks'),(135845117952,'Gtran','Gtran Inc'),(135861895168,'DatronWo','Datron World Communications, Inc'),(135878672384,'T&WElect','T&W Electronics(Shenzhen)Co.,Ltd'),(135895449600,'Shenzhen','ShenZhen Gongjin Electronics Co.'),(135912226816,'Blue-Whi','Blue-White Industries'),(135929004032,'StiloSrl','Stilo srl'),(135945781248,'SonyComp','Sony Computer Entertainment Inc.'),(135962558464,'SmartEne','Smart Energy Instruments Inc.'),(135979335680,'AtlantaD','Atlanta DTH, Inc.'),(135996112896,'Taseon','Taseon, Inc.'),(136012890112,'ISHighTe','I.S HIGH TECH.INC'),(136029667328,'Goodmill','Goodmill Systems Ltd'),(136046444544,'BrownInn','Brown Innovations, Inc'),(136063221760,'BlickSou','Blick South Africa (Pty) Ltd'),(136079998976,'Nextio','NextIO, Inc.'),(136096776192,'Timeips','TimeIPS, Inc.'),(136113553408,'Cybertec','Cybertech Inc.'),(136130330624,'Sontheim','Sontheim Industrie Elektronik Gm'),(136147107840,'2wire',''),(136163885056,'Smartsha','SmartShare Systems'),(136180662272,'I/OInter','I/O Interconnect Inc.'),(136197439488,'ChiLinTe','Chi Lin Technology Co., Ltd.'),(136214216704,'WimateTe','WiMate Technologies Corp.'),(136230993920,'Universa','Universal Remote Control, Inc.'),(136247771136,'Paltroni','Paltronics'),(136264548352,'BoyoungT','BoYoung Tech. & Marketing, Inc.'),(136281325568,'Xenatech','Xenatech Co.,LTD'),(136298102784,'Evga','EVGA Corporation'),(136314880000,'KyoceraW','Kyocera Wireless Corp.'),(136331657216,'Shenzhen','Shenzhen Mopnet Industrial Co.,L'),(136348434432,'FulhuaMi','Fulhua Microelectronics Corp. Ta'),(136365211648,'ControlE','Control Express Finland Oy'),(136381988864,'HanlongT','Hanlong Technology Co.,LTD'),(136398766080,'JowTongT','Jow Tong Technology Co Ltd'),(136415543296,'Smartsyn','SmartSynch, Inc'),(136432320512,'Motorola','Motorola Mobility, Inc.'),(136449097728,'Nintendo','Nintendo Co., Ltd.'),(136465874944,'AsustekC','ASUSTek COMPUTER INC.'),(136482652160,'CasioHit','Casio Hitachi Mobile Comunicatio'),(136499429376,'Up-Today','Up-Today Industrial Co., Ltd.'),(136516206592,'Cisco','CISCO SYSTEMS, INC.'),(136532983808,'Cisco','CISCO SYSTEMS, INC.'),(136549761024,'NiwSolut','NIW Solutions'),(136566538240,'SamsungE','Samsung Electronics Co.,Ltd'),(136583315456,'SamsungE','Samsung Electronics'),(136600092672,'QtechLlc','QTECH LLC'),(136616869888,'MsiTechn','MSI Technology GmbH'),(136633647104,'Giga-Byt','GIGA-BYTE TECHNOLOGY CO.,LTD.'),(136650424320,'Optex','OPTEX CO.,LTD.'),(136667201536,'Commtech','COMMTECH TECHNOLOGY MACAO COMMER'),(136683978752,'RivaNetw','RIVA Networks Inc.'),(136700755968,'4ipnet','4IPNET, INC.'),(136717533184,'Microris','MICRORISC s.r.o.'),(136734310400,'Shenzhen','Shenzhen Allywll'),(136751087616,'TeleradS','TELERAD SA'),(136767864832,'A-TrustC','A-TRUST COMPUTER CORPORATION'),(136784642048,'RsdCommu','RSD Communications Ltd'),(136801419264,'NortelNe','Nortel Networks'),(136818196480,'NetworkS','Network Supply Corp.,'),(136834973696,'MobileSa','Mobile Safe Track Ltd'),(136851750912,'GdiLlc','GDI LLC'),(136868528128,'NokiaDan','Nokia Danmark A/S'),(136885305344,'NokiaDan','Nokia Danmark A/S'),(136902082560,'Edgevelo','EdgeVelocity Corp'),(136918859776,'HonHaiPr','Hon Hai Precision Ind. Co., Ltd.'),(136935636992,'HonHaiPr','Hon Hai Precision Ind. Co., Ltd.'),(136952414208,'LgElectr','LG Electronics'),(136969191424,'SonyEric','Sony Ericsson Mobile Communicati'),(136985968640,'In-Circu','In-Circuit GmbH'),(137002745856,'Alphion','Alphion Corporation'),(137019523072,'Simet',''),(137036300288,'Kurusuga','KURUSUGAWA Electronics Industry '),(137053077504,'Printrex','Printrex, Inc.'),(137069854720,'AppliedM','Applied Media Technologies Corpo'),(137086631936,'TrioData','Trio Datacom Pty Ltd'),(137103409152,'SynapseÃ‰','Synapse Ã‰lectronique'),(137120186368,'Tecan','Tecan Systems Inc.'),(137136963584,'UbisysTe','ubisys technologies GmbH'),(137153740800,'ShinseiI','SHINSEI INDUSTRIES CO.,LTD'),(137170518016,'AudioPar','Audio Partnership'),(137187295232,'ParadoxH','Paradox Hellas S.A.'),(137204072448,'ViaTechn','VIA Technologies, Inc.'),(137220849664,'Apple','Apple, Inc'),(137237626880,'PowerMon','Power Monitors, Inc.'),(137254404096,'Kongsber','Kongsberg Defence & Aerospace'),(137271181312,'PsAudioI','PS Audio International'),(137287958528,'Nakajima','Nakajima All Precision Co., Ltd.'),(137304735744,'SiemensS','Siemens AG, Sector Industry, Dri'),(137321512960,'Advanced','Advanced Knowledge Associates'),(137338290176,'Coretree','Coretree, Co, Ltd'),(137355067392,'GreenPac','Green Packet Bhd'),(137371844608,'Riccius+','Riccius+Sohn GmbH'),(137388621824,'IndigoMo','Indigo Mobile Technologies Corp.'),(137405399040,'HpnSuppl','HPN Supply Chain'),(137422176256,'Respiron','Respironics, Inc.'),(137438953472,'LexmarkI','LEXMARK INTERNATIONAL, INC.'),(137455730688,'DspSolut','DSP SOLUTIONS, INC.'),(137472507904,'Seritech','SERITECH ENTERPRISE CO., LTD.'),(137489285120,'PixelPow','PIXEL POWER LTD.'),(137506062336,'Yamatake','YAMATAKE-HONEYWELL CO., LTD.'),(137522839552,'SimpleTe','SIMPLE TECHNOLOGY'),(137539616768,'GarrettC','GARRETT COMMUNICATIONS, INC.'),(137556393984,'Sfa','SFA, INC.'),(137573171200,'CableCom','CABLE & COMPUTER TECHNOLOGY'),(137589948416,'PackardB','PACKARD BELL ELEC., INC.'),(137606725632,'Source-C','SOURCE-COMM CORP.'),(137623502848,'Octagon','OCTAGON SYSTEMS CORP.'),(137640280064,'Adastra','ADASTRA SYSTEMS CORP.'),(137657057280,'CarlZeis','CARL ZEISS'),(137673834496,'Satellit','SATELLITE TECHNOLOGY MGMT, INC'),(137690611712,'Tanbac','TANBAC CO., LTD.'),(137707388928,'JeolSyst','JEOL SYSTEM TECHNOLOGY CO. LTD'),(137724166144,'Canopus','CANOPUS CO., LTD.'),(137740943360,'Camtroni','CAMTRONICS MEDICAL SYSTEMS'),(137757720576,'Diversif','DIVERSIFIED TECHNOLOGY, INC.'),(137774497792,'GlobalVi','GLOBAL VIEW CO., LTD.'),(137791275008,'ActisCom','ACTIS COMPUTER SA'),(137808052224,'ShowaEle','SHOWA ELECTRIC WIRE & CABLE CO'),(137824829440,'Orbotech',''),(137841606656,'CisTechn','CIS TECHNOLOGY INC.'),(137858383872,'Ohler','OHLER GmbH'),(137875161088,'MrvCommu','MRV Communications, Inc.'),(137891938304,'Northern','NORTHERN TELECOM/NETWORK'),(137908715520,'Excel','EXCEL, INC.'),(137925492736,'KatanaPr','KATANA PRODUCTS'),(137942269952,'Netquest','NETQUEST CORPORATION'),(137959047168,'BestPowe','BEST POWER TECHNOLOGY, INC.'),(137975824384,'Megatron','MEGATRON COMPUTER INDUSTRIES PTY'),(137992601600,'Algorith','ALGORITHMS SOFTWARE PVT. LTD.'),(138009378816,'NmsCommu','NMS Communications'),(138026156032,'TCTechno','T.C. TECHNOLOGIES PTY. LTD'),(138042933248,'PacificC','PACIFIC COMMUNICATION SCIENCES'),(138059710464,'ControlT','CONTROL TECHNOLOGY, INC.'),(138076487680,'Amkly','AMKLY SYSTEMS, INC.'),(138093264896,'MingFort','MING FORTUNE INDUSTRY CO., LTD'),(138110042112,'WestEgg','WEST EGG SYSTEMS, INC.'),(138126819328,'Teleproc','TELEPROCESSING PRODUCTS, INC.'),(138143596544,'NVDzine','N.V. DZINE'),(138160373760,'Advanced','ADVANCED TELECOMMUNICATIONS MODU'),(138177150976,'Welltron','WELLTRONIX CO., LTD.'),(138193928192,'Taiyo','TAIYO CORPORATION'),(138210705408,'DaystarD','DAYSTAR DIGITAL'),(138227482624,'ZetaComm','ZETA COMMUNICATIONS, LTD.'),(138244259840,'AnalogDi','ANALOG & DIGITAL SYSTEMS'),(138261037056,'TattileS','Tattile SRL'),(138277814272,'AlcatelT','ALCATEL TAISEL'),(138294591488,'SynapseT','SYNAPSE TECHNOLOGIES, INC.'),(138311368704,'RotecInd','ROTEC INDUSTRIEAUTOMATION GMBH'),(138328145920,'Ibm','IBM Corp'),(138344923136,'BmcSoftw','BMC SOFTWARE'),(138361700352,'SeagateT','SEAGATE TECHNOLOGY'),(138378477568,'VmeMicro','VME MICROSYSTEMS INTERNATIONAL C'),(138395254784,'Scinets',''),(138412032000,'DigitalB','DIGITAL BI0METRICS INC.'),(138428809216,'Wisdm','WISDM LTD.'),(138445586432,'Eurotime','EUROTIME AB'),(138462363648,'Honeywel','Honeywell ECC'),(138479140864,'LogicanT','LogiCan Technologies, Inc.'),(138495918080,'Juki','JUKI CORPORATION'),(138512695296,'Motorola','Motorola Broadband Communication'),(138529472512,'DataNet','DATA NET'),(138546249728,'Datametr','DATAMETRICS CORP.'),(138563026944,'Neuron','NEURON COMPANY LIMITED'),(138579804160,'Genitech','GENITECH PTY LTD'),(138596581376,'IonNetwo','ION Networks, Inc.'),(138613358592,'Ciprico','CIPRICO, INC.'),(138630135808,'Steinbre','STEINBRECHER CORP.'),(138646913024,'MarconiC','Marconi Communications'),(138663690240,'Comtron','COMTRON, INC.'),(138680467456,'Pronet','PRONET GMBH'),(138697244672,'Autocomp','AUTOCOMPUTER CO., LTD.'),(138714021888,'MitronCo','MITRON COMPUTER PTE LTD.'),(138730799104,'Inovis','INOVIS GMBH'),(138747576320,'NetworkS','NETWORK SECURITY SYSTEMS, INC.'),(138764353536,'Deutsche','DEUTSCHE AEROSPACE AG'),(138781130752,'KoreaCom','KOREA COMPUTER INC.'),(138797907968,'Verilink','Verilink Corporation'),(138814685184,'Ragula','RAGULA SYSTEMS'),(138831462400,'Huntsvil','HUNTSVILLE MICROSYSTEMS, INC.'),(138848239616,'Sycamore','Sycamore Networks'),(138865016832,'Altech','ALTECH CO., LTD.'),(138881794048,'Neoprodu','NEOPRODUCTS'),(138898571264,'TitzeDat','TITZE DATENTECHNIK GmbH'),(138915348480,'AlliedSi','ALLIED SIGNAL INC.'),(138932125696,'MiroComp','MIRO COMPUTER PRODUCTS AG'),(138948902912,'Computer','COMPUTER IDENTICS'),(138965680128,'KentroxL','Kentrox, LLC'),(138982457344,'Internet','InterNet Systems of Florida, Inc'),(138999234560,'Nanomati','NANOMATIC OY'),(139016011776,'CastleRo','CASTLE ROCK, INC.'),(139032788992,'Gammadat','GAMMADATA COMPUTER GMBH'),(139049566208,'AlcatelI','ALCATEL ITALIA S.p.A.'),(139066343424,'Garrettc','GarrettCom, Inc.'),(139083120640,'Scorpion','SCORPION LOGIC, LTD.'),(139099897856,'WiproInf','WIPRO INFOTECH LTD.'),(139116675072,'ProtecMi','PROTEC MICROSYSTEMS, INC.'),(139133452288,'Supernet','SUPERNET NETWORKING INC.'),(139150229504,'GeneralM','GENERAL MAGIC, INC.'),(139167006720,'Private',''),(139183783936,'Isdyne',''),(139200561152,'Isdn','ISDN SYSTEMS CORPORATION'),(139217338368,'OsakaCom','OSAKA COMPUTER CORP.'),(139234115584,'KonicaMi','KONICA MINOLTA HOLDINGS, INC.'),(139250892800,'Evergree','EVERGREEN TECHNOLOGY CORP.'),(139267670016,'DataRace','DATA RACE, INC.'),(139284447232,'Xact','XACT, INC.'),(139301224448,'Flowpoin','FLOWPOINT CORPORATION'),(139318001664,'Hynet','HYNET, LTD.'),(139334778880,'Ibr','IBR GMBH'),(139351556096,'Worklink','WORKLINK INNOVATIONS'),(139368333312,'Fusion','FUSION SYSTEMS CORPORATION'),(139385110528,'Sungwoon','SUNGWOON SYSTEMS'),(139401887744,'Motorola','MOTOROLA COMMUNICATION ISRAEL'),(139418664960,'Reudo','REUDO CORPORATION'),(139435442176,'Kardios','KARDIOS SYSTEMS CORP.'),(139452219392,'Runtop','RUNTOP, INC.'),(139468996608,'Mikron','MIKRON GMBH'),(139485773824,'WiseComm','WiSE Communications, Inc.'),(139502551040,'Intel','Intel Corporation'),(139519328256,'Autec','AUTEC GmbH'),(139536105472,'Advanced','ADVANCED COMPUTER APPLICATIONS'),(139552882688,'Finecom','FINECOM Co., Ltd.'),(139569659904,'KyoeiSan','KYOEI SANGYO CO., LTD.'),(139586437120,'SynergyU','SYNERGY (UK) LTD.'),(139603214336,'TitanEle','TITAN ELECTRONICS'),(139619991552,'Oneac','ONEAC CORPORATION'),(139636768768,'Prestico','PRESTICOM INCORPORATED'),(139653545984,'OcePrint','OCE PRINTING SYSTEMS, GMBH'),(139670323200,'3Com',''),(139687100416,'Microtec','MICROTECH ELECTRONICS LIMITED'),(139703877632,'Memotec','MEMOTEC, INC.'),(139720654848,'GlobalVi','GLOBAL VILLAGE COMMUNICATION'),(139737432064,'T3plusNe','T3PLUS NETWORKING, INC.'),(139754209280,'SonixCom','SONIX COMMUNICATIONS, LTD.'),(139770986496,'LapisTec','LAPIS TECHNOLOGIES, INC.'),(139787763712,'GalaxyNe','GALAXY NETWORKS, INC.'),(139804540928,'CmdTechn','CMD TECHNOLOGY'),(139821318144,'ChevinSo','CHEVIN SOFTWARE ENG. LTD.'),(139838095360,'EciTelec','ECI TELECOM LTD.'),(139854872576,'Advanced','ADVANCED COMPRESSION TECHNOLOGY,'),(139871649792,'J125Nati','J125, NATIONAL SECURITY AGENCY'),(139888427008,'ChessEng','CHESS ENGINEERING B.V.'),(139905204224,'Landings','LANDINGS TECHNOLOGY CORP.'),(139921981440,'Cubix','CUBIX CORPORATION'),(139938758656,'RivaElec','RIVA ELECTRONICS'),(139955535872,'Invensys',''),(139972313088,'AppliedS','APPLIED SIGNAL TECHNOLOGY'),(139989090304,'Hectroni','HECTRONIC AB'),(140005867520,'BonElect','BON ELECTRIC CO., LTD.'),(140022644736,'3do','THE 3DO COMPANY'),(140039421952,'ErsatEle','ERSAT ELECTRONIC GMBH'),(140056199168,'PrimaryA','PRIMARY ACCESS CORP.'),(140072976384,'LippertA','LIPPERT AUTOMATIONSTECHNIK'),(140089753600,'BrownSOp','BROWN`S OPERATING SYSTEM SERVICE'),(140106530816,'MercuryC','MERCURY COMPUTER SYSTEMS, INC.'),(140123308032,'OaLabora','OA LABORATORY CO., LTD.'),(140140085248,'Dovatron',''),(140156862464,'GalcomNe','GALCOM NETWORKING LTD.'),(140173639680,'Harmonic','Harmonic, Inc'),(140190416896,'Multipoi','MULTIPOINT NETWORKS'),(140207194112,'ApiEngin','API ENGINEERING'),(140223971328,'ProximWi','Proxim Wireless'),(140240748544,'Pairgain','PAIRGAIN TECHNOLOGIES, INC.'),(140257525760,'SastTech','SAST TECHNOLOGY CORP.'),(140274302976,'WhiteHor','WHITE HORSE INDUSTRIAL'),(140291080192,'Ericsson','Ericsson Television Limited'),(140307857408,'MicroInd','MICRO INDUSTRIES CORP.'),(140324634624,'Interfle','INTERFLEX DATENSYSTEME GMBH'),(140341411840,'Linq','LINQ SYSTEMS'),(140358189056,'OrnetDat','ORNET DATA COMMUNICATION TECH.'),(140374966272,'3com','3COM CORPORATION'),(140391743488,'GatewayD','GATEWAY DEVICES, INC.'),(140408520704,'ComtechR','COMTECH RESEARCH INC.'),(140425297920,'GkdGesel','GKD Gesellschaft Fur Kommunikati'),(140442075136,'TattileS','Tattile SRL'),(140458852352,'TermaEle','TERMA ELEKTRONIK AS'),(140475629568,'YaskawaE','YASKAWA ELECTRIC CORPORATION'),(140492406784,'AgileNet','AGILE NETWORKS, INC.'),(140509184000,'NamaquaC','NAMAQUA COMPUTERWARE'),(140525961216,'PrimeOpt','PRIME OPTION, INC.'),(140542738432,'Metricom','METRICOM, INC.'),(140559515648,'CenterFo','CENTER FOR HIGH PERFORMANCE'),(140576292864,'Zax','ZAX CORPORATION'),(140593070080,'LongReac','Long Reach Networks Pty Ltd'),(140609847296,'Niobrara','NIOBRARA R & D CORPORATION'),(140626624512,'LanAcces','LAN ACCESS CORP.'),(140643401728,'AehrTest','AEHR TEST SYSTEMS'),(140660178944,'PulseEle','PULSE ELECTRONICS, INC.'),(140676956160,'Saxa','SAXA, Inc.'),(140693733376,'TexasMem','TEXAS MEMORY SYSTEMS, INC.'),(140710510592,'CounterS','COUNTER SOLUTIONS LTD.'),(140727287808,'Inet','INET,INC.'),(140744065024,'EagleTec','EAGLE TECHNOLOGY'),(140760842240,'Nectec',''),(140777619456,'AkaiProf','AKAI Professional M.I. Corp.'),(140794396672,'Larscom','LARSCOM INCORPORATED'),(140811173888,'VictronB','VICTRON BV'),(140827951104,'DigitalO','DIGITAL OCEAN'),(140844728320,'PretecEl','PRETEC ELECTRONICS CORP.'),(140861505536,'DigitalS','DIGITAL SERVICES, LTD.'),(140878282752,'HybridNe','HYBRID NETWORKS, INC.'),(140895059968,'LogicalD','LOGICAL DESIGN GROUP, INC.'),(140911837184,'TestMeas','TEST & MEASUREMENT SYSTEMS INC'),(140928614400,'Versalyn','VERSALYNX CORPORATION'),(140945391616,'Microcom','MICROCOMPUTER SYSTEMS (M) SDN.'),(140962168832,'RadDataC','RAD DATA COMMUNICATIONS, LTD.'),(140978946048,'OstOuest','OST (OUEST STANDARD TELEMATIQU'),(140995723264,'Cabletro','CABLETRON - ZEITTNET INC.'),(141012500480,'Vipa','VIPA GMBH'),(141029277696,'Breezeco','BREEZECOM'),(141046054912,'JapanMin','JAPAN MINICOMPUTER SYSTEMS CO., '),(141062832128,'NortelNe','Nortel Networks'),(141079609344,'Panasoni','PANASONIC TECHNOLOGIES, INC./MIE'),(141096386560,'AlcatelN','Alcatel North America ESD'),(141113163776,'XnetTech','XNET TECHNOLOGY, INC.'),(141129940992,'Densitro','DENSITRON TAIWAN LTD.'),(141146718208,'Cybertec','Cybertec Pty Ltd'),(141163495424,'JapanDig','JAPAN DIGITAL LABORAT`Y CO.LTD'),(141180272640,'KyosanEl','KYOSAN ELECTRIC MFG. CO., LTD.'),(141197049856,'Actionte','Actiontec Electronics, Inc.'),(141213827072,'AlamarEl','ALAMAR ELECTRONICS'),(141230604288,'Informat','INFORMATION RESOURCE ENGINEERING'),(141247381504,'McdKenco','MCD KENCOM CORPORATION'),(141264158720,'HsingTec','HSING TECH ENTERPRISE CO., LTD'),(141280935936,'ApexData','APEX DATA, INC.'),(141297713152,'Lidkopin','LIDKOPING MACHINE TOOLS AB'),(141314490368,'B&WNucle','B&W NUCLEAR SERVICE COMPANY'),(141331267584,'Datatrek','DATATREK CORPORATION'),(141348044800,'Dantel',''),(141364822016,'Efficien','EFFICIENT NETWORKS, INC.'),(141381599232,'Cincinna','CINCINNATI MICROWAVE, INC.'),(141398376448,'Techware','TECHWARE SYSTEMS CORP.'),(141415153664,'Giga-Byt','GIGA-BYTE TECHNOLOGY CO., LTD.'),(141431930880,'Gtech','GTECH CORPORATION'),(141448708096,'Usc','USC CORPORATION'),(141465485312,'Universa','UNIVERSAL MICROELECTRONICS CO.'),(141482262528,'AltosInd','ALTOS INDIA LIMITED'),(141499039744,'Oracle','Oracle Corporation'),(141515816960,'Raynet','RAYNET CORPORATION'),(141532594176,'Spectrix','SPECTRIX CORPORATION'),(141549371392,'Pandatel','PANDATEL AG'),(141566148608,'NetTekAn','NET TEK  AND KARLNET, INC.'),(141582925824,'Cyberdat','CYBERDATA CORPORATION'),(141599703040,'CarreraC','CARRERA COMPUTERS, INC.'),(141616480256,'Paralink','PARALINK NETWORKS, INC.'),(141633257472,'Gde','GDE SYSTEMS, INC.'),(141650034688,'OctelCom','OCTEL COMMUNICATIONS CORP.'),(141666811904,'Matrox',''),(141683589120,'ItvTechn','ITV TECHNOLOGIES, INC.'),(141700366336,'Topware/','TOPWARE INC. / GRAND COMPUTER'),(141717143552,'Symmetri','SYMMETRICAL TECHNOLOGIES'),(141733920768,'GemtekTe','GemTek Technology Co., Ltd.'),(141750697984,'Aplicaci','Aplicaciones Electronicas Quasar'),(141767475200,'Updatelo','UpdateLogic Inc.'),(141784252416,'GhiElect','GHI Electronics, LLC'),(141801029632,'GigasetC','Gigaset Communications GmbH'),(141817806848,'Alcatel-','Alcatel-Lucent'),(141834584064,'RimTesti','RIM Testing Services'),(141851361280,'Seowonin','Seowonintech Co Ltd.'),(141868138496,'NokiaDan','Nokia Danmark A/S'),(141884915712,'NokiaDan','Nokia Danmark A/S'),(141901692928,'Byd:Sign','byd:sign Corporation'),(141918470144,'GeminiTr','GEMINI TRAZE RFID PVT. LTD.'),(141935247360,'Cymtec','Cymtec Systems, Inc.'),(141952024576,'SamsinIn','SAMSIN INNOTEC'),(141968801792,'OrpakLTD','Orpak Systems L.T.D.'),(141985579008,'Cernium','Cernium Corp'),(142002356224,'Clearbox','Clearbox Systems'),(142019133440,'Uniphone','Uniphone Inc.'),(142035910656,'WiscomSy','WISCOM SYSTEM CO.,LTD'),(142052687872,'Padtec','Padtec S/A'),(142069465088,'HylabTec','Hylab Technology Inc.'),(142086242304,'PhyweSys','PHYWE Systeme GmbH & Co. KG'),(142103019520,'Transcon','Transcon Electronic Systems, spo'),(142119796736,'Tellord',''),(142136573952,'AthenaTe','Athena Tech, Inc.'),(142153351168,'SamsungE','Samsung Electro-Mechanics'),(142170128384,'Lintech','LInTech Corporation'),(142186905600,'Cisco','CISCO SYSTEMS, INC.'),(142203682816,'Cisco','CISCO SYSTEMS, INC.'),(142220460032,'Dataline','Dataline AB'),(142237237248,'Motorola','Motorola Mobility, Inc.'),(142254014464,'Shinsung','SHINSUNG DELTATECH CO.,LTD.'),(142270791680,'SequelTe','Sequel Technologies'),(142287568896,'Vrmagic','VRmagic GmbH'),(142304346112,'Chip-Pro','Chip-pro Ltd.'),(142321123328,'AerosatA','Aerosat Avionics'),(142337900544,'Optos','Optos Plc'),(142354677760,'KukJeTon','KUK JE TONG SHIN Co.,LTD'),(142371454976,'Shenzhen','Shenzhen Torch Equipment Co., Lt'),(142388232192,'Tp-LinkT','TP-LINK Technology Co., Ltd.'),(142405009408,'Oracle','Oracle Corporation'),(142421786624,'Cisco-Li','Cisco-Linksys, LLC'),(142438563840,'Audiovox','Audiovox Corporation'),(142455341056,'MsaAuer','MSA Auer'),(142472118272,'Semindia','SemIndia System Private Limited'),(142488895488,'Scimolex','SCIMOLEX CORPORATION'),(142505672704,'Dresden-','dresden-elektronik'),(142522449920,'PhoebeMi','Phoebe Micro Inc.'),(142539227136,'KeicoHig','Keico Hightech Inc.'),(142556004352,'Blynke','Blynke Inc.'),(142572781568,'Mastercl','Masterclock, Inc.'),(142589558784,'Building','Building B, Inc'),(142606336000,'Brandywi','Brandywine Communications'),(142623113216,'Alcatel-','ALCATEL-LUCENT'),(142639890432,'Motorola','Motorola Mobility, Inc.'),(142656667648,'BayContr','Bay Controls, LLC'),(142673444864,'Cepheid',''),(142690222080,'Escherlo','Escherlogic Inc.'),(142706999296,'Winchest','Winchester Systems Inc.'),(142723776512,'Berkshir','Berkshire Products, Inc'),(142740553728,'Aliphcom',''),(142757330944,'Cermetek','Cermetek Microelectronics, Inc.'),(142774108160,'Tomtom',''),(142790885376,'A-TeamTe','A-Team Technology Ltd.'),(142807662592,'EnTechno','EN Technologies Inc.'),(142824439808,'Radlive',''),(142841217024,'Advanced','Advanced Control Systems doo'),(142857994240,'Motorola','Motorola Mobility, Inc.'),(142874771456,'SsTeleco','SS Telecoms'),(142891548672,'Semptian','Semptian Technologies Ltd.'),(142908325888,'Sanmina-','Sanmina-SCI'),(142925103104,'Nintendo','Nintendo Co., Ltd.'),(142941880320,'KacoSola','Kaco Solar Korea'),(142958657536,'ChinaDah','China Daheng Group ,Inc.'),(142975434752,'PixelVel','Pixel Velocity, Inc'),(142992211968,'Shenzhen','Shenzhen HAMP Science & Technolo'),(143008989184,'SamsungE','SAMSUNG ELECTRONICS CO., LTD.'),(143025766400,'Guangzho','Guangzhou Skytone Transmission T'),(143042543616,'GsYuasaP','GS Yuasa Power Supply Ltd.'),(143059320832,'AlpsElec','ALPS Electric Co., Ltd'),(143076098048,'EyeviewE','EYEVIEW ELECTRONICS'),(143092875264,'Millinet','Millinet Co., Ltd.'),(143109652480,'GeneralS','General Satellite Research & Dev'),(143126429696,'Seamicro','SeaMicro Inc.'),(143143206912,'D-TacqSo','D-TACQ Solutions Ltd'),(143159984128,'Cisco','CISCO SYSTEMS, INC.'),(143176761344,'Cisco','CISCO SYSTEMS, INC.'),(143193538560,'National','National Datacast, Inc.'),(143210315776,'StyleFly','Style Flying Technology Co.'),(143227092992,'JuniperN','Juniper Networks'),(143243870208,'Hewlett-','Hewlett-Packard Company'),(143260647424,'Inotive',''),(143277424640,'IntelCor','Intel Corporate'),(143294201856,'IntelCor','Intel Corporate'),(143310979072,'Ibm','IBM Corp'),(143327756288,'Ihse','IHSE GmbH'),(143344533504,'HideaSol','Hidea Solutions Co. Ltd.'),(143361310720,'Yournet','Yournet Inc.'),(143378087936,'Nortel',''),(143394865152,'AskeyCom','ASKEY COMPUTER CORP'),(143411642368,'SpecialD','Special Design Bureau for Seismi'),(143428419584,'Presstek','Presstek Inc.'),(143445196800,'Novatel','NovAtel Inc.'),(143461974016,'HwaJinT&','HWA JIN T&I Corp.'),(143478751232,'IveiaLlc','iVeia, LLC'),(143495528448,'Prologix','Prologix, LLC.'),(143512305664,'IntelCor','Intel Corporate'),(143529082880,'IntelCor','Intel Corporate'),(143545860096,'Odva',''),(143562637312,'Soltech','Soltech Co., Ltd.'),(143579414528,'Function','Function ATI (Huizhou) Telecommu'),(143596191744,'Symcom','SymCom, Inc.'),(143612968960,'Dell','Dell Inc'),(143629746176,'WesungTn','Wesung TNC Co., Ltd.'),(143646523392,'Seoultek','Seoultek Valley'),(143663300608,'IonTorre','Ion Torrent Systems, Inc.'),(143680077824,'AvalanWi','AvaLAN Wireless'),(143696855040,'PacificS','Pacific Satellite International '),(143713632256,'YmaxTele','YMax Telecom Ltd.'),(143730409472,'WLGoreAs','W. L. Gore & Associates'),(143747186688,'Matusche','Matuschek Messtechnik GmbH'),(143763963904,'Iogear','IOGEAR, Inc.'),(143780741120,'SejinEle','Sejin Electron, Inc.'),(143797518336,'Bastec','Bastec AB'),(143814295552,'2wire',''),(143831072768,'PyxisSRL','PYXIS S.R.L.'),(143847849984,'TelitCom','Telit Communication s.p.a'),(143864627200,'IntracoT','Intraco Technology Pte Ltd'),(143881404416,'Motorola','Motorola Mobility, Inc.'),(143898181632,'Si2Micro','Si2 Microsystems Limited'),(143914958848,'Sandlink','SandLinks Systems, Ltd.'),(143931736064,'VatechHy','VATECH HYDRO'),(143948513280,'Powersof','POWERSOFT SRL'),(143965290496,'Micro-St','MICRO-STAR INT`L CO.,LTD.'),(143982067712,'Universa','Universal Global Scientific Indu'),(143998844928,'Imacs','Imacs GmbH'),(144015622144,'Emc','EMC Corporation'),(144032399360,'Apptech','AppTech, Inc.'),(144049176576,'Electron','Electronic Design and Manufactur'),(144065953792,'WesconTe','Wescon Technology, Inc.'),(144082731008,'Topcontr','TopControl GMBH'),(144099508224,'ApRouter','AP Router Ind. Eletronica LTDA'),(144116285440,'Mekics','MEKICS CO., LTD.'),(144133062656,'Avantgar','Avantgarde Acoustic Lautsprecher'),(144149839872,'GoliathS','Goliath Solutions'),(144166617088,'D-Link','D-Link Corporation'),(144183394304,'BaodingG','Baoding Galaxy Electronic Techno'),(144200171520,'Videofon','Videofon MV'),(144216948736,'PingComm','Ping Communication'),(144233725952,'GwdMedia','GWD Media Limited'),(144250503168,'TelseySP','Telsey  S.p.A.'),(144267280384,'Elitegro','ELITEGROUP COMPUTER SYSTEM'),(144284057600,'ThaiRadi','Thai Radio Co, LTD'),(144300834816,'Vacon','Vacon Plc'),(144317612032,'Cambridg','Cambridge Visual Networks Ltd'),(144334389248,'Dell','Dell Inc'),(144351166464,'Honeywld','Honeywld Technology Corp.'),(144367943680,'AdesysBv','Adesys BV'),(144384720896,'SonyEric','Sony Ericsson Mobile Communicati'),(144401498112,'SatelOy','SATEL OY'),(144418275328,'Cisco','CISCO SYSTEMS, INC.'),(144435052544,'Cisco','CISCO SYSTEMS, INC.'),(144451829760,'Eke-Elec','EKE-Electronics Ltd.'),(144468606976,'Micromin','Micromint'),(144485384192,'DbiiNetw','Dbii Networks'),(144502161408,'Erlphase','ERLPhase Power Technologies Ltd.'),(144518938624,'Videotec','Videotec Spa'),(144535715840,'HantleSy','Hantle System Co., Ltd.'),(144552493056,'Telephon','Telephonics Corporation'),(144569270272,'Mobilink','Mobilink Telecom Co.,Ltd'),(144586047488,'NokiaDan','Nokia Danmark A/S'),(144602824704,'NokiaDan','Nokia Danmark A/S'),(144619601920,'Infrared','Infrared Integrated Systems Ltd'),(144636379136,'NordicId','Nordic ID Oy'),(144653156352,'Alcatel-','ALCATEL-LUCENT FRANCE - WTD'),(144669933568,'RadioFre','Radio Frequency Systems'),(144686710784,'TycoTele','Tyco Telecommunications'),(144703488000,'DigitalS','DIGITAL SOLUTIONS LTD'),(144720265216,'Fiberbla','Fiberblaze A/S'),(144737042432,'RossCont','Ross Controls'),(144753819648,'AproMedi','APRO MEDIA CO., LTD'),(144770596864,'Galvanic','Galvanic Ltd'),(144787374080,'TriactaP','Triacta Power Technologies Inc.'),(144804151296,'LexmarkI','Lexmark International Inc.'),(144820928512,'Inphi','Inphi Corporation'),(144837705728,'Universa','Universal Devices Inc.'),(144854482944,'TexasIns','Texas Instruments'),(144871260160,'RikenKei','Riken Keiki Co., Ltd.'),(144888037376,'ZalaComp','ZALA COMPUTER'),(144904814592,'Nintendo','Nintendo Co., Ltd.'),(144921591808,'CiscoSer','Cisco, Service Provider Video Te'),(144938369024,'HitachiH','Hitachi High-Tech Control System'),(144955146240,'MobileAp','Mobile Appliance, Inc.'),(144971923456,'AbbOy/Me','ABB Oy / Medium Voltage Products'),(144988700672,'GlCommun','GL Communications Inc'),(145005477888,'CornellC','CORNELL Communications, Inc.'),(145022255104,'Consiliu','Consilium AB'),(145039032320,'3dsp','3DSP Corp'),(145055809536,'CsjGloba','CSJ Global, Inc.'),(145072586752,'Russound',''),(145089363968,'LohuisNe','LOHUIS Networks'),(145106141184,'WavecomA','Wavecom Asia Pacific Limited'),(145122918400,'ArtSyste','ART System Co., Ltd.'),(145139695616,'SmsTecno','SMS TECNOLOGIA ELETRONICA LTDA'),(145156472832,'Flextron','Flextronics International'),(145173250048,'Livetv',''),(145190027264,'Ntc-Metr','NTC-Metrotek'),(145206804480,'CryptoGr','The Crypto Group'),(145223581696,'GlobalDi','Global Display Solutions Spa'),(145240358912,'SamsungE','Samsung Electronics Co.,Ltd'),(145257136128,'SamsungE','Samsung Electronics Co.,Ltd'),(145273913344,'BocomSec','BOCOM SECURITY(ASIA PACIFIC) LIM'),(145290690560,'VollmerW','Vollmer Werke GmbH'),(145307467776,'X2e','X2E GmbH'),(145324244992,'LxiConso','LXI Consortium'),(145341022208,'Cisco','CISCO SYSTEMS, INC.'),(145357799424,'Cisco','CISCO SYSTEMS, INC.'),(145374576640,'Sekonic','SEKONIC CORPORATION'),(145391353856,'Automati','Automation Products Group Inc.'),(145408131072,'Santachi','Santachi Video Technology (Shenz'),(145424908288,'Tecnoala','TECNOALARM S.r.l.'),(145441685504,'Northsta','Northstar Systems Corp'),(145458462720,'FireproW','Firepro Wireless'),(145475239936,'MartinCh','Martin Christ GmbH'),(145492017152,'Commagil','CommAgility Ltd'),(145508794368,'NortelNe','Nortel Networks'),(145525571584,'Creative','Creative Electronic GmbH'),(145542348800,'Serialte','SerialTek LLC'),(145559126016,'I-Win',''),(145575903232,'DisplayS','Display Solution AG'),(145592680448,'Starligh','Starlight Video Limited'),(145609457664,'Informat','Informatics Services Corporation'),(145626234880,'MurataMa','Murata Manufacturing Co., Ltd.'),(145643012096,'Apple','Apple, Inc'),(145659789312,'Bystroni','Bystronic Laser AG'),(145676566528,'EspLlc','ESP SYSTEMS, LLC'),(145693343744,'Solutron','Solutronic GmbH'),(145710120960,'Telegesi','Telegesis'),(145726898176,'FullSpec','Full Spectrum Inc.'),(145743675392,'Kapsys',''),(145760452608,'Ew3Techn','EW3 Technologies LLC'),(145777229824,'TutusDat','Tutus Data AB'),(145794007040,'Easy3cal','EASY3CALL Technology Limited'),(145810784256,'Si14','Si14 SpA'),(145827561472,'Inrange','INRange Systems, Inc'),(145844338688,'WesternE','Western Engravers Supply, Inc.'),(145861115904,'Oracle','Oracle Corporation'),(145877893120,'HpnSuppl','HPN Supply Chain'),(145894670336,'Enseo','Enseo, Inc.'),(145911447552,'WirecomT','WIRECOM Technologies'),(145928224768,'A4spTech','A4SP Technologies Ltd.'),(145945001984,'LgElectr','LG Electronics'),(145961779200,'NokiaDan','Nokia Danmark A/S'),(145978556416,'DstaSL','DSTA S.L.'),(145995333632,'NokiaDan','Nokia Danmark A/S'),(146012110848,'CyfrowyP','Cyfrowy Polsat SA'),(146028888064,'Ibm','IBM Corp'),(146045665280,'AksysNet','Aksys Networks Inc'),(146062442496,'ExcitoEl','Excito Elektronik i SkÃ¥ne AB'),(146079219712,'Glensoun','Glensound Electronics Ltd'),(146095996928,'Koratek',''),(146112774144,'WelinkSo','WeLink Solutions, Inc.'),(146129551360,'Cyberdyn','Cyberdyne Inc.'),(146146328576,'IntenoBr','Inteno Broadband Technology AB'),(146163105792,'Certicom','Certicom Corp'),(146179883008,'OmronHea','Omron Healthcare Co., Ltd'),(146196660224,'Onlive','OnLive, Inc'),(146213437440,'National','National Source Coding Center'),(146230214656,'Cisco','CISCO SYSTEMS, INC.'),(146246991872,'Cisco','CISCO SYSTEMS, INC.'),(146263769088,'IndigoSe','Indigo Security Co., Ltd.'),(146280546304,'MocaMult','MoCA (Multimedia over Coax Allia'),(146297323520,'Motorola','Motorola Mobility, Inc.'),(146314100736,'Rohati','Rohati Systems'),(146330877952,'CaiNetwo','CAI Networks, Inc.'),(146347655168,'Pci','PCI CORPORATION'),(146364432384,'RinnaiKo','RINNAI KOREA'),(146381209600,'AsustekC','ASUSTek COMPUTER INC.'),(146397986816,'Shibaura','SHIBAURA VENDING MACHINE CORPORA'),(146414764032,'NeatElec','Neat Electronics'),(146431541248,'Verivue','Verivue Inc.'),(146448318464,'Dell','Dell Inc'),(146465095680,'AudioPre','Audio Precision'),(146481872896,'Morega','Morega Systems'),(146498650112,'Private',''),(146515427328,'Freegene','Freegene Technology LTD'),(146532204544,'MediaDev','Media Devices Co., Ltd.'),(146548981760,'EsangTec','eSang Technologies Co., Ltd.'),(146565758976,'MitacTec','Mitac Technology Corp'),(146582536192,'ItohDenk','ITOH DENKI CO,LTD.'),(146599313408,'Schaffne','Schaffner Deutschland GmbH'),(146616090624,'Timekeep','TimeKeeping Systems, Inc.'),(146632867840,'GoodWill','Good Will Instrument Co., Ltd.'),(146649645056,'ThalesAv','Thales Avionics Ltd'),(146666422272,'Avaak','Avaak, Inc.'),(146683199488,'Uv-Elect','uv-electronic GmbH'),(146699976704,'BreezeIn','Breeze Innovations Ltd.'),(146716753920,'Compumed','Compumedics Ltd'),(146733531136,'Soundear','SoundEar A/S'),(146750308352,'Nucomm','Nucomm, Inc.'),(146767085568,'Ceton','Ceton Corp'),(146783862784,'SmcNetwo','SMC Networks Inc.'),(146800640000,'Maintech','maintech GmbH'),(146817417216,'OpenGrid','Open Grid Computing, Inc.'),(146834194432,'Futurelo','FutureLogic Inc.'),(146850971648,'Smt&C','SMT&C Co., Ltd.'),(146867748864,'DesignDe','Design Design Technology Ltd'),(146884526080,'AdbBroad','ADB Broadband Italia'),(146901303296,'Corventi','Corventis Inc.'),(146918080512,'Strukton','Strukton Systems bv'),(146934857728,'VectorSp','VECTOR SP. Z O.O.'),(146951634944,'Shinhint','Shinhint Group'),(146968412160,'Logiplus',''),(146985189376,'IndianaL','Indiana Life Sciences Incorporat'),(147001966592,'Scientif','Scientific Atlanta, Cisco SPVT G'),(147018743808,'Communic','Communication Networks, LLC'),(147035521024,'RatioEnt','RATIO Entwicklungen GmbH'),(147052298240,'JumpgenL','JumpGen Systems, LLC'),(147069075456,'Irtrans','IRTrans GmbH'),(147085852672,'Netgear','Netgear Inc.'),(147102629888,'Universa','Universal Telecom S/A'),(147119407104,'Apple','Apple, Inc'),(147136184320,'Alacron','Alacron Inc.'),(147152961536,'Azurewav','AzureWave Technologies, Inc.'),(147169738752,'ChengduL','Chengdu Linkon Communications De'),(147186515968,'LeineLin','Leine & Linde AB'),(147203293184,'EvocInte','Evoc Intelligent Technology Co.,'),(147220070400,'DacEngin','DAC ENGINEERING CO., LTD.'),(147236847616,'Microsof','Microsoft Corporation'),(147253624832,'HomeMult','HOME MULTIENERGY SL'),(147270402048,'Raylase','RAYLASE AG'),(147287179264,'AirtechT','AIRTECH TECHNOLOGIES, INC.'),(147303956480,'Nintendo','Nintendo Co., Ltd.'),(147320733696,'MitacInt','MITAC INTERNATIONAL CORP.'),(147337510912,'Seenergy','SEEnergy Corp.'),(147354288128,'ByzoroNe','Byzoro Networks Ltd.'),(147371065344,'PointSix','Point Six Wireless, LLC'),(147387842560,'Lumasens','Lumasense Technologies'),(147404619776,'ZollLife','ZOLL Lifecor Corporation'),(147421396992,'Entorian','Entorian Technologies'),(147438174208,'BigelowA','Bigelow Aerospace'),(147454951424,'Cisco','CISCO SYSTEMS, INC.'),(147471728640,'Cisco','CISCO SYSTEMS, INC.'),(147488505856,'3comEuro','3Com Europe Ltd'),(147505283072,'TaiyoYud','Taiyo Yuden Co., Ltd.'),(147522060288,'Guangzho','Guangzhou New Postcom Equipment '),(147538837504,'GardeSec','Garde Security AB'),(147555614720,'Teradici','Teradici Corporation'),(147572391936,'Multimed','Multimedia & Communication Techn'),(147589169152,'Digicabl','Digicable Network India Pvt. Ltd'),(147605946368,'UwinTech','Uwin Technologies Co.,LTD'),(147622723584,'LiteonTe','Liteon Technology Corporation'),(147639500800,'Afreey','AFREEY Inc.'),(147656278016,'Frontier','Frontier Silicon Ltd'),(147673055232,'BepMarin','BEP Marine'),(147689832448,'KoosTech','Koos Technical Services, Inc.'),(147706609664,'Hewlett-','Hewlett-Packard Company'),(147723386880,'NokiaDan','Nokia Danmark A/S'),(147740164096,'NokiaDan','Nokia Danmark A/S'),(147756941312,'NortelNe','Nortel Networks'),(147773718528,'HonHaiPr','Hon Hai Precision Ind. Co., Ltd.'),(147790495744,'HonHaiPr','Hon Hai Precision Ind. Co., Ltd.'),(147807272960,'Honeywel','Honeywell'),(147824050176,'Cisco-Li','Cisco-Linksys, LLC'),(147840827392,'Linkspri','LinkSprite Technologies, Inc.'),(147857604608,'Shenzhen','Shenzhen GIEC Electronics Co., L'),(147874381824,'GowellEl','Gowell Electronic Limited'),(147891159040,'3onedata','3onedata Technology Co. Ltd.'),(147907936256,'AbkNorth','ABK North America, LLC'),(147924713472,'JÃ¤gerCom','JÃ¤ger Computergesteuerte MeÃŸte'),(147941490688,'American','American Micro-Fuel Device Corp.'),(147958267904,'Techway',''),(147975045120,'Familyph','FamilyPhone AB'),(147991822336,'BelkinIn','Belkin International Inc.'),(148008599552,'TripleEy','Triple EYE B.V.'),(148025376768,'NecAustr','NEC Australia Pty Ltd'),(148042153984,'Shenzhen','Shenzhen  Tongfang Multimedia  T'),(148058931200,'NipponCo','Nippon Conlux Co., Ltd.'),(148075708416,'TelecomD','Telecom Design'),(148092485632,'ApogeeLa','Apogee Labs, Inc.'),(148109262848,'WooriSmt','Woori SMT Co.,ltd'),(148126040064,'YeData','YE DATA INC.'),(148142817280,'Chengdu3','Chengdu 30Kaitian Communication '),(148159594496,'RuckusWi','Ruckus Wireless'),(148176371712,'A2bElect','A2B Electronics AB'),(148193148928,'Daintree','Daintree Networks Pty'),(148209926144,'8086Cons','8086 Consultancy'),(148226703360,'JuniperN','Juniper Networks'),(148243480576,'DesayA&V','DESAY A&V SCIENCE AND TECHNOLOGY'),(148260257792,'NomusCom','NOMUS COMM SYSTEMS'),(148277035008,'Astron',''),(148293812224,'TitanWir','Titan Wireless LLC'),(148310589440,'Sagrad','Sagrad, Inc.'),(148327366656,'Optosecu','Optosecurity Inc.'),(148344143872,'Teratron','Teratronik elektronische systeme'),(148360921088,'Kensingt','Kensington Computer Products Gro'),(148377698304,'PhotonEu','Photon Europe GmbH'),(148394475520,'GbsLabor','GBS Laboratories LLC'),(148411252736,'Tv-Numer','TV-NUMERIC'),(148428029952,'Cnrs',''),(148444807168,'Cisco','CISCO SYSTEMS, INC.'),(148461584384,'Cisco','CISCO SYSTEMS, INC.'),(148478361600,'Cinetal',''),(148495138816,'Zte','ZTE Corporation'),(148511916032,'Kyocera','Kyocera Corporation'),(148528693248,'SgmTechn','SGM Technology for lighting spa'),(148545470464,'Linowave','LinoWave Corporation'),(148562247680,'XmosSemi','XMOS Semiconductor'),(148579024896,'SonyEric','Sony Ericsson Mobile Communicati'),(148595802112,'Seamicro','SeaMicro Inc.'),(148612579328,'Lastar','Lastar, Inc.'),(148629356544,'Averlogi','AverLogic Technologies, Inc.'),(148646133760,'VerismoN','Verismo Networks Inc'),(148662910976,'Pyung-Hw','PYUNG-HWA IND.CO.,LTD'),(148679688192,'SocialAi','Social Aid Research Co., Ltd.'),(148696465408,'SensysTr','Sensys Traffic AB'),(148713242624,'Delphi','Delphi Corporation'),(148730019840,'HuaweiSy','Huawei Symantec Technologies Co.'),(148746797056,'XtramusT','Xtramus Technologies'),(148763574272,'Californ','California Eastern Laboratories'),(148780351488,'2wire',''),(148797128704,'TexasIns','Texas Instruments'),(148813905920,'SonyComp','Sony Computer Entertainment Amer'),(148830683136,'TycoElec','Tyco Electronics AMP GmbH'),(148847460352,'OumanOy','Ouman Oy'),(148864237568,'LgElectr','LG Electronics Inc'),(148881014784,'Nintendo','Nintendo Co., Ltd.'),(148897792000,'Shenzhen','Shenzhen Turbosight Technology L'),(148914569216,'Hangzhou','Hangzhou Siyuan Tech. Co., Ltd'),(148931346432,'TelesisT','TELESIS TECHNOLOGIES, INC.'),(148948123648,'Mattel','Mattel Inc.'),(148964900864,'SafetyVi','Safety Vision'),(148981678080,'D-Link','D-Link Corporation'),(148998455296,'Elbit','Elbit Systems'),(149015232512,'4rfCommu','4RF Communications Ltd'),(149032009728,'SeiSPA','Sei S.p.A.'),(149048786944,'Motorola','Motorola Mobility, Inc.'),(149065564160,'Novita',''),(149082341376,'Superflo','Superflow Technologies Group'),(149099118592,'GssGrund','GSS Grundig SAT-Systems GmbH'),(149115895808,'Norcott',''),(149132673024,'Analogix','Analogix Seminconductor, Inc'),(149149450240,'HuthElek','HUTH Elektronik Systeme GmbH'),(149166227456,'Beyerdyn','beyerdynamic GmbH & Co. KG'),(149183004672,'JdsuFran','JDSU France SAS'),(149199781888,'Cisco','CISCO SYSTEMS, INC.'),(149216559104,'Cisco','CISCO SYSTEMS, INC.'),(149233336320,'SieampGr','SieAmp Group of Companies'),(149250113536,'Shenzhen','Shenzhen Forcelink Electronic Co'),(149266890752,'ActiveSt','Active Storage Inc.'),(149283667968,'ProviewE','Proview EletrÃ´nica do Brasil LT'),(149300445184,'ZeeportT','Zeeport Technology Inc.'),(149317222400,'Epro','epro GmbH'),(149333999616,'Inforson','INFORSON Co,Ltd.'),(149350776832,'Sutus','Sutus Inc'),(149367554048,'SeggerMi','SEGGER Microcontroller GmbH & Co'),(149384331264,'AppliedI','Applied Instruments B.V.'),(149401108480,'LenordBa','Lenord, Bauer & Co GmbH'),(149417885696,'AnvizBio','Anviz Biometric Tech. Co., Ltd.'),(149434662912,'Ionodes','IONODES Inc.'),(149451440128,'Scilog','SciLog, Inc.'),(149468217344,'AredTech','Ared Technology Co., Ltd.'),(149484994560,'CiscoSer','Cisco, Service Provider Video Te'),(149501771776,'PlanexCo','PLANEX Communications INC'),(149518548992,'PolarEle','Polar Electro Oy'),(149535326208,'Albrecht','Albrecht Jung GmbH & Co. KG'),(149552103424,'AllEarth','All Earth ComÃ©rcio de EletrÃ´ni'),(149568880640,'Hub-Tech',''),(149585657856,'Comworth','ComWorth Co., Ltd.'),(149602435072,'EatonEle','Eaton Corp. Electrical Group Dat'),(149619212288,'Cypak','Cypak AB'),(149635989504,'Nintendo','Nintendo Co., Ltd.'),(149652766720,'Shenzhen','Shenzhen GST Security and Safety'),(149669543936,'FortexIn','Fortex Industrial Ltd.'),(149686321152,'AnatekLl','ANATEK, LLC'),(149703098368,'Translog','Translogic Corporation'),(149719875584,'VigilHea','Vigil Health Solutions Inc.'),(149736652800,'Protecta','Protecta Electronics Ltd'),(149753430016,'OppoDigi','OPPO Digital, Inc.'),(149770207232,'TamuzMon','TAMUZ Monitors'),(149786984448,'Atlantic','Atlantic Software Technologies S'),(149803761664,'ZortLabs','ZORT Labs, LLC.'),(149820538880,'WabtecTr','WABTEC Transit Division'),(149837316096,'Amerigon',''),(149854093312,'ApassTec','APASS TECHNOLOGY CO., LTD.'),(149870870528,'Fisher-R','Fisher-Rosemount Systems Inc.'),(149887647744,'Intellig','Intelligent Data'),(149904424960,'WpsParki','WPS Parking Systems'),(149921202176,'Applitio','Applition Co., Ltd.'),(149937979392,'Provisio','ProVision Communications'),(149954756608,'Rustelco','Rustelcom Inc.'),(149971533824,'DataResp','Data Respons A/S'),(149988311040,'IdealbtT','IDEALBT TECHNOLOGY CORPORATION'),(150005088256,'TsiPower','TSI Power Corporation'),(150021865472,'AlgoComm','Algo Communication Products Ltd'),(150038642688,'IbisTekL','Ibis Tek, LLC'),(150055419904,'3GreensA','3 Greens Aviation Limited'),(150072197120,'Private',''),(150088974336,'Sunpower','SunPower Corp'),(150105751552,'Sharp','SHARP Corporation'),(150122528768,'AmpakTec','AMPAK Technology, Inc.'),(150139305984,'Advanced','Advanced Realtime Tracking GmbH'),(150156083200,'Syracuse','Syracuse Research Corporation'),(150172860416,'Conceptr','Conceptronic'),(150189637632,'PimaElec','PIMA Electronic Systems Ltd.'),(150206414848,'PollinEl','Pollin Electronic GmbH'),(150223192064,'IntelCor','Intel Corporate'),(150239969280,'IntelCor','Intel Corporate'),(150256746496,'NokiaDan','Nokia Danmark A/S'),(150273523712,'NokiaDan','Nokia Danmark A/S'),(150290300928,'Micropro','Microprocessor Designs Inc'),(150307078144,'NivisLlc','NIVIS LLC'),(150323855360,'CayeeCom','Cayee Computer Ltd.'),(150340632576,'WitronTe','Witron Technology Limited'),(150357409792,'CobaltDi','Cobalt Digital, Inc.'),(150374187008,'Lite-OnI','LITE-ON IT Corporation'),(150390964224,'Cisco','CISCO SYSTEMS, INC.'),(150407741440,'Cisco','CISCO SYSTEMS, INC.'),(150424518656,'AlpsElec','ALPS Electric Co., Ltd'),(150441295872,'FutureIn','FUTURE INNOVATION TECH CO.,LTD'),(150458073088,'Arcadyan','Arcadyan Technology Corporation'),(150474850304,'JanamTec','Janam Technologies LLC'),(150491627520,'Arburg','ARBURG GmbH & Co KG'),(150508404736,'Motorola','Motorola Mobility, Inc.'),(150525181952,'CloverEl','CLOVER ELECTRONICS CO.,LTD.'),(150541959168,'NortelNe','Nortel Networks'),(150558736384,'Gorba','Gorba AG'),(150575513600,'HirschEl','Hirsch Electronics Corporation'),(150592290816,'LncTechn','LNC Technology Co., Ltd.'),(150609068032,'Gloscom','Gloscom Co., Ltd.'),(150625845248,'Apple','Apple, Inc'),(150642622464,'QoolTech','Qool Technologies Ltd.'),(150659399680,'IntelCor','Intel Corporate'),(150676176896,'IntelCor','Intel Corporate'),(150692954112,'KisanEle','KISAN ELECTRONICS CO'),(150709731328,'Lasercra','Lasercraft Inc'),(150726508544,'Toshiba',''),(150743285760,'SieloxLl','Sielox LLC'),(150760062976,'Itf','ITF Co., Ltd.'),(150776840192,'DanaherM','Danaher Motion - Kollmorgen'),(150793617408,'Fourier','Fourier Systems Ltd.'),(150810394624,'Deltacom','Deltacom Electronics Ltd'),(150827171840,'CezzerMu','Cezzer Multimedia Technologies'),(150843949056,'GuangdaE','Guangda Electronic & Telecommuni'),(150860726272,'NiciraNe','Nicira Networks'),(150877503488,'AvitechI','Avitech International Corp'),(150894280704,'KissTekn','KISS Teknical Solutions, Inc.'),(150911057920,'ZylinAs','Zylin AS'),(150927835136,'G-ProCom','G-PRO COMPUTER'),(150944612352,'Iolan','IOLAN Holding'),(150961389568,'Fujitsu','Fujitsu Limited'),(150978166784,'ShouyoEl','Shouyo Electronics CO., LTD'),(150994944000,'AlconTel','ALCON TELECOMMUNICATIONS CO., LT'),(151011721216,'Ddrdrive','DDRdrive LLC'),(151028498432,'EonasIt-','eonas IT-Beratung und -Entwicklu'),(151045275648,'Ird','IRD A/S'),(151062052864,'Senticar','Senticare'),(151078830080,'Sandforc','SandForce'),(151095607296,'KedahEle','Kedah Electronics Engineering, L'),(151112384512,'Advanced','Advanced Card Systems Ltd.'),(151129161728,'Dizipia','DIZIPIA, INC.'),(151145938944,'Nintendo','Nintendo Co., Ltd.'),(151162716160,'Apple','Apple, Inc'),(151179493376,'Cisco','CISCO SYSTEMS, INC.'),(151196270592,'Cisco','CISCO SYSTEMS, INC.'),(151213047808,'Linkflex','Linkflex Co.,Ltd'),(151229825024,'MetelSRO','METEL s.r.o.'),(151246602240,'GlobalSt','Global Star Solutions ULC'),(151263379456,'Oj-Elect','OJ-Electronics A/S'),(151280156672,'SamsungE','Samsung Electronics'),(151296933888,'SamsungE','Samsung Electronics Co.,Ltd'),(151313711104,'C-Matic','C-Matic Systems Ltd'),(151330488320,'Alflex',''),(151347265536,'NoveroBV','Novero holding B.V.'),(151364042752,'Alcatel-','Alcatel-Lucent-IPD'),(151380819968,'Purechoi','Purechoice Inc'),(151397597184,'MixTelem','MiX Telematics'),(151414374400,'SiemensI','Siemens AG, Infrastructure & Cit'),(151431151616,'CoffeeEq','Coffee Equipment Company'),(151447928832,'Tem','TEM AG'),(151464706048,'Objectiv','Objective Interface Systems, Inc'),(151481483264,'SonyEric','Sony Ericsson Mobile Communicati'),(151498260480,'Vestac',''),(151515037696,'Procurve','ProCurve Networking by HP'),(151531814912,'SagemCom','SAGEM COMMUNICATION'),(151548592128,'Helmholt','Helmholtz Centre Berlin for Mate'),(151565369344,'Private',''),(151582146560,'InyuanTe','Inyuan Technology Inc.'),(151598923776,'Ktc','KTC AB'),(151615700992,'HonHaiPr','Hon Hai Precision Ind. Co., Ltd.'),(151632478208,'HonHaiPr','Hon Hai Precision Ind. Co., Ltd.'),(151649255424,'Luminous','Luminous Power Technologies Pvt.'),(151666032640,'Lyntec',''),(151682809856,'2wire',''),(151699587072,'Datasens','DATASENSOR S.p.A.'),(151716364288,'FETElett','F E T Elettronica snc'),(151733141504,'AsustekC','ASUSTek COMPUTER INC.'),(151749918720,'KincoAut','Kinco Automation(Shanghai) Ltd.'),(151766695936,'PacketFo','Packet Forensics LLC'),(151783473152,'Pitronot','Pitronot Technologies and Engine'),(151800250368,'SystelSa','SYSTEL SA'),(151817027584,'Benchmar','Benchmark Electronics ( Thailand'),(151833804800,'CompalIn','COMPAL INFORMATION (KUNSHAN) CO.'),(151850582016,'Gulfstre','Gulfstream'),(151867359232,'Aprius','Aprius, Inc.'),(151884136448,'Cisco','CISCO SYSTEMS, INC.'),(151900913664,'Cisco','CISCO SYSTEMS, INC.'),(151917690880,'SiliconM','Silicon Micro Sensors GmbH'),(151934468096,'LookitTe','Lookit Technology Co., Ltd'),(151951245312,'Unigen','Unigen Corporation'),(151968022528,'Goldline','Goldline Controls'),(151984799744,'ZhuhaiRa','Zhuhai RaySharp Technology Co., '),(152001576960,'PowerIns','Power Instruments Pte Ltd'),(152018354176,'Elka-Ele','ELKA-Elektronik GmbH'),(152035131392,'BeijingS','Beijing Siasun Electronic System'),(152051908608,'Unicontr','UniControls a.s.'),(152068685824,'Motorola',''),(152085463040,'Cisco-Li','Cisco-Linksys, LLC'),(152102240256,'Smartrg','SmartRG Inc'),(152119017472,'Xembedde','Xembedded, Inc.'),(152135794688,'Apple','Apple, Inc'),(152152571904,'Resmed','ResMed Ltd'),(152169349120,'Burster','Burster GmbH & Co KG'),(152186126336,'DaqSyste','DAQ System'),(152202903552,'Snell',''),(152219680768,'SoamSyst','SOAM Systel'),(152236457984,'MoreStar','MORE STAR INDUSTRIAL GROUP LIMIT'),(152253235200,'Gridiron','GridIron Systems, Inc.'),(152270012416,'Motorola','Motorola Mobility, Inc.'),(152286789632,'Motorola','Motorola Mobility, Inc.'),(152303566848,'Htc','HTC Corporation'),(152320344064,'IsotekEl','Isotek Electronics Ltd'),(152337121280,'GnNetcom','GN Netcom A/S'),(152353898496,'UnionBus','Union Business Machines Co. Ltd.'),(152370675712,'Rim',''),(152387452928,'WhdiLlc','WHDI LLC'),(152404230144,'Neotion',''),(152421007360,'Hewlett-','Hewlett-Packard Company'),(152437784576,'Elster','ELSTER GMBH'),(152454561792,'Plantron','PLANTRONICS, INC.'),(152471339008,'Nanoteq',''),(152488116224,'LengdaTe','Lengda Technology(Xiamen) Co.,Lt'),(152504893440,'LihRongE','Lih Rong Electronic Enterprise C'),(152521670656,'Inmage','InMage Systems Inc'),(152538447872,'GghEngin','GGH Engineering s.r.l.'),(152555225088,'Antipode',''),(152572002304,'TourAnde','Tour & Andersson AB'),(152588779520,'Thinkflo','ThinkFlood, Inc.'),(152605556736,'VTTelema','V.T. Telematica S.p.a.'),(152622333952,'Hangzhou','HANGZHOU H3C Technologies Co., L'),(152639111168,'Ciena','Ciena Corporation'),(152655888384,'QuantaCo','Quanta Computer Inc.'),(152672665600,'Private',''),(152689442816,'TechnoDe','Techno Design Co., Ltd.'),(152706220032,'PirelliT','Pirelli Tyre S.p.A.'),(152722997248,'NidecCop','NIDEC COPAL CORPORATION'),(152739774464,'Algolwar','Algolware Corporation'),(152756551680,'Maxian',''),(152773328896,'ProteusI','Proteus Industries Inc.'),(152790106112,'Ajinexte','AJINEXTEK'),(152806883328,'Samjeon',''),(152823660544,'Motorola','Motorola Mobility, Inc.'),(152840437760,'AndesTec','ANDES TECHNOLOGY CORPORATION'),(152857214976,'WestellT','Westell Technologies Inc.'),(152873992192,'SkyContr','Sky Control'),(152890769408,'VdDivisi','VD Division, Samsung Electronics'),(152907546624,'Easydata','EasyData Hardware GmbH'),(152924323840,'ElsterSo','Elster Solutions, LLC'),(152941101056,'JuniperN','Juniper Networks'),(152957878272,'MapowerE','Mapower Electronics Co., Ltd'),(152974655488,'JiangsuL','Jiangsu Lemote Technology Corpor'),(152991432704,'Institut','Institut fÃ¼r PrÃ¼ftechnik'),(153008209920,'HanaCns','Hana CNS Co., LTD.'),(153024987136,'TrendEle','Trend Electronics Ltd'),(153041764352,'Motorola','Motorola Mobility, Inc.'),(153058541568,'Motorola','Motorola Mobility, Inc.'),(153075318784,'NewConce','New Concepts Development Corp.'),(153092096000,'SagetvLl','SageTV, LLC'),(153108873216,'E-Mon',''),(153125650432,'RedpineS','Redpine Signals, Inc.'),(153142427648,'Marshall','Marshall Electronics'),(153159204864,'BeijingD','Beijing Detianquan Electromechan'),(153175982080,'Hfr','HFR, Inc.'),(153192759296,'Cisco','CISCO SYSTEMS, INC.'),(153209536512,'Cisco','CISCO SYSTEMS, INC.'),(153226313728,'Xmark','Xmark Corporation'),(153243090944,'Dell','Dell Inc.'),(153259868160,'Motorola','Motorola Mobility, Inc.'),(153276645376,'ComxionT','COMXION Technology Inc.'),(153293422592,'Longchee','Longcheer Technology (Singapore)'),(153310199808,'Intellig','Intelligent Mechatronic Systems '),(153326977024,'Lyyn','Lyyn AB'),(153343754240,'NokiaDan','Nokia Danmark A/S'),(153360531456,'Ortana','ORTANA LTD'),(153377308672,'Securite','SECURITE COMMUNICATIONS / HONEYW'),(153394085888,'Q-Light','Q-Light Co., Ltd.'),(153410863104,'SichuanJ','Sichuan Jiuzhou Electronic Techn'),(153427640320,'EadsDeut','EADS Deutschland GmbH'),(153444417536,'Chroma',''),(153461194752,'SchmittI','Schmitt Industries'),(153477971968,'Eq-Sys','EQ-SYS GmbH'),(153494749184,'DigitalA','Digital Ally, Inc.'),(153511526400,'CiscoSpv','Cisco SPVTG'),(153528303616,'Mainpine','Mainpine, Inc.'),(153545080832,'Broadway','Broadway Networks'),(153561858048,'Securita','Securitas Direct AB'),(153578635264,'SamsungE','SAMSUNG Electronics. Co. LTD'),(153595412480,'Logmein','LogMeIn, Inc.'),(153612189696,'LuxLumen','Lux Lumen'),(153628966912,'Radiatio','Radiation Safety and Control Ser'),(153645744128,'Smc','SMC Corporation'),(153662521344,'Avsystem',''),(153679298560,'Team-R',''),(153696075776,'SichuanT','Sichuan Tianyi Information Scien'),(153712852992,'BehindSe','Behind The Set, LLC'),(153729630208,'Shenzhen','Shenzhen Full-join Technology Co'),(153746407424,'Nintendo','Nintendo Co., Ltd.'),(153763184640,'Tp-LinkT','TP-LINK TECHNOLOGIES CO., LTD.'),(153779961856,'KitaDens','KITA DENSHI CORPORATION'),(153796739072,'Cummins-','CUMMINS-ALLISON CORP.'),(153813516288,'UnilocUs','Uniloc USA Inc.'),(153830293504,'Trg',''),(153847070720,'InhandEl','Inhand Electronics, Inc.'),(153863847936,'AirlinkW','AirLink WiFi Networking Corp.'),(153880625152,'TexasIns','Texas Instruments'),(153897402368,'WaremaEl','WAREMA electronic GmbH'),(153914179584,'SamsungE','Samsung Electronics Co.,LTD'),(153930956800,'SamsungE','Samsung Electronics'),(153947734016,'Ball-ItO','Ball-It Oy'),(153964511232,'BannerEn','Banner Engineering'),(153981288448,'Industri','Industrial Computer Source (Deut'),(153998065664,'Saxnet','saxnet gmbh'),(154014842880,'Benein','Benein, Inc'),(154031620096,'ElginSA','ELGIN S.A.'),(154048397312,'Ansync','Ansync Inc.'),(154065174528,'Apple','Apple, Inc'),(154081951744,'InoThera','INO Therapeutics LLC'),(154098728960,'CavenaIm','Cavena Image Products AB'),(154115506176,'SeaSigna','SEA Signalisation'),(154132283392,'Microtro','Microtronic AG'),(154149060608,'Ipnect','IPnect co. ltd.'),(154165837824,'IpaxiomN','IPaXiom Networks'),(154182615040,'Pirkus','Pirkus, Inc.'),(154199392256,'Hinke','Hinke A/S'),(154216169472,'Demco','Demco Corp.'),(154232946688,'F5Networ','F5 Networks, Inc.'),(154249723904,'Cisco','CISCO SYSTEMS, INC.'),(154266501120,'Cisco','CISCO SYSTEMS, INC.'),(154283278336,'Algorith','Algorithmix GmbH'),(154300055552,'Motorola','Motorola CHS'),(154316832768,'Motorola','Motorola Mobility, Inc.'),(154333609984,'ZuendSys','Zuend Systemtechnik AG'),(154350387200,'Shanghai','Shanghai Jinghan Weighing Appara'),(154367164416,'SonyEric','Sony Ericsson Mobile Communicati'),(154383941632,'Tvlogic',''),(154400718848,'Glocom','Glocom, Inc.'),(154417496064,'Masterna','Masternaut'),(154434273280,'WiloSe','WILO SE'),(154451050496,'Softwell','Softwell Technology Co., Ltd.'),(154467827712,'Private',''),(154484604928,'ZyxelCom','ZyXEL Communications Corporation'),(154501382144,'Double-T','Double-Take Software, INC.'),(154518159360,'RgNets','RG Nets, Inc.'),(154534936576,'IpDatate','IP Datatel, LLC.'),(154551713792,'UltraSte','Ultra Stereo Labs, Inc'),(154568491008,'AftAtlas','AFT Atlas Fahrzeugtechnik GmbH'),(154585268224,'Biodevic','Biodevices, SA'),(154602045440,'BeijingH','Beijing HTTC Technology Ltd.'),(154618822656,'NortelNe','Nortel Networks'),(154635599872,'D-Link','D-Link Corporation'),(154652377088,'Op-Tecti','Op-Tection GmbH'),(154669154304,'NokiaDan','Nokia Danmark A/S'),(154685931520,'NokiaDan','Nokia Danmark A/S'),(154702708736,'DilogNor','Dilog Nordic AB'),(154719485952,'Pointmob','Pointmobile'),(154736263168,'TelemSas','TELEM SAS'),(154753040384,'PacificB','Pacific Biosciences'),(154769817600,'Toro','The Toro Company'),(154786594816,'UsBevera','US Beverage Net'),(154803372032,'VirtualC','Virtual Computer Inc.'),(154820149248,'Delec','DELEC GmbH'),(154836926464,'OnepathN','OnePath Networks LTD.'),(154853703680,'Inventec','Inventec Besta Co., Ltd.'),(154870480896,'IshiiToo','Ishii Tool & Engineering Corpora'),(154887258112,'NueteqTe','NUETEQ Technology,Inc.'),(154904035328,'Pharmasm','PharmaSmart LLC'),(154920812544,'BenignTe','Benign Technologies Co, Ltd.'),(154937589760,'Cisco','CISCO SYSTEMS, INC.'),(154954366976,'Cisco','CISCO SYSTEMS, INC.'),(154971144192,'Magnetic','Magnetic Autocontrol GmbH'),(154987921408,'AnyUse','Any Use'),(155004698624,'ThomsonT','Thomson Telecom Belgium'),(155021475840,'Nextwave','Nextwave Semiconductor'),(155038253056,'Private',''),(155055030272,'RedBeetl','Red Beetle Inc.'),(155071807488,'IwowComm','iWOW Communications Pte Ltd'),(155088584704,'FugangEl','FuGang Electronic (DG) Co.,Ltd'),(155105361920,'Giga-Byt','GIGA-BYTE TECHNOLOGY CO.,LTD.'),(155122139136,'Nintendo','Nintendo Co., Ltd.'),(155138916352,'Dct-Delt','DCT-Delta GmbH'),(155155693568,'Netup','NetUP Inc.'),(155172470784,'Micro-St','MICRO-STAR INT`L CO., LTD.'),(155189248000,'KnappLog','Knapp Logistik Automation GmbH'),(155206025216,'Azurewav','AzureWave Technologies (Shanghai'),(155222802432,'AxisNetw','Axis Network Technology'),(155239579648,'Shenzhen','Shenzhenshi chuangzhicheng Techn'),(155256356864,'NohmiBos','NOHMI BOSAI LTD.'),(155273134080,'SsiCompu','SSI COMPUTER CORP'),(155289911296,'Energyic','EnergyICT'),(155306688512,'MkMaster','MK MASTER INC.'),(155323465728,'HittiteM','Hittite Microwave Corporation'),(155340242944,'HonHaiPr','Hon Hai Precision Ind.Co.,Ltd.'),(155357020160,'HonHaiPr','Hon Hai Precision Ind. Co., Ltd.'),(155390574592,'Datastri','Datastrip Inc.'),(155407351808,'Virtensy','VirtenSys Inc'),(155424129024,'RubyTech','Ruby Tech Corp.'),(155440906240,'Uni-V','Uni-v co.,ltd'),(155457683456,'NeostarT','Neostar Technology Co.,LTD'),(155474460672,'AlpsElec','Alps Electric Co., Ltd'),(155491237888,'Lectroso','Lectrosonics, Inc.'),(155508015104,'Wide','WIDE CORPORATION'),(155524792320,'Apple','Apple, Inc'),(155541569536,'Motorola','Motorola - BSG'),(155558346752,'BrocadeC','Brocade Communications Systems, '),(155575123968,'DigitalB','Digital Barriers Advanced Techno'),(155591901184,'LudlElec','Ludl Electronic Products'),(155608678400,'CssiSPte','CSSI (S) Pte Ltd'),(155625455616,'SAAA','S.A.A.A.'),(155642232832,'EmersonA','Emerson Appliance Motors and Con'),(155675787264,'Storwize','Storwize, Inc.'),(155692564480,'HaloMoni','Halo Monitoring, Inc.'),(155709341696,'WanzlMet','Wanzl Metallwarenfabrik GmbH'),(155726118912,'Axona','Axona Limited'),(155742896128,'NortelNe','Nortel Networks'),(155759673344,'Nintendo','Nintendo Co., Ltd.'),(155776450560,'Commscop','CommScope Canada Inc.'),(155793227776,'MmbResea','MMB Research Inc.'),(155810004992,'Kaztek','Kaztek Systems'),(155826782208,'Spidercl','SpiderCloud Wireless, Inc'),(155843559424,'ShenZhen','Shen Zhen Lite Star Electronics '),(155860336640,'VoyantIn','Voyant International'),(155877113856,'Perceptr','PERCEPTRON INC'),(155893891072,'Solartro','Solartron Metrology Ltd'),(155910668288,'Hokkaido','Hokkaido Electronics Corporation'),(155927445504,'Radchips','RadChips, Inc.'),(155944222720,'Asantron','Asantron Technologies Ltd.'),(155960999936,'Cisco','CISCO SYSTEMS, INC.'),(155977777152,'Cisco','CISCO SYSTEMS, INC.'),(155994554368,'SiliconS','Silicon Software GmbH'),(156011331584,'InitraDO','Initra d.o.o.'),(156028108800,'SamsungE','Samsung Electronics CO., LTD'),(156044886016,'MulogicB','MuLogic BV'),(156061663232,'2wire',''),(156095217664,'PaBastio','PA Bastion CC'),(156111994880,'AbbStotz','ABB STOTZ-KONTAKT GmbH'),(156128772096,'NanjingP','Nanjing Panda Electronics Compan'),(156145549312,'RaidonTe','RAIDON TECHNOLOGY, INC.'),(156162326528,'Design-C','Design-Com Technologies Pty. Ltd'),(156179103744,'TerbergB','Terberg besturingstechniek B.V.'),(156195880960,'Hivision','Hivision Co.,ltd'),(156212658176,'VineTele','Vine Telecom CO.,Ltd.'),(156229435392,'GiavalSc','Giaval Science Development Co. L'),(156246212608,'ShinWang','Shin Wang Tech.'),(156262989824,'Rayzone','Rayzone Corporation'),(156279767040,'Phybridg','Phybridge Inc'),(156296544256,'BridgeTe','Bridge Technologies Co AS'),(156313321472,'Elentec',''),(156330098688,'UnitronN','Unitron nv'),(156346875904,'AocInter','AOC International (Europe) GmbH'),(156363653120,'Sumavisi','Sumavision Technologies Co.,Ltd'),(156380430336,'SmartDoo','Smart Doorphones'),(156397207552,'SolidYea','Solid Year Co., Ltd.'),(156413984768,'Covia','Covia, Inc.'),(156430761984,'ArubaNet','ARUBA NETWORKS, INC.'),(156447539200,'Weinzier','Weinzierl Engineering GmbH'),(156464316416,'PhihongU','Phihong USA Corp.'),(156481093632,'OndaComm','Onda Communication spa'),(156497870848,'Aurotech','AUROTECH ultrasound AS.'),(156514648064,'FusionMu','Fusion MultiSystems dba Fusion-i'),(156531425280,'Redriven','ReDriven Power Inc.'),(156548202496,'3comEuro','3Com Europe Ltd'),(156564979712,'Autronic','Autronica Fire And Securirty'),(156581756928,'CompassS','Compass System(Embedded Dept.)'),(156598534144,'TapTv','TAP.tv'),(156615311360,'TibboTec','Tibbo Technology'),(156632088576,'MagTechE','Mag Tech Electronics Co Limited'),(156648865792,'OptecDis','Optec Displays, Inc.'),(156665643008,'FuYiChen','FU YI CHENG Technology Co., Ltd.'),(156682420224,'Actionte','Actiontec Electronics, Inc'),(156699197440,'NokiaDan','Nokia Danmark A/S'),(156715974656,'NokiaDan','Nokia Danmark A/S'),(156732751872,'Universa','Universal Global Scientific Indu'),(156749529088,'NortelNe','Nortel Networks'),(156766306304,'Meteocon','Meteocontrol GmbH'),(156783083520,'Hewlett-','Hewlett-Packard Company'),(156799860736,'RuckusWi','Ruckus Wireless'),(156816637952,'LgElectr','LG Electronics'),(156833415168,'BangAndO','Bang and Olufsen Medicom a/s'),(156850192384,'Contextr','ConteXtream Ltd'),(156866969600,'Designar','DesignArt Networks'),(156883746816,'Blackboa','Blackboard Inc.'),(156900524032,'CentreFo','Centre For Development Of Telema'),(156917301248,'Vodafone','Vodafone Omnitel N.V.'),(156934078464,'KagaElec','Kaga Electronics Co., Ltd.'),(156950855680,'Hybus','HYBUS CO., LTD.'),(156967632896,'AsustekC','ASUSTek COMPUTER INC.'),(156984410112,'SonyComp','Sony Computer Entertainment Inc.'),(157001187328,'Infoware','Infoware ZRt.'),(157017964544,'Do-Monix',''),(157034741760,'SamsungE','Samsung Electronics Co.,LTD'),(157051518976,'SamsungE','Samsung Electronics'),(157068296192,'Motorola','Motorola, Broadband Solutions Gr'),(157085073408,'Motorola','Motorola, Inc'),(157101850624,'Shenzhen','Shenzhen Baoxin Tech CO., Ltd.'),(157118627840,'Motorola','Motorola Mobility, Inc.'),(157135405056,'Ginzinge','Ginzinger electronic systems'),(157152182272,'Cisco','CISCO SYSTEMS, INC.'),(157168959488,'Cisco','CISCO SYSTEMS, INC.'),(157185736704,'AquilaTe','Aquila Technologies'),(157202513920,'BeijingZ','Beijing Zhongchuang Telecommunic'),(157219291136,'ActionSt','Action Star Enterprise Co., Ltd.'),(157236068352,'BimengCo','Bimeng Comunication System Co. L'),(157252845568,'NesTechn','NES Technology Inc.'),(157269622784,'Adc-Elek','ADC-Elektronik GmbH'),(157286400000,'RimTesti','RIM Testing Services'),(157303177216,'Motorola','Motorola Mobility, Inc.'),(157319954432,'Motorola','Motorola Mobility, Inc.'),(157336731648,'HongKong','Hong Kong Middleware Technology '),(157353508864,'SonimTec','Sonim Technologies Inc'),(157370286080,'SikluCom','Siklu Communication'),(157387063296,'Buffalo','Buffalo Inc.'),(157403840512,'Telestar','TELESTAR DIGITAL GmbH'),(157420617728,'Advanced','Advanced Video Communications In'),(157437394944,'Procurve','ProCurve Networking by HP'),(157454172160,'LeaderTe','Ag Leader Technology'),(157470949376,'DycorTec','Dycor Technologies Ltd.'),(157487726592,'A7Engine','A7 Engineering, Inc.'),(157504503808,'Hangzhou','Hangzhou DPtech Technologies Co.'),(157521281024,'AdolfThi','Adolf Thies Gmbh & Co. KG'),(157538058240,'Morpho',''),(157554835456,'Echostar','EchoStar Technologies'),(157571612672,'Esab','ESAB AB'),(157588389888,'CoulombT','Coulomb Technologies'),(157605167104,'Netgear',''),(157621944320,'Graf-Syt','Graf-Syteco GmbH & Co. KG'),(157638721536,'Escatron','ESCATRONIC GmbH'),(157655498752,'NortelNe','Nortel Networks'),(157672275968,'SeagateT','Seagate Technology'),(157689053184,'Gridpoin','GridPoint, Inc.'),(157705830400,'FreeAlli','free alliance sdn bhd'),(157722607616,'WuhanHig','Wuhan Higheasy Electronic Techno'),(157739384832,'TexasIns','Texas Instruments'),(157756162048,'Central','CENTRAL Corporation'),(157772939264,'Hurob','HuRob Co.,Ltd'),(157789716480,'HainzlIn','Hainzl Industriesysteme GmbH'),(157806493696,'Sony','Sony Corporation'),(157823270912,'Ciat',''),(157840048128,'NtiComod','NTI COMODO INC'),(157856825344,'Motorola','Motorola Mobility, Inc.'),(157873602560,'Asumo','Asumo Co.,Ltd.'),(157890379776,'Cisco','CISCO SYSTEMS, INC.'),(157907156992,'Cisco','CISCO SYSTEMS, INC.'),(157923934208,'Meridian','Meridian Audio Limited'),(157940711424,'HagerEle','Hager Electro SAS'),(157957488640,'Mobilarm','Mobilarm Ltd'),(157974265856,'Broadban','Broadband Solutions Group'),(157991043072,'Broadban','Broadband Solutions Group'),(158007820288,'TobiiTec','Tobii Technology AB'),(158024597504,'AutonetM','Autonet Mobile'),(158041374720,'Fascinat','Fascinations Toys and Gifts, Inc'),(158058151936,'WillowGa','Willow Garage, Inc.'),(158074929152,'Exeltech','Exeltech Inc'),(158091706368,'InscapeD','Inscape Data Corporation'),(158108483584,'Shenzhen','Shenzhen SOGOOD Industry CO.,LTD'),(158125260800,'Thomson','Thomson Inc.'),(158142038016,'AskeyCom','Askey Computer'),(158158815232,'Qualica','QUALICA Inc.'),(158175592448,'FreeboxS','FREEBOX SA'),(158192369664,'WinwardI','Winward Industrial Limited'),(158209146880,'IntelCor','Intel Corporate'),(158225924096,'IntelCor','Intel Corporate'),(158242701312,'IlsungPr','IlSung Precision'),(158259478528,'Bicom','BICOM, Inc.'),(158276255744,'Innovar','Innovar Systems Limited'),(158293032960,'AlcoholM','Alcohol Monitoring Systems'),(158309810176,'JuniperN','Juniper Networks'),(158326587392,'Centrak','Centrak, Inc.'),(158343364608,'GlobalTe','GLOBAL Technology Inc.'),(158360141824,'Digitalb','Digitalbox Europe GmbH'),(158376919040,'DsTechLl','DS Tech, LLC'),(158393696256,'ConveyCo','Convey Computer Corp.'),(158410473472,'Hasegawa','HASEGAWA ELECTRIC CO.,LTD.'),(158427250688,'CaoGroup','CAO Group'),(158444027904,'Withings',''),(158460805120,'SeerTech','Seer Technology, Inc'),(158477582336,'InMotion','In Motion Technology Inc.'),(158494359552,'PlasterN','Plaster Networks'),(158511136768,'Dell','Dell Inc.'),(158527913984,'SamsungE','Samsung Electronics Co., Ltd., S'),(158544691200,'Iris-Gmb','iris-GmbH infrared & intelligent'),(158561468416,'Clearpat','ClearPath Networks, Inc.'),(158578245632,'UnitedIn','United Information Technology Co'),(158595022848,'YtElec','YT Elec. Co,.Ltd.'),(158611800064,'Wynmax','Wynmax Inc.'),(158628577280,'SonyEric','Sony Ericsson Mobile Communicati'),(158645354496,'Seanodes',''),(158662131712,'Shenzhen','Shenzhen Fanhai Sanjiang Electro'),(158678908928,'Uniphone','Uniphone Telecommunication Co., '),(158695686144,'Nintendo','Nintendo Co., Ltd.'),(158712463360,'Kaminari','Kaminario Technologies Ltd.'),(158729240576,'NdsSurgi','NDS Surgical Imaging'),(158746017792,'MiyoshiE','MIYOSHI ELECTRONICS CORPORATION'),(158762795008,'Cisco','CISCO SYSTEMS, INC.'),(158779572224,'Technica','Technical Solutions Company Ltd.'),(158796349440,'Cisco','CISCO SYSTEMS, INC.'),(158813126656,'HilgerUK','Hilger u. Kern GMBH'),(158829903872,'Private',''),(158846681088,'Quopin','QuoPin Co., Ltd.'),(158863458304,'Accedian','Accedian Networks Inc'),(158880235520,'Avm','AVM GmbH'),(158897012736,'Qlogic','QLogic Corporation'),(158913789952,'Apple','Apple, Inc'),(158930567168,'Jsc\"Supe','JSC \"Supertel\"'),(158947344384,'Naturalp','NaturalPoint'),(158964121600,'Ibm','IBM Corp'),(158980898816,'ValiantC','Valiant Communications Limited'),(158997676032,'EksEngel','eks Engel GmbH & Co. KG'),(159014453248,'AIAntita','A.I. ANTITACCHEGGIO ITALIA SRL'),(159031230464,'Astak','ASTAK Inc.'),(159048007680,'MaquetCa','Maquet Cardiopulmonary AG'),(159064784896,'Sharetro','SHARETRONIC Group LTD'),(159081562112,'Security','Security Expert Co. Ltd'),(159098339328,'Centrofa','CENTROFACTOR  INC'),(159115116544,'Enertrac',''),(159131893760,'GztTelko','GZT Telkom-Telmor sp. z o.o.'),(159148670976,'GtGerman','gt german telematics gmbh'),(159165448192,'On-RampW','On-Ramp Wireless, Inc.'),(159182225408,'Pico-Tes','Pico-Tesla Magnetic Therapies'),(159199002624,'Elitegro','ELITEGROUP COMPUTER SYSTEM CO., '),(159215779840,'Zte','ZTE Corporation'),(159232557056,'CxpDigit','CXP DIGITAL BV'),(159249334272,'PcWorthI','PC Worth Int`l Co., Ltd.'),(159266111488,'Sfr',''),(159282888704,'Integrat','Integrated Design Tools, Inc.'),(159299665920,'VenntisL','Venntis, LLC'),(159316443136,'PowerPlu','Power PLUS Communications AG'),(159333220352,'Viaas','Viaas Inc'),(159349997568,'PsiberDa','Psiber Data Systems Inc.'),(159366774784,'PhilipsC','Philips CareServant'),(159383552000,'Edt',''),(159400329216,'DsaEncor','DSA Encore, LLC'),(159417106432,'RotelTec','ROTEL TECHNOLOGIES'),(159433883648,'ZynusVis','ZYNUS VISION INC.'),(159450660864,'SmaRailw','SMA Railway Technology GmbH'),(159467438080,'LogitekE','Logitek Electronic Systems, Inc.'),(159484215296,'AsrockIn','ASRock Incorporation'),(159500992512,'Ocp','OCP Inc.'),(159517769728,'Lightcom','Lightcomm Technology Co., Ltd'),(159534546944,'CteraNet','CTERA Networks Ltd.'),(159551324160,'GenuineT','Genuine Technologies Co., Ltd.'),(159568101376,'Bitrode','Bitrode Corp.'),(159584878592,'DaidoSig','Daido Signal Co., Ltd.'),(159601655808,'ComelitG','COMELIT GROUP S.P.A'),(159618433024,'ChengduG','Chengdu GeeYa Technology Co.,LTD'),(159635210240,'Stirling','Stirling Energy Systems'),(159651987456,'Entourag','Entourage Systems, Inc.'),(159668764672,'KiryungE','Kiryung Electronics'),(159685541888,'CiscoSpv','Cisco SPVTG'),(159702319104,'Energy','Energy, Inc.'),(159719096320,'Aetas','Aetas Systems Inc.'),(159735873536,'CloudEng','Cloud Engines, Inc.'),(159752650752,'DigitalR','Digital Recorders'),(159769427968,'Wittenst','WITTENSTEIN AG'),(159802982400,'Minimax','Minimax GmbH & Co KG'),(159819759616,'OkiElect','Oki Electric Industry Co., Ltd.'),(159836536832,'RuncomTe','Runcom Technologies Ltd.'),(159853314048,'SamsungE','Samsung Electronics Co., Ltd., M'),(159870091264,'Ifta','IfTA GmbH'),(159886868480,'Ceva','CEVA, Ltd.'),(159903645696,'DinDietm','din Dietmar Nocker Facilitymanag'),(159920422912,'2wire',''),(159937200128,'DrsConso','DRS Consolidated Controls'),(159953977344,'SensusMe','Sensus Metering Systems'),(159987531776,'QuasarTe','Quasar Technologies, Inc.'),(160004308992,'MaquetCr','Maquet Critical Care AB'),(160021086208,'Pittasof','Pittasoft'),(160037863424,'Moneytec','MONEYTECH'),(160054640640,'Lojack','LoJack Corporation'),(160071417856,'Cisco','CISCO SYSTEMS, INC.'),(160088195072,'Cisco','CISCO SYSTEMS, INC.'),(160104972288,'NokiaDan','Nokia Danmark A/S'),(160121749504,'NokiaDan','Nokia Danmark A/S'),(160138526720,'JeorichT','Jeorich Tech. Co.,Ltd.'),(160155303936,'Ringcube','RingCube Technologies, Inc.'),(160172081152,'Apple','Apple, Inc'),(160188858368,'VideonCe','Videon Central, Inc.'),(160205635584,'Singapor','Singapore Technologies Electroni'),(160222412800,'VertexWi','Vertex Wireless Co., Ltd.'),(160239190016,'Elettrol','ELETTROLAB Srl'),(160255967232,'Riverbed','Riverbed Technology'),(160272744448,'Se-Elekt','SE-Elektronic GmbH'),(160289521664,'Vxi','VXI CORPORATION'),(160306298880,'PirelliT','Pirelli Tyre S.p.A.'),(160323076096,'Pixel8Ne','Pixel8 Networks'),(160339853312,'VisonicT','Visonic Technologies 1993 Ltd'),(160356630528,'HonHaiPr','Hon Hai Precision Ind. Co., Ltd.'),(160373407744,'Research','Research In Motion'),(160390184960,'Mpedia',''),(160406962176,'SyphanTe','Syphan Technologies Ltd'),(160423739392,'Tantalus','Tantalus Systems Corp.'),(160440516608,'Coachcom','CoachComm, LLC'),(160457293824,'Nec','NEC Corporation'),(160474071040,'Mornings','Morningstar Corporation'),(160490848256,'Shanghai','Shanghai Dare Technologies Co.,L'),(160507625472,'Sentec','SenTec AG'),(160524402688,'IbridgeN','Ibridge Networks & Communication'),(160541179904,'Procurve','ProCurve Networking by HP'),(160557957120,'Interbro','interbro Co. Ltd.'),(160574734336,'Luxtera','Luxtera Inc'),(160591511552,'Dell','Dell Inc.'),(160608288768,'Vizimax','Vizimax Inc.'),(160625065984,'SamsungE','Samsung Electronics Co.,Ltd'),(160641843200,'SamsungE','Samsung Electronics'),(160658620416,'Shenzhen','Shenzhen Huawei Communication Te'),(160675397632,'SagemCom','SAGEM COMMUNICATION'),(160692174848,'Init-Ins','inIT - Institut Industrial IT'),(160708952064,'AtenixEE','ATENIX E.E. s.r.l.'),(160725729280,'\"Azimut\"','\"Azimut\" Production Association '),(160742506496,'Broadban','Broadband Forum'),(160759283712,'VanBreda','Van Breda B.V.'),(160776060928,'Dantherm','Dantherm Power'),(160792838144,'EasternC','Eastern Communications Company L'),(160809615360,'Zhejiang','Zhejiang Tianle Digital Electric'),(160826392576,'Nemo-QIn','Nemo-Q International AB'),(160843169792,'StElectr','ST Electronics (Info-Security) P'),(160859947008,'KunimiMe','KUNIMI MEDIA DEVICE Co., Ltd.'),(160876724224,'Fiberple','FiberPlex Technologies, LLC'),(160893501440,'NeliTech','NELI TECHNOLOGIES'),(160910278656,'D-BoxTec','D-BOX Technologies'),(160927055872,'Jsc\"Conc','JSC \"Concern \"Sozvezdie\"'),(160943833088,'JFLabs','J & F Labs'),(160960610304,'CamcoPro','CAMCO Produktions- und Vertriebs'),(160977387520,'StjElect','STJ  ELECTRONICS  PVT  LTD'),(160994164736,'Huachent','Huachentel Technology Developmen'),(161010941952,'Pointred','PointRed Telecom Private Ltd.'),(161027719168,'NewPosTe','NEW POS Technology Limited'),(161044496384,'Calltech','CallTechSolution Co.,Ltd'),(161061273600,'Equipson','Equipson S.A.'),(161078050816,'X-StarNe','x-star networks Inc.'),(161094828032,'MaksatTe','Maksat Technologies (P) Ltd'),(161111605248,'Cisco','CISCO SYSTEMS, INC.'),(161128382464,'Cisco','CISCO SYSTEMS, INC.'),(161145159680,'KokuyoS&','KOKUYO S&T Co., Ltd.'),(161161936896,'Tp-LinkT','TP-LINK Technologies Co., Ltd.'),(161178714112,'Vitality','Vitality, Inc.'),(161195491328,'GenieInd','Genie Industries, Inc.'),(161212268544,'HillsInd','Hills Industries Limited'),(161229045760,'Pole/Zer','Pole/Zero Corporation'),(161245822976,'Mellanox','Mellanox Technologies Ltd'),(161262600192,'EsusElek','ESUS ELEKTRONIK SAN. VE DIS. TIC'),(161279377408,'Haier',''),(161296154624,'WeatherC','The Weather Channel'),(161312931840,'TridentM','Trident Microsystems, Inc.'),(161329709056,'SuperMic','Super Micro Computer, Inc.'),(161346486272,'Nextek','NEXTEK, Inc.'),(161363263488,'Guangzho','Guangzhou Shirui Electronic Co.,'),(161380040704,'DatnetIn','DatNet Informatikai Kft.'),(161396817920,'Eurodesi','Eurodesign BG LTD'),(161413595136,'Northwes','Northwest Signal Supply, Inc'),(161430372352,'Gigavisi','GIGAVISION srl'),(161447149568,'KalkiCom','Kalki Communication Technologies'),(161463926784,'ZhongSha','Zhong Shan City Litai Electronic'),(161480704000,'HedonEDB','Hedon e.d. B.V.'),(161497481216,'Cestroni','CEStronics GmbH'),(161514258432,'BeijingP','Beijing PKUNITY Microsystems Tec'),(161531035648,'Cisco-Li','Cisco-Linksys, LLC'),(161547812864,'Private',''),(161564590080,'HuaweiTe','Huawei Technologies Co., Ltd.'),(161581367296,'Technodi','TechnoDigital Technologies GmbH'),(161598144512,'Nintendo','Nintendo Co., Ltd.'),(161614921728,'Enalasys',''),(161631698944,'AltaDefi','Alta Definicion LINCEO S.L.'),(161648476160,'TrimaxWi','Trimax Wireless, Inc.'),(161665253376,'Eurodesi','EuroDesign embedded technologies'),(161682030592,'WalnutMe','Walnut Media Network'),(161698807808,'CentralN','Central Network Solution Co., Lt'),(161715585024,'Comverge','Comverge, Inc.'),(161732362240,'KontronB','Kontron (BeiJing) Technology Co.'),(161749139456,'Shanghai','Shanghai Embedway Information Te'),(161765916672,'BeijingS','Beijing Soul Technology Co.,Ltd.'),(161782693888,'AioLcdPc','AIO LCD PC BU / TPV'),(161799471104,'I-Tech','I-Tech corporation'),(161816248320,'Manufact','Manufacturing Resources Internat'),(161833025536,'Microsof','Microsoft Corporation'),(161849802752,'ComfileT','COMFILE Technology'),(161866579968,'Schmartz','Schmartz Inc'),(161883357184,'Maya-Cre','Maya-Creation Corporation'),(161900134400,'MbdaDeut','MBDA Deutschland GmbH'),(161916911616,'Hewlett-','Hewlett-Packard Company'),(161933688832,'Cisco','CISCO SYSTEMS, INC.'),(161950466048,'Cisco','CISCO SYSTEMS, INC.'),(161967243264,'TelecomF','Telecom FM'),(161984020480,'CostarEl','Costar  electronics, inc.,'),(162000797696,'AgileCom','Agile Communications, Inc.'),(162017574912,'Agilink','Agilink Systems Corp.'),(162034352128,'Alcatel-','Alcatel-Lucent IPD'),(162051129344,'Innerint','INNERINT Co., Ltd.'),(162067906560,'Apple','Apple, Inc'),(162084683776,'Italdata','Italdata Ingegneria dell`Idea S.'),(162101460992,'Tektrap','Tektrap Systems Inc.'),(162118238208,'Wireless','Wireless Cables Inc.'),(162135015424,'Zilliont','ZillionTV Corporation'),(162151792640,'NawooKor','Nawoo Korea Corp.'),(162168569856,'Ringbell','RingBell Co.,Ltd.'),(162185347072,'NortelNe','Nortel Networks'),(162202124288,'RuckusWi','Ruckus Wireless'),(162218901504,'StarLink','Star Link Communication Pvt. Ltd'),(162235678720,'Kasercor','kasercorp, ltd'),(162252455936,'Altek','altek Corporation'),(162269233152,'S-Access','S-Access GmbH'),(162286010368,'Shenzhen','SHENZHEN HUAPU DIGITAL CO., LTD'),(162302787584,'LsResear','LS Research, LLC'),(162319564800,'ReinerSc','Reiner SCT'),(162336342016,'MobileCo','Mobile Communications Korea Inco'),(162353119232,'SkylaneO','Skylane Optics'),(162369896448,'Innerspa','InnerSpace'),(162386673664,'NokiaDan','Nokia Danmark A/S'),(162403450880,'NokiaDan','Nokia Danmark A/S'),(162420228096,'EasternA','Eastern Asia Technology Limited'),(162437005312,'Inpegvis','InpegVision Co., Ltd'),(162453782528,'Azurewav','AzureWave Technologies, Inc'),(162470559744,'Fortress','Fortress Technologies'),(162487336960,'Robonica','Robonica (Pty) Ltd'),(162504114176,'Kroger','The Kroger Co.'),(162520891392,'Cedo',''),(162537668608,'KoreaMai','KOREA MAINTENANCE'),(162554445824,'Datafab','DataFab Systems Inc.'),(162571223040,'SecuraKe','Secura Key'),(162588000256,'AtiElect','ATI Electronics(Shenzhen) Co., L'),(162604777472,'Sumitomo','Sumitomo Electric Networks, Inc'),(162621554688,'Sunnytek','SUNNYTEK INFORMATION CO., LTD.'),(162638331904,'Probits','Probits Co., LTD.'),(162655109120,'Private',''),(162671886336,'CeedtecS','CeedTec Sdn Bhd'),(162688663552,'Shanghai','SHANGHAI SEEYOO ELECTRONIC & TEC'),(162705440768,'Everspri','Everspring Industry Co., Ltd.'),(162722217984,'Hanshini','Hanshinit Inc.'),(162738995200,'Omni-Wif','OMNI-WiFi, LLC'),(162755772416,'LgElectr','LG Electronics Inc'),(162772549632,'BelgianM','Belgian Monitoring Systems bvba'),(162789326848,'SonyEric','Sony Ericsson Mobile Communicati'),(162806104064,'IdahoTec','Idaho Technology'),(162822881280,'I-MateDe','i-mate Development, Inc.'),(162839658496,'IphionBv','Iphion BV'),(162856435712,'ReutechR','Reutech Radar Systems (PTY) Ltd'),(162873212928,'Humanwar','Humanware'),(162889990144,'NuvoTech','NuVo Technologies LLC'),(162906767360,'Avtex','Avtex Ltd'),(162923544576,'I-Tec','I-TEC Co., Ltd.'),(162940321792,'SugaElec','Suga Electronics Limited'),(162957099008,'Motorola','Motorola Mobility, Inc.'),(162973876224,'Motorola','Motorola Mobility, Inc.'),(162990653440,'Nordwest','Nordwestdeutsche ZÃ¤hlerrevision'),(163007430656,'KocoConn','KoCo Connector AG'),(163024207872,'DvsKorea','DVS Korea, Co., Ltd'),(163040985088,'NettalkC','netTALK.com, Inc.'),(163057762304,'AnsaldoS','Ansaldo STS USA'),(163091316736,'GmkElect','GMK electronic design GmbH'),(163108093952,'J&MAnaly','J&M Analytik AG'),(163124871168,'Tunstall','Tunstall Healthcare A/S'),(163141648384,'EndaEndu','ENDA ENDUSTRIYEL ELEKTRONIK LTD.'),(163158425600,'ObrCentr','OBR Centrum Techniki Morskiej S.'),(163175202816,'PilotEle','Pilot Electronics Corporation'),(163191980032,'CrenovaM','CreNova Multimedia Co., Ltd'),(163208757248,'TeacAust','TEAC Australia Pty Ltd.'),(163225534464,'Cutera','Cutera Inc'),(163242311680,'SmartTem','SMART Temps LLC'),(163259088896,'Shenzhen','Shenzhen Wistar Technology Co., '),(163275866112,'AudioPro','Audio Processing Technology Ltd'),(163292643328,'Cc','CC Systems AB'),(163309420544,'Raumfeld','RAUMFELD GmbH'),(163326197760,'Enabling','Enabling Technology Pty Ltd'),(163342974976,'Apple','Apple, Inc'),(163359752192,'Phyllis','Phyllis Co., Ltd.'),(163376529408,'Cisco','CISCO SYSTEMS, INC.'),(163393306624,'Cisco','CISCO SYSTEMS, INC.'),(163410083840,'Dataram',''),(163426861056,'Mercury','Mercury Systems, Inc.'),(163443638272,'AblazeLl','Ablaze Systems, LLC'),(163460415488,'LinnProd','Linn Products Ltd'),(163477192704,'Apacewav','Apacewave Technologies'),(163493969920,'Licera','Licera AB'),(163510747136,'SpaceExp','Space Exploration Technologies'),(163527524352,'EngelAxi','Engel Axil S.L.'),(163544301568,'Ktnf',''),(163561078784,'Teracom','Teracom Limited'),(163577856000,'Rosemoun','Rosemount Inc.'),(163594633216,'OemWorld','OEM Worldwide'),(163611410432,'AsustekC','ASUSTek COMPUTER INC.'),(163628187648,'Frc',''),(163644964864,'Femtocom','Femtocomm System Technology Corp'),(163661742080,'LaurelBa','LAUREL BANK MACHINES CO., LTD.'),(163678519296,'Neovia','NEOVIA INC.'),(163695296512,'CopSecur','COP SECURITY SYSTEM CORP.'),(163712073728,'Qingbang','QINGBANG ELEC(SZ) CO., LTD'),(163728850944,'SaeMagne','SAE Magnetics (H.K.) Ltd.'),(163745628160,'Isgus','ISGUS GmbH'),(163762405376,'Intelicl','InteliCloud Technology Inc.'),(163779182592,'CompalIn','COMPAL INFORMATION (KUNSHAN) CO.'),(163795959808,'JrdCommu','JRD Communication Inc'),(163812737024,'Thomson','Thomson Inc.'),(163829514240,'Mediaspu','MediaSputnik'),(163846291456,'Geophysi','Geophysical Survey Systems, Inc.'),(163863068672,'Truesell',''),(163879845888,'Companyt','companytec automaÃ§Ã£o e control'),(163896623104,'JuphoonS','Juphoon System Software Inc.'),(163913400320,'Proxense','Proxense, LLC'),(163930177536,'WongsEle','Wongs Electronics Co. Ltd.'),(163946954752,'IktAdvan','IKT Advanced Technologies s.r.o.'),(163963731968,'Wistron','Wistron Corporation'),(163980509184,'ChengduJ','Chengdu Jiuzhou Electronic Techn'),(163997286400,'Hamamats','HAMAMATSU TOA ELECTRONICS'),(164014063616,'AcorelSA','ACOREL S.A.S'),(164030840832,'Commtact','COMMTACT LTD'),(164047618048,'Instrume','Instrumentation Technologies d.d'),(164064395264,'Mir-Medi','MIR - Medical International Rese'),(164081172480,'Infineta','Infineta Systems, Inc'),(164097949696,'Bluetech','Bluetechnix GmbH'),(164114726912,'Motorola','Motorola Mobility, Inc.'),(164131504128,'SamsungE','Samsung Electro-Mechanics'),(164148281344,'XiaMenJo','Xia Men Joyatech Co., Ltd.'),(164165058560,'TMElectr','T.M. Electronics, Inc.'),(164181835776,'Digitec','Digitec Systems'),(164198612992,'Onbnetec','Onbnetech'),(164215390208,'Bachmann','Bachmann Technology GmbH & Co. K'),(164232167424,'Mia','MIA Corporation'),(164248944640,'TrapezeN','Trapeze Networks'),(164265721856,'LiosTech','LIOS Technology GmbH'),(164282499072,'BaustemB','Baustem Broadband Technologies, '),(164299276288,'Motorola','Motorola, Inc'),(164316053504,'Motorola','Motorola, Inc'),(164332830720,'AlpsElec','Alps Electric Co., Ltd'),(164349607936,'ThomsonT','Thomson Telecom Belgium'),(164366385152,'Circontr','Circontrol S.A.'),(164383162368,'Shenyang','SHENYANG TONGFANG MULTIMEDIA TEC'),(164399939584,'WfeTechn','WFE TECHNOLOGY CORP.'),(164416716800,'Emitech','Emitech Corp.'),(164450271232,'Apple','Apple, Inc'),(164483825664,'Shanghai','Shanghai DigiVision Technology C'),(164500602880,'Arcadyan','Arcadyan Technology Corporation'),(164517380096,'RailRoad','Rail & Road Protec GmbH'),(164534157312,'KrÃ¼ger&G','KrÃ¼ger &Gothe GmbH'),(164550934528,'2wire',''),(164567711744,'Cisco','CISCO SYSTEMS, INC.'),(164584488960,'Cisco','CISCO SYSTEMS, INC.'),(164601266176,'Dayseque','DaySequerra Corporation'),(164618043392,'3com','3Com Corporation'),(164634820608,'Hewlett-','Hewlett-Packard Company'),(164651597824,'Sansonic','Sansonic Electronics USA'),(164668375040,'OooNppEk','OOO NPP EKRA'),(164685152256,'T-Platfo','T-Platforms (Cyprus) Limited'),(164701929472,'Nintendo','Nintendo Co., Ltd.'),(164718706688,'D-Link','D-Link Corporation'),(164735483904,'HitronTe','Hitron Technologies. Inc'),(164752261120,'HonHaiPr','Hon Hai Precision Ind. Co.,Ltd.'),(164769038336,'SamsungE','Samsung Electronics'),(164785815552,'HonHaiPr','Hon Hai Precision Ind. Co.,Ltd.'),(164802592768,'SamsungE','Samsung Electronics Co.,Ltd'),(164819369984,'Logiways',''),(164836147200,'Irumtek','Irumtek Co., Ltd.'),(164852924416,'Actionte','Actiontec Electronics, Inc'),(164869701632,'Shenzhen','Shenzhen Huitaiwei Tech. Ltd, co'),(164886478848,'CoreSyst','Core System Japan'),(164903256064,'Protecte','ProtectedLogic Corporation'),(164920033280,'EfmNetwo','EFM Networks'),(164936810496,'Carecom','CARECOM CO.,LTD.'),(164953587712,'NokiaDan','Nokia Danmark A/S'),(164970364928,'NokiaDan','Nokia Danmark A/S'),(164987142144,'Essensiu','ESSENSIUM NV'),(165003919360,'ShineUni','SHINE UNION ENTERPRISE LIMITED'),(165020696576,'Inventec',''),(165037473792,'Mobileac','MobileAccess Networks'),(165054251008,'Nissho-D','Nissho-denki Co.,LTD.'),(165071028224,'Coordiwi','Coordiwise Technology Corp.'),(165087805440,'CinchCon','Cinch Connectors'),(165104582656,'Autovisi','AUTOVISION Co., Ltd'),(165121359872,'AampOfAm','AAMP of America'),(165138137088,'Ricoh','RICOH COMPANY,LTD.'),(165154914304,'Electron','Electronic Solutions, Inc.'),(165171691520,'AztechEl','Aztech Electronics Pte Ltd'),(165188468736,'CommidtA','COMMidt AS'),(165205245952,'Deif','DEIF A/S'),(165222023168,'LogicIns','Logic Instrument SA'),(165238800384,'Euphonic','Euphonic Technologies, Inc.'),(165255577600,'WuhanHon','wuhan hongxin telecommunication '),(165272354816,'GsiHelmh','GSI Helmholtzzentrum fÃ¼r Schwer'),(165289132032,'Metz-Wer','Metz-Werke GmbH & Co KG'),(165305909248,'A-MaxTec','A-Max Technology Macao Commercia'),(165322686464,'ParrotSa','Parrot SA'),(165339463680,'Zenterio','Zenterio AB'),(165356240896,'LockieIn','Lockie Innovation Pty Ltd'),(165373018112,'Interspi','Interspiro AB'),(165389795328,'GemtekTe','Gemtek Technology Co., Ltd.'),(165406572544,'AjohoEnt','Ajoho Enterprise Co., Ltd.'),(165423349760,'KisanSys','KISAN SYSTEM'),(165440126976,'DigitalI','Digital Innovation'),(165456904192,'Quantenn','Quantenna Communcations, Inc.'),(165473681408,'AlliedTe','ALLIED TELESIS, K.K corega divis'),(165490458624,'JuniperN','Juniper Networks'),(165507235840,'GeneralD','General Dynamics Robotic Systems'),(165524013056,'TerrierS','Terrier SC Ltd'),(165540790272,'Guangzho','Guangzhou Escene Computer Techno'),(165557567488,'Starleaf','StarLeaf Ltd.'),(165574344704,'CelltelS','CellTel S.p.A.'),(165591121920,'AltaSolu','Alta Solutions, Inc.'),(165607899136,'Mta','MTA SpA'),(165624676352,'IDoIt','I DO IT'),(165641453568,'SagemCom','SAGEM COMMUNICATION'),(165658230784,'Mitsubis','Mitsubishi Electric Co.'),(165675008000,'QvidiumT','QVidium Technologies, Inc.'),(165691785216,'Senscien','Senscient Ltd'),(165708562432,'ZtGroupI','ZT Group Int`l Inc'),(165725339648,'Noolix','NOOLIX Co., Ltd'),(165742116864,'CheetahT','Cheetah Technologies, L.P.'),(165758894080,'Cisco','CISCO SYSTEMS, INC.'),(165775671296,'Cisco','CISCO SYSTEMS, INC.'),(165792448512,'CarinaSy','Carina System Co., Ltd.'),(165809225728,'Sokrat','SOKRAT Ltd.'),(165826002944,'ItusJapa','ITUS JAPAN CO. LTD'),(165842780160,'M2mnet','M2Mnet Co., Ltd.'),(165859557376,'QuantaCo','Quanta Computer Inc'),(165876334592,'Private',''),(165893111808,'Moblic',''),(165909889024,'Megger',''),(165926666240,'Instrume','Instrumentation Technology Syste'),(165943443456,'FqIngeni','FQ Ingenieria Electronica S.A.'),(165960220672,'NovusPro','Novus Produtos Eletronicos Ltda'),(165976997888,'Microrob','MICROROBOT.CO.,LTD'),(165993775104,'Trixell',''),(166010552320,'ConnectS','CONNECT SRL'),(166027329536,'DaehapHy','DAEHAP HYPER-TECH'),(166044106752,'StrongTe','Strong Technologies Pty Ltd'),(166060883968,'KenmecMe','Kenmec Mechanical Engineering Co'),(166077661184,'SeikoEps','SEIKO EPSON CORPORATION'),(166094438400,'Shanghai','Shanghai LUSTER Teraband photoni'),(166111215616,'Arada','Arada Systems, Inc.'),(166127992832,'Wireless','Wireless Measurement Ltd'),(166144770048,'Duelco','Duelco A/S'),(166161547264,'Apple','Apple, Inc'),(166178324480,'NavisAut','Navis Auto Motive Systems, Inc.'),(166195101696,'Setrix','Setrix GmbH'),(166211878912,'ThalesCo','Thales Communications Inc'),(166228656128,'FordMoto','Ford Motor Company'),(166245433344,'IcommTel','ICOMM Tele Ltd'),(166262210560,'AskeyCom','Askey Computer'),(166278987776,'Kingston','Kingston Technology Company, Inc'),(166295764992,'Actionte','Actiontec Electronics, Inc'),(166312542208,'Dell','Dell Inc'),(166329319424,'Motorola','Motorola Mobility, Inc.'),(166346096640,'Apple','Apple, Inc'),(166362873856,'GeneralJ','General Jack Technology Ltd.'),(166379651072,'JtecCard','JTEC Card & Communication Co., L'),(166396428288,'Schoonde','Schoonderbeek Elektronica System'),(166413205504,'Shenzhen','ShenZhen Temobi Science&Tech Dev'),(166429982720,'Energyhu','EnergyHub'),(166446759936,'Artray','ARTRAY CO., LTD.'),(166463537152,'Scdi','SCDI Co. LTD'),(166480314368,'Insighte','Insightek Corp.'),(166497091584,'CadmosMi','Cadmos microsystems S.r.l.'),(166513868800,'Guangdon','Guangdong Gosun Telecommunicatio'),(166530646016,'IntelCor','Intel Corporate'),(166547423232,'IntelCor','Intel Corporate'),(166564200448,'SystemSe','System Sensor'),(166580977664,'Proventi','Proventix Systems, Inc.'),(166597754880,'Cisco','CISCO SYSTEMS, INC.'),(166614532096,'Cisco','CISCO SYSTEMS, INC.'),(166631309312,'NokiaDan','Nokia Danmark A/S'),(166648086528,'Purpleco','PurpleComm, Inc.'),(166664863744,'KozumiUs','Kozumi USA Corp.'),(166681640960,'DekaR&D','DEKA R&D'),(166698418176,'Semihalf',''),(166715195392,'SSquared','S Squared Innovations Inc.'),(166731972608,'Pcube','Pcube Systems, Inc.'),(166748749824,'ZenoInfo','Zeno Information System'),(166765527040,'Irca','IRCA SpA'),(166782304256,'OrySoluc','Ory Solucoes em Comercio de Info'),(166799081472,'NingboAn','Ningbo Andy Optoelectronic Co., '),(166815858688,'KmElecto','KM Electornic Technology Co., Lt'),(166832635904,'MagicPoi','Magic Point Inc.'),(166849413120,'Pace','Pace plc'),(166866190336,'Universa','Universal Media Corporation /Slo'),(166882967552,'IonicsEm','Ionics EMS Inc.'),(166899744768,'OpticalD','Optical Systems Design'),(166916521984,'FivalSci','Fival Science & Technology Co.,L'),(166933299200,'FdiMatel','FDI MATELEC'),(166950076416,'TaidocTe','TaiDoc Technology Corp.'),(166966853632,'Asiteq',''),(166983630848,'Stanford','Stanford University, OpenFlow Gr'),(167000408064,'LgElectr','LG Electronics'),(167017185280,'Dti',''),(167033962496,'CanalOve','CANAL OVERSEAS'),(167050739712,'AegPower','AEG Power Solutions'),(167067516928,'Visionhi','Visionhitech Co., Ltd.'),(167084294144,'Shanghai','Shanghai ONLAN Communication Tec'),(167101071360,'MurataMa','Murata Manufacturing Co., Ltd.'),(167117848576,'Sp','SP Corp'),(167134625792,'Cheerchi','Cheerchip Electronic Technology '),(167151403008,'Advanced','Advanced Spectrum Technology Co.'),(167168180224,'LegrandH','Legrand Home Systems, Inc'),(167184957440,'Zte','zte corporation'),(167201734656,'Tkm','TKM GmbH'),(167218511872,'Technolo','Technology Advancement Group, In'),(167235289088,'CtrixsIn','cTrixs International GmbH.'),(167252066304,'Procurve','ProCurve Networking by HP'),(167268843520,'Netgear',''),(167285620736,'SmcNetwo','SMC Networks'),(167302397952,'Nesslab',''),(167319175168,'Xrplus','XRPLUS Inc.'),(167335952384,'Military','Military Communication Institute'),(167352729600,'InfosysT','Infosys Technologies Ltd.'),(167369506816,'GoldenHi','Golden Highway Industry Developm'),(167386284032,'SEMSrl','S.E.M. srl'),(167403061248,'Bandrich','BandRich Inc.'),(167419838464,'AirdioWi','AirDio Wireless, Inc.'),(167436615680,'AcsipTec','AcSiP Technology Corp.'),(167453392896,'Interact','Interactive Intelligence'),(167470170112,'MkdTechn','MKD Technology Inc.'),(167486947328,'Research','Research In Motion'),(167503724544,'Shenzhen','Shenzhen Siglent Technology Co.,'),(167520501760,'Incostar','INCOstartec GmbH'),(167537278976,'Solaredg','SolarEdge Technologies'),(167554056192,'TestechE','Testech Electronics Pte Ltd'),(167570833408,'Accelera','Accelerated Concepts, Inc'),(167587610624,'Sectroni','Sectronic'),(167604387840,'Yoisys',''),(167621165056,'LiftComp','Lift Complex DS, JSC'),(167637942272,'NordiagA','Nordiag ASA'),(167654719488,'Nintendo','Nintendo Co., Ltd.'),(167671496704,'IeeSA','IEE S.A.'),(167688273920,'AduraTec','Adura Technologies'),(167705051136,'Cisco','CISCO SYSTEMS, INC.'),(167721828352,'Cisco','CISCO SYSTEMS, INC.'),(167738605568,'IntelCor','Intel Corporate'),(167755382784,'Envision','Envisionnovation Inc'),(167772160000,'IntelCor','Intel Corporate'),(167788937216,'Lanpro','LanPro Inc'),(167805714432,'Maxvisio','MaxVision LLC'),(167822491648,'Universa','Universal Global Scientific Indu'),(167839268864,'Grainmus','Grainmustards, Co,ltd.'),(167856046080,'ReboundT','Rebound Telecom. Co., Ltd'),(167872823296,'Adachi-S','Adachi-Syokai Co., Ltd.'),(167889600512,'CeDigita','CE Digital(Zhenjiang)Co.,Ltd'),(167906377728,'SuzhouNe','Suzhou NEW SEAUNION Video Techno'),(167923154944,'Tp-LinkT','TP-LINK TECHNOLOGIES CO., LTD.'),(167939932160,'GeenovoT','Geenovo Technology Ltd.'),(167956709376,'AlecSich','Alec Sicherheitssysteme GmbH'),(167973486592,'Mercury','MERCURY CORPORATION'),(167990263808,'CombaTel','Comba Telecom Systems (China) Lt'),(168007041024,'XagylCom','Xagyl Communications'),(168023818240,'MiproEle','MIPRO Electronics Co., Ltd'),(168040595456,'New-SolC','NEW-SOL COM'),(168057372672,'Shenzhen','Shenzhen Baoan Fenda Industrial '),(168074149888,'Ubiquiti','Ubiquiti Networks'),(171664474112,'BrocadeC','Brocade Communications Systems, '),(182167011328,'Cisco','CISCO SYSTEMS, INC.'),(183324639232,'Larsys-A','LARsys-Automation GmbH'),(195253239808,'Titech','TITECH GmbH'),(206158430208,'AllwellT','ALLWELL TECHNOLOGY CORP.'),(206175207424,'Smp',''),(206191984640,'ExpandNe','Expand Networks'),(206208761856,'Phasys','Phasys Ltd.'),(206225539072,'LeadtekR','LEADTEK RESEARCH INC.'),(206242316288,'FujitsuS','Fujitsu Siemens Computers'),(206259093504,'Superpow','SUPERPOWER COMPUTER'),(206275870720,'Opti','OPTI, INC.'),(206292647936,'AvioDigi','AVIO DIGITAL, INC.'),(206309425152,'TachionN','Tachion Networks, Inc.'),(206326202368,'AztechEl','AZTECH Electronics Pte Ltd'),(206342979584,'MphaseTe','mPHASE Technologies, Inc.'),(206359756800,'Congruen','CONGRUENCY, LTD.'),(206376534016,'MmcTechn','MMC Technology, Inc.'),(206393311232,'KlotzDig','Klotz Digital AG'),(206410088448,'Imt-Info','IMT - Information Management T'),(206426865664,'Visionet','VISIONETICS INTERNATIONAL'),(206443642880,'HmsIndus','HMS Industrial Networks'),(206460420096,'DigitalE','DIGITAL ENGINEERING LTD.'),(206477197312,'Nec','NEC Corporation'),(206493974528,'Divio','DIVIO, INC.'),(206510751744,'CpClare','CP CLARE CORP.'),(206527528960,'Ishida','ISHIDA CO., LTD.'),(206544306176,'BluearcU','BlueArc UK Ltd'),(206561083392,'JetwayIn','Jetway Information Co., Ltd.'),(206577860608,'Cisco','CISCO SYSTEMS, INC.'),(206594637824,'Smartbri','SMARTBRIDGES PTE. LTD.'),(206611415040,'Shuttle','SHUTTLE, INC.'),(206628192256,'Altvater','ALTVATER AIRDATA SYSTEMS'),(206644969472,'Skystrea','SKYSTREAM, INC.'),(206661746688,'3comEuro','3COM Europe Ltd.'),(206678523904,'OpticalN','OPTICAL NETWORKS, INC.'),(206695301120,'Tsi','TSI, Inc..'),(206712078336,'HsingTec','HSING TECH. ENTERPRISE CO.,LTD'),(206728855552,'FongKaiI','Fong Kai Industrial Co., Ltd.'),(206745632768,'CogentCo','COGENT COMPUTER SYSTEMS, INC.'),(206762409984,'Cisco','CISCO SYSTEMS, INC.'),(206779187200,'Checkout','CHECKOUT COMPUTER SYSTEMS, LTD'),(206795964416,'HeitelDi','HeiTel Digital Video GmbH'),(206812741632,'Kerbango','KERBANGO, INC.'),(206829518848,'FaseSald','FASE Saldatura srl'),(206846296064,'Opicom',''),(206863073280,'Southern','SOUTHERN INFORMATION'),(206879850496,'InalpNet','INALP NETWORKS, INC.'),(206896627712,'Sylantro','SYLANTRO SYSTEMS CORPORATION'),(206913404928,'QuantumB','QUANTUM BRIDGE COMMUNICATIONS'),(206930182144,'HoftWess','Hoft & Wessel AG'),(206946959360,'GeAviati','GE Aviation System'),(206963736576,'Harmonix','HARMONIX CORPORATION'),(206980513792,'Lightwav','LIGHTWAVE COMMUNICATIONS, INC.'),(206997291008,'Magicram','MagicRam, Inc.'),(207014068224,'OrientTe','ORIENT TELECOM CO., LTD.'),(207030845440,'SetEngin','SET ENGINEERING'),(207047622656,'Corning','Corning Incorporated'),(207064399872,'RmpElekt','RMP ELEKTRONIKSYSTEME GMBH'),(207081177088,'PackardB','Packard Bell Nec Services'),(207097954304,'Xcp','XCP, INC.'),(207114731520,'Softbook','SOFTBOOK PRESS'),(207131508736,'Maatel',''),(207148285952,'Powercom','PowerCom Technology'),(207165063168,'Onnto','ONNTO CORP.'),(207181840384,'Iva','IVA CORPORATION'),(207198617600,'Radcom','Radcom Ltd.'),(207215394816,'Turbocom','TurboComm Tech Inc.'),(207232172032,'Cisco','CISCO SYSTEMS, INC.'),(207248949248,'SaejinTM','SAEJIN T & M CO., LTD.'),(207265726464,'Detewe-D','DeTeWe-Deutsche Telephonwerke'),(207282503680,'IdreamTe','IDREAM TECHNOLOGIES, PTE. LTD.'),(207299280896,'Cradlepo','CradlePoint, Inc'),(207316058112,'VillageN','Village Networks, Inc. (VNI)'),(207332835328,'Controll','Controlled Electronic Manageme'),(207349612544,'NisseiEl','NISSEI ELECTRIC CO., LTD.'),(207366389760,'Supermic','Supermicro Computer, Inc.'),(207383166976,'BryantTe','BRYANT TECHNOLOGY, LTD.'),(207399944192,'Fraunhof','Fraunhofer IPMS'),(207416721408,'Orbacom','ORBACOM SYSTEMS, INC.'),(207433498624,'AppianCo','APPIAN COMMUNICATIONS, INC.'),(207450275840,'Esi',''),(207467053056,'BustecPr','BUSTEC PRODUCTION LTD.'),(207483830272,'PlanetTe','PLANET Technology Corporation'),(207500607488,'VersaTec','Versa Technology'),(207517384704,'OrbitAvi','ORBIT AVIONIC & COMMUNICATION'),(207534161920,'ElasticN','ELASTIC NETWORKS'),(207550939136,'Basler','Basler AG'),(207567716352,'Castlene','CASTLENET TECHNOLOGY, INC.'),(207584493568,'RenesasT','Renesas Technology America, Inc.'),(207601270784,'BeckIpc','Beck IPC GmbH'),(207618048000,'Qtelnet','QTelNet, Inc.'),(207634825216,'ApiMotio','API MOTION'),(207651602432,'KontronC','KONTRON COMPACT COMPUTERS AG'),(207668379648,'Telgen','TELGEN CORPORATION'),(207685156864,'Toko','Toko Inc.'),(207701934080,'SmarLabo','SMAR Laboratories Corp.'),(207718711296,'Digitra','DIGITRA SYSTEMS, INC.'),(207735488512,'AbelkoIn','Abelko Innovation'),(207752265728,'Hasselbl','Hasselblad'),(207769042944,'Powerfil','Powerfile, Inc.'),(207785820160,'Mobytel',''),(207802597376,'IpVideoN','IP Video Networks Inc'),(207819374592,'Santera','SANTERA SYSTEMS, INC.'),(207836151808,'AdlinkTe','ADLINK TECHNOLOGY, INC.'),(207852929024,'AppleCom','APPLE COMPUTER, INC.'),(207869706240,'Rfm',''),(207886483456,'BiostarM','BIOSTAR MICROTECH INT`L CORP.'),(207903260672,'Cybernet','CYBERNETICS TECH. CO., LTD.'),(207920037888,'ImpacctT','IMPACCT TECHNOLOGY CORP.'),(207936815104,'PentaMed','PENTA MEDIA CO., LTD.'),(207953592320,'Cmos','CMOS SYSTEMS, INC.'),(207970369536,'Hitex','Hitex Holding GmbH'),(207987146752,'LucentTe','LUCENT TECHNOLOGIES'),(208003923968,'HewlettP','HEWLETT PACKARD'),(208020701184,'SeyeonTe','SEYEON TECH. CO., LTD.'),(208037478400,'1net','1Net Corporation'),(208054255616,'Cisco','CISCO SYSTEMS, INC.'),(208071032832,'Intellib','Intellibyte Inc.'),(208087810048,'Internat','International Microsystems, In'),(208104587264,'Equiinet','EQUIINET LTD.'),(208121364480,'Adtech',''),(208138141696,'Akamba','Akamba Corporation'),(208154918912,'OnpremNe','ONPREM NETWORKS'),(208171696128,'Cisco','CISCO SYSTEMS, INC.'),(208188473344,'Cqos','CQOS, INC.'),(208205250560,'Advanced','Advanced Technology & Systems'),(208222027776,'Cisco','CISCO SYSTEMS, INC.'),(208238804992,'AdidSa','ADID SA'),(208255582208,'GreAmeri','GRE AMERICA, INC.'),(208272359424,'RedflexC','Redflex Communication Systems'),(208289136640,'Irlan','IRLAN LTD.'),(208305913856,'Cisco','CISCO SYSTEMS, INC.'),(208322691072,'AltosC&C','ALTOS C&C'),(208339468288,'TaihanEl','TAIHAN ELECTRIC WIRE CO., LTD.'),(208356245504,'Ivron','Ivron Systems'),(208373022720,'AlliedTe','ALLIED TELESYN INTERNAIONAL'),(208389799936,'Cisco','CISCO SYSTEMS, INC.'),(208406577152,'Transist','Transistor Devices, Inc.'),(208423354368,'VegaGrie','VEGA GRIESHABER KG'),(208440131584,'Ericsson',''),(208456908800,'Spectrap','Spectrapoint Wireless, LLC'),(208473686016,'NicotraS','NICOTRA SISTEMI S.P.A'),(208490463232,'BrixNetw','Brix Networks'),(208507240448,'Quantum','Quantum Corporation'),(208524017664,'Pinnacle','Pinnacle Systems, Inc.'),(208540794880,'CrossMat','CROSS MATCH TECHNOLOGIES, INC.'),(208557572096,'Micrilor','MICRILOR, Inc.'),(208574349312,'CyraTech','CYRA TECHNOLOGIES, INC.'),(208591126528,'TaiwanFi','TAIWAN FIRST LINE ELEC. CORP.'),(208607903744,'Modunorm','ModuNORM GmbH'),(208624680960,'SonnetTe','Sonnet Technologies, Inc'),(208641458176,'Cisco','CISCO SYSTEMS, INC.'),(208658235392,'ProcompI','Procomp Informatics, Ltd.'),(208675012608,'Cisco','CISCO SYSTEMS, INC.'),(208691789824,'Regin','AB Regin'),(208708567040,'GlobalCo','Global Converging Technologies'),(208725344256,'BoenigUn','BOENIG UND KALLENBACH OHG'),(208742121472,'AstroTer','ASTRO TERRA CORP.'),(208758898688,'Smartwar','Smartware'),(208775675904,'TimingAp','Timing Applications, Inc.'),(208792453120,'NimbleMi','Nimble Microsystems, Inc.'),(208809230336,'Workbit','WORKBIT CORPORATION.'),(208826007552,'AmberNet','AMBER NETWORKS'),(208842784768,'TycoSubm','TYCO SUBMARINE SYSTEMS, LTD.'),(208859561984,'Webgate','WEBGATE Inc.'),(208876339200,'Lightner','Lightner Engineering'),(208893116416,'Cisco','CISCO SYSTEMS, INC.'),(208909893632,'Woodwind','Woodwind Communications System'),(208926670848,'ActivePo','ACTIVE POWER'),(208943448064,'VianetTe','VIANET TECHNOLOGIES, LTD.'),(208960225280,'Schweitz','SCHWEITZER ENGINEERING'),(208977002496,'OlECommu','OL`E COMMUNICATIONS, INC.'),(208993779712,'Netivers','Netiverse, Inc.'),(209010556928,'AxusMicr','AXUS MICROSYSTEMS, INC.'),(209027334144,'DeltaNet','DELTA NETWORKS, INC.'),(209044111360,'SystemeL','Systeme Lauer GmbH & Co., Ltd.'),(209060888576,'Shanghai','SHANGHAI COMMUNICATION'),(209077665792,'TimesNSy','Times N System, Inc.'),(209094443008,'Honeywel','Honeywell GmbH'),(209111220224,'Converge','Convergenet Technologies'),(209127997440,'Trunknet',''),(209144774656,'L-3Sonom','L-3 Sonoma EO'),(209161551872,'SanValle','San Valley Systems, Inc.'),(209178329088,'Intersil','INTERSIL CORP.'),(209195106304,'TadiranM','Tadiran Microwave Networks'),(209211883520,'Cisco','CISCO SYSTEMS, INC.'),(209228660736,'Teletrol','Teletrol Systems, Inc.'),(209245437952,'Riverdel','RiverDelta Networks'),(209262215168,'Ectel',''),(209278992384,'Ac&TSyst','AC&T SYSTEM CO., LTD.'),(209295769600,'Cacheflo','CacheFlow, Inc.'),(209312546816,'Optronic','Optronic AG'),(209329324032,'BelkinCo','BELKIN COMPONENTS'),(209346101248,'City-Net','City-Net Technology, Inc.'),(209362878464,'Multidat','MULTIDATA GMBH'),(209379655680,'LaraTech','Lara Technology, Inc.'),(209396432896,'Hewlett-','HEWLETT-PACKARD'),(209413210112,'Comone',''),(209429987328,'Flueckig','FLUECKIGER ELEKTRONIK AG'),(209446764544,'CanonIma','Canon Imaging Systems Inc.'),(209463541760,'CadenceD','CADENCE DESIGN SYSTEMS'),(209480318976,'ControlS','CONTROL SOLUTIONS, INC.'),(209497096192,'Macromat','Macromate Corp.'),(209513873408,'GadLine','GAD LINE, LTD.'),(209530650624,'LuxnN','LuxN, N'),(209547427840,'Discover','Discovery Com'),(209564205056,'OmniFlow','OMNI FLOW COMPUTERS, INC.'),(209580982272,'TenorNet','Tenor Networks, Inc.'),(209597759488,'Conexant','CONEXANT SYSTEMS, INC.'),(209614536704,'Zaffire',''),(209631313920,'TwoTechn','TWO TECHNOLOGIES, INC.'),(209648091136,'Tellabs',''),(209664868352,'Inova','INOVA CORPORATION'),(209681645568,'WinTechn','WIN TECHNOLOGIES, CO., LTD.'),(209698422784,'AgilentT','Agilent Technologies'),(209715200000,'Aae','AAE Systems, Inc.'),(209731977216,'Dresearc','DResearch GmbH'),(209748754432,'MscVertr','MSC VERTRIEBS GMBH'),(209765531648,'Innovati','Innovative Systems, L.L.C.'),(209782308864,'Sitek',''),(209799086080,'Datacore','DATACORE SOFTWARE CORP.'),(209815863296,'Comtrend','COMTREND CO.'),(209832640512,'Mindread','Mindready Solutions, Inc.'),(209849417728,'Rightech','RIGHTECH CORPORATION'),(209866194944,'Indigita','INDIGITA CORPORATION'),(209882972160,'WagoKont','WAGO Kontakttechnik GmbH'),(209899749376,'Kb/TelTe','KB/TEL TELECOMUNICACIONES'),(209916526592,'OxfordSe','OXFORD SEMICONDUCTOR LTD.'),(209933303808,'NetworkE','Network Equipment Technologies, '),(209950081024,'Garnet','GARNET SYSTEMS CO., LTD.'),(209966858240,'SedonaNe','SEDONA NETWORKS CORP.'),(209983635456,'ChiyodaS','CHIYODA SYSTEM RIKEN'),(210000412672,'AmperDat','Amper Datos S.A.'),(210017189888,'DraegerM','Draeger Medical Systems, Inc.'),(210033967104,'CnfMobil','CNF MOBILE SOLUTIONS, INC.'),(210050744320,'Ensim','ENSIM CORP.'),(210067521536,'GmaCommu','GMA COMMUNICATION MANUFACT`G'),(210084298752,'Teraforc','TeraForce Technology Corporation'),(210101075968,'Turbonet','TURBONET COMMUNICATIONS, INC.'),(210117853184,'Borgardt',''),(210134630400,'ExpertMa','Expert Magnetics Corp.'),(210151407616,'DsgTechn','DSG Technology, Inc.'),(210168184832,'NeonTech','NEON TECHNOLOGY, INC.'),(210184962048,'UniformI','Uniform Industrial Corp.'),(210201739264,'AcctonTe','Accton Technology Corp.'),(210218516480,'Cisco','CISCO SYSTEMS, INC.'),(210235293696,'AtWorkCo','At Work Computers'),(210252070912,'StardotT','STARDOT TECHNOLOGIES'),(210268848128,'WildLab','Wild Lab. Ltd.'),(210285625344,'Securelo','SECURELOGIX CORPORATION'),(210302402560,'Ramix','RAMIX INC.'),(210319179776,'Dynapro','Dynapro Systems, Inc.'),(210335956992,'Sollae','Sollae Systems Co., Ltd.'),(210352734208,'Telica','TELICA, INC.'),(210369511424,'AzsTechn','AZS Technology AG'),(210386288640,'Terawave','Terawave Communications, Inc.'),(210403065856,'Integrat','INTEGRATED SYSTEMS DESIGN'),(210419843072,'Dsa','DSA GmbH'),(210436620288,'Datafab','DATAFAB SYSTEMS, INC.'),(220855271424,'Synapsen','SynapSense Corporation'),(227381608448,'RadicomR','Radicom Research, Inc.'),(228472127488,'Electro-','Electro-Metrics Corporation'),(236088983552,'ContiTem','Conti Temic microelectronic GmbH'),(236189646848,'Supervis','SuperVision'),(238051917824,'MurataMa','Murata Manufacturing Co., Ltd.'),(251658240000,'Cisco','CISCO SYSTEMS, INC.'),(251675017216,'Cisco','CISCO SYSTEMS, INC.'),(251691794432,'Cisco','CISCO SYSTEMS, INC.'),(251708571648,'Cisco','CISCO SYSTEMS, INC.'),(251725348864,'Cisco','CISCO SYSTEMS, INC.'),(251742126080,'NecAcces','NEC AccessTechnica, Ltd.'),(252044115968,'Bluebit','BlueBit Ltd.'),(261003149312,'WonwooEn','WONWOO Engineering Co., Ltd'),(263083524096,'Hattelan','Hatteland Computer AS'),(270062845952,'Apple','Apple, Inc.'),(274877906944,'PciCompo','PCI COMPONENTES DA AMZONIA LTD'),(274894684160,'ZeroOneT','Zero One Technology Co. Ltd.'),(274911461376,'Perle','PERLE SYSTEMS LIMITED'),(274928238592,'EmersonP','Emerson Process Management Power'),(274945015808,'Icm','ICM CO. LTD.'),(274961793024,'AniCommu','ANI COMMUNICATIONS INC.'),(274978570240,'SampoTec','SAMPO TECHNOLOGY CORPORATION'),(274995347456,'TelmatIn','TELMAT INFORMATIQUE'),(275012124672,'APlusInf','A PLUS INFO CORPORATION'),(275028901888,'Tachiban','TACHIBANA TECTRON CO., LTD.'),(275045679104,'PivotalT','PIVOTAL TECHNOLOGIES, INC.'),(275062456320,'Cresc',''),(275079233536,'GeneralM','GENERAL MICRO SYSTEMS, INC.'),(275096010752,'LannetDa','LANNET DATA COMMUNICATIONS,LTD'),(275112787968,'Memotec','MEMOTEC, INC.'),(275129565184,'DatacomT','DATACOM TECHNOLOGIES'),(275146342400,'Sonic','SONIC SYSTEMS, INC.'),(275163119616,'AndoverC','ANDOVER CONTROLS CORPORATION'),(275179896832,'Windata','WINDATA, INC.'),(275196674048,'NttDataC','NTT DATA COMM. SYSTEMS CORP.'),(275213451264,'Comsoft','COMSOFT GMBH'),(275230228480,'AscomInf','ASCOM INFRASYS AG'),(275247005696,'Adc-Glob','ADC - Global Connectivity Soluti'),(275263782912,'SilexTec','Silex Technology America'),(275280560128,'Adobe','ADOBE SYSTEMS, INC.'),(275297337344,'Aeon','AEON SYSTEMS, INC.'),(275314114560,'FujiElec','FUJI ELECTRIC CO., LTD.'),(275330891776,'Printer','PRINTER SYSTEMS CORP.'),(275347668992,'AstResea','AST RESEARCH, INC.'),(275364446208,'Invisibl','INVISIBLE SOFTWARE, INC.'),(275381223424,'Icc',''),(275398000640,'Colorgra','COLORGRAPH LTD'),(275414777856,'TeConnec','TE Connectivity Ltd.'),(275431555072,'RasterGr','RASTER GRAPHICS'),(275448332288,'KleverCo','KLEVER COMPUTERS, INC.'),(275465109504,'Logic','LOGIC CORPORATION'),(275481886720,'Compac','COMPAC INC.'),(275498663936,'Molecula','MOLECULAR DYNAMICS'),(275515441152,'Buffalo','Buffalo Inc.'),(275532218368,'SmcMassa','SMC MASSACHUSETTS, INC.'),(275548995584,'Netcomm','NETCOMM LIMITED'),(275565772800,'Compex',''),(275582550016,'Canoga-P','CANOGA-PERKINS'),(275599327232,'TrigemCo','TRIGEM COMPUTER, INC.'),(275616104448,'IsisDist','ISIS DISTRIBUTED SYSTEMS, INC.'),(275632881664,'HarrisAd','HARRIS ADACOM CORPORATION'),(275649658880,'Precisio','PRECISION SOFTWARE, INC.'),(275666436096,'XlntDesi','XLNT DESIGNS INC.'),(275683213312,'GkComput','GK COMPUTER'),(275699990528,'KokusaiE','KOKUSAI ELECTRIC CO., LTD'),(275716767744,'DigitalC','DIGITAL COMMUNICATIONS'),(275733544960,'AddtronT','ADDTRON TECHNOLOGY CO., LTD.'),(275750322176,'Bustek','BUSTEK CORPORATION'),(275767099392,'Opcom',''),(275783876608,'TribeCom','TRIBE COMPUTER WORKS, INC.'),(275800653824,'Sea-Ilan','SEA-ILAN, INC.'),(275817431040,'TalentEl','TALENT ELECTRIC INCORPORATED'),(275834208256,'OptecDai','OPTEC DAIICHI DENKO CO., LTD.'),(275850985472,'ImpactTe','IMPACT TECHNOLOGIES'),(275867762688,'Synerjet','SYNERJET INTERNATIONAL CORP.'),(275884539904,'Forks','FORKS, INC.'),(275901317120,'Teradata','Teradata Corporation'),(275918094336,'RasterOp','RASTER OPS CORPORATION'),(275934871552,'Ssangyon','SSANGYONG COMPUTER SYSTEMS'),(275951648768,'RingAcce','RING ACCESS, INC.'),(275968425984,'Fujikura','FUJIKURA LTD.'),(275985203200,'NAT','N.A.T. GMBH'),(276001980416,'NokiaSie','Nokia Siemens Networks GmbH & Co'),(276018757632,'QnixComp','QNIX COMPUTER CO., LTD.'),(276035534848,'Twinhead','TWINHEAD CORPORATION'),(276052312064,'UdcResea','UDC RESEARCH LIMITED'),(276069089280,'WindRive','WIND RIVER SYSTEMS'),(276085866496,'SmdInfor','SMD INFORMATICA S.A.'),(276102643712,'RocheDia','Roche Diagnostics International '),(276119420928,'WestAust','WEST AUSTRALIAN DEPARTMENT'),(276136198144,'MapleCom','MAPLE COMPUTER SYSTEMS'),(276152975360,'Hypertec','HYPERTEC PTY LTD.'),(276169752576,'Telecomm','TELECOMMUNICATIONS TECHNIQUES'),(276186529792,'Fluent','FLUENT, INC.'),(276203307008,'SpaceNav','SPACE & NAVAL WARFARE SYSTEMS'),(276220084224,'Ironics','IRONICS, INCORPORATED'),(276236861440,'Gracilis','GRACILIS, INC.'),(276253638656,'StarTech','STAR TECHNOLOGIES, INC.'),(276270415872,'AmproCom','AMPRO COMPUTERS'),(276287193088,'Connecti','CONNECTION MACHINES SERVICES'),(276303970304,'Metronix','METRONIX GMBH'),(276320747520,'McmJapan','MCM JAPAN LTD.'),(276337524736,'Lockheed','LOCKHEED - SANDERS'),(276354301952,'Kronos','KRONOS, INC.'),(276371079168,'YoshidaK','YOSHIDA KOGYO K. K.'),(276387856384,'Goldstar','GOLDSTAR INFORMATION & COMM.'),(276404633600,'Funasset','FUNASSET LIMITED'),(276421410816,'Future','FUTURE SYSTEMS, INC.'),(276438188032,'Star-Tek','STAR-TEK, INC.'),(276454965248,'NorthHil','NORTH HILLS ISRAEL'),(276471742464,'AfeCompu','AFE COMPUTERS LTD.'),(276488519680,'Comendec','COMENDEC LTD'),(276505296896,'Datatech','DATATECH ENTERPRISES CO., LTD.'),(276522074112,'E-System','E-SYSTEMS, INC./GARLAND DIV.'),(276538851328,'ViaTechn','VIA TECHNOLOGIES, INC.'),(276555628544,'KlaInstr','KLA INSTRUMENTS CORPORATION'),(276572405760,'GteSpace','GTE SPACENET'),(276589182976,'HitachiC','HITACHI CABLE, LTD.'),(276605960192,'Omnibyte','OMNIBYTE CORPORATION'),(276622737408,'Extended','EXTENDED SYSTEMS'),(276639514624,'Lemcom','LEMCOM SYSTEMS, INC.'),(276656291840,'KentekIn','KENTEK INFORMATION SYSTEMS,INC'),(276673069056,'Sysgen',''),(276689846272,'Coperniq','COPERNIQUE'),(276706623488,'Lanco','LANCO, INC.'),(276723400704,'Corollar','COROLLARY, INC.'),(276740177920,'SyncRese','SYNC RESEARCH INC.'),(276756955136,'Interwar','INTERWARE CO., LTD.'),(276773732352,'AtmCompu','ATM COMPUTER GMBH'),(276790509568,'AppliedI','Applied Innovation Inc.'),(276807286784,'BassAsso','BASS ASSOCIATES'),(276824064000,'CableAnd','CABLE AND WIRELESS'),(276840841216,'TattileS','Tattile SRL'),(276857618432,'SunConve','Sun Conversion Technologies'),(276874395648,'MaxtonTe','MAXTON TECHNOLOGY CORPORATION'),(276891172864,'WearnesA','WEARNES AUTOMATION PTE LTD'),(276907950080,'JukoManu','JUKO MANUFACTURE COMPANY, LTD.'),(276924727296,'SocieteD','SOCIETE D`EXPLOITATION DU CNIT'),(276941504512,'Scientif','SCIENTIFIC ATLANTA'),(276958281728,'Qume','QUME CORPORATION'),(276975058944,'Extensio','EXTENSION TECHNOLOGY CORP.'),(276991836160,'Evergree','EVERGREEN SYSTEMS, INC.'),(277008613376,'Flir','FLIR Systems'),(277025390592,'Athenix','ATHENIX CORPORATION'),(277042167808,'Mannesma','MANNESMANN SCANGRAPHIC GMBH'),(277058945024,'Laborato','LABORATORY EQUIPMENT CORP.'),(277075722240,'TdaIndus','TDA INDUSTRIA DE PRODUTOS'),(277092499456,'Honeywel','HONEYWELL ACS'),(277109276672,'SaabInst','SAAB INSTRUMENTS AB'),(277126053888,'MichelsK','MICHELS & KLEBERHOFF COMPUTER'),(277142831104,'Ubitrex','UBITREX CORPORATION'),(277159608320,'MobiusTe','MOBIUS TECHNOLOGIES, INC.'),(277176385536,'Meidensh','MEIDENSHA CORPORATION'),(277193162752,'TpsTelep','TPS TELEPROCESSING SYS. GMBH'),(277209939968,'Raylan','RAYLAN CORPORATION'),(277226717184,'AxisComm','AXIS COMMUNICATIONS AB'),(277243494400,'Goodyear','THE GOODYEAR TIRE & RUBBER CO.'),(277260271616,'TattileS','Tattile SRL'),(277277048832,'Wm-DataM','WM-DATA MINFO AB'),(277293826048,'AnselCom','ANSEL COMMUNICATIONS'),(277310603264,'ProcompI','PROCOMP INDUSTRIA ELETRONICA'),(277327380480,'AspCompu','ASP COMPUTER PRODUCTS, INC.'),(277344157696,'PaxdataN','PAXDATA NETWORKS LTD.'),(277360934912,'Shograph','SHOGRAPHICS, INC.'),(277377712128,'RPTInter','R.P.T. INTERGROUPS INT`L LTD.'),(277394489344,'Aironet','Cisco Systems, Inc.'),(277411266560,'DatexDiv','DATEX DIVISION OF'),(277428043776,'Dressler','DRESSLER GMBH & CO.'),(277444820992,'Newgen','NEWGEN SYSTEMS CORP.'),(277461598208,'NetworkE','NETWORK EXPRESS, INC.'),(277478375424,'HalCompu','HAL COMPUTER SYSTEMS INC.'),(277495152640,'Transwar','TRANSWARE'),(277511929856,'Digiboar','DIGIBOARD, INC.'),(277528707072,'Concurre','CONCURRENT TECHNOLOGIES  LTD.'),(277545484288,'Telco','Telco Systems, Inc.'),(277562261504,'Goldstar','GOLDSTAR CO., LTD.'),(277579038720,'ErgoComp','ERGO COMPUTING'),(277595815936,'Kingstar','KINGSTAR TECHNOLOGY INC.'),(277612593152,'Microuni','MICROUNITY SYSTEMS ENGINEERING'),(277629370368,'RoseElec','ROSE ELECTRONICS'),(277646147584,'Clinicom','CLINICOMP INTL.'),(277662924800,'Cray','Cray, Inc.'),(277679702016,'ItautecP','ITAUTEC PHILCO S.A.'),(277696479232,'ImfInter','IMF INTERNATIONAL LTD.'),(277713256448,'Datacom','DATACOM INC.'),(277730033664,'ValmetAu','VALMET AUTOMATION INC.'),(277746810880,'RolandDg','ROLAND DG CORPORATION'),(277763588096,'SuperWor','SUPER WORKSTATION, INC.'),(277780365312,'SmaRegel','SMA REGELSYSTEME GMBH'),(277797142528,'DeltaCon','DELTA CONTROLS, INC.'),(277813919744,'DigitalP','DIGITAL PRODUCTS, INC.'),(277830696960,'BytexEng','BYTEX CORPORATION, ENGINEERING'),(277847474176,'Codonics','CODONICS INC.'),(277864251392,'Systemfo','SYSTEMFORSCHUNG'),(277881028608,'Partech','ParTech Inc.'),(277897805824,'NextcomK','NEXTCOM K.K.'),(277914583040,'VideoTec','VIDEO TECHNOLOGY COMPUTERS LTD'),(277931360256,'Computer','COMPUTERM  CORPORATION'),(277948137472,'StealthC','STEALTH COMPUTER SYSTEMS'),(277964914688,'IdeaAsso','IDEA ASSOCIATES'),(277981691904,'MacqElec','MACQ ELECTRONIQUE SA'),(277998469120,'AlliantC','ALLIANT COMPUTER SYSTEMS CORP.'),(278015246336,'Goldstar','GOLDSTAR CABLE CO., LTD.'),(278032023552,'Algorith','ALGORITHMICS LTD.'),(278048800768,'Starligh','STARLIGHT NETWORKS, INC.'),(278065577984,'BoeingDe','BOEING DEFENSE & SPACE'),(278082355200,'ChannelI','CHANNEL SYSTEMS INTERN`L INC.'),(278099132416,'VistaCon','VISTA CONTROLS CORPORATION'),(278115909632,'Bizerba-','BIZERBA-WERKE WILHEIM KRAUT'),(278132686848,'AppliedC','APPLIED COMPUTING DEVICES'),(278149464064,'FischerA','FISCHER AND PORTER CO.'),(278166241280,'KinkeiSy','KINKEI SYSTEM CORPORATION'),(278183018496,'MicomCom','MICOM COMMUNICATIONS INC.'),(278199795712,'Fibernet','FIBERNET RESEARCH, INC.'),(278216572928,'RubyTech','RUBY TECH CORPORATION'),(278233350144,'MilanTec','MILAN TECHNOLOGY CORPORATION'),(278250127360,'Ncube',''),(278266904576,'FirstInt','FIRST INTERNAT`L COMPUTER, INC'),(278283681792,'LanwanTe','LANWAN TECHNOLOGIES'),(278300459008,'SilcomMa','SILCOM MANUF`G TECHNOLOGY INC.'),(278317236224,'TeraMicr','TERA MICROSYSTEMS, INC.'),(278334013440,'Net-Sour','NET-SOURCE, INC.'),(278350790656,'Strawber','STRAWBERRY TREE, INC.'),(278367567872,'MitacInt','MITAC INTERNATIONAL CORP.'),(278384345088,'FukudaDe','FUKUDA DENSHI CO., LTD.'),(278401122304,'Pagine','PAGINE CORPORATION'),(278417899520,'Kimpsion','KIMPSION INTERNATIONAL CORP.'),(278434676736,'GageTalk','GAGE TALKER CORP.'),(278451453952,'Sartoriu','Sartorius Mechatronics T&H GmbH'),(278468231168,'Locamati','LOCAMATION B.V.'),(278485008384,'StudioGe','STUDIO GEN INC.'),(278501785600,'OceanOff','OCEAN OFFICE AUTOMATION LTD.'),(278518562816,'American','AMERICAN MEGATRENDS INC.'),(278535340032,'Telspec','TELSPEC LTD'),(278552117248,'Advanced','ADVANCED TECHNICAL SOLUTIONS'),(278568894464,'TritecEl','TRITEC ELECTRONIC GMBH'),(278585671680,'HongTech','HONG TECHNOLOGIES'),(278602448896,'ElsagDat','Elsag Datamat spa'),(278619226112,'Digalog','DIGALOG SYSTEMS, INC.'),(278636003328,'Atomwide','ATOMWIDE LTD.'),(278652780544,'MarnerIn','MARNER INTERNATIONAL, INC.'),(278669557760,'MesaRidg','MESA RIDGE TECHNOLOGIES, INC.'),(278686334976,'Quin','QUIN SYSTEMS LTD'),(278703112192,'E-MTechn','E-M TECHNOLOGY, INC.'),(278719889408,'Sybus','SYBUS CORPORATION'),(278736666624,'CAEN','C.A.E.N.'),(278753443840,'ArnosIns','ARNOS INSTRUMENTS & COMPUTER'),(278770221056,'CharlesR','CHARLES RIVER DATA SYSTEMS,INC'),(278786998272,'Accord','ACCORD SYSTEMS, INC.'),(278803775488,'PlainTre','PLAIN TREE SYSTEMS INC'),(278820552704,'MartinMa','MARTIN MARIETTA CORPORATION'),(278837329920,'MikasaSy','MIKASA SYSTEM ENGINEERING'),(278854107136,'NetworkC','NETWORK CONTROLS INT`NATL INC.'),(278870884352,'Optimem',''),(278887661568,'Hypercom','HYPERCOM, INC.'),(278904438784,'Microbra','MicroBrain,Inc.'),(278921216000,'ChuoElec','CHUO ELECTRONICS CO., LTD.'),(278937993216,'JanichKl','JANICH & KLASS COMPUTERTECHNIK'),(278954770432,'Netcor',''),(278971547648,'CameoCom','CAMEO COMMUNICATIONS, INC.'),(278988324864,'OemEngin','OEM ENGINES'),(279005102080,'KatronCo','KATRON COMPUTERS INC.'),(279021879296,'Polaroid','Polaroid Corporation'),(279038656512,'Systemha','SYSTEMHAUS DISCOM'),(279055433728,'Combinet',''),(279072210944,'Microboa','MICROBOARDS, INC.'),(279088988160,'CascadeC','CASCADE COMMUNICATIONS CORP.'),(279105765376,'IbrCompu','IBR COMPUTER TECHNIK GMBH'),(279122542592,'Lxe',''),(279139319808,'SymplexC','SYMPLEX COMMUNICATIONS'),(279156097024,'Telebit','TELEBIT CORPORATION'),(282192773120,'WuxiZhon','Wuxi Zhongxing Optoelectronics T'),(284843573248,'RlxTechn','RLX Technologies'),(292040998912,'KetronSR','KETRON S.R.L.'),(296369520640,'VersusTe','Versus Technology, Inc.'),(301906001920,'HuaweiTe','HUAWEI TECHNOLOGIES CO.,LTD'),(310646931456,'DigitalS','Digital SemiConductor		21143/2 b'),(331551342592,'AndonHea','Andon Health Co.,Ltd.'),(340527153152,'Realtek',''),(340560707584,'PineTech','Pine Technology Ltd.'),(343597383680,'NexoComm','NEXO COMMUNICATIONS, INC.'),(343614160896,'Yamashit','YAMASHITA SYSTEMS CORP.'),(343630938112,'Omnisec','OMNISEC AG'),(343647715328,'Xrite','Xrite Inc'),(343664492544,'3com','3COM CORPORATION'),(343698046976,'Tac','TAC AB'),(343714824192,'SiemensT','SIEMENS TELECOMMUNICATION SYSTEM'),(343731601408,'TivaMicr','TIVA MICROCOMPUTER CORP. (TMC)'),(343748378624,'PhilipsB','PHILIPS BROADBAND NETWORKS'),(343765155840,'IrisTech','IRIS TECHNOLOGIES, INC.'),(343781933056,'Cisco','CISCO SYSTEMS, INC.'),(343798710272,'E-TekLab','e-Tek Labs, Inc.'),(343815487488,'SatoriEl','SATORI ELECTORIC CO., LTD.'),(343832264704,'Chromati','CHROMATIS NETWORKS, INC.'),(343849041920,'Cisco','CISCO SYSTEMS, INC.'),(343865819136,'NovanetL','NovaNET Learning, Inc.'),(343899373568,'Cbl-','CBL - GMBH'),(343916150784,'Chaparra','Chaparral Network Storage'),(343932928000,'Cisco','CISCO SYSTEMS, INC.'),(343949705216,'BrightSt','BRIGHT STAR ENGINEERING'),(343966482432,'Sst/Wood','SST/WOODHEAD INDUSTRIES'),(343983259648,'RsrSRL','RSR S.R.L.'),(344000036864,'Amit','AMIT, Inc.'),(344016814080,'SpringTi','SPRING TIDE NETWORKS, INC.'),(344033591296,'Iqinvisi','IQinVision'),(344050368512,'AblCanad','ABL CANADA, INC.'),(344067145728,'Jatom','JATOM SYSTEMS, INC.'),(344100700160,'MirandaT','Miranda Technologies, Inc.'),(344117477376,'Mrg','MRG SYSTEMS, LTD.'),(344134254592,'Mediasta','MEDIASTAR CO., LTD.'),(344151031808,'EisInter','EIS INTERNATIONAL, INC.'),(344167809024,'ZonetTec','ZONET TECHNOLOGY, INC.'),(344184586240,'PgDesign','PG DESIGN ELECTRONICS, INC.'),(344201363456,'Navic','NAVIC SYSTEMS, INC.'),(344234917888,'Cosystem','COSYSTEMS, INC.'),(344251695104,'Genicom','GENICOM CORPORATION'),(344268472320,'AvalComm','AVAL COMMUNICATIONS'),(344285249536,'1394Prin','1394 PRINTER WORKING GROUP'),(344302026752,'Cisco','CISCO SYSTEMS, INC.'),(344318803968,'Genrad','GENRAD LTD.'),(344335581184,'SoyoComp','SOYO COMPUTER, INC.'),(344352358400,'Accel','ACCEL, INC.'),(344369135616,'Cambex','CAMBEX CORPORATION'),(344385912832,'Tollbrid','TollBridge Technologies, Inc.'),(344402690048,'FuturePl','FUTURE PLUS SYSTEMS'),(344419467264,'Aeroflex','AEROFLEX LABORATORIES, INC.'),(344436244480,'PicazoCo','PICAZO COMMUNICATIONS, INC.'),(344453021696,'MayanNet','MAYAN NETWORKS'),(344503353344,'Netcam','NETCAM, LTD.'),(344520130560,'KogaElec','KOGA ELECTRONICS CO.'),(344536907776,'DainTele','DAIN TELECOM CO., LTD.'),(344553684992,'MarinerN','MARINER NETWORKS'),(344570462208,'DatongEl','DATONG ELECTRONICS LTD.'),(344587239424,'Mediafir','MEDIAFIRE CORPORATION'),(344604016640,'Tsinghua','TSINGHUA NOVEL ELECTRONICS'),(344637571072,'Cisco','CISCO SYSTEMS, INC.'),(344654348288,'AnchorGa','ANCHOR GAMES'),(344671125504,'Panasoni','Panasonic Electric Works Co., Lt'),(344687902720,'Coretron','Coretronic Corporation'),(344704679936,'SciManuf','SCI MANUFACTURING SINGAPORE PTE,'),(344721457152,'MarvellS','MARVELL SEMICONDUCTOR, INC.'),(344738234368,'Asaca','ASACA CORPORATION'),(344755011584,'Rioworks','RIOWORKS SOLUTIONS, INC.'),(344771788800,'MenicxIn','MENICX INTERNATIONAL CO., LTD.'),(344788566016,'Private',''),(344805343232,'Infolibr','INFOLIBRIA'),(344822120448,'ArborNet','Arbor Networks Inc'),(344838897664,'EltecoAS','ELTECO A.S.'),(344855674880,'Barconet','BARCONET N.V.'),(344872452096,'GalilMot','Galil Motion Control'),(344889229312,'TokyoEle','Tokyo Electron Device Limited'),(344906006528,'SierraMo','SIERRA MONITOR CORP.'),(344922783744,'OlencomE','OLENCOM ELECTRONICS'),(344939560960,'Cisco','CISCO SYSTEMS, INC.'),(344956338176,'IwatsuEl','IWATSU ELECTRIC CO., LTD.'),(344973115392,'TiaraNet','TIARA NETWORKS, INC.'),(344989892608,'Cisco','CISCO SYSTEMS, INC.'),(345006669824,'Cisco','CISCO SYSTEMS, INC.'),(345023447040,'Doms','DOMS A/S'),(345040224256,'Vmware','VMware, Inc.'),(345057001472,'Broadban','BROADBAND ACCESS SYSTEMS'),(345073778688,'Vegastre','VegaStream Group Limted'),(345090555904,'Ibahn',''),(345107333120,'NetworkA','NETWORK ALCHEMY, INC.'),(345124110336,'Kawasaki','KAWASAKI LSI U.S.A., INC.'),(345140887552,'Tundo','TUNDO CORPORATION'),(345174441984,'DigitekM','DIGITEK MICROLOGIC S.A.'),(345191219200,'BrandInn','BRAND INNOVATORS'),(345207996416,'Tandberg','TANDBERG TELECOM AS'),(345241550848,'KouwellE','KOUWELL ELECTRONICS CORP.  **'),(345258328064,'OyComsel','OY COMSEL SYSTEM AB'),(345275105280,'CaeElect','CAE ELECTRONICS'),(345291882496,'Tdk-Lamb','TDK-Lambda Corporation'),(345308659712,'AtecomAd','AtecoM GmbH advanced telecomunic'),(345325436928,'Aerocomm','AEROCOMM, INC.'),(345342214144,'Electron','ELECTRONIC INDUSTRIES ASSOCIATIO'),(345358991360,'Pixstrea','PixStream Incorporated'),(345375768576,'Edeva','EDEVA, INC.'),(345392545792,'Spx-Ateg',''),(345409323008,'BeijerEl','Beijer Electronics Products AB'),(345426100224,'Videojet','VIDEOJET SYSTEMS'),(345442877440,'CorderEn','CORDER ENGINEERING CORPORATION'),(345459654656,'G-Connec','G-CONNECT'),(345476431872,'Chaintec','CHAINTECH COMPUTER CO., LTD.'),(345493209088,'Aiwa','AIWA CO., LTD.'),(345509986304,'Corvis','CORVIS CORPORATION'),(345526763520,'Cisco','CISCO SYSTEMS, INC.'),(345543540736,'Advanced','ADVANCED HI-TECH CORP.'),(345560317952,'KestrelS','KESTREL SOLUTIONS'),(345577095168,'Ibm','IBM Corp'),(345593872384,'Prolific','PROLIFIC TECHNOLOGY, INC.'),(345610649600,'MegatonH','MEGATON HOUSE, LTD.'),(345627426816,'Private',''),(345644204032,'Xpeed','XPEED, INC.'),(345660981248,'MerlotCo','MERLOT COMMUNICATIONS'),(345677758464,'Videocon','VIDEOCON AG'),(345694535680,'Ifp',''),(345711312896,'NewerTec','NEWER TECHNOLOGY'),(345728090112,'Draytek','DrayTek Corp.'),(345744867328,'Cisco','CISCO SYSTEMS, INC.'),(345761644544,'MurataMa','MURATA MACHINERY, LTD.'),(345778421760,'Foresson','FORESSON CORPORATION'),(345795198976,'Gilbarco','GILBARCO, INC.'),(345811976192,'AtlProdu','ATL PRODUCTS'),(345845530624,'TelkomSa','TELKOM SA, LTD.'),(345862307840,'Terasaki','TERASAKI ELECTRIC CO., LTD.'),(345879085056,'Amano','AMANO CORPORATION'),(345895862272,'SafetyMa','SAFETY MANAGEMENT SYSTEMS'),(345929416704,'Hewlett-','Hewlett-Packard Company'),(345946193920,'Rsi','RSI SYSTEMS'),(345962971136,'AbitComp','ABIT COMPUTER CORPORATION'),(345979748352,'Optimati','OPTIMATION, INC.'),(345996525568,'AsitaTec','ASITA TECHNOLOGIES INT`L LTD.'),(346013302784,'Dctri',''),(346030080000,'Netacces','NETACCESS, INC.'),(346046857216,'RigakuIn','RIGAKU INDUSTRIAL CORPORATION'),(346063634432,'Boeing',''),(346080411648,'Pace','PACE plc'),(346097188864,'PeracomN','PERACOM NETWORKS'),(346113966080,'SalixTec','SALIX TECHNOLOGIES, INC.'),(346130743296,'Mmc-Embe','MMC-EMBEDDED COMPUTERTECHNIK Gmb'),(346147520512,'Globaloo','GLOBALOOP, LTD.'),(346164297728,'3comEuro','3COM EUROPE, LTD.'),(346181074944,'TagElect','TAG ELECTRONIC SYSTEMS'),(346197852160,'Switchco','SWITCHCORE AB'),(346214629376,'BetaRese','BETA RESEARCH'),(346231406592,'Industre','THE INDUSTREE B.V.'),(346248183808,'LesTechn','Les Technologies SoftAcoustik In'),(346264961024,'HorizonC','HORIZON COMPUTER'),(346281738240,'DeltaCom','DELTA COMPUTER SYSTEMS, INC.'),(346298515456,'CarloGav','CARLO GAVAZZI, INC.'),(346315292672,'Cisco','CISCO SYSTEMS, INC.'),(346332069888,'Transmed','TransMedia Communications, Inc.'),(346348847104,'IoTech','IO TECH, INC.'),(346365624320,'CapitolB','CAPITOL BUSINESS SYSTEMS, LTD.'),(346382401536,'Optronic','OPTRONICS'),(346399178752,'Cisco','CISCO SYSTEMS, INC.'),(346415955968,'Opencon','OpenCon Systems, Inc.'),(346432733184,'MoldatWi','MOLDAT WIRELESS TECHNOLGIES'),(346449510400,'KonicaMi','KONICA MINOLTA HOLDINGS, INC.'),(346466287616,'Naltec','NALTEC, Inc.'),(346483064832,'MapleCom','MAPLE COMPUTER CORPORATION'),(346499842048,'Communiq','CommUnique Wireless Corp.'),(346516619264,'Fdk','FDK Co., Ltd'),(346533396480,'Intergon','INTERGON, INC.'),(346550173696,'Technolo','TECHNOLOGY ATLANTA CORPORATION'),(346566950912,'Giddings','GIDDINGS & LEWIS'),(346583728128,'Brodel','BRODEL GmbH'),(346600505344,'Voiceboa','VOICEBOARD CORPORATION'),(346617282560,'Satchwel','SATCHWELL CONTROL SYSTEMS, LTD'),(346634059776,'Fichet-B','FICHET-BAUCHE'),(346650836992,'GoodWayI','GOOD WAY IND. CO., LTD.'),(346667614208,'BoserTec','BOSER TECHNOLOGY CO., LTD.'),(346684391424,'InovaCom','INOVA COMPUTERS GMBH & CO. KG'),(346701168640,'XitronTe','XITRON TECHNOLOGIES, INC.'),(346717945856,'D-Link',''),(346734723072,'CmsTechn','CMS TECHNOLOGIES'),(346751500288,'HammerSt','HAMMER STORAGE SOLUTIONS'),(346768277504,'Cisco','CISCO SYSTEMS, INC.'),(346785054720,'FastMult','FAST MULTIMEDIA AG'),(346801831936,'Metallig','Metalligence Technology Corp.'),(346818609152,'Gatan','GATAN, INC.'),(346835386368,'GemflexN','GEMFLEX NETWORKS, LTD.'),(346852163584,'TLS','T.L.S. Corp.'),(346885718016,'Imd',''),(346902495232,'AdsTechn','ADS Technologies, Inc'),(346919272448,'LoopTele','LOOP TELECOMMUNICATION INTERNATI'),(346952826880,'Addonics','Addonics Technologies, Inc.'),(346969604096,'MasproDe','MASPRO DENKOH CORP.'),(346986381312,'NetToNet','NET TO NET TECHNOLOGIES'),(347003158528,'Jetter',''),(347019935744,'Xyratex',''),(347036712960,'Digiansw','DIGIANSWER A/S'),(347053490176,'LgIntern','LG INTERNATIONAL CORP.'),(347070267392,'VanlinkC','VANLINK COMMUNICATION TECHNOLOGY'),(347087044608,'Minerva','MINERVA SYSTEMS'),(347103821824,'Cisco','CISCO SYSTEMS, INC.'),(347120599040,'CmcElect','CMC Electronics Inc'),(347137376256,'DigitalA','DIGITAL AUDIO PROCESSING PTY. LT'),(347154153472,'JoohongI','JOOHONG INFORMATION &'),(347170930688,'Ad','AD SYSTEMS CORP.'),(347187707904,'AtlasCop','ATLAS COPCO TOOLS AB'),(347204485120,'Telstrat',''),(347221262336,'UnicornC','UNICORN COMPUTER CORP.'),(347238039552,'Engetron','ENGETRON-ENGENHARIA ELETRONICA I'),(347254816768,'3com','3COM CORPORATION'),(347271593984,'Contempo','CONTEMPORARY CONTROL'),(347288371200,'TasTelef','TAS TELEFONBAU A. SCHWABE GMBH &'),(347305148416,'SerraSol','SERRA SOLDADURA, S.A.'),(347321925632,'Signum','SIGNUM SYSTEMS CORP.'),(347338702848,'Airfiber','AirFiber, Inc.'),(347372257280,'NsTechEl','NS TECH ELECTRONICS SDN BHD'),(347389034496,'Cisco','CISCO SYSTEMS, INC.'),(347405811712,'Motorola','Motorola, Inc.'),(347422588928,'AppleCom','APPLE COMPUTER, INC.'),(347456143360,'Hakusan','HAKUSAN CORPORATION'),(347472920576,'Paradise','PARADISE INNOVATIONS (ASIA)'),(347489697792,'Nomadix','NOMADIX INC.'),(347523252224,'XelCommu','XEL COMMUNICATIONS, INC.'),(347540029440,'Alpha-To','ALPHA-TOP CORPORATION'),(347556806656,'Olicom','OLICOM A/S'),(347573583872,'AndaNetw','ANDA NETWORKS'),(347590361088,'TekDigit','TEK DIGITEL CORPORATION'),(347607138304,'SpeSyste','SPE Systemhaus GmbH'),(347623915520,'Cisco','CISCO SYSTEMS, INC.'),(347640692736,'Intel','Intel Corporation'),(347657469952,'Microsof','MICROSOFT CORP.'),(347674247168,'GlobalNe','GLOBAL NET INFORMATION CO., Ltd.'),(347691024384,'Sigmatek','SIGMATEK GMBH & CO. KG'),(347724578816,'Pan-Inte','PAN-INTERNATIONAL INDUSTRIAL COR'),(347741356032,'VentureM','VENTURE MANUFACTURING (SINGAPORE'),(347758133248,'EntregaT','ENTREGA TECHNOLOGIES, INC.'),(347774910464,'Sensorma','SENSORMATIC ACD'),(347791687680,'Oxtel','OXTEL, LTD.'),(347808464896,'VskElect','VSK ELECTRONICS'),(347825242112,'EdimaxTe','EDIMAX TECHNOLOGY CO., LTD.'),(347842019328,'Visionco','VISIONCOMM CO., LTD.'),(347858796544,'PctvnetA','PCTVnet ASA'),(347875573760,'HakkoEle','HAKKO ELECTRONICS CO., LTD.'),(352589971456,'WuxiKebo','Wuxi Keboda Electron Co.Ltd'),(363713265664,'Continen','Continental Automotive Systems I'),(365072220160,'Xerox',''),(382369529856,'Lenovoem','LenovoEMC Products USA, LLC'),(398106558464,'GospellD','Gospell DIGITAL TECHNOLOGY CO., '),(399482290176,'Xilinx','Xilinx, Inc'),(412316860416,'Xycom','XYCOM INC.'),(412333637632,'Innosys','InnoSys, Inc.'),(412350414848,'ScreenSu','SCREEN SUBTITLING SYSTEMS, LTD'),(412367192064,'TeraokaW','TERAOKA WEIGH SYSTEM PTE, LTD.'),(412383969280,'Computad','COMPUTADORES MODULARES SA'),(412400746496,'Feedback','FEEDBACK DATA LTD.'),(412417523712,'Sotec','SOTEC CO., LTD'),(412434300928,'AcresGam','ACRES GAMING, INC.'),(412451078144,'3com','3COM CORPORATION'),(412467855360,'Cisco','CISCO SYSTEMS, INC.'),(412484632576,'SordComp','SORD COMPUTER CORPORATION'),(412501409792,'Logware','LOGWARE GmbH'),(412518187008,'Eurotech','Eurotech Inc.'),(412534964224,'DigitalL','Digital Logic GmbH'),(412551741440,'WavenetI','WAVENET INTERNATIONAL, INC.'),(412568518656,'Westell','WESTELL, INC.'),(412585295872,'NetworkM','NETWORK MACHINES, INC.'),(412602073088,'CrystalS','CRYSTAL SEMICONDUCTOR CORP.'),(412618850304,'PowerCom','POWER COMPUTING CORPORATION'),(412635627520,'NetstalM','NETSTAL MASCHINEN AG'),(412652404736,'Edec','EDEC CO., LTD.'),(412669181952,'Net2net','NET2NET CORPORATION'),(412685959168,'Clariion',''),(412702736384,'Tokimec','TOKIMEC INC.'),(412719513600,'StellarO','STELLAR ONE CORPORATION'),(412736290816,'RocheDia','Roche Diagnostics'),(412753068032,'Keithley','KEITHLEY INSTRUMENTS'),(412769845248,'MesaElec','MESA ELECTRONICS'),(412786622464,'Telxon','TELXON CORPORATION'),(412803399680,'LucentTe','LUCENT TECHNOLOGIES'),(412820176896,'Softlab','SOFTLAB, INC.'),(412836954112,'Stallion','STALLION TECHNOLOGIES'),(412853731328,'PivotalN','PIVOTAL NETWORKING, INC.'),(412870508544,'Dsc','DSC CORPORATION'),(412887285760,'Vicom','VICOM SYSTEMS, INC.'),(412904062976,'PericomS','PERICOM SEMICONDUCTOR CORP.'),(412920840192,'Gradient','GRADIENT TECHNOLOGIES, INC.'),(412937617408,'ActiveIm','ACTIVE IMAGING PLC'),(412954394624,'VikingMo','VIKING Modular Solutions'),(412971171840,'Superior','Superior Modular Products'),(412987949056,'Macrovis','MACROVISION CORPORATION'),(413004726272,'CaryPeri','CARY PERIPHERALS INC.'),(413021503488,'Symicron','SYMICRON COMPUTER COMMUNICATIONS'),(413038280704,'PeakAudi','PEAK AUDIO'),(413055057920,'LinxData','LINX Data Terminals, Inc.'),(413071835136,'AlertonT','ALERTON TECHNOLOGIES, INC.'),(413088612352,'Cyclades','CYCLADES CORPORATION'),(413105389568,'Cisco','CISCO SYSTEMS, INC.'),(413122166784,'VillageT','VILLAGE TRONIC ENTWICKLUNG'),(413138944000,'Hrk','HRK SYSTEMS'),(413155721216,'I-Cube','I-CUBE, INC.'),(413172498432,'AcuityIm','ACUITY IMAGING, INC.'),(413189275648,'RobertBo','ROBERT BOSCH GmbH'),(413206052864,'DallasSe','DALLAS SEMICONDUCTOR, INC.'),(413222830080,'AitAustr','AIT Austrian Institute of Techno'),(413239607296,'NxpSemic','NXP Semiconductors'),(413256384512,'NortelNe','Nortel Networks'),(413273161728,'SancomTe','SanCom Technology, Inc.'),(413289938944,'QuickCon','QUICK CONTROLS LTD.'),(413306716160,'Amtec','AMTEC spa'),(413323493376,'Hagiwara','HAGIWARA SYS-COM CO., LTD.'),(413340270592,'3cx',''),(413357047808,'Cisco','CISCO SYSTEMS, INC.'),(413373825024,'Patapsco','PATAPSCO DESIGNS'),(413390602240,'Netro','NETRO CORP.'),(413407379456,'Yokogawa','Yokogawa Electric Corporation'),(413424156672,'TksUsa','TKS (USA), INC.'),(413440933888,'Idirect','iDirect, INC.'),(413457711104,'Litton/P','LITTON/POLY-SCIENTIFIC'),(413474488320,'Pathligh','PATHLIGHT TECHNOLOGIES'),(413491265536,'Vmetro','VMETRO, INC.'),(413508042752,'Cisco','CISCO SYSTEMS, INC.'),(413524819968,'Emc','EMC CORPORATION'),(413541597184,'VinaTech','VINA TECHNOLOGIES'),(413558374400,'SaicIdea','SAIC IDEAS GROUP'),(413575151616,'Safe-Com','Safe-com GmbH & Co. KG'),(413591928832,'SagemCom','SAGEM COMMUNICATION'),(413608706048,'MmcNetwo','MMC NETWORKS, INC.'),(413625483264,'CycleCom','CYCLE COMPUTER CORPORATION, INC.'),(413642260480,'TattileS','Tattile SRL'),(413659037696,'Internix','INTERNIX INC.'),(413675814912,'QualityS','QUALITY SEMICONDUCTOR'),(413692592128,'Peripher','PERIPHERALS ENTERPRISE CO., Ltd.'),(413709369344,'ToyodaMa','TOYODA MACHINE WORKS, LTD.'),(413726146560,'Controlw','CONTROLWARE GMBH'),(413742923776,'CornellU','CORNELL UNIVERSITY'),(413759700992,'NetworkT','NETWORK TOOLS, INC.'),(413776478208,'MurataMa','MURATA MANUFACTURING CO., LTD.'),(413793255424,'CopperMo','COPPER MOUNTAIN COMMUNICATIONS, '),(413810032640,'Technica','TECHNICAL COMMUNICATIONS CORP.'),(413826809856,'Celcore','CELCORE, INC.'),(413843587072,'Intraser','IntraServer Technology, Inc.'),(413860364288,'Cisco','CISCO SYSTEMS, INC.'),(413877141504,'Scanival','SCANIVALVE CORP.'),(413893918720,'LibertyT','LIBERTY TECHNOLOGY NETWORKING'),(413910695936,'NipponUn','NIPPON UNISOFT CORPORATION'),(413927473152,'DawningT','DAWNING TECHNOLOGIES, INC.'),(413944250368,'WhistleC','WHISTLE COMMUNICATIONS CORP.'),(413961027584,'Telesync','TELESYNC, INC.'),(413977804800,'PsionDac','PSION DACOM PLC.'),(413994582016,'Netcomm','NETCOMM LIMITED'),(414011359232,'Bernecke','BERNECKER & RAINER INDUSTRIE-ELE'),(414028136448,'LacroixT','LACROIX Trafic'),(414044913664,'AcerNetx','ACER NETXUS INC.'),(414061690880,'Dialogic','Dialogic Corporation'),(414078468096,'BrocadeC','Brocade Communications Systems, '),(414095245312,'Mitsubis','MITSUBISHI WIRELESS COMMUNICATIO'),(414112022528,'Synclaye','Synclayer Inc.'),(414128799744,'Arescom',''),(414145576960,'DigitalE','DIGITAL EQUIPMENT CORP.'),(414162354176,'DavicomS','DAVICOM SEMICONDUCTOR, INC.'),(414179131392,'ClarionO','CLARION CORPORATION OF AMERICA'),(414195908608,'Cisco','CISCO SYSTEMS, INC.'),(414212685824,'MidasLab','MIDAS LAB, INC.'),(414229463040,'VxlInstr','VXL INSTRUMENTS, LIMITED'),(414246240256,'Redcreek','REDCREEK COMMUNICATIONS, INC.'),(414263017472,'QscAudio','QSC AUDIO PRODUCTS'),(414279794688,'Pentek','PENTEK, INC.'),(414296571904,'Schlumbe','SCHLUMBERGER TECHNOLOGIES RETAIL'),(414313349120,'PrisaNet','PRISA NETWORKS'),(414330126336,'PowerMea','POWER MEASUREMENT LTD.'),(414346903552,'Mainstre','Mainstream Data, Inc.'),(414363680768,'Dvs','DVS GmbH'),(414380457984,'Fore','FORE SYSTEMS, INC.'),(414397235200,'Waveacce','WaveAccess, Ltd.'),(414414012416,'Sentient','SENTIENT NETWORKS INC.'),(414430789632,'Gigalabs','GIGALABS, INC.'),(414447566848,'AuroraTe','AURORA TECHNOLOGIES, INC.'),(414464344064,'Microtro','MICROTRONIX DATACOM LTD.'),(414481121280,'Tv/ComIn','TV/COM INTERNATIONAL'),(414497898496,'Novalink','NOVALINK TECHNOLOGIES, INC.'),(414514675712,'Cisco','CISCO SYSTEMS, INC.'),(414531452928,'DigitalV','DIGITAL VIDEO'),(414548230144,'StorageC','Storage Concepts'),(414565007360,'LogicRep','LOGIC REPLACEMENT TECH. LTD.'),(414581784576,'KansaiEl','KANSAI ELECTRIC CO., LTD.'),(414598561792,'WhiteMou','WHITE MOUNTAIN DSP, INC.'),(414615339008,'Xata',''),(414632116224,'CitadelC','CITADEL COMPUTER'),(414648893440,'Conferte','ConferTech International'),(414665670656,'3com','3COM CORPORATION'),(414682447872,'Unipulse','UNIPULSE CORP.'),(414699225088,'HeElectr','HE ELECTRONICS, TECHNOLOGIE & SY'),(414716002304,'TekramTe','TEKRAM TECHNOLOGY CO., LTD.'),(414732779520,'ArtizaNe','Artiza Networks Inc'),(414749556736,'FirstPac','FIRST PACIFIC NETWORKS, INC.'),(414766333952,'Micro/Sy','MICRO/SYS, INC.'),(414783111168,'Varian',''),(414799888384,'Ibm','IBM Corp'),(414816665600,'Accu-Tim','ACCU-TIME SYSTEMS, INC.'),(414833442816,'TSMicrot','T.S. MICROTECH INC.'),(414850220032,'3com','3COM CORPORATION'),(414866997248,'HtCommun','HT COMMUNICATIONS'),(414883774464,'Sbe','SBE, Inc.'),(414900551680,'NjkTechn','NJK TECHNO CO.'),(414917328896,'Astro-Me','ASTRO-MED, INC.'),(414934106112,'Perkin-E','Perkin-Elmer Incorporated'),(414950883328,'PmiFoodE','PMI FOOD EQUIPMENT GROUP'),(414967660544,'AscX3-In','ASC X3 - INFORMATION TECHNOLOGY '),(414984437760,'Phast','PHAST CORPORATION'),(415001214976,'Switched','SWITCHED NETWORK TECHNOLOGIES, I'),(415017992192,'Vpnet','VPNet, Inc.'),(415034769408,'NihonUni','NIHON UNISYS LIMITED CO.'),(415051546624,'Continuu','CONTINUUM TECHNOLOGY CORP.'),(415068323840,'Grinaker','GRINAKER SYSTEM TECHNOLOGIES'),(415085101056,'Performa','PERFORMANCE TELECOM CORP.'),(415101878272,'Particle','PARTICLE MEASURING SYSTEMS'),(415118655488,'Microsen','MICROSENS GmbH & CO. KG'),(415135432704,'Tidomat','TIDOMAT AB'),(415152209920,'GesytecM','GESYTEC MbH'),(415168987136,'Intellig','INTELLIGENT DEVICES INC. (IDI)'),(415185764352,'Larscom','LARSCOM INCORPORATED'),(415202541568,'Resilien','RESILIENCE CORPORATION'),(415219318784,'Megachip','MegaChips Corporation'),(415236096000,'TrioInfo','TRIO INFORMATION SYSTEMS AB'),(415252873216,'PacificM','PACIFIC MICRO DATA, INC.'),(415269650432,'HP',''),(415286427648,'Input/Ou','INPUT/OUTPUT, INC.'),(415303204864,'ProcessC','PROCESS CONTROL CORP.'),(415319982080,'Z-Com','Z-COM, INC.'),(415336759296,'Glenayre','GLENAYRE R&D INC.'),(415353536512,'Keba','KEBA GmbH'),(415370313728,'LandComp','LAND COMPUTER CO., LTD.'),(415387090944,'Channelm','CHANNELMATIC, INC.'),(415403868160,'Corelis','CORELIS Inc.'),(415420645376,'NecInfro','NEC Infrontia Corporation'),(415437422592,'SaharaNe','SAHARA NETWORKS, INC.'),(415454199808,'Cabletro','CABLETRON - NETLINK, INC.'),(415470977024,'Keunyoun','KeunYoung Electronics & Communic'),(415487754240,'Hubbell-','HUBBELL-PULSECOM'),(415504531456,'Webtroni','WEBTRONICS'),(415521308672,'Macraigo','MACRAIGOR SYSTEMS, INC.'),(415538085888,'NeraNetw','Nera Networks AS'),(415554863104,'Wavespan','WaveSpan Corporation'),(415571640320,'Mpl','MPL AG'),(415588417536,'Netvisio','NETVISION CORPORATION'),(415605194752,'SolitonK','SOLITON SYSTEMS K.K.'),(415621971968,'Ancot','ANCOT CORP.'),(415638749184,'Dcs','DCS AG'),(415655526400,'AmatiCom','AMATI COMMUNICATIONS CORP.'),(415672303616,'KukaWeld','KUKA WELDING SYSTEMS & ROBOTS'),(415689080832,'Controln','ControlNet, Inc.'),(415705858048,'Harmonic','HARMONIC SYSTEMS INCORPORATED'),(415722635264,'HitachiZ','HITACHI ZOSEN CORPORATION'),(415739412480,'Emtrak','EMTRAK, INCORPORATED'),(415756189696,'Videoser','VideoServer, Inc.'),(415772966912,'AcclaimC','ACCLAIM COMMUNICATIONS'),(415789744128,'AlteonNe','ALTEON NETWORKS, INC.'),(415806521344,'SnmpRese','SNMP RESEARCH INCORPORATED'),(415823298560,'CascadeC','CASCADE COMMUNICATIONS'),(415840075776,'LucentTe','LUCENT TECHNOLOGIES TAIWAN TELEC'),(415856852992,'At&T',''),(415873630208,'EldatCom','ELDAT COMMUNICATION LTD.'),(415890407424,'MiyachiT','MIYACHI TECHNOS CORP.'),(415907184640,'NovatelW','NovAtel Wireless Technologies Lt'),(415923961856,'EcolePol','ECOLE POLYTECHNIQUE FEDERALE DE '),(415940739072,'Elmic','ELMIC SYSTEMS, INC.'),(415957516288,'TransysN','TRANSYS NETWORKS INC.'),(415974293504,'JbmElect','JBM ELECTRONICS CO.'),(415991070720,'NtpElekt','NTP ELEKTRONIK A/S'),(416007847936,'ToyoNetw','Toyo Network Systems  & System I'),(416024625152,'Myricom','MYRICOM, INC.'),(416041402368,'Kayser-T','Kayser-Threde GmbH'),(416058179584,'BrocadeC','Brocade Communications Systems, '),(416074956800,'AxiomTec','AXIOM TECHNOLOGY CO., LTD.'),(416091734016,'OrckitCo','ORCKIT COMMUNICATIONS LTD.'),(416108511232,'QuestEng','QUEST ENGINEERING & DEVELOPMENT'),(416125288448,'ArbinIns','ARBIN INSTRUMENTS'),(416142065664,'Compuser','COMPUSERVE, INC.'),(416158842880,'FujiAuto','FUJI AUTOMATION CO., LTD.'),(416175620096,'Shomiti','SHOMITI SYSTEMS INCORPORATED'),(416192397312,'Randata',''),(416209174528,'HitachiC','HITACHI COMPUTER PRODUCTS (AMERI'),(416225951744,'AtopTech','ATOP TECHNOLOGIES, INC.'),(416242728960,'Streamlo','StreamLogic'),(416259506176,'Fourthtr','FOURTHTRACK SYSTEMS'),(416276283392,'HermaryO','HERMARY OPTO ELECTRONICS INC.'),(416293060608,'RicardoT','RICARDO TEST AUTOMATION LTD.'),(416309837824,'Apollo',''),(416326615040,'FlytechT','FLYTECH TECHNOLOGY CO., LTD.'),(416343392256,'JohnsonJ','JOHNSON & JOHNSON MEDICAL, INC'),(416360169472,'ExpCompu','EXP COMPUTER, INC.'),(416376946688,'Lasergra','LASERGRAPHICS, INC.'),(416393723904,'Performa','Performance Analysis Broadband, '),(416410501120,'Advanced','ADVANCED COMPUTER SOLUTIONS, Inc'),(416427278336,'IconWest','ICON WEST, INC.'),(416444055552,'NextestC','NEXTEST COMMUNICATIONS PRODUCTS,'),(416460832768,'Datafusi','DATAFUSION SYSTEMS'),(416477609984,'LoranInt','Loran International Technologies'),(416494387200,'DiamondL','DIAMOND LANE COMMUNICATIONS'),(416511164416,'Educatio','EDUCATIONAL TECHNOLOGY RESOURCES'),(416527941632,'Packetee','PACKETEER, INC.'),(416544718848,'Conserva','CONSERVATION THROUGH INNOVATION '),(416561496064,'Netics','NetICs, Inc.'),(416578273280,'LynxSyst','LYNX SYSTEM DEVELOPERS, INC.'),(416595050496,'Quvis','QuVis, Inc.'),(430570471424,'Cisco','CISCO SYSTEMS, INC.'),(432281747456,'MaquetCa','Maquet CardioVascular'),(439344955392,'HuaweiTe','Huawei Technologies Co., Ltd'),(462212300800,'Vizio','VIZIO Inc'),(462245855232,'Shenzhen','SHENZHEN UNIVERSAL INTELLISYS PT'),(472362516480,'VutrixUk','Vutrix (UK) Ltd'),(483989127168,'M/A-ComC','M/A-COM INC. COMPANIES'),(484039458816,'DataReca','DATA RECALL LTD.'),(506286047232,'AmptLlc','Ampt, LLC'),(518046875648,'Sagemcom',''),(546131935232,'Actionte','Actiontec Electronics, Inc'),(549755813888,'Multitec','MULTITECH SYSTEMS, INC.'),(549772591104,'Periphon','PERIPHONICS CORPORATION'),(549789368320,'Satelcom','SATELCOM (UK) LTD'),(549806145536,'HytecEle','HYTEC ELECTRONICS LTD.'),(549822922752,'AntlowCo','ANTLOW COMMUNICATIONS, LTD.'),(549839699968,'CactusCo','CACTUS COMPUTER INC.'),(549856477184,'Compuadd','COMPUADD CORPORATION'),(549873254400,'DlogNc-S','DLOG NC-SYSTEME'),(549890031616,'Dynatech','DYNATECH COMPUTER SYSTEMS'),(549906808832,'Jupiter','JUPITER SYSTEMS, INC.'),(549923586048,'JapanCom','JAPAN COMPUTER CORP.'),(549940363264,'Csk','CSK CORPORATION'),(549957140480,'Videcom','VIDECOM LIMITED'),(549973917696,'Vosswink','VOSSWINKEL F.U.'),(549990694912,'Atlantix','ATLANTIX CORPORATION'),(550007472128,'SMC',''),(550024249344,'Commodor','COMMODORE INTERNATIONAL'),(550041026560,'DigitalI','DIGITAL SYSTEMS INT`L. INC.'),(550057803776,'Integrat','INTEGRATED MEASUREMENT SYSTEMS'),(550074580992,'Thomas-C','THOMAS-CONRAD CORPORATION'),(550091358208,'Esprit','ESPRIT SYSTEMS'),(550108135424,'Seiko','SEIKO SYSTEMS, INC.'),(550124912640,'WandelAn','WANDEL AND GOLTERMANN'),(550141689856,'Pfu','PFU LIMITED'),(550158467072,'KobeStee','KOBE STEEL, LTD.'),(550175244288,'DaynaCom','DAYNA COMMUNICATIONS, INC.'),(550192021504,'BellAtla','BELL ATLANTIC'),(550208798720,'KodiakTe','KODIAK TECHNOLOGY'),(550225575936,'Cisco','NEWPORT SYSTEMS SOLUTIONS'),(550242353152,'Integrat','INTEGRATED INFERENCE MACHINES'),(550259130368,'Xinetron','XINETRON, INC.'),(550275907584,'KruppAtl','KRUPP ATLAS ELECTRONIK GMBH'),(550292684800,'NetworkP','NETWORK PRODUCTS'),(550309462016,'AlcatelC','Alcatel Canada Inc.'),(550326239232,'Scan-Opt','SCAN-OPTICS'),(550343016448,'Integrat','INTEGRATED BUSINESS NETWORKS'),(550359793664,'Kalpana','KALPANA, INC.'),(550376570880,'Stollman','STOLLMANN GMBH'),(550393348096,'NetworkP','NETWORK PRODUCTS CORPORATION'),(550410125312,'Adaptive','ADAPTIVE SYSTEMS, INC.'),(550426902528,'Tradpost','TRADPOST (HK) LTD'),(550443679744,'EagleTec','EAGLE TECHNOLOGY, INC.'),(550460456960,'TestSimu','TEST SYSTEMS & SIMULATIONS INC'),(550477234176,'Integrat','INTEGRATED MARKETING CO'),(550494011392,'SageGrou','THE SAGE GROUP PLC'),(550510788608,'Xylogics','XYLOGICS INC'),(550527565824,'CastleRo','CASTLE ROCK COMPUTING'),(550544343040,'National','NATIONAL INSTRUMENTS CORP.'),(550561120256,'NexusEle','NEXUS ELECTRONICS'),(550577897472,'Basys','BASYS, CORP.'),(550594674688,'Access','ACCESS CO., LTD.'),(550611451904,'EmsAviat','EMS Aviation, Inc.'),(550628229120,'SmtGoupi','SMT GOUPIL'),(550645006336,'Technolo','TECHNOLOGY WORKS, INC.'),(550661783552,'ReflexMa','REFLEX MANUFACTURING SYSTEMS'),(550678560768,'Ericsson','Ericsson Group'),(550695337984,'DataRese','DATA RESEARCH & APPLICATIONS'),(550712115200,'AlcatelS','ALCATEL STC AUSTRALIA'),(550728892416,'Varitype','VARITYPER, INC.'),(550745669632,'AptCommu','APT COMMUNICATIONS, INC.'),(550762446848,'TvsElect','TVS ELECTRONICS LTD'),(550779224064,'Surigike','SURIGIKEN CO.,  LTD.'),(550796001280,'Synernet','SYNERNETICS'),(550812778496,'Tatung','TATUNG COMPANY'),(550829555712,'JohnFluk','JOHN FLUKE MANUFACTURING CO.'),(550846332928,'VebKombi','VEB KOMBINAT ROBOTRON'),(550863110144,'EmersonN','Emerson Network Power'),(550879887360,'Networld','NETWORLD, INC.'),(550896664576,'SystechC','SYSTECH COMPUTER CORP.'),(550913441792,'Matsushi','MATSUSHITA ELECTRIC IND. CO'),(550930219008,'TattileS','Tattile SRL'),(550946996224,'In-Net','IN-NET CORP.'),(550963773440,'Compex','COMPEX INCORPORATED'),(550980550656,'NissinEl','NISSIN ELECTRIC CO., LTD.'),(550997327872,'Pro-Log',''),(551014105088,'EagleTec','EAGLE TECHNOLOGIES PTY.LTD.'),(551030882304,'Contec','CONTEC CO., LTD.'),(551047659520,'CycloneM','CYCLONE MICROSYSTEMS, INC.'),(551064436736,'ApexComp','APEX COMPUTER COMPANY'),(551081213952,'DaikinIn','DAIKIN INDUSTRIES, LTD.'),(551097991168,'Ziatech','ZIATECH CORPORATION'),(551114768384,'Fibermux',''),(551131545600,'Technica','TECHNICALLY ELITE CONCEPTS'),(551148322816,'Intellic','INTELLICOM, INC.'),(551165100032,'Frontier','FRONTIER TECHNOLOGIES CORP.'),(551181877248,'Fermilab',''),(551198654464,'SphinxEl','SPHINX ELEKTRONIK GMBH'),(551215431680,'Adsoft','ADSOFT, LTD.'),(551232208896,'Printer','PRINTER SYSTEMS CORPORATION'),(551248986112,'StanleyE','STANLEY ELECTRIC CO., LTD'),(551265763328,'TulipCom','TULIP COMPUTERS INTERNAT`L B.V'),(551282540544,'Condor','CONDOR SYSTEMS, INC.'),(551299317760,'Agilis','AGILIS CORPORATION'),(551316094976,'Canstar',''),(551332872192,'LsiLogic','LSI LOGIC CORPORATION'),(551349649408,'Hewlett-','Hewlett-Packard Company'),(551366426624,'NetworkI','NETWORK INTERFACE CORPORATION'),(551383203840,'Litton','LITTON SYSTEMS, INC.'),(551399981056,'Interfac','INTERFACE  CO.'),(551416758272,'Hirschma','Hirschmann Automation and Contro'),(551433535488,'TattileS','Tattile SRL'),(551450312704,'Cybergra','CYBERGRAPHIC SYSTEMS PTY LTD.'),(551467089920,'ArcomCon','ARCOM CONTROL SYSTEMS, LTD.'),(551483867136,'SquareD','SQUARE D COMPANY'),(551500644352,'Yamatech','YAMATECH SCIENTIFIC LTD.'),(551517421568,'Computon','COMPUTONE SYSTEMS'),(551534198784,'EriEmpac','ERI (EMPAC RESEARCH INC.)'),(551550976000,'SchmidTe','SCHMID TELECOMMUNICATION'),(551567753216,'CegelecP','CEGELEC PROJECTS LTD'),(551584530432,'Century','CENTURY SYSTEMS CORP.'),(551601307648,'NipponSt','NIPPON STEEL CORPORATION'),(551618084864,'Onelan','ONELAN LTD.'),(551634862080,'Computad','COMPUTADORAS MICRON'),(551651639296,'SaiTechn','SAI TECHNOLOGY'),(551668416512,'Microple','MICROPLEX SYSTEMS LTD.'),(551685193728,'DwbAssoc','DWB ASSOCIATES'),(551701970944,'FisherCo','FISHER CONTROLS'),(551718748160,'Parsytec','PARSYTEC GMBH'),(551735525376,'Mcnc',''),(551752302592,'BrotherI','BROTHER INDUSTRIES, LTD.'),(551769079808,'Practica','PRACTICAL PERIPHERALS, INC.'),(551785857024,'Microbus','MICROBUS DESIGNS LTD.'),(551802634240,'Aitech','AITECH SYSTEMS LTD.'),(551819411456,'ArtelCom','ARTEL COMMUNICATIONS CORP.'),(551836188672,'Fibercom','FIBERCOM, INC.'),(551852965888,'Equinox','EQUINOX SYSTEMS INC.'),(551869743104,'Southern','SOUTHERN PACIFIC LTD.'),(551886520320,'Dy-4','DY-4 INCORPORATED'),(551903297536,'Datamedi','DATAMEDIA CORPORATION'),(551920074752,'KendallS','KENDALL SQUARE RESEARCH CORP.'),(551936851968,'PepModul','PEP MODULAR COMPUTERS GMBH'),(551953629184,'Amdahl',''),(551970406400,'Cloud','THE CLOUD INC.'),(551987183616,'H-Three','H-THREE SYSTEMS CORPORATION'),(552003960832,'Computer','COMPUTER GENERATION INC.'),(552020738048,'OkiElect','OKI ELECTRIC INDUSTRY CO., LTD'),(552037515264,'VictorOf','VICTOR COMPANY OF JAPAN, LTD.'),(552054292480,'Tecnetic','TECNETICS (PTY) LTD.'),(552071069696,'SummitMi','SUMMIT MICROSYSTEMS CORP.'),(552087846912,'Dacoll','DACOLL LIMITED'),(552104624128,'Netscout','NetScout Systems, Inc.'),(552121401344,'Westcoas','WESTCOAST TECHNOLOGY B.V.'),(552138178560,'Radstone','RADSTONE TECHNOLOGY'),(552154955776,'CItohEle','C. ITOH ELECTRONICS, INC.'),(552171732992,'Microtek','MICROTEK INTERNATIONAL, INC.'),(552188510208,'TokyoEle','TOKYO ELECTRIC CO.,LTD'),(552205287424,'SilexTec','Silex Technology, Inc.'),(552222064640,'Xyron','XYRON CORPORATION'),(552238841856,'AlfaLava','ALFA LAVAL AUTOMATION AB'),(552255619072,'BasicMer','BASIC MERTON HANDELSGES.M.B.H.'),(552272396288,'HDS',''),(552289173504,'Centralp','CENTRALP AUTOMATISMES'),(552305950720,'Tdk','TDK CORPORATION'),(552322727936,'EatonInd','Eaton Industries GmbH'),(552339505152,'NovusNet','NOVUS NETWORKS LTD'),(552356282368,'Justsyst','JUSTSYSTEM CORPORATION'),(552373059584,'Luxcom','LUXCOM, INC.'),(552389836800,'Commscra','Commscraft Ltd.'),(552406614016,'Datus','DATUS GMBH'),(552423391232,'AlcatelB','ALCATEL BUSINESS SYSTEMS'),(552440168448,'EdisaHew','EDISA HEWLETT PACKARD S/A'),(552456945664,'Microtes','MICROTEST, INC.'),(552473722880,'TattileS','Tattile SRL'),(552490500096,'Lantroni','Lantronix'),(552507277312,'LibertyE','LIBERTY ELECTRONICS'),(552524054528,'SpeedInt','SPEED INTERNATIONAL'),(552540831744,'Republic','REPUBLIC TECHNOLOGY, INC.'),(552557608960,'Honeywel','Honeywell International Inc'),(552574386176,'Vitacom','VITACOM CORPORATION'),(552591163392,'Clearpoi','CLEARPOINT RESEARCH'),(552607940608,'Maxpeed',''),(552624717824,'DukaneNe','DUKANE NETWORK INTEGRATION'),(552641495040,'ImlogixD','IMLOGIX, DIVISION OF GENESYS'),(552658272256,'Telebit',''),(552675049472,'HughesNe','HUGHES NETWORK SYSTEMS'),(552691826688,'Allumer','ALLUMER CO., LTD.'),(552708603904,'Advanced','ADVANCED INFORMATION'),(552725381120,'Softcom','SOFTCOM A/S'),(552742158336,'NetworkE','NETWORK EQUIPMENT TECHNOLOGIES'),(552758935552,'AvalData','AVAL DATA CORPORATION'),(552775712768,'Sophia','SOPHIA SYSTEMS'),(552792489984,'UnitedNe','UNITED NETWORKS INC.'),(552809267200,'ThemisCo','THEMIS COMPUTER'),(552826044416,'StellarC','STELLAR COMPUTER'),(552842821632,'Bug','BUG, INCORPORATED'),(552859598848,'ArcheTec','ARCHE TECHNOLIGIES INC.'),(552876376064,'Speciali','SPECIALIX (ASIA) PTE, LTD'),(552893153280,'HughesLa','HUGHES LAN SYSTEMS'),(552909930496,'HitachiE','HITACHI ENGINEERING CO., LTD'),(552926707712,'Furukawa','THE FURUKAWA ELECTRIC CO., LTD'),(552943484928,'AriesRes','ARIES RESEARCH'),(552960262144,'TakaokaE','TAKAOKA ELECTRIC MFG. CO. LTD.'),(552977039360,'PenrilDa','PENRIL DATACOMM'),(552993816576,'Lanex','LANEX CORPORATION'),(553010593792,'Ieee8021','IEEE 802.1 COMMITTEE'),(553027371008,'BiccInfo','BICC INFORMATION SYSTEMS & SVC'),(553044148224,'Document','DOCUMENT TECHNOLOGIES, INC.'),(553060925440,'Novellco','NOVELLCO DE MEXICO'),(553077702656,'National','NATIONAL DATACOMM CORPORATION'),(553094479872,'Xircom',''),(553111257088,'D-Link','D-LINK SYSTEMS, INC.'),(553128034304,'AlbertaM','ALBERTA MICROELECTRONIC CENTRE'),(553144811520,'NetcomRe','NETCOM RESEARCH INCORPORATED'),(553161588736,'FalcoDat','FALCO DATA PRODUCTS'),(553178365952,'Microwav','MICROWAVE BYPASS SYSTEMS'),(553195143168,'Micronic','MICRONICS COMPUTER, INC.'),(553211920384,'Broadcas','BROADCAST TELEVISION SYSTEMS'),(553228697600,'Embedded','EMBEDDED PERFORMANCE INC.'),(553245474816,'Computer','COMPUTER PERIPHERALS, INC.'),(553262252032,'Kimtron','KIMTRON CORPORATION'),(553279029248,'Shinniho','SHINNIHONDENKO CO., LTD.'),(553295806464,'Shiva','SHIVA CORP.'),(553312583680,'ChaseRes','CHASE RESEARCH LTD.'),(553329360896,'CadreTec','CADRE TECHNOLOGIES'),(553346138112,'Nuvotech','NUVOTECH, INC.'),(553362915328,'FantumEn','Fantum Engineering'),(553379692544,'NetworkP','NETWORK PERIPHERALS INC.'),(553396469760,'EmkElekt','EMK Elektronik GmbH & Co. KG'),(553413246976,'BruelKja','Bruel & Kjaer Sound & Vibration '),(553430024192,'Graphon','GRAPHON CORPORATION'),(553446801408,'PickerIn','PICKER INTERNATIONAL'),(553463578624,'GmxInc/G','GMX INC/GIMIX'),(553480355840,'GipsiSA','GIPSI S.A.'),(553497133056,'AdcCoden','ADC CODENOLL TECHNOLOGY CORP.'),(553513910272,'Xtp','XTP SYSTEMS, INC.'),(553530687488,'Stmicroe','STMICROELECTRONICS'),(553547464704,'TDI','T.D.I. CO., LTD.'),(553564241920,'CoralNet','CORAL NETWORK CORPORATION'),(553581019136,'Northwes','NORTHWEST DIGITAL SYSTEMS, INC'),(553597796352,'Netapp','NetApp, Inc'),(553614573568,'PeerNetw','PEER NETWORKS, INC.'),(553631350784,'LynwoodS','LYNWOOD SCIENTIFIC DEV. LTD.'),(553648128000,'CumulusC','CUMULUS CORPORATIION'),(553664905216,'Madge','Madge Ltd.'),(553681682432,'AdvaOpti','ADVA Optical Networking Ltd.'),(553698459648,'Compcont','COMPCONTROL B.V.'),(553715236864,'Supercom','SUPERCOMPUTING SOLUTIONS, INC.'),(553732014080,'IqTechno','IQ TECHNOLOGIES, INC.'),(553748791296,'ThomsonC','THOMSON CSF'),(553765568512,'Rational',''),(553782345728,'Panasoni','Panasonic Communications Co., Lt'),(553799122944,'Opus','OPUS SYSTEMS'),(553815900160,'Raycom','RAYCOM SYSTEMS INC'),(553832677376,'SunElect','SUN ELECTRONICS CORP.'),(553849454592,'Telemeca','TELEMECANIQUE ELECTRIQUE'),(553866231808,'Quantel','Quantel Ltd'),(553883009024,'SynergyM','SYNERGY MICROSYSTEMS'),(553899786240,'ZenithEl','ZENITH ELECTRONICS'),(553916563456,'Mizar','MIZAR, INC.'),(553933340672,'Heurikon','HEURIKON CORPORATION'),(553950117888,'Rwt','RWT GMBH'),(553966895104,'Bvm','BVM LIMITED'),(553983672320,'Avatar','AVATAR CORPORATION'),(554000449536,'ExsceedC','EXSCEED CORPRATION'),(554017226752,'AzureTec','AZURE TECHNOLOGIES, INC.'),(554034003968,'SocDeTel','SOC. DE TELEINFORMATIQUE RTC'),(578209972224,'Private',''),(585810051072,'Apple',''),(601563856896,'BlackBox','Black Box Corp.'),(602704707584,'AdbBroad','ADB Broadband Italia'),(605489725440,'Inventec','Inventec Corporation'),(606899011584,'CjscNiiS','CJSC NII STT'),(609247821824,'LinkOne','Link One Co., Ltd.'),(613945442304,'Netgear','NETGEAR INC.,'),(618475290624,'DiamondM','DIAMOND MULTIMEDIA'),(618492067840,'NishimuE','NISHIMU ELECTRONICS INDUSTRIES C'),(618508845056,'Allgon','ALLGON AB'),(618525622272,'Aplio',''),(618542399488,'3comEuro','3COM EUROPE LTD.'),(618559176704,'Protech','PROTECH SYSTEMS CO., LTD.'),(618575953920,'Hamamats','HAMAMATSU PHOTONICS K.K.'),(618592731136,'DomexTec','DOMEX TECHNOLOGY CORP.'),(618609508352,'Hana','HanA Systems Inc.'),(618626285568,'IControl','I Controls, Inc.'),(618643062784,'ProtonEl','PROTON ELECTRONIC INDUSTRIAL CO.'),(618659840000,'LannerEl','LANNER ELECTRONICS, INC.'),(618676617216,'Cisco','CISCO SYSTEMS, INC.'),(618693394432,'Overland','Overland Storage Inc.'),(618710171648,'Handlink','HANDLINK TECHNOLOGIES, INC.'),(618726948864,'Kawasaki','KAWASAKI HEAVY INDUSTRIES, LTD'),(618743726080,'Simulati','SIMULATION LABORATORIES, INC.'),(618760503296,'Wavtrace','WAVTrace, Inc.'),(618777280512,'Globespa','GLOBESPAN SEMICONDUCTOR, INC.'),(618794057728,'Samsan','SAMSAN CORP.'),(618810834944,'RotorkIn','ROTORK INSTRUMENTS, LTD.'),(618827612160,'Centigra','CENTIGRAM COMMUNICATIONS CORP.'),(618844389376,'Zac',''),(618861166592,'Zypcom','Zypcom, Inc'),(618877943808,'ItoElect','ITO ELECTRIC INDUSTRY CO, LTD.'),(618894721024,'HermesEl','HERMES ELECTRONICS CO., LTD.'),(618911498240,'Unispher','UNISPHERE SOLUTIONS'),(618928275456,'DigitalC','DIGITAL CONTROLS'),(618945052672,'MpsSoftw','mps Software Gmbh'),(618961829888,'PecNz','PEC (NZ) LTD.'),(618978607104,'SelestaI','Selesta Ingegneria S.p.A.'),(618995384320,'AdtecPro','ADTEC PRODUCTIONS, INC.'),(619012161536,'PhilipsA','PHILIPS ANALYTICAL X-RAY B.V.'),(619028938752,'Cisco','CISCO SYSTEMS, INC.'),(619045715968,'Ivex',''),(619062493184,'Zilog','ZILOG INC.'),(619079270400,'Pipelink','PIPELINKS, INC.'),(619096047616,'BaeAustr','BAE Systems Australia (Electroni'),(619112824832,'Advanced','ADVANCED SWITCHING COMMUNICATION'),(619129602048,'Intel','INTEL CORPORATION'),(619146379264,'NipponSi','NIPPON SIGNAL CO., LTD.'),(619163156480,'Crypto','CRYPTO AG'),(619179933696,'Communic','COMMUNICATION DEVICES, INC.'),(619196710912,'Cisco','CISCO SYSTEMS, INC.'),(619213488128,'DataCont','DATA & CONTROL EQUIPMENT LTD.'),(619230265344,'DataElec','DATA ELECTRONICS (AUST.) PTY, LT'),(619247042560,'Namco','NAMCO LIMITED'),(619263819776,'Netcore','NETCORE SYSTEMS, INC.'),(619280596992,'Honeywel','HONEYWELL-DATING'),(619297374208,'Mysticom','MYSTICOM, LTD.'),(619314151424,'Pelcombe','PELCOMBE GROUP LTD.'),(619330928640,'Innovaph','INNOVAPHONE AG'),(619347705856,'Imagic','IMAGIC, INC.'),(619364483072,'AlphaTel','ALPHA TELECOM, INC.'),(619381260288,'Ens','ens, inc.'),(619398037504,'Acucomm','ACUCOMM, INC.'),(619414814720,'Fountain','FOUNTAIN TECHNOLOGIES, INC.'),(619431591936,'ShastaNe','SHASTA NETWORKS'),(619448369152,'NihonMed','NIHON MEDIA TOOL INC.'),(619465146368,'TriemsRe','TriEMS Research Lab, Inc.'),(619481923584,'Atlantic','ATLANTIC NETWORK SYSTEMS'),(619498700800,'Biopac','BIOPAC SYSTEMS, INC.'),(619515478016,'NVPhilip','N.V. PHILIPS INDUSTRIAL ACTIVITI'),(619532255232,'AztecRad','AZTEC RADIOMEDIA'),(619549032448,'SiemensN','Siemens Network Convergence LLC'),(619565809664,'AppliedD','APPLIED DIGITAL ACCESS'),(619582586880,'Eccs','ECCS, Inc.'),(619599364096,'TattileS','Tattile SRL'),(619616141312,'AssuredD','ASSURED DIGITAL, INC.'),(619632918528,'MarconiC','Marconi Communications'),(619649695744,'Dexdyne','DEXDYNE, LTD.'),(619666472960,'GigaFast','GIGA FAST E. LTD.'),(619683250176,'Zeal','ZEAL CORPORATION'),(619700027392,'Entridia','ENTRIDIA CORPORATION'),(619716804608,'ConcurSy','CONCUR SYSTEM TECHNOLOGIES'),(619733581824,'GemtekTe','GemTek Technology Co., Ltd.'),(619750359040,'Epigram','EPIGRAM, INC.'),(619767136256,'SpecSA','SPEC S.A.'),(619783913472,'DelemBv','DELEM BV'),(619800690688,'AbbPower','ABB POWER T&D COMPANY, INC.'),(619817467904,'TelesteO','TELESTE OY'),(619834245120,'Ultimate','ULTIMATE TECHNOLOGY CORP.'),(619851022336,'SelcomEl','SELCOM ELETTRONICA S.R.L.'),(619867799552,'DaewooEl','DAEWOO ELECTRONICS CO., LTD.'),(619884576768,'Innovati','INNOVATIVE SEMICONDUCTORS, INC'),(619901353984,'ParkerHa','PARKER HANNIFIN CORPORATION COMP'),(619918131200,'Telestre','TELESTREAM, INC.'),(619934908416,'Aanetcom','AANetcom, Inc.'),(619951685632,'UltraEle','Ultra Electronics Ltd., Command '),(619968462848,'TelecomD','TELECOM DEVICE K.K.'),(619985240064,'Dearborn','DEARBORN GROUP, INC.'),(620002017280,'RaymondA','RAYMOND AND LAE ENGINEERING'),(620018794496,'Edmi',''),(620035571712,'NetcomSi','NETCOM SICHERHEITSTECHNIK GmbH'),(620052348928,'Rauland-','RAULAND-BORG CORPORATION'),(620069126144,'Cisco','CISCO SYSTEMS, INC.'),(620085903360,'SystemCr','SYSTEM CREATE CORP.'),(620102680576,'PacificR','PACIFIC RESEARCH & ENGINEERING C'),(620119457792,'IcpVorte','ICP VORTEX COMPUTERSYSTEME GmbH'),(620136235008,'Coherent','COHERENT COMMUNICATIONS SYSTEMS '),(620153012224,'Thomson','Thomson Inc.'),(620169789440,'Finisar','FINISAR CORPORATION'),(620186566656,'TroikaNe','Troika Networks, Inc.'),(620203343872,'Walkabou','WalkAbout Computers, Inc.'),(620220121088,'Dvt','DVT CORP.'),(620236898304,'JuniperN','JUNIPER NETWORKS, INC.'),(620253675520,'Turnston','TURNSTONE SYSTEMS, INC.'),(620270452736,'AppliedR','APPLIED RESOURCES, INC.'),(620287229952,'Sartoriu','Sartorius Hamburg GmbH'),(620304007168,'Cisco','CISCO SYSTEMS, INC.'),(620320784384,'Praxon','PRAXON, INC.'),(620337561600,'Cisco','CISCO SYSTEMS, INC.'),(620354338816,'NeoNetwo','NEO NETWORKS, INC.'),(620371116032,'AppliedI','Applied Innovation Inc.'),(620387893248,'SimradAs','SIMRAD AS'),(620404670464,'GaioTech','GAIO TECHNOLOGY'),(620421447680,'ArgonNet','ARGON NETWORKS, INC.'),(620438224896,'NecDoBra','NEC DO BRASIL S.A.'),(620455002112,'FmtAircr','FMT AIRCRAFT GATE SUPPORT SYSTEM'),(620471779328,'Advanced','ADVANCED FIBRE COMMUNICATIONS'),(620488556544,'MerTelem','MER TELEMANAGEMENT SOLUTIONS, LT'),(620505333760,'Clearone','ClearOne, Inc.'),(620522110976,'Spectral','Spectralink, Inc'),(620538888192,'E-Tech','E-TECH, INC.'),(620555665408,'Digitalc','DIGITALCAST, INC.'),(620572442624,'LakeComm','Lake Communications'),(620589219840,'Vetronix','VETRONIX CORP.'),(620605997056,'Watchgua','WatchGuard Technologies, Inc.'),(620622774272,'Not','NOT LIMITED, INC.'),(620639551488,'AlohaNet','ALOHA NETWORKS, INC.'),(620656328704,'ForceIns','FORCE INSTITUTE'),(620673105920,'TurboCom','TURBO COMMUNICATION, INC.'),(620689883136,'AtechSys','ATECH SYSTEM'),(620706660352,'GoldenEn','GOLDEN ENTERPRISES, INC.'),(620723437568,'Cisco','CISCO SYSTEMS, INC.'),(620740214784,'Itis',''),(620756992000,'BaxallSe','BAXALL SECURITY LTD.'),(620773769216,'SoftcomM','SOFTCOM MICROSYSTEMS, INC.'),(620790546432,'BaylyCom','BAYLY COMMUNICATIONS, INC.'),(620807323648,'TattileS','Tattile SRL'),(620824100864,'EtrendEl','ETREND ELECTRONICS, INC.'),(620840878080,'VickersE','VICKERS ELECTRONICS SYSTEMS'),(620857655296,'NortelNe','Nortel Networks Broadband Access'),(620874432512,'AudioCod','AUDIO CODES LTD.'),(620891209728,'I-Bus',''),(620907986944,'Digitals','DigitalScape, Inc.'),(620924764160,'Cisco','CISCO SYSTEMS, INC.'),(620941541376,'Nanao','NANAO CORPORATION'),(620958318592,'OspreyTe','OSPREY TECHNOLOGIES, INC.'),(620975095808,'Universa','UNIVERSAL AVIONICS'),(620991873024,'AskeyCom','ASKEY COMPUTER CORP.'),(621008650240,'Sycamore','Sycamore Networks'),(621025427456,'SbcDesig','SBC DESIGNS, INC.'),(621042204672,'AlliedTe','ALLIED TELESIS, K.K.'),(621058981888,'OneWorld','ONE WORLD SYSTEMS, INC.'),(621075759104,'Markem-I','MARKEM-IMAJE'),(621092536320,'Motorola','Motorola, Inc.'),(621109313536,'Novatech','NovaTech Process Solutions, LLC'),(621126090752,'Critical','Critical IO, LLC'),(621142867968,'Digi-Dat','DIGI-DATA CORPORATION'),(621159645184,'8x8','8X8 INC.'),(621176422400,'FlyingPi','Flying Pig Systems/High End Syst'),(621193199616,'Cybertan','CYBERTAN TECHNOLOGY, INC.'),(621209976832,'Corecess','Corecess Inc.'),(621226754048,'AltigaNe','ALTIGA NETWORKS'),(621243531264,'SpectraL','SPECTRA LOGIC'),(621260308480,'Cisco','CISCO SYSTEMS, INC.'),(621277085696,'Clientec','CLIENTEC CORPORATION'),(621293862912,'Ninetile','NineTiles Networks, Ltd.'),(621310640128,'WesternD','WESTERN DIGITAL'),(621327417344,'IndigoAc','INDIGO ACTIVE VISION SYSTEMS LIM'),(621344194560,'Cisco','CISCO SYSTEMS, INC.'),(621360971776,'Optivisi','OPTIVISION, INC.'),(621377748992,'AspectEl','ASPECT ELECTRONICS, INC.'),(621394526208,'ItaltelS','ITALTEL S.p.A.'),(621411303424,'JMoritaM','J. MORITA MFG. CORP.'),(621428080640,'Vadem',''),(621444857856,'Cisco','CISCO SYSTEMS, INC.'),(621461635072,'Avici','AVICI SYSTEMS INC.'),(621478412288,'Agranat','AGRANAT SYSTEMS'),(621495189504,'Willowbr','WILLOWBROOK TECHNOLOGIES'),(621511966720,'Nikon','NIKON CORPORATION'),(621528743936,'Fibex','FIBEX SYSTEMS'),(621545521152,'DigitalL','DIGITAL LIGHTWAVE, INC.'),(621562298368,'RohdeSch','ROHDE & SCHWARZ GMBH & CO. KG'),(621579075584,'BeranIns','BERAN INSTRUMENTS LTD.'),(621595852800,'ValidNet','VALID NETWORKS, INC.'),(621612630016,'TainetCo','TAINET COMMUNICATION SYSTEM Corp'),(621629407232,'Telemann','TELEMANN CO., LTD.'),(621646184448,'OmniaCom','OMNIA COMMUNICATIONS, INC.'),(621662961664,'Ibc/Inte','IBC/INTEGRATED BUSINESS COMPUTER'),(621679738880,'Cisco','CISCO SYSTEMS, INC.'),(621696516096,'KJLawEng','K.J. LAW ENGINEERS, INC.'),(621713293312,'PecoIi','Peco II, Inc.'),(621730070528,'JkMicros','JK microsystems, Inc.'),(621746847744,'TopicSem','TOPIC SEMICONDUCTOR CORP.'),(621763624960,'Javelin','JAVELIN SYSTEMS, INC.'),(621780402176,'Internet','INTERNET MAGIC, INC.'),(621797179392,'Optim','OPTIM SYSTEMS, INC.'),(621813956608,'Icom','ICOM INC.'),(621830733824,'Waveride','WAVERIDER COMMUNICATIONS (CANADA'),(621847511040,'DpacTech','DPAC Technologies'),(621864288256,'AccordVi','ACCORD VIDEO TELECOMMUNICATIONS,'),(621881065472,'Wireless','Wireless OnLine, Inc.'),(621897842688,'PlanexCo','Planex Communications'),(621914619904,'Ent-Empr','ENT-EMPRESA NACIONAL DE TELECOMM'),(621931397120,'Tetra','TETRA GmbH'),(621948174336,'Nortel',''),(621964951552,'ThomsonT','Thomson Telecom Belgium'),(621981728768,'LeichuEn','LEICHU ENTERPRISE CO., LTD.'),(621998505984,'ArtelVid','ARTEL VIDEO SYSTEMS'),(622015283200,'Giesecke','GIESECKE & DEVRIENT GmbH'),(622032060416,'Bindview','BindView Development Corp.'),(622048837632,'Euphonix','EUPHONIX, INC.'),(622065614848,'CrystalG','CRYSTAL GROUP'),(622082392064,'Netboost','NetBoost Corp.'),(622099169280,'Whitecro','WHITECROSS SYSTEMS'),(622115946496,'Cisco','CISCO SYSTEMS, INC.'),(622132723712,'Dynarc','DYNARC, INC.'),(622149500928,'NextLeve','NEXT LEVEL COMMUNICATIONS'),(622166278144,'TecoInfo','TECO INFORMATION SYSTEMS'),(622183055360,'MiharuCo','MIHARU COMMUNICATIONS Inc'),(622199832576,'Cardkey','CARDKEY SYSTEMS, INC.'),(622216609792,'Mitsubis','MITSUBISHI CHEMICAL AMERICA, INC'),(622233387008,'Systran','SYSTRAN CORP.'),(622250164224,'TelenaSP','TELENA S.P.A.'),(622266941440,'Distribu','DISTRIBUTED PROCESSING TECHNOLOG'),(622283718656,'AvexElec','AVEX ELECTRONICS INC.'),(622300495872,'NecAmeri','NEC AMERICA, INC.'),(622317273088,'Teknema','TEKNEMA, INC.'),(622334050304,'Ali','ALi Corporation'),(622350827520,'HorschEl','HORSCH ELEKTRONIK AG'),(622367604736,'MoxaTech','MOXA TECHNOLOGIES CORP., LTD.'),(622384381952,'JanzComp','JANZ COMPUTER AG'),(622401159168,'AlphaTec','ALPHA TECHNOLOGIES, INC.'),(622417936384,'SentryTe','SENTRY TELECOM SYSTEMS'),(622434713600,'Pyrescom',''),(622451490816,'CentralS','CENTRAL SYSTEM RESEARCH CO., LTD'),(622468268032,'Personal','PERSONAL COMMUNICATIONS TECHNOLO'),(622485045248,'Integrix','INTEGRIX, INC.'),(622501822464,'Harmonic','Harmonic Video Systems Ltd.'),(622518599680,'DotHill','DOT HILL SYSTEMS CORPORATION'),(622535376896,'Cisco','CISCO SYSTEMS, INC.'),(622552154112,'AspectCo','ASPECT COMMUNICATIONS'),(622568931328,'Lightnin','LIGHTNING INSTRUMENTATION'),(622585708544,'Clevo','CLEVO CO.'),(622602485760,'Escalate','ESCALATE NETWORKS, INC.'),(622619262976,'NbaseCom','NBASE COMMUNICATIONS LTD.'),(622636040192,'Mediatri','MEDIATRIX TELECOM'),(622652817408,'Leitch',''),(622669594624,'Emulex','EMULEX Corp'),(622686371840,'Portwell','PORTWELL, INC.'),(622703149056,'NetworkC','NETWORK COMPUTING DEVICES'),(622719926272,'Copperco','CopperCom, Inc.'),(622736703488,'ElecomLa','ELECOM CO., LTD.  (LANEED DIV.)'),(622753480704,'TellusTe','TELLUS TECHNOLOGY INC.'),(626360582144,'CrystalG','Crystal Group, Inc.'),(626964561920,'SynapseP','Synapse Product Development'),(633021136896,'Uni-Link','Uni-Link Technology Co., Ltd.'),(641711734784,'LsdScien','LSD Science and Technology Co.,L'),(652818251776,'HeimannS','Heimann Sensor GmbH'),(670048452608,'Hewlett-','Hewlett-Packard Company'),(676692230144,'CardiacR','CARDIAC RECORDERS, INC.'),(687194767360,'Centilli','CENTILLION NETWORKS, INC.'),(687211544576,'DrsSigna','DRS Signal Solutions'),(687228321792,'LeedsNor','LEEDS & NORTHRUP AUSTRALIA PTY L'),(687245099008,'SiemensS','Siemens Switzerland Ltd., I B T '),(687261876224,'Netpower','NETPOWER, INC.'),(687278653440,'DanielIn','DANIEL INSTRUMENTS, LTD.'),(687295430656,'ImageDat','IMAGE DATA PROCESSING SYSTEM GRO'),(687312207872,'ApexxTec','APEXX TECHNOLOGY, INC.'),(687328985088,'Netcorp',''),(687345762304,'Whitetre','WHITETREE NETWORK'),(687362539520,'Airspan',''),(687379316736,'Computex','COMPUTEX CO., LTD.'),(687396093952,'KingmaxT','KINGMAX TECHNOLOGY, INC.'),(687412871168,'PandaPro','THE PANDA PROJECT'),(687429648384,'VisualNe','VISUAL NETWORKS, INC.'),(687446425600,'Broadban','Broadband Technologies'),(687463202816,'Syslogic','SYSLOGIC DATENTECHNIK AG'),(687479980032,'MutohInd','MUTOH INDUSTRIES LTD.'),(687496757248,'Telco','Telco Systems, Inc.'),(687513534464,'Teltrend','TELTREND LTD.'),(687530311680,'Csir',''),(687547088896,'Wyle',''),(687563866112,'Micropol','MICROPOLIS CORP.'),(687580643328,'JBM','J B M CORPORATION'),(687597420544,'Creative','CREATIVE CONTROLLERS, INC.'),(687614197760,'NebulaCo','NEBULA CONSULTANTS, INC.'),(687630974976,'BinarEle','BINAR ELEKTRONIK AB'),(687647752192,'Premisys','PREMISYS COMMUNICATIONS, INC.'),(687664529408,'NascentN','NASCENT NETWORKS CORPORATION'),(687681306624,'Sixnet',''),(687698083840,'Est','EST CORPORATION'),(687714861056,'Tricord','TRICORD SYSTEMS, INC.'),(687731638272,'Citicorp','CITICORP/TTI'),(687748415488,'GeneralD','General Dynamics'),(687765192704,'CentreFo','CENTRE FOR DEVELOPMENT OF ADVANC'),(687781969920,'AppliedC','APPLIED CREATIVE TECHNOLOGY, INC'),(687798747136,'3com','3COM CORPORATION'),(687815524352,'RedcomLa','REDCOM LABS INC.'),(687832301568,'TeldatSA','TELDAT, S.A.'),(687849078784,'Firepowe','FIREPOWER SYSTEMS, INC.'),(687865856000,'ConnerPe','CONNER PERIPHERALS'),(687882633216,'Coulter','COULTER CORPORATION'),(687899410432,'Trancell','TRANCELL SYSTEMS'),(687916187648,'Transiti','TRANSITIONS RESEARCH CORP.'),(687932964864,'Interwav','interWAVE Communications'),(687949742080,'1394Trad','1394 Trade Association'),(687966519296,'BrandCom','BRAND COMMUNICATIONS, LTD.'),(687983296512,'PirelliC','PIRELLI CAVI'),(688000073728,'CaptorNv','CAPTOR NV/SA'),(688016850944,'Hazeltin','HAZELTINE CORPORATION, MS 1-17'),(688033628160,'GesSinga','GES SINGAPORE PTE. LTD.'),(688050405376,'ImcMebsy','imc MeBsysteme GmbH'),(688067182592,'Axel',''),(688083959808,'Cylink','CYLINK CORPORATION'),(688100737024,'AppliedN','APPLIED NETWORK TECHNOLOGY'),(688117514240,'MindrayD','Mindray DS USA, Inc.'),(688134291456,'EmailEle','EMAIL ELECTRONICS'),(688151068672,'RossTech','ROSS TECHNOLOGY, INC.'),(688167845888,'Kubotek','KUBOTEK CORPORATION'),(688184623104,'ToshinEl','TOSHIN ELECTRIC CO., LTD.'),(688201400320,'Eg&GNucl','EG&G NUCLEAR INSTRUMENTS'),(688218177536,'Opto-22',''),(688234954752,'AtmForum','ATM FORUM'),(688251731968,'Computer','COMPUTER SOCIETY MICROPROCESSOR '),(688268509184,'AppleCom','APPLE COMPUTER'),(688285286400,'Inficon',''),(688302063616,'SpurProd','SPUR PRODUCTS CORP.'),(688318840832,'American','AMERICAN TECHNOLOGY LABS, INC.'),(688335618048,'NttIt','NTT IT CO., LTD.'),(688352395264,'PhoenixC','PHOENIX CONTACT GMBH & CO.'),(688369172480,'Scitex','SCITEX CORP. LTD.'),(688385949696,'Integrat','INTEGRATED FITNESS CORP.'),(688402726912,'Questech','QUESTECH, LTD.'),(688419504128,'Digitech','DIGITECH INDUSTRIES, INC.'),(688436281344,'NisshinE','NISSHIN ELECTRIC CO., LTD.'),(688453058560,'TflLan','TFL LAN INC.'),(688469835776,'Innovati','INNOVATIVE SYSTEMS & TECHNOLOGIE'),(688486612992,'EdaInstr','EDA INSTRUMENTS, INC.'),(688503390208,'VoelkerT','VOELKER TECHNOLOGIES, INC.'),(688520167424,'Ameritec','AMERITEC CORP.'),(688536944640,'CypressS','CYPRESS SEMICONDUCTOR'),(688553721856,'AngiaCom','ANGIA COMMUNICATIONS. INC.'),(688570499072,'Stanilit','STANILITE ELECTRONICS PTY. LTD'),(688587276288,'CompactD','COMPACT DEVICES, INC.'),(688604053504,'Private',''),(688620830720,'DataDevi','Data Device Corporation'),(688637607936,'Micropro','MICROPROSS'),(688654385152,'Lancom','LANCOM Systems GmbH'),(688671162368,'Glory','GLORY, LTD.'),(688687939584,'Hamilton','HAMILTON HALLMARK'),(688704716800,'KofaxIma','KOFAX IMAGE PRODUCTS'),(688721494016,'Marquip','MARQUIP, INC.'),(688738271232,'Inventor','INVENTORY CONVERSION, INC./'),(688755048448,'CsComput','CS COMPUTER SYSTEME GmbH'),(688771825664,'MyriadLo','MYRIAD LOGIC INC.'),(688788602880,'BtgElect','BTG Electronics Design BV'),(688805380096,'AcerPeri','ACER PERIPHERALS, INC.'),(688822157312,'PuritanB','PURITAN BENNETT'),(688838934528,'AesProda','AES PRODATA'),(688855711744,'Jrl','JRL SYSTEMS, INC.'),(688872488960,'Kvb/Anal','KVB/ANALECT'),(688889266176,'Symantec','Symantec Corporation'),(688906043392,'Isa','ISA CO., LTD.'),(688922820608,'NetworkS','NETWORK SERVICES GROUP'),(688939597824,'Bhp','BHP LIMITED'),(688956375040,'Symmetri','Symmetricom, Inc.'),(688973152256,'Verilink','Verilink Corporation'),(688989929472,'DmsDorsc','DMS DORSCH MIKROSYSTEM GMBH'),(689006706688,'Shindeng','SHINDENGEN ELECTRIC MFG. CO., LT'),(689023483904,'Mannesma','MANNESMANN TALLY CORPORATION'),(689040261120,'Austron','AUSTRON, INC.'),(689057038336,'AppconGr','THE APPCON GROUP, INC.'),(689073815552,'Coastcom',''),(689090592768,'VideoLot','VIDEO LOTTERY TECHNOLOGIES,INC'),(689107369984,'Ovation','OVATION SYSTEMS LTD.'),(689124147200,'Com21','COM21, INC.'),(689140924416,'Percepti','PERCEPTION TECHNOLOGY'),(689157701632,'MicronTe','MICRON TECHNOLOGY, INC.'),(689174478848,'Cardware','CARDWARE LAB, INC.'),(689191256064,'FujitsuN','FUJITSU NEXION, INC.'),(689208033280,'MarconiC','Marconi Communications'),(689224810496,'AlpsElec','ALPS ELECTRIC (USA), INC.'),(689241587712,'Advanced','ADVANCED PERIPHERALS TECHNOLOGIE'),(689258364928,'DawnComp','DAWN COMPUTER INCORPORATION'),(689275142144,'TonyangN','TONYANG NYLON CO., LTD.'),(689291919360,'SeeqTech','SEEQ TECHNOLOGY, INC.'),(689308696576,'AvidTech','AVID TECHNOLOGY, INC.'),(689325473792,'Gsm-Synt','GSM-SYNTEL, LTD.'),(689342251008,'TattileS','Tattile SRL'),(689359028224,'AlcatelD','ALCATEL DATA NETWORKS'),(689375805440,'NktElekt','NKT ELEKTRONIK A/S'),(689392582656,'Asimmpho','ASIMMPHONY TURKEY'),(689409359872,'Dataplex','Dataplex Pty Ltd'),(689426137088,'Private',''),(689442914304,'AmberWav','AMBER WAVE SYSTEMS, INC.'),(689459691520,'ZarlinkS','Zarlink Semiconductor Ltd.'),(689476468736,'Essentia','ESSENTIAL COMMUNICATIONS'),(689493245952,'XpointTe','XPOINT TECHNOLOGIES, INC.'),(689510023168,'Brooktro','BROOKTROUT TECHNOLOGY, INC.'),(689526800384,'AstonEle','ASTON ELECTRONIC DESIGNS LTD.'),(689543577600,'Multimed','MultiMedia LANs, Inc.'),(689560354816,'Jacomo','JACOMO CORPORATION'),(689577132032,'CheckPoi','Check Point Software Technologie'),(689593909248,'Desknet','DESKNET SYSTEMS, INC.'),(689610686464,'Timestep','TimeStep Corporation'),(689627463680,'Applicom','APPLICOM INTERNATIONAL'),(689644240896,'HBollman','H. BOLLMANN MANUFACTURERS, LTD'),(689661018112,'B/EAeros','B/E AEROSPACE, Inc.'),(689677795328,'Comsat','COMSAT CORPORATION'),(689694572544,'AcaciaNe','ACACIA NETWORKS, INC.'),(689711349760,'MitsumiE','MITSUMI ELECTRIC CO., LTD.'),(689728126976,'JcInform','JC INFORMATION SYSTEMS'),(689744904192,'Netapp',''),(689761681408,'K-Net','K-NET LTD.'),(689778458624,'NihonKoh','NIHON KOHDEN AMERICA'),(689795235840,'QpsxComm','QPSX COMMUNICATIONS, LTD.'),(689812013056,'Xyplex','Xyplex, Inc.'),(689828790272,'Johnatho','JOHNATHON FREEMAN TECHNOLOGIES'),(689845567488,'Ictv',''),(689862344704,'Commvisi','COMMVISION CORP.'),(689879121920,'CompactD','COMPACT DATA, LTD.'),(689895899136,'EpicData','EPIC DATA INC.'),(689912676352,'DigicomS','DIGICOM S.P.A.'),(689929453568,'Reliable','RELIABLE POWER METERS'),(689946230784,'Micros','MICROS SYSTEMS, INC.'),(689963008000,'TeknorMi','TEKNOR MICROSYSTEME, INC.'),(689979785216,'MIKK','M.I. SYSTEMS, K.K.'),(689996562432,'Vorax','VORAX CORPORATION'),(690013339648,'Renex','RENEX CORPORATION'),(690030116864,'NavtelCo','NAVTEL COMMUNICATIONS INC.'),(690046894080,'Spacelab','SPACELABS MEDICAL'),(690063671296,'NetcsInf','NETCS INFORMATIONSTECHNIK GMBH'),(690080448512,'GilatSat','GILAT SATELLITE NETWORKS, LTD.'),(690097225728,'Marconi','MARCONI SPA'),(690114002944,'Nucom','NUCOM SYSTEMS, INC.'),(690130780160,'WmsIndus','WMS INDUSTRIES'),(690147557376,'I-ODataD','I-O DATA DEVICE, INC.'),(690164334592,'FirstVir','FIRST VIRTUAL CORPORATION'),(690181111808,'ShimaSei','SHIMA SEIKI'),(690197889024,'Zykronix',''),(690214666240,'TexasMic','TEXAS MICROSYSTEMS, INC.'),(690231443456,'3hTechno','3H TECHNOLOGY'),(690248220672,'SanritzA','SANRITZ AUTOMATION CO., LTD.'),(690264997888,'Cordant','CORDANT, INC.'),(690281775104,'SymbiosL','SYMBIOS LOGIC INC.'),(690298552320,'EagleTec','EAGLE TECHNOLOGY, INC.'),(690315329536,'PattonEl','PATTON ELECTRONICS CO.'),(690332106752,'Hilan','HILAN GMBH'),(690348883968,'Viasat','VIASAT, INCORPORATED'),(690365661184,'I-Tech','I-TECH CORP.'),(690382438400,'Integrat','INTEGRATED CIRCUIT SYSTEMS, INC.'),(690399215616,'Wireless','WIRELESS DATA GROUP MOTOROLA'),(690415992832,'DigitalL','DIGITAL LINK CORP.'),(690432770048,'OrtivusM','ORTIVUS MEDICAL AB'),(690449547264,'RA','R.A. SYSTEMS CO., LTD.'),(690466324480,'Unicompu','UNICOMPUTER GMBH'),(690483101696,'CristieE','CRISTIE ELECTRONICS LTD.'),(690499878912,'ZyxelCom','ZYXEL COMMUNICATION'),(690516656128,'Qualcomm','QUALCOMM INCORPORATED'),(690533433344,'TadiranT','TADIRAN TELECOMMUNICATIONS'),(690550210560,'Adtran','ADTRAN INC.'),(690566987776,'Intel-Hf','INTEL CORPORATION - HF1-06'),(690583764992,'FujitsuD','FUJITSU DENSO LTD.'),(690600542208,'ArkTelec','ARK TELECOMMUNICATIONS, INC.'),(690617319424,'Lite-OnC','LITE-ON COMMUNICATIONS, INC.'),(690634096640,'DrJohann','DR. JOHANNES HEIDENHAIN GmbH'),(690650873856,'Ecessa',''),(690667651072,'Sotas','SOTAS, INC.'),(690684428288,'TenXTech','TEN X TECHNOLOGY, INC.'),(690701205504,'Inventec','INVENTEC CORPORATION'),(690717982720,'AlliedTe','ALLIED TELESIS INTERNATIONAL COR'),(690734759936,'InstemCo','INSTEM COMPUTER SYSTEMS, LTD.'),(690751537152,'Radiolan','RADIOLAN,  INC.'),(690768314368,'SierraWi','SIERRA WIRELESS INC.'),(690785091584,'Sbe','SBE, INC.'),(690801868800,'KastenCh','KASTEN CHASE APPLIED RESEARCH'),(690818646016,'Spectra-','SPECTRA - TEK'),(690835423232,'ConvexCo','CONVEX COMPUTER CORPORATION'),(690852200448,'Integrat','INTEGRATED SYSTEMS Technology, I'),(690868977664,'FisherPa','FISHER & PAYKEL PRODUCTION'),(690885754880,'ONElectr','O.N. ELECTRONIC CO., LTD.'),(690902532096,'Azonix','AZONIX CORPORATION'),(690919309312,'Yamaha','YAMAHA CORPORATION'),(690936086528,'StsTechn','STS TECHNOLOGIES, INC.'),(690952863744,'Tennyson','TENNYSON TECHNOLOGIES PTY LTD'),(690969640960,'Westport','WESTPORT RESEARCH ASSOCIATES, IN'),(690986418176,'Keisokug','Keisokugiken Corporation'),(691003195392,'Xkl','XKL SYSTEMS CORP.'),(691019972608,'Optiques','OPTIQUEST'),(691036749824,'NhcCommu','NHC COMMUNICATIONS'),(691053527040,'Dialogic','DIALOGIC CORPORATION'),(691070304256,'CentralD','CENTRAL DATA CORPORATION'),(691087081472,'ReutersH','REUTERS HOLDINGS PLC'),(691103858688,'Electron','ELECTRONIC RETAILING SYSTEMS INT'),(691120635904,'Ethercom','ETHERCOM CORP.'),(691137413120,'EncoreNe','Encore Networks, Inc.'),(691154190336,'Transmit','TRANSMITTON LTD.'),(691170967552,'BrooksAu','Brooks Automation, Inc.'),(691187744768,'NashobaN','NASHOBA NETWORKS'),(691204521984,'Lucidata','LUCIDATA LTD.'),(691221299200,'TorontoM','TORONTO MICROELECTRONICS INC.'),(691238076416,'Mti',''),(691254853632,'InfotekC','INFOTEK COMMUNICATIONS, INC.'),(691271630848,'Staubli',''),(691288408064,'Ge',''),(691305185280,'Radguard','RADGUARD LTD.'),(691321962496,'Autogas','AutoGas Systems Inc.'),(691338739712,'VIComput','V.I COMPUTER CORP.'),(691355516928,'SymbolTe','SYMBOL TECHNOLOGIES, INC.'),(691372294144,'BintecCo','BINTEC COMMUNICATIONS GMBH'),(691389071360,'MarconiC','Marconi Communication GmbH'),(691405848576,'TorayEng','TORAY ENGINEERING CO., LTD.'),(691422625792,'ImageSci','IMAGE SCIENCES, INC.'),(691439403008,'ScitexDi','SCITEX DIGITAL PRINTING, INC.'),(691456180224,'BostonTe','BOSTON TECHNOLOGY, INC.'),(691472957440,'TellabsO','TELLABS OPERATIONS, INC.'),(695214276608,'Shenzhen','ShenZhen ShiHua Technology CO.,L'),(699442135040,'Inat','INAT GmbH'),(730144440320,'Intel','INTEL CORPORATION'),(730161217536,'Intel','INTEL CORPORATION'),(730177994752,'Intel','INTEL CORPORATION'),(731151073280,'Olivetti','OLIVETTI TELECOM SPA (OLTECO)'),(732023488512,'LgElectr','LG Electronics'),(756065239040,'GrassVal','Grass Valley Group'),(756300120064,'Infogear','InfoGear Technology Corp.'),(756333674496,'UtcCcs','UTC CCS'),(756384006144,'Westport','Westport Technologies'),(756417560576,'RanticLa','Rantic Labs, Inc.'),(756618887168,'Orsys','ORSYS GmbH'),(756669218816,'ViagateT','ViaGate Technologies, Inc.'),(756769882112,'Oao\"Izhe','OAO \"Izhevskiy radiozavod\"'),(756904099840,'HiqNetwo','HiQ Networks'),(757122203648,'MarconiC','Marconi Communications Inc.'),(757155758080,'Cisco','CISCO SYSTEMS, INC.'),(757289975808,'AtherosC','Atheros Communications'),(757591965696,'Cisco','CISCO SYSTEMS, INC.'),(757675851776,'Honewell','Honewell Oy'),(757742960640,'JonesFut','Jones Futurex Inc.'),(758061727744,'Mannesma','Mannesmann Ipulsys B.V.'),(758162391040,'Locsoft','LocSoft Limited'),(758296608768,'Cisco','CISCO SYSTEMS, INC.'),(758346940416,'Transmet','Transmeta Corp.'),(758397272064,'Alaris','Alaris, Inc.'),(758497935360,'MorrowTe','Morrow Technologies Corp.'),(758548267008,'PointGre','Point Grey Research Inc.'),(758799925248,'Siae-Mic','SIAE-Microelettronica S.p.A.'),(758833479680,'Symmetri','Symmetricom'),(758917365760,'Xstreami','Xstreamis PLC'),(759169024000,'Cisco','CISCO SYSTEMS, INC.'),(759252910080,'TellabsO','Tellabs Operations, Inc.'),(759370350592,'Technolo','TECHNOLOGY RESCUE'),(759403905024,'DellComp','Dell Computer Corp.'),(759588454400,'Nextcell','Nextcell, Inc.'),(759655563264,'Starboar','Starboard Storage Systems'),(759789780992,'BritishF','British Federal Ltd.'),(759873667072,'Eacem',''),(759907221504,'Ajile','Ajile Systems, Inc.'),(759940775936,'CalyNetw','CALY NETWORKS'),(760024662016,'Networth','NetWorth Technologies, Inc.'),(769738670080,'KontronD','Kontron Design Manufacturing Ser'),(769906442240,'Macrosan','MacroSAN Technologies Co., Ltd.'),(779217797120,'DavidEle','David Electronics Co., LTD.'),(780979404800,'Omnibit','Omnibit Inc.'),(788344602624,'NanjingS','Nanjing Shining Electric Automat'),(798696144896,'Shenzhen','Shenzhen Super Rich Electronics '),(802085142528,'Biometri','Biometric Access Company'),(803175661568,'Octothor','OCTOTHORPE CORP.'),(804131962880,'Private',''),(805541249024,'Hme','HME Co., Ltd.'),(807185416192,'Ungerman','UNGERMANN-BASS INC.'),(812403130368,'Exar','Exar Corp.'),(812721897472,'Nokia','Nokia Corporation'),(820691075072,'Genetec','Genetec Inc.'),(824633720832,'Lanoptic','LANOPTICS, LTD.'),(824650498048,'DiatekPa','DIATEK PATIENT MANAGMENT'),(824667275264,'Sercomm','SERCOMM CORPORATION'),(824684052480,'Globalne','GLOBALNET COMMUNICATIONS'),(824700829696,'JapanBus','JAPAN BUSINESS COMPUTER CO.LTD'),(824717606912,'Livingst','LIVINGSTON ENTERPRISES, INC.'),(824734384128,'NipponAv','NIPPON AVIONICS CO., LTD.'),(824751161344,'Pinnacle','PINNACLE DATA SYSTEMS, INC.'),(824767938560,'SecoSrl','SECO SRL'),(824784715776,'KtTechno','KT TECHNOLOGY (S) PTE LTD'),(824801492992,'MicroCra','MICRO CRAFT'),(824818270208,'Norcontr','NORCONTROL A.S.'),(824835047424,'ReliaTec','RELIA TECHNOLGIES'),(824851824640,'Advanced','ADVANCED LOGIC RESEARCH, INC.'),(824868601856,'Psitech','PSITECH, INC.'),(824885379072,'QuantumS','QUANTUM SOFTWARE SYSTEMS LTD.'),(824902156288,'Hirakawa','HIRAKAWA HEWTECH CORP.'),(824918933504,'Interact','INTERACTIVE COMPUTING DEVICES'),(824935710720,'Netspan','NETSPAN CORPORATION'),(824952487936,'Netrix',''),(824969265152,'Telemati','TELEMATICS CALABASAS INT`L,INC'),(824986042368,'NewMedia','NEW MEDIA CORPORATION'),(825002819584,'Electron','ELECTRONIC THEATRE CONTROLS'),(825019596800,'Fluke','Fluke Corporation'),(825036374016,'Lanart','LANART CORPORATION'),(825053151232,'LeapTech','LEAP TECHNOLOGY, INC.'),(825069928448,'Corometr','COROMETRICS MEDICAL SYSTEMS'),(825086705664,'SocketCo','SOCKET COMMUNICATIONS, INC.'),(825103482880,'Interlin','INTERLINK COMMUNICATIONS LTD.'),(825120260096,'GrandJun','GRAND JUNCTION NETWORKS, INC.'),(825137037312,'LaFranca','LA FRANCAISE DES JEUX'),(825153814528,'SERCEL','S.E.R.C.E.L.'),(825170591744,'ArcoElec','ARCO ELECTRONIC, CONTROL LTD.'),(825187368960,'Netexpre','NETEXPRESS'),(825204146176,'Lasermas','LASERMASTER TECHNOLOGIES, INC.'),(825220923392,'Tutankha','TUTANKHAMON ELECTRONICS'),(825237700608,'EdenSist','EDEN SISTEMAS DE COMPUTACAO SA'),(825254477824,'Dataprod','DATAPRODUCTS CORPORATION'),(825271255040,'LansTech','LANS TECHNOLOGY CO., LTD.'),(825288032256,'Cipher','CIPHER SYSTEMS, INC.'),(825304809472,'Jasco','JASCO CORPORATION'),(825321586688,'NexansDe','Nexans Deutschland GmbH - ANS'),(825338363904,'OhkuraEl','OHKURA ELECTRIC CO., LTD.'),(825355141120,'GerloffG','GERLOFF GESELLSCHAFT FUR'),(825371918336,'CentrumC','CENTRUM COMMUNICATIONS, INC.'),(825388695552,'FujiPhot','FUJI PHOTO FILM CO., LTD.'),(825405472768,'Netwiz',''),(825422249984,'Okuma','OKUMA CORPORATION'),(825439027200,'Integrat','INTEGRATED ENGINEERING B. V.'),(825455804416,'DesignRe','DESIGN RESEARCH SYSTEMS, INC.'),(825472581632,'I-Cubed','I-CUBED LIMITED'),(825489358848,'TelebitC','TELEBIT COMMUNICATIONS APS'),(825506136064,'Transact','TRANSACTION NETWORK'),(825522913280,'Quintar','QUINTAR COMPANY'),(825539690496,'RaytechE','RAYTECH ELECTRONIC CORP.'),(825556467712,'Dynatem',''),(825573244928,'RasterIm','RASTER IMAGE PROCESSING SYSTEM'),(825590022144,'Teridian','Teridian Semiconductor Corporati'),(825606799360,'Men-Mikr','MEN-MIKRO ELEKTRONIK GMBH'),(825623576576,'Multiacc','MULTIACCESS COMPUTING CORP.'),(825640353792,'TowerTec','TOWER TECH S.R.L.'),(825657131008,'Wieseman','WIESEMANN & THEIS GMBH'),(825673908224,'FaGebrHe','FA. GEBR. HELLER GMBH'),(825690685440,'StoresAu','STORES AUTOMATED SYSTEMS, INC.'),(825707462656,'Ecci',''),(825724239872,'DigitalT','DIGITAL TRANSMISSION SYSTEMS'),(825741017088,'Datalux','DATALUX CORP.'),(825757794304,'Strataco','STRATACOM'),(825774571520,'Emcom','EMCOM CORPORATION'),(825791348736,'Isolatio','ISOLATION SYSTEMS, LTD.'),(825808125952,'BlueChip','Blue Chip Technology Ltd'),(825824903168,'Unimicro','UNIMICRO SYSTEMS, INC.'),(825841680384,'BayTechn','BAY TECHNICAL ASSOCIATES'),(825858457600,'USRoboti','U.S. ROBOTICS, INC.'),(825875234816,'Group200','GROUP 2000 AG'),(825892012032,'Creative','CREATIVE MICROSYSTEMS'),(825908789248,'Departme','DEPARTMENT OF FOREIGN AFFAIRS'),(825925566464,'Mitec','MITEC, INC.'),(825942343680,'Comtrol','COMTROL CORPORATION'),(825959120896,'DellComp','DELL COMPUTER CORPORATION'),(825975898112,'ToyoDenk','TOYO DENKI SEIZO K.K.'),(825992675328,'Advanced','ADVANCED INTEGRATION RESEARCH'),(826009452544,'Burr-Bro','BURR-BROWN'),(826026229760,'AspectSo','Aspect Software Inc.'),(826043006976,'NetworkP','NETWORK PERIPHERALS, LTD.'),(826059784192,'ModularC','MODULAR COMPUTING TECHNOLOGIES'),(826076561408,'Somelec',''),(826093338624,'MycoElec','MYCO ELECTRONICS'),(826110115840,'Dataexpe','DATAEXPERT CORP.'),(826126893056,'Denso','DENSO CORPORATION'),(826143670272,'Semaphor','SEMAPHORE COMMUNICATIONS CORP.'),(826160447488,'Networks','NETWORKS NORTHWEST, INC.'),(826177224704,'Elonex','ELONEX PLC'),(826194001920,'L&NTechn','L&N TECHNOLOGIES'),(826210779136,'Vari-Lit','VARI-LITE, INC.'),(826227556352,'Fine-Pal','FINE-PAL COMPANY LIMITED'),(826244333568,'IdScandi','ID SCANDINAVIA AS'),(826261110784,'Solectek','SOLECTEK CORPORATION'),(826277888000,'ImpulseT','IMPULSE TECHNOLOGY'),(826294665216,'MorningS','MORNING STAR TECHNOLOGIES, INC'),(826311442432,'GeneralD','GENERAL DATACOMM IND. INC.'),(826328219648,'ScopeCom','SCOPE COMMUNICATIONS, INC.'),(826344996864,'Docupoin','DOCUPOINT, INC.'),(826361774080,'UnitedBa','UNITED BARCODE INDUSTRIES'),(826378551296,'HmeClear','HME Clear-Com LTD.'),(826395328512,'Axxceler','Axxcelera Broadband Wireless'),(826412105728,'Zahner-E','ZAHNER-ELEKTRIK GMBH & CO. KG'),(826428882944,'OsiPlus','OSI PLUS CORPORATION'),(826445660160,'SvecComp','SVEC COMPUTER CORP.'),(826462437376,'BocaRese','BOCA RESEARCH, INC.'),(826479214592,'HaftTech','HAFT TECHNOLOGY, INC.'),(826495991808,'Komatsu','KOMATSU LTD.'),(826512769024,'SectraSe','SECTRA SECURE-TRANSMISSION AB'),(826529546240,'AreanexC','AREANEX COMMUNICATIONS, INC.'),(826546323456,'Knx','KNX LTD.'),(826563100672,'Xedia','XEDIA CORPORATION'),(826579877888,'ToyodaAu','TOYODA AUTOMATIC LOOM'),(826596655104,'Xante','XANTE CORPORATION'),(826613432320,'I-DataIn','I-DATA INTERNATIONAL A-S'),(826630209536,'DaewooTe','DAEWOO TELECOM LTD.'),(826646986752,'Computer','COMPUTER SYSTEMS ENGINEERING'),(826663763968,'Fonsys','FONSYS CO.,LTD.'),(826680541184,'PrivaBV','PRIVA B.V.'),(826697318400,'AscendCo','ASCEND COMMUNICATIONS, INC.'),(826714095616,'Hightech','HIGHTECH INFORMATION'),(826730872832,'RiscDeve','RISC DEVELOPMENTS LTD.'),(826747650048,'KubotaEl','KUBOTA CORPORATION ELECTRONIC'),(826764427264,'NuponCom','NUPON COMPUTING CORP.'),(826781204480,'Netstar','NETSTAR, INC.'),(826797981696,'Metrodat','METRODATA LTD.'),(826814758912,'MoorePro','MOORE PRODUCTS CO.'),(826831536128,'TraceMou','TRACE MOUNTAIN PRODUCTS, INC.'),(826848313344,'DataLink','DATA LINK CORP. LTD.'),(826865090560,'Electron','ELECTRONICS FOR IMAGING, INC.'),(826881867776,'Lynk','THE LYNK CORPORATION'),(826898644992,'UunetTec','UUNET TECHNOLOGIES, INC.'),(826915422208,'EkfElekt','EKF ELEKTRONIK GMBH'),(826932199424,'Telindus','TELINDUS DISTRIBUTION'),(826948976640,'Lauterba','Lauterbach GmbH'),(826965753856,'RisqModu','RISQ MODULAR SYSTEMS, INC.'),(826982531072,'Performa','PERFORMANCE TECHNOLOGIES, INC.'),(826999308288,'TronixPr','TRONIX PRODUCT DEVELOPMENT'),(827016085504,'NetworkI','NETWORK INFORMATION TECHNOLOGY'),(827032862720,'Panasoni','Panasonic Electric Works Co., Lt'),(827049639936,'PraimSRL','PRAIM S.R.L.'),(827066417152,'JabilCir','JABIL CIRCUIT, INC.'),(827083194368,'MennenMe','MENNEN MEDICAL INC.'),(827099971584,'AltaRese','ALTA RESEARCH CORP.'),(827116748800,'Vmx','VMX INC.'),(827133526016,'Znyx',''),(827150303232,'Tamura','TAMURA CORPORATION'),(827167080448,'Archipel','ARCHIPEL SA'),(827183857664,'ChuntexE','CHUNTEX ELECTRONIC CO., LTD.'),(827200634880,'YoshikiI','YOSHIKI INDUSTRIAL CO.,LTD.'),(827217412096,'Photonic','PHOTONICS CORPORATION'),(827234189312,'Reliance','RELIANCE COMM/TEC, R-TEC'),(827250966528,'HiokiEE','HIOKI E.E. CORPORATION'),(827267743744,'Distribu','DISTRIBUTED SYSTEMS INT`L, INC'),(827284520960,'CacheCom','CACHE COMPUTERS, INC.'),(827301298176,'QuantaCo','QUANTA COMPUTER, INC.'),(827318075392,'AdvanceM','ADVANCE MICRO RESEARCH, INC.'),(827334852608,'TokyoDen','TOKYO DENSHI SEKEI CO.'),(827351629824,'Intermed','INTERMEDIUM A/S'),(827368407040,'DualEnte','DUAL ENTERPRISES CORPORATION'),(827385184256,'UnigrafO','UNIGRAF OY'),(827401961472,'DickensD','DICKENS DATA SYSTEMS'),(827418738688,'ExicomAu','EXICOM AUSTRALIA PTY. LTD'),(827435515904,'Seel','SEEL LTD.'),(827452293120,'Gvc','GVC CORPORATION'),(827469070336,'BarronMc','BARRON MCCANN LTD.'),(827485847552,'SiliconV','SILICON VALLEY COMPUTER'),(827502624768,'Telco','Telco Systems, Inc.'),(827519401984,'GambitCo','GAMBIT COMPUTER COMMUNICATIONS'),(827536179200,'MarbenCo','MARBEN COMMUNICATION SYSTEMS'),(827552956416,'Towercom','TOWERCOM CO. INC. DBA PC HOUSE'),(827569733632,'Teklogix','TEKLOGIX INC.'),(827586510848,'GccTechn','GCC TECHNOLOGIES,INC.'),(827603288064,'GeniusNe','GENIUS NET CO.'),(827620065280,'Norand','NORAND CORPORATION'),(827636842496,'ComstatD','COMSTAT DATACOMM CORPORATION'),(827653619712,'MysonTec','MYSON TECHNOLOGY, INC.'),(827670396928,'Corporat','CORPORATE NETWORK SYSTEMS,INC.'),(827687174144,'Overland','Overland Storage, Inc.'),(827703951360,'American','AMERICAN POWER CONVERSION CORP'),(827720728576,'FraserSH','FRASER`S HILL LTD.'),(827737505792,'FunkSoft','FUNK SOFTWARE, INC.'),(827754283008,'Netvanta','NETVANTAGE'),(827771060224,'ForvalCr','FORVAL CREATIVE, INC.'),(827787837440,'TelecomA','TELECOM AUSTRALIA/CSSC'),(827804614656,'InexTech','INEX TECHNOLOGIES, INC.'),(827821391872,'Alcatel-','ALCATEL - SEL'),(827838169088,'Technolo','TECHNOLOGY CONCEPTS, LTD.'),(827854946304,'ShoreMic','SHORE MICROSYSTEMS, INC.'),(827871723520,'Quad/Gra','QUAD/GRAPHICS, INC.'),(827888500736,'Infinite','INFINITE NETWORKS LTD.'),(827905277952,'AcusonCo','ACUSON COMPUTED SONOGRAPHY'),(827922055168,'Computer','COMPUTER OPERATIONAL'),(827938832384,'SidInfor','SID INFORMATICA'),(827955609600,'Personal','PERSONAL MEDIA CORP.'),(827972386816,'Sparktru','SPARKTRUM MICROSYSTEMS, INC.'),(827989164032,'MicroByt','MICRO BYTE PTY. LTD.'),(828005941248,'ElsagBai','ELSAG BAILEY PROCESS'),(828022718464,'Alfa','ALFA, INC.'),(828039495680,'ControlT','CONTROL TECHNOLOGY CORPORATION'),(828056272896,'Telescie','TELESCIENCES CO SYSTEMS, INC.'),(828073050112,'ComeltaS','COMELTA, S.A.'),(828089827328,'CeiEngin','CEI SYSTEMS & ENGINEERING PTE'),(828106604544,'ImatranV','IMATRAN VOIMA OY'),(828123381760,'RatocSys','RATOC SYSTEM INC.'),(828140158976,'ComtreeT','COMTREE TECHNOLOGY CORPORATION'),(828156936192,'Syntelle','SYNTELLECT, INC.'),(828173713408,'OlympusI','OLYMPUS IMAGE SYSTEMS, INC.'),(828190490624,'AxonNetw','AXON NETWORKS, INC.'),(828207267840,'Werbeage','Werbeagentur JÃ¼rgen Siebert'),(828224045056,'J1','J1 SYSTEMS, INC.'),(828240822272,'TaiwanTr','TAIWAN TRADING CENTER DBA'),(828257599488,'Universa','UNIVERSAL DATA SYSTEMS'),(828274376704,'QuinteNe','QUINTE NETWORK CONFIDENTIALITY'),(828291153920,'Nice','NICE SYSTEMS LTD.'),(828307931136,'IpcPte','IPC CORPORATION (PTE) LTD.'),(828324708352,'EosTechn','EOS TECHNOLOGIES, INC.'),(828341485568,'Qlogic','QLogic Corporation'),(828358262784,'Zcomm','ZCOMM, INC.'),(828375040000,'Kye','KYE Systems Corp.'),(828391817216,'DscCommu','DSC COMMUNICATION CORP.'),(828408594432,'SonicSol','SONIC SOLUTIONS'),(828425371648,'Calcomp','CALCOMP, INC.'),(828442148864,'OsitechC','OSITECH COMMUNICATIONS, INC.'),(828458926080,'SiemensB','SIEMENS BUILDING'),(828475703296,'GespacSA','GESPAC, S.A.'),(828492480512,'Verilink','Verilink Corporation'),(828509257728,'Fiberdat','FIBERDATA AB'),(828526034944,'Plexcom','PLEXCOM, INC.'),(828542812160,'OakSolut','OAK SOLUTIONS, LTD.'),(828559589376,'ArrayTec','ARRAY TECHNOLOGY LTD.'),(828576366592,'SehCompu','SEH COMPUTERTECHNIK GMBH'),(828593143808,'DauphinT','DAUPHIN TECHNOLOGY'),(828609921024,'UsArmyEl','US ARMY ELECTRONIC'),(828626698240,'Kyocera','KYOCERA CORPORATION'),(828643475456,'Abit','ABIT CORPORATION'),(828660252672,'Kingston','KINGSTON TECHNOLOGY CORP.'),(828677029888,'ShinkoEl','SHINKO ELECTRIC CO., LTD.'),(828693807104,'Transiti','TRANSITION NETWORKS'),(828710584320,'NetworkC','NETWORK COMMUNICATIONS CORP.'),(828727361536,'Interlin','INTERLINK SYSTEM CO., LTD.'),(828744138752,'Metacomp','METACOMP, INC.'),(828760915968,'CelanTec','CELAN TECHNOLOGY INC.'),(828777693184,'EngageCo','ENGAGE COMMUNICATION, INC.'),(828794470400,'AboutCom','ABOUT COMPUTING INC.'),(828811247616,'EmersonN','Emerson Network Power'),(828828024832,'CanaryCo','CANARY COMMUNICATIONS, INC.'),(828844802048,'Advanced','ADVANCED TECHNOLOGY LABS'),(828861579264,'ElasticR','ELASTIC REALITY, INC.'),(828878356480,'Prosum',''),(828895133696,'AptecCom','APTEC COMPUTER SYSTEMS, INC.'),(828911910912,'DotHill','DOT HILL SYSTEMS CORPORATION'),(830254088192,'Ddl','DDL Co,.ltd.'),(836545544192,'IntelCor','Intel Corporate'),(849782767616,'Datatech','Datatech Sistemas Digitales Avan'),(850671960064,'Apple','Apple, Inc.'),(875049254912,'Cambridg','Cambridge Broadband Networks Ltd'),(882884214784,'MasElekt','MAS Elektronik AG'),(889527992320,'Communic','COMMUNICATION MACHINERY CORP.'),(893353197568,'FerranSc','FERRAN SCIENTIFIC, INC.'),(893369974784,'VstTechn','VST TECHNOLOGIES, INC.'),(893386752000,'Ditech','DITECH CORPORATION'),(893403529216,'ComdaEnt','COMDA ENTERPRISES CORP.'),(893420306432,'Pentacom','PENTACOM LTD.'),(893437083648,'ZhsZeitm','ZHS ZEITMANAGEMENTSYSTEME'),(893453860864,'Cisco','CISCO SYSTEMS, INC.'),(893470638080,'MicAssoc','MIC ASSOCIATES, INC.'),(893487415296,'Mactell','MACTELL CORPORATION'),(893504192512,'HsingTec','HSING TECH. ENTERPRISE CO. LTD'),(893520969728,'Lanacces','LANACCESS TELECOM S.A.'),(893537746944,'RhkTechn','RHK TECHNOLOGY, INC.'),(893554524160,'SnijderM','SNIJDER MICRO SYSTEMS'),(893571301376,'Micromer','MICROMERITICS INSTRUMENT'),(893588078592,'Pluris','PLURIS, INC.'),(893604855808,'SpeechDe','SPEECH DESIGN GMBH'),(893621633024,'Converge','CONVERGENT NETWORKS, INC.'),(893638410240,'PrismVid','PRISM VIDEO, INC.'),(893655187456,'Gatework','GATEWORKS CORP.'),(893671964672,'PrimexAe','PRIMEX AEROSPACE COMPANY'),(893688741888,'Root','ROOT, INC.'),(893705519104,'UnivexMi','UNIVEX MICROTECHNOLOGY CORP.'),(893722296320,'ScmMicro','SCM MICROSYSTEMS, INC.'),(893739073536,'SyntechI','SYNTECH INFORMATION CO., LTD.'),(893755850752,'QwesCom','QWES. COM, INC.'),(893772627968,'Dainippo','DAINIPPON SCREEN CORPORATE'),(893789405184,'UrmetTlc','URMET  TLC S.P.A.'),(893806182400,'MimakiEn','MIMAKI ENGINEERING CO., LTD.'),(893822959616,'SbsTechn','SBS TECHNOLOGIES,'),(893839736832,'FurunoEl','FURUNO ELECTRIC CO., LTD.'),(893856514048,'Pingtel','PINGTEL CORP.'),(893873291264,'CtamPty','CTAM PTY. LTD.'),(893890068480,'AimSyste','AIM SYSTEM, INC.'),(893906845696,'RegentEl','REGENT ELECTRONICS CORP.'),(893923622912,'Incredib','INCREDIBLE TECHNOLOGIES, INC.'),(893940400128,'Infortre','INFORTREND TECHNOLOGY, INC.'),(893957177344,'Cognex','Cognex Corporation'),(893973954560,'Xrosstec','XROSSTECH, INC.'),(893990731776,'Hirschma','HIRSCHMANN AUSTRIA GMBH'),(894007508992,'AppliedA','APPLIED AUTOMATION, INC.'),(894024286208,'Harmonic','Harmonic, Inc'),(894041063424,'Wakefern','WAKEFERN FOOD CORPORATION'),(894057840640,'Voxent','Voxent Systems Ltd.'),(894074617856,'Jetcell','JETCELL, INC.'),(894091395072,'Campbell','CAMPBELL SCIENTIFIC, INC.'),(894108172288,'Ademco',''),(894124949504,'Communic','COMMUNICATION AUTOMATION CORP.'),(894141726720,'VlsiTech','VLSI TECHNOLOGY INC.'),(894158503936,'Safetran','Safetran Systems Corp'),(894175281152,'Industri','INDUSTRIAL LOGIC CORPORATION'),(894192058368,'YanoElec','YANO ELECTRIC CO., LTD.'),(894208835584,'DalianDa','DALIAN DAXIAN NETWORK'),(894225612800,'Ormec','ORMEC SYSTEMS CORP.'),(894242390016,'Behavior','BEHAVIOR TECH. COMPUTER CORP.'),(894259167232,'Technolo','TECHNOLOGY ATLANTA CORP.'),(894275944448,'PaceFran','Pace France'),(894292721664,'Fivemere','FIVEMERE, LTD.'),(894309498880,'Utilicom','UTILICOM, INC.'),(894326276096,'Zoneworx','ZONEWORX, INC.'),(894343053312,'VisionPr','VISION PRODUCTS PTY. LTD.'),(894359830528,'Vieo','Vieo, Inc.'),(894376607744,'GalileoT','GALILEO TECHNOLOGY, LTD.'),(894393384960,'Rocketch','ROCKETCHIPS, INC.'),(894410162176,'American','AMERICAN COMMUNICATION'),(894426939392,'Sysmate','SYSMATE CO., LTD.'),(894443716608,'AmigoTec','AMIGO TECHNOLOGY CO., LTD.'),(894460493824,'MahloUg','MAHLO GMBH & CO. UG'),(894477271040,'ZonalRet','ZONAL RETAIL DATA SYSTEMS'),(894494048256,'AlidianN','ALIDIAN NETWORKS, INC.'),(894510825472,'Kvaser','KVASER AB'),(894527602688,'DolbyLab','DOLBY LABORATORIES, INC.'),(894544379904,'XnTechno','XN TECHNOLOGIES'),(894561157120,'Ecton','ECTON, INC.'),(894577934336,'Impresst','IMPRESSTEK CO., LTD.'),(894594711552,'Presence','PRESENCE TECHNOLOGY GMBH'),(894611488768,'LaCieGro','LA CIE GROUP S.A.'),(894628265984,'EurotelT','EUROTEL TELECOM LTD.'),(894645043200,'DivOfRes','DIV OF RESEARCH & STATISTICS'),(894661820416,'Logibag',''),(894678597632,'Bitronic','BITRONICS, INC.'),(894695374848,'Iskratel',''),(894712152064,'O2Micro','O2 MICRO, INC.'),(894728929280,'AscendCo','ASCEND COMMUNICATIONS, INC.'),(894745706496,'Connecte','CONNECTED SYSTEMS'),(894762483712,'SasInsti','SAS INSTITUTE INC.'),(894779260928,'Kathrein','KATHREIN-WERKE KG'),(894796038144,'Somat','SOMAT CORPORATION'),(894812815360,'Ultrak','ULTRAK, INC.'),(894829592576,'Cisco','CISCO SYSTEMS, INC.'),(894846369792,'AmbitMic','AMBIT MICROSYSTEMS CORP.'),(894863147008,'Symbioni','SYMBIONICS, LTD.'),(894879924224,'Acroloop','ACROLOOP MOTION CONTROL'),(894896701440,'Technotr','TECHNOTREND SYSTEMTECHNIK GMBH'),(894913478656,'Intelliw','INTELLIWORXX, INC.'),(894930255872,'Stratabe','STRATABEAM TECHNOLOGY, INC.'),(894947033088,'Valcom','VALCOM, INC.'),(894963810304,'Panasoni','Panasonic Europe Ltd.'),(894980587520,'TremonEn','TREMON ENTERPRISES CO., LTD.'),(894997364736,'Digigram',''),(895014141952,'Cisco','CISCO SYSTEMS, INC.'),(895030919168,'Multitel',''),(895047696384,'TokoElec','TOKO ELECTRIC'),(895064473600,'Wintriss','WINTRISS ENGINEERING CORP.'),(895081250816,'CampioCo','CAMPIO COMMUNICATIONS'),(895098028032,'Iwill','IWILL CORPORATION'),(895114805248,'Technolo','TECHNOLOGIC SYSTEMS'),(895131582464,'Linkup','LINKUP SYSTEMS CORPORATION'),(895148359680,'SrTeleco','SR TELECOM INC.'),(895165136896,'Sharewav','SHAREWAVE, INC.'),(895181914112,'Acrison','ACRISON, INC.'),(895198691328,'Trendvie','TRENDVIEW RECORDERS LTD.'),(895215468544,'KmcContr','KMC CONTROLS'),(895232245760,'LongWell','LONG WELL ELECTRONICS CORP.'),(895249022976,'Echelon','ECHELON CORP.'),(895265800192,'Broadlog','BROADLOGIC'),(895282577408,'AcnAdvan','ACN ADVANCED COMMUNICATIONS'),(895299354624,'Taqua','TAQUA SYSTEMS, INC.'),(895316131840,'AlarisMe','ALARIS MEDICAL SYSTEMS, INC.'),(895332909056,'BankOfAm','Bank of America'),(895349686272,'LucentTe','LUCENT TECHNOLOGIES'),(895366463488,'EltexOfS','Eltex of Sweden AB'),(895383240704,'Cisco','CISCO SYSTEMS, INC.'),(895400017920,'Amaquest','AMAQUEST COMPUTER CORP.'),(895416795136,'ComcamIn','COMCAM INTERNATIONAL INC'),(895433572352,'KoyoElec','KOYO ELECTRONICS INC. CO.,LTD.'),(895450349568,'CosineCo','COSINE COMMUNICATIONS'),(895467126784,'Keycorp','KEYCORP LTD.'),(895483904000,'Strategy','STRATEGY & TECHNOLOGY, LIMITED'),(895500681216,'Exabyte','EXABYTE CORPORATION'),(895517458432,'RtdEmbed','RTD Embedded Technologies, Inc.'),(895534235648,'Iowave','IOWAVE INC.'),(895551012864,'Invertex','INVERTEX, INC.'),(895567790080,'Nexcomm','NEXCOMM SYSTEMS, INC.'),(895584567296,'OtisElev','OTIS ELEVATOR COMPANY'),(895601344512,'Foveon','FOVEON, INC.'),(895618121728,'Microfir','MICROFIRST INC.'),(895634898944,'Motorola','Motorola, Inc.'),(895651676160,'Dynacolo','DYNACOLOR, INC.'),(895668453376,'PhotronU','PHOTRON USA'),(895685230592,'AdvaOpti','ADVA Optical Networking Ltd.'),(895702007808,'GenoaTec','GENOA TECHNOLOGY, INC.'),(895718785024,'PhoenixG','PHOENIX GROUP, INC.'),(895735562240,'Nvision','NVISION INC.'),(895752339456,'ArdentTe','ARDENT TECHNOLOGIES, INC.'),(895769116672,'Cisco','CISCO SYSTEMS, INC.'),(895785893888,'Smartsan','SMARTSAN SYSTEMS, INC.'),(895802671104,'Glenayre','GLENAYRE WESTERN MULTIPLEX'),(895819448320,'Tq-Compo','TQ - COMPONENTS GMBH'),(895836225536,'Timeline','TIMELINE VISTA, INC.'),(895853002752,'Alcatel-','Alcatel-Lucent, Enterprise Busin'),(895869779968,'3comEuro','3COM EUROPE LTD.'),(895886557184,'Cisco','CISCO SYSTEMS, INC.'),(895903334400,'PhotonDy','Photon Dynamics Canada Inc.'),(895920111616,'ElcardWi','Elcard Wireless Systems Oy'),(895936888832,'Filanet','FILANET CORPORATION'),(895953666048,'Spectel','SPECTEL LTD.'),(895970443264,'KapadiaC','KAPADIA COMMUNICATIONS'),(895987220480,'VerisInd','VERIS INDUSTRIES'),(896003997696,'2wire','2WIRE, INC.'),(896020774912,'NovtekTe','NOVTEK TEST SYSTEMS'),(896037552128,'MipsDenm','MIPS DENMARK'),(896054329344,'OskarVie','OSKAR VIERLING GMBH + CO. KG'),(896071106560,'Integrat','INTEGRATED DEVICE'),(896087883776,'VocalDat','VOCAL DATA, INC.'),(896104660992,'AlantroC','ALANTRO COMMUNICATIONS'),(896121438208,'American','AMERICAN ARIUM'),(896138215424,'LanbirdT','LANBIRD TECHNOLOGY CO., LTD.'),(896154992640,'TokyoSok','TOKYO SOKKI KENKYUJO CO., LTD.'),(896171769856,'NetworkE','NETWORK ENGINES, INC.'),(896188547072,'ShinanoK','SHINANO KENSHI CO., LTD.'),(896205324288,'ChaseCom','CHASE COMMUNICATIONS'),(896222101504,'Deltakab','DELTAKABEL TELECOM CV'),(896238878720,'GraysonW','GRAYSON WIRELESS'),(896255655936,'TlIndust','TL INDUSTRIES'),(896272433152,'OresisCo','ORESIS COMMUNICATIONS, INC.'),(896289210368,'Cutler-H','CUTLER-HAMMER, INC.'),(896305987584,'Bitswitc','BITSWITCH LTD.'),(896322764800,'OmegaEle','OMEGA ELECTRONICS SA'),(896339542016,'Xiotech','XIOTECH CORPORATION'),(896356319232,'DrsTechn','DRS Technologies Canada Ltd'),(896373096448,'Katsujim','KATSUJIMA CO., LTD.'),(896389873664,'IpricotF','IPricot formerly DotCom'),(896406650880,'Crescent','CRESCENT NETWORKS, INC.'),(896423428096,'Intel','INTEL CORPORATION'),(896440205312,'Iomega','Iomega Corporation'),(896456982528,'Microtek','MICROTEK INTERNATIONAL, INC.'),(896473759744,'Cisco','CISCO SYSTEMS, INC.'),(896490536960,'Cisco','CISCO SYSTEMS, INC.'),(896507314176,'Cisco','CISCO SYSTEMS, INC.'),(896524091392,'SiliconI','Silicon Image GmbH'),(896540868608,'Emutec','EMUTEC INC.'),(896557645824,'PivotalT','PIVOTAL TECHNOLOGIES'),(896574423040,'Cisco','CISCO SYSTEMS, INC.'),(896591200256,'Harmonic','HARMONIC DATA SYSTEMS, LTD.'),(896607977472,'Balthaza','BALTHAZAR TECHNOLOGY AB'),(896624754688,'VividTec','VIVID TECHNOLOGY PTE, LTD.'),(896641531904,'Teratech','TERATECH CORPORATION'),(896658309120,'Computat','COMPUTATIONAL SYSTEMS, INC.'),(896675086336,'ThomasBe','THOMAS & BETTS CORP.'),(896691863552,'Pathway','PATHWAY, INC.'),(896708640768,'Prevas','Prevas A/S'),(896725417984,'Advantec','ADVANTECH CO., LTD.'),(896742195200,'Intrinsy','Intrinsyc Software International'),(896758972416,'Dasan','DASAN CO., LTD.'),(896775749632,'Technolo','TECHNOLOGIES LYRE INC.'),(896792526848,'AtanTech','ATAN TECHNOLOGY INC.'),(896809304064,'AsystEle','ASYST ELECTRONIC'),(896826081280,'MoretonB','MORETON BAY'),(896842858496,'Zhongxin','ZHONGXING TELECOM LTD.'),(896859635712,'Sycamore','Sycamore Networks'),(896876412928,'Epilog','EPILOG CORPORATION'),(896893190144,'Cisco','CISCO SYSTEMS, INC.'),(896909967360,'V-Bits','V-BITS, INC.'),(896926744576,'Grundig','GRUNDIG AG'),(896943521792,'AethraTe','AETHRA TELECOMUNICAZIONI'),(896960299008,'B2c2','B2C2, INC.'),(896977076224,'3com','3Com Corporation'),(896993853440,'Dedicate','DEDICATED MICROCOMPUTERS'),(897010630656,'TaicomDa','TAICOM DATA SYSTEMS CO., LTD.'),(897027407872,'McquayIn','MCQUAY INTERNATIONAL'),(897044185088,'ModularM','MODULAR MINING SYSTEMS, INC.'),(897060962304,'SunriseT','SUNRISE TELECOM, INC.'),(897077739520,'PhilipsM','PHILIPS MULTIMEDIA NETWORK'),(897094516736,'KuzumiEl','KUZUMI ELECTRONICS, INC.'),(897111293952,'DooinEle','DOOIN ELECTRONICS CO.'),(897128071168,'Avionite','AVIONITEK ISRAEL INC.'),(897144848384,'MrtMicro','MRT MICRO, INC.'),(897161625600,'Ele-Chem','ELE-CHEM ENGINEERING CO., LTD.'),(897178402816,'Cisco','CISCO SYSTEMS, INC.'),(897195180032,'Solidum','SOLIDUM SYSTEMS CORP.'),(897211957248,'Ibond','IBOND INC.'),(897228734464,'VconTele','VCON TELECOMMUNICATION LTD.'),(897245511680,'MacSyste','MAC SYSTEM CO., LTD.'),(897262288896,'Advantag','Advantage Century Telecommunicat'),(897279066112,'NextoneC','NEXTONE COMMUNICATIONS, INC.'),(897295843328,'Lightera','LIGHTERA NETWORKS, INC.'),(897312620544,'NakayoTe','NAKAYO TELECOMMUNICATIONS, INC'),(897329397760,'Xiox',''),(897346174976,'Dictapho','DICTAPHONE CORPORATION'),(897362952192,'Igt',''),(897379729408,'Convisio','CONVISION TECHNOLOGY GMBH'),(897396506624,'SegaEnte','SEGA ENTERPRISES, LTD.'),(897413283840,'Monterey','MONTEREY NETWORKS'),(897430061056,'SolariDi','SOLARI DI UDINE SPA'),(897446838272,'Carinthi','CARINTHIAN TECH INSTITUTE'),(897463615488,'OrangeMi','ORANGE MICRO, INC.'),(897480392704,'AlcatelC','Alcatel Canada'),(897497169920,'NextNets','NEXT NETS CORPORATION'),(897513947136,'FujianSt','FUJIAN STAR TERMINAL'),(897530724352,'AcuteCom','ACUTE COMMUNICATIONS CORP.'),(897547501568,'ThalesE-','Thales e-Security Ltd.'),(897564278784,'TekMicro','TEK MICROSYSTEMS, INCORPORATED'),(897581056000,'GraniteM','GRANITE MICROSYSTEMS'),(897597833216,'OptimaTe','OPTIMA TELE.COM, INC.'),(897614610432,'AstralPo','ASTRAL POINT'),(897631387648,'Cisco','CISCO SYSTEMS, INC.'),(898117926912,'Acetel',''),(908603686912,'HotelTec','Hotel Technology Next Generation'),(919961862144,'GeEnergy','GE Energy'),(941101154304,'AlbedoTe','Albedo Telecom SL'),(941755465728,'Thamway','THAMWAY CO.,LTD.'),(944339156992,'IntelCor','Intel Corporate'),(949187772416,'Ungerman','UNGERMANN-BASS INC.'),(949204549632,'Ungerman','UNGERMANN-BASS INC.'),(949221326848,'Ungerman','UNGERMANN-BASS INC.'),(949238104064,'Ungerman','UNGERMANN-BASS INC.'),(949254881280,'Ungerman','UNGERMANN-BASS INC.'),(949271658496,'Ungerman','UNGERMANN-BASS INC.'),(949288435712,'Ungerman','UNGERMANN-BASS INC.'),(949305212928,'Ungerman','UNGERMANN-BASS INC.'),(949321990144,'Ungerman','UNGERMANN-BASS INC.'),(949338767360,'Ungerman','UNGERMANN-BASS INC.'),(949355544576,'Ungerman','UNGERMANN-BASS INC.'),(949372321792,'Ungerman','UNGERMANN-BASS INC.'),(949389099008,'Ungerman','UNGERMANN-BASS INC.'),(949405876224,'Ungerman','UNGERMANN-BASS INC.'),(949422653440,'Ungerman','UNGERMANN-BASS INC.'),(949439430656,'Ungerman','UNGERMANN-BASS INC.'),(957693820928,'Cisco','CISCO SYSTEMS, INC.'),(962072674304,'Fujitsu','Fujitsu Limited'),(962089451520,'StrandLi','STRAND LIGHTING LIMITED'),(962106228736,'Crossroa','CROSSROADS SYSTEMS, INC.'),(962123005952,'NokiaWir','NOKIA WIRELESS BUSINESS COMMUN'),(962139783168,'Pmc-Sier','PMC-SIERRA, INC.'),(962156560384,'Technica','TECHNICAL CORP.'),(962173337600,'SiliconI','SILICON INTEGRATED SYS. CORP.'),(962190114816,'AvayaEcs','Avaya ECS Ltd'),(962206892032,'AmazingC','AMAZING CONTROLS! INC.'),(962223669248,'Marathon','MARATHON TECHNOLOGIES CORP.'),(962240446464,'Diba','DIBA, INC.'),(962257223680,'RooftopC','ROOFTOP COMMUNICATIONS CORP.'),(962274000896,'Motorola',''),(962290778112,'Radiant','RADIANT SYSTEMS'),(962307555328,'AvalonIm','AVALON IMAGING SYSTEMS, INC.'),(962324332544,'Shanghai','SHANGHAI BAUD DATA'),(962341109760,'HessSb-A','HESS SB-AUTOMATENBAU GmbH'),(962357886976,'Uniden','Uniden Corporation'),(962374664192,'PlutoTec','PLUTO TECHNOLOGIES INTERNATIONAL'),(962391441408,'EasternE','EASTERN ELECTRONIC CO., LTD.'),(962408218624,'Cisco','CISCO SYSTEMS, INC.'),(962424995840,'Heiwa','HEIWA CORPORATION'),(962441773056,'RapidCit','RAPID CITY COMMUNICATIONS'),(962458550272,'Exxact','EXXACT GmbH'),(962475327488,'AsustekC','ASUSTEK COMPUTER INC.'),(962492104704,'IngGiord','ING. GIORDANO ELETTRONICA'),(962508881920,'Comtec','COMTEC SYSTEMS. CO., LTD.'),(962525659136,'SphereCo','SPHERE COMMUNICATIONS, INC.'),(962542436352,'Cradlepo','Cradlepoint, Inc'),(962559213568,'WebtvNet','WebTV NETWORKS, INC.'),(962575990784,'Cisco','CISCO SYSTEMS, INC.'),(962592768000,'Avidia','AVIDIA Systems, Inc.'),(962609545216,'Tecnomen','TECNOMEN OY'),(962626322432,'Freegate','FREEGATE CORP.'),(962643099648,'AnalogDe','Analog Devices Inc.'),(962659876864,'Telrad',''),(962676654080,'GadzooxN','GADZOOX NETWORKS'),(962693431296,'Dit','dit Co., Ltd.'),(962710208512,'RedlakeM','Redlake MASD LLC'),(962726985728,'Dux','DUX, INC.'),(962743762944,'Aptix','APTIX CORPORATION'),(962760540160,'Standard','STANDARD MICROSYSTEMS CORP.'),(962777317376,'Tandberg','TANDBERG TELEVISION AS'),(962794094592,'ExtremeN','EXTREME NETWORKS'),(962810871808,'AstCompu','AST COMPUTER'),(962827649024,'Innomedi','InnoMediaLogic, Inc.'),(962844426240,'SpcElect','SPC ELECTRONICS CORPORATION'),(962861203456,'McnsHold','MCNS HOLDINGS, L.P.'),(962877980672,'MelitaIn','MELITA INTERNATIONAL CORP.'),(962894757888,'Hagiwara','HAGIWARA ELECTRIC CO., LTD.'),(962911535104,'MisysFin','MISYS FINANCIAL SYSTEMS, LTD.'),(962928312320,'EEPD','E.E.P.D. GmbH'),(962945089536,'Cisco','CISCO SYSTEMS, INC.'),(962961866752,'EmersonN','Emerson Network Power'),(962978643968,'Pioneer','PIONEER CORPORATION'),(962995421184,'Century','CENTURY CORPORATION'),(963012198400,'Proxima','PROXIMA CORPORATION'),(963028975616,'Paradyne','PARADYNE CORP.'),(963045752832,'Cabletro','CABLETRON SYSTEMS, INC.'),(963062530048,'Prominet','PROMINET CORPORATION'),(963079307264,'Advansys',''),(963096084480,'FoconEle','FOCON ELECTRONIC SYSTEMS A/S'),(963112861696,'Alfatech','ALFATECH, INC.'),(963129638912,'Jaton','JATON CORPORATION'),(963146416128,'Deskstat','DeskStation Technology, Inc.'),(963163193344,'Cspi',''),(963179970560,'Pacom','Pacom Systems Ltd.'),(963196747776,'Vitalcom',''),(963213524992,'Lsics','LSICS CORPORATION'),(963230302208,'Touchwav','TOUCHWAVE, INC.'),(963247079424,'BentlyNe','BENTLY NEVADA CORP.'),(963263856640,'Infocus','InFocus Corporation'),(963280633856,'SdlCommu','SDL COMMUNICATIONS, INC.'),(963297411072,'MicrowiE','MICROWI ELECTRONIC GmbH'),(963314188288,'Enhanced','ENHANCED MESSAGING SYSTEMS, INC'),(963330965504,'JumpIndu','JUMP INDUSTRIELLE COMPUTERTECHNI'),(963347742720,'RealtekS','REALTEK SEMICONDUCTOR CORP.'),(963364519936,'Internet','INTERNET INITIATIVE JAPAN, INC'),(963381297152,'SanyoDen','SANYO DENKI CO., LTD.'),(963398074368,'Cisco','CISCO SYSTEMS, INC.'),(963414851584,'Executon','EXECUTONE INFORMATION SYSTEMS, I'),(963431628800,'Talx','TALX CORPORATION'),(963448406016,'BrocadeC','Brocade Communications Systems, '),(963465183232,'Cellport','CELLPORT LABS, INC.'),(963481960448,'KodaiHit','KODAI HITEC CO., LTD.'),(963498737664,'Ingenier','INGENIERIA ELECTRONICA COMERCIAL'),(963515514880,'Holontec','HOLONTECH CORPORATION'),(963532292096,'HanMicro','HAN MICROTELECOM. CO., LTD.'),(963549069312,'PhaseOne','PHASE ONE DENMARK A/S'),(963565846528,'Controll','CONTROLLED ENVIRONMENTS, LTD.'),(963582623744,'GaleaNet','GALEA NETWORK SECURITY'),(963599400960,'WestEnd','WEST END SYSTEMS CORP.'),(963616178176,'Matsushi','MATSUSHITA KOTOBUKI ELECTRONICS '),(963632955392,'Unitec','UNITEC CO., LTD.'),(963649732608,'JapanAvi','JAPAN AVIATION ELECTRONICS INDUS'),(963666509824,'E-Net','e-Net, Inc.'),(963683287040,'Sherwood',''),(963700064256,'Edgepoin','EdgePoint Networks, Inc.'),(963716841472,'HostEngi','HOST ENGINEERING'),(963733618688,'Cabletro','CABLETRON - YAGO SYSTEMS, INC.'),(963750395904,'SamsungE','SAMSUNG ELECTRONICS'),(963767173120,'OpticalA','OPTICAL ACCESS INTERNATIONAL'),(963783950336,'Promax','ProMax Systems, Inc.'),(963800727552,'EacAutom','eac AUTOMATION-CONSULTING GmbH'),(963817504768,'Merrimac','MERRIMAC SYSTEMS INC.'),(963834281984,'Jaycor',''),(963851059200,'Kapsch','KAPSCH AG'),(963867836416,'W&GSpeci','W&G SPECIAL PRODUCTS'),(963901390848,'Compuwar','COMPUWARE CORPORATION'),(963918168064,'FarSPA','FAR SYSTEMS S.p.A.'),(963934945280,'Motorola','Motorola, Inc.'),(963951722496,'DhTechno','DH TECHNOLOGY'),(963968499712,'EpisMicr','EPIS MICROCOMPUTER'),(963985276928,'Lynk',''),(964002054144,'National','NATIONAL AMUSEMENT NETWORK, INC.'),(964018831360,'TiernanC','TIERNAN COMMUNICATIONS, INC.'),(964035608576,'Verilink','Verilink Corporation'),(964052385792,'Developm','DEVELOPMENT CONCEPTS, INC.'),(964069163008,'Webgear','WEBGEAR, INC.'),(964085940224,'Berkeley','BERKELEY NETWORKS'),(964102717440,'ATNR','A.T.N.R.'),(964119494656,'Mikrodid','MIKRODIDAKT AB'),(964136271872,'BayNetwo','BAY NETWORKS'),(964153049088,'Mettler-','METTLER-TOLEDO, INC.'),(964169826304,'Netronix','NETRONIX, INC.'),(964186603520,'WaltDisn','WALT DISNEY IMAGINEERING'),(964203380736,'Logistis','LOGISTISTEM s.r.l.'),(964220157952,'ControlR','CONTROL RESOURCES CORPORATION'),(964236935168,'TyanComp','TYAN COMPUTER CORP.'),(964253712384,'Anerma',''),(964270489600,'JatoTech','JATO TECHNOLOGIES, INC.'),(964287266816,'Compulit','COMPULITE R&D'),(964304044032,'GlobalMa','GLOBAL MAINTECH, INC.'),(964320821248,'EmersonN','Emerson Network Power, Avocent D'),(964337598464,'Lecroy-N','LeCroy - Networking Productions '),(964354375680,'Ltx-Cred','LTX-Credence CORPORATION'),(964371152896,'IonNetwo','ION Networks, Inc.'),(964387930112,'GecAvery','GEC AVERY, LTD.'),(964404707328,'Qlogic','QLogic Corp.'),(964421484544,'Neoparad','NEOPARADIGM LABS, INC.'),(964438261760,'Pressure','PRESSURE SYSTEMS, INC.'),(964455038976,'Utstarco','UTSTARCOM'),(964471816192,'Cisco','CISCO SYSTEMS, INC.'),(964488593408,'BeckmanL','BECKMAN LAB. AUTOMATION DIV.'),(964505370624,'LgElectr','LG ELECTRONICS, INC.'),(964522147840,'Admtek','ADMTEK INCORPORATED'),(964538925056,'AckfinNe','ACKFIN NETWORKS'),(964555702272,'OsaiSrl','OSAI SRL'),(964572479488,'Advanced','ADVANCED-VISION TECHNOLGIES CORP'),(964589256704,'Shimadzu','SHIMADZU CORPORATION'),(964606033920,'CarrierA','CARRIER ACCESS CORPORATION'),(964622811136,'Trend',''),(964639588352,'Samson','SAMSON AG'),(964656365568,'Positron','Positron Inc.'),(964673142784,'EngageNe','ENGAGE NETWORKS, INC.'),(964689920000,'Mii',''),(964706697216,'Sarnoff','SARNOFF CORPORATION'),(964723474432,'Quantum','QUANTUM CORPORATION'),(964740251648,'PixelVis','PIXEL VISION'),(964757028864,'Wiltron','WILTRON CO.'),(964773806080,'HimaPaul','HIMA PAUL HILDEBRANDT GmbH Co. K'),(964790583296,'Microsla','MICROSLATE INC.'),(964807360512,'Cisco','CISCO SYSTEMS, INC.'),(964824137728,'EsaoteSP','ESAOTE S.p.A.'),(964840914944,'ComcoreS','ComCore Semiconductor, Inc.'),(964857692160,'TelogyNe','TELOGY NETWORKS, INC.'),(964874469376,'IpcInfor','IPC INFORMATION SYSTEMS, INC.'),(964891246592,'Sat','SAT GmbH & Co.'),(964908023808,'FunaiEle','FUNAI ELECTRIC CO., LTD.'),(964924801024,'Electros','ELECTROSONIC LTD.'),(964941578240,'DimatSA','DIMAT S.A.'),(964958355456,'Midsco','MIDSCO, INC.'),(964975132672,'EesTechn','EES TECHNOLOGY, LTD.'),(964991909888,'Xaqti','XAQTI CORPORATION'),(965008687104,'GeneralD','GENERAL DYNAMICS INFORMATION SYS'),(965025464320,'Cisco','CISCO SYSTEMS, INC.'),(965042241536,'Alcatel-','Alcatel-Lucent, Enterprise Busin'),(965059018752,'TelmaxCo','TELMAX COMMUNICATIONS CORP.'),(965075795968,'Etherwan','EtherWAN Systems, Inc.'),(965092573184,'TechnoSc','TECHNO SCOPE CO., LTD.'),(965109350400,'ArdentCo','ARDENT COMMUNICATIONS CORP.'),(965126127616,'EntradaN','Entrada Networks'),(965142904832,'PiGroup','PI GROUP, LTD.'),(965159682048,'Gateway2','GATEWAY 2000'),(965176459264,'Byas','BYAS SYSTEMS'),(965193236480,'BerghofA','BERGHOF AUTOMATIONSTECHNIK GmbH'),(965210013696,'Nbx','NBX CORPORATION'),(965226790912,'SymonCom','SYMON COMMUNICATIONS, INC.'),(965243568128,'Interfac','INTERFACE SYSTEMS, INC.'),(965260345344,'GenrocoI','GENROCO INTERNATIONAL, INC.'),(965277122560,'TorrentN','TORRENT NETWORKING TECHNOLOGIES '),(965293899776,'SeiwaEle','SEIWA ELECTRIC MFG. CO., LTD.'),(965310676992,'MemorexT','MEMOREX TELEX JAPAN, LTD.'),(965327454208,'NecsySPA','NECSY S.p.A.'),(965344231424,'SakaiSys','SAKAI SYSTEM DEVELOPMENT CORP.'),(965361008640,'HornerEl','HORNER ELECTRIC, INC.'),(965377785856,'BcomElec','BCOM ELECTRONICS INC.'),(965394563072,'Link2itL','LINK2IT, L.L.C.'),(965411340288,'Eurotech','EUROTECH SRL'),(965428117504,'VirtualA','VIRTUAL ACCESS, LTD.'),(965444894720,'Automate','AutomatedLogic Corporation'),(965461671936,'BestData','BEST DATA PRODUCTS'),(965478449152,'Reson','RESON, INC.'),(965495226368,'Hero','HERO SYSTEMS, LTD.'),(965512003584,'Sensis','SENSIS CORPORATION'),(965528780800,'Arn',''),(965545558016,'Integrat','INTEGRATED DEVICE TECHNOLOGY, IN'),(965562335232,'Netspeed','NETSPEED, INC.'),(965579112448,'Telsis','TELSIS LIMITED'),(965595889664,'Versanet','VERSANET COMMUNICATIONS, INC.'),(965612666880,'Datentec','DATENTECHNIK GmbH'),(965629444096,'Excellen','EXCELLENT COMPUTER'),(965646221312,'Emulex','Emulex Corporation'),(965662998528,'Computer','COMPUTER & COMMUNICATION RESEARC'),(965679775744,'Sunshine','SUNSHINE ELECTRONICS, INC.'),(965696552960,'LanbitCo','LANBit Computer, Inc.'),(965713330176,'Tazmo','TAZMO CO., LTD.'),(965730107392,'AlcatelN','Alcatel North America ESD'),(965746884608,'Viavideo','ViaVideo Communications, Inc.'),(965763661824,'Nexware','NEXWARE CORP.'),(965780439040,'ZenithEl','ZENITH ELECTRONICS CORPORATION'),(965797216256,'DataxNv','DATAX NV'),(965813993472,'Keymile','KEYMILE GmbH'),(965830770688,'SiElectr','SI ELECTRONICS, LTD.'),(965847547904,'G2Networ','G2 NETWORKS, INC.'),(965864325120,'Innova','INNOVA CORP.'),(965881102336,'Sk-Elekt','SK-ELEKTRONIK GmbH'),(965897879552,'FanucRob','FANUC ROBOTICS NORTH AMERICA, In'),(965914656768,'CincoNet','CINCO NETWORKS, INC.'),(965931433984,'IncaaDat','INCAA DATACOM B.V.'),(965948211200,'Raytheon','RAYTHEON E-SYSTEMS, INC.'),(965964988416,'Gretacod','GRETACODER Data Systems AG'),(965981765632,'DataLabs','DATA LABS, INC.'),(965998542848,'InnovatC','INNOVAT COMMUNICATIONS, INC.'),(966015320064,'Digicom','DIGICOM SYSTEMS, INCORPORATED'),(966032097280,'Celestic','CELESTICA INC.'),(966048874496,'Silicom','SILICOM, LTD.'),(966065651712,'MarelHf','MAREL HF'),(966082428928,'Dionex',''),(966099206144,'AblerTec','ABLER TECHNOLOGY, INC.'),(966115983360,'That','THAT CORPORATION'),(966132760576,'ArlottoC','ARLOTTO COMNET, INC.'),(966149537792,'Websprin','WebSprint Communications, Inc.'),(966166315008,'InsideTe','INSIDE Technology A/S'),(966183092224,'Teles','TELES AG'),(966199869440,'Decision','DECISION EUROPE'),(966216646656,'Cisco','CISCO SYSTEMS, INC.'),(966233423872,'DicnaCon','DICNA CONTROL AB'),(966250201088,'Cisco','CISCO SYSTEMS, INC.'),(966266978304,'TrlTechn','TRL TECHNOLOGY, LTD.'),(966283755520,'Leightro','LEIGHTRONIX, INC.'),(966300532736,'HuaweiTe','HUAWEI TECHNOLOGIES CO., LTD.'),(966317309952,'A-TrendT','A-TREND TECHNOLOGY CO., LTD.'),(966334087168,'Cisco','CISCO SYSTEMS, INC.'),(966350864384,'Security','SECURITY DYNAMICS TECHNOLOGIES, '),(968330575872,'Ak-Syste','AK-Systems Ltd'),(989553754112,'ArimaCom','ARIMA Communications Corp.'),(991382470656,'NixdorfC','NIXDORF COMPUTER CORP.'),(999301316608,'MeggittT','Meggitt Training Systems, Inc.'),(1010072289280,'SonyMobi','Sony Mobile Communications AB'),(1032151105536,'Kwb','KWB Gmbh'),(1048022351872,'OrbisOy','Orbis Systems Oy'),(1051075805184,'Apple','Apple, Inc.'),(1066762502144,'PtPanggu','PT. Panggung Electric Citrabuana'),(1074731679744,'CloosEle','CLOOS ELECTRONIC GMBH'),(1083808153600,'Websilic','WebSilicon Ltd.'),(1084210806784,'Intrepid','Intrepid Control Systems, Inc.'),(1087901794304,'Nevatec',''),(1163114053632,'PN-MC','PROFINET Multicast'),(2216303788032,'BbnInter','BBN				internal usage (not regis'),(2229104803840,'Racal-Da','RACAL-DATACOM'),(2321362714624,'Perq','PERQ SYSTEMS CORPORATION'),(2337670168576,'Marconi','At least some 2810 send with loc'),(2612950728704,'3com',''),(2613588262912,'LogicRep','LOGIC REPLACEMENT TECH. LTD.'),(2613688926208,'3com','3COM CORPORATION'),(2680076369920,'Racal-Da','RACAL-DATACOM'),(2683012382720,'M/A-ComC','M/A-COM INC. COMPANIES'),(2683062714368,'DataReca','DATA RECALL LTD'),(2875715485696,'CardiacR','CARDIAC RECORDERS INC.'),(2889590243328,'Intel',''),(2930174328832,'Olivetti','OLIVETTI TELECOMM SPA (OLTECO)'),(3002198917120,'Octothor','OCTOTHORPE CORP.'),(3026005786624,'3com','3COM CORPORATION'),(3088551247872,'Communic','COMMUNICATION MACHINERY CORP.'),(3088601579520,'CMC',''),(3162085785600,'Prominet','Prominet Corporation		Gigabit Et'),(3190405726208,'NixdorfC','NIXDORF COMPUTER CORPORATION'),(4443193999360,'Alcatel-','Alcatel-Lucent'),(4444754280448,'XmitComp','XMIT AG COMPUTER NETWORKS'),(4453042225152,'Apple','Apple, Inc.'),(4461430833152,'Viewsoni','ViewSonic Mobile China Limited'),(4489616556032,'Apple',''),(4501377384448,'SamsungE','Samsung Electronics Co.,Ltd'),(4504179179520,'Private',''),(4504716050432,'Ubiquiti','Ubiquiti Networks'),(4516493656064,'HostMobi','Host Mobility AB'),(4517131190272,'SamsungE','Samsung Electronics Co.,Ltd'),(4522868998144,'DreamWar','Dream Ware Inc.'),(4528573251584,'Apple','Apple, Inc'),(4538069155840,'Panasoni','Panasonic AVC Networks Company'),(4544947814400,'Wireless','Wireless Standard Extensions'),(4561339154432,'GfrGesel','GFR Gesellschaft fÃ¼r Regelungst'),(4562949767168,'Apple',''),(4585867444224,'Picocela','PicoCELA, Inc.'),(4601352814592,'AtocsShe','ATOCS (Shenzhen) LTD'),(4616888516608,'Partron',''),(4630041853952,'Gyeyoung','Gyeyoung I&T'),(4662589652992,'Chongqin','ChongQing QingJia Electronics CO'),(4700388720640,'MurataMa','Murata Manufacturing Co., Ltd.'),(4717216268288,'RamaxelT','Ramaxel Technology (Shenzhen) li'),(4724447248384,'Guangzho','GuangZhou Hedy Digital Technolog'),(4728473780224,'FujianSa','Fujian Sanao Technology Co.,Ltd'),(4740201054208,'RuckusWi','Ruckus Wireless'),(4760216272896,'Apple','Apple, Inc.'),(4766507728896,'BriviewX','BriView (Xiamen) Corp.'),(4777865904128,'SichuanW','Sichuan Whayer information indus'),(4787093372928,'Nokia','Nokia Corporation'),(4793284165632,'ZmodoTec','Zmodo Technology Corporation'),(4798921310208,'CamtronI','camtron industrial inc.'),(4808870199296,'Shenzhen','Shenzhen Yichen Technology Devel'),(4822560407552,'AlstomHy','ALSTOM HYDRO FRANCE'),(4827006369792,'NomeOy','Nome Oy'),(4867305242624,'Bryston','Bryston Ltd.'),(4871717650432,'TaiyearE','TaiYear Electronic Technology (S'),(4882236964864,'Globalst','Globalstar Inc.'),(4898963849216,'AligeraE','Aligera Equipamentos Digitais Lt'),(4904668102656,'Csst',''),(4906698145792,'Alps','ALPS Co,. Ltd.'),(4936981020672,'QuantaCo','Quanta Computer Inc.'),(4955016527872,'Clack','Clack Corporation'),(4967297449984,'7inovaTe','7INOVA TECHNOLOGY LIMITED'),(4983319691264,'BayNetwo','Bay Networks			token ring line c'),(4984510873600,'Eifelwer','Eifelwerk Butler Systeme GmbH'),(4985953714176,'BeatsEle','Beats Electronics LLC'),(4991104319488,'Avaya','Avaya, Inc'),(4996154261504,'Skspruce','Skspruce Technology Limited'),(4999392264192,'ThinpadT','ThinPAD Technology (Shenzhen)CO.'),(5004576423936,'NetcoreT','Netcore Technology Inc.'),(5036402802688,'CatchWin','CATCH THE WIND INC'),(5054958403584,'AlpsElec','ALPS Electric Co,. Ltd.'),(5069705576448,'BmtMedic','BMT Medical Technology s.r.o.'),(5081046974464,'Smobile','Smobile Co., Ltd.'),(5083110572032,'Netscout','Netscout Systems, Inc.'),(5090895200256,'Netgear','NETGEAR INC.,'),(5102203043840,'Emicon',''),(5120305659904,'Nokia','Nokia Corporation'),(5169899110400,'SeamapUk','Seamap (UK) Ltd'),(5172851900416,'Bsp','BSP Co., Ltd.'),(5221203836928,'Isb','ISB Corporation'),(5224206958592,'TigoEner','Tigo Energy'),(5224542502912,'Shenzhen','Shenzhen Huawei Communication Te'),(5230078984192,'Fiberhom','Fiberhome Telecommunication Tech'),(5246906531840,'Cisco','CISCO SYSTEMS, INC.'),(5259187453952,'Samtec','Samtec Inc'),(5283145318400,'Wilocity','Wilocity LTD.'),(5287725498368,'Manycolo','MANYCOLORS, INC.'),(5309502324736,'Znv',''),(5323662295040,'Y&HE&C','Y&H E&C Co.,LTD.'),(5337872596992,'Cisco',''),(5348509351936,'Velocyte','Velocytech'),(5357585825792,'CarConne','Car Connectivity Consortium'),(5363407519744,'Triumph-','TRIUMPH-ADLER AG'),(5367769595904,'ImsSoluÃ§','IMS SoluÃ§Ãµes em Energia Ltda.'),(5372869869568,'AepTicke','AEP Ticketing solutions srl'),(5378658009088,'TexasIns','Texas Instruments'),(5382499991552,'Apple',''),(5382801981440,'CohdaWir','Cohda Wireless Pty Ltd'),(5387533156352,'Acroname','Acroname Inc.'),(5402615873536,'PjrcComL','PJRC.COM, LLC'),(5422681423872,'X-Fabric','x-fabric GmbH'),(5429392310272,'CompexPt','Compex Systems Pte Ltd'),(5435230781440,'TaranaWi','Tarana Wireless'),(5449172647936,'XenaNetw','Xena Networks'),(5462728638464,'Apple',''),(5466453180416,'Flaircom','Flaircomm Microelectronics, Inc.'),(5489790287872,'SamsungE','Samsung Electronics Co.,Ltd'),(5491098910720,'Cisco','CISCO SYSTEMS, INC.'),(5494622126080,'Novamedi','NOVAMEDIA INNOVISION SP. Z O.O.'),(8796109799424,'Computer','COMPUTERVISION CORPORATION'),(8796126576640,'3Com',''),(8796143353856,'ACC',''),(8796160131072,'Cromemco','CROMEMCO INCORPORATED'),(8796176908288,'Symbolic','SYMBOLICS INC.'),(8796193685504,'Siemens','SIEMENS AG'),(8796210462720,'AppleCom','APPLE COMPUTER INC.'),(8796227239936,'BBN',''),(8796244017152,'HP',''),(8796260794368,'Nestar','NESTAR SYSTEMS INCORPORATED'),(8796277571584,'Unisys','UNISYS CORPORATION'),(8796294348800,'MiklynDe','MIKLYN DEVELOPMENT CO.'),(8796311126016,'Internat','INTERNATIONAL COMPUTERS LTD.'),(8796327903232,'Ncr','NCR CORPORATION'),(8796344680448,'Mitel','MITEL CORPORATION'),(8796361457664,'At&T[Mis','AT&T [misrepresentation of 80001'),(8796378234880,'Tektroni','TEKTRONIX INC.'),(8796395012096,'BellAtla','BELL ATLANTIC INTEGRATED SYST.'),(8796411789312,'Exxon',''),(8796428566528,'Excelan',''),(8796445343744,'StcBusin','STC BUSINESS SYSTEMS'),(8796462120960,'Barriste','BARRISTER INFO SYS CORP'),(8796478898176,'National','NATIONAL SEMICONDUCTOR'),(8796495675392,'PirelliF','PIRELLI FOCOM NETWORKS'),(8796512452608,'GeneralE','GENERAL ELECTRIC CORPORATION'),(8796529229824,'DataGenl','Data General'),(8796546007040,'Emc','EMC Corporation'),(8796562784256,'Kdd-Koku','KDD-KOKUSAI DEBNSIN DENWA CO.'),(8796579561472,'AbleComm','ABLE COMMUNICATIONS INC.'),(8796596338688,'ApolloCo','APOLLO COMPUTER INC.'),(8796613115904,'Sharp','SHARP CORPORATION'),(8796629893120,'Oracle','Oracle Corporation'),(8796646670336,'3m','3M COMPANY'),(8796663447552,'Nbi','NBI INC.'),(8796680224768,'Panasoni','Panasonic Communications Co., Lt'),(8796697001984,'10netCom','10NET COMMUNICATIONS/DCA'),(8796713779200,'ControlD','CONTROL DATA'),(8796730556416,'NorskDat','NORSK DATA A.S.'),(8796747333632,'CadmusCo','CADMUS COMPUTER SYSTEMS'),(8796764110848,'TexasIns','Texas Instruments'),(8796780888064,'Megatek','MEGATEK CORPORATION'),(8796797665280,'MosaicTe','MOSAIC TECHNOLOGIES INC.'),(8796814442496,'DigitalE','DIGITAL EQUIPMENT CORPORATION'),(8796831219712,'BrittonL','BRITTON LEE INC.'),(8796847996928,'Lan-Tec','LAN-TEC INC.'),(8796864774144,'Metaphor','METAPHOR COMPUTER SYSTEMS'),(8796881551360,'PrimeCom','PRIME COMPUTER INC.'),(8796898328576,'NetworkR','NETWORK RESEARCH CORPORATION'),(8796915105792,'LittleMa','LITTLE MACHINES INC.'),(8796931883008,'Tigan','TIGAN INCORPORATED'),(8796948660224,'BauschLo','BAUSCH & LOMB'),(8796965437440,'Filenet','FILENET CORPORATION'),(8796982214656,'Microfiv','MICROFIVE CORPORATION'),(8796998991872,'Intergra','INTERGRAPH CORPORATION'),(8797015769088,'Fuji-Xer','FUJI-XEROX CO. LTD.'),(8797032546304,'Bull',''),(8797049323520,'Spider','SPIDER SYSTEMS LIMITED'),(8797066100736,'Orcatech','ORCATECH INC.'),(8797082877952,'Torus','TORUS SYSTEMS LIMITED'),(8797099655168,'Schlumbe','SCHLUMBERGER WELL SERVICES'),(8797116432384,'Cadnetix','CADNETIX CORPORATIONS'),(8797133209600,'Motorola',''),(8797149986816,'FredKosc','FRED KOSCHARA ENTERPRISES'),(8797166764032,'Ferranti','FERRANTI COMPUTER SYS. LIMITED'),(8797183541248,'Racal-Mi','RACAL-MILGO INFORMATION SYS..'),(8797200318464,'JapanMac','JAPAN MACNICS CORP.'),(8797217095680,'PixelCom','PIXEL COMPUTER INC.'),(8797233872896,'David','DAVID SYSTEMS INC.'),(8797250650112,'Concurre','CONCURRENT COMPUTER CORP.'),(8797267427328,'Sony','Sony Corporation'),(8797284204544,'SequentC','SEQUENT COMPUTER SYSTEMS INC.'),(8797300981760,'Eurother','EUROTHERM GAUGING SYSTEMS'),(8797317758976,'Univatio','UNIVATION'),(8797334536192,'Banyan','BANYAN SYSTEMS INC.'),(8797351313408,'Planning','PLANNING RESEARCH CORP.'),(8797368090624,'HydraCom','HYDRA COMPUTER SYSTEMS INC.'),(8797384867840,'Corvus','CORVUS SYSTEMS INC.'),(8797401645056,'3comEuro','3COM EUROPE LTD.'),(8797418422272,'Cygnet','CYGNET SYSTEMS'),(8797435199488,'Daisy','DAISY SYSTEMS CORP.'),(8797451976704,'Experdat','EXPERDATA'),(8797468753920,'Insystec',''),(8797485531136,'MiddleEa','MIDDLE EAST TECH. UNIVERSITY'),(8797519085568,'Stanford','STANFORD TELECOMM. INC.'),(8797535862784,'Stanford','STANFORD LINEAR ACCEL. CENTER'),(8797552640000,'EvansSut','EVANS & SUTHERLAND'),(8797569417216,'Concepts','SYSTEMS CONCEPTS'),(8797586194432,'Mycron','A/S MYCRON'),(8797602971648,'Ibm','IBM Corp'),(8797619748864,'VtaTechn','VTA TECHNOLOGIES INC.'),(8797636526080,'FourPhas','FOUR PHASE SYSTEMS'),(8797653303296,'Gould','GOULD INC.'),(8797670080512,'Counterp','COUNTERPOINT COMPUTER INC.'),(8797686857728,'SaberTec','SABER TECHNOLOGY CORP.'),(8797703634944,'Industri','INDUSTRIAL NETWORKING INC.'),(8797720412160,'Jarogate','JAROGATE LTD.'),(8797737189376,'GeneralD','GENERAL DYNAMICS'),(8797753966592,'Plessey',''),(8797770743808,'Sitasys','Sitasys AG'),(8797787521024,'Genrad','GENRAD INC.'),(8797804298240,'Agfa','AGFA CORPORATION'),(8797821075456,'Comdesig','COMDESIGN'),(8797837852672,'RidgeCom','RIDGE COMPUTERS'),(8797854629888,'SGI',''),(8797871407104,'AttBellL','ATT BELL LABORATORIES'),(8797888184320,'AccelTec','ACCEL TECHNOLOGIES INC.'),(8797904961536,'SuntekTe','SUNTEK TECHNOLOGY INT`L'),(8797921738752,'Whitecha','WHITECHAPEL COMPUTER WORKS'),(8797938515968,'Masscomp',''),(8797955293184,'PhilipsA','PHILIPS APELDOORN B.V.'),(8797972070400,'Mitsubis','MITSUBISHI ELECTRIC CORP.'),(8797988847616,'MatraDsi','MATRA (DSIE)'),(8798005624832,'XeroxUni','XEROX CORP UNIV GRANT PROGRAM'),(8798022402048,'Tecmar','TECMAR INC.'),(8798039179264,'CasioCom','CASIO COMPUTER CO. LTD.'),(8798055956480,'DanskDat','DANSK DATA ELECTRONIK'),(8798072733696,'PcLanTec','PC LAN TECHNOLOGIES'),(8798089510912,'TslCommu','TSL COMMUNICATIONS LTD.'),(8798106288128,'Accell','ACCELL CORPORATION'),(8798123065344,'SGI',''),(8798139842560,'Indata',''),(8798156619776,'SanyoEle','SANYO ELECTRIC CO. LTD.'),(8798173396992,'Vitalink','VITALINK COMMUNICATIONS CORP.'),(8798206951424,'Amalgama','AMALGAMATED WIRELESS(AUS) LTD'),(8798223728640,'Carnegie','CARNEGIE-MELLON UNIVERSITY'),(8798240505856,'AesData','AES DATA INC.'),(8798257283072,'Astech','ASTECH INC.'),(8798274060288,'VeritasS','VERITAS SOFTWARE'),(8798290837504,'SeikoIns','Seiko Instruments Inc.'),(8798307614720,'TomenEle','TOMEN ELECTRONICS CORP.'),(8798324391936,'Elxsi',''),(8798341169152,'KonicaMi','KONICA MINOLTA HOLDINGS, INC.'),(8798357946368,'Xyplex',''),(8798374723584,'BrocadeC','Brocade Communications Systems, '),(8798391500800,'Kinetics',''),(8798408278016,'Perftech','PerfTech, Inc.'),(8798425055232,'PyramidT','PYRAMID TECHNOLOGY CORP.'),(8798441832448,'NetworkR','NETWORK RESEARCH CORPORATION'),(8798458609664,'Xyvision','XYVISION INC.'),(8798475386880,'TandemCo','TANDEM COMPUTERS'),(8798492164096,'Chipcom','CHIPCOM CORPORATION'),(8798508941312,'Retix',''),(8833707540480,'SamsungE','Samsung Electronics'),(8834378629120,'Amsc',''),(8847817179136,'SysmikDr','SysMik GmbH Dresden'),(8851004850176,'MissionT','Mission Technology Group, dba Ma'),(8854142189568,'Geco','GECO, Inc.'),(8859041136640,'VelexSRL','Velex s.r.l.'),(8864711835648,'Ksp','KSP INC.'),(8871624048640,'IntelCor','Intel Corporate'),(8883116441600,'Unibrain','UNIBRAIN S.A.'),(8891941257216,'Shenzhen','Shenzhen Sea Star Technology Co.'),(8895766462464,'Cisco','CISCO SYSTEMS, INC.'),(8898970910720,'Ibm','IBM Corp'),(8899608444928,'Zte','zte corporation'),(8900447305728,'ASThomas','A. S. Thomas, Inc.'),(8906252222464,'HuaweiTe','HUAWEI TECHNOLOGIES CO.,LTD'),(8924858155008,'Shanghai','Shanghai Mexon Communication Tec'),(8930293972992,'Wondalin','WondaLink Inc.'),(8933313871872,'Cisco','CISCO SYSTEMS, INC.'),(8955577237504,'Advansee',''),(8964016177152,'ApsSyste','APS systems/electronic AG'),(8979971309568,'SrdInnov','SRD Innovations Inc.'),(8995255353344,'HewlettP','Hewlett Packard'),(9025622114304,'Caswell','CASwell INC.'),(9033339633664,'SamsungE','Samsung Electronics Co.,Ltd'),(9034933469184,'Topaz','Topaz Co. LTD.'),(9039379431424,'Funkwerk','Funkwerk plettac electronic GmbH'),(9048288133120,'ShinodaP','Shinoda Plasma Co., Ltd.'),(9062582321152,'ArrisGro','ARRIS Group, Inc.'),(9064763359232,'HonHaiPr','Hon Hai Precision Ind.Co.Ltd'),(9106068865024,'RaycoreT','Raycore Taiwan Co., LTD.'),(9131570233344,'H2aLlc','H2A Systems, LLC'),(9134304919552,'BroadNet','Broad Net Mux Corporation'),(9144757125120,'OrionDia','Orion Diagnostica Oy'),(9187169927168,'Fortinet','Fortinet, Inc.'),(9210255376384,'AsustekC','ASUSTek COMPUTER INC.'),(9222922174464,'HuaweiTe','Huawei Technologies Co., Ltd'),(9246259281920,'JapanSys','Japan System Design'),(9246695489536,'EitoElec','EITO ELECTRONICS CO., LTD.'),(9278286987264,'Apple',''),(9300516798464,'ObeluxOy','Obelux Oy'),(9303301816320,'VieTechn','ViE Technologies Sdn. Bhd.'),(9305398968320,'AutoIndu','Auto Industrial Co., Ltd.'),(9307177353216,'ThomsonT','Thomson Telecom Belgium'),(9318350979072,'Aim','AIM GmbH'),(9321354100736,'HuaweiTe','Huawei Technologies Co., Ltd'),(9327226126336,'Svyazkom','SVYAZKOMPLEKTSERVICE, LLC'),(9331856637952,'Quintic','Quintic Corp.'),(9333517582336,'AltasecT','Altasec technology corporation'),(9346805137408,'CiscoSpv','Cisco SPVTG'),(9354237444096,'JuniperN','Juniper Networks'),(9372608495616,'BelkinIn','Belkin International, Inc.'),(9405038854144,'RyowaEle','Ryowa Electronics Co.,Ltd'),(9407303778304,'SfSoftwa','SF Software Solutions'),(9411011543040,'HillsSou','Hills Sound Vision & Lighting'),(9443945218048,'Avm','AVM GmbH'),(9474714632192,'QuantaCo','QUANTA COMPUTER INC.'),(9481526181888,'LeroyAut','LEROY AUTOMATION'),(9488304177152,'Shenzhen','ShenZhen EZL Technology Co., Ltd'),(9523452444672,'Azurewav','Azurewave'),(9537595637760,'BenuVide','Benu Video, Inc.'),(9549725564928,'TotusSol','Totus Solutions, Inc.'),(9572660019200,'AbicomIn','Abicom International'),(9583011561472,'Lite-OnT','Lite-On Technogy Corp.'),(9586031460352,'Wireless','Wireless Seismic'),(9602674458624,'Ak-NordE','AK-NORD EDV VERTRIEBSGES. mbH'),(9608965914624,'Netgear','NETGEAR INC.,'),(9612287803392,'AstrolEl','Astrol Electronic AG'),(9674011181056,'Cisco',''),(9692113797120,'Cisco','CISCO SYSTEMS, INC.'),(9700619845632,'Proforma','Proformatique'),(9706827415552,'IntelCor','Intel Corporate'),(9707347509248,'SamsungE','Samsung Electronics'),(9714142281728,'SeersTec','Seers Technology Co., Ltd'),(9783297966080,'NanjingF','NANJING FUJITSU COMPUTER PRODUCT'),(9785848102912,'JebseeEl','JEBSEE ELECTRONICS CO.,LTD.'),(9802256220160,'Aerohive','Aerohive Networks, Inc.'),(9807356493824,'Humax',''),(9809386536960,'WorldEli','World Elite Technology Co.,LTD'),(9817104056320,'HonHaiPr','Hon Hai Precision Ind. Co.,Ltd.'),(9823580061696,'McsLogic','MCS Logic Inc.'),(9834250371072,'Towerstr','Towerstream Corpration'),(9839568748544,'NetOnePa','Net One Partners Co.,Ltd.'),(9856815726592,'GetEngin','GET Engineering'),(9873592942592,'FohhnAud','Fohhn Audio AG'),(9879800512512,'OpenxsBv','OpenXS BV'),(9880706482176,'SamsungE','Samsung Electronics Co.,Ltd'),(9897383034880,'AT&T',''),(13211319402496,'JantarDO','Jantar d.o.o.'),(13216503562240,'Juniper','Juniper Systems'),(13267237863424,'Ringslin','Ringslink (Xiamen) Network Commu'),(13275928461312,'Uniqoteq','Uniqoteq Ltd.'),(13280575750144,'SamsungE','Samsung Electronics Co.,Ltd'),(13287638958080,'Sdtec','SDTEC Co., Ltd.'),(13296967090176,'Telecsys',''),(13302033809408,'InformEl','Inform Electronik'),(13321948364800,'SeahNetw','SeAH Networks'),(13362247237632,'Cisco',''),(13363069321216,'Valuable','Valuable Techologies Limited'),(13376289767424,'Electric','electric imp, incorporated'),(13378403696640,'BeijingG','Beijing General Research Institu'),(13389711540224,'QiiqComm','QiiQ Communications Inc.'),(13434053722112,'HuaweiTe','Huawei Technologies Co., Ltd'),(13440395509760,'Observat','Observator instruments'),(13453532069888,'DomeImag','Dome Imaging Inc'),(13497421266944,'MsSedco','MS Sedco'),(13521513349120,'Mitrasta','Mitrastar Technology'),(13546175856640,'ChauvinA','CHAUVIN ARNOUX'),(13559765401600,'Axiros','Axiros GmbH'),(13565050224640,'HybroadV','HyBroad Vision (Hong Kong) Techn'),(13571744333824,'Mueller','Mueller Systems'),(13581106020352,'AxtionSd','Axtion Sdn Bhd'),(13608436105216,'HonHaiPr','Hon Hai Precision Ind. Co.,Ltd.'),(13640866463744,'Cisco',''),(13667911335936,'Primevol','PrimeVOLT Co., Ltd.'),(13681031118848,'SamsungE','Samsung Electronics Co.,Ltd'),(13684504002560,'Tp-LinkT','TP-LINK TECHNOLOGIES CO.,LTD.'),(13695610519552,'Apple','Apple, Inc.'),(13697237909504,'BeijingG','BEIJING GEHUA CATV NETWORK CO.,L'),(13705676849152,'Apple','Apple, Inc.'),(13733090820096,'KexiangI','Kexiang Information Technology C'),(13748492304384,'Private',''),(13753290588160,'Shenzhen','SHENZHEN MAGNUS TECHNOLOGIES CO.'),(13754230112256,'Tp-LinkT','TP-LINK TECHNOLOGIES CO.,LTD.'),(13754263666688,'WuhanHua','Wuhan Huagong Genuine Optics Tec'),(13761360429056,'AOSmithW','A.O. Smith Water Products'),(13763289808896,'ZenoviaE','Zenovia Electronics Inc.'),(13764766203904,'HonHaiPr','Hon Hai Precision Ind. Co.,Ltd.'),(13765990940672,'Cisco','CISCO SYSTEMS, INC.'),(13795384623104,'IntelCor','Intel Corporate'),(13799125942272,'SuuntoOy','Suunto Oy'),(13802280058880,'TopEight','TOP EIGHT IND CORP'),(13822513381376,'RiceLake','Rice Lake Weighing Systems'),(13825516503040,'PtPrasim','PT. Prasimax Inovasi Teknologi'),(13829710807040,'BnsSolut','BNS Solutions'),(13841589075968,'HuaweiTe','Huawei Technologies Co., Ltd'),(13869892239360,'ConsortC','Consort Controls Ltd'),(13875177062400,'Sankosha','Sankosha Corporation'),(13886568792064,'BlinqWir','Blinq Wireless Inc.'),(13894017875968,'Chameleo','Chameleon Technology (UK) Limite'),(13898547724288,'AlcatelL','Alcatel Lucent IPD'),(13899218812928,'ObTeleco','OB Telecom Electronic Technology'),(13947268759552,'GenusPow','GENUS POWER INFRASTRUCTURES LIMI'),(13971243401216,'Digience','Digience Co.,Ltd.'),(14014830608384,'Genetec',''),(14021994479616,'MagnetiM','MAGNETI MARELLI SISTEMAS ELECTRO'),(14034459951104,'Meritec',''),(14038067052544,'Eucast','EUCAST Co., Ltd.'),(14045969121280,'WuxiYste','Wuxi YSTen Technology Co.,Ltd.'),(14046321442816,'Nokia','Nokia Corporation'),(14047428739072,'Dags',''),(14053653086208,'SummerIn','Summer Infant, Inc.'),(14060749848576,'SamwinHo','Samwin Hong Kong Limited'),(14078147821568,'Eastrive','EASTRIVER TECHNOLOGY CO., LTD.'),(14078818910208,'Edic','EDIC Systems Inc.'),(14098532139008,'IntelCor','Intel Corporate'),(14099119341568,'Binatone','Binatone Telecommunication Pvt. '),(14109001121792,'Westell',''),(14115779117056,'Amimon','Amimon Ltd'),(14120812281856,'AxiumTec','Axium Technologies, Inc.'),(14128664018944,'Cisco','CISCO SYSTEMS, INC.'),(14129385439232,'JohnsonC','Johnson Controls-ASG'),(14131532922880,'Hangzhou','Hangzhou H3C Technologies Co., L'),(14142454890496,'InalaTec','Inala Technologies'),(14147337060352,'Nokia','Nokia Corporation'),(14154668703744,'SamsungE','Samsung Electronics Co.,Ltd'),(14181227036672,'DhElectr','DH electronics GmbH'),(14186427973632,'FoxCrypt','Fox Crypto B.V.'),(14191360475136,'Bonfigli','Bonfiglioli Vectron GmbH'),(14195772882944,'ElimosSr','ELIMOS srl'),(14220200509440,'HonHaiPr','Hon Hai Precision Ind. Co.,Ltd.'),(14222717091840,'Anacom','AnaCom Inc'),(14225351114752,'MalgnTec','Malgn Technology Co., Ltd.'),(14227951583232,'Globalsa','Globalsat International Technolo'),(14239443976192,'JavaInfo','Java Information'),(14241809563648,'EmMicroe','EM Microelectronic'),(14242195439616,'BeijingS','Beijing Signalway Technologies C'),(14261757673472,'ArrisGro','ARRIS Group, Inc.'),(14278669107200,'AirohaTe','Airoha Technology Corp.,'),(17592186044416,'Private',''),(17593695993856,'Ibm','IBM Corp'),(17594601963520,'HP',''),(17595742814208,'DEC',''),(17595944140800,'AppleA/U','Apple A/UX			(modified addresses'),(17596078358528,'National','NATIONAL SEMICONDUCTOR'),(17596430680064,'Laonpeop','LaonPeople'),(17599870009344,'AshleyBu','Ashley Butterworth'),(17631042076672,'JanomeSe','Janome Sewing Machine Co., Ltd.'),(17642266034176,'IntelCor','Intel Corporate'),(17644329631744,'Pomdevic','pomdevices, LLC'),(17648809148416,'OnlineSe','Online Security Pty. Ltd.'),(17648859480064,'Embedian','Embedian, Inc.'),(17650151325696,'Netgear','NETGEAR INC.,'),(17653037006848,'NecCasio','NEC CASIO Mobile Communications'),(17663958974464,'Mccain','McCain Inc'),(17669797445632,'VivoInte','Vivo International Corporation P'),(17670703415296,'Itg','ITG, Inc.'),(17677783400448,'JustecIn','Justec International Technology '),(17697916059648,'ElmoMoti','Elmo Motion Control'),(17709559447552,'HuaweiTe','HUAWEI TECHNOLOGIES CO.,LTD'),(17712646455296,'Apple',''),(17718099050496,'On-QLlcD','ON-Q LLC dba ON-Q Mesh Networks'),(17719961321472,'SamsungE','Samsung Electronics Co.,Ltd'),(17727276187648,'Hewlett-','Hewlett-Packard Company'),(17740244975616,'Zerodesk','ZeroDesktop, Inc.'),(17764806819840,'Morion','Morion Inc.'),(17787976155136,'Looxcie','Looxcie Inc.'),(17792690552832,'TexasIns','Texas Instruments'),(17828694458368,'SimlinkA','Simlink AS'),(17847082287104,'SamsungE','Samsung Electronics Co.,Ltd'),(17858104918016,'HfcTechn','HFC Technology (Beijing) Ltd. Co'),(17871140814848,'Apple','Apple, Inc.'),(17881710460928,'Soundmax','Soundmax Electronic Limited'),(17885753769984,'ShaanxiH','Shaanxi Hitech Electronic Co., L'),(17891726458880,'Norphoni','Norphonic AS'),(17892699537408,'Lnt-Auto','LNT-Automation GmbH'),(17899276206080,'HuaweiTe','HUAWEI TECHNOLOGIES CO.,LTD'),(17904393256960,'BeijingD','Beijing Duokan Technology Limite'),(17924895014912,'Innovati','Innovative Computer Engineering'),(17964942229504,'PeplinkI','Peplink International Ltd.'),(17988312891392,'Perma-Pi','Perma-Pipe, Inc.'),(17990527483904,'Durobyte','DuroByte Inc'),(18000308600832,'Actionte','Actiontec Electronics, Inc'),(18001432674304,'CiscoSpv','Cisco SPVTG'),(18005761196032,'HewlettP','Hewlett Packard'),(18016465059840,'Adatis','Adatis GmbH & Co. KG'),(18025474424832,'AdfwebCo','ADFweb.com s.r.l.'),(18029450625024,'Iqsim',''),(18032453746688,'NecAcces','NEC AccessTechnica, Ltd.'),(18039919607808,'LgElectr','LG Electronics'),(18069984378880,'Buffalo','Buffalo Inc.'),(18072937168896,'Ad-SolNi','Ad-Sol Nissin Corp'),(18081694875648,'CloudTel','Cloud Telecomputers, LLC'),(18101307441152,'Eocell',''),(18106256719872,'SamsungE','Samsung Electronics Co.,LTD'),(18111038226432,'HanvitSi','Hanvit SI, Inc.'),(18111105335296,'Elitegro','ELITEGROUP COMPUTER SYSTEM CO., '),(18118420201472,'U&UEngin','U&U ENGINEERING INC.'),(18158349975552,'Microsev','Microseven Systems, LLC'),(18176553254912,'DarumaTe','Daruma TelecomunicaÃ§Ãµes e Info'),(18196954349568,'Cisco','CISCO SYSTEMS, INC.'),(18227455328256,'Apple','Apple, Inc.'),(18256714792960,'TosiboxO','Tosibox Oy'),(18257318772736,'Apple','Apple, Inc.'),(18277921193984,'Actionte','Actiontec Electronics, Inc'),(18284665634816,'Fujikura','FUJIKURA RUBBER LTD.'),(18310569656320,'SkMtek','SK Mtek Limited'),(18318874378240,'BeijingC','Beijing Cyber Cloud Technology C'),(18382292254720,'Plastofo','Plastoform Industries Ltd.'),(18391016407040,'LikaSrl','Lika srl'),(18393818202112,'GanaI&C','GANA I&C CO., LTD'),(18404337516544,'Cisco','CISCO SYSTEMS, INC.'),(18413732757504,'AsustekC','ASUSTEK COMPUTER INC.'),(18428530262016,'Utt','UTT Co., Ltd.'),(18440542748672,'BioSound','BIO SOUND LAB CO., LTD.'),(18443109662720,'HuaweiTe','Huawei Technologies Co., Ltd'),(18446817427456,'GarminIn','Garmin International'),(18447941500928,'MidasKla','Midas Klark Teknik Ltd'),(18461933699072,'Precia',''),(18472033583104,'AximumPr','AXIMUM PRODUITS ELECTRONIQUES'),(18493525196800,'InstarDe','INSTAR Deutschland GmbH'),(18508121374720,'SamsungE','Samsung Electronics Co.,Ltd'),(18544343384064,'Apple',''),(18566422200320,'QiHardwa','Qi Hardware Inc.'),(18570482286592,'SeohwaTe','Seohwa Telecom'),(18574374600704,'AprLlc','APR, LLC'),(18582947758080,'SourceTe','Source Technologies, LLC'),(18592611434496,'Phasespa','PhaseSpace'),(18598701563904,'CiscoSpv','Cisco SPVTG'),(18618028916736,'CanogaPe','Canoga Perkins Corporation'),(18636148310016,'Cisco',''),(18639537307648,'Gridco','Gridco Systems, Inc.'),(18642741755904,'T3Innova','T3 Innovation'),(18663495172096,'LgElectr','LG Electronics'),(18665625878528,'Nokia','Nokia Corporation'),(18674249367552,'Kangshen','KangSheng LTD.'),(18675927089152,'ShanyEle','Shany Electronic Co., Ltd.'),(18687083937792,'Tp-LinkT','TP-LINK TECHNOLOGIES CO., LTD.'),(18694549798912,'Private',''),(22020431544320,'Private',''),(22024055422976,'Abrantix','Abrantix AG'),(22043751874560,'FreeboxS','FREEBOX SAS'),(22047392530432,'Flextron','Flextronics International'),(22061619609600,'Apple','Apple Inc'),(22072642240512,'Anakreon','Anakreon UK LLP'),(22077390192640,'FujianSt','FUJIAN STAR-NET COMMUNICATION CO'),(22103260659712,'Treetech','Treetech Sistemas Digitais'),(22109367566336,'Volex','Volex Inc.'),(22110223204352,'Intellim','Intellimedia Systems Ltd'),(22144163512320,'Eutronix','EUTRONIX CO., LTD.'),(22185838116864,'IncipioT','Incipio Technologies, Inc'),(22187616501760,'Amphitec','Amphitech'),(22198437806080,'Avermetr','Avermetrics'),(22220197855232,'Mediabri','Mediabridge Products, LLC.'),(22220868943872,'FutureDe','Future Designs, Inc.'),(22222244675584,'Nokia','Nokia Corporation'),(22227445612544,'Procom','PROCOM Systems'),(22243266527232,'Dynapowe','Dynapower Company LLC'),(22258131140608,'Alcatel-','Alcatel-Lucent'),(22273197080576,'MonacoEn','Monaco Enterprises, Inc.'),(22278414794752,'Creative','Creative&Link Technology Limited'),(22305778434048,'DigitalC','Digital Control Incorporated'),(22307523264512,'SamsungE','Samsung Electro Mechanics co.,LT'),(22317086277632,'MaxCommu','Max Communication GmbH'),(22351311798272,'Entis','Entis Co., Ltd.'),(22376863498240,'Apple','Apple, Inc.'),(22384581017600,'Motorola','Motorola Mobility, Inc.'),(22415568535552,'JabilCir','JABIL CIRCUIT (SHANGHAI) LTD.'),(22445683638272,'CypressE','Cypress Electronics Limited'),(22462846730240,'Private',''),(22486083174400,'TubitakU','TUBITAK UEKAE'),(22488733974528,'Rim',''),(22530106589184,'JoaTelec','JOA TELECOM.CO.,LTD'),(22530408579072,'MurataMa','Murata Manufacturing Co., Ltd.'),(22550105030656,'HefeiRad','Hefei Radio Communication Techno'),(22568207646720,'Tp-LinkT','TP-LINK TECHNOLOGIES CO.,LTD.'),(22582887710720,'SamsungE','Samsung Electronics'),(22584817090560,'Ads','ADS GmbH'),(22607734767616,'Apple','Apple, Inc.'),(22611123765248,'KongtopI','KongTop industrial(shen zhen)CO.'),(22627095674880,'BluCastl','BLU CASTLE S.A.'),(22677024669696,'LenovoMo','Lenovo Mobile Communication Tech'),(22703935324160,'SMDezacS','S.M. Dezac S.A.'),(22713582223360,'Shenzhen','ShenZhen Telacom Science&Technol'),(22719890456576,'Mst','MST CORPORATION'),(22728698494976,'ArrisGro','ARRIS Group, Inc.'),(22753797210112,'Infiniwi','InfiniWing, Inc.'),(22777234980864,'ArcheanT','ARCHEAN Technologies'),(22823942750208,'SabtechI','Sabtech Industries'),(22881656373248,'OhsungEl','OHSUNG ELECTRONICS CO., LTD.'),(22881740259328,'Tp-LinkT','TP-LINK TECHNOLOGIES CO., LTD.'),(22883082436608,'ArrisGro','ARRIS Group, Inc.'),(22905027035136,'Pace','Pace plc'),(22910647402496,'D-LinkIn','D-Link International'),(22915496017920,'ConchEle','CONCH ELECTRONIC Co.,Ltd'),(22930444517376,'AsustekC','ASUSTek COMPUTER INC.'),(22933061763072,'SNetMedi','S NET MEDIA'),(22973444521984,'MlogicLl','mLogic LLC'),(22981900238848,'Tp-LinkT','TP-LINK TECHNOLOGIES CO., LTD.'),(23000405508096,'Bsmedias','BSMediasoft Co., Ltd.'),(23015068794880,'AirnavLl','AirNav Systems LLC'),(23024329818112,'Xtremio','Xtremio Ltd.'),(23038909218816,'SamsungE','Samsung Electronics'),(23084090261504,'Sagittar','SAGITTAR LIMITED'),(23084190924800,'Dell','Dell Inc'),(26389034041344,'SonyMobi','Sony Mobile Communications AB'),(26391953276928,'Fitbit','Fitbit Inc.'),(26396382461952,'Elektrob','Elektrobit Wireless Communicatio'),(26403093348352,'Dell','Dell Inc'),(26405358272512,'IbtInter','IBT Interfaces'),(26416011804672,'DilaxInt','DILAX Intelcom GmbH'),(26436899438592,'Nanotron','Nanotron Technologies GmbH'),(26441815162880,'Westingh','Westinghouse Electric Company, L'),(26442704355328,'Canon','CANON INC.'),(26458307166208,'Cedint-U','CEDINT-UPM'),(26474715283456,'TebSas','TEB SAS'),(26475621253120,'Nokia','Nokia Corporation'),(26487398858752,'Daewoois',''),(26487684071424,'CameoCom','Cameo Communications, Inc.'),(26496710213632,'TamtronO','Tamtron Oy'),(26520080875520,'SamsungE','Samsung Electronics Co.,Ltd'),(26526556880896,'Apple','Apple, Inc.'),(26553199099904,'SamsungE','Samsung Electronics Co.,Ltd'),(26561705148416,'AirtiesW','AirTies Wireless Networks'),(26570731290624,'Nintendo','Nintendo Co., Ltd.'),(26573046546432,'8dTechno','8D Technologies'),(26579690323968,'ConceptD','Concept Development, Inc.'),(26605745340416,'LaonTech','LAON TECHNOLOGY CO., LTD.'),(26609956421632,'Cisco','CISCO SYSTEMS, INC.'),(26612976320512,'Apple','Apple, Inc.'),(26624435159040,'ElecsysI','Elecsys International Corporatio'),(26629417992192,'WuhanLin','Wuhan Lingjiu High-tech Co.,Ltd.'),(26633511632896,'Unicoi','Unicoi Systems'),(26645205352448,'BydPreci','BYD Precision Manufacture Compan'),(26652989980672,'IntelCor','Intel Corporate'),(26660053188608,'SamsungE','Samsung Electronics Co.,Ltd'),(26672233447424,'Private',''),(26672535437312,'AlcatelL','Alcatel Lucent'),(26689312653312,'SamsungE','Samsung Electronics'),(26701140590592,'Fastback','Fastback Networks'),(26725769543680,'MessoaTe','MESSOA TECHNOLOGIES INC.'),(26741858893824,'Pixord','Pixord Corporation'),(26748519448576,'HanyangD','Hanyang Digitech Co.Ltd'),(26753602945024,'CiscoSpv','Cisco SPVTG'),(26771386793984,'CiscoSpv','Cisco SPVTG'),(26778718437376,'Zenotech','Zenotech.Co.,Ltd'),(26830174158848,'Veros','Veros Systems, Inc.'),(26831717662720,'HanoverD','Hanover Displays Limited'),(26832019652608,'KomegInd','KOMEG Industrielle Messtechnik G'),(26833613488128,'SamsungE','Samsung Electronics Co.,LTD'),(26858997415936,'Adanis','Adanis Inc.'),(26914731327488,'AmiccomE','AMICCOM Electronics Corporation'),(26923019272192,'ValeoVis','Valeo Vision Systems'),(26941490987008,'Barberry','Barberry Solutions Ltd'),(26942145298432,'Alcatel-','Alcatel-Lucent Shanghai Bell Co.'),(26955483185152,'Coretrus','CoreTrust Inc.'),(26964777762816,'DigitalA','DIGITAL ART SYSTEM'),(26966690365440,'NokiaDan','Nokia Danmark A/S'),(26970616233984,'Htc','HTC Corporation'),(26973854236672,'BeijingJ','Beijing Jinhong Xi-Dian Informat'),(27001737969664,'TpVision','TP Vision Belgium N.V. - innovat'),(27016082489344,'VirtualI','Virtual Instruments'),(27041097318400,'Techfait','TechFaith Wireless Technology Li'),(27051432083456,'Cse-Serv','CSE-Servelec Limited'),(27071111757824,'Apple','Apple Inc'),(27114212425728,'Hewlett-','Hewlett-Packard Company'),(27116729008128,'DellPcba','Dell Inc PCBA Test'),(27126828892160,'UltraEle','Ultra Electronics - Electrics'),(27132600254464,'Polostar','Polostar Technology Corporation'),(27138740715520,'SiemensC','Siemens Convergence Creators Gmb'),(27142297485312,'Apple',''),(27142565920768,'Digitron','DIGITRONIC Automationsanlagen Gm'),(27152934240256,'TorreyPi','Torrey Pines Logic, Inc'),(27160198774784,'Netlogic','Netlogic AB'),(27162178486272,'NestLabs','Nest Labs Inc.'),(27168100843520,'I-Storm',''),(27176908881920,'Invoxia',''),(27215160934400,'Broadcom','Broadcom Corporation'),(27231451611136,'TucsonEm','Tucson Embedded Systems'),(27283528089600,'DasanSmc','DASAN SMC, Inc.'),(27309180452864,'Inmarsat',''),(27310874951680,'KurthEle','Kurth Electronic GmbH'),(27321511706624,'QvisLabs','Qvis Labs, LLC'),(27334614712320,'YulongCo','Yulong Computer Telecommunicatio'),(27361223376896,'SttCondi','STT Condigi'),(27362196455424,'SamsungE','Samsung Electronics'),(27384510152704,'Apple','Apple, Inc.'),(27384963137536,'VikingEl','Viking Electronics Inc.'),(27388419244032,'Modulete','MODULETEK'),(27416437194752,'Cisco','CISCO SYSTEMS, INC.'),(27438029471744,'HonHaiPr','Hon Hai Precision Ind. Co.,Ltd.'),(27446183198720,'Multimed','Multimedia Pacific Limited'),(27455477776384,'I3Intern','i3 International Inc.'),(27463883161600,'IscAppli','ISC applied systems corp'),(27473278402560,'ChangheE','Changhe Electronics Co., Ltd.'),(27480073175040,'Espressi','Espressif Inc.'),(30813538222080,'Idy','IDY Corporation'),(30823923318784,'LgInnote','Lg Innotek'),(30834945949696,'EpicomSA','EPICOM S.A'),(30854222970880,'SyproOpt','Sypro Optics GmbH'),(30863114895360,'Wartsila','Wartsila Finland Oy'),(30866269011968,'IeeePesP','IEEE PES PSRC/SUB'),(30873432883200,'Motorola','Motorola Mobility, Inc.'),(30888649818112,'Cisco','CISCO SYSTEMS, INC.'),(30890646306816,'Shenzhen','ShenZhen RicherLink Technologies'),(30897424302080,'Eyevis','eyevis GmbH'),(30912607682560,'Shenzhen','Shenzhen Huawei Communication Te'),(31006660755456,'ItsTelec','ITS Telecom'),(31011660365824,'Innovati','Innovation Wireless'),(31018002153472,'NewLiftN','NEW Lift Neue Elektronische Wege'),(31025753227264,'Cloudium','Cloudium Systems Ltd.'),(31036759080960,'Accuspec','AccuSpec Electronics, LLC'),(31052194119680,'SigmaKok','Sigma Koki Co.,Ltd.'),(31054828142592,'HonHaiPr','Hon Hai Precision Ind. Co.,Ltd.'),(31078047809536,'JapanCir','JAPAN CIRCUIT CO.,LTD'),(31085144571904,'TexasIns','Texas Instruments'),(31099740749824,'GnNetcom','GN Netcom A/S'),(31108297129984,'Amon','AMON INC'),(31112038449152,'Azurewav','AzureWave'),(31137254604800,'Techaya','Techaya LTD'),(31142103220224,'FlatDisp','FLAT DISPLAY TECHNOLOGY CORPORAT'),(31173912821760,'SamsungE','Samsung Eletronics Co., Ltd (Vis'),(31174667796480,'PhilipsE','Philips Electronics Nederland BV'),(31182888632320,'PrimaCin','PRIMA Cinema, Inc'),(31183073181696,'Shenzhen','Shenzhen Belzon Technology Co.,L'),(31198625660928,'BeijingE','Beijing Ereneben Information Tec'),(31210319380480,'SamsungE','Samsung Electronics Co.,Ltd'),(31222751297536,'LiteonTe','Liteon Technology Corporation'),(31226240958464,'HonHaiPr','Hon Hai Precision Ind.Co.Ltd'),(31227264368640,'SamsungE','Samsung Electronics'),(31240065384448,'Research','Research In Motion'),(31249276076032,'Mitsunam','Mitsunami Co., Ltd.'),(31264761446400,'Giga-Byt','GIGA-BYTE TECHNOLOGY CO.,LTD.'),(31288970969088,'CompalIn','COMPAL INFORMATION (KUNSHAN) CO.'),(31296520716288,'TerasicT','Terasic Technologies Inc.'),(31315160203264,'SonyMobi','Sony Mobile Communications AB'),(31319186735104,'Eid',''),(31320059150336,'VitekInd','Vitek Industrial Video Products,'),(31322240188416,'Coriant','Coriant GmbH'),(31331333439488,'D-LinkIn','D-Link International'),(31351919083520,'LinkedIp','Linked IP GmbH'),(31354938982400,'FormosaW','FORMOSA WIRELESS COMMUNICATION C'),(31364753653760,'Mct','MCT CO., LTD.'),(31398593298432,'DbCommun','DB Communication & Systems Co., '),(31402821156864,'PhaseMot','Phase Motion Control SpA'),(31411125878784,'Integrat','Integrated System Technologies L'),(31424430211072,'RuagSchw','RUAG Schweiz AG'),(31427835985920,'I-LaxEle','I-LAX ELECTRONICS INC.'),(31428943282176,'Veethree','Veethree Electronics And Marine '),(31435889049600,'PricomDe','PRICOM Design'),(31444730642432,'MurataMa','Murata Manufactuaring Co.,Ltd.'),(31505464164352,'Shenzhen','SHENZHEN CHUANGWEI-RGB ELECTRONI'),(31516587458560,'Cisco','CISCO SYSTEMS, INC.'),(31523566780416,'Apple','Apple, Inc.'),(31538028740608,'SamsungE','Samsung Electronics Co.,Ltd'),(31542088826880,'D-LinkIn','D-LINK INTERNATIONAL PTE LIMITED'),(31544722849792,'Htc','HTC Corporation'),(31548665495552,'NecAcces','NEC AccessTechnica, Ltd.'),(31551953829888,'Tdc','TDC A/S'),(31587538305024,'TexasIns','Texas Instruments'),(31592303034368,'Ojsc\"Ufi','OJSC \"Ufimskiy Zavod \"Promsvyaz\"'),(31598309277696,'Amplifie','Amplified Engineering Pty Ltd'),(31601178181632,'D-LinkIn','D-LINK INTERNATIONAL PTE LIMITED'),(31618978807808,'Hewlett-','Hewlett-Packard Company'),(31624213299200,'Milesigh','MileSight Technology Co., Ltd.'),(31637735735296,'Arcadyan','Arcadyan Technology Corporation'),(31697059971072,'KriwanIn','Kriwan Industrie-Elektronik GmbH'),(31744354942976,'Cisco','CISCO SYSTEMS, INC.'),(31754387718144,'Marshal','Marshal Corporation'),(31755142692864,'Qisda','Qisda Corporation'),(31760410738688,'TexasIns','Texas Instruments'),(31774889476096,'Apple',''),(31777506721792,'Cisco',''),(31818745118720,'Scaps','SCAPS GmbH'),(31837686595584,'Private',''),(31842468102144,'TurtleIn','Turtle Industry Co., Ltd.'),(31861812232192,'Tp-LinkT','TP-LINK TECHNOLOGIES CO.,LTD.'),(31880049065984,'Identyte','IDentytech Solutins Ltd.'),(35189992456192,'LineaRes','Linea Research Ltd'),(35195898036224,'MurataMa','Murata Manufactuaring Co.,Ltd.'),(35205930811392,'RadmaxCo','RADMAX COMMUNICATION PRIVATE LIM'),(35209739239424,'OooInpro','OOO InProMedia'),(35228898820096,'Xiangsha','Xiangshan Giant Eagle Technology'),(35255138385920,'GemtekTe','Gemtek Technology Co., Ltd.'),(35263141117952,'MostLuck','Most Lucky Trading Ltd'),(35269734563840,'SamsungE','Samsung Electronics Co.,Ltd'),(35282485248000,'LiteonTe','Liteon Technology Corporation'),(35296141901824,'CompalIn','COMPAL INFORMATION (KUNSHAN) CO.'),(35308976472064,'Elatec','Elatec GmbH'),(35328874250240,'LgElectr','LG Electronics Inc'),(35345836015616,'Teleview',''),(35372293685248,'Shenzhen','Shenzhen Huawei Communication Te'),(35376420880384,'KongYueE','Kong Yue Electronics & Informati'),(35420695953408,'Cisco','CISCO SYSTEMS, INC.'),(35423749406720,'KuipersE','Kuipers Electronic Engineering B'),(35433597632512,'Cisco',''),(35459333881856,'Feno','feno GmbH'),(35465054912512,'SmartehD','Smarteh d.o.o.'),(35477402943488,'Schneide','Schneider Electric Asia Pacific '),(35487720931328,'Vecow','VECOW Co., Ltd'),(35489197326336,'Advanced','Advanced Network Devices (dba:AN'),(35505051795456,'HanscanS','Hanscan Spain S.A.'),(35512618319872,'HugoBren','Hugo Brennenstuhl Gmbh & Co. KG.'),(35521174700032,'AxxanaIs','Axxana(israel) ltd'),(35521510244352,'Netgear',''),(35547129053184,'SonyMobi','Sony Mobile Communications AB'),(35558587891712,'SalixTec','Salix Technology CO., Ltd.'),(35569308532736,'ParagonT','Paragon Technologies Inc.'),(35575918755840,'Private',''),(35576791171072,'Shenzhen','Shenzhen Wonhe Technology Co., L'),(35614707679232,'SamsungE','SAMSUNG ELECTRO MECHANICS CO.,LT'),(35629723287552,'Pluto','Pluto inc.'),(35633682710528,'LiteonTe','Liteon Technology Corporation'),(35641953878016,'WistronI','Wistron InfoComm Manufacturing(K'),(35643916812288,'AtlasEle','Atlas Elektronik UK Limited'),(35665072881664,'BraemacC','Braemac CA LLC'),(35679719391232,'ArrisGro','ARRIS Group, Inc.'),(35686061178880,'Shenzhen','Shenzhen Voxtech Co.,Ltd'),(35691178229760,'Actionte','Actiontec Electronics, Inc'),(35719347175424,'QuantaMi','Quanta Microsystems,Inc.'),(35723189157888,'Apple',''),(35757951549440,'Assa',''),(35774997200896,'CompalIn','COMPAL INFORMATION (KUNSHAN) CO.'),(35809457602560,'Profalux',''),(35810783002624,'IM','I`M SPA'),(35852860260352,'JiaxingG','JIAXING GLEAD Electronics Co.,Lt'),(35884032327680,'Lee-Dick','Lee-Dickens Ltd'),(35915137286144,'Ip-NetLl','IP-NET LLC'),(35915774820352,'Cisco-Li','Cisco-Linksys, LLC'),(35944430305280,'Enclustr','Enclustra GmbH'),(35955738148864,'Enterasy','Enterasys'),(35965083058176,'MimosaNe','Mimosa Networks'),(35973572329472,'OmicronE','Omicron electronics GmbH'),(35990752198656,'Cisco',''),(35990852861952,'JabilCir','Jabil Circuit Hungary Ltd.'),(36008385052672,'Dvl',''),(36016236789760,'IWitDigi','i Wit Digital Co., Limited'),(36038718259200,'Panasoni','Panasonic Corporation AVC Networ'),(36046368669696,'Shenzhen','SHENZHEN BUL-TECH CO.,LTD.'),(36051150176256,'Apple','Apple Inc'),(36065796685824,'TexasIns','Texas Instruments, Inc'),(36072423686144,'PerasoTe','Peraso Technologies'),(36074235625472,'AsustekC','ASUSTek COMPUTER INC.'),(36102069026816,'KoreaInf','Korea Infocom Co.,Ltd.'),(36102404571136,'SamsungE','Samsung Eletronics Co., Ltd'),(36103612530688,'Nokia','Nokia Corporation'),(36116480655360,'Iota','Iota, Inc.'),(36131731144704,'CheetahH','Cheetah Hi-Tech, Inc.'),(36133123653632,'Tp-LinkT','TP-LINK TECHNOLOGIES CO., LTD.'),(36143206760448,'NanjingS','Nanjing SAC Power Grid Automatio'),(36168624242688,'Netgear','NETGEAR INC.,'),(36169597321216,'Motorola','Motorola Mobility, Inc.'),(36209896194048,'Elefirst','Elefirst Science & Tech Co ., lt'),(36215197794304,'MtdataDe','MTData Developments Pty. Ltd.'),(36230783827968,'HuaweiTe','Huawei Technologies Co., Ltd'),(36251101036544,'DeltaEle','Delta Electronics'),(36261251252224,'Cambridg','Cambridge Executive Limited'),(36275042123776,'3comEuro','3COM EUROPE LTD'),(36278733111296,'SystemIn','System In Frontier Inc.'),(36278967992320,'M2mSolut','M2M Solution S.A.S.'),(39590052233216,'Cisco',''),(39621459181568,'DevlinEl','Devlin Electronics Limited'),(39627045994496,'Azurewav','AzureWaveTechnologies,Inc'),(39630367883264,'ViettelG','Viettel Group'),(39632632807424,'KostalIn','KOSTAL Industrie Elektrik GmbH'),(39652815798272,'Shenzhen','Shenzhen Ecsino Tecnical Co. Ltd'),(39656053800960,'Hutek','Hutek Co., Ltd.'),(39658922704896,'Chongqin','Chongqing Ehs Science and Techno'),(39696436559872,'Squarehe','Squarehead Technology AS'),(39698701484032,'Shanghai','Shanghai Nutshell Electronic Co.'),(39716300783616,'Calsys','Calsys, Inc.'),(39727021424640,'SonyEric','Sony Ericsson Mobile Communicati'),(39788476366848,'ToshibaG','Toshiba Global Commerce Solution'),(39819916869632,'CiscoSpv','Cisco SPVTG'),(39822651555840,'EmcElect','EMC Electronic Media Communicati'),(39840653508608,'Dynamode','Dynamode Group'),(39881304702976,'GemueGeb','GEMUE Gebr. Mueller Apparatebau'),(39887596158976,'Pentroni','PentronicAB'),(39898014810112,'Innovati','Innovative Converged Devices Inc'),(39994181812224,'Kyocera','KYOCERA Corporation'),(40005338660864,'Sysmocom','sysmocom - systems for mobile co'),(40016495509504,'Avm','AVM GmbH'),(40034631680000,'Jasmine','Jasmine Systems Inc.'),(40036158406656,'HuaweiTe','Huawei Technologies Co., Ltd'),(40040554037248,'It-IsInt','IT-IS International'),(40091321892864,'CiscoSpv','Cisco SPVTG'),(40093570039808,'IntelCor','Intel Corporate'),(40139321507840,'KshInter','KSH International Co., Ltd.'),(40143079604224,'ProwaveT','Prowave Technologies Ltd.'),(40162037858304,'Ctek','Ctek, Inc.'),(40162356625408,'Senergy','SEnergy Corporation'),(40219181056000,'OpenRoad','OPEN ROAD SOLUTIONS , INC.'),(40222435835904,'Sfr',''),(40287531433984,'KoukaamA','KOUKAAM a.s.'),(40287799869440,'Ubiquiti','Ubiquiti Networks, INC'),(40309190819840,'PureStor','PURE Storage'),(40319022268416,'Apple','Apple, Inc.'),(40335279390720,'Alcatel-','Alcatel-Lucent-IPD'),(40335447162880,'NexgenMe','NEXGEN Mediatech Inc.'),(40365562265600,'Cisco','CISCO SYSTEMS, INC.'),(40367189655552,'Friem','FRIEM SPA'),(40368347283456,'Dell','Dell Inc'),(40375041392640,'Crenus','Crenus Co.,Ltd.'),(40376215797760,'OpzoonTe','Opzoon Technology Co.,Ltd.'),(40382087823360,'Technica','Technical Consumer Products, Inc'),(40388815486976,'Absolute','Absolute Analysis'),(40392053489664,'DaliWire','Dali Wireless, Inc.'),(40398546272256,'HewlettP','Hewlett Packard'),(40404703510528,'Private',''),(40410055442432,'Rsf',''),(40435338706944,'SamsungE','Samsung Electronics Co.,Ltd'),(40443257552896,'ChaneyIn','Chaney Instrument Co.'),(40448408158208,'RuckusWi','Ruckus Wireless'),(40449431568384,'Genoray',''),(40458172497920,'Myk','MYK, Inc.'),(40472030478336,'Shenzhen','Shenzhen State Micro Technology '),(40487784284160,'Smartdri','SmartDrive Systems Inc.'),(40514980151296,'Avaya','Avaya, Inc'),(40521774923776,'Sistemas','Sistemas de GestiÃ³n EnergÃ©tica'),(40525902118912,'Shenzhen','Shenzhen Huawei Communication Te'),(40525918896128,'Shoppert','ShopperTrak RCT Corporation'),(40539223228416,'ArubaNet','Aruba Networks'),(40573381640192,'JscZavod','JSC Zavod im. Kozitsky'),(40588514689024,'SystemeH','Systeme Helmholz GmbH'),(40593430413312,'SaetISSR','SAET I.S. S.r.l.'),(40598597795840,'AskeyCom','Askey Computer Corp'),(40599621206016,'CsgScien','CSG Science & Technology Co.,Ltd'),(40605593894912,'ChengduY','Chengdu Yingji Electronic Hi-tec'),(40617488941056,'Ght','GHT Co., Ltd.'),(40625508450304,'RadiantZ','Radiant Zemax LLC'),(40637537714176,'SamsungE','Samsung Electronics Co.,LTD'),(40670421057536,'LiteonTe','Liteon Technology Corporation'),(44001403076608,'FermaxEl','FERMAX ELECTRONICA S.A.U.'),(44006738231296,'NingboGl','NINGBO GLOBAL USEFUL ELECTRIC CO'),(44008600502272,'ItlLlc','ITL, LLC'),(44035091726336,'Mikrosay','Mikrosay Yazilim ve Elektronik A'),(44040527544320,'SonyComp','Sony Computer Entertainment Inc.'),(44051248185344,'D-LinkIn','D-Link International'),(44068260282368,'Lantis','Lantis co., LTD.'),(44075726143488,'2wire',''),(44082705465344,'Omnisens','Omnisense Ltd'),(44085557592064,'Microsof','Microsoft Corporation'),(44087788961792,'AdityaIn','Aditya Infotech Ltd.'),(44146458886144,'PbrElect','PBR electronics GmbH'),(44153824083968,'ZyxelCom','ZyXEL Communications Corporation'),(44160199426048,'Globalbe','GlobalBeiMing technology (Beijin'),(44172430016512,'Tp-LinkT','TP-LINK TECHNOLOGIES CO.,LTD.'),(44192294240256,'HuaweiTe','HUAWEI TECHNOLOGIES CO.,LTD'),(44204071845888,'EnigmaDi','Enigma Diagnostics Limited'),(44217611059200,'Apple','Apple, Inc.'),(44224456163328,'Gen2wave',''),(44229153783808,'PrecenoT','Preceno Technology Pte.Ltd.'),(44241988354048,'HuaweiTe','Huawei Technologies Co., Ltd'),(44255779225600,'C8Medise','C8 MediSensors, Inc.'),(44260191633408,'Optisens','OptiSense Network, LLC'),(44290877161472,'Gridcent','GridCentric Inc.'),(44308275134464,'IntuneNe','Intune Networks'),(44323223633920,'Liaoning','Liaoning Wontel Science and Tech'),(44329196322816,'Shenzhen','Shenzhen Prayfly Technology Co.,'),(44392161214464,'Shenzhen','Shenzhen Huawei Communication Te'),(44393956376576,'LantechC','Lantech Communications Global, I'),(44395264999424,'Capelec',''),(44438818652160,'Apple','Apple, Inc.'),(44438852206592,'Apple','Apple, Inc.'),(44451149905920,'Samjin','SAMJIN Co., Ltd.'),(44456468283392,'HuaweiTe','HUAWEI TECHNOLOGIES CO.,LTD'),(44468011008000,'SpirePay','Spire Payments'),(44473396494336,'Smartmat','Smartmatic Corp'),(44474117914624,'Athena',''),(44502639181824,'Realplay','Realplay Digital Technology(Shen'),(44552450736128,'TouchNet','Touch Networks'),(44569227952128,'Cashguar','CashGuard Sverige AB'),(44606725029888,'StageTec','Stage Tec Entwicklungsgesellscha'),(44608771850240,'HewlettP','Hewlett Packard'),(44616086716416,'Cisco','CISCO SYSTEMS, INC.'),(44616371929088,'Cisco','CISCO SYSTEMS, INC.'),(44635363737600,'SamsungE','Samsung Electronics Co.,Ltd'),(44643148365824,'Steelser','SteelSeries ApS'),(44662811262976,'DanfossT','Danfoss Turbocor Compressors, In'),(44674202992640,'Enblink',''),(44674404319232,'GerpSolu','GERP Solution'),(44677340332032,'Exlar','exlar corp'),(44691080871936,'MillerEl','Miller Electric Mfg. Co.'),(44732252160000,'SiriusXm','Sirius XM Radio Inc'),(44739801907200,'XenyaDOO','Xenya d.o.o.'),(44748140183552,'IntelCor','Intel Corporate'),(44752133160960,'GenmarkA','Genmark Automation'),(44779731681280,'NextnavL','NextNav, LLC'),(44799109365760,'Technico','Technicolor USA Inc.'),(44808756264960,'JuniperN','Juniper Networks'),(44832764461056,'YotaDevi','Yota Devices OY'),(44833251000320,'Netgear','NETGEAR INC.,'),(44835566256128,'Altierre',''),(44844089081856,'Taimag','Taimag Corporation'),(44856286117888,'One',''),(44856655216640,'SamsungE','Samsung Electronics Co.,Ltd'),(44860916629504,'Corporac','Corporacion Empresarial Altra SL'),(44861403168768,'EspotelO','Espotel Oy'),(44862208475136,'Individu','Individual Computers GmbH'),(44863550652416,'Shenzhen','Shenzhen Dynamax Software Develo'),(44873180774400,'Apple','Apple, Inc.'),(44873432432640,'Apple',''),(44881049288704,'Nokia','Nokia Corporation'),(44883549093888,'LcfcHefe','LCFC(HeFei) Electronics Technolo'),(44897272856576,'PremierW','Premier Wireless, Inc.'),(44913513201664,'Telecor','Telecor Inc.'),(44915006373888,'YuduanMo','Yuduan Mobile Co., Ltd.'),(44923227209728,'Shanghai','Shanghai Guao Electronic Technol'),(44943275982848,'Apple','Apple, Inc.'),(44953661079552,'Shanghai','Shanghai InfoTM Microelectronics'),(44968441806848,'Tokheim',''),(44975085584384,'Microtim','Microtime Computer Inc.'),(44976075440128,'Apple','Apple, Inc.'),(44999848755200,'JagJakob','JAG Jakob AG'),(45003405524992,'Frontlin','Frontline Test Equipment'),(45006979072000,'Private',''),(45025618558976,'2c-Trifo','2C - Trifonov & Co'),(45033570959360,'Add-Engi','ADD-Engineering BV'),(45037127729152,'SyesSrl','Syes srl'),(45062041894912,'Ragentek','Ragentek Technology Group'),(48379249819648,'Unowhy',''),(48379367260160,'Econtrol','EControls, LLC'),(48382655594496,'Xos',''),(48404868628480,'WinLeade','Win Leader Inc.'),(48450469101568,'Nintendo','Nintendo Co., Ltd.'),(48488100397056,'IdnTelec','IDN Telecom, Inc.'),(48511286509568,'Aerodev',''),(48522158145536,'JuniperN','Juniper Networks'),(48534724280320,'BabolatV','Babolat VS'),(48545025490944,'Zte','zte corporation'),(48549622448128,'Hewlett-','Hewlett-Packard Company'),(48551065288704,'BbkCommu','BBK COMMUNICATIAO TECHNOLOGY CO.'),(48572993110016,'BctElect','bct electronic GesmbH'),(48586414882816,'Pantech','Pantech Co.,Ltd'),(48602504232960,'ErcoGene','ERCO & GENER'),(48607604506624,'ElliyPow','ELLIY Power CO..Ltd'),(48613124210688,'Capisco','Capisco Limited'),(48614600605696,'Cisco','CISCO SYSTEMS, INC.'),(48625841340416,'Sagemcom',''),(48628290813952,'FagorEle','Fagor ElectrÃ³nica'),(48636159328256,'NetstorT','Netstor Technology Co., Ltd.'),(48650034085888,'Cisco','CISCO SYSTEMS, INC.'),(48650134749184,'Alge-Tim','Alge-Timing GmbH'),(48658624020480,'Hewlett-','Hewlett-Packard Company'),(48670586175488,'SamsungE','Samsung Electronics Co.,Ltd'),(48671022383104,'Spectrum','Spectrum Medical Limited'),(48674814033920,'HewlettP','Hewlett Packard'),(48740043849728,'Cisco','CISCO SYSTEMS, INC.'),(48764605693952,'HewlettP','Hewlett Packard'),(48767793364992,'PromateE','PROMATE ELECTRONIC CO.LTD'),(48800928366592,'FinestSe','Finest Security Systems Co., Ltd'),(48801716895744,'Regeners','Regenersis (Glenrothes) Ltd'),(48825104334848,'Shenzhen','ShenZhen Zhengjili Electronics C'),(48832603750400,'RfContro','RF Controls, LLC'),(48842183540736,'JuniperN','Juniper networks'),(48871409451008,'Soundmat','Soundmatters'),(48881274454016,'Shanghai','Shanghai Dongzhou-Lawton Communi'),(48887633018880,'Hewlett-','Hewlett-Packard Company'),(48908302548992,'Milper','Milper Ltd'),(48909007192064,'OooPetrT','OOO Petr Telegin'),(48923150385152,'Onzo','Onzo Ltd'),(48929961934848,'HartingO','HARTING Inc. of North America'),(48934038798336,'HonHaiPr','Hon Hai Precision Ind. Co.,Ltd'),(48979572162560,'HitachiM','Hitachi Metals America Ltd'),(49001936191488,'Eintechn','Eintechno Corporation'),(49006315044864,'KishuGik','Kishu Giken Kogyou Company Ltd,.'),(49015844503552,'Cincoze','Cincoze Co., Ltd.'),(49027437559808,'ICYBV','I.C.Y. B.V.'),(49058710290432,'Motorola','Motorola Mobility, Inc.'),(49061344313344,'Canon','CANON INC.'),(49071460974592,'Acromate','acromate, Inc.'),(49097918644224,'TrueTech','True Technologies Inc.'),(49100955320320,'Rim',''),(49113571786752,'Shenzhen','Shenzhen Gongjin Electronics Co.'),(49135986147328,'Netgear',''),(49138167185408,'SolitonT','Soliton Technologies Pvt Ltd'),(49152578813952,'Apple',''),(49162661920768,'Radware',''),(49162829692928,'RedDigit','RED Digital Cinema'),(49197088768000,'Ingenieu','Ingenieurbuero Bickele und Buehl'),(49213345890304,'Ravello','Ravello Systems'),(49255037272064,'Nokia','Nokia Corporation'),(49259634229248,'Precor','Precor Inc'),(49260103991296,'SummitTe','Summit Technology Group'),(49273374769152,'LiteonTe','Liteon Technology Corporation'),(49279817220096,'Sanjole','Sanjole, Inc.'),(49284330291200,'Nokia','Nokia Corporation'),(49290185539584,'Fujitsu','Fujitsu Limited'),(49327900721152,'Discover','Discovergy GmbH'),(49351992803328,'Devicede','DeviceDesign'),(49358066155520,'Sagemcom','SAGEMCOM SAS'),(49369776652288,'RuckusWi','Ruckus Wireless'),(49376839860224,'AlertMet','Alert Metalguard ApS'),(49400361517056,'AlpheusD','Alpheus Digital Company Limited'),(49401351372800,'Petroleu','Petroleum Geo-Services'),(49417944039424,'EmkoElek','EMKO ELEKTRONIK SAN VE TIC AS'),(49429788753920,'Avaya','Avaya, Inc'),(50775875125248,'LaaLocal','LAA (Locally Administered Addres'),(52799576473600,'BrotherI','Brother industries, LTD.'),(52826420019200,'DeltaMob','Delta Mobile Systems, Inc.'),(52840261222400,'HonHaiPr','Hon Hai Precision Ind.Co.Ltd'),(52863212453888,'Piciorgr','Piciorgros GmbH'),(52863698993152,'WistronN','Wistron Neweb Corp.'),(52867155099648,'Ubiquito','Ubiquitous Communication Co. ltd'),(52873413001216,'Prolon',''),(52878697824256,'SonyEric','Sony Ericsson Mobile Communicati'),(52883110232064,'DeosCont','DEOS control systems GmbH'),(52888898371584,'MakoNetw','Mako Networks Ltd'),(52919818780672,'Shenzhen','Shenzhen Ostar Display Electroni'),(52973723975680,'JdaLlcJd','JDA, LLC (JDA Systems)'),(52993789526016,'W-Ie-Ne-','W-IE-NE-R Plein & Baus GmbH'),(52994863267840,'Hanilstm','Hanilstm Co., Ltd.'),(53015566352384,'Cisco','CISCO SYSTEMS, INC.'),(53018502365184,'Nokia','Nokia Corporation'),(53022008803328,'SonyEric','Sony Ericsson Mobile Communicati'),(53022797332480,'Shenzhen','Shenzhen Jinhengjia Electronic C'),(53025431355392,'AdbBroad','ADB Broadband Italia'),(53027343958016,'IntelCor','Intel Corporate'),(53038685356032,'GlinttTe','GLINTT TES S.A.'),(53045748563968,'SonavoxC','Sonavox Canada Inc'),(53057677164544,'AltecLan','ALTEC LANSING LLC'),(53069840646144,'Plath','PLATH GmbH'),(53079789535232,'Netgear',''),(53091080601600,'NanjingZ','Nanjing Z-Com Wireless Co.,Ltd'),(53105089576960,'Panasoni','Panasonic Electric Works Automat'),(53114837139456,'TianjinT','Tianjin Techua Technology Co., L'),(53130255400960,'Nst','NST Co., LTD'),(53145606553600,'TrexNetw','Trex Network LLC'),(53153105969152,'Irlab','IRLAB LTD.'),(53176929615872,'Beissbar','Beissbarth'),(53189462196224,'ArrisGro','ARRIS Group, Inc.'),(53193471950848,'Pav','PAV GmbH'),(53193572614144,'Paradom','Paradom Inc.'),(53214309253120,'WistronC','Wistron (ChongQing)'),(53225583542272,'ReachTec','Reach Technology Inc.'),(53228787990528,'Rim',''),(53243602272256,'Skymotio','Skymotion Technology (HK) Limite'),(53250548039680,'ValidusT','Validus Technologies'),(53264875782144,'Hangzhou','Hangzhou Prevail Optoelectronic '),(53285226545152,'LgElectr','LG Electronics'),(53293749370880,'TianjinG','TIANJIN Golden Pentagon Electron'),(53295208988672,'Innowire','Innowireless, Co. Ltd.'),(53309939384320,'Rim',''),(53321129787392,'Sfr',''),(53350624133120,'AsustekC','Asustek Computer Inc'),(53357184024576,'Shenzhen','Shenzhen Huawei Communication Te'),(53367535566848,'Guangdon','Guangdong East Power Co.,'),(53382064635904,'Dropcam',''),(53397902327808,'Apple',''),(53407750553600,'Shanghai','SHANGHAI SUNMON COMMUNICATION TE'),(53509873467392,'Shanghai','Shanghai Reallytek Information T'),(53525946040320,'DeqingDu','Deqing Dusun Electron CO., LTD'),(53528009637888,'RadioMob','Radio Mobile Access'),(53541431410688,'HytecGer','Hytec Geraetebau GmbH'),(53548075188224,'Shenzhen','Shenzhen Heguang Measurement & C'),(53636256235520,'Wi-NextS','Wi-Next s.r.l.'),(53659828224000,'SamsungE','Samsung Electronics ITS, Printer'),(53684255850496,'Logosol','Logosol, Inc.'),(53688869584896,'Autosale','Autosales Incorporated'),(53732289019904,'CedacSof','Cedac Software S.r.l.'),(53758193041408,'Vodafone','Vodafone UK'),(53759484887040,'Cisco','CISCO SYSTEMS, INC.'),(53786496204800,'IntekDig','INTEK DIGITAL'),(53806561755136,'AlstomSt','Alstom Strongwish (Shenzhen) Co.'),(53820721725440,'Zte','zte corporation'),(53821208264704,'+PluggSr','+plugg srl'),(53837633159168,'Cisco','Cisco Systems'),(53840720166912,'Apple',''),(53849981190144,'Sony','Sony Corporation'),(53863470071808,'Macrotec','MACROTECH (USA) INC.'),(57208880496640,'Ericsson','Ericsson AB'),(57209031491584,'D-Link','D-Link Corporation'),(57260101337088,'IntelCor','Intel Corporate'),(57267449757696,'Apple','Apple, Inc'),(57287548862464,'Shenzhen','SHENZHEN WEIBU ELECTRONICS CO.,L'),(57291139186688,'Grandbei','Grandbeing Technology Co., Ltd'),(57316489560064,'JensenSc','Jensen Scandinavia AS'),(57328049061888,'SamsungE','Samsung Electro Mechanics co.,LT'),(57335078715392,'Shenzhen','Shenzhen Loadcom Technology Co.,'),(57354624172032,'McdElect','MCD ELECTRONICS SP. Z O.O.'),(57378313601024,'Anywire','Anywire corporation'),(57452519227392,'Ibm',''),(57497750601728,'Fiberhom','Fiberhome Telecommunication Tech'),(57498069368832,'Zte','ZTE Corporation'),(57515668668416,'EkinopsS','EKINOPS SAS'),(57525869215744,'Apple','Apple, Inc.'),(57565731880960,'EviHeat','EVI HEAT AB'),(57622522757120,'Terawork','Teraworks Co., Ltd.'),(57637706137600,'HuaweiTe','Huawei Technologies Co., Ltd'),(57649366302720,'Ecosense',''),(57653795487744,'WhiteRod','White Rodgers Division'),(57680454483968,'Avaya','Avaya, Inc'),(57684715896832,'I-ODataD','I-O DATA DEVICE, INC.'),(57691997208576,'O-NetCom','O-NET Communications(Shenzhen) L'),(57716726824960,'NokiaDan','Nokia Danmark A/S'),(57729578172416,'UnicardS','UNICARD SA'),(57736674934784,'KayoTech','Kayo Technology, Inc.'),(57737278914560,'Iforcom','iFORCOM Co., Ltd'),(57742714732544,'Ericsson','Ericsson AB'),(57750834905088,'HeinzLac','Heinz Lackmann GmbH & Co KG'),(57818228981760,'Logitec','Logitec Corporation'),(57827355787264,'Advanced','ADVANCED RF TECHNOLOGIES INC'),(57833596911616,'VpiEngin','VPI Engineering'),(57835341742080,'Universa','Universal Flow Monitors, Inc.'),(57836247711744,'ZbdDispl','ZBD Displays Ltd'),(57851330428928,'Heinzman','Heinzmann GmbH & CO. KG'),(57868292194304,'Aware','AWare, Inc'),(57884834529280,'Technoso','TECHNOSOFT INTERNATIONAL SRL'),(57889918025728,'ShinePro','Shine Profit Development Limited'),(57892015177728,'TrevilSr','Trevil srl'),(57894984744960,'FischerI','Fischer International Systems Co'),(57897283223552,'KyoceraD','KYOCERA Display Corporation'),(57897467772928,'Cisco',''),(57907315998720,'Alcatel-','Alcatel-Lucent'),(57908742062080,'Mikrovis','Mikrovisatos Servisas UAB'),(57921459191808,'Shanghai','Shanghai Chint Power Systems Co.'),(57926962118656,'Nintendo','Nintendo Co., Ltd.'),(57938957828096,'TexasIns','Texas Instruments'),(57953889550336,'Plds',''),(57974827515904,'Se-KureC','Se-Kure Controls, Inc.'),(57976052252672,'Asiatelc','Asiatelco Technologies Co.'),(57978283622400,'Research','Research In Motion'),(57984843513856,'BeijingD','Beijing Ding Qing Technology, Lt'),(57989708906496,'Cisco','Cisco Systems'),(57990530990080,'Shanghai','Shanghai WDK Industrial Co.,Ltd.'),(57990547767296,'CiscoSpv','Cisco SPVTG'),(57997359316992,'Fiberhom','Fiberhome Telecommunication Tech'),(58000731537408,'Apple',''),(58015008948224,'SamsungE','Samsung Electronics'),(58027591860224,'Enecsys','Enecsys Ltd'),(58030125219840,'Alps','ALPS Co,. Ltd.'),(58033648435200,'Nokia','Nokia Corporation'),(58040527093760,'EidolonC','EIDOLON COMMUNICATIONS TECHNOLOG'),(58056901656576,'CommskyT','CommSky Technologies'),(58058260611072,'HuaweiTe','Huawei Technologies Co., Ltd'),(58061850935296,'ParsecPt','Parsec (Pty) Ltd'),(58070558310400,'Mobilmax','MobilMAX Technology Inc.'),(58079836110848,'RenaPrin','RENA GmbH Print Systeme'),(58101042511872,'Tributar','Tributary Systems, Inc.'),(58133086994432,'FujikonI','Fujikon Industrial Co.,Limited'),(58140150202368,'Zte','zte corporation'),(58140284420096,'Dongguan','DONGGUAN QISHENG ELECTRONICS IND'),(58202242678784,'2wire',''),(58203433861120,'NttCommu','NTT Communications Corporation'),(58220882165760,'Wizlan','WizLAN Ltd.'),(58231921573888,'Sharp','SHARP Corporation'),(58245796331520,'AtekProd','ATEK Products, LLC'),(58249420210176,'Guangzho','Guangzhou Robustel Technologies '),(58258798673920,'Alcea',''),(61579479482368,'ToshibaS','Toshiba Samsung Storage Technolg'),(61601440858112,'ADC','A.D.C. GmbH'),(61615768600576,'Sky-City','Sky-City Communication and Elect'),(61618083856384,'SamsungE','Samsung Electronics Co.,Ltd'),(61632042500096,'PrimaxEl','Primax Electronics LTD.'),(61638317178880,'Apple',''),(61640900870144,'Dedicate','Dedicated Network Partners Oy'),(61670646874112,'SamsungE','Samsung Electronics Co.,Ltd'),(61673146679296,'Promzaka','PROMZAKAZ LTD.'),(61680813867008,'Nokia','Nokia Corporation'),(61694151753728,'SimcomWi','SIMCom Wireless Solutions Co.,Lt'),(61721314066432,'PirelliT','Pirelli Tyre S.p.A.'),(61722270367744,'H3cTechn','H3C Technologies Co., Limited'),(61739299241984,'Andtek',''),(61748375715840,'FujianNe','Fujian Netcom Technology Co., LT'),(61785990234112,'Weg',''),(61843502530560,'DblTechn','DBL Technology Ltd.'),(61856974635008,'Wildeboe','Wildeboer Bauteile GmbH'),(61862175571968,'PatrolPr','Patrol Products Consortium LLC'),(61871352709120,'MycloudT','MyCloud Technology corporation'),(61873433083904,'Zte','ZTE Corporation'),(61883163869184,'Apple',''),(61915980103680,'Azurewav','Azurewave Technologies, Inc.'),(61925274681344,'Alcatel-','Alcatel-Lucent 7705'),(61950809604096,'Panacces','Panaccess Systems GmbH'),(61959063994368,'Mindmade','MindMade sp. z o.o.'),(61959080771584,'HonHaiPr','Hon Hai Precision Ind. Co.,Ltd.'),(61983944605696,'YuJeongS','Yu Jeong System, Co.Ltd'),(61986964504576,'Pegatron','PEGATRON CORPORATION'),(62001980112896,'3nodMult','3NOD MULTIMEDIA(SHENZHEN)CO.,LTD'),(62011895447552,'OosicTec','OOSIC Technology CO.,Ltd'),(62017499037696,'AsiaOpti','Asia Optical Co., Inc.'),(62035349995520,'Motorola','Motorola Mobility, Inc.'),(62045651206144,'WasionGr','Wasion Group Ltd.'),(62065498652672,'Comtrend',''),(62136449499136,'Tp-LinkT','TP-LINK TECHNOLOGIES CO., LTD.'),(62168426872832,'ItcNetwo','ITC Networks'),(62186412048384,'Fanhatta','Fanhattan LLC'),(62199632494592,'XenoxBv','Xenox Holding BV'),(62215050756096,'BeijingT','Beijing Tendyron Corporation'),(62257748770816,'OtnNV','OTN Systems N.V.'),(62284374212608,'Shenzhen','SHENZHEN MEGMEET ELECTRICAL CO.,'),(62295564615680,'MoogIng','Moog, Ing'),(62296000823296,'OrgaBv','Orga BV'),(62300094464000,'Actifio','Actifio Inc'),(62303802228736,'SamsungE','SAMSUNG ELECTRO-MECHANICS'),(62333615341568,'Sonotron','Sonotronic Nagel GmbH'),(62353211129856,'EGOElekt','E.G.O. Elektro-Ger'),(62376397242368,'Ozvision','OzVision America LLC'),(62380541214720,'MeizuTec','Meizu technology co.,ltd'),(62393845547008,'NecCasio','NEC CASIO Mobile Communications'),(62399801458688,'AlpsElec','ALPS ELECTRIC CO.,LTD.'),(62430470209536,'CsServic','CS Services Co.,Ltd.'),(62433188118528,'CiscoSpv','Cisco SPVTG'),(62471188512768,'EasyioSd','EasyIO Corporation Sdn. Bhd.'),(62527744507904,'Mohlenho','Mohlenhoff GmbH'),(62537106194432,'Mitsubis','Mitsubishi Electric Corporation'),(62558698471424,'Shenzhen','Shenzhen Gongjin Electronics Co.'),(62568412479488,'Htc','HTC Corporation'),(62572824887296,'BMedien+','b gmbh medien + datenbanken'),(62575727345664,'RecoSPA','Reco S.p.A.'),(62580475297792,'HewlettP','Hewlett Packard'),(62590088642560,'SamsungE','Samsung Electronics'),(62597487394816,'Anedo','Anedo Ltd.'),(62627451502592,'Home2net','home2net GmbH'),(62640873275392,'V2comPar','V2COM PARTICIPACOES S.A.'),(62666877960192,'EllipsBV','Ellips B.V.'),(65970697666560,'3Com',''),(65982257168384,'Creation','Creation Technologies LP'),(65991081984000,'Pravis','PRAVIS SYSTEMS Co.Ltd.,'),(65995041406976,'ProductC','Product Creation Studio'),(66002171723776,'Apple','Apple, Inc.'),(66002658263040,'Sony','Sony Corporation'),(66005560721408,'BeijingY','Beijing Yupont Electric Power Te'),(66011181088768,'Powerhou','Powerhouse Dynamics'),(66038360178688,'KbcNetwo','KBC Networks'),(66041279414272,'Albahith','ALBAHITH TECHNOLOGIES'),(66078424170496,'GfiChron','GFI Chrono Time'),(66080169000960,'Ericsson','Ericsson AB'),(66083826434048,'Cardiopu','Cardiopulmonary Corp'),(66084396859392,'HuayuanT','Huayuan Technology CO.,LTD'),(66094144421888,'JadakLlc','JADAK LLC'),(66137479970816,'SoteraWi','Sotera Wireless'),(66139862335488,'SleQuali','SLE quality engineering GmbH & C'),(66167041425408,'TexasIns','Texas Instruments'),(66173534208000,'Sforzato','SFORZATO Corp.'),(66203649310720,'Nokia','Nokia Corporation'),(66213497536512,'Connectq','ConnectQuest, llc'),(66218782359552,'JwElectr','JW Electronics Co., Ltd.'),(66221735149568,'Avaya','Avaya, Inc'),(66246900973568,'Guangdon','Guangdong Pisen Electronics Co. '),(66260842840064,'Motorola','Motorola Mobility, LLC.'),(66290974720000,'Hewlett-','Hewlett-Packard Company'),(66298876788736,'Infinity','Infinity System S.L.'),(66306896297984,'Etronic','Etronic A/S'),(66347530715136,'KesslerC','Kessler Crane Inc.'),(66347933368320,'Fiveco',''),(66358167470080,'SamsungE','Samsung Electronics'),(66378736336896,'Synerchi','Synerchip Co., Ltd.'),(66391604461568,'SamsungE','Samsung electronics CO., LTD'),(66393617727488,'Shenzhen','SHENZHEN JETNET TECHNOLOGY CO.,L'),(66413817495552,'Sciovid','Sciovid Inc.'),(66428061351936,'NiigataP','Niigata Power Systems Co., Ltd.'),(66448596664320,'Fiberpro','Fiberpro Inc.'),(66451583008768,'Entek','EnTek Systems, Inc.'),(66453227175936,'Makerbot','MakerBot Industries'),(66469836619776,'Rim',''),(66474450354176,'Motorola','Motorola Mobility, Inc.'),(66510538145792,'TexasIns','Texas Instruments'),(66528372326400,'Sagemcom','SAGEMCOM SAS'),(66536375058432,'AdvanceV','Advance Vision Electronics Co. L'),(66549041856512,'Sangshin','Sangshin elecom .co,, LTD'),(66566355943424,'JuniperN','Juniper Networks'),(66567245135872,'TensunIn','Tensun Information Technology(Ha'),(66571959533568,'SamsungE','Samsung Electronics'),(66594927542272,'Hangzhou','Hangzhou Yulong Conmunication Co'),(66595414081536,'AlongCom','ALONG COMMUNICATION TECHNOLOGY'),(66609926373376,'JuniperN','Juniper Networks'),(66619472609280,'WistronI','Wistron InfoComm(Kunshan)Co.,Ltd'),(66621351657472,'IpsTechn','IPS Technology Limited'),(66626737143808,'QuestCon','Quest Controls, Inc.'),(66631971635200,'Lansente','Lansentechnology AB'),(66655761727488,'Shenzhen','Shenzhen CATIC Bit Communication'),(66671129657344,'BlessInf','Bless Information & Communicatio'),(66688678625280,'MrvCommu','MRV Communications (Networks) LT'),(66700640780288,'IntelCor','Intel Corporate'),(66732433604608,'Avaya','Avaya, Inc'),(66733037584384,'Wattwatc','Wattwatchers Pty Ld'),(66763018469376,'Private',''),(66768051634176,'BeldenDe','Belden Deutschland GmbH'),(66786070364160,'LgElectr','LG ELECTRONICS INC'),(66798653276160,'D&BAudio','d&b audiotechnik GmbH'),(66800364552192,'Aes','AES Corporation'),(66803753549824,'MelangeP','Melange Systems Pvt. Ltd.'),(66805045395456,'Nokia','Nokia Corporation'),(66836636893184,'HuiyangT','Huiyang Technology Co., Ltd'),(66857390309376,'Cisco','CISCO SYSTEMS, INC.'),(66868211613696,'Apple','Apple, Inc.'),(66870191325184,'Telepowe','Telepower Communication Co., Ltd'),(66897773068288,'SkMtekMi','SK Mtek microelectronics(shenzhe'),(66903426990080,'Hewlett-','Hewlett-Packard Company'),(66928978690048,'Cisco','CISCO SYSTEMS, INC.'),(66934682943488,'Apple',''),(66957030195200,'Hangzhou','Hangzhou H3C Technologies Co., L'),(66957265076224,'KidasenI','KIDASEN INDUSTRIA E COMERCIO DE '),(66959144124416,'LgDispla','LG Display'),(66977045413888,'2wire',''),(66979931095040,'Nse','NSE AG'),(67016824193024,'Virtualt','Virtualtek. Co. Ltd'),(67023702851584,'Dspecial','DSPECIALISTS GmbH'),(67032259231744,'Nokia','Nokia Corporation'),(67051251040256,'EmcraftL','Emcraft Systems LLC'),(70368794509312,'NetWare?','Net Ware (?)'),(70376361033728,'3comEuro','3COM EUROPE LTD'),(70386125373440,'A&T',''),(70402030174208,'Railtec','Railtec Systems GmbH'),(70430601773056,'Tremol','Tremol Ltd.'),(70431105089536,'SamsungE','Samsung Electro Mechanics co.,LT'),(70449878794240,'Compass-','Compass-EOS'),(70453989212160,'GlobalEs','Global ES'),(70461471850496,'ProtectA','Protect America, Inc.'),(70465901035520,'Tp-LinkT','TP-LINK TECHNOLOGIES CO., LTD.'),(70467427762176,'EkmMeter','EKM Metering'),(70474792960000,'Aerohive','Aerohive Networks Inc.'),(70475430494208,'WyleTele','Wyle Telemetry and Data Systems'),(70494791401472,'Biometri','Biometric Associates, LP'),(70518749265920,'DigitalP','Digital Projection Ltd'),(70530912747520,'IntelCor','Intel Corporate'),(70536432451584,'Mobileec','Mobileeco Co., Ltd'),(70556128903168,'SonyEric','Sony Ericsson Mobile Communicati'),(70561816379392,'Universa','Universal Global Scientific Indu'),(70574969716736,'Apple','Apple, Inc.'),(70589599449088,'GodrejBo','Godrej & Boyce Mfg. co. ltd'),(70607869837312,'MacroIma','Macro Image Technology, Inc.'),(70630670073856,'Apple','Apple, Inc.'),(70644192509952,'Ziv',''),(70645417246720,'Icomera',''),(70686622089216,'ZyxelCom','ZyXEL Communications Corporation'),(70701839024128,'Shenzhen','Shenzhen Huawei Communication Te'),(70716099657728,'MiltonSe','Milton Security Group LLC'),(70718448467968,'GrandexI','Grandex International Corporatio'),(70721149599744,'PicoTech','Pico Technology'),(70734772699136,'Cisco','CISCO SYSTEMS, INC.'),(70738312691712,'InHomeDi','In Home Displays Ltd'),(70757891702784,'Anovo',''),(70779953741824,'Rim',''),(70780020850688,'TexasIns','Texas Instruments'),(70782570987520,'HawkeyeT','Hawkeye Tech Co. Ltd'),(70787604152320,'Micro-St','MICRO-STAR INT`L CO.,LTD'),(70787738370048,'Stella-G','Stella-Green Co'),(70808877662208,'Mediola-','mediola - connected living AG'),(70816058310656,'ThalesOp','Thales Optronics Limited'),(70826879614976,'Rim',''),(70834999787520,'Apple','Apple, Inc.'),(70846190190592,'Research','Research In Motion'),(70851022028800,'PowerIde','Power Idea Technology Limited'),(70851726671872,'LifeTech','Life Technology (China) Co., Ltd'),(70897478139904,'MettleNe','Mettle Networks Inc.'),(70935109435392,'Motorola',''),(70938146111488,'Claviste','Clavister AB'),(70956617826304,'BeijingE','Beijing Ereneben Information Tec'),(70964033355776,'Titeng','TITENG CO., Ltd.'),(70965862072320,'Actionte','Actiontec Electronics, Inc'),(70969871826944,'Shenzhen','Shenzhen TCL New Technology Co; '),(71010170699776,'Aisino','Aisino Corporation'),(71020790677504,'BkElectr','BK Electronics cc'),(71022854275072,'CasacomS','Casacom Solutions AG'),(71022887829504,'TexasIns','Texas Instruments'),(71023642804224,'Aisino','Aisino Corporation'),(71054982643712,'Baekchun','BAEKCHUN I&C Co., Ltd.'),(71084460212224,'Passivsy','PassivSystems Ltd'),(71085349404672,'Apple','Apple, Inc.'),(71109844140032,'DataMana','Data Management, Inc.'),(71128852725760,'LgElectr','LG Electronics'),(71136603799552,'NortelNe','Nortel Networks'),(71140043128832,'Apple',''),(71141771182080,'Logital','Logital Co. Limited'),(71145864822784,'JuniperN','Juniper Networks'),(71158800056320,'Motorola','Motorola Mobility, Inc.'),(71169235484672,'ArimaCom','Arima Communications Corp.'),(71178127409152,'Cronopla','Cronoplast  S.L.'),(71178530062336,'Itelio','itelio GmbH'),(71183143796736,'Physio-C','Physio-Control, Inc'),(71189468807168,'Digistar','Digistar Telecom. SA'),(71203125460992,'Shenzhen','Shenzhen Hexicom Technology Co.,'),(71214148091904,'Chongqin','ChongQing Camyu Technology Devel'),(71226814889984,'Naviit','Naviit Inc.'),(71243441111040,'HuaweiTe','Huawei Technologies Co., Ltd'),(71250185551872,'Z3Techno','Z3 Technology'),(71275737251840,'Apple','Apple, Inc'),(71279512125440,'Biodata','Biodata Ltd'),(71285065383936,'MicroSER','MICRO S.E.R.I.'),(71297883176960,'Xronos','XRONOS.INC'),(71361686929408,'DeyStora','DEY Storage Systems, Inc.'),(71363347873792,'Shenzhen','Shenzhen Siviton Technology Co.,'),(71386517209088,'Siemens','Siemens AG'),(71396516429824,'Fihonest','Fihonest communication co.,Ltd'),(71405106364416,'IseEurop','ISE Europe SPRL'),(71412035354624,'Ibm',''),(71412555448320,'MurataMa','Murata Manufactuaring Co.,Ltd.'),(71416833638400,'Nintendo','Nintendo Co., Ltd.'),(71420675620864,'Cisco','CISCO SYSTEMS, INC.'),(71421782917120,'LeicaMic','Leica Microsystems (Schweiz) AG'),(71453374414848,'Motorola','Motorola Mobility, LLC.'),(74782477385728,'Cisco',''),(74822574931968,'Netman','NetMan Co., Ltd.'),(74848814497792,'WkkTechn','WKK TECHNOLOGY LTD.'),(74871195303936,'Fitview',''),(74877218324480,'Hangzhou','Hangzhou Hikvision Digital Techn'),(74898340839424,'Hewlett-','Hewlett-Packard Company'),(74919966670848,'Farmage','Farmage Co., Ltd.'),(74928841818112,'BambooEn','Bamboo Entertainment Corporation'),(74948789927936,'Apple','Apple, Inc.'),(74951457505280,'E3Techno','E3 Technology, Inc.'),(74951524614144,'Cisco','CISCO SYSTEMS, INC.'),(74982243696640,'Avaya','Avaya, Inc'),(74984894496768,'Technico','Technicolor USA Inc.'),(74987109089280,'Shenzhen','Shenzhen Bilian electronic CO.,L'),(74992528130048,'MxtIndus','MXT INDUSTRIAL LTDA'),(75003433320448,'2SaveEne','2 Save Energy Ltd'),(75004876161024,'YoungEle','Young Electric Sign Co'),(75006872649728,'HonHaiPr','Hon Hai Precision Ind.Co.Ltd'),(75008265158656,'CumulusN','Cumulus Networks, inc'),(75014892158976,'Universa','Universal Global Scientific Indu'),(75029337341952,'Nuvolt',''),(75036065005568,'Deotron','DEOTRON Co., LTD.'),(75064535941120,'Microsoft',''),(75068663136256,'DfiDiamo','DFI (Diamond Flower Industries)'),(75086312767488,'Silverfl','Silverflare Ltd.'),(75093409529856,'Apple','Apple Inc'),(75102234345472,'SamsungE','Samsung Electronics Co.,Ltd'),(75107670163456,'PanStudi','Pan Studios Co.,Ltd.'),(75118357250048,'Raytheon','Raytheon BBN Technologies'),(75130789167104,'Thompson','Thompson Aerospace'),(75138523463680,'PncTechn','PNC Technologies  Co., Ltd.'),(75139228106752,'SpawnLab','Spawn Labs, Inc'),(75145435676672,'CiscoSpv','Cisco SPVTG'),(75151710355456,'Criticar','Criticare Systems, Inc'),(75174594478080,'Tonalite','Tonalite Holding B.V.'),(75176859402240,'ShihlinE','Shihlin Electric & Engineering C'),(75184241377280,'Ecobee','ecobee inc'),(75186019762176,'Fonsyste','FONsystem co. ltd.'),(75210598383616,'OrbitIrr','Orbit Irrigation'),(75216336191488,'Juin','JUIN COMPANY, LIMITED'),(75231251136512,'ReallinE','Reallin Electronic Co.,Ltd'),(75236401741824,'LiteonTe','Liteon Technology Corporation'),(75301497339904,'Innoligh','Innolight Technology Corporation'),(75306429841408,'VtionInf','VTION INFORMATION TECHNOLOGY (FU'),(75310456373248,'AlphaAnd','Alpha and Omega, Inc'),(75329733394432,'Star-Net',''),(75338021339136,'IntelCor','Intel Corporate'),(75350839132160,'Elitegro','ELITEGROUP COMPUTER SYSTEM CO., '),(75369461841920,'Ktis','KTIS CO., Ltd'),(75376978034688,'DtResear','DT Research, Inc.'),(75378840305664,'Vig',''),(75393235156992,'Shanghai','Shanghai Huaqin Telecom Technolo'),(75406673707008,'Netgear','NETGEAR INC.,'),(75410935119872,'QingdaoS','Qingdao Santong Digital Technolo'),(75434523885568,'NowFacto','The Now Factory'),(75439842263040,'Alcomp','Alcomp, Inc'),(75471920300032,'TctMobil','TCT Mobile Limited'),(75482053738496,'PromaxEl','PROMAX ELECTRONICA SA'),(75487523110912,'MurataMa','Murata Manufacturing Co., Ltd.'),(75491599974400,'SewooTec','SEWOO TECH CO., LTD'),(75497589440512,'Udworks','udworks Co., Ltd.'),(75500827443200,'NanotecE','Nanotec Electronic GmbH & Co. KG'),(75513460686848,'Cisco',''),(75537770872832,'Kuang-Ch','Kuang-chi Institute of Advanced '),(75597262880768,'TexasIns','Texas Instruments'),(75600869982208,'Guangzho','Guangzhou Comet Technology Devel'),(75606909779968,'OooRubez','OOO RUBEZH NPO'),(75632797024256,'Greenwal','Greenwald Industries'),(75666015911936,'Shanghai','Shanghai Kingto Information Tech'),(75672122818560,'AnviaTvO','Anvia TV Oy'),(75676417785856,'Cisco','CISCO SYSTEMS, INC.'),(75686937100288,'TalariNe','Talari Networks'),(75695342485504,'Azurewav','Azurewave Technologies, Inc.'),(75696718217216,'Apple','Apple, Inc.'),(75714116190208,'PlanexCo','PLANEX COMMUNICATIONS INC.'),(75715089268736,'Semindia','SEMINDIA SYSTEMS PVT LTD'),(75731245727744,'CiscoSpv','Cisco SPVTG'),(75748626923520,'Omnitron','OMNITRONICS PTY LTD'),(75749683888128,'Cisco','CISCO SYSTEMS, INC.'),(75765991342080,'MyrekaTe','Myreka Technologies Sdn. Bhd.'),(75786157555712,'Longicor','Longicorn, inc.'),(75816255881216,'SamsungE','Samsung Electronics'),(75833167314944,'UnionPac','Union Pacific Railroad'),(75845934776320,'Apple',''),(78427226898432,'GtcNotRe','GTC (Not registered!)		(This num'),(79174131777536,'B-LinkEl','B-Link Electronic Limited'),(79179366268928,'DesayEle','DESAY ELECTRONICS(HUIZHOU)CO.,LT'),(79243371347968,'LuxcomTe','Luxcom Technologies Inc.'),(79250518441984,'BbkElect','BBK Electronics Corp., Ltd.'),(79264896516096,'Micropow','MicroPower technologies'),(79284324532224,'IntronSc','Intron Scientific co., ltd.'),(79337424420864,'Zte','ZTE Corporation'),(79357741629440,'Motorola','Motorola Inc Business Light Radi'),(79387588296704,'ZennioAv','ZENNIO AVANCE Y TECNOLOGIA, S.L.'),(79389198909440,'Iep','IEP GmbH'),(79458287484928,'Hds???','HDS ???'),(79459159900160,'CiscoSpv','Cisco SPVTG'),(79461038948352,'SamsungE','Samsung Electronics Co., LTD'),(79469528219648,'UrosOy','Uros Oy'),(79491254714368,'NetworkS','Network Solutions'),(79518651908096,'Soreel',''),(79529506766848,'Winbond?',''),(79552441221120,'Wisol',''),(79556635525120,'AsustekC','ASUSTek COMPUTER INC.'),(79565879771136,'Azurewav','Azurewave Technologies, Inc.'),(79580308176896,'Apple','Apple, Inc.'),(79584183713792,'Concern\"','Concern \"Axion\" JSC'),(79626831396864,'Fleetwoo','Fleetwood Group Inc.'),(79639212982272,'Pica8','Pica8, Inc.'),(79645101785088,'Storsimp','StorSimple Inc'),(79650587934720,'SgbGroup','SGB GROUP LTD.'),(79775829852160,'Digalog','DIGALOG GmbH'),(79788999966720,'Weinmann','Weinmann GerÃ¤te fÃ¼r Medizin Gm'),(79791734652928,'Shenzhen','Shenzhen Reach software technolo'),(79834348781568,'SciInnov','SCI Innovations Ltd'),(79839751045120,'Research','Research In Motion'),(79861376876544,'Shenzhen','Shenzhen Huaxuchang Telecom Tech'),(79881324986368,'GjsunOpt','GJsun Optical Science and Tech C'),(79896541921280,'StoreEle','Store Electronic Systems'),(79930733887488,'Marketax','Marketaxess Corporation'),(79958835724288,'Homewins','HOMEWINS TECHNOLOGY CO.,LTD.'),(79962660929536,'Teletics','Teletics Inc.'),(79981635960832,'Symanitr','Symanitron'),(79996651569152,'Plantron','PLANTRONICS, INC.'),(80025474826240,'SimoWire','Simo Wireless,Inc.'),(80026884112384,'Systec','SysTec GmbH'),(80038561054720,'CelloEle','Cello Electronics (UK) Ltd'),(80067384311808,'LiteonTe','Liteon Technology Corporation'),(80080940302336,'JedaNetw','Jeda Networks'),(80092533358592,'BlankomA','BLANKOM Antennentechnik GmbH'),(80096811548672,'ClaridyS','ClarIDy Solutions, Inc.'),(80113941086208,'Nokia','Nokia Corporation'),(80123084668928,'WuhanNec','Wuhan NEC Fibre Optic Communicat'),(80134140854272,'Vity',''),(80171520491520,'Zhejiang','Zhejiang Uniview Technologies Co'),(80174959820800,'EternaTe','ETERNA TECHNOLOGY, INC.'),(80184891932672,'DaesungE','daesung eltec'),(80205024591872,'Ubizcore','Ubizcore Co.,LTD'),(80208900128768,'Private',''),(80214906372096,'Techvisi','TechVision Holding  Internation '),(80229737431040,'Alcatel-','Alcatel-Lucent'),(80232992210944,'Cisco-Li','Cisco-Linksys, LLC'),(80233763962880,'AlcatelL','Alcatel Lucent WT'),(80234904813568,'Maestron','Maestronic'),(80250255966208,'Woodstre','Woodstream Corporation'),(83565064749056,'Cisco',''),(83572245397504,'CmrKorea','CMR KOREA CO., LTD'),(83573772124160,'LexCompu','LEX COMPUTECH CO., LTD'),(83590968770560,'BaslerEl','Basler Electric Company'),(83596320702464,'Computer','COMPUTER OFFICE Co.,Ltd.'),(83604558315520,'Zte','zte corporation'),(83611101429760,'TctMobil','TCT Mobile Limited'),(83629153714176,'HonHaiPr','Hon Hai Precision Ind. Co.,Ltd.'),(83630646886400,'EardaEle','Earda Electronics Co.,Ltd'),(83650930540544,'Noregon','NOREGON SYSTEMS, INC'),(83665610604544,'Sagemcom',''),(83675525939200,'PrimaRes','PRIMA Research And Production En'),(83677052665856,'Novakon','Novakon Co., Ltd.'),(83699450249216,'HuaweiTe','HUAWEI TECHNOLOGIES CO.,LTD'),(83708107292672,'SonyMobi','Sony Mobile Communications AB'),(83710388994048,'Cozybit','cozybit, Inc.'),(83723810766848,'Nokia','Nokia Corporation'),(83754009755648,'BeijingS','Beijing Skyway Technologies Co.,'),(83767381196800,'IcmContr','ICM Controls'),(83771340619776,'ThalesTr','Thales Transportation Systems Gm'),(83778387050496,'Teledata','TELEDATA NETWORKS'),(83781272731648,'MRuttyHo','M Rutty Holdings Pty. Ltd.'),(83807965282304,'NewtekEl','Newtek Electronics co., Ltd.'),(83818232938496,'VogtecHK','VOGTEC(H.K.) Co., Ltd'),(83847626620928,'Informat','Information Modes software modif'),(83886751088640,'MobileDe','Mobile Device, Inc.'),(83898780352512,'Cisco',''),(83924315275264,'LineproS','Linepro Sp. z o.o.'),(83926227877888,'Shenzhen','Shenzhen Huawei Communication Te'),(83930187300864,'Hamilton','Hamilton Systems'),(83931042938880,'Turkcell','Turkcell Teknoloji'),(83931378483200,'AckmeNet','ACKme Networks Pty Ltd'),(83965754998784,'OyFinnis','Oy Finnish Electric Vehicle Tech'),(83974428819456,'Alcatel-','Alcatel-Lucent'),(83978774118400,'Airpoint','airPointe of New Hampshire'),(83978925113344,'Netgear',''),(83985216569344,'Sanmina-','SANMINA-SCI SYSTEM DE MEXICO S.A'),(83992028119040,'Applicat','Application Solutions (Electroni'),(83996021096448,'Guangdon','Guangdong Leawin Group Co., Ltd'),(84055613767680,'Pegatron','Pegatron Corporation'),(84058533003264,'GeniusBy','Genius Bytes Software Solutions '),(84059573190656,'Kove',''),(84075310219264,'Embedded','Embedded Wireless Labs'),(84080813146112,'Arrowhea','Arrowhead Alarm Products Ltd'),(84085695315968,'IntelCor','Intel Corporate'),(84113964924928,'Armstron','Armstrong Monitoring Corp'),(84115105775616,'IntelCor','Intel Corporate'),(84124702343168,'Echostar','Echostar Technologies'),(84161310228480,'GrupoDig','Grupo Digicon'),(84163893919744,'HuaweiTe','Huawei Technologies Co., Ltd'),(84170504142848,'Apple',''),(84179832274944,'Jastec',''),(84207464349696,'JuniperN','Juniper Networks'),(84219728494592,'Zeo',''),(84243636027392,'KyokkoEl','KYOKKO ELECTRIC Co., Ltd.'),(84245313748992,'HanyangN','Hanyang Navicom Co.,Ltd.'),(84281401540608,'AlcatelL','Alcatel Lucent'),(84293397250048,'Azurewav','AzureWave Technologies (Shanghai'),(84298178756608,'KstTechn','KST technology'),(84301785858048,'Zte','ZTE Corporation'),(84324904861696,'HuaweiTe','HUAWEI TECHNOLOGIES CO.,LTD'),(84325659836416,'Apple','Apple, Inc.'),(84339903692800,'HrdSPte','HRD (S) PTE., LTD.'),(84360808103936,'Conet','CONET CO., LTD.'),(84364482314240,'BisonEle','Bison Electronics Inc.'),(84373105803264,'SamsungE','Samsung Electronics Co.,Ltd'),(84406073032704,'ShangHai','Shang Hai Tyd. Electon Technolog'),(84413320790016,'Radios','Radios, Inc.'),(84427497537536,'Alcatel-','Alcatel-Lucent'),(84431859613696,'Skyera','Skyera, Inc.'),(84439929454592,'Motorola','Motorola Solutions Inc.'),(84482929459200,'QsonoEle','Qsono Electronics Co., Ltd'),(84521684828160,'TeamEngi','TEAM ENGINEERS ADVANCE TECHNOLOG'),(84552705900544,'Buffalo','Buffalo Inc.'),(84573308321792,'IntelCor','Intel Corporate'),(84584515502080,'AskeyCom','Askey Computer Corp'),(84624663379968,'SamjiEle','SamJi Electronics Co., Ltd'),(87963279032320,'HongKong','Hong Kong Telecommunications (HK'),(87968362528768,'SamsungE','Samsung Electronics'),(87983428468736,'CyweeGro','CyWee Group Ltd'),(87986767134720,'Cisco',''),(88009013723136,'FoxdaTec','Foxda Technology Industrial(Shen'),(88022888480768,'Trafficc','TrafficCast International'),(88037887311872,'Silverne','SilverNet Ltd'),(88108687163392,'Pixelink',''),(88120565432320,'NethraIm','Nethra Imaging Incorporated'),(88126554898432,'Fujitsu','Fujitsu Limited'),(88143432777728,'SmartEle','Smart electronic GmbH'),(88143650881536,'TelekomR','Telekom Research and Development'),(88154690289664,'Nokia','Nokia Corporation'),(88156921659392,'IntelCor','Intel Corporate'),(88158297391104,'PhytecMe','Phytec Messtechnik GmbH'),(88161954824192,'AsahiEle','Asahi Electronics Co.,Ltd'),(88177641521152,'SamsungE','Samsung Electronics Co.,Ltd'),(88207169421312,'CiscoSpv','Cisco SPVTG'),(88221916594176,'LenovoMo','Lenovo Mobile Communication Tech'),(88226765209600,'Cisco','CISCO SYSTEMS, INC.'),(88232956002304,'Syncmold','Syncmold Enterprise Corp'),(88263138213888,'AsustekC','ASUSTek COMPUTER INC.'),(88274110513152,'BeijingH','BEIJING HAIHEJINSHENG NETWORK TE'),(88280334860288,'Masimo','Masimo Corporation'),(88302715666432,'LoxoneEl','Loxone Electronics GmbH'),(88331958353920,'TexasIns','Texas Instruments'),(88337410949120,'Cisco','CISCO SYSTEMS, INC.'),(88350799167488,'Guangdon','GUANGDONG SUPER TELECOM CO.,LTD.'),(88373918171136,'Xirrus','Xirrus Inc.'),(88381132374016,'Indu-Sol','Indu-Sol GmbH'),(88386450751488,'HonHaiPr','Hon Hai Precision Ind. Co.,Ltd.'),(88391517470720,'Greenlee',''),(88407338385408,'ZyxelCom','ZyXEL Communications Corporation'),(88440255283200,'Wi-FiAll','Wi-Fi Alliance'),(88445808541696,'HeShanWo','He Shan World Fair Electronics T'),(88451848339456,'BegBruec','BEG Brueck Electronic GmbH'),(88470169059328,'Tekpea','Tekpea, Inc.'),(88470521380864,'EcilInfo','Ecil Informatica Ind. Com. Ltda'),(88482147991552,'Interexp','Interexport Telecomunicaciones S'),(88497834688512,'Biodit',''),(88503656382464,'Arcadyan','Arcadyan Technology Corporation'),(88543837814784,'Nuvyyo','Nuvyyo Inc'),(88554743005184,'UptmateT','Uptmate Technology Co., LTD'),(88557041483776,'Shenzhen','SHENZHEN MAXMADE TECHNOLOGY CO.,'),(88564222132224,'Dirmeier','DIRMEIER Schanktechnik GmbH &Co '),(88568382881792,'Chahoo','CHAHOO Limited'),(88593615814656,'GradualT','Gradual Tecnologia Ltda.'),(88611382886400,'Westingh','Westinghouse Digital'),(88615661076480,'Inventum','Inventum Technologies Private Li'),(88644484333568,'HuaweiTe','Huawei Technologies Co., Ltd'),(88651329437696,'AlbaFibe','Alba Fiber Systems Inc.'),(88668660301824,'SamsungE','Samsung Electronics Co.,Ltd'),(88677703221248,'DavidCla','David Clark Company'),(88678542082048,'Aboundi','Aboundi, Inc.'),(88679045398528,'RuckusWi','Ruckus Wireless'),(88698574077952,'HoseoTel','Hoseo Telecom'),(88714478878720,'Shenzhen','Shenzhen Bitland Information Tec'),(88750180794368,'SamsungE','Samsung Electronics CO., LTD'),(88753922113536,'ImtechTe','ImTech Technologies LLC,'),(88809404366848,'JuniperN','Juniper Networks'),(88826114473984,'GnNetcom','GN Netcom A/S'),(88841264300032,'SamsungE','Samsung Electro Mechanics'),(88842237378560,'NanjingC','NanJing Chaoran Science & Techno'),(88847656419328,'MeasyEle','Measy Electronics Ltd'),(88864819511296,'Steffes','Steffes Corporation'),(88883660324864,'Takahata','Takahata Precision'),(88945702469632,'Giga-Byt','GIGA-BYTE TECHNOLOGY CO.,LTD.'),(88969542893568,'Apple','Apple, Inc.'),(88970683744256,'BrocadeC','Brocade Communications Systems, '),(88981320499200,'EgatelSl','Egatel SL'),(88991772704768,'OpenStac','Open Stack, Inc.'),(89013734080512,'SamsungE','Samsung Electronics Co.,Ltd'),(89017928384512,'KunshanJ','Kunshan JADE Technologies co., L'),(89037540950016,'L-TekDOO','L-tek d.o.o.'),(89044067287040,'Treehous','Treehouse Labs'),(90520730730496,'RealtekU','Realtek (UpTech? also reported)'),(90522005798912,'Novell20','Novell 2000'),(90523599634432,'RealtekA','REALTEK (a Realtek 8029 based PC'),(92375972052992,'EbnTechn','EBN Technology Corp.'),(92378673184768,'Gigawave','Gigawave LTD'),(92378941620224,'AsustekC','ASUSTek COMPUTER INC.'),(92381357539328,'VivagoOy','Vivago Oy'),(92382045405184,'AlcatelL','Alcatel Lucent'),(92432779706368,'SulzerPu','Sulzer Pump Solutions Finland Oy'),(92433585012736,'AtamoPty','Atamo Pty Ltd'),(92476501131264,'Techno-I','Techno-Innov'),(92487741865984,'Freestyl','Freestyle Energy Ltd'),(92495694266368,'Advantag','Advantage Electronics'),(92496818339840,'TelyLabs','Tely Labs'),(92502321266688,'Resoluti','Resolution Products'),(92509166370816,'Zte','zte corporation'),(92524702072832,'Apple',''),(92541982605312,'LsyDefen','LSY Defense, LLC.'),(92551881162752,'Protectr','PROTECTRON'),(92570252214272,'RasterVi','Raster Vision Ltd'),(92590351319040,'Symeo','Symeo GmbH'),(92605534699520,'Edgewate','Edgewater Networks Inc'),(92621892485120,'RuckusWi','Ruckus Wireless'),(92643669311488,'Sony','Sony Corporation'),(92651168727040,'Nokia','Nokia Corporation'),(92661419606016,'Shenzhen','Shenzhen CZTIC Electronic Techno'),(92676888199168,'WenglorS','wenglor sensoric gmbh'),(92719435218944,'Sony','Sony Corporation'),(92720089530368,'DigitalR','Digital RF Corea, Inc'),(92765874552832,'NlTechno','NL Technologies'),(92769833975808,'Teracom','Teracom Limited'),(92779514429440,'Zaplox','Zaplox AB'),(92855448109056,'ToyoElec','Toyo Electronics Corporation'),(92861051699200,'WebtechW','Webtech Wireless'),(92864977567744,'Cisco','CISCO SYSTEMS, INC.'),(92874809016320,'Cisco',''),(92880630710272,'Nokia','Nokia Corporation'),(92905846865920,'Ingenico',''),(92907256152064,'TelcoSRO','TELCO systems, s.r.o.'),(92908430557184,'Cisco','CISCO SYSTEMS, INC.'),(92915929972736,'EagleRes','Eagle Research Corporation'),(92927976013824,'DigitalD','Digital Devices GmbH'),(92947957678080,'Zelfy','Zelfy Inc'),(92949937389568,'HuaweiTe','HUAWEI TECHNOLOGIES CO.,LTD'),(92989229629440,'SamsungE','Samsung Electronics Co.,Ltd'),(92996645158912,'Silversh','Silvershore Technology Partners'),(93020770795520,'UzushioE','Uzushio Electric Co.,Ltd.'),(93024998653952,'SamsungE','Samsung Electronics'),(93035517968384,'Eneracce','EnerAccess inc'),(93047496900608,'T-MacTec','t-mac Technologies Ltd'),(93068099321856,'Shenzhen','Shenzhen Huawei Communication Te'),(93072360734720,'Alcatel-','Alcatel-Lucent Shanghai Bell Co.'),(93088382976000,'Minibar','Minibar Systems'),(93141197651968,'SuhdolE&','SUHDOL E&C Co.Ltd.'),(93242246823936,'FujianSh','Fujian Shenzhou Electronic Co.,L'),(93256306130944,'AximComm','AXIM Communications'),(93259577688064,'Universa','Universal Laser Systems, Inc'),(93271372070912,'CiscoSpv','Cisco SPVTG'),(93318415384576,'Intrakey','Intrakey technologies GmbH'),(93321888268288,'JuniperN','Juniper Networks'),(93336887099392,'JvlIndus','JVL Industri Elektronik'),(93347876175872,'Shenzhen','ShenZhen LingKeWeiEr Technology '),(93351047069696,'Tp-LinkT','TP-LINK TECHNOLOGIES CO., LTD.'),(93414297174016,'Oriental','ORIENTAL PACIFIC INTERNATIONAL L'),(93417249964032,'Berthold','Berthold Technologies GmbH and C'),(93448807907328,'ScheidtB','Scheidt & Bachmann GmbH'),(94937416728576,'AculabPl','Aculab plc			audio bridges'),(96779940921344,'Elettron','Elettronica GF S.r.L.'),(96795577286656,'FiberOpt','Fiber Optic & telecommunication '),(96796802023424,'Private',''),(96799519932416,'Kivic','Kivic Inc.'),(96835456729088,'AcsipTec','AcSiP Technology Corp.'),(96852150059008,'Avaya','Avaya, Inc'),(96856008818688,'SonyEric','Sony Ericsson Mobile Communicati'),(96880453222400,'Affinegy',''),(96884009992192,'Advanced','Advanced Mobile Telecom co.,ltd.'),(96893019357184,'Apple','Apple, Inc.'),(96894176985088,'Tuttnaer','Tuttnaer LTD'),(96958853152768,'Lighting','Lighting Science Group'),(96959994003456,'Universa','Universal Electric Corporation'),(96981351399424,'GlovastT','Glovast Technology Ltd.'),(96988297166848,'Cisco','CISCO SYSTEMS, INC.'),(97018043170816,'Omnealit','Omneality Ltd.'),(97044316291072,'SigmaInt','Sigma International General Medi'),(97060070096896,'KoncarEl','Koncar Electronics and Informati'),(97061445828608,'BaxterHe','Baxter Healthcare'),(97069482115072,'Coflec',''),(97073676419072,'ChitaiEl','Chitai Electronic Corp.'),(97083860189184,'Chongqin','Chongqing Guohong Technology Dev'),(97087433736192,'DigitalO','Digital One Technologies, Limite'),(97102600339456,'LinearEq','Linear Equipamentos Eletronicos '),(97104479387648,'BestBuy','Best Buy Corporation'),(97125484462080,'Apple','Apple, Inc.'),(97130282745856,'Motorola','Motorola Mobility Inc'),(97130903502848,'DanfossS','Danfoss Solar Inverters'),(97194673700864,'Infomark','INFOMARK CO., LTD.'),(97198230470656,'Hangzhou','Hangzhou H3C Technologies Co., L'),(97199841083392,'Barnes&N','BARNES&NOBLE.COM'),(97201535582208,'ClareCon','Clare Controls Inc.'),(97209806749696,'FujianRu','Fujian Ruijie Networks co, ltd'),(97212172337152,'FusionTr','Fusion Transactive Ltd.'),(97227573821440,'Cisco-Li','Cisco-Linksys, LLC'),(97233059971072,'Private',''),(97260088066048,'CjscRtso','CJSC RTSoft'),(97265792319488,'BeijingE','Beijing ECHO Technologies Co.,Lt'),(97282301100032,'Stonesof','Stonesoft Corporation'),(97299816513536,'HisenseE','Hisense Electric Co., Ltd'),(97305839534080,'S2m',''),(97327784132608,'Ip500All','IP500 Alliance e.V.'),(97338118897664,'Lite-OnC','LITE-ON CLEAN ENERGY TECHNOLOGY '),(97340635480064,'Shenzhen','Shenzhen Coship Electronics Co.,'),(97362764627968,'Cisco','CISCO SYSTEMS, INC.'),(97383266385920,'IntelCor','Intel Corporate'),(97384306573312,'KineticA','Kinetic Avionics Limited'),(97390900019200,'RuckusWi','Ruckus Wireless'),(97394473566208,'IntelCor','Intel Corporate'),(97396151287808,'VertexSt','Vertex Standard LMR, Inc.'),(97406066622464,'Cisco',''),(97410747465728,'Technico','Technicolor'),(97411720544256,'Revoluti','Revolution Display'),(97476145053696,'Id','iD corporation'),(97513826680832,'Apple','Apple, Inc'),(97516494258176,'Zunidata','ZuniData Systems Inc.'),(97555367067648,'Crystalf','Crystalfontz America, Inc.'),(97565131407360,'Cisco','CISCO SYSTEMS, INC.'),(97571506749440,'Nintendo','Nintendo Co., Ltd.'),(97581287866368,'Cisco','CISCO SYSTEMS, INC.'),(97591085760512,'Nec','NEC Corporation'),(97596873900032,'SamsungE','Samsung Electronics'),(97647339765760,'LufkinIn','Lufkin Industries'),(97652272267264,'BwBroadc','BW Broadcast'),(97652775583744,'Ieee1904','IEEE 1904.1 Working Group'),(97679686238208,'DairyChe','Dairy Cheq Inc'),(97699986669568,'Fast','Fast Co., Ltd.'),(97719834116096,'MicroTec','Micro Technic A/S'),(97738255499264,'CentronC','CENTRON COMMUNICATIONS TECHNOLOG'),(97745771692032,'EvrsafeT','EVRsafe Technologies'),(97750351872000,'Deltanet','Deltanet AG'),(97753589874688,'Autonics','AUTONICS CORPORATION'),(97766676103168,'ProteusD','Proteus Digital Health'),(97774410399744,'Newport','Newport Corporation'),(97782681567232,'IconTime','Icon Time Systems'),(97802965221376,'Hccp',''),(97815648796672,'XiaMenUn','Xia Men UnionCore Technology LTD'),(97816789647360,'KyotoUni','Kyoto University'),(97828852465664,'Secudos','SECUDOS GmbH'),(97844186841088,'BravidaS','Bravida Sakerhet AB'),(101165438074880,'AppliedV','Applied Vision Corporation'),(101186996797440,'ThoughtC','Thought Creator'),(101199546155008,'SamsungE','SAMSUNG ELECTRO-MECHANICS CO., L'),(101209746702336,'Celizion','CELIZION Inc.'),(101217531330560,'Motorola',''),(101241891848192,'Thyssenk','Thyssenkrupp Aufzugswerke GmbH'),(101249038942208,'AidcTech','AIDC TECHNOLOGY (S) PTE LTD'),(101252897701888,'BigSwitc','Big Switch Networks'),(101254776750080,'I-ViewNo','I-View Now, LLC.'),(101257393995776,'Lge',''),(101261185646592,'TalonCom','Talon Communications'),(101295998369792,'AsoniCom','Asoni Communication Co., Ltd.'),(101304386977792,'DaeEunEl','DAE EUN ELETRONICS CO., LTD'),(101311718621184,'Baltech','Baltech AG'),(101318446284800,'Dell','Dell Inc.'),(101374767398912,'SpazioIt','Spazio Italia srl'),(101375656591360,'Swisspho','Swissphone Telecom AG'),(101376495452160,'AlphaNet','Alpha Networkc Inc.'),(101383692877824,'CompalBr','Compal Broadband Networks Inc.'),(101386360455168,'ThereOy','There Corporation Oy'),(101399346020352,'Shanghai','Shanghai Super Electronics Techn'),(101413422104576,'SamsungE','Samsung Electronics Co.,Ltd'),(101431424057344,'Jefferso','Jefferson Audio Video Systems, I'),(101446355779584,'Hazemeye','HAZEMEYER'),(101473534869504,'EnguityT','Enguity Technology Corp'),(101484322619392,'Shenzhen','Shenzhen Huawei Communication Te'),(101499019460608,'Cisco','CISCO SYSTEMS, INC.'),(101504287506432,'IntelCor','Intel Corporate'),(101528413143040,'3pleplay','3pleplay Electronics Private Lim'),(101529168117760,'ArrisGro','ARRIS Group, Inc.'),(101532087353344,'Nokia','Nokia Corporation'),(101538529804288,'Apple','Apple, Inc.'),(101561665585152,'JuniperN','Juniper Networks'),(101583475965952,'Tp-LinkT','TP-LINK TECHNOLOGIES CO., LTD.'),(101608255913984,'Nuvico',''),(101612433440768,'Kentkart','KENTKART EGE ELEKTRONIK SAN. VE '),(101615470116864,'TexasIns','Texas Instruments'),(101623758061568,'HonHaiPr','Hon Hai Precision Ind. Co.,Ltd.'),(101633136525312,'SASistel','S.A. SISTEL'),(101667630481408,'Haivisio','Haivision Network Video'),(101693517725696,'HuaweiTe','Huawei Technologies Co., Ltd'),(101724253585408,'Brightso','Brightsource Industries Israel L'),(101731836887040,'SecretLa','Secret Labs LLC'),(101736903606272,'Cybertel','Cybertelbridge co.,ltd'),(101747037044736,'BeijingB','Beijing Banner Electric Co.,Ltd'),(101797939118080,'Apple','Apple Inc'),(101801948872704,'Apple',''),(101820118597632,'Fujitsu','Fujitsu Limited'),(101857783447552,'SamsungE','SAMSUNG ELECTRO-MECHANICS CO., L'),(101859092070400,'LokelSRO','Lokel s.r.o.'),(101895079198720,'HonHaiPr','Hon Hai Precision Ind. Co.,Ltd.'),(101933062815744,'SonyEric','Sony Ericsson Mobile Communicati'),(101969469374464,'Hongkong','HONGKONG MIRACLE EAGLE TECHNOLOG'),(101988612177920,'FrSauter','Fr. Sauter AG'),(102008962940928,'Skyworth','Skyworth Digital technology(shen'),(102021898174464,'Palladiu','PALLADIUM ENERGY ELETRONICA DA A'),(102023492009984,'Theben','Theben AG'),(102042735476736,'Cdyne','CDYNE Corporation'),(102053607112704,'XtremePo','Xtreme Power Systems'),(102060838092800,'IntelCor','Intel Corporate'),(102066055806976,'UczoonTe','UCZOON Technology Co., LTD'),(102068471726080,'Zektor',''),(102089627795456,'D-Link','D-Link Corporation'),(102094929395712,'MurataMa','Murata Manufacturing Co., Ltd.'),(102120531427328,'FeitianU','FeiTian United (Beijing) System '),(102121269624832,'NicBr-Nu','NIC.br- Nucleo de Informacao e C'),(102126319566848,'DelphinT','Delphin Technology AG'),(102127980511232,'NortelNe','Nortel Networks'),(102129826004992,'AcsipTec','AcSiP Technology Corp.'),(102155444813824,'SamsungE','Samsung Electronics'),(102165695692800,'RStahlHm','R. STAHL HMI Systems GmbH'),(102179302014976,'GlobalDi','Global Digitech Co LTD'),(102194569281536,'SpecoTec','Speco Technologies'),(102200625856512,'Cc&CTech','CC&C Technologies, Inc'),(102202974666752,'Ibm','IBM Corp'),(102215322697728,'SamsungE','Samsung Electronics Co.,LTD'),(102222922776576,'MurataMa','Murata Manufactuaring Co.,Ltd.'),(102228224376832,'Dell','Dell Inc'),(102251175608320,'Wistron','Wistron Corporation'),(105564726099968,'WistronN','Wistron NeWeb Corp.'),(105619537264640,'Silverpl','SilverPlus, Inc'),(105628697624576,'Siama','Siama Systems Inc'),(105632623493120,'Solucion','Soluciones Tecnologicas para la '),(105646649245696,'Idatech',''),(105660691775488,'Rramac',''),(105661178314752,'Voltroni','VOLTRONIC POWER TECHNOLOGY(SHENZ'),(105677921976320,'MidniteS','Midnite Solar'),(105681998839808,'Eltexala','EltexAlatau'),(105698071412736,'MurataMa','Murata Manufactuaring Co.,Ltd.'),(105734914179072,'Cardiote','CardioTek B.V.'),(105736994553856,'CiscoSpv','Cisco SPVTG'),(105771891163136,'MplusTec','Mplus technology'),(105773417889792,'Apple','Apple, Inc.'),(105782142042112,'BuwonTec','Buwon Technology'),(105788752265216,'IntelCor','Intel Corporate'),(105793869316096,'AlpsElec','Alps Electric Co.,'),(105798449496064,'Abb','ABB Ltd'),(105827004317696,'Cox','COX CO., LTD'),(105849284460544,'EasyDigi','Easy Digital Ltd.'),(105851046068224,'LiptelSR','Liptel s.r.o.'),(105852639903744,'Microsof','Microsoft'),(105854133075968,'XiamenVa','XIAMEN VANN INTELLIGENT CO., LTD'),(105871413608448,'Suyin','SUYIN Corporation'),(105908793245696,'FactsEng','FACTS Engineering'),(105915571240960,'EyedroGr','Eyedro Green Solutions Inc.'),(105927181074432,'IntelCor','Intel Corporate'),(105965953220608,'SzDjiTec','SZ DJI TECHNOLOGY CO.,LTD'),(105982562664448,'Transcen','Transcend Communication Beijing '),(105996034768896,'IntelCor','Intel Corporate'),(106006688301056,'Isepos','isepos GmbH'),(106015848660992,'SamsungE','Samsung Electronics Co., LTD'),(106018684010496,'IntelCor','Intel Corporate'),(106048581009408,'Cisco',''),(106053698060288,'AtmacaEl','Atmaca Elektronik'),(106062204108800,'Velodyne',''),(106118743326720,'GkwareEK','GkWare e.K.'),(106121041805312,'Soladigm','Soladigm, Inc.'),(106129799512064,'AveryWei','Avery Weigh-Tronix, LLC'),(106142533419008,'ThermoFi','Thermo Fisher Scientific P.O.A.'),(106144496353280,'KeyDigit','Key Digital Systems'),(106144597016576,'KaelMÃ¼he','KAEL MÃœHENDÄ°SLÄ°K ELEKTRONÄ°K '),(106155133108224,'HansonTe','Hanson Technology'),(106159092531200,'SentrusG','Sentrus Government Systems Divis'),(106173806149632,'Dssd','DSSD Inc'),(106217292693504,'GviSecur','GVI SECURITY INC.'),(106233398820864,'Vivonic','Vivonic GmbH'),(106238650089472,'Cloudswi','CloudSwitch'),(106244773773312,'SamsungE','Samsung Electronics Co.,Ltd'),(106258765971456,'AsustekC','ASUSTek COMPUTER INC.'),(106315556847616,'AthSyste','ATH system'),(106325203746816,'ElberSrl','Elber Srl'),(106334900977664,'Phorus',''),(106348540854272,'DeutronE','Deutron Electronics Corp.'),(106349866254336,'RoVeRLab','RO.VE.R. Laboratories S.p.A.'),(106356476477440,'BeijingH','Beijing HuaqinWorld Technology C'),(106361845186560,'EwmHight','EWM Hightec Welding GmbH'),(106367297781760,'MoveInno','Move Innovation'),(106393168248832,'2wire','2Wire Inc'),(106400416006144,'Apple','Apple, Inc.'),(106402043396096,'BeijingL','Beijing LT Honway Technology Co.'),(106418552176640,'Trymus',''),(106429205708800,'Airscape','AirScape Inc.'),(106436889673728,'TaiwanCa','Taiwan Carol Electronics., Ltd'),(106449304813568,'SamsungE','Samsung Electronics Co.,Ltd'),(106453616558080,'VishalTe','Vishal Telecommunications Pvt Lt'),(106458163183616,'RealandB','REALAND BIO CO., LTD.'),(106459522138112,'Quatius','Quatius Limited'),(106481248632832,'HonHaiPr','Hon Hai Precision Ind. Co.,Ltd.'),(106490006339584,'Estech','Estech Co.,Ltd'),(106507739856896,'HuaweiTe','HUAWEI TECHNOLOGIES CO.,LTD'),(106515423821824,'ShinseiE','SHINSEI ELECTRONICS CO LTD'),(106555286487040,'AylaNetw','Ayla Networks, Inc'),(106564195188736,'QuantaCo','Quanta computer Inc.'),(106589226795008,'Jablocom','JABLOCOM s.r.o.'),(106594662612992,'TranwoTe','TRANWO TECHNOLOGY CO., LTD.'),(106596508106752,'Visionve','VisionVera International Co., Lt'),(106600450752512,'LogicWay','Logic Way GmbH'),(106603571314688,'HonHaiPr','Hon Hai Precision Ind. Co.,Ltd.'),(106608000499712,'Cru-Data','CRU-Dataport'),(106611607601152,'Terumo','TERUMO CORPORATION'),(106630297419776,'Apple','Apple, Inc.'),(106632260354048,'Apple','Apple, Inc'),(106644541276160,'ChinaPal','China Palms Telecom.Ltd'),(106647343071232,'Apple',''),(106648215486464,'ThomasBe','Thomas & Betts'),(109955206086656,'Cisco','CISCO SYSTEMS, INC.'),(109975825285120,'NewLight','NEW LIGHT LED'),(109991092551680,'BeijingS','Beijing Superbee Wireless Techno'),(109999648931840,'DigitalT','Digital Telecom Technology Limit'),(110012198289408,'Taztag',''),(110013775347712,'Pluribus','Pluribus Networks, Inc.'),(110016258375680,'2wire',''),(110022096846848,'HexiumTe','HEXIUM Technical Development Co.'),(110048017645568,'Cisco','CISCO SYSTEMS, INC.'),(110049678589952,'Shehzhen','Shehzhen Huawei Communication Te'),(110063402352640,'Heliospe','Heliospectra/Woodhill Investment'),(110073149915136,'Digibras','DIGIBRAS INDUSTRIA DO BRASILS/A'),(110082176057344,'Dowslake','Dowslake Microsystems'),(110088803057664,'Apple','Apple, Inc.'),(110097560764416,'Shandong','Shandong Taixin Electronic co.,L'),(110105781600256,'Xorcom','Xorcom Ltd.'),(110119589249024,'HonHaiPr','Hon Hai Precision Ind. Co.,Ltd.'),(110147506536448,'SeungilE','SEUNGIL ELECTRONICS'),(110162958352384,'Hewlett-','Hewlett-Packard Company'),(110163730104320,'Dexin','Dexin Corporation'),(110174652071936,'BitwaveP','BITwave Pte Ltd'),(110240099991552,'Guangdon','GuangDong Quick Network Computer'),(110276556881920,'Shanghai','Shanghai WOASiS Telecommunicatio'),(110277311856640,'Caldigit','CalDigit, Inc'),(110283754307584,'Dspace','dSPACE GmbH'),(110292411351040,'Lenus','LENUS Co., Ltd.'),(110301169057792,'LongBenD','LONG BEN (DONGGUAN) ELECTRONIC T'),(110305917009920,'Chamberl','The Chamberlain Group, Inc'),(110309205344256,'Frausche','Frauscher Sensortechnik'),(110312510455808,'EquinoxP','Equinox Payments'),(110317895942144,'Inteligh','Intelight Inc.'),(110318365704192,'NsfocusI','NSFOCUS Information Technology C'),(110337776943104,'ChiconyE','Chicony Electronics Co., Ltd.'),(110354201837568,'Shenzhen','Shenzhen Lifesense Medical Elect'),(110358077374464,'Yahoo!Ja','Yahoo! JAPAN'),(110363462860800,'NicoletN','Nicolet Neuro'),(110372656775168,'Cellient','Cellient Co., Ltd.'),(110388175699968,'Nuvon','Nuvon, Inc'),(110392252563456,'Tp-LinkT','TP-LINK TECHNOLOGIES CO., LTD.'),(110393661849600,'BeijingO','Beijing Omnific Technology, Ltd.'),(110398040702976,'Comtrend',''),(110405288460288,'HyteraCo','Hytera Communications Co .,ltd'),(110425421119488,'RadioDat','Radio Datacom LLC'),(110427535048704,'Iskratel','Iskratel d.o.o.'),(110432232669184,'Tp-LinkT','TP-LINK TECHNOLOGIES CO., LTD.'),(110444412928000,'GoowiTec','GooWi Technology Co.,Limited'),(110448875667456,'Arbiter','Arbiter Systems, Inc.'),(110459428536320,'Innovati','Innovative Security Designs'),(110464696582144,'SamsungE','Samsung Electronics Co.,Ltd'),(110483000524800,'TexasIns','Texas Instruments'),(110484611137536,'UbeeInte','Ubee Interactive Corp.'),(110490197950464,'YokotaIn','YOKOTA INDUSTRIAL CO,.LTD'),(110500281057280,'Tektelic','TEKTELIC Communications Inc.'),(110503250624512,'VgContro','VG Controls, Inc.'),(110503485505536,'IntelCor','Intel Corporate'),(110505834315776,'Alphatro','Alphatron Marine BV'),(110533265063936,'JuniperN','Juniper Networks'),(110534590464000,'PirelliT','Pirelli Tyre S.p.A.'),(110539556519936,'SichuanC','Sichuan Changhong Electric Ltd.'),(110609853054976,'Lge',''),(110610037604352,'Elentec',''),(110610977128448,'Elektron','AG Elektronik AB'),(110617486688256,'VTechnol','V Technology Co., Ltd.'),(110623341936640,'Qualcomm','Qualcomm iSkoot, Inc.'),(110623560040448,'TexasIns','Texas Instruments'),(110633844473856,'Cisco','CISCO SYSTEMS, INC.'),(110638206550016,'KoneOyj','Kone OYj'),(110642233081856,'Cisco','CISCO SYSTEMS, INC.'),(110647786340352,'OooSamli','OOO Samlight'),(110652332965888,'Wonderla','Wonderlan (Beijing) Technology C'),(110654648221696,'Apple',''),(110670183923712,'Htc','HTC Corporation'),(110673640030208,'JuniKore','Juni Korea Co., Ltd'),(110698688413696,'Cisco','CISCO SYSTEMS, INC.'),(110700768788480,'Polytec','Polytec GmbH'),(110720230359040,'SamsungE','Samsung Electronics Co.,Ltd'),(110734088339456,'Vivotech','ViVOtech, Inc.'),(110749624041472,'Apple','Apple, Inc'),(110758901841920,'Combiq','CombiQ AB'),(110800123461632,'SouthAfr','South African Broadcasting Corpo'),(110803294355456,'Barnes&N','Barnes&Noble'),(110804502315008,'AxerraNe','AXERRA Networks Ltd'),(110815592054784,'LarkTech','LARK Technologies, Inc'),(110845270949888,'NextGene','Next Generation Integration (NGI'),(110851545628672,'SitecomE','Sitecom Europe BV'),(110854196428800,'KeithKoe','Keith & Koep GmbH'),(110864866738176,'AlpsElec','ALPS ELECTRIC CO.,LTD.'),(110865353277440,'IntelCor','Intel Corporate'),(110879211257856,'Cisco','CISCO SYSTEMS, INC.'),(110883472670720,'Solidica','Solidica, Inc.'),(110885469159424,'Cisco','CISCO SYSTEMS, INC.'),(110892163268608,'Openpatt','OpenPattern'),(110896072359936,'StaticGr','Static Systems Group PLC'),(110905115279360,'Kingneti','Kingnetic Pte Ltd'),(110919157809152,'Dep','DEP Corp.'),(110937277202432,'EfmNetwo','EFM Networks'),(110941186293760,'Apple','Apple, Inc.'),(110948920590336,'Serialwa','Serialway Communication Technolo'),(110951453949952,'GlobalMo','global moisture management syste'),(110970529644544,'Motorola','Motorola Mobility, Inc.'),(110970714193920,'Woori','WOORI SYSTEMS Co., Ltd'),(110991652159488,'GerdesAk','Gerdes Aktiengesellschaft'),(111003664646144,'KinionTe','Kinion Technology Company Limite'),(111022488682496,'KenadeEl','Kenade Electronics Technology Co'),(111022874558464,'Avvasi','Avvasi Inc.'),(111035843346432,'Zonar','Zonar Systems'),(114374073122816,'IntelCor','Intel Corporate'),(114388518305792,'Apple','Apple, Inc.'),(114427273674752,'SpecialI','Special Instrument Development C'),(114441819521024,'Sagemcom','SAGEMCOM SAS'),(114442943594496,'ZakladyE','Zaklady Elektroniki i Mechaniki '),(114443782455296,'AndElect','Systems And Electronic Developme'),(114448681402368,'IntelCor','Intel Corporate'),(114463864782848,'Zte','zte corporation'),(114472186281984,'Rosewill','Rosewill Inc.'),(114475441061888,'SunwaveC','Sunwave Communications Co., Ltd'),(114480390340608,'Infosigh','InfoSight Corporation'),(114485977153536,'Advanced','Advanced Telemetry'),(114500791435264,'NihonDen','Nihon Dengyo Kousaku'),(114603115675648,'Countwis','Countwise LTD'),(114619456684032,'Ereca',''),(114638347829248,'Bhuu','Bhuu Limited'),(114673613537280,'Galtroni','Galtronics Telemetry Inc.'),(114678445375488,'Shenzhen','Shenzhen Herotel Tech. Co., Ltd.'),(114700171870208,'Powerclo','PowerCloud Systems, Inc.'),(114713962741760,'Alcatel-','Alcatel-Lucent - Nuage'),(114714096959488,'Enlighte','enLighted Inc'),(114733592084480,'AlcatelL','Alcatel Lucent'),(114740940505088,'Apple','Apple inc'),(114740957282304,'Powertec','POWERTECH INDUSTRIAL CO., LTD.'),(114749765320704,'IntelCor','Intel Corporate'),(114754731376640,'Powerray','PowerRay Co., Ltd.'),(114775904223232,'Advanced','Advanced Digital Broadcast SA'),(114804240941056,'ComapSRO','ComAp s.r.o.'),(114822242893824,'Wi3','Wi3 Inc.'),(114840194514944,'Ubiquiti','Ubiquiti Networks'),(114865880432640,'NortelNe','Nortel Networks'),(114869504311296,'Els-Gmbh','ELS-GmbH & Co. KG'),(114872876531712,'Sharp','SHARP Corporation'),(114885358780416,'YSoftAS','Y Soft Corporation, a.s.'),(114896616292352,'Cisco-Li','Cisco-Linksys, LLC'),(114912286212096,'PandoraM','Pandora Mobility Corporation'),(114918024019968,'Essys','eSSys Co.,Ltd'),(114921513680896,'IgiMobil','IGI Mobile, Inc.'),(114927536701440,'Cisco',''),(114928610443264,'Orbotix','Orbotix, Inc.'),(114930825035776,'InqMobil','INQ Mobile Limited'),(114977146929152,'RuckusWi','Ruckus Wireless'),(114985451651072,'HonHaiPr','Hon Hai Precision Ind. Co.,Ltd.'),(114995517980672,'Apple','Apple Inc'),(114999007641600,'Shenzhen','Shenzhen Costar Electronics Co. '),(115001641664512,'SocietyO','Society of Motion Picture &amp; '),(115020801245184,'AcsipTec','AcSiP Technology Corp.'),(115021103235072,'Apple',''),(115043769253888,'HonghaoM','Honghao Mingchuan Technology (Be'),(115052577292288,'LiteonTe','Liteon Technology Corporation'),(115053818806272,'BshBosch','BSH Bosch and Siemens Home Appli'),(115072592510976,'Apple','Apple, Inc.'),(115082876944384,'Datecs','DATECS LTD.,'),(115085963952128,'RfIdeas','RF IDeas'),(115101147332608,'FuturaMo','Futura Mobility'),(115107606560768,'InesaEle','INESA ELECTRON CO.,LTD'),(115123276480512,'Waterfur','WaterFurnace International, Inc.'),(115129165283328,'Hewlett-','Hewlett-Packard Company'),(115135121195008,'HitronTe','Hitron Technologies. Inc'),(115143123927040,'ActKde','Act KDE, Inc.'),(115156864466944,'Cisco','CISCO SYSTEMS, INC.'),(115163827011584,'Cisco','CISCO SYSTEMS, INC.'),(115216792682496,'Octopus','Octopus Systems Limited'),(115227999862784,'MineSite','Mine Site Technologies'),(115229929242624,'UTek','U Tek Company Limited'),(115235281174528,'L-3Commu','L-3 Communications Infrared Prod'),(115251102089216,'Shenzhen','Shenzhen Trimax Technology Co.,L'),(115281837948928,'ProsysDe','ProSys Development Services'),(115291535179776,'NantongC','Nantong Coship Electronics Co., '),(115292323708928,'OpwillTe','OPWILL Technologies CO .,LTD'),(115297994407936,'Packetst','PacketStorm Communications'),(115317288206336,'Private',''),(115328981925888,'Unglaube','Unglaube Identech GmbH'),(115361445838848,'SamsungE','Samsung Electronics Co.,Ltd'),(115361831714816,'Angstrem','Angstrem Telecom'),(115364465737728,'YodoTech','YODO Technology Corp. Ltd.'),(115368240611328,'Research','Research In Motion'),(115373928087552,'CiscoSpv','Cisco SPVTG'),(115378877366272,'Cisco','CISCO SYSTEMS, INC.'),(115384917164032,'DataCont','Data Controls Inc.'),(115416860983296,'Redflow','Redflow Limited'),(115429745885184,'Generalp','Generalplus Technology Inc.'),(118766046281728,'RbhAcces','RBH Access Technologies Inc.'),(118807603445760,'SonyEric','Sony Ericsson Mobile Communicati'),(118813458694144,'JdcTech','JDC Tech Co., Ltd.'),(118850620227584,'DecaturE','Decatur Electronics'),(118886137593856,'Cisco',''),(118896153591808,'Ainswort','Ainsworth Game Technology'),(118900683440128,'SonyEric','Sony Ericsson Mobile Communicati'),(118925849264128,'IntelCor','Intel Corporate'),(118945679933440,'Accelink','Accelink Technologies Co.,Ltd.'),(118947055665152,'Sagemcom',''),(118965728706560,'IndieonT','Indieon Technologies Pvt. Ltd.'),(118969134481408,'Magicjac','Magicjack LP'),(118992555474944,'BeijingZ','Beijing ZhongHuaHun Network Info'),(118998578495488,'Shenzhen','Shenzhen Aero-Startech. Co.Ltd'),(119004500852736,'HewlettP','Hewlett Packard'),(119015372488704,'Apple','Apple Inc'),(119016161017856,'KeKneste','KE Knestel Elektronik GmbH'),(119025455595520,'NimbusDa','Nimbus Data Systems, Inc.'),(119028207058944,'Cisco',''),(119092145029120,'Cisco','CISCO SYSTEMS, INC.'),(119122947997696,'Aclima','Aclima, Inc.'),(119134675271680,'Shenzhen','Shenzhen Haitianxiong Electronic'),(119146117332992,'Sunrepor','SunReports, Inc.'),(119148348702720,'Shenzhen','ShenZhen Rapoo Technology Co., L'),(119153029545984,'Ubiquito','Ubiquitous Internet Telecom Co.,'),(119164505161728,'RinicomH','Rinicom Holdings'),(119169991311360,'Micro-St','Micro-Star INT`L CO., LTD'),(119224399822848,'Stereota','Stereotaxis, Inc.'),(119229248438272,'Novar','Novar GmbH'),(119236227760128,'Azurewav','AzureWave Technologies, Inc'),(119305567993856,'Mitsuba','Mitsuba Corporation'),(119310802485248,'SamsungE','Samsung Electronics Co.,Ltd'),(119325029564416,'Technoni','Technonia'),(119331706896384,'IntelCor','Intel Corporate'),(119345044783104,'Zte','zte corporation'),(119352225431552,'OtusTech','Otus Technologies Ltd'),(119354540687360,'Wireless','Wireless Glue Networks, Inc.'),(119368700657664,'Sanlogic','SanLogic Inc'),(119377525473280,'InspurEl','Inspur Electronic Information In'),(119412052983808,'Valentin','Valentine Research, Inc.'),(119413009285120,'Nokia','Nokia Corporation'),(119421179789312,'NimbleSt','Nimble Storage'),(119421246898176,'Cisco','CISCO SYSTEMS, INC.'),(119462401409024,'EdamInfo','EDAM information & communication'),(119466662821888,'Nokia','Nokia Corporation'),(119473205936128,'Telefiel','Telefield Ltd'),(119474967543808,'Transpac','TransPacket AS'),(119482987053056,'DigitalP','Digital Payment Technologies'),(119487600787456,'Venetex','Venetex Corp'),(119491342106624,'HubbellB','Hubbell Building Automation, Inc'),(119494294896640,'KzBroadb','KZ Broadband Technologies, Ltd.'),(119494445891584,'Azurewav','Azurewave Technologies, Inc.'),(119496912142336,'Ibm','IBM Corporation'),(119516340158464,'Shenzhen','Shenzhen Lianrui Electronics Co.'),(119517397123072,'AnhuiCom','Anhui comhigher tech co.,ltd'),(119537328455680,'SamsungE','Samsung Electronics Co.,Ltd'),(119567208677376,'Alcatel-','Alcatel-Lucent-IPD'),(119579707703296,'Motorola','Motorola Mobility, Inc.'),(119582274617344,'Apple','Apple, Inc.'),(119641447858176,'LgElectr','LG Electronics'),(119646078369792,'SmartekD','Smartek d.o.o.'),(119647856754688,'WingSing','WING SING ELECTRONICS HONG KONG '),(119668694056960,'LgElectr','LG Electronics Inc'),(119693926989824,'Promethe','Promethean Limited'),(119712281264128,'Sound4',''),(119729964449792,'Villiger','Villiger Security Solutions AG'),(119745617592320,'Tp-LinkT','TP-LINK TECHNOLOGIES CO., LTD.'),(119748100620288,'Nokia','Nokia Corporation'),(119750180995072,'Gastron','Gastron Co., LTD.'),(119763569213440,'Shenzhen','SHENZHEN CLOU ELECTRONICS CO. LT'),(119779272687616,'Giga-Byt','GIGA-BYTE TECHNOLOGY CO.,LTD.'),(119792862232576,'SamsungE','Samsung Electronics Co.,Ltd'),(119793063559168,'ArubaNet','Aruba Networks'),(119818783031296,'Nanoptix','Nanoptix Inc.'),(119822474018816,'Avaya','Avaya, Inc'),(119836986310656,'ProwareT','Proware Technologies Co Ltd.'),(119845660131328,'MpbCommu','MPB Communications Inc.'),(123155368640512,'01db-Met','01DB-METRAVIB'),(123167112691712,'LgElectr','LG Electronics'),(123195768176640,'DewavTec','Dewav Technology Company'),(123213686243328,'Poindus','Poindus Systems Corp.'),(123215565291520,'Cisco',''),(123218920734720,'Apple',''),(123231268765696,'Liabilit','Limited Liability Company'),(123257038569472,'LiteonTe','Liteon Tech Corp.'),(123260947660800,'Advas','ADVAS CO., LTD.'),(123298092417024,'Fos4x','fos4X GmbH'),(123304853635072,'Alcatel-','Alcatel-Lucent'),(123305709273088,'Cybertan','CyberTAN Technology, Inc.'),(123330472443904,'E-DomusI','E-Domus International Limited'),(123348424065024,'Polyvisi','PolyVision Inc.'),(123349699133440,'AavaMobi','Aava Mobile Oy'),(123351863394304,'Avaya','Avaya, Inc'),(123358020632576,'Acx','ACX GmbH'),(123363624222720,'AthenaWi','Athena Wireless Communications I'),(123386105692160,'Invensys','Invensys Rail'),(123388840378368,'LowTechS','Low Tech Solutions'),(123389813456896,'Avaya','Avaya, Inc'),(123398034292736,'Shenzhen','Shenzhen Afoundry Electronic Co.'),(123403956649984,'SeawingK','SEAWING Kft'),(123427545415680,'EdwardsL','Edwards Lifesciences LLC'),(123447057317888,'ChyngHon','CHYNG HONG ELECTRONIC CO., LTD.'),(123466049126400,'XstreamF','Xstream Flow (Pty) Ltd'),(123466955096064,'Rinstrum','Rinstrum Pty Ltd'),(123475696025600,'Tmrg','TMRG, Inc.'),(123500794740736,'Avaya','Avaya, Inc.'),(123509602779136,'Pegatron','PEGATRON CORPORATION'),(123510189981696,'HuaweiTe','HUAWEI TECHNOLOGIES CO.,LTD'),(123516833759232,'Apple','Apple Inc'),(123523561422848,'Panasoni','Panasonic AVC Networks Company'),(123534902820864,'CompalIn','COMPAL INFORMATION (KUNSHAN) CO.'),(123543341760512,'KonamiGa','Konami Gaming Inc'),(123551881363456,'ActionTa','Action Target, Inc.'),(123575184916480,'OrbisTec','ORBIS TECNOLOGIA ELECTRICA S.A.'),(123581275045888,'SuzhouHa','Suzhou Hanming Technologies Co.,'),(123624207941632,'Private',''),(123627613716480,'PurpleCo','Purple Communications, Inc'),(123633787731968,'Pegatron','PEGATRON CORPORATION'),(123635935215616,'HuaweiTe','Huawei Technologies Co., Ltd'),(123638401466368,'Edgecore','EdgeCore Networks'),(123642629324800,'Apple','Apple, Inc.'),(123652913758208,'Pace','Pace plc.'),(123655816216576,'Oxyguard','Oxyguard International A/S'),(123656134983680,'Levelone','LevelOne Communications (India) '),(123677475602432,'HuaweiTe','HUAWEI TECHNOLOGIES CO.,LTD'),(123687592263680,'Motorola','Motorola Mobility, Inc.'),(123690192732160,'Nastec','NASTEC LTD.'),(123699436978176,'Cisco','CISCO SYSTEMS, INC.'),(123703882940416,'AsElectr','as electronics GmbH'),(123706030424064,'Oleumtec','OleumTech Corporation'),(123744316030976,'Citygrow','citygrow technology co., ltd'),(123780823252992,'SpaceMon','Space Monkey, Inc.'),(123795285213184,'Happyele','Happyelectronics Co.,Ltd'),(123806911823872,'ItalianI','Italian Institute of Technology'),(123813790482432,'Shenzhen','Shenzhen Y&D Electronics Co.,LTD'),(123815250100224,'Bryton','Bryton Inc.'),(123824595009536,'SonyComp','Sony Computer Entertainment Inc.'),(123826155290624,'X6d','X6D Limited'),(123839224741888,'Trendset','Trendsetter Medical, LLC'),(123850146709504,'Advanced','Advanced Wireless Dynamics S.L.'),(123860045266944,'ProxDyna','Prox Dynamics AS'),(123870665244672,'HuaweiTe','HUAWEI TECHNOLOGIES CO.,LTD'),(123878433095680,'Research','Research In Motion'),(123902105747456,'Shenzhen','Shenzhen Zowee Technology Co., L'),(123903565365248,'ShenouCo','Shenou Communication Equipment C'),(123906820145152,'Pace','Pace plc'),(123911500988416,'HiltronS','Hiltron s.r.l.'),(123925258305536,'Embedded','Embedded Technologies s.r.o.'),(123940424908800,'Fiberhom','FiberHome Telecommunication Tech'),(123998591516672,'BoschAut','Bosch Automotive Aftermarket'),(124015486173184,'Cisco','CISCO SYSTEMS, INC.'),(124027381219328,'Apple','Apple, Inc.'),(124059895463936,'Rim',''),(124062244274176,'Scalar','Scalar Corporation'),(124064005881856,'Wellcore','Wellcore Corporation'),(124067478765568,'MetrumTe','Metrum Technologies'),(124075162730496,'UposSyst','Upos System sp. z o.o.'),(124097191215104,'Tellabs',''),(124102576701440,'Apple','Apple, Inc.'),(124108029296640,'HongyuCo','HONGYU COMMUNICATION TECHNOLOGY '),(124112626253824,'3view','3view Ltd'),(124117239988224,'SaeIt-Sy','SAE IT-systems GmbH & Co. KG'),(124118179512320,'WistronI','Wistron InfoComm(Zhongshan) Corp'),(124142858797056,'BeijingC','Beijing C&W Optical Communicatio'),(124168846704640,'Netatmo',''),(124182369140736,'DataModu','Data Modul AG'),(124183090561024,'LiteonTe','Liteon Technology Corporation'),(124184231411712,'Xetawave','Xetawave LLC'),(124191479169024,'Universa','Universal Global Scientific Indu'),(124215403479040,'SamsungE','Samsung Electronics'),(127589452611584,'JsjsDesi','JSJS Designs (Europe) Limited'),(127631546646528,'SrtWirel','SRT Wireless'),(127637334786048,'Tri-Sen','Tri-Sen Systems Corporation'),(127674664091648,'Fiberhom','Fiberhome Telecommunication Tech'),(127704577867776,'Hangzhou','Hangzhou H3C Technologies Co., L'),(127711859179520,'Changyan','ChangYang Technology (Nanjing) C'),(127714778415104,'Elitegro','Elitegroup Computer Systems Co.,'),(127728284073984,'Infinida','Infinidat Ltd.'),(127736790122496,'NorfolkE','Norfolk Elektronik AG'),(127746957115392,'Azurewav','Azurewave Technologies, Inc.'),(127755681267712,'Arcadyan','Arcadyan Technology Corporation'),(127759540027392,'Nt-WareS','NT-ware Systemprg GmbH'),(127780360552448,'Tongfang','Tongfang Shenzhen Cloudcomputing'),(127786165469184,'AnnaxAnz','ANNAX Anzeigesysteme GmbH'),(127835423375360,'Netgear',''),(127842016821248,'SamsungE','Samsung Electronics Co.,Ltd'),(127846680887296,'HewlettP','Hewlett Packard'),(127869380460544,'Explorer','EXPLORER HYPERTECH CO.,LTD'),(127876091346944,'Arrive','Arrive Systems Inc.'),(127900485419008,'Commsen','COMMSEN CO., LIMITED'),(127913017999360,'Motorola','Motorola Mobility, Inc.'),(127919561113600,'TrumpfLa','TRUMPF Laser GmbH + Co. KG'),(127947545509888,'Pioneer','PIONEER CORPORATION'),(127951370715136,'SamsungS','Samsung Semiconductor Inc.'),(127954289950720,'TslPpl','TSL PPL'),(127972291903488,'Vts','VTS GmbH'),(127980646957056,'Atlinks',''),(127982240792576,'T:MiYtti','T:mi Ytti'),(128000913833984,'Rezolt','Rezolt Corporation'),(128005091360768,'Movek',''),(128037035180032,'ChipsipT','Chipsip Technology Co., Ltd.'),(128059147550720,'Servicea','ServiceAssure'),(128073676619776,'Eth','ETH Inc.'),(128083273187328,'AliweiCo','Aliwei Communications, Inc'),(128084950908928,'RedEmbed','Red Embedded Design Limited'),(128085269676032,'BeijingT','Beijing Thomson CITIC Digital Te'),(128120921260032,'DellPcba','Dell Inc PCBA Test'),(128129796407296,'AdbBroad','ADB Broadband Italia'),(128153368395776,'Bestek','Bestek Corp.'),(128157394927616,'BrocadeC','Brocade Communications Systems, '),(128163166289920,'RenesasE','Renesas Electronics Corporation'),(128166555287552,'RuckusWi','Ruckus Wireless'),(128177460477952,'ZebraTec','Zebra Technologies Corp.'),(128180027392000,'Agjuncti','AgJunction'),(128202441752576,'Ibm','IBM Corporation'),(128221349675008,'2wire',''),(128250525253632,'QrsMusic','QRS Music Technologies, Inc.'),(128261178785792,'LgElectr','LG Electronics'),(128289448394752,'ChinaMob','China Mobile Group Device Co.,Lt'),(128292652843008,'InovoBro','iNovo Broadband, Inc.'),(128299464392704,'NetworkV','Network Video Technologies, Inc'),(128341860417536,'FujianJi','Fujian JinQianMao Electronic Tec'),(128359526825984,'AtekProd','ATEK Products, LLC'),(128366388707328,'Hyunteck',''),(128409220939776,'Ericsson','Ericsson AB'),(128411552972800,'Calxeda','Calxeda, Inc.'),(128424018444288,'SmithMye','Smith Myers Communications Ltd.'),(128429554925568,'PacketFo','Packet Force Technology Limited '),(128437423439872,'AsustekC','ASUSTek COMPUTER INC.'),(128440393007104,'Ericsson','ERICSSON AB'),(128464434757632,'WymaTecn','WYMA Tecnologia'),(128472403935232,'Evrisko','Evrisko Systems'),(128497552982016,'LiteonTe','Liteon Technology Corporation'),(128507266990080,'Ergophon','Ergophone GmbH'),(128512769916928,'Apple','Apple, Inc.'),(128518121848832,'Apple','Apple Inc'),(128523205345280,'Apiste','APISTE CORPORATION'),(128527080882176,'IntelCor','Intel Corporate'),(128527819079680,'Radspin',''),(128528020406272,'LiteonTe','Liteon Technology Corporation'),(128538808156160,'Motorola','Motorola Mobility, Inc.'),(128549344247808,'Tp-LinkT','TP-LINK Technologies Co.,Ltd.'),(128561004412928,'Acumen',''),(128575969689600,'Azurewav','AzureWave Technologies, Inc.'),(128576238125056,'Bncom','BnCOM Co.,Ltd'),(128578469494784,'BeijingH','Beijing HCHCOM Technology Co., L'),(128600212766720,'Motorola','Motorola Mobility, Inc.'),(128604843278336,'NeuronRo','Neuron Robotics'),(128632659902464,'Compupal','Compupal (Group) Corporation'),(128635478474752,'Advantec','ADVANTECH CO., LTD.'),(128640662634496,'WrenSoun','Wren Sound Systems, LLC'),(131952384409600,'Adaptive','Adaptive Spectrum and Signal Ali'),(131972399628288,'ZUKElzab','Z.U.K. Elzab S.A.'),(132016641146880,'NbsPayme','NBS Payment Solutions Inc.'),(132021791752192,'Orantek','ORANTEK LIMITED'),(132046638809088,'Azurewav','AzureWave Technologies, Inc.'),(132049541267456,'NascentT','NASCENT Technology'),(132052913487872,'JuniperN','Juniper Networks'),(132063164366848,'Sharp','SHARP Corporation'),(132069069946880,'HuaweiTe','HUAWEI TECHNOLOGIES CO.,LTD'),(132070194020352,'Jabil','Jabil Inc'),(132078213529600,'SamsungE','Samsung Electronics Co.,Ltd'),(132088447631360,'Affirmed','Affirmed Networks'),(132101449973760,'Omnima','Omnima Limited'),(132103211581440,'SamsungE','SAMSUNG ELECTRONICS CO., LTD.'),(132129484701696,'Dell','Dell Inc'),(132142973583360,'Nokia','Nokia Corporation'),(132148543619072,'StephenT','Stephen Technologies Co.,Limited'),(132151328636928,'Ultracle','UltraClenz, LLC'),(132157469097984,'Millenni','Millennium Group, Inc.'),(132202901798912,'Kai-Ee',''),(132212330594304,'Easysync','EasySYNC Ltd.'),(132233536995328,'FujituHo','FUJITU(HONG KONG) ELECTRONIC Co.'),(132235432820736,'ZioncomT','Zioncom technology co.,ltd'),(132241036410880,'Dell','Dell Inc'),(132245331378176,'DaehapHy','DAEHAP HYPER-TECH'),(132246824550400,'SamsungE','Samsung Electronics Co.,Ltd'),(132263652098048,'FRobotic','f.robotics acquisitions ltd'),(132289489010688,'Liveu','LiveU Ltd.'),(132294018859008,'SamsungE','Samsung Electronics Co.,Ltd'),(132295226818560,'Shenzhen','Shenzhen Hojy Software Co., Ltd.'),(132302944337920,'D-LinkIn','D-Link International'),(132306853429248,'Sankyuel','SankyuElectronics'),(132315359477760,'MobileIn','Mobile Integration Workgroup'),(132324687609856,'Rafi','RAFI GmbH & Co.KG'),(132325224480768,'SamsungE','Samsung Electronics Co.,Ltd'),(132338444926976,'HiosoTec','Hioso Technology Co., Ltd.'),(132360087535616,'MitsumiE','MITSUMI ELECTRIC CO.,LTD'),(132382401232896,'ZtecInst','ZTEC Instruments, Inc.'),(132405721563136,'Apple',''),(132488500346880,'GikMbh','GiK mbH'),(132497845256192,'ServerRa','Server Racks Australia Pty Ltd'),(132509337649152,'Sony','Sony Corporation'),(132512323993600,'IndraEsp','INDRA ESPACIO S.A.'),(132531735232512,'Cmc',''),(132544100040704,'EltekTec','Eltek Technologies LTD'),(132551129694208,'HitronTe','Hitron Technologies. Inc'),(132571077804032,'IntelCor','Intel Corporate'),(132598474997760,'Q9Networ','Q9 Networks Inc.'),(132600068833280,'NationzT','Nationz Technologies Inc'),(132600236605440,'MusilabE','Musilab Electronics (DongGuan)Co'),(132600924471296,'Mediline','MEDILINE ITALIA SRL'),(132623489826816,'SamsungE','Samsung Electronics'),(132625570201600,'Hoerbige','HOERBIGER Elektronik GmbH'),(132626560057344,'SiemensI','Siemens AG I IA PP PRM'),(132629949054976,'IinetLab','iiNet Labs Pty Ltd'),(132632985731072,'Tp-LinkT','TP-LINK TECHNOLOGIES CO.,LTD.'),(132635082883072,'Advidia',''),(132639864389632,'Nintendo','Nintendo Co., Ltd.'),(132645300207616,'Apple','Apple, Inc.'),(132653772701696,'Shenzhen','Shenzhen Smarteye Digital Electr'),(132656557719552,'Precidat','Precidata'),(132657530798080,'DaeyeonC','DAEYEON Control&Instrument Co,.L'),(132658990415872,'Amphenol',''),(132677445353472,'AbbAustr','ABB Australia'),(132678972080128,'SamsungE','Samsung Electronics Co.,LTD'),(132683350933504,'Hewlett-','Hewlett-Packard Company'),(132713650585600,'EloTouch','Elo touch solutions'),(132726317383680,'AoboTele','AOBO Telecom Co.,Ltd'),(132732105523200,'InterSal','INTER SALES A/S'),(132743748911104,'Shinybow','Shinybow Technology Co. Ltd.'),(132760492572672,'Enhanced','Enhanced Vision'),(132760610013184,'Stulz','STULZ GmbH'),(132783443804160,'H&DWirel','H&D Wireless'),(132786077827072,'Shenzhen','Shenzhen Runsil Technology Co.,L'),(132791345872896,'TexasIns','Texas Instruments'),(132794936197120,'Innovasi','Innovasic, Inc.'),(132809045835776,'Nokia','Nokia Corporation'),(132809935028224,'Apple','Apple, Inc.'),(132814129332224,'DhcSoftw','DHC Software Co.,Ltd'),(132824245993472,'SmcNetwo','SMC Networks Inc'),(132834815639552,'NeousysT','Neousys Technology Inc.'),(132839731363840,'Vicos',''),(132848958832640,'Pace-O-M','Pace-O-Matic, Inc.'),(132849999020032,'Hongkong','HONGKONG YUNLINK TECHNOLOGY LIMI'),(132859260043264,'Navielek','NAVIELEKTRO KY'),(132864544866304,'SamsungE','Samsung Electro Mechanics'),(132880701325312,'GboTechn','GBO Technology'),(132890717323264,'HonHaiPr','Hon Hai Precision Ind. Co.,Ltd.'),(132894173429760,'C-Scape',''),(132898703278080,'TexasIns','Texas Instruments'),(132919389585408,'Hewlett-','Hewlett-Packard Company'),(132920647876608,'HonHaiPr','Hon Hai Precision Ind. Co.,Ltd.'),(132937039216640,'Hewlett-','Hewlett-Packard Company'),(132940881199104,'Zte','zte corporation'),(132955578040320,'Shanghai','Shanghai Qihui Telecom Technolog'),(132969167585280,'Unetconv','Unetconvergence Co., Ltd.'),(132997504303104,'BegaGant','BEGA Gantenbrink-Leuchten KG'),(132997906956288,'HuaweiTe','Huawei Technologies Co., Ltd'),(133005439926272,'SamsungE','Samsung Electronics Co.,Ltd'),(133005741916160,'Silverbr','Silverbrook Research'),(133033340436480,'JuniperN','Juniper Networks'),(133033407545344,'SocusNet','Socus networks'),(133038071611392,'IntelCor','Intel Corporate'),(136346001735680,'CurtisIn','Curtis Instruments, Inc.'),(136351185895424,'HansungE','Hansung Electronics Co. LTD'),(136353601814528,'Sagemcom',''),(136355950624768,'Sagemcom','SAGEMCOM SAS'),(136361034121216,'Pegatron','PEGATRON CORPORATION'),(136361419997184,'Rafael','RAFAEL LTD.'),(136377442238464,'Shanghai','Shanghai Engineering Research Ce'),(136378817970176,'Bekey','Bekey A/S'),(136383733694464,'J-Mex','J-MEX Inc.'),(136415643959296,'Apple','Apple, Inc.'),(136427320901632,'DamallTe','Damall Technologies SAS'),(136434149228544,'Saia-Bur','Saia-Burgess Controls AG'),(136455338852352,'DalianCo','Dalian Co-Edifice Video Technolo'),(136469666594816,'Microsof','Microsoft'),(136471293984768,'2nTeleko','2N TELEKOMUNIKACE a.s.'),(136478558519296,'AlcatelL','Alcatel Lucent IPD'),(136532497268736,'SecureEl','Secure Electrans Ltd'),(136537228443648,'Blackmag','Blackmagic Design'),(136543452790784,'GigasetC','Gigaset Communications GmbH'),(136560330670080,'MegElect','MEG Electronics Inc.'),(136581771952128,'RealTime','Real Time Logic'),(136584791851008,'SsomaSec','SSOMA SECURITY'),(136596418461696,'ImagoGro','Imago Group'),(136608363839488,'Patech',''),(136629603794944,'E-BandCo','E-Band Communications Corp.'),(136659450462208,'Portsmit','Portsmith LLC'),(136660087996416,'Mindtree','MindTree Wireless PVT Ltd'),(136663577657344,'RedSunSy','Red Sun Synthesis Pte Ltd'),(136667335753728,'ScaleCom','Scale Computing, Inc.'),(136668627599360,'Bskyb','BSkyB Ltd'),(136681780936704,'Arcadyan','Arcadyan Technology Corporation'),(136708389601280,'Ysi','YSI, Inc.'),(136754292064256,'HuaweiTe','HUAWEI TECHNOLOGIES CO.,LTD'),(136758519922688,'Htc','HTC Corporation'),(136794540605440,'Cisco',''),(136798382587904,'Safetone','SafeTone Technology Co.,Ltd'),(136799858982912,'TenyuTec','Tenyu Tech Co. Ltd.'),(136800379076608,'TigaroWi','Tigaro Wireless'),(136804254613504,'PixsysSr','PIXSYS SRL'),(136805697454080,'AmsNeve','AMS NEVE LTD'),(136809237446656,'Apple','Apple, Inc'),(136816283877376,'Caterpil','Caterpillar Trimble Control Tech'),(136820343963648,'Shenzhen','ShenZhen ACTO Digital Video Tech'),(136848177364992,'Enmas','ENMAS GmbH'),(136865860550656,'IntelCor','Intel Corporate'),(136871548026880,'ZSedaiKe','Z`SEDAI KENKYUSHO CORPORATION'),(136877403275264,'JinmuyuE','Jinmuyu Electronics Co., Ltd.'),(136898542567424,'Nortec',''),(136902183223296,'GlenDimp','Glen Dimplex Nordic as'),(136953152405504,'TexasIns','Texas Instruments'),(136978083348480,'PhilipsH','Philips Healthcare PCCI'),(136983468834816,'Cisco',''),(137003467276288,'VseValen','VSE valencia smart energy'),(137032491859968,'GnResoun','GN ReSound A/S'),(137037827014656,'DSignt','D.SignT GmbH & Co. KG'),(137052892954624,'MhlLlc','MHL, LLC'),(137081162563584,'BoschSof','Bosch Software Innovations GmbH'),(137084417343488,'Cisco',''),(137096396275712,'Osram','OSRAM GmbH'),(137104399007744,'CiscoSpv','Cisco SPVTG'),(137104784883712,'TclKingH','TCL King High Frequency EI,Co.,L'),(137117938221056,'AcesTech','ACES Technology'),(137127484456960,'Paradigm','Paradigm Electronics Inc'),(137144462999552,'CoscoEle','Cosco Electronics Co., Ltd.'),(137162750164992,'Motorola','Motorola Mobility, Inc.'),(137179661598720,'Apple','Apple, Inc.'),(137186473148416,'Apple','Apple, Inc.'),(137201304207360,'AcroAsso','Acro Associates, Inc.'),(137201924964352,'TianjinY','TIANJIN YAAN TECHNOLOGY CO., LTD'),(137202042404864,'Damalisk',''),(137211538309120,'AntairaT','Antaira Technologies, LLC'),(137231972958208,'Shanghai','Shanghai SEARI Intelligent Syste'),(137240361566208,'Apple','Apple Inc'),(137264503980032,'Freestyl','Freestyle Technology Pty Ltd'),(137268295630848,'Enmotus','Enmotus Inc'),(137275711160320,'NewCosmo','New Cosmos Electric Co., Ltd.'),(137277959307264,'Dongnian','Dongnian Networks Inc.'),(137288914829312,'Chongqin','Chongqing MAS SCI&TECH.Co.,Ltd'),(137289166487552,'IoxosTec','IOXOS Technologies S.A.'),(137291045535744,'Shenzhen','Shenzhen Ogemray Technology Co.,'),(137302655369216,'Neon','NEON Inc'),(137324784517120,'EsenOpto','ESEN Optoelectronics Technology '),(137343709216768,'HonHaiPr','Hon Hai Precision Ind. Co.,Ltd.'),(137352685027328,'Asct',''),(137359714680832,'Microsof','MICROSOFT'),(137366341681152,'Creative','Creative Product Design Pty. Ltd'),(137368254283776,'InhonInt','Inhon International Ltd.'),(137371827830784,'Apple','Apple, Inc.'),(137372784132096,'BeeBeans','Bee Beans Technologies, Inc.'),(137373354557440,'Linkwell','Linkwell Telesystems Pvt Ltd'),(137388101730304,'Nuuo','NUUO Inc.'),(137416924987392,'Apple',''),(137431034626048,'Salutron','Salutron Inc.'),(140737672904704,'IntelCor','Intel Corporate'),(140737756790784,'AttBellL','ATT BELL LABORATORIES'),(140762704510976,'MontageT','Montage Technology Group Limited'),(140770271035392,'EssonTec','Esson Technology Inc.'),(140780538691584,'Comtec','COMTEC co.,ltd'),(140824461443072,'SunlitSy','Sunlit System Technology Corp'),(140835047866368,'BrunelUn','Brunel University'),(140838369755136,'NortelNe','Nortel Networks'),(140843369365504,'SamsungE','Samsung Eletronics Co., Ltd'),(140864894533632,'Avaya','Avaya Inc'),(140870665895936,'EdimaxTe','Edimax Technology Co. Ltd.'),(140877863321600,'TradeFid','Trade FIDES, a.s.'),(140885480177664,'BeijingB','Beijing Beny Wave Technology Co '),(140922071285760,'Germanee','Germaneers GmbH'),(140934536757248,'Solarbri','Solarbridge Technologies'),(140935392395264,'AzetiNet','azeti Networks AG'),(140943076360192,'ZurichIn','Zurich Instruments AG'),(140962286272512,'Ot','OT Systems Limited'),(140982251159552,'Leapfrog','LeapFrog Enterprises, Inc.'),(140986143473664,'Patlite','PATLITE CORPORATION'),(140993475117056,'Ghe-CesE','ghe-ces electronic ag'),(141009631576064,'Winstars','Winstars Technology Ltd'),(141011661619200,'BytesAtW','bytes at work AG'),(141023036571648,'AdolfTed','Adolf Tedsen GmbH & Co. KG'),(141043253116928,'PacketDe','Packet Design, Inc.'),(141052916793344,'Apple','Apple Inc'),(141060147773440,'Ventilat','Ventilation Control'),(141078267166720,'Thinkeco','ThinkEco, Inc.'),(141081538723840,'Nokia','Nokia Corporation'),(141118750588928,'NovatecK','NovaTec Kommunikationstechnik Gm'),(141149922656256,'Rim',''),(141168478257152,'Nimbus','Nimbus Inc.'),(141175189143552,'Benq','BenQ Corporation'),(141176262885376,'Prescope','Prescope Technologies CO.,LTD.'),(141203676856320,'KaeserKo','KAESER KOMPRESSOREN AG'),(141204498939904,'NetNewEl','NET New Electronic Technology Gm'),(141223339753472,'JuniperN','Juniper Networks'),(141246760747008,'NewagSa','Newag SA'),(141263605071872,'AbbGenwa','ABB Genway Xiamen Electrical Equ'),(141266272649216,'CorsairC','Corsair Components'),(141274812252160,'Neosyste','Neosystem Co. Ltd.'),(141278167695360,'Chongqin','Chongqing Sichuan Instrument Mic'),(141294307377152,'Tongqing','TONGQING COMMUNICATION EQUIPMENT'),(141298099027968,'AtcomTec','ATCOM Technology Co.Ltd.'),(141315564109824,'Netronic','Netronics Technologies Inc.'),(141317074059264,'IntelCor','Intel Corporate'),(141336032313344,'Shenzhen','Shenzhen Runhuicheng Technology '),(141360963256320,'LihRongE','Lih Rong electronic Enterprise C'),(141363479838720,'Agilemes','AgileMesh, Inc.'),(141367221157888,'Apple',''),(141371314798592,'Xapt','Xapt GmbH'),(141374955454464,'TokyoRad','TOKYO RADAR CORPORATION'),(141384703016960,'Motorola','Motorola Mobility, LLC.'),(141386481401856,'Altenerg','Altenergy Power System,Inc.'),(141403745157120,'IntelCor','Intel Corporate'),(141432585191424,'Shanghai','Shanghai DareGlobal Technologies'),(141470384259072,'Usag',''),(141480517697536,'CnetTech','CNET Technology Inc. (Probably a'),(141504291012608,'Forworld','Forworld Electronics Ltd.'),(141506992144384,'AlstomGr','Alstom Grid'),(141521420550144,'HuaweiTe','Huawei Technologies Co., Ltd'),(141533600808960,'Elftech','ELFTECH Co., Ltd.'),(141539237953536,'Teleadap','TeleAdapt Ltd'),(141544589885440,'Satmap','Satmap Systems Ltd'),(141568262537216,'HewlettP','Hewlett Packard'),(141588948844544,'RemecBro','Remec Broadband Wireless , LLC'),(141590760783872,'Technico','Technicolor USA Inc.'),(141591280877568,'EndianSR','Endian s.r.l.'),(141598125981696,'Openpeak','Openpeak, Inc'),(141625221185536,'Theissen','Theissen Training Systems GmbH'),(141627637104640,'LenovoMo','Lenovo Mobile Communication Tech'),(141631260983296,'Embed','Embed, Inc'),(141637468553216,'Hangzhou','Hangzhou I`converge Technology C'),(141661761961984,'QsrAutom','QSR Automations, Inc.'),(141678908276736,'PowerQuo','Power Quotient International Co.'),(141761619951616,'Shuttle','Shuttle Inc.'),(141792221593600,'IrcoSist','IRCO Sistemas de TelecomunicaciÃ'),(141794822062080,'Hangzhou','Hangzhou H3C Technologies Co., L'),(141812756905984,'Clevo','CLEVO CO.'),(141815625809920,'HuaweiTe','HUAWEI TECHNOLOGIES CO.,LTD'),(141835523588096,'Unidis',''),(145139058081792,'SonyEric','Sony Ericsson Mobile Communicati'),(145183534481408,'SamsungE','SAMSUNG ELECTRO-MECHANICS CO., L'),(145234671435776,'GpElectr','GP Electronics (HK) Ltd.'),(145240895782912,'JuniperN','Juniper Networks'),(145253076041728,'Netgear',''),(145265021419520,'Kernel-I','KERNEL-I Co.,LTD'),(145278359306240,'Shenzhen','Shenzhen Ginwave Technologies Lt'),(145292519276544,'Motorola','Motorola Solutions Inc'),(145295505620992,'SilexTec','Silex Technology, Inc'),(145298122866688,'SamsungE','Samsung Electronics Co.,Ltd'),(145306494697472,'OfPresid','Corporation of the Presiding Bis'),(145311964069888,'EmporiaT','EMPORIA TELECOM Produktions- und'),(145314195439616,'Apple','Apple Inc'),(145320939880448,'Dell','Dell Inc.'),(145321560637440,'Huria','Huria Co.,Ltd.'),(145323372576768,'Modellei','Modelleisenbahn GmbH'),(145339361263616,'InnokasG','Innokas Group'),(145345535279104,'Skyhawke','SkyHawke Technologies, LLC'),(145361406525440,'HewlettP','Hewlett Packard'),(145367748313088,'Hyungseu','hyungseul publishing networks'),(145376942227456,'Apple',''),(145385901260800,'IntelCor','Intel Corporate'),(145407426428928,'Tri-Tech','Tri-Tech Manufacturing, Inc.'),(145445359714304,'WoxterTe','WOXTER TECHNOLOGY Co. Ltd'),(145449419800576,'VarmourN','vArmour Networks, Inc.'),(145461767831552,'HonHaiPr','Hon Hai Precision Ind. Co.,Ltd.'),(145485591478272,'SamsungE','Samsung Electronics Co.,Ltd'),(145511461945344,'DvrC&C','DVR C&C Co., Ltd.'),(145533138108416,'Chabrier','Chabrier Services'),(145538573926400,'Shenzhen','Shenzhen Netcom Electronics Co.,'),(145557028864000,'Shenzhen','Shenzhen Coship Electronics Co.,'),(145559226679296,'EurocbPh','EuroCB (Phils), Inc.'),(145594777600000,'Wireless','Wireless Tsukamoto.,co.LTD'),(145610950836224,'ParkAssi','Park Assist LLC'),(145634455715840,'Zte','zte corporation'),(145653816623104,'Cisco',''),(145661802577920,'Htc','HTC Corporation'),(145677774487552,'TexasIns','Texas Instruments'),(145697974255616,'BeijingH','Beijing Huasun Unicreate Technol'),(145700071407616,'Avaya','Avaya, Inc'),(145706866180096,'Apple','Apple Inc'),(145743339847680,'Rajant','Rajant Corporation'),(145747936804864,'Embertec','Embertec Pty Ltd'),(145751476797440,'Dell','Dell Inc.'),(145754010157056,'ArnoldRi','Arnold & Richter Cine Technik'),(145787161935872,'Memjet','Memjet Inc.'),(145808334782464,'Arcadyan','Arcadyan Technology Corporation'),(145813149843456,'CenteraP','Centera Photonics Inc.'),(145851854880768,'IntelCor','Intel Corporate'),(145860914577408,'Shenzhen','Shenzhen Huawei Communication Te'),(145863817035776,'CyberTra','Cyber Trans Japan Co.,Ltd.'),(145877020704768,'BeijingN','Beijing Novel Super Digital TV T'),(145887674236928,'BeatSyst','Beat System Service Co,. Ltd.'),(145972583727104,'JiangsuQ','Jiangsu Qinheng Co., Ltd.'),(145990887669760,'Gnodal','Gnodal Ltd'),(145993068707840,'C3poSA','C3PO S.A.'),(145997497892864,'Incognit','Incognito Software Inc.'),(146001809637376,'D-LinkIn','D-Link International'),(146042477608960,'Ieee1905','IEEE 1905.1'),(146070898212864,'Unipatte','Unipattern Co.,'),(146076921233408,'SierraWi','Sierra Wireless Inc'),(146085259509760,'TexasIns','Texas Instruments'),(146090041016320,'CrystalV','Crystal Vision Ltd'),(146093513900032,'Net2grid','NET2GRID BV'),(146118428065792,'Shenzhen','Shenzhen NEED technology Ltd.'),(146124065210368,'BluwanSa','Bluwan SA'),(146128007856128,'LiangHer','Liang Herng Enterprise,Co.Ltd.'),(146143124127744,'Vieworks',''),(146154297753600,'Bbmc','BBMC Co.,Ltd'),(146185973137408,'OmsSpolS','OMS spol. s.r.o.'),(146193371889664,'CrossPoi','Cross Point BV'),(146222128037888,'Apple',''),(149547892342784,'Arcadyan','Arcadyan Technology Corp.'),(149572319969280,'Mtmcommu','MTMCommunications'),(149603206823936,'PanodicS','Panodic(ShenZhen) Electronics Li'),(149612199411712,'Qualcomm','Qualcomm Atheros'),(149620202143744,'Protonic','Protonic Holland'),(149624916541440,'Meraki','Meraki, Inc.'),(149639579828224,'Tamron','Tamron Co., Ltd'),(149669426495488,'Apple',''),(149671322320896,'LmiTechn','LMI Technologies'),(149679123726336,'Nebusens','Nebusens, S.L.'),(149685582954496,'Watchnet','Watchnet DVR Inc'),(149688166645760,'TttechCo','TTTech Computertechnik AG'),(149693233364992,'Arcadyan','Arcadyan Technology Corporation'),(149732659822592,'Storone',''),(149742055063552,'MurataMa','Murata Manufactuaring Co.,Ltd.'),(149750930210816,'SamsungE','Samsung Electro Mechanics co.,LT'),(149752960253952,'TexasIns','Texas Instruments'),(149762489712640,'Transics',''),(149765811601408,'SrcCompu','SRC Computers, LLC'),(149815992254464,'OrbisatD','ORBISAT DA AMAZONIA IND E AEROL '),(149825119059968,'Cisco','CISCO SYSTEMS, INC.'),(149834933731328,'Telechip','Telechips Inc.'),(149856660226048,'SiemensH','Siemens AG, Healthcare Sector'),(149885684809728,'HewlettP','Hewlett Packard'),(149890835415040,'IntelCor','Intel Corporate'),(149892563468288,'Apple',''),(149893620432896,'HuaweiTe','Huawei Technologies Co., Ltd'),(149930043768832,'AlcatelL','Alcatel Lucent'),(149951703154688,'SianoMob','Siano Mobile Silicon Ltd.'),(149981801480192,'Shenzhen','Shenzhen ChuangDao & Perpetual E'),(149995122589696,'ChinaHop','CHINA HOPEFUL GROUP HOPEFUL ELEC'),(150030052753408,'K2eTekpo','K2E Tekpoint'),(150037535391744,'Cisco',''),(150111791349760,'SimtonTe','Simton Technologies, Ltd.'),(150113787838464,'Canon','CANON INC.'),(150117109727232,'Darbeevi','DarbeeVision Inc.'),(150123669618688,'GsiElect','GSI Electronics Inc.'),(150132142112768,'StorageA','Storage Appliance Corporation'),(150135296229376,'BradyAsi','Brady Corp Asia Pacific Ltd'),(150160059400192,'Racktivi','Racktivity'),(150173414064128,'GemicomT','Gemicom Technology, Inc.'),(150176635289600,'UnifiedP','Unified Packet Systems Crop'),(150179806183424,'TtcMarco','TTC MARCONI s.r.o.'),(150185862758400,'Entrypas','Entrypass Corporation Sdn. Bhd.'),(150186970054656,'Teraon',''),(150200257609728,'SamsungE','Samsung Electronics Co.,Ltd'),(150220675481600,'HonHaiPr','Hon Hai Precision Ind. Co.,Ltd.'),(150237083598848,'AmatisCo','Amatis Controls'),(150245421875200,'Qpcom','QPCOM INC.'),(150275553755136,'Generito','Generiton Co., Ltd.'),(150281392226304,'CompalIn','COMPAL INFORMATION(KUNSHAN)CO.,L'),(150295535419392,'DeltaCon','Delta Control GmbH'),(150315919736832,'GembirdE','Gembird Europe BV'),(150334576001024,'Qfiednet','Qfiednet Co., Ltd.'),(150357493678080,'SimpleAu','Simple Audio Ltd'),(150372945494016,'BeijingE','Beijing Ereneben lnformation Tec'),(150385645846528,'Apple','Apple, Inc.'),(150407724662784,'Apple',''),(150460153462784,'Dep','DEP Company'),(150480990765056,'SenaoNet','SENAO Networks, Inc.'),(150484799193088,'Voltaire',''),(150498338406400,'Shenzhen','Shenzhen VisionSTOR Technologies'),(150499730915328,'JuniperN','Juniper Networks'),(150526020812800,'Whirlpoo','Whirlpool Corporation'),(150528503840768,'Iknowled','iKnowledge Integration Corp.'),(150534694633472,'Tamaggo',''),(150551958388736,'CudoComm','Cudo Communication Co., Ltd.'),(150566370017280,'Cisco','CISCO SYSTEMS, INC.'),(150583835099136,'CellonCo','cellon communications technology'),(150583969316864,'Jetmobil','Jetmobile Pte Ltd'),(150620560424960,'Lineeye','LINEEYE CO., LTD'),(153933456605184,'Apple',''),(153953085947904,'Technico','Technicolor USA Inc.'),(153964041469952,'FlowData','FLOW DATA INC'),(153985583415296,'RuckusWi','Ruckus Wireless'),(153985902182400,'Amper',''),(153995565858816,'Guangdon','GUANGDONG OPPO MOBILE TELECOMMUN'),(154008048107520,'AbusSecu','ABUS Security-Center GmbH & Co. '),(154067254902784,'RfSurgic','RF Surgical System Inc.'),(154073529581568,'Tp-LinkT','TP-LINK TECHNOLOGIES CO., LTD.'),(154099618152448,'Quanthou','QuantHouse'),(154101446868992,'Vocollec','Vocollect Inc'),(154127753543680,'Apple','Apple Inc'),(154151476527104,'Emfirst','EmFirst Co., Ltd.'),(154189443366912,'SkivaTec','Skiva Technologies, Inc.'),(154190567440384,'NakayoTe','NAKAYO TELECOMMUNICATIONS,INC.'),(154224574857216,'Shanghai','Shanghai BroadMobi Communication'),(154253448445952,'GigaTms','GIGA TMS INC'),(154255243608064,'3dImagin','3D Imaging & Simulations Corp'),(154261736390656,'PlanexCo','PLANEX COMMUNICATIONS INC.'),(154266266238976,'Cerio','Cerio Corporation'),(154279604125696,'Shenzhen','Shenzhen ireadygo Information Te'),(154292254146560,'A&DEngin','A&D ENGINEERING CO., LTD.'),(154292891680768,'Lge',''),(154304300187648,'Nintendo','Nintendo Co., Ltd.'),(154309534679040,'LvxWeste','LVX Western'),(154311581499392,'Apple','Apple, Inc.'),(154316212011008,'CTechnol','C Technologies AB'),(154322201477120,'Exeltech','Exeltech Solar Products'),(154329466011648,'D-Broad','d-broad,INC'),(154343391100928,'BeijingR','Beijing Railway Signal Factory'),(154345270149120,'Cisco','CISCO SYSTEMS, INC.'),(154361309167616,'BeyondDe','Beyond Devices d.o.o.'),(154361695043584,'SonyEric','Sony Ericsson Mobile Communicati'),(154380317753344,'Nortek-A','Nortek-AS'),(154390719627264,'Viogem','Viogem Limited'),(154414174175232,'IntelCor','Intel Corporate'),(154421119942656,'SamsungE','Samsung Electronics Co.,Ltd'),(154427394621440,'Fujitsu','Fujitsu Limited'),(154441672032256,'GodenTec','Goden Tech Limited'),(154443030986752,'SamsungE','Samsung Electronics Co.,Ltd'),(154443098095616,'Longchee','LONGCHEER TELECOMMUNICATION LIMI'),(154462542888960,'Apple','Apple, Inc.'),(154467240509440,'HonHaiPr','Hon Hai Precision Ind. Co.,Ltd.'),(154468482023424,'BrocadeC','Brocade Communications Systems, '),(154475796889600,'Lytro','Lytro, Inc.'),(154492792209408,'InsigmaT','Insigma Technology Co.,Ltd'),(154498580348928,'Private',''),(154522806648832,'Micro-St','Micro-Star INT`L CO., LTD'),(154526178869248,'EstunAut','ESTUN AUTOMATION TECHNOLOY CO., '),(154543492956160,'Taskit','taskit GmbH'),(154553643171840,'AlcatelL','Alcatel Lucent'),(154559599083520,'AusLinxT','Aus.Linx Technology Co., Ltd.'),(154570755932160,'EncellTe','Encell Technology, Inc.'),(154620030615552,'BeijingN','Beijing NeTopChip Technology Co.'),(154659658399744,'IntelCor','Intel Corporate'),(154680227266560,'Plugable','Plugable Technologies'),(154714637336576,'Cisco','CISCO SYSTEMS, INC.'),(154722640068608,'IpitomyC','IPitomy Communications'),(154723579592704,'AcsipTec','AcSiP Technology Corp.'),(154761110224896,'Panasoni','Panasonic Corporation AVC Networ'),(154781511319552,'Shenzhen','ShenZhen Konka Telecommunication'),(154789178507264,'RadinetC','Radinet Communications Inc.'),(154789816041472,'Zhejiang','zhejiang ebang communication co.'),(154794060677120,'SamsungE','Samsung Electronics Co., LTD'),(154815988498432,'Nintendo','Nintendo Co., Ltd.'),(154822229622784,'Befega','BEFEGA GmbH'),(154831339651072,'CgMobile','CG Mobile'),(154840583897088,'VissimAs','VisSim AS'),(154851421978624,'IkorMete','Ikor Metering'),(154872846483456,'EsgSolut','ESG Solutions'),(154883181248512,'Wifly-Ci','Wifly-City System Inc.'),(154886486360064,'IsscTech','ISSC Technologies Corp.'),(154895864823808,'Zte','zte corporation'),(154924973293568,'Private',''),(154926768455680,'Sonardyn','Sonardyne International Ltd'),(154957151993856,'Precepsc','Precepscion Pty. Ltd.'),(155002232373248,'PowerAut','Power Automation pte Ltd'),(155004446965760,'MesadaTe','MESADA Technology Co.,Ltd.'),(155008490274816,'Apple','Apple Inc'),(155022281146368,'Qualcomm','QUALCOMM Incorporated'),(158330983022592,'HonHaiPr','Hon Hai Precision Ind. Co.,Ltd.'),(158334959222784,'Sagemcom',''),(158341099683840,'Zhejiang','ZHEJIANG DAHUA TECHNOLOGY CO.,LT'),(158345629532160,'Parrot',''),(158368714981376,'Far-Sigh','Far-sighted mobile'),(158373597151232,'PsgPlast','PSG Plastic Service GmbH'),(158387220250624,'Digimore','Digimore Electronics Co., Ltd'),(158388914749440,'ArrisGro','ARRIS Group, Inc.'),(158434330673152,'ApexTool','Apex Tool Group GmbH & Co OHG'),(158434833989632,'SamsungE','Samsung Electro Mechanics co., L'),(158435672850432,'Shanghai','Shanghai Meridian Technologies, '),(158437048582144,'ScsSa','SCS SA'),(158445873397760,'FujitsuT','Fujitsu Technology Solutions Gmb'),(158454882762752,'Zte','zte corporation'),(158462231183360,'GreatCom','GREAT COMPUTER CORPORATION'),(158472834383872,'Htc','HTC Corporation'),(158501003329536,'Apple','Apple, Inc.'),(158515230408704,'Giga-Byt','GIGA-BYTE TECHNOLOGY CO.,LTD.'),(158529507819520,'Labjack',''),(158553734119424,'Gatekeep','Gatekeeper Systems, Inc.'),(158557240557568,'HonHaiPr','Hon Hai Precision Ind. Co.,Ltd.'),(158573933887488,'Changzho','Changzhou Tiannengbo System Co. '),(158581466857472,'Alcatel-','Alcatel-Lucent'),(158590291673088,'YunnanKs','Yunnan KSEC Digital Technology C'),(158593177354240,'Shenzhen','Shenzhen Wision Technology Holdi'),(158593462566912,'ZiconTec','Zicon Technology Corp.'),(158598831276032,'ArrisGro','ARRIS Group, Inc.'),(158633392340992,'VadaroPt','Vadaro Pte Ltd'),(158634986176512,'Rorze','RORZE CORPORATION'),(158647401316352,'Intel','Intel Corporation'),(158659933896704,'HonHaiPr','Hon Hai Precision Ind. Co.,Ltd.'),(158675335380992,'Advanced','Advanced PANMOBIL Systems GmbH &'),(158678623715328,'Elettron','Elettronica Santerno'),(158691626057728,'TesElect','TES ELECTRONIC SOLUTIONS'),(158697665855488,'Ericsson','Ericsson, EAB/RWI/K'),(158701222625280,'Lenbrook','Lenbrook Industries Limited'),(158701491060736,'Autotalk','Autotalks Ltd.'),(158714862501888,'TexasIns','Texas Instruments'),(158738468044800,'TctMobil','TCT Mobile Limited'),(158740061880320,'Modas','modas GmbH'),(158746487554048,'FidaInte','Fida International (S) Pte Ltd'),(158775092707328,'Alcatel-','Alcatel-Lucent'),(158776132894720,'AlcatelL','Alcatel Lucent'),(158801181278208,'DlgAutom','DLG AutomaÃ§Ã£o Industrial Ltda'),(158805258141696,'HonHaiPr','Hon Hai Precision Ind. Co.,Ltd.'),(158811331493888,'GareaMic','Garea Microsys Co.,Ltd.'),(158853828182016,'GebrBode','Gebr. Bode GmbH & Co KG'),(158854331498496,'BeijingM','Beijing Morncloud Information An'),(158857703718912,'SnupiTec','SNUPI Technologies'),(158876762636288,'ChiconyE','Chicony Electronics Co., Ltd.'),(158889630760960,'Ieee1904','IEEE 1904.1 Working Group'),(158896828186624,'Apple','Apple, Inc'),(158916507860992,'IonicsTe','IONICS TECHNOLOGY ME LTDA'),(158935751327744,'GhTechno','GH Technologies'),(158947327606784,'UnoSyste','UNO System Co., Ltd'),(158949156323328,'TrisonTe','TRISON TECHNOLOGY CORPORATION'),(158949760303104,'RsiVideo','RSI VIDEO TECHNOLOGIES'),(158959759523840,'DiehlBgt','Diehl BGT Defence GmbH & Co. KG'),(158969154764800,'D-LinkIn','D-Link International'),(159007742361600,'NewlandD','Newland Design + Assoc. Inc.'),(159029116534784,'GheoSa','GHEO SA'),(159037773578240,'WistronN','Wistron Neweb Corp.'),(159049131753472,'JswPacif','JSW PACIFIC CORPORATION'),(159050171940864,'PakedgeD','Pakedge Device and Software Inc.'),(159069465739264,'Brightsi','BrightSign LLC'),(159090353373184,'Dell','Dell Inc.'),(159090756026368,'Motorola','Motorola Mobility, Inc.'),(159123438043136,'Joyent','Joyent, Inc.'),(159126340501504,'JohnsonO','Johnson Outdoors Marine Electron'),(159158955409408,'SonyEric','Sony Ericsson Mobile Communicati'),(159206451707904,'Synaptic','Synaptics, Inc'),(159219084951552,'Nokia','Nokia Corporation'),(159220594900992,'Dlogixs','Dlogixs Co Ltd'),(159220829782016,'QingdaoH','Qingdao Hisense Electric Co.,Ltd'),(159227775549440,'PalomarM','Palomar Medical Technologies'),(159254417768448,'Bookeen',''),(159257035014144,'TexasIns','Texas Instruments'),(159258763067392,'Comtec','Comtec Co., Ltd.'),(159262420500480,'Hug-Wits','HUG-WITSCHI AG'),(159267285893120,'Avanu',''),(159295773605888,'HarmanIn','Harman International'),(159303457570816,'IntelCor','Intel Corporate'),(159320637440000,'AsustekC','ASUSTek COMPUTER INC.'),(159336307359744,'SpiLaser','SPI Lasers Ltd'),(159371069751296,'RadiusGa','Radius Gateway'),(159380884422656,'RandMcna','Rand McNally'),(159387612086272,'Tp-LinkT','TP-LINK TECHNOLOGIES CO., LTD.'),(159391319851008,'Phillips','Phillips Machine & Welding Co., '),(159409237917696,'Avaya','Avaya, Inc'),(159410496208896,'HonHaiPr','Hon Hai Precision Ind.Co.Ltd'),(159426921103360,'MetroEth','Metro Ethernet Forum'),(162729599959040,'Nokia','Nokia Corporation'),(162733240614912,'Autohotb','AutoHotBox'),(162775720525824,'NetviewT','NetView Technologies(Shenzhen) C'),(162781089234944,'Tp-LinkT','TP-LINK Technologies Co.,Ltd.'),(162804392787968,'ItfFrÃ¶sc','ITF FrÃ¶schl GmbH'),(162824139571200,'PointCor','Point Core SARL'),(162852744724480,'TlabWest','TLab West Systems AB'),(162866552373248,'Nokia','Nokia Corporation'),(162871988191232,'Stalmart','Stalmart Technology Limited'),(162879890259968,'Shenzhen','Shenzhen Junlan Electronic Ltd'),(162925675282432,'Schneide','Schneider Electric Canada Inc'),(162926950350848,'FinsÃ©cur',''),(162940774776832,'Alphatro','Alphatronics BV'),(162950472007680,'TacoElec','Taco Electronic Solutions, Inc.'),(162955521949696,'SamsungE','Samsung Electronics Co.,Ltd'),(162963407241216,'SichuanB','Sichuan Bihong Broadcast &amp; T'),(162976376029184,'HonHaiPr','Hon Hai Precision Ind. Co.,Ltd.'),(162980855545856,'Nokia','Nokia Corporation'),(163005316726784,'AnywaveC','Anywave Communication Technologi'),(163020919537664,'LgInnote','LG Innotek'),(163021154418688,'BelkinIn','Belkin International Inc.'),(163030885203968,'Baudtec','BaudTec Corporation'),(163045699485696,'BitwiseC','BitWise Controls'),(163072509476864,'Rechnerb','Rechnerbetriebsgruppe'),(163075663593472,'SamsungE','Samsung Electronics'),(163110727974912,'EkeBuild','EKE Building Technology Systems '),(163120676864000,'Trilobit','TRILOBIT LTDA.'),(163144936718336,'Pason','Pason Systems'),(163156429111296,'SamsungE','Samsung Electronics Co.,Ltd'),(163215937896448,'TctMobil','TCT Mobile Limited'),(163232077578240,'QinetiqN','QinetiQ North America'),(163284523155456,'AzurayTe','Azuray Technologies'),(163300998381568,'Evantage','Evantage Industries Corp'),(163313245749248,'TexasIns','Texas Instruments'),(163324771696640,'EagetInn','EAGET Innovation and Technology '),(163334653476864,'BeamexOy','Beamex Oy Ab'),(163345894211584,'HughesTe','Hughes Telematics, Inc.'),(163364013604864,'Apple',''),(163383273848832,'Shanghai','Shanghai LISTEN TECH.LTD'),(163397685477376,'TransNew','Trans New Technology, Inc.'),(163399161872384,'AltaData','Alta Data Technologies'),(163413640609792,'ChengduJ','ChengDu JiaFaAnTai Technology Co'),(163448134565888,'Bodymedi','BodyMedia, Inc.'),(163460952358912,'JoviewBe','Joview(Beijing) Technology Co. L'),(163469844283392,'TrivumTe','trivum technologies GmbH'),(163476672610304,'AlcatelL','Alcatel Lucent'),(163521300004864,'Ruggedco','RuggedCom Inc.'),(163527406911488,'Visionte','Visiontec da AmazÃ´nia Ltda.'),(163548562980864,'Eflow/Sm','eflow Inc. / Smart Device Planni'),(163573443592192,'Powerlay','PowerLayer Microsystems HongKong'),(163582067081216,'NovaElec','NOVA electronics, Inc.'),(163585355415552,'RayliosT','Raylios Technology'),(163592653504512,'Teseq','Teseq AG'),(163595555962880,'Honeywel','Honeywell Analytics'),(163606998024192,'Motorola','Motorola Mobility, Inc.'),(163611074887680,'Creowave','Creowave Oy'),(163613222371328,'SonyMobi','Sony Mobile Communications AB'),(163621493538816,'Cydle','Cydle Corp.'),(163651726082048,'Shanghai','Shanghai DareGlobal Technologies'),(163653034704896,'SamsungE','Samsung Electronics Co.,Ltd'),(163660735447040,'Enelps',''),(163669543485440,'Sitcorp',''),(163671690969088,'Azurewav','Azurewave'),(163677965647872,'A+VLinkT','A+V Link Technologies, Corp.'),(163681438531584,'Smartopt','SmartOptics AS'),(163683351134208,'Giga-Byt','GIGA-BYTE TECHNOLOGY CO.,LTD.'),(163686975012864,'IjElectr','IJ Electron CO.,Ltd.'),(163693283246080,'Healthst','HealthStream Taiwan Inc.'),(163699021053952,'DOrtizCo','D. ORtiz Consulting, LLC'),(163720143568896,'XirkaDam','Xirka Dama Persada PT'),(163725361283072,'FyldeMic','FYLDE MICRO LTD'),(163740477554688,'Research','Research In Motion Limited'),(163786732339200,'Geminico','Geminico co.,Ltd.'),(163789114703872,'TianjinD','Tianjin Deviser Electronics Inst'),(163805355048960,'Shenzhen','Shenzhen Eycom Technology Co., L'),(163814834176000,'Wherewhe','WhereWhen Corp'),(163815119388672,'Shanghai','Shanghai Uniscope Technologies C'),(163822736244736,'Sagemcom',''),(167136571949056,'Theobrom','Theobroma Systems GmbH'),(167141336678400,'AbbNVPow','ABB n.v. Power Quality Products'),(167142276202496,'Apple','Apple, Inc.'),(167179488067584,'SamsungE','Samsung Electro Mechanics'),(167182373748736,'Htc','HTC Corporation'),(167189722169344,'Private',''),(167196969926656,'Shenzhen','Shenzhen Vsun communication tech'),(167265588740096,'Definium','Definium Technologies'),(167289680822272,'AppliedR','Applied Research Associates, Inc'),(167302347620352,'JaguarDe','Jaguar de Mexico, SA de CV'),(167302918045696,'FujianSt','Fujian Start Computer Equipment '),(167317933654016,'2wire',''),(167320483790848,'Resoluti','Resolution Audio'),(167331925852160,'BeijingK','Beijing KEMACOM Technologies Co.'),(167333821677568,'Daikyung','DAIKYUNG VASCOM'),(167355296514048,'Sub10','Sub10 Systems Ltd'),(167356487696384,'Assemble','Assembled Products Corporation'),(167379539591168,'AmpakTec','AMPAK Technology Inc'),(167399017938944,'ChinaSsj','China SSJ (Suzhou) Network Techn'),(167410409668608,'SolIndus','SOL INDUSTRY PTE., LTD'),(167431716732928,'Shanghai','SHANGHAI SUNMON COMMUNICATION TE'),(167444786184192,'ChgHospi','CHG Hospital Beds'),(167449131483136,'Motorola','Motorola Mobility, LLC.'),(167451664842752,'Hewlett-','Hewlett-Packard Company'),(167452252045312,'Zhangzho','Zhangzhou Keneng Electrical Equi'),(167455724929024,'MantisDe','Mantis Deposition'),(167463308230656,'Starligh','Starlight Marketing (H. K.) Ltd.'),(167469062815744,'IntelCor','Intel Corporate'),(167480924307456,'SamsungE','Samsung Electronics'),(167502969569280,'HonHai-C','HON HAI-CCPBG  PRECISION IND.CO.'),(167506039799808,'Sysgrati','SYSGRATION Ltd.'),(167509177139200,'TexasIns','Texas Instruments'),(167523370663936,'SbgSas','SBG Systems SAS'),(167526373785600,'Peoplene','PeopleNet Communication'),(167529947332608,'Conversd','ConversDigital Co., Ltd.'),(167538654707712,'Emw','EMW Co., Ltd.'),(167567779954688,'Industri','Industrial Control Communication'),(167597274300416,'ToshibaM','TOSHIBA MITSUBISHI-ELECTRIC INDU'),(167622976995328,'SageElec','Sage Electronic Engineering LLC'),(167635627016192,'Adafruit',''),(167684499046400,'Disrupti','Disruptive Ltd'),(167704262606848,'Flyaudio','Flyaudio corporation (China)'),(167718154141696,'AnademIn','Anadem Information Inc.'),(167724328157184,'SagemCom','SAGEM COMMUNICATION'),(167725670334464,'Corintec','Corintech Ltd.'),(167736525193216,'Zhejiang','ZHEJIANG BOXSAM ELECTRONIC CO.,L'),(167739360542720,'TeConnec','TE Connectivity Limerick'),(167746390196224,'Linkpowe','Linkpower Network System Inc Ltd'),(167760550166528,'LgElectr','LG Electronics Inc.'),(167762647318528,'Skyworth','Skyworth Wireless Technology Ltd'),(167845979750400,'McstZao','MCST ZAO'),(167859518963712,'BlueWave','BLUE WAVE NETWORKING CO LTD'),(167882637967360,'Alcatel-','Alcatel-Lucent'),(167919849832448,'Apple',''),(167934680891392,'SvaTechn','SVA TECHNOLOGIES CO.LTD'),(167935788187648,'Edeltech','Edeltech Co.,Ltd.'),(167985918509056,'Packetac','PacketAccess'),(168009255616512,'Virident','Virident Systems, Inc.'),(168047138570240,'ChyiLeeI','Chyi Lee industry Co., ltd.'),(168048027762688,'Apple','Apple, Inc.'),(168049034395648,'LgElectr','LG Electronics'),(168055829168128,'NortelNe','Nortel Networks'),(168074300882944,'Unitec','UNITEC Co., Ltd.'),(168093829562368,'Accutome',''),(168120488558592,'FoxconnN','Foxconn(NanJing) Communication C'),(168141074202624,'CosesyAp','Cosesy ApS'),(168178957156352,'Zte','zte corporation'),(168194157314048,'IdtTechn','IDT Technology Limited'),(168194593521664,'MariniIm','Marini Impianti Industriali s.r.'),(168208384393216,'Cisco-Li','Cisco-Linksys, LLC'),(168216739446784,'Ericsson','Ericsson - North America'),(168219172143104,'Apple','Apple Inc'),(171528394113024,'Shenzhen','Shenzhen Newabel Electronic Co.,'),(171534954004480,'SamsungE','Samsung Electronics Co.,Ltd'),(171542923182080,'Tecmobil','Tecmobile (International) Ltd.'),(171544936448000,'Apple',''),(171551429230592,'HyteraCo','Hytera Communications Corporatio'),(171582534189056,'Tymphany','Tymphany HK Limited'),(171611407777792,'EdataEle','Edata Elektronik San. ve Tic. A.'),(171628839305216,'NokiaDan','Nokia Danmark A/S'),(171644375007232,'ArubaNet','Aruba Networks'),(171660665683968,'Accupix','Accupix Inc.'),(171663316484096,'Apple','Apple Inc'),(171670077702144,'TascanSe','TASCAN Service GmbH'),(171696686366720,'Discover','Discovery Technology,LTD..'),(171698817073152,'Continen','Continental Automotive Czech Rep'),(171706081607680,'HonHaiPr','Hon Hai Precision Ind. Co.,Ltd.'),(171736280596480,'FoshanHu','Foshan Huadian Intelligent Commu'),(171737320783872,'KuliteSe','Kulite Semiconductor Products In'),(171775858049024,'SamsungE','Samsung Electronics Co.,Ltd'),(171805067182080,'HameTech','Hame  Technology Co.,  Limited'),(171821827620864,'DimepSis','DIMEP Sistemas'),(171843705110528,'Nokia','Nokia Corporation'),(171853150683136,'MesaLabs','Mesa Labs'),(171859358253056,'Cisco','CISCO SYSTEMS, INC.'),(171859727351808,'IntelCor','Intel Corporate'),(171861203746816,'Alt','ALT Systems Ltd'),(171862025830400,'Boxcast',''),(171883735547904,'EngicamS','ENGICAM s.r.l.'),(171885060947968,'Shenzhen','Shenzhen My-power Technology Co.'),(171887980183552,'Zhengzho','Zhengzhou VCOM Science and Techn'),(171891906052096,'ISESRL','I.S.E. S.r.l.'),(171897761300480,'FeitianX','Feitian Xunda(Beijing) Aeronauti'),(171917172539392,'Nmr','NMR Corporation'),(171921316511744,'FiremaxI','FIREMAX INDÃšSTRIA E COMÃ‰RCIO D'),(171923547881472,'Aerohive','Aerohive Networks Inc'),(171925745696768,'VtcElect','VTC Electronics Corp.'),(171929470238720,'CalibreU','Calibre UK Ltd'),(171940912300032,'Omni-IdU','Omni-ID USA, Inc.'),(171954887720960,'HarmanCo','Harman Consumer Group'),(171963242774528,'GlodioTe','Glodio Technolies Co.,Ltd Tianji'),(171982268137472,'QeesAps','QEES ApS.'),(172026660651008,'WildixSr','Wildix srl'),(172037767168000,'Nadasnv',''),(172046390657024,'SuntecSo','Suntec Software(Shanghai) Co., L'),(172055618125824,'NeolabCo','NEOLAB Convergence'),(172075666898944,'Syscable','SYSCABLE Korea Inc.'),(172124857696256,'Warehous','The Warehouse Limited'),(172129840529408,'IntegPro','INTEG process group inc'),(172136266203136,'Hewlett-','Hewlett-Packard Company'),(172137390276608,'Teracom','Teracom Limited'),(172156482748416,'Xerox','Xerox Corporation'),(172167924809728,'Smartdoo','SmartDoor Systems, LLC'),(172172991528960,'Technico','Technicolor'),(172176934174720,'Guangzho','Guangzhou Sunrise Electronics De'),(172194315370496,'StarkeyL','Starkey Labs Inc.'),(172216176082944,'Nike','Nike, Inc.'),(172227014164480,'SakuraIn','SAKURA Internet Inc.'),(172234480025600,'OsornoEn','Osorno Enterprises Inc.'),(172270853029888,'ObihaiTe','Obihai Technology, Inc.'),(172278822207488,'Cisco','CISCO SYSTEMS, INC.'),(172279862394880,'Ubiquito','Ubiquitous Computing Technology '),(172288418775040,'Procente','PROCENTEC'),(172310011052032,'LiteonTe','Liteon Technology Corporation'),(172312259198976,'Creatcom','Creatcomm Technology Inc.'),(172350444142592,'Printcou','PrintCounts, LLC'),(172351970869248,'Conducti','Conductix-Wampfler AG'),(172381297442816,'Avm','AVM GmbH'),(172382018863104,'Sharp','SHARP Corporation'),(172395037982720,'Nokia','Nokia Corporation'),(172406463266816,'ChengUei','CHENG UEI PRECISION INDUSTRY CO.'),(172427015356416,'Zte','zte corporation'),(172431880749056,'Netgear','NETGEAR INC.,'),(172481641971712,'Harman/B','Harman/Becker Automotive Systems'),(172490416455680,'Nctech','NCTech Ltd'),(172493771898880,'JungerAu','Junger Audio-Studiotechnik GmbH'),(172512545603584,'Nintendo','Nintendo Co., Ltd.'),(172515531948032,'SamsungE','Samsung Electronics Co.,Ltd'),(172537023561728,'BizlinkK','BizLink (Kunshan) Co.,Ltd'),(172580812095488,'UtcFireA','UTC Fire and Security'),(172582473039872,'RicardoP','Ricardo Prague, s.r.o.'),(172594200313856,'ArevaNp','AREVA NP GmbH'),(172622218264576,'Otsl','OTSL Inc.'),(175936406290432,'RobertBo','Robert Bosch Healthcare GmbH'),(175954475352064,'SamsungE','Samsung Electronics'),(175954978668544,'Advanced','Advanced Technical Support, Inc.'),(175968014565376,'WiesonTe','Wieson Technologies Co., Ltd.'),(175972225646592,'SamsungE','SAMSUNG ELECTRO-MECHANICS'),(175976101183488,'SktbSkit','SKTB SKiT'),(176001585774592,'Avaya','Avaya, Inc'),(176004454678528,'Copyrigh','Copyright Â© HiTi Digital, Inc.'),(176017893228544,'Triteka','Triteka LTD'),(176026432831488,'Shenzhen','Shenzhen Yidashi Electronics Co '),(176029620502528,'BertelSP','Bertel S.p.a.'),(176042203414528,'NimaxTel','NIMAX TELECOM CO.,LTD.'),(176066094170112,'SamsungE','Samsung Electronics Digital Imag'),(176066664595456,'Netgear',''),(176072637284352,'Telecomp','TeleComp R&D Corp.'),(176123505803264,'UnitedIn','United Integrated Services Co., '),(176156456255488,'IntelCor','Intel Corporate'),(176157815209984,'Comprehe','Comprehensive Power'),(176157982982144,'EttusRes','Ettus Research LLC'),(176172931481600,'PssBelgi','PSS Belgium N.V.'),(176197359108096,'Actionca','Actioncable, Inc.'),(176197828870144,'Samwonfa','SAMWONFA Co.,Ltd.'),(176203835113472,'NlMinist','NL Ministry of Defense'),(176206385250304,'TyanComp','Tyan Computer Corp'),(176251515961344,'Helixtec','Helixtech Corp.'),(176256935002112,'Nokia','Nokia Corporation'),(176273074683904,'Avaya','Avaya, Inc'),(176290657206272,'Pace','Pace plc'),(176305085612032,'VDSVideo','V.D.S. Video Display Systems srl'),(176311158964224,'GrandPro','Grand Products Nevada, Inc.'),(176313256116224,'Envinet','ENVINET GmbH'),(176324530405376,'Tmct','TMCT Co., LTD.'),(176325167939584,'Directv','DIRECTV, Inc.'),(176327382532096,'Melper','MELPER Co., Ltd.'),(176367429746688,'SiconSRL','Sicon s.r.l.'),(176375080157184,'WellavTe','Wellav Technologies Ltd'),(176377126977536,'Verilink','Verilink Corporation'),(176389676335104,'Rim',''),(176390162874368,'Intelcan','Intelcan Technosystems Inc.'),(176395649024000,'NanotekE','Nanotek Elektronik Sistemler Ltd'),(176410027098112,'Nokia','Nokia Corporation'),(176416620544000,'Cashmast','Cashmaster International Limited'),(176420009541632,'RancoreT','Rancore Technologies Private Lim'),(176426804314112,'SamsungE','Samsung Electronics Co.,Ltd'),(176440377081856,'Pantech','Pantech Co., Ltd.'),(176480726286336,'SamsungE','Samsung Electronics Co.,Ltd'),(176483544858624,'PTI','P.T.I Co.,LTD'),(176497872601088,'ChengduF','Chengdu Fuhuaxin Technology co.,'),(176501345484800,'SaehanHi','SAEHAN HITEC Co., Ltd'),(176507737604096,'IntelCor','Intel Corporate'),(176508995895296,'IntelCor','Intel Corporate'),(176516830855168,'HuizhouK','HuiZhou KaiYue Electronic Co.,Lt'),(176523508187136,'GerhardD','Gerhard D. Wempe KG'),(176525756334080,'XtremeTe','Xtreme Technologies Corp'),(176544060276736,'VeedimsL','VEEDIMS,LLC'),(176574779359232,'OpenvoxC','OpenVox Communication Co Ltd'),(176578671673344,'Shandong','Shandong Intelligent Optical Com'),(176584795357184,'TimeDoma','Time Domain'),(176590751268864,'TotalAvi','Total Aviation Solutions Pty Ltd'),(176614155485184,'DliTaiwa','DLI Taiwan Branch office'),(176640780926976,'Polytron','Polytron Vertrieb GmbH'),(176646854279168,'IntelCor','Intel Corporate'),(176656249520128,'Erathink','EraThink Technologies Corp.'),(176682069655552,'Shenzhen','ShenZhen Cando Electronics Co.,L'),(176694082142208,'HewlettP','Hewlett Packard'),(176702906957824,'Hongkong','HongKong THTF Co., Ltd'),(176705188659200,'Acutvist','Acutvista Innovation Co., Ltd.'),(176720405594112,'Skytap',''),(176723811368960,'PixonIma','Pixon Imaging'),(176744967438336,'Coresys',''),(176763103608832,'TritonEl','Triton Electronic Systems Ltd.'),(176776223391744,'Shenzhen','ShenZhen ANYK Technology Co.,LTD'),(176809979150336,'CeLink','CE LINK LIMITED'),(176812445401088,'Cisco','CISCO SYSTEMS, INC.'),(176866820358144,'Becker-A','Becker-Antriebe GmbH'),(176873581576192,'Polarlin','PolarLink Technologies, Ltd'),(176874890199040,'Sharp','SHARP Corporation'),(176875427069952,'Jsc\"Irbi','JSC \"Irbis-T\"'),(176892539830272,'AvtraceC','AVTrace Ltd.(China)'),(176894033002496,'AmicusSk','Amicus SK, s.r.o.'),(176895022858240,'DatSyste','DAT System Co.,Ltd'),(176906280370176,'StratecB','Stratec Biomedical AG'),(176926262034432,'NingboFr','Ningbo FreeWings Technologies Co'),(176933157470208,'Aircuve','AirCUVE Inc.'),(176937620209664,'Zte','zte corporation'),(176943207022592,'Apple',''),(176950572220416,'SeineIma','Seine Image Int`l Co., Ltd'),(176961628405760,'GeMedica','GE Medical System(China) Co., Lt'),(176968775499776,'Tp-LinkT','TP-LINK TECHNOLOGIES CO., LTD.'),(176969362702336,'AlcatelL','Alcatel Lucent IPD'),(176970251894784,'Nokia','Nokia Corporation'),(176971174641664,'Htc','HTC Corporation'),(177015214833664,'AvatAuto','AVAT Automation GmbH'),(180325007228928,'Abisyste','ABIsystems Co., LTD'),(180371127795712,'CarryTec','Carry Technology Co.,Ltd'),(180374718119936,'Cisco','CISCO SYSTEMS, INC.'),(180402819956736,'Luxul',''),(180411812544512,'WeiFangG','Wei Fang Goertek Electronics Co.'),(180419513286656,'HonHaiPr','Hon Hai Precision Ind. Co.,Ltd.'),(180424949104640,'Cisco','CISCO SYSTEMS, INC.'),(180439092297728,'FastecIm','Fastec Imaging Corporation'),(180454963544064,'Dell','Dell Inc.'),(180463956131840,'NortelNe','Nortel Networks'),(180470314696704,'OpenNetw','Open Networking Laboratory'),(180477528899584,'Flatfrog','FlatFrog Laboratories AB'),(180499070844928,'Bluesky',''),(180509019734016,'Masterwo','Masterwork Automodules'),(180542456725504,'Fibrlink','Fibrlink Communications Co.,Ltd.'),(180564652982272,'PlasticL','Plastic Logic'),(180622349828096,'EocTechn','EOC Technology'),(180624748969984,'AmtranVi','AmTRAN Video Corporation'),(180642381824000,'SunCupid','Sun Cupid Technology (HK) LTD'),(180646609682432,'Cisco','CISCO SYSTEMS, INC.'),(180655669379072,'Adaptive','Adaptive Wireless Solutions, LLC'),(180655736487936,'IntelCor','Intel Corporate'),(180664930402304,'BuswareD','busware.de'),(180673956544512,'AdbBroad','ADB Broadband Italia'),(180689727127552,'Mcot','MCOT Corporation'),(180690079449088,'Cisco','CISCO SYSTEMS, INC.'),(180706923773952,'Smart-El','smart-electronic GmbH'),(180715698257920,'Nintendo','Nintendo Co., Ltd.'),(180720244883456,'HewlettP','Hewlett Packard'),(180762389250048,'Apple','Apple, Inc.'),(180794383400960,'DftSyste','DFT System Co.Ltd'),(180843423203328,'Klinfo','KLINFO Corp'),(180846644428800,'Motorola','Motorola Mobility, Inc.'),(180847365849088,'VibicomC','VIBICOM COMMUNICATIONS INC.'),(180852818444288,'Chargest','ChargeStorm AB'),(180853002993664,'GlobalMi','Global Microwave Systems Inc.'),(180892932767744,'QElectro','Q Electronics Ltd'),(180938466131968,'ChinaGre','CHINA GREATWALL COMPUTER SHENZHE'),(180952542216192,'Cisco','CISCO SYSTEMS, INC.'),(180971584356352,'HitachiI','Hitachi Industrial Equipment Sys'),(180978228133888,'HuaweiTe','Huawei Technologies Co., Ltd'),(180979201212416,'FujianEl','FuJian Elite Power Tech CO.,LTD.'),(180985945653248,'Burrough','Burroughs Payment Systems, Inc.'),(181002185998336,'Autocrib','AutoCrib, Inc.'),(181016933171200,'CiscoSpv','Cisco SPVTG'),(181041713119232,'Shenzhen','Shenzhen Coship Electronics Co.,'),(181062936297472,'Ragsdale','Ragsdale Technology'),(181066023305216,'VitecGro','Vitec Group, Camera Dynamics Ltd'),(181069814956032,'MaestroW','Maestro Wireless Solutions ltd.'),(181080669814784,'Arantia2','Arantia 2010 S.L.'),(181082649526272,'Apple','Apple, Inc.'),(181084025257984,'Technico','Technicolor'),(181084109144064,'HZander','H. ZANDER GmbH & Co. KG'),(181087212929024,'AdaxysSo','Adaxys Solutions AG'),(181090484486144,'JscSdoCh','JSC SDO Chromatec'),(181110583590912,'PentaGes','PENTA Gesellschaft fÃ¼r elektron'),(181116623388672,'ParkingB','Parking BOXX Inc.'),(181122445082624,'Dell','Dell Inc.'),(181137578131456,'Eutrovis','EutroVision System, Inc.'),(181147879342080,'Shenzhen','ShenZhen Hitom Communication Tec'),(181148315549696,'Nintendo','Nintendo Co., Ltd.'),(181155999514624,'Hangzhou','Hangzhou LEAD-IT Information & T'),(181159052967936,'Apple',''),(181215743180800,'ErwinPet','Erwin Peters Systemtechnik GmbH'),(181219954262016,'Shenzhen','Shenzhen Skyee Optical Fiber Com'),(181221061558272,'Ecotalit','ECOtality North America'),(181221078335488,'Apple','Apple, Inc.'),(181229181730816,'GlitelSt','GLITEL Stropkov, s.r.o.'),(181249062731776,'Qualcomm','Qualcomm Labs Inc.'),(181257266790400,'Bionics','Bionics Corp.'),(181261276545024,'Kingspan','Kingspan Environmental Ltd'),(181274731872256,'TotalWal','Total Walther GmbH'),(181285838389248,'Filizola','FILIZOLA S.A. PESAGEM E AUTOMACA'),(181295636283392,'SiliconS','Silicon & Software Systems Ltd.'),(181297297227776,'DenyFont','DENY FONTAINE'),(181312866484224,'Nokia','Nokia Corporation'),(181315869605888,'Connex','Connex GmbH'),(181323067031552,'Sistemas','SISTEMAS AUDIOVISUALES ITELSIS S'),(181332764262400,'SamsungE','Samsung Electronics Co.,Ltd'),(181339122827264,'Motorola','Motorola Mobility, Inc.'),(181343568789504,'SeikoEps','SEIKO EPSON CORPORATION'),(181347779870720,'Telewave','Telewave Co., Ltd.'),(181366822010880,'OpenSour','Open Source Robotics Foundation,'),(181372744368128,'ChofuSei','CHOFU SEISAKUSHO CO.,LTD'),(181384253538304,'LanAcces','LAN Accessories Co., Ltd.'),(181400309334016,'Hangzhou','Hangzhou Dunchong Technology Co.'),(181405694820352,'Security','Security Expert Ltd.'),(184724395917312,'ImagoTec','IMAGO Technologies GmbH'),(184743723270144,'SamsungE','Samsung Electronics Co.,Ltd'),(184809439625216,'Tp-LinkT','TP-LINK TECHNOLOGIES CO.,LTD.'),(184815429091328,'LgElectr','LG Electronics'),(184818214109184,'Elektron','Elektronik System i UmeÃ¥ AB'),(184834320236544,'Xts','XTS CORP'),(184854033465344,'KryptonP','KRYPTON POLSKA'),(184857103695872,'Apple','Apple Inc'),(184884802879488,'Htc','HTC Corporation'),(184895322193920,'Precisio','Precision Optical Transceivers, '),(184906227384320,'ShinaSys','Shina System Co., Ltd'),(184927014354944,'WeiFangG','Wei Fang Goertek Electronics Co.'),(184963907452928,'Actionte','Actiontec Electronics, Inc'),(184993921892352,'DraginoT','Dragino Technology Co., Limited'),(185012175503360,'Nokia','Nokia Corporation'),(185018215301120,'FirichEn','Firich Enterprises CO., LTD.'),(185034254319616,'Lisantec','Lisantech Co., Ltd.'),(185081717063680,'WistronN','Wistron Neweb Corp.'),(185084804071424,'Pocketne','Pocketnet Technology Inc.'),(185111748280320,'Shenzhen','Shenzhen Dehoo Technology Co.,Lt'),(185112872353792,'Audivo','Audivo GmbH'),(185137417420800,'Cloudvie','Cloudview Limited'),(185141578170368,'Jiwumedi','JIWUMEDIA CO., LTD.'),(185146896547840,'Displair','DISPLAIRE CORPORATION'),(185147215314944,'TexasIns','Texas Instruments'),(185154731507712,'Dongguan','DONGGUAN YISHANG ELECTRONIC TECH'),(185175082270720,'Rim',''),(185201758044160,'Unicomm','UniComm Inc.'),(185224054964224,'FreetekI','FreeTek International Co., Ltd.'),(185230916845568,'Zonoff',''),(185247190745088,'Nokia','Nokia Corporation'),(185259974983680,'NokiaDan','Nokia Danmark A/S'),(185300223524864,'Broadban','Broadband Antenna Tracking Syste'),(185301750251520,'ArcWirel','ARC Wireless LLC'),(185302203236352,'Apple',''),(185323241865216,'Micromad','MicroMade Galka i Drozdz sp.j.'),(185345756889088,'LgElectr','LG Electronics'),(185353172418560,'JiangxiJ','JIANGXI JINGGANGSHAN CKING COMMU'),(185360856383488,'AkerSubs','Aker Subsea Ltd'),(185364513816576,'Apple',''),(185370184515584,'Ibm',''),(185374110384128,'Shinbo','Shinbo Co., Ltd.'),(185376626966528,'Aizo','aizo ag'),(185383941832704,'Inmotion','inMotion Ltd.'),(185462006218752,'Alcatel-','Alcatel-Lucent Shanghai Bell Co.'),(185476786946048,'Leoni',''),(185481719447552,'Cisco','CISCO SYSTEMS, INC.'),(185524585234432,'Apple','Apple, Inc.'),(185530138492928,'HoneyBee','Honey Bee (Hong Kong) Limited'),(185551747547136,'Tm-Resea','TM-Research Inc.'),(185592331632640,'EastBest','EAST BEST CO., LTD.'),(185605132648448,'Cvc',''),(185615148646400,'JuniperN','Juniper Networks'),(185620802568192,'Lightwar','Lightware Visual Engineering'),(185627547009024,'Wachendo','Wachendorff Elektronik  GmbH & C'),(185680428793856,'Nokia','Nokia Corporation'),(185696904019968,'SonyComp','Sony Computer Entertainment Inc.'),(185745088184320,'Tritonwa','Tritonwave'),(185759281709056,'SamsungE','Samsung Electronics'),(185767804534784,'FujianNe','Fujian Newland Communication Sci'),(185788658614272,'EltexEnt','Eltex Enterprise Ltd.'),(185795319169024,'Apple',''),(185797869305856,'WisesecL','WiseSec L.t.d'),(185803355455488,'Consolid','Consolidated Resource Imaging'),(186916976721920,'DigitalE','DIGITAL EQUIPMENT CORPORATION'),(186916993499136,'DigitalE','DIGITAL EQUIPMENT CORPORATION'),(186917010276352,'DigitalE','DIGITAL EQUIPMENT CORPORATION'),(186917027053568,'DigitalE','DIGITAL EQUIPMENT CORPORATION'),(186917043830784,'DigitalE','DIGITAL EQUIPMENT CORPORATION'),(189121402241024,'UrielTec','Uriel Technologies SIA'),(189128062795776,'RwTecnol','RW Tecnologia Industria e Comerc'),(189128599666688,'Comsis',''),(189142088548352,'Senselog','Senselogix Ltd'),(189160577040384,'LaborSRL','Labor S.r.L.'),(189176095965184,'Ekon-Myg','Ekon GmbH - myGEKKO'),(189203526713344,'Ataw','ATAW  Co., Ltd.'),(189205422538752,'Wi-Daq','wi-daq, inc.'),(189211244232704,'HewlettP','Hewlett Packard'),(189214817779712,'FibarGro','Fibar Group sp. z o.o.'),(189219716726784,'SeikoEps','SEIKO EPSON CORPORATION'),(189226041737216,'SungrowP','SUNGROW POWER SUPPLY CO.,LTD.'),(189256291057664,'Dmatek','DMATEK Co., Ltd.'),(189262213414912,'AsustekC','ASUSTek COMPUTER INC.'),(189320682012672,'Humannix','Humannix Co.,Ltd.'),(189329087397888,'Shenzhen','Shenzhen TG-NET Botone Technolog'),(189342744051712,'ShanhaiG','Shanhai GBCOM Communication Tech'),(189373882564608,'Apple',''),(189376717914112,'Nilan','Nilan A/S'),(189378076868608,'Instores','Instorescreen Aisa'),(189379955916800,'Hangzhou','HANGZHOU ZHIWAY TECHNOLOGIES CO.'),(189389334380544,'TaiyoYud','TAIYO YUDEN CO.,LTD'),(189394803752960,'C&TSolut','C&T Solution Inc.'),(189395743277056,'EclipseE','Eclipse Electronic Systems Inc.'),(189412117839872,'Revolabs','Revolabs Inc'),(189421529858048,'Genelec',''),(189438088970240,'HisenseB','Hisense Broadband Multimedia Tec'),(189441477967872,'JuniperN','Juniper Networks'),(189453440122880,'HuaweiTe','HUAWEI TECHNOLOGIES CO.,LTD'),(189459530252288,'Svs-Vist','SVS-VISTEK GmbH'),(189464781520896,'MpiTech','MPI TECH'),(189467885305856,'Cambridg','Cambridge Communication Systems '),(189480736653312,'IeeeP182','IEEE P1823 Standards Working Gro'),(189494946955264,'HumanAss','Human Assembler, Inc.'),(189515700371456,'PaceAmer','Pace Americas'),(189522075713536,'Utillink',''),(189533199007744,'Drivven','Drivven, Inc.'),(189558482272256,'RuckusWi','Ruckus Wireless'),(189588882587648,'Shenzhen','Shenzhen Gongjin Electronics Co.'),(189594066747392,'Enspert','Enspert Inc'),(189595878686720,'TatungTe','TATUNG Technology Inc.'),(189596382003200,'Valueplu','Valueplus Inc.'),(189606532218880,'LexkingT','Lexking Technology Co., Ltd.'),(189607924727808,'IntelCor','Intel Corporate'),(189641093283840,'Iconnect','iConnectivity'),(189646982086656,'IntelCor','Intel Corporate'),(189669346115584,'Hexatron','Hexatronic AB'),(189670352748544,'GemtekTe','Gemtek Technology Co., Ltd.'),(189674127622144,'Nokia','Nokia Corporation'),(189679026569216,'Shenzhen','Shenzhen Furtunetel Communicatio'),(189682667225088,'Immediat','ImmediaTV Corporation'),(189693471752192,'OpenMesh','Open Mesh, Inc.'),(189693639524352,'CreateNe','Create New Technology (HK) Limit'),(189712144793600,'RogerDWe','ROGER D.Wensker, G.Wensker sp.j.'),(189721925910528,'Smartrov','Smartrove Inc'),(189748148699136,'Nokia','Nokia Corporation'),(189751705468928,'Envision','Envision Peripherals Inc'),(189779941523456,'LantiqDe','Lantiq Deutschland GmbH'),(189783934500864,'SmakTecn','Smak Tecnologia e Automacao'),(189789840080896,'Alcatel-','Alcatel-Lucent Shanghai Bell Co.'),(189803563843584,'Cisco','CISCO SYSTEMS, INC.'),(189812522876928,'BaycityT','Baycity Technologies Ltd'),(189821179920384,'Peerless','Peerless AV'),(189852804972544,'LyngsoMa','Lyngso Marine A/S'),(189885117890560,'ArrisGro','ARRIS Group, Inc.'),(189927933345792,'Imac','IMAC CO.,LTD'),(189934006697984,'UfineTec','Ufine Technologies Co.,Ltd.'),(189935097217024,'Visualed','Visualedge Technology Co., Ltd.'),(189953183055872,'CltIntLI','CLT INT`L IND. CORP.'),(189968953638912,'KohzuPre','Kohzu Precision Co., Ltd.'),(189980177596416,'Ness','Ness Corporation'),(189984992657408,'TelldusT','Telldus Technologies AB'),(189985965735936,'OdaTechn','ODA Technologies'),(189986703933440,'Midokura','Midokura Co., Ltd.'),(189988029333504,'HefcomMe','Hefcom Metering (Pty) Ltd'),(189994555670528,'AxisComm','Axis Communications AB'),(190003162382336,'HwaYaoTe','HWA YAO TECHNOLOGIES CO., LTD'),(190005645410304,'Hi-Flyin','Hi-flying electronics technology'),(190015795625984,'Crexendo','Crexendo Business Solutions, Inc'),(190023915798528,'AbbAbbSa','ABB SPA, ABB SACE DIV.'),(190036582596608,'ShaanxiG','Shaanxi Guolian Digital TV Techn'),(190051598204928,'Tci','tci GmbH'),(190060255248384,'Shenzhen','Shenzhen Geniatech Inc, Ltd'),(190070690676736,'Private',''),(190087014907904,'HuaweiTe','Huawei Technologies Co., Ltd'),(190092165513216,'Madgetec','MadgeTech, Inc'),(190096024272896,'SkHynix','SK hynix'),(190105100746752,'Shenzhen','Shenzhen Baojia Battery Technolo'),(190114495987712,'HuaweiTe','Huawei Technologies Co., Ltd'),(190114546319360,'Bytemark','Bytemark Computer Consulting Ltd'),(190118858063872,'IotTech','IoT Tech Limited'),(190119579484160,'Hay','Hay Systems Ltd'),(190122800709632,'GenixInf','GENIX INFOCOMM CO., LTD.'),(190139192049664,'6harmoni','6harmonics Inc'),(190149778472960,'BeckerEl','Becker Electronics Taiwan Ltd.'),(190154828414976,'D-LinkIn','D-Link International'),(190158687174656,'Cisco',''),(190180933763072,'Xiaomi','XIAOMI CORPORATION'),(190187560763392,'Elesys','ELESYS INC.'),(193591406231552,'Dynamics','Dynamics Hong Kong Limited'),(193593067175936,'Futaba-K','Futaba-Kikaku'),(193600080052224,'Lightspe','LIGHTSPEED INTERNATIONAL CO.'),(193613954809856,'EdisonGl','EDISON GLOBAL CIRCUITS LLC'),(193632090980352,'OntrolAS','Ontrol A.S.'),(193636738269184,'Elim','Elim Co'),(193744045342720,'Nokia','Nokia Corporation'),(193755252523008,'Siliconw','Siliconware Precision Industries'),(193755906834432,'NanjingC','Nanjing CAS-ZDC IOT SYSTEM CO.,L'),(193803369578496,'Nuleds','NuLEDs, Inc.'),(193818922057728,'Mitrasta','MitraStar Technology Corp.'),(193825330954240,'Tp-LinkT','TP-LINK TECHNOLOGIES CO., LTD.'),(193840547889152,'Freseniu','Fresenius Medical Care Deutschla'),(193860797988864,'Shenzhen','SHENZHEN BASICOM ELECTRONIC CO.,'),(193864321204224,'HollTech','Holl technology CO.Ltd.'),(193895291944960,'Broadcas','Broadcast Microwave Services, In'),(193905408606208,'ThermoFi','THERMO FISHER SCIENTIFIC S.P.A.'),(193913025462272,'Nokia','Nokia Corporation'),(193949499129856,'Shanghai','Shanghai Railway Communication F'),(193951009079296,'Apple','Apple Inc'),(193981107404800,'3alityDi','3ality Digital Systems GmbH'),(194016758988800,'QaCafe','QA Cafe'),(194020131209216,'Zte','ZTE Corporation'),(194028033277952,'Motorola','Motorola Mobility, Inc.'),(194034744164352,'Revolv','Revolv Inc'),(194036220559360,'Motorola','Motorola Mobility LLC'),(194052561567744,'Dipl-Ing','Dipl.-Ing. H. Horstmann GmbH'),(194066151112704,'LaserLig','Laser Light Engines'),(194071721148416,'I-Sys','I-sys Corp'),(194098279481344,'StrataWo','Strata Worldwide'),(194104889704448,'Lge',''),(194124368052224,'Uradio','URadio Systems Co., Ltd'),(194134467936256,'FulanEle','Fulan Electronics Limited'),(194137689161728,'Taleo',''),(194163559628800,'E-Fuel','E-Fuel Corporation'),(194171847573504,'Fujitsu','Fujitsu Limited'),(194179263102976,'StemmerI','STEMMER IMAGING GmbH'),(194183323189248,'GnhSoftw','GNH Software India Private Limit'),(194205703995392,'Pivotal','Pivotal Systems Corporation'),(194232010670080,'Ensemble','Ensemble Designs, Inc.'),(194237446488064,'JuniperN','Juniper Networks'),(194245096898560,'Guangdon','GUANGDONG OPPO MOBILE TELECOMMUN'),(194256975167488,'Fujitsu','Fujitsu Limited'),(194282241654784,'ZyxelCom','Zyxel Communications Corporation'),(194283567054848,'SlicanSp','Slican Sp. z o.o.'),(194288348561408,'TexasIns','Texas Instruments'),(194307894018048,'NanjingN','Nanjing Nengrui Auto Equipment C'),(194327624024064,'Echostre','Echostreams Innovative Solutions'),(194328496439296,'ZakladEl','ZAKLAD ELEKTRONICZNY SIMS'),(194336952156160,'Wizitdon','WIZITDONGDO'),(194359735615488,'SamsungE','Samsung Electronics'),(194367033704448,'JuniperN','Juniper Networks'),(194369902608384,'Buffalo','Buffalo Inc.'),(194374096912384,'JiangsuC','Jiangsu Cynray IOT Co., Ltd.'),(194375942406144,'PeoplePo','People Power Company'),(194378861641728,'BeijingS','Beijing Symtech CO.,LTD'),(194399212404736,'Zhejiang','Zhejiang shenghui lighting co.,L'),(194404396564480,'Mi-ZoneT','MI-Zone Technology Ireland'),(194410016931840,'SamsungE','Samsung Electronics Co.,Ltd'),(194420100038656,'Vello','Vello Systems, Inc.'),(194491638087680,'CatSyste','CAT SYSTEM CO.,LTD.'),(194497828880384,'Nrg','NRG SYSTEMS INC'),(194507593220096,'2wire',''),(194512928374784,'SeikoEps','SEIKO EPSON CORPORATION'),(194516887797760,'Advanced','Advanced Micro Peripherals'),(194529554595840,'SamsungE','Samsung Electronics Co.,Ltd'),(194537406332928,'Azurewav','AzureWave Technologies, Inc.'),(194552287723520,'DhemaxIn','Dhemax Ingenieros Ltda'),(194591730958336,'Cisco',''),(194608139075584,'Private',''),(197914710245376,'Cablewor','CableWorld Ltd.'),(197917495263232,'GciScien','GCI Science & Technology Co.,LTD'),(197929675522048,'Smartchi','Smartchip Integrated Inc.'),(197946335297536,'SamsungE','SAMSUNG ELECTRO-MECHANICS'),(197947291598848,'TcCommun','TC Communications'),(197961384460288,'BrusaEle','Brusa Elektronik AG'),(197964253364224,'PaloAlto','Palo Alto Networks'),(197974739124224,'Heran',''),(197975913529344,'Lg-Erics','LG-Ericsson Co.,Ltd.'),(198000290824192,'Cisco','CISCO SYSTEMS, INC.'),(198002606080000,'HuaweiTe','HUAWEI TECHNOLOGIES CO.,LTD'),(198040656805888,'Internet','Internet Laboratories, Inc.'),(198054313459712,'BeijingG','Beijing GuangXin Technology Co.,'),(198056142176256,'DogHunte','Dog Hunter LLC'),(198087935000576,'E-Prime','E-Prime Co., Ltd.'),(198093437927424,'OrbitMer','ORBIT MERRET, spol. s r. o.'),(198104259231744,'DirectPa','Direct Payment Solutions Limited'),(198125633404928,'Aviwest',''),(198137243238400,'Matsunic','MATSUNICHI DIGITAL TECHNOLOGY (H'),(198141403987968,'FujianTi','Fujian Tian Cheng Electron Scien'),(198143870238720,'Zhejiang','Zhejiang Pearmain Electronics Co'),(198149406720000,'Consert','Consert, Inc.'),(198160496459776,'Procurve','ProCurve Networking by HP'),(198177072349184,'Degreane','Degreane Horizon'),(198193312694272,'Shenzhen','ShenZhen Gongjin Electronics Co.'),(198241765294080,'NrElectr','NR ELECTRIC CO., LTD'),(198264162877440,'NbSoftwa','NB Software'),(198265672826880,'SeagateT','Seagate Technology'),(198266377469952,'SonyMobi','Sony Mobile Communications AB'),(198279044268032,'Borea',''),(198291677511680,'CremoteL','CRemote, LLC'),(198309981454336,'Thing-Ta','Thing-talk Wireless Communicatio'),(198332983017472,'Lumigon','Lumigon A/S'),(198333939318784,'Exablox',''),(198335466045440,'SamsungE','Samsung Electronics Co.,Ltd'),(198358383722496,'QingdaoG','Qingdao GoerTek Technology Co., '),(198412976783360,'AskeyCom','askey computer corp'),(198459130904576,'Foresigh','Foresight Manufacture (S) Pte Lt'),(198471864811520,'Research','Research Products Corporation'),(198473743859712,'Relay2','Relay2, Inc.'),(198474700161024,'AskeyCom','Askey Computer Corp'),(198500771954688,'CosterTE','Coster T.E. S.P.A.'),(198549056782336,'Weteleco','WeTelecom Co., Ltd.'),(198566035324928,'Zte','zte corporation'),(198572343558144,'Hewlett-','Hewlett-Packard Company'),(198589422764032,'AxionTec','Axion Technologies Inc.'),(198594556592128,'Shenzhen','SHENZHEN TECHNOLOGY CO LTD'),(198619504312320,'ZenEye','Zen Eye Co.,Ltd'),(198620276064256,'Cisco','CISCO SYSTEMS, INC.'),(198623597953024,'Modi','MODI GmbH'),(198639452422144,'Avaya','Avaya, Inc'),(198643529285632,'Ensequen','Ensequence, Inc.'),(198647270604800,'MtmTechn','MtM Technology Corporation'),(198668393119744,'Avaya','Avaya, Inc'),(198682536312832,'Zte','ZTE Corporation'),(198690270609408,'HewlettP','Hewlett Packard'),(198692418093056,'MinsungE','Minsung Electronics'),(198695756759040,'IntelCor','Intel Corporate'),(198704732569600,'Thuh','Thuh Company'),(198755215212544,'VxlEtech','VXL eTech Pvt Ltd'),(198769358405632,'Motorola','Motorola Solutions Inc.'),(198771354894336,'UmpiElet','UMPI Elettronica'),(198804825440256,'Shenzhen','Shenzhen Jiuzhou Electric Co.,LT'),(198842641285120,'Betterbo','BetterBots'),(198843530477568,'IotaComp','iota Computing, Inc.'),(198861633093632,'Controlt','ControlThings Oy Ab'),(198870860562432,'Chromlec','Chromlech'),(198874065010688,'LitemaxE','Litemax Electronics Inc.'),(198877605003264,'Fusion-I','Fusion-io, Inc'),(198882403287040,'Private',''),(198915773169664,'Cisco',''),(198930419679232,'PieDigit','Pie Digital, Inc.'),(198931409534976,'WohlerTe','Wohler Technologies'),(198937851985920,'TexasIns','Texas Instruments'),(198945754054656,'Apple',''),(198955367399424,'Pace','Pace plc'),(198956357255168,'Petatel','PETATEL INC.'),(198996387692544,'SemaElec','SEMA Electronics(HK) CO.,LTD'),(199005363503104,'CentroSi','Centro Sicurezza Italia SpA'),(202323108298752,'IntelCor','Intel Corporate'),(202327671701504,'BayanAud','Bayan Audio'),(202360018173952,'RopexInd','ROPEX Industrie-Elektronik GmbH'),(202396357623808,'KeenHigh','Keen High Holding(HK) Ltd.'),(202405048221696,'Motorola','Motorola Mobility, Inc.'),(202412178538496,'Apple','Apple, Inc.'),(202420080607232,'Nesys',''),(202451454001152,'Guangzho','Guangzhou Horizontal Information'),(202465026768896,'MagnetiM','Magneti Marelli Slovakia s.r.o.'),(202465194541056,'SwedaInf','SWEDA INFORMATICA LTDA'),(202476905037824,'Furukawa','Furukawa Industrial S.A. Produto'),(202481585881088,'Raspberr','Raspberry Pi Foundation'),(202484270235648,'ParkerHa','Parker Hannifin'),(202490377142272,'BlasterT','Blaster Tech'),(202494219124736,'EfrEurop','EFR EuropÃ¤ische Funk-Rundsteuer'),(202501802426368,'Honeywel','Honeywell HomMed'),(202519116513280,'Road-Tra','Road-Track Telematics Developmen'),(202545691623424,'Videoswi','Videoswitch'),(202554046676992,'KyokkoTs','Kyokko Tsushin System CO.,LTD'),(202561311211520,'Worldpla','Worldplay (Canada) Inc.'),(202573441138688,'Shenzhen','Shenzhen Cultraview Digital Tech'),(202577920655360,'Roku','Roku, Inc'),(202590906220544,'Asp','ASP AG'),(202618404077568,'SanjetTe','SanJet Technology Corp.'),(202675480166400,'ZioncomE','Zioncom Electronics (Shenzhen) L'),(202688365068288,'Numera','NUMERA, INC.'),(202700830539776,'Ouya','Ouya, Inc'),(202700947980288,'HandaerC','Handaer Communication Technology'),(202715930034176,'SamsungE','Samsung Electronics Co.,Ltd'),(202724889067520,'OnnetTec','Onnet Technologies and Innovatio'),(202728613609472,'AcctonWi','Accton Wireless Broadband(AWB), '),(202731566399488,'Cisco','CISCO SYSTEMS, INC.'),(202738495389696,'Robotis','ROBOTIS, Co, Ltd'),(202742068936704,'CkTeleco','CK Telecom Ltd'),(202744921063424,'Bolymin','Bolymin, Inc.'),(202770288214016,'Toshiba',''),(202795269488640,'CompalIn','COMPAL INFORMATION (KUNSHAN) CO.'),(202808959696896,'Viessman','Viessmann Elektronik GmbH'),(202809546899456,'Converge','Convergence Technologies'),(202818002616320,'HonHaiPr','Hon Hai Precision Ind. Co.,Ltd.'),(202824512176128,'DecagonD','Decagon Devices, Inc.'),(202826307338240,'Apple',''),(202831944482816,'SecureMe','Secure Meters (UK) Limited'),(202890463412224,'GoodMind','Good Mind Industries Co., Ltd.'),(202892778668032,'StepAhea','Step Ahead Innovations Inc.'),(202898063491072,'CompalIn','COMPAL INFORMATION (KUNSHAN) CO.'),(202901939027968,'IljinEle','ILJIN ELECTRIC Co., Ltd.'),(202904455610368,'IntelCor','Intel Corporate'),(202916031889408,'Apple','Apple, Inc.'),(202920997945344,'Infinite','Infinite Technologies JLT'),(202924655378432,'Analytic','Analytica GmbH'),(202937691275264,'BgT&A','BG T&A'),(202949317885952,'RetailIn','Retail Innovation HTT AB'),(202956330762240,'Alldsp','AllDSP GmbH & Co. KG'),(202960189521920,'BiostarM','BIOSTAR Microtech Int`l Corp.'),(202965927329792,'Atlona','Atlona Inc.'),(202975540674560,'Oceanser','OceanServer Technology, Inc'),(202979231662080,'SmcNetwo','SMC Networks Inc'),(203012467326976,'D-LinkIn','D-Link International'),(203013977276416,'BenruiTe','BenRui Technology Co.,Ltd'),(203034630029312,'LogicSPA','Logic S.p.A.'),(203050736156672,'Dell','Dell Inc'),(203059309314048,'Nintendo','Nintendo Co., Ltd.'),(203063486840832,'Hewlett-','Hewlett-Packard Company'),(203073687388160,'Bt&Com','BT&COM CO.,LTD'),(203084005376000,'GioneeCo','Gionee Communication Equipment C'),(203099725627392,'2gigTech','2GIG Technologies'),(203106017083392,'Shenzhen','Shenzhen iBaby Labs, Inc.'),(203110748258304,'XiAnJizh','Xi`an Jizhong Digital Communicat'),(203110916030464,'Cynove',''),(203115127111680,'Eneres','ENERES Co.,Ltd.'),(203129387745280,'Cisco','CISCO SYSTEMS, INC.'),(203153815371776,'Primmcon','PRIMMCON INDUSTRIES INC'),(203162925400064,'SamsungE','Samsung Electronics Co.,Ltd'),(203165207101440,'Fiberhom','Fiberhome Telecommunication Tech'),(203166398283776,'Apple','Apple, Inc.'),(203170559033344,'Shanghai','Shanghai GBCOM Communication Tec'),(203178695983104,'DellPcba','Dell PCBA Test'),(203193074057216,'Penetek','Penetek, Inc'),(203193409601536,'MaxelerT','Maxeler Technologies Ltd.'),(203205354979328,'Guangzho','GUANGZHOU HKUST FOK YING TUNG RE'),(203223306600448,'MSevenSy','M Seven System Ltd.'),(203245603520512,'SamsungE','Samsung Electronics'),(203250485690368,'Strahlen','Strahlenschutz- Entwicklungs- un'),(203250586353664,'Advanced','Advanced Photonics, Inc.'),(203257297240064,'Iai','IAI Corporation'),(203295985500160,'PayterBv','Payter BV'),(203298602745856,'2wire',''),(203304306999296,'9solutio','9Solutions Oy'),(203311789637632,'Sonos','Sonos, Inc.'),(203334371770368,'YwireTec','YWire Technologies, Inc.'),(203361601191936,'Herrmann','Herrmann Ultraschalltechnik GmbH'),(203366282035200,'Waytools','WayTools, LLC'),(203369671032832,'Apple','Apple, Inc.'),(203371835293696,'AryakaNe','Aryaka Networks Inc'),(203375962488832,'Changshu','Changshu Gaoshida Optoelectronic'),(203380458782720,'SonyEric','Sony Ericsson Mobile Communicati'),(203397605097472,'Zhejiang','Zhejiang ROICX Microelectronics'),(203406983561216,'Apple','Apple, Inc.'),(203407218442240,'Shanghai','Shanghai Typrotech Technology Co'),(203409617584128,'TexasIns','Texas Instruments'),(206716775956480,'StewartA','Stewart Audio'),(206730784931840,'Avm','AVM GmbH'),(206766788837376,'TexasIns','Texas Instruments'),(206773331951616,'FortuneT','FORTUNE TECHGROUP CO.,LTD'),(206787072491520,'BeijingW','Beijing  WisVideo  INC.'),(206794102145024,'HitronTe','Hitron Technologies. Inc'),(206801165352960,'TaiwanJa','Taiwan Jantek Electronics,Ltd.'),(206804369801216,'Cisco',''),(206848376438784,'SamsungE','Samsung Electronics'),(206848745537536,'InspurSh','Inspur (Shandong) Electronic Inf'),(206871881318400,'HongKong','HONG KONG TECON TECHNOLOGY'),(206881159118848,'NextbitC','NextBIT Computing Pvt. Ltd.'),(206883575037952,'RowleyAs','Rowley Associates Limited'),(206896476717056,'RevogiIn','Revogi Innovation Co., Ltd.'),(206898590646272,'BearFlag','Bear Flag Design, Inc.'),(206915871178752,'Dell','Dell Inc.'),(206939661271040,'Hydro','Hydro Systems Company'),(206952227405824,'Pandachi','Pandachip Limited'),(206955784175616,'CsunSyst','CSUN System Technology Co.,LTD'),(206964525105152,'Apple',''),(206974792761344,'Accordan','Accordance Systems Inc.'),(206997945319424,'HangZhou','Hang Zhou Huite Technology Co.,l'),(207014739312640,'SamsungE','Samsung Electronics Co.,Ltd'),(207032338612224,'Sensingt','SensingTek'),(207044200103936,'CoreStaf','CORE STAFF CO., LTD.'),(207060339785728,'SwannCom','Swann Communications Pty Ltd'),(207063443570688,'Apple','Apple Inc'),(207120301555712,'AsrockIn','ASRock Incorporation'),(207131760394240,'TelenetP','Telenet Systems P. Ltd.'),(207152580919296,'Apple','Apple Inc'),(207152782245888,'Environi','Environics Oy'),(207163821654016,'Tdvine',''),(207164140421120,'TexasIns','Texas Instruments'),(207182612135936,'GreenEne','Green Energy Options Ltd'),(207196755329024,'Xtrillio','XTrillion, Inc.'),(207200781860864,'SamsungE','Samsung Electronics Co.,Ltd'),(207216300785664,'Rackspac','Rackspace US, Inc.'),(207216871211008,'Shenzhen','Shenzhen Huawei Communication Te'),(207220209876992,'IntelCor','Intel Corporate'),(207221954707456,'Sbm','SBM Co., Ltd.'),(207230779523072,'SamsungE','Samsung Electronics Co.,Ltd'),(207248563372032,'RadioDat','Radio Data Comms'),(207262756896768,'Ingate','Ingate Systems'),(207264803717120,'Basic','BASIC Co.,Ltd.'),(207273628532736,'Shenzhen','SHENZHEN CHUANGWEI-RGB ELECTRONI'),(207279936765952,'SamsungE','Samsung Electronics'),(207280859512832,'HonHaiPr','Hon Hai Precision Ind. Co.,Ltd.'),(207306612539392,'NppEliks','NPP ELIKS America Inc. DBA T&M A'),(207312920772608,'SamsungE','Samsung Electro Mechanics co.,LT'),(207337046409216,'Apple',''),(207354578599936,'Shenzhen','Shenzhen Gongjin Electronics Co.'),(207368470134784,'FonseeTe','FonSee Technology Inc.'),(207385264128000,'DascomEu','DASCOM Europe GmbH'),(207416335532032,'Nabto',''),(207437625819136,'Cyber-Ra','Cyber-Rain, Inc.'),(207458815442944,'AsustekC','ASUSTek COMPUTER INC.'),(207470559494144,'Sharp','SHARP CORPORATION'),(207472472096768,'SamsungE','Samsung Electronics'),(207499835736064,'Cybera','Cybera, Inc.'),(207510824812544,'Arec','AREC Inc.'),(207514717126656,'Kellendo','Kellendonk Elektronik GmbH'),(207538859540480,'DinboxSv','DinBox Sverige AB'),(207542382755840,'ThomsonV','Thomson Video Networks'),(207559025754112,'SpectraE','SPECTRA EMBEDDED SYSTEMS'),(207562263756800,'Nokia','Nokia Corporation'),(207567447916544,'CiscoSpv','Cisco SPVTG'),(207589811945472,'Voismart',''),(207600666804224,'Htc','HTC Corporation'),(207607830675456,'Tp-LinkT','TP-LINK TECHNOLOGIES CO.,LTD.'),(207626067509248,'D2dTechn','d2d technologies'),(207641267666944,'Asr','ASR Co,.Ltd.'),(207672892719104,'Eoslink',''),(207694401110016,'Waterwor','WATERWORLD Technology Co.,LTD'),(207713929789440,'Citycom','CityCom GmbH'),(207750504120320,'Devolo','devolo AG'),(207766979346432,'D-LinkIn','D-Link International'),(207801456525312,'Altronic','Altronic, LLC'),(207806288363520,'Topcon','TOPCON CORPORATION'),(211106232532992,'WesternD','Western Digital (may be reversed'),(211164181037056,'Additech','Additech, Inc.'),(211182031994880,'Fort-Tel','Fort-Telecom ltd.'),(211184649240576,'AlphaSec','Alpha Security Products'),(211193155289088,'HonHaiPr','Hon Hai Precision Ind. Co.,Ltd.'),(211211543117824,'HonHaiPr','Hon Hai Precision Ind. Co.,Ltd.'),(211237682020352,'PixaviAs','Pixavi AS'),(211253603598336,'Private',''),(211265246986240,'Avm','AVM GmbH'),(211276840042496,'BeijingN','Beijing National Railway Researc'),(211284255571968,'Audyssey','Audyssey Laboratories Inc.'),(211286403055616,'Xysystem',''),(211295143985152,'InesAppl','iNES. applied informatics GmbH'),(211297257914368,'ShenZhen','Shen Zhen Horn audio Co., Ltd.'),(211332590731264,'Gigaston','Gigastone Corporation'),(211337036693504,'Velocyte','Velocytech Aps'),(211350928228352,'NokiaDan','Nokia Danmark A/S'),(211362034745344,'MinicomD','Minicom Digital Signage'),(211372772163584,'Bskyb','BSkyB Ltd'),(211377050353664,'Netgear',''),(211377520115712,'Biscotti','Biscotti, Inc.'),(211389532602368,'LgElectr','LG Electronics Inc'),(211394012119040,'EpecOy','Epec Oy'),(211402098737152,'Shenzhen','Shenzhen Sinkna Electronics Co.,'),(211420788555776,'Maitrise','MAITRISE TECHNOLOGIQUE'),(211424060112896,'Tp-LinkT','TP-LINK TECHNOLOGIES CO.,LTD.'),(211441088987136,'Serelec',''),(211486991450112,'Pico','Pico Systems Co., Ltd.'),(211511821729792,'VStonkau','V. Stonkaus firma \"Kodinis Rakta'),(211511989501952,'Shenzhen','SHENZHEN HUAXUN ARK TECHNOLOGIES'),(211528934490112,'Cisco','CISCO SYSTEMS, INC.'),(211533917323264,'Apple',''),(211542591143936,'SamsungE','Samsung Electronics Co.,Ltd'),(211570340659200,'DobbsSta','Dobbs Stanford'),(211571917717504,'Magnemot','MagneMotion, Inc.'),(211648472154112,'Shenzhen','SHENZHEN XDK COMMUNICATION EQUIP'),(211662162362368,'EffigisG','Effigis GeoSolutions'),(211669041020928,'2wire',''),(211675215036416,'Apple','Apple, Inc.'),(211691874811904,'SndTech','SnD Tech Co., Ltd.'),(211702662561792,'RuckusWi','Ruckus Wireless'),(211705095258112,'SISistem','S I Sistemas Inteligentes EletrÃ'),(211709138567168,'Cisco',''),(211729841651712,'PatriotM','Patriot Memory'),(211729875206144,'Procurve','ProCurve Networking by HP'),(211778696904704,'Coby',''),(211790239629312,'Apple','Apple Inc'),(211796765966336,'Fairfiel','FAIRFIELD INDUSTRIES'),(211797151842304,'MultiTou','Multi Touch Oy'),(211797218951168,'EdenInno','Eden Innovations'),(211803845951488,'AbbottPo','Abbott Point of Care'),(211807989923840,'3dMassac','3D Systems Massachusetts'),(211808963002368,'Earthcam','EarthCam, Inc.'),(211838121803776,'OsasiTec','OSASI Technos Inc.'),(211846376194048,'Sagemcom',''),(211875987980288,'Comigo','Comigo Ltd.'),(211876491296768,'YoshikiE','Yoshiki Electronics Industry Ltd'),(211899476082688,'Bitbox','BitBox Ltd'),(211908955209728,'Applicat','Application Solutions (Electroni'),(211919088648192,'ZpaSmart','ZPA Smart Energy a.s.'),(211938382446592,'Cisco-Li','Cisco-Linksys, LLC'),(211946804609024,'Automati','Automatic Systems'),(211952877961216,'RuckusWi','Ruckus Wireless'),(211970695364608,'MitsuyaL','MITSUYA LABORATORIES INC.'),(211979050418176,'HonHaiPr','Hon Hai Precision Ind. Co.,Ltd.'),(211998025449472,'Creative','Creative Electronics & Software,'),(212000726581248,'Sagemcom',''),(212039884603392,'AskeyCom','Askey Computer Corp.'),(212044481560576,'Hangzhou','Hangzhou Sunyard Technology Co.,'),(212066006728704,'ConradEl','Conrad Electronic SE'),(212086055501824,'TexasIns','Texas Instruments'),(212091088666624,'DenxComp','DENX Computer Systems GmbH'),(212115080085504,'Sonicwal','Sonicwall'),(212175041855488,'HonHaiPr','Hon Hai Precision Ind. Co.,Ltd.'),(215509681307648,'Maxmedia','MaxMedia Technology Limited'),(215510654386176,'RuckusWi','Ruckus Wireless'),(215511543578624,'Seektech','SeekTech INC'),(215543873273856,'FujianSt','Fujian Star-net Communication Co'),(215550634491904,'Cisco','CISCO SYSTEMS, INC.'),(215568854548480,'HermesEl','Hermes electronic GmbH'),(215575313776640,'RuckusWi','Ruckus Wireless'),(215602962628608,'Prysm','Prysm Inc'),(215607324704768,'HonHaiPr','Hon Hai Precision Ind. Co.,Ltd.'),(215613985259520,'Dominion','Dominion Voting Systems Corporat'),(215615612649472,'Qualisys','Qualisys AB'),(215636584169472,'HmiSourc','HMI Sources Ltd.'),(215649368408064,'Kyocera','KYOCERA Corporation'),(215656649719808,'Whiznets','WhizNets Inc.'),(215659669618688,'Galvanic','Galvanic Applied Sciences Inc'),(215668158889984,'AiroWire','Airo Wireless'),(215693307936768,'Apple','Apple, Inc.'),(215739864711168,'Rustelet','Rusteletech Ltd.'),(215748337205248,'Tagatec','TAGATEC CO.,LTD'),(215750065258496,'SmcNetwo','SMC Networks Inc'),(215756054724608,'Siconix','Siconix Inc.'),(215762983714816,'CybelecS','CYBELEC SA'),(215769610715136,'Netgear',''),(215794440994816,'LgElectr','LG Electronics'),(215802359840768,'SambonPr','SAMBON PRECISON and ELECTRONICS'),(215805346185216,'HonHaiPr','Hon Hai Precision Ind. Co.,Ltd.'),(215814456213504,'SatcomDi','Satcom Direct, Inc.'),(215825596284928,'Fireflie','FIREFLIES SYSTEMS'),(215827542441984,'Omniprin','Omniprint Inc.'),(215842172174336,'Shenzhen','Shenzhen Shiningworth Technology'),(215866197147648,'QuantaCo','QUANTA COMPUTER INC.'),(215872136282112,'CadacHol','Cadac Holdings Ltd'),(215872606044160,'Bach-Sim','Bach-Simpson'),(215873646231552,'GalleonE','Galleon Embedded Computing'),(215885490946048,'Shenzhen','Shenzhen TATFOOK Technology Co.,'),(215888510844928,'FugooCoo','Fugoo Coorporation'),(215907334881280,'HdmiForu','HDMI Forum'),(215917736755200,'EverexEl','Everex Electronics Limited'),(215929111707648,'SamsungE','Samsung Electronics Co.,Ltd'),(215930890092544,'U-Raku','U-Raku, Inc.'),(215934094540800,'Cisco','CISCO SYSTEMS, INC.'),(215949697351680,'Libraton','Libratone A/S'),(215962615808000,'XiaomiTe','Xiaomi Technology,Inc.'),(215976473788416,'Datagrav','DataGravity'),(215990415654912,'FonTechn','Fon Technology S.L.'),(215993871761408,'Cisco','CISCO SYSTEMS, INC.'),(215998703599616,'SamsungE','Samsung Eletronics Co., Ltd'),(216033348550656,'BeijingJ','Beijing JoinHope Image Technolog'),(216035294707712,'Navis','NAVIS Inc.'),(216042475356160,'Cisco','CISCO SYSTEMS, INC.'),(216044572508160,'Motorola','Motorola Solutions Inc.'),(216045411368960,'ANSoluti','A.N. Solutions GmbH'),(216051098845184,'Inventek','Inventek Systems'),(216063681757184,'FujianNe','Fujian Newland Auto-ID Tech. Co,'),(216075643912192,'IntelCor','Intel Corporate'),(216092236578816,'SamsungE','Samsung Electronics Co.,Ltd'),(216135639236608,'8devices',''),(216135958003712,'100fioNe','100fio networks technology llc'),(216146947080192,'Shenzhen','SHENZHEN WEIJIU INDUSTRY AND TRA'),(216157197959168,'MinieumN','Minieum Networks, Inc'),(216237124616192,'SummitDe','SUMMIT DEVELOPMENT, spol.s r.o.'),(216247862034432,'Mediaedg','MEDIAEDGE Corporation'),(216281970114560,'GeneralE','General Electric Digital Energy'),(216305709875200,'I+MeActi','I+ME Actia Informatik und Mikro-'),(216335875309568,'National','National Oilwell Varco Instrumen'),(216360403599360,'BeijingH','Beijing HuaqinWorld Technology C'),(216375503093760,'Hangzhou','Hangzhou H3C Technologies Co., L'),(216385904967680,'BeijingB','Beijing Boomsense Technology CO.'),(216417110589440,'JiangsuJ','JiangSu Joyque Information Indus'),(216438551871488,'IntelCor','Intel Corporate'),(216441219448832,'NoblexSa','NOBLEX SA'),(216467190579200,'Ieee1904','IEEE 1904.1 Working Group'),(216472727060480,'U2s','U2S co.'),(216499604160512,'Scspro','SCSpro Co.,Ltd'),(216517404786688,'RrcnSas','RRCN SAS'),(216525306855424,'TexasIns','Texas Instruments'),(216529400496128,'VssMonit','VSS Monitoring'),(216530591678464,'Oclaro','Oclaro, Inc.'),(216553928785920,'SpicaInt','Spica international'),(216558626406400,'BrocadeC','Brocade Communications Systems, '),(216590436007936,'DishtvNz','DishTV NZ Ltd'),(219912391884800,'ItwGseAp','ITW GSE ApS'),(219913700507648,'BeijingN','Beijing Newmine Technology'),(219932792979456,'Tdsi',''),(219948110577664,'QuantaCo','Quanta Computer Inc.'),(219964451586048,'LeShiZhi','Le Shi Zhi Xin Electronic Techno'),(219964954902528,'Omnilync','OmniLync Inc.'),(220013843709952,'SamsungE','Samsung Electronics Co.,Ltd'),(220018256117760,'Dlogic','DLOGIC GmbH'),(220033556938752,'AdvSecur','ADV Security (S) Pte Ltd'),(220037180817408,'DellPcba','Dell Inc PCBA Test'),(220042146873344,'Storaged','Storagedata'),(220079123857408,'BarunEle','Barun Electronics'),(220083049725952,'Apple','Apple, Inc'),(220102377078784,'HalfaEnt','Halfa Enterprise Co., Ltd.'),(220117912780800,'HuntingI','Hunting Innova'),(220122627178496,'Apple','Apple, Inc.'),(220133045829632,'Ericsson','Ericsson, EAB/RWI/K'),(220152322850816,'TendaTec','Tenda Technology Co., Ltd.'),(220156886253568,'Jri-Maxa','JRI-Maxant'),(220166851919872,'Nokia','Nokia Corporation'),(220171180441600,'TexasIns','Texas Instruments'),(220171415322624,'Kunbus','KUNBUS GmbH'),(220199366164480,'ImkNetwo','IMK Networks Co.,Ltd'),(220199819149312,'Shanghai','Shanghai Enlogic Electric Techno'),(220215673618432,'MedisonX','MEDISON Xray Co., Ltd'),(220230706003968,'Cisco','CISCO SYSTEMS, INC.'),(220272850370560,'Intermas','Intermas France'),(220314642415616,'AsustekC','ASUSTek COMPUTER INC.'),(220335160950784,'Zte','zte corporation'),(220366685339648,'Display','Display Systems Ltd'),(220368446947328,'ZyxelCom','Zyxel Communications Corp'),(220369235476480,'Optcom','Optcom Co., Ltd.'),(220379553464320,'Apple',''),(220393159786496,'AplicomO','Aplicom Oy'),(220432133259264,'Zte','zte corporation'),(220438055616512,'Valink','Valink Co., Ltd.'),(220441192955904,'Shenzhen','Shenzhen Kingtech Communication '),(220445454368768,'SamsungE','Samsung Electronics Co.,Ltd'),(220470217539584,'SunriseT','Sunrise Technologies'),(220470452420608,'Beautifu','Beautiful Enterprise Co., Ltd'),(220483135995904,'NetOptic','Net Optics'),(220497228857344,'Dongguan','Dongguan HuaHong Electronics Co.'),(220500517191680,'Nolangro','Nolangroup S.P.A con Socio Unico'),(220521841033216,'PaktonTe','Pakton Technologies'),(220534860152832,'Mxchip','MXCHIP Company Limited'),(220535883563008,'Embedded','Embedded Automation, Inc.'),(220541503930368,'JiangsuD','Jiangsu Datang  Electronic Produ'),(220553533194240,'Nokia','Nokia Corporation'),(220572826992640,'Cisco','CISCO SYSTEMS, INC.'),(220576031440896,'Elitegro','ELITEGROUP COMPUTER SYSTEM CO., '),(220586332651520,'VdiiInno','VDII Innovation AB'),(220590325628928,'TexasIns','Texas Instruments'),(220596868743168,'Shenzhen','Shenzhen Longway Technologies Co'),(220596935852032,'Neul','Neul Ltd'),(220615826997248,'Nebula','Nebula, Inc'),(220619752865792,'VerizonB','Verizon Business'),(220620272959488,'Systroni','SYStronics Co., Ltd.'),(220633023643648,'Motorola','Motorola Mobility, LLC.'),(220635892547584,'Private',''),(220652267110400,'Shanghai','Shanghai TYD Elecronic Technolog'),(220655018573824,'MarcoSys','marco Systemanalyse und Entwickl'),(220673054081024,'Cisco-Li','Cisco-Linksys, LLC'),(220682784866304,'Apple','Apple, Inc.'),(220709024432128,'Embrane',''),(220713134850048,'Apple','Apple, Inc.'),(220718788771840,'D-LinkIn','D-Link International'),(220731891777536,'ZpmIndus','ZPM Industria e Comercio Ltda'),(220732260876288,'Ruggedte','RuggedTek Hangzhou Co., Ltd'),(220759456743424,'Zero1Tv','Zero1.tv GmbH'),(220777290924032,'HewlettP','Hewlett Packard'),(220784706453504,'Sagemcom',''),(220800158269440,'Nokia','Nokia Corporation'),(220801550778368,'HuaweiTe','Huawei Technologies Co., Ltd'),(220803480158208,'AgaitTec','AGAiT Technology Corporation'),(220807506690048,'JetlunSh','Jetlun (Shenzhen) Corporation'),(220811298340864,'D-LinkIn','D-Link International'),(220821415002112,'Shenzhen','Shenzhen Zowee Technology Co., L'),(220826162954240,'CiscoCon','Cisco Consumer Products, LLC'),(220854885548032,'LenovoMo','Lenovo Mobile Communication Tech'),(220857167249408,'IntegraN','Integra Networks, Inc.'),(220862183636992,'Nokia','Nokia Corporation'),(220868340875264,'Apple',''),(220871494991872,'Vertu','Vertu Corporation Limited'),(220924661989376,'TangtopT','TANGTOP TECHNOLOGY CO.,LTD'),(220927312789504,'Shenzhen','Shenzhen SHX Technology Co., Ltd'),(220929594490880,'BeijingG','Beijing Gefei Tech. Co., Ltd'),(220947797770240,'YamatoSc','Yamato Scale Co.,Ltd.'),(220948250755072,'Shenzhen','Shenzhen Xiaoniao Technology Co.'),(220950398238720,'Avaya','Avaya, Inc'),(220963249586176,'Building','Building Block Video'),(220964038115328,'IntelCor','Intel Corporate'),(220973936672768,'SenecaSR','Seneca s.r.l.'),(220975949938688,'Cisco','CISCO SYSTEMS, INC.'),(220980999880704,'CiscoSpv','Cisco SPVTG'),(220994052554752,'BejingDa','Bejing DAYO Mobile Communication'),(224302519549952,'BettiniS','BETTINI SRL'),(224319632310272,'G-WayMic','G-WAY Microwave'),(224320571834368,'SelectCo','Select Comfort'),(224322299887616,'SamsungE','Samsung Electronics Co.,Ltd'),(224338489901056,'Apple','Apple, Inc.'),(224342382215168,'Imaqliq','IMAQLIQ LTD'),(224355569106944,'Miljovak','Miljovakt AS'),(224360166064128,'CiscoSpv','Cisco SPVTG'),(224389056430080,'YichunMy','Yichun MyEnergy Domain, Inc'),(224405514878976,'Manzanit','Manzanita Systems, Inc.'),(224416235520000,'Zte','zte corporation'),(224433499275264,'Metrolog','Metrological Group BV'),(224446803607552,'Innodigi','InnoDigital Co., Ltd.'),(224464335798272,'VerifiLl','Verifi, LLC'),(224482908176384,'Micro-Bi','Micro-Biz intelligence solutions'),(224495994404864,'LgElectr','LG ELECTRONICS INC'),(224522552737792,'Sagemcom','SAGEMCOM SAS'),(224527317467136,'GewissSP','GEWISS S.P.A.'),(224529079074816,'Technico','Technicolor USA Inc.'),(224551107559424,'SamsungE','SAMSUNG ELECTRO MECHANICS CO., L'),(224559127068672,'SaSSDate','SA.S.S. Datentechnik AG'),(224568253874176,'HewlettP','Hewlett Packard'),(224591943303168,'TrumpSA','Trump s.a.'),(224605365075968,'Intercon','Intercon Systems Co., Ltd.'),(224626705694720,'Hellberg','Hellberg Safety AB'),(224635983495168,'BrocadeC','Brocade Communications Systems, '),(224644439212032,'KvhIndus','KVH Industries, Inc.'),(224645949161472,'OcomComm','Ocom Communications, Inc.'),(224655495397376,'Universa','Universal Global Scientific Indu'),(224659891027968,'HuaweiTe','HUAWEI TECHNOLOGIES CO.,LTD'),(224662642491392,'OntimeNe','OnTime Networks AS'),(224668346744832,'Rim',''),(224683664343040,'Toumaz','TOUMAZ LTD'),(224697471991808,'Weightec','Weightech Com. Imp. Exp. Equip. '),(224701112647680,'ZyxelCom','ZyXEL Communications Corporation'),(224701263642624,'Informat','Information  System Research Ins'),(224715826266112,'EmpowerR','Empower RF Systems'),(224754296422400,'GlobalTr','Global Traffic Technologies, LLC'),(224762483703808,'MinetecW','Minetec Wireless Technologies'),(224763976876032,'SoundMas','Sound Masking Inc.'),(224771207856128,'Roku','Roku, Inc.'),(224772533256192,'TjkTieto','TJK Tietolaite Oy'),(224808939814912,'Seetech',''),(224817361977344,'Apple',''),(224825163382784,'CmaxWire','CMAX Wireless Co., Ltd.'),(224829542236160,'Zte','zte corporation'),(224838165725184,'Motorola','Motorola Mobility, Inc.'),(224845413482496,'Panasoni','Panasonic AVC Networks Company'),(224905475915776,'TexasIns','Texas Instruments'),(224921313607680,'HansongT','Hansong Tehnologies'),(224923863744512,'TeConnec','TE Connectivity Touch Solutions'),(224937268740096,'Pfeiffer','Pfeiffer Vacuum GmbH'),(224947301515264,'Shenzhen','Shenzhen Huawei Communication Te'),(224978976899072,'Nintendo','Nintendo Co., Ltd.'),(225002397892608,'Guangdon','Guangdong Guanglian Electronic T'),(225006390870016,'ArrisGro','ARRIS Group, Inc.'),(225054004609024,'HonHaiPr','Hon Hai Precision Ind. Co.,Ltd.'),(225066302308352,'D-LinkIn','D-Link International'),(225073331961856,'FujitsuI','FUJITSU ISOTEC LIMITED'),(225079271096320,'Fraunhof','Fraunhofer ITWM'),(225092927750144,'AnbSecur','AnB Securite s.a.'),(225094689357824,'EagleKin','EAGLE KINGDOM TECHNOLOGIES LIMIT'),(225113010077696,'Steinel','Steinel GmbH'),(225118311677952,'Optilogi','OptiLogix BV'),(225129367863296,'AppliedT','Applied Technical Systems'),(225146648395776,'Shenzhen','SHENZHEN DAJIAHAO TECHNOLOGY CO.'),(225151497011200,'Tri-Syst','Tri-Systems Corporation'),(225162972626944,'CiasElet','CIAS Elettronica srl'),(225177854017536,'SunFount','Sun Fountainhead USA. Corp'),(225178709655552,'HuaweiTe','HUAWEI TECHNOLOGIES CO.,LTD'),(225182518083584,'Sm-Elect','SM-Electronic GmbH'),(225186209071104,'Janteq','Janteq Corp'),(225204915666944,'Shenzhen','Shenzhen Bopengfa Elec&Technolog'),(225216156401664,'Cisco',''),(225228370214912,'AiconnTe','Aiconn Technology Corporation'),(225236289060864,'ScrEngin','SCR Engineers Ltd.'),(225295059648512,'MySocial','My Social Stuff'),(225296250830848,'American','American Magnetics, Inc.'),(225299690160128,'SoyeaTec','SOYEA Technology Co.,Ltd.'),(225305864175616,'Dconwork','DCONWORKS  Co., Ltd'),(225326214938624,'DetoMech','Deto Mechatronic GmbH'),(225328077209600,'Cisco','CISCO SYSTEMS, INC.'),(225346817359872,'ChiMeiCo','Chi Mei Communication Systems, I'),(225348461527040,'EukreaEl','EUKREA ELECTROMATIQUE SARL'),(225358980841472,'AyeckaCo','Ayecka Communication Systems LTD'),(225366614474752,'Lumewave',''),(225369550487552,'XiAnHisu','Xi`an HISU Multimedia Technology'),(225371228209152,'Avaya','Avaya, Inc'),(225373711237120,'SamsungE','Samsung Electronics Co.,Ltd'),(225384532541440,'RizTrans','RIZ TRANSMITTERS'),(225385673392128,'Wireless','Wireless Technology, Inc.'),(225392300392448,'SamsungE','Samsung Electronics'),(228730899267584,'TexasIns','Texas Instruments'),(228761299582976,'PorscheC','Porsche Cars North America'),(228780526272512,'SunrexTe','Sunrex Technology Corp'),(228789854404608,'Zte','zte corporation'),(228798981210112,'SamsungE','Samsung Electronics Co.,Ltd'),(228812889522176,'Uniprint',''),(228821815001088,'BeijingC','Beijing Ctimes Digital Technolog'),(228847635136512,'SamsungE','Samsung Electro Mechanics co.,LT'),(228852416643072,'Apple','Apple, Inc.'),(228868204003328,'HonHaiPr','Hon Hai Precision Ind.Co.Ltd'),(228894695227392,'HuaweiTe','Huawei Technologies Co., Ltd'),(228909140410368,'IngenicS','Ingenic Semiconductor Co.,Ltd'),(228936269168640,'TexasIns','Texas Instruments'),(229002757275648,'Southwes','Southwest Research Institute'),(229028074094592,'Sintrone','SINTRONES Technology Corp.'),(229044582875136,'AsrockIn','ASRock Incorporation'),(229047955095552,'SonyMobi','Sony Mobile Communications AB'),(229053424467968,'Physical','Physical Graph Corporation'),(229059950804992,'Cambridg','Cambridge Industries(Group) Co.,'),(229073355800576,'Cisco','CISCO SYSTEMS, INC.'),(229074312101888,'Pantech','Pantech Co., Ltd.'),(229078338633728,'ActiveCo','Active Control Technology Inc.'),(229083942223872,'Ceramicr','CeraMicro Technology Corporation'),(229085217292288,'I-BtDigi','I-BT DIGITAL CO.,LTD'),(229109896577024,'HitachiD','Hitachi Data Systems'),(229126640238592,'Solidrun','SolidRun Ltd.'),(229138568839168,'SamsungE','Samsung Electronics Co., LTD'),(229144642191360,'Dell','Dell Inc'),(229152040943616,'LuminexL','LUMINEX Lighting Control Equipme'),(229194470522880,'Mini-Cir','Mini-Circuits'),(229194722181120,'DongOhPr','DONG OH PRECISION CO., LTD.'),(229195913363456,'LifiLabs','LIFI LABS MANAGEMENT PTY LTD'),(229204117422080,'RenoA&E','Reno A&E'),(229239131471872,'ForwardP','Forward Pay Systems, Inc.'),(229240255545344,'HewlettP','Hewlett Packard'),(229289396011008,'Apcon','APCON, Inc.'),(229297532960768,'PassifSe','Passif Semiconductor'),(229302750674944,'TexasIns','Texas Instruments'),(229303992188928,'Upwis','UPWIS AB'),(229333939519488,'Stonestr','Stonestreet One LLC'),(229364222394368,'Emtronix',''),(229398783459328,'Neuberge','Neuberger GebÃ¤udeautomation Gmb'),(229449702309888,'AlphaNet','Alpha Networks Inc.'),(229453091307520,'LinktopT','Linktop Technology Co., LTD'),(229468274688000,'Shenzhen','SHENZHEN TINNO MOBILE TECHNOLOGY'),(229474062827520,'RobertBo','Robert Bosch LLC Automotive Elec'),(229476831068160,'SeproRob','SEPRO ROBOTIQUE'),(229503724945408,'ShlTelem','SHL Telemedicine International L'),(229515200561152,'Cnslink','CNSLink Co., Ltd.'),(229530316832768,'SamsungE','Samsung Electronics Co.,Ltd'),(229533823270912,'Cisco','CISCO SYSTEMS, INC.'),(229555415547904,'Cisco',''),(229582661746688,'Scientec','Scientech Electronics'),(229589053865984,'EnergyMi','Energy Micro AS'),(229596016410624,'Cisco','CISCO SYSTEMS, INC.'),(229600663699456,'K2net','K2NET Co.,Ltd.'),(229602609856512,'BeckmanC','Beckman Coulter K.K.'),(229608884535296,'Mios','Mios, Ltd.'),(229609253634048,'AdbBroad','ADB Broadband Italia'),(229610847469568,'Mvtech','MVTECH co., Ltd'),(229620964130816,'Wintop',''),(229639855276032,'Nokia','Nokia Corporation'),(229658779975680,'LiteonTe','Liteon Technology Corporation'),(229659182628864,'GenieNet','Genie Networks Limited'),(229659534950400,'SamsungE','Samsung Electronics Co.,Ltd'),(229674567335936,'Yoga',''),(229677855670272,'Wearable','Wearable Inc.'),(229683257933824,'Pace','Pace plc'),(229692737060864,'Azurewav','Azurewave Technologies, Inc.'),(229707786223616,'ZhehuaTe','Zhehua technology limited'),(229710386692096,'Seowoo','Seowoo Inc.'),(229732884938752,'Ericsson',''),(229739931369472,'Steadyse','SteadyServ Technoligies, LLC'),(229760265355264,'HelmutMa','Helmut Mauell GmbH'),(229794977415168,'TexasIns','Texas Instruments, Inc'),(233096683192320,'PhoenixB','Phoenix Broadband Technologies, '),(233097924706304,'McTechno','MC Technologies GmbH'),(233101447921664,'Broadcom','Broadcom Corporation'),(233102588772352,'Tp-LinkT','TP-LINK TECHNOLOGIES CO.,LTD.'),(233106296537088,'Delphian','Delphian Systems LLC'),(233146813513728,'SolidSem','Solid Semecs bv.'),(233163875942400,'AppliedM','Applied Micro Electronics AME bv'),(233167600484352,'Inform','iNFORM Systems AG'),(233168657448960,'Huanshun','Huanshun Network Science and Tec'),(233173069856768,'Shotspot','ShotSpotter, Inc.'),(233176291082240,'AnobitTe','Anobit Technologies Ltd.'),(233176911839232,'Quadrant','Quadrant Components Inc. Ltd'),(233179931738112,'AsiaPaci','Asia Pacific Brands'),(233217193934848,'RcfSPA','RCF S.P.A.'),(233226203299840,'TohoElec','TOHO Electronics INC.'),(233229810401280,'TviVisio','TVI Vision Oy'),(233235732758528,'Htc','HTC Corporation'),(233243550941184,'LenovoMo','Lenovo Mobile Communication Tech'),(233265327767552,'Infopia','Infopia Co., Ltd'),(233271250124800,'Iobridge','ioBridge, Inc.'),(233276484616192,'Zimory','Zimory GmbH'),(233286467059712,'SkyLight','Sky Light Digital Limited'),(233347267690496,'IgrsEngi','IGRS Engineering Lab Ltd.'),(233349482283008,'Dongguan','DONGGUAN ipt INDUSTRIAL CO., LTD'),(233360186146816,'CarmaInd','Carma Industries Inc.'),(233360572022784,'Micro-St','Micro-Star Int`l Co, Ltd'),(233387046469632,'Changzho','Changzhou Haojie Electric Co., L'),(233420164694016,'TaiyoYud','TAIYO YUDEN CO., LTD.'),(233423486582784,'Vuppalam','Vuppalamritha Magnetic Component'),(233425499848704,'Shenzhen','Shenzhen YOOBAO Technology Co.Lt'),(233425684398080,'Informte','Informtekhnika & Communication, '),(233437914988544,'KemperDi','Kemper Digital GmbH'),(233442109292544,'CeivaLog','CEIVA Logic, Inc'),(233450011361280,'IbtIngen','IBT Ingenieurbureau Broennimann '),(233451185766400,'Nstreams','nSTREAMS Technologies, Inc.'),(233455883386880,'VigoSyst','VIGO System S.A.'),(233485998489600,'Galleon','Galleon Systems'),(233493481127936,'Wireless','Wireless Gigabit Alliance'),(233497004343296,'Nokia','Nokia Corporation'),(233530105790464,'ChengduU','CHENGDU USEE DIGITAL TECHNOLOGY '),(233537370324992,'RiedoNet','Riedo Networks GmbH'),(233542722256896,'Fiberhom','Fiberhome Telecommunication Tech'),(233554164318208,'SnapAv','Snap AV'),(233563526004736,'Goodrich','Goodrich ISR'),(233563978989568,'Csm','CSM GmbH'),(233570454994944,'HuaweiTe','Huawei Technologies Co., Ltd'),(233574313754624,'WaxessUs','WAXESS USA Inc'),(233619427688448,'Camerone','Cameronet GmbH & Co. KG'),(233626709000192,'HartingE','HARTING Electronics GmbH'),(233655851024384,'ArgosyTe','Argosy Technologies, Ltd.'),(233669373460480,'Hewlett-','Hewlett-Packard Company'),(233679909552128,'SamsungE','Samsung Electronics'),(233682996559872,'SamsungE','Samsung Electronics Co.,Ltd'),(233700797186048,'Cisco','CISCO SYSTEMS, INC.'),(233713497538560,'SogecamI','Sogecam Industrial, S.A.'),(233722171359232,'Electroa','Electroacustica General Iberica,'),(233730509635584,'FidelixO','Fidelix Oy'),(233733630197760,'Cosmo','COSMO CO., LTD'),(233734821380096,'TexasIns','Texas Instruments'),(233737019195392,'CloverNe','Clover Network, Inc.'),(233744451502080,'SungjinC','SUNGJIN C&T CO.,LTD'),(233758426923008,'Apple','Apple, Inc'),(233767151075328,'JaybirdG','JayBird Gear LLC'),(233768862351360,'Universi','University of FUKUI'),(233776898637824,'WuhanZho','Wuhan Zhongyuan Huadian Science '),(233784364498944,'Cisco','CISCO SYSTEMS, INC.'),(233801460482048,'SmaxTech','SMAX Technology Co., Ltd.'),(233803406639104,'InviewTe','InView Technology Corporation'),(233822985650176,'Greenwav','GreenWave Reality Inc'),(233830887718912,'MicroWor','MICRO WORLD'),(233836508086272,'BodiRsLl','BODi rS, LLC'),(233845165129728,'Dell','Dell Inc'),(233856942735360,'HuaweiTe','HUAWEI TECHNOLOGIES CO.,LTD'),(233916149530624,'Dell','Dell Inc'),(233917558816768,'SeContro','SE Controls Asia Pacific Ltd'),(233918934548480,'Upvel',''),(233929621635072,'Nokia','Nokia Corporation'),(233952874856448,'Acentic','Acentic GmbH'),(233963763269632,'HewlettP','Hewlett Packard'),(233965877198848,'Routerbo','Routerboard.com'),(233965893976064,'U-Blox','u-blox AG'),(233971279462400,'Nokia','Nokia Corporation'),(233984315359232,'Enatel','Enatel LTD'),(233996327845888,'AdbBroad','ADB Broadband Italia'),(233999632957440,'PowerEth','Power Ethernet'),(234011511226368,'Southwes','Southwest Microwave, Inc'),(234021091016704,'Cisco','CISCO SYSTEMS, INC.'),(234026728161280,'KoreaCno','Korea CNO Tech Co., Ltd'),(234055702413312,'Alpinion','Alpinion Medical Systems'),(234072160862208,'SSiedleS','S. Siedle & Sohne'),(234072479629312,'Alcatel-','Alcatel-Lucent'),(234095883845632,'SamsungE','Samsung Electronics'),(234101722316800,'Avaya','Avaya, Inc'),(234110278696960,'Harley-D','Harley-Davidson Motor Company'),(234118784745472,'Hiwifi','HIWIFI Co., Ltd.'),(234127911550976,'NavetasE','Navetas Energy Management'),(234130277138432,'NapcoSec','Napco Security Technologies'),(234132676280320,'Iproad','IPROAD.,Inc'),(234154084007936,'IeaSRL','IEA S.R.L.'),(237495803445248,'Apple',''),(237516758188032,'Skyviia','Skyviia Corporation'),(237523787841536,'Honeywel','Honeywell Fire System (Shanghai)'),(237532981755904,'ArcadiaN','Arcadia Networks Co. Ltd.'),(237536437862400,'Cercacor','Cercacor Labs'),(237554154602496,'FxiTechn','FXI TECHNOLOGIES AS'),(237589168652288,'NipponEl','Nippon Electro-Sensory Devices'),(237598312235008,'ContiTem','Conti Temic Microelectronic GmbH'),(237605341888512,'Telesqua','Telesquare'),(237614737129472,'Twinlinx','TWINLINX CORPORATION'),(237615106228224,'Compacta','Compacta International, Ltd.'),(237627085160448,'B&WGroup','B&W Group Ltd'),(237652301316096,'Cisco','CISCO SYSTEMS, INC.'),(237660824141824,'Guangdon','Guangdong Coagent Electronics S '),(237669682511872,'GeneralE','General Electric Consumer and In'),(237670974357504,'AscentCo','Ascent Communication Technology'),(237672853405696,'BestWish','Best Wish Technology LTD'),(237677014155264,'Nokia','Nokia Corporation'),(237690385596416,'Shenzhen','Shenzhen G.Credit Communication '),(237691560001536,'Tricasca','Tricascade Inc.'),(237702314196992,'Apple','Apple, Inc'),(237708437880832,'SamsungE','Samsung Electronics Co.,Ltd'),(237715685638144,'OfficeFa','Office FA.com Co.,Ltd.'),(237780865122304,'Shanghai','Shanghai Feixun Communication Co'),(237795259973632,'SiliconV','Silicon Valley Global Marketing'),(237808228761600,'HuaweiTe','HUAWEI TECHNOLOGIES CO.,LTD'),(237817338789888,'Cognitas','Cognitas Technologies, Inc.'),(237856261931008,'TexasIns','Texas Instruments'),(237872183508992,'SamsungE','Samsung Electronics'),(237895218626560,'Tp-LinkT','TP-LINK Technologies Co.,Ltd.'),(237896158150656,'CaxSoft','CAx soft GmbH'),(237919092604928,'Eno','Eno Inc.'),(237935920152576,'Shenzhen','Shenzhen Daystar Technology Co.,'),(237940533886976,'Cisco','CISCO SYSTEMS, INC.'),(237947093778432,'Steinsvi','Steinsvik'),(237958217072640,'Nintendo','Nintendo Co., Ltd.'),(237962277158912,'Sagemcom','SAGEMCOM SAS'),(237981302521856,'LenovoMo','Lenovo Mobile Communication Tech'),(237997878411264,'Nokia','Nokia Corporation'),(238001485512704,'Escort','Escort, Inc.'),(238013749657600,'KuhnSa','KUHN SA'),(238016484343808,'HonHaiPr','Hon Hai Precision Ind. Co., Ltd.'),(238088206942208,'Unit-Em',''),(238116879204352,'SamsungE','Samsung Electronics Co.,Ltd'),(238135250255872,'TexasIns','Texas Instruments'),(238140988063744,'Gopro',''),(238144041517056,'EmersonN','Emerson Network Power Embedded P'),(238144662274048,'C2Develo','C2 Development, Inc.'),(238170549518336,'HewlettP','Hewlett Packard'),(238171925250048,'Emegatec','eMegatech International Corp.'),(238174173396992,'Apple','Apple, Inc.'),(238191873359872,'Apple','Apple, Inc.'),(238244251828224,'ItibiaTe','Itibia Technologies'),(238247120732160,'Hangzhou','Hangzhou Bigbright Integrated co'),(238250174185472,'Panasoni','Panasonic Appliances Company'),(238251197595648,'Guangzho','Guangzhou Zonerich Business Mach'),(238251700912128,'JinanUsr','Jinan USR IOT Technology Co., Lt'),(238255425454080,'Panasoni','Panasonic Mobile Communications '),(238265307234304,'Htc','HTC Corporation'),(238279433650176,'Networka','NetworkAccountant, Inc.'),(238288912777216,'Nantwork','Nantworks'),(238289315430400,'TripleDo','Triple Domain Vision Co.,Ltd.'),(238316125421568,'VictoryC','Victory Concept Electronics Limi'),(238320890150912,'Netgenet','Netgenetech.co.,ltd.'),(238336241303552,'Detracom',''),(238347347820544,'HichanTe','Hichan Technology Corp.'),(238352565534720,'ArubaNet','Aruba Networks'),(238360434049024,'EaDispla','EA DISPLAY LIMITED'),(238395565539328,'Apple',''),(238398535106560,'JemaEner','JEMA ENERGY, SA'),(238402981068800,'Hewlett-','Hewlett-Packard Company'),(238406051299328,'Sony','Sony Corporation'),(238412443418624,'Rainfore','Rainforest Automation, Inc.'),(238415748530176,'GskCncEq','GSK CNC EQUIPMENT CO.,LTD'),(238432190201856,'ApatorSA','APATOR S.A.'),(238443313496064,'KunshanE','Kunshan Erlab ductless filtratio'),(238452507410432,'Beronet','beroNet GmbH'),(238472388411392,'CirtecMe','CIRTEC MEDICAL SYSTEMS'),(238487370465280,'OnpathTe','OnPATH Technologies'),(238487773118464,'Wush','Wush, Inc'),(238496614711296,'Keopsys',''),(238506362273792,'Trendnet','TRENDnet, Inc.'),(238529363836928,'Zeebo','Zeebo Inc'),(238587832434688,'Idfone','IDFone Co., Ltd.'),(238589241720832,'D-LinkIn','D-Link International'),(241902842544128,'Meditech','Meditech Kft'),(241903530409984,'Zte','zte corporation'),(241918009147392,'Nabtesco','Nabtesco  Corporation'),(241925860884480,'Hangzhou','HangZhou QiYang Technology Co.,L'),(241940238958592,'AdbBroad','ADB Broadband Italia'),(241955388784640,'CompalIn','COMPAL INFORMATION (KUNSHAN) CO.'),(241989765300224,'Medtroni','Medtronic Diabetes'),(241992852307968,'HitachiH','Hitachi High-Technologies Corpor'),(241993791832064,'Captivat','Captivate Network'),(242019779739648,'UBTech','U & B tech'),(242020668932096,'Microste','Microstep-MIS spol. s r.o.'),(242024141815808,'Accensus','Accensus LLC'),(242030131281920,'AsdElect','ASD Electronics Ltd'),(242073282281472,'Shanghai','Shanghai Longjing Technology Co.'),(242078869094400,'Apple','Apple, Inc.'),(242078952980480,'Infobloc','InfoBLOCK S.A. de C.V.'),(242080630702080,'Zera','Zera GmbH'),(242082174205952,'ItonTech','Iton Technology Limited'),(242091904991232,'Hct','HCT. Co., Ltd.'),(242101333786624,'Heyrex','Heyrex Limited'),(242112943620096,'Techsat','TechSAT GmbH'),(242132304527360,'HunanHkt','Hunan HKT Electronic Technology '),(242143243272192,'Roku','Roku, Inc'),(242151027900416,'Manufact','Manufacturing System Insights, I'),(242152470740992,'TicomGeo','Ticom Geomatics, Inc.'),(242160205037568,'SolbergA','Solberg & Andersen AS'),(242189296730112,'Motorola','Motorola Mobility, Inc.'),(242209462943744,'CascoSig','CASCO SIGNAL LTD'),(242231290101760,'ShinyeiT','SHINYEI TECHNOLOGY CO., LTD.'),(242266857799680,'Power-On','Power-One'),(242324135215104,'CRSIimot','C.R.S. iiMotion GmbH'),(242369299480576,'Livescri','Livescribe, Inc.'),(242369433698304,'BayStora','Bay Storage Technology'),(242373929992192,'Private',''),(242379030265856,'SamsungE','Samsung Electro Mechanics'),(242423322116096,'Cisco','CISCO SYSTEMS, INC.'),(242452430585856,'JanusSpo','JANUS, spol. s r.o.'),(242467513303040,'Azurewav','Azurewave Technologies., inc.'),(242558781358080,'Intercom','Intercom, Inc.'),(242563948740608,'Sapphire','Sapphire Technology Limited.'),(242578209374208,'Nokia','Nokia Corporation'),(242579132121088,'Ubiquiti','Ubiquiti Networks, Inc.'),(242605321355264,'Cisco',''),(242608693575680,'BeijingL','Beijing Lanbo Technology Co., Lt'),(242613458305024,'Compress','Compressor Controls Corp'),(242617585500160,'NewSpinG','New Spin Golf, LLC.'),(242620303409152,'IntelCor','Intel Corporate'),(242620706062336,'Macandc',''),(242639949529088,'Celoxica','CELOXICA Ltd'),(242649948749824,'BurkertW','Burkert Werke GmbH'),(242668940558336,'Microsof','Microsoft XCG'),(242715312783360,'HuizhouQ','HUIZHOU QIAOXING TELECOMMUNICATI'),(242720866041856,'Shenzhen','Shenzhen Kaiboer Technology Co.,'),(242721503576064,'SolidTec','SOLiD Technologies, Inc.'),(242734942126080,'Systemba','Systembase Limited'),(242767255044096,'ExploraT','Explora Technologies Inc'),(242778411892736,'FeGlobal','FE GLOBAL HONG KONG LIMITED'),(242784099368960,'BeijingR','Beijing Rongcheng Hutong Technol'),(242790055280640,'Bentek','Bentek Systems Ltd.'),(242798729101312,'HuaweiTe','HUAWEI TECHNOLOGIES CO.,LTD'),(242799349858304,'HumaxTld','HUMAX co.,tld'),(242808090787840,'SunnyHea','Sunny Heart Limited'),(242822401753088,'Shenzhen','Shenzhen JoinCyber Telecom Equip'),(242849429848064,'Akyllor',''),(242866106400768,'LumensDi','Lumens Digital Optics Inc.'),(242885165318144,'AugElekt','AUG Elektronik GmbH'),(242924910542848,'LettaTek','Letta Teknoloji'),(242954841096192,'Sitronik',''),(242959186395136,'LorentNe','Lorent Networks, Inc.'),(242969873481728,'StrongGe','STRONG Ges.m.b.H.'),(246315384569856,'Tp-LinkT','TP-LINK Technologies Co.,Ltd.'),(246320233185280,'HonHaiPr','Hon Hai Precision Ind. Co.,Ltd.'),(246338520350720,'Inovonic','Inovonics'),(246344274935808,'Nintendo','Nintendo Co., Ltd.'),(246377544155136,'Modoosis','Modoosis Inc.'),(246395680325632,'Fujitsu','Fujitsu Limited'),(246411954225152,'Aerohive','Aerohive Networks Inc.'),(246414856683520,'BravoTec','Bravo Tech, Inc.'),(246416148529152,'Cambridg','Cambridge Industries(Group) Co.,'),(246419571081216,'AniteTel','Anite Telecoms  US. Inc'),(246423916380160,'XslentEn','Xslent Energy Technologies. LLC'),(246447354150912,'HuaweiTe','HUAWEI TECHNOLOGIES CO.,LTD'),(246450457935872,'TitanPet','Titan Pet Products'),(246454618685440,'Intrigue','Intrigue Technologies, Inc.'),(246454719348736,'NortelNe','Nortel Networks'),(246458544553984,'TtcNext-','TTC Next-generation Home Network'),(246473174286336,'Universa','Universal Global Scientific Indu'),(246494296801280,'Cisco',''),(246496846938112,'Alcatel-','Alcatel-Lucent Shanghai Bell Co.'),(246504547680256,'SzTelsta','SZ Telstar CO., LTD'),(246539024859136,'Plexxi','Plexxi, Inc.'),(246549829386240,'Shenzhen','SHENZHEN JIAXINJIE ELECTRON CO.,'),(246558134108160,'Cavanagh','Cavanagh Group International'),(246558989746176,'Data-Com','data-complex GmbH'),(246593836023808,'Netgear',''),(246658210201600,'Emergent','Emergent Vision Technologies Inc'),(246671212544000,'LaerdalM','Laerdal Medical'),(246683325693952,'Innovid','Innovid, Co., Ltd.'),(246692821598208,'DetlefFi','Detlef Fink Elektronik & Softwar'),(246701730299904,'Cisco','CISCO SYSTEMS, INC.'),(246710202793984,'Hangzhou','HANGZHOU ZENOINTEL TECHNOLOGY CO'),(246713927335936,'JinanJov','Jinan Jovision Science & Technol'),(246719648366592,'SonyMobi','Sony Mobile Communications AB'),(246723238690816,'Digiview','DigiView S.r.l.'),(246735989374976,'C-DataTe','C-Data Technology Co., Ltd'),(246744075993088,'Pegatron','PEGATRON CORPORATION'),(246795212947456,'Motorola','Motorola Mobility LLC'),(246824824733696,'WhistleL','Whistle Labs, Inc.'),(246838347169792,'Evidence','EVIDENCE Network SIA'),(246846651891712,'Greenbyt','GreenBytes, Inc.'),(246873394774016,'Nata-Inf','Nata-Info Ltd.'),(246885424037888,'Exponent',''),(246908744368128,'Repotec','REPOTEC CO., LTD.'),(246914767388672,'XaviTech','XAVi Technologies Corp.'),(246917485297664,'Netgear',''),(246927987834880,'IntelCor','Intel Corporate'),(246932584792064,'Orthosof','ORTHOsoft inc, d/b/a Zimmer CAS'),(246965736570880,'IntelCor','Intel Corporate'),(246968001495040,'PlanexCo','PLANEX COMMUNICATIONS INC.'),(246984644493312,'NojaPowe','NOJA Power Switchgear Pty Ltd'),(246985701457920,'Sfr',''),(246990935949312,'Pevco',''),(247005448241152,'Nokia','Nokia Corporation'),(247023701852160,'GeneralV','GENERAL VISION ELECTRONICS CO. L'),(247029305442304,'OrbNetwo','Orb Networks, Inc.'),(247039505989632,'Alps','ALPS Co,. Ltd.'),(247041905131520,'Loenk',''),(247059152109568,'Fn-LinkT','FN-LINK TECHNOLOGY LIMITED'),(247079553204224,'Pace','Pace plc'),(247087941812224,'Azurewav','Azurewave'),(247088294133760,'Apple','Apple, Inc.'),(247099182546944,'C2Micros','C2 Microsystems, Inc.'),(247126076424192,'AisaiCom','Aisai Communication Technology C'),(247126898507776,'Masimo','Masimo Corporation'),(247132200108032,'Zte','ZTE Corporation'),(247144011268096,'Mildef','MilDef AB'),(247147937136640,'TexasIns','Texas Instruments'),(247154463473664,'JirehEne','Jireh Energy Tech., Ltd.'),(247155939868672,'Apple','Apple Inc'),(247159479861248,'Shenzhen','Shenzhen Unistar Communication C'),(247160671043584,'AskeyCom','Askey Computer'),(247162969522176,'Private',''),(247163791605760,'AsustekC','ASUSTek COMPUTER INC.'),(247178639441920,'AskeyCom','ASKEY COMPUTER CORP'),(247180417826816,'Gemintek','Gemintek Corporation'),(247188420558848,'Katouden','Katoudenkikougyousyo co ltd'),(247192111546368,'AliphDba','Aliph dba Jawbone'),(247217143152640,'TexasIns','Texas Instruments'),(247225330434048,'HippihAp','Hippih aps'),(247230598479872,'JvcKenwo','JVC KENWOOD Corporation'),(247232628523008,'Dell','Dell Inc'),(247238181781504,'SiemensE','Siemens Electrical Apparatus Ltd'),(247284101021696,'Nintendo','Nintendo Co., Ltd.'),(247290929348608,'OliveTel','Olive Telecommunication Pvt. Ltd'),(247308948078592,'Vastrive','vastriver Technology Co., Ltd'),(247311850536960,'Shenzhen','Shenzhen Friendcom Technology De'),(247313259823104,'Panasoni','Panasonic Automotive Systems Com'),(247317722562560,'LintesTe','Lintes Technology Co., Ltd.'),(247330271920128,'Digitalw','Digitalwatt'),(247336311717888,'Vaddio',''),(247346193498112,'Apple','Apple Inc'),(247346260606976,'ChengUei','CHENG UEI PRECISION INDUSTRY CO.'),(247356947693568,'Apple','Apple, Inc.'),(247363239149568,'Cloudena','Cloudena Corp.'),(247368305868800,'PlatanSp','Platan sp. z o.o. sp. k.'),(248541419143168,'Kingston','Kingston Technologies'),(250763192303616,'HewlettP','Hewlett Packard'),(250768259022848,'Topsyste','topsystem Systemhaus GmbH'),(250810168508416,'V2Techno','V2 TECHNOLOGY, INC.'),(250822113886208,'Ibm','IBM Corp'),(250851440459776,'Apple',''),(250851474014208,'Color-Ch','Color-Chip'),(250858050682880,'Smartlab','Smartlabs'),(250872579751936,'MagnetiM','Magneti Marelli S.p.A. Powertrai'),(250879072534528,'Lilee','Lilee Systems, Ltd.'),(250881958215680,'TctMobil','TCT Mobile Limited'),(250891152130048,'Fiberhom','Fiberhome Telecommunication Tech'),(250894641790976,'UnicoreC','Unicore communication Inc.'),(250906805272576,'SamsungE','Samsung Electronics Co.,Ltd'),(250918750650368,'Hangzhou','Hangzhou GoTo technology Co.Ltd'),(250920495480832,'SabreTec','Sabre Technology (Hull) Ltd'),(250928481435648,'HenriDep','HENRI DEPAEPE S.A.S.'),(250933229387776,'Advantag','Advantage Controls'),(250961951981568,'WuxiDspT','Wuxi DSP Technologies Inc.'),(250967320690688,'SamsungE','Samsung Electronics Co.,Ltd'),(250971682766848,'OttecTec','Ottec Technology GmbH'),(250992469737472,'C&CTechn','C&C TECHNIC TAIWAN CO., LTD.'),(251001227444224,'CiscoSpv','Cisco SPVTG'),(251024061235200,'Gardasof','Gardasoft VisionLimited'),(251028641415168,'MaLighti','MA Lighting Technology GmbH'),(251029547384832,'EdsElekt','EDS Elektronik Destek San.Tic.Lt'),(251057649221632,'Dedicate','Dedicated Computing'),(251058353864704,'SuttleAp','Suttle Apparatus'),(251065131859968,'StuartMa','Stuart Manufacturing, Inc.'),(251119372599296,'Motorola','Motorola Mobility, Inc.'),(251134153326592,'DanishIn','Danish Interpretation Systems A/'),(251138062417920,'HuaweiTe','HUAWEI TECHNOLOGIES CO.,LTD'),(251153061249024,'Messma','messMa GmbH'),(251176213807104,'Securifi','Securifi Ltd'),(251191665623040,'GetingeS','Getinge Sterilization AB'),(251201547403264,'Aartesys','AARTESYS AG'),(251203309010944,'MinrrayI','Minrray Industry Co.,Ltd'),(251225404604416,'SamsungE','Samsung Electronics Co., LTD'),(251227031994368,'BeijingH','Beijing Hanbang Technology Corp.'),(251245705035776,'Shenzhen','Shenzhen ACT Industrial Co.,Ltd.'),(251253858762752,'Motorola','Motorola Mobility, Inc.'),(251284930166784,'RfWindow','RF WINDOW CO., LTD.'),(251287782293504,'Apple',''),(251308888031232,'Rockwell','Rockwell Automation'),(251319591895040,'Gridlink','Gridlink Tech. Co.,Ltd.'),(251319927439360,'SamsungE','Samsung Electronics Co.,Ltd'),(251335815462912,'Altograp','ALTOGRAPHICS Inc.'),(251341217726464,'Shanghai','Shanghai VLC Technologies Ltd. C'),(251401330491392,'TronLink','TRON LINK ELECTRONICS CO., LTD.'),(251410155307008,'CellcoPa','Cellco Partnership'),(251424264945664,'UabSelte','UAB Selteka'),(251433777627136,'SclEleme','SCL Elements'),(251442971541504,'Hes-So',''),(251445119025152,'SamsungE','Samsung Electronics Co.,Ltd'),(251518754226176,'Objetivo','Objetivos y Servicios de Valor A'),(251542913417216,'MophieLl','Mophie, LLC'),(251547745255424,'CeiecEle','Ceiec Electric Technology Inc.'),(251575813537792,'Apple','Apple, Inc.'),(251598932541440,'Cisco',''),(251604502577152,'HonHaiPr','Hon Hai Precision Ind. Co.,Ltd.'),(251612555640832,'OrayaThe','Oraya Therapeutics'),(251639868948480,'En-Visio','En-Vision America, Inc.'),(251654028918784,'SamsungE','Samsung Electronics Co., LTD'),(251668054671360,'Leifheit','LEIFHEIT AG'),(251702531850240,'Nokia','Nokia Corporation'),(251715097985024,'Mr&DManu','MR&D Manufacturing'),(251734022684672,'Time-O-M','Time-O-Matic, Inc.'),(251736136613888,'Shanghai','Shanghai iComhome Co.,Ltd.'),(251752209186816,'Datafox','Datafox GmbH'),(251762879496192,'PadPerip','PAD Peripheral Advanced Design I'),(251787575558144,'Electron','ELECTRON INDIA'),(255102166237184,'SamsungE','Samsung Electronics CO., LTD'),(255104062062592,'Apple','Apple, Inc.'),(255105521680384,'Cisco','CISCO SYSTEMS, INC.'),(255107954376704,'Throught','Throughtek Co., Ltd.'),(255110001197056,'NortelNe','Nortel Networks'),(255114749149184,'Apple','Apple, Inc.'),(255134261051392,'AkibTaiw','Akib Systems Taiwan, INC'),(255139176775680,'Daeyoung','DAEYOUNG INFORMATION SYSTEM CO.,'),(255140200185856,'Syncbak','Syncbak, Inc.'),(255156188872704,'ReallySi','Really Simple Software, Inc'),(255160550948864,'SamsungE','Samsung Electronics CO., LTD'),(255168906002432,'Guangzho','GuangZhou Bonsoninfo System CO.,'),(255260492824576,'Tmy','TMY Co., Ltd.'),(255262069882880,'CotsTech','Cots Technology'),(255271012139008,'IntelCor','Intel Corporate'),(255284870119424,'OutOfFog','Out of the Fog Research LLC'),(255332399972352,'HewlettP','Hewlett Packard'),(255335252099072,'AskeyCom','Askey Computer'),(255338339106816,'OczTechn','OCZ Technology Group'),(255356039069696,'Rim',''),(255357196697600,'Geodesic','GEODESIC LTD.'),(255357213474816,'ArrisGro','ARRIS Group, Inc.'),(255362649292800,'Cisco','CISCO SYSTEMS, INC.'),(255365635637248,'Pegatron','PEGATRON CORPORATION'),(255377513906176,'Qnap','QNAP Systems, Inc.'),(255396455383040,'Advanced','Advanced Automotive Antennas'),(255421805756416,'EdupInte','EDUP INTERNATIONAL (HK) CO., LTD'),(255425161199616,'Nintendo','Nintendo Co., Ltd.'),(255436435488768,'Tsmart','TSMART Inc.'),(255437224017920,'YeonhabP','Yeonhab Precision Co.,LTD'),(255449689489408,'NeoInfor','NEO INFORMATION SYSTEMS CO., LTD'),(255459655155712,'Nctech','NCTech Ltd'),(255476046495744,'LlcEmzio','LLC Emzior'),(255479066394624,'LgElectr','LG ELECTRONICS INC'),(255481566199808,'ImagingD','Imaging Diagnostics'),(255491817078784,'Infratec','Infratec Datentechnik GmbH'),(255554211545088,'Supercom','Supercomputers and Neurocomputer'),(255556224811008,'Motorola','Motorola Mobility, Inc.'),(255556258365440,'DigitMob','Digit Mobile Inc'),(255556694573056,'ControlD','Control & Display Systems Ltd t/'),(255574394535936,'ElsysEqu','Elsys Equipamentos Eletronicos L'),(255591339524096,'FirsTech','FIRS Technologies(Shenzhen) Co.,'),(255604794851328,'BeoviewI','BEOVIEW INTERCOM DOO'),(255614760517632,'S5TechSR','S5 Tech S.r.l.'),(255640077336576,'GntekEle','GNTEK Electronics Co.,Ltd.'),(255675846361088,'ArrisGro','ARRIS Group, Inc.'),(255692959121408,'Apple',''),(255696398450688,'ZnyxNetw','ZNYX Networks, Inc.'),(255714165522432,'Arcontia','Arcontia International AB'),(255716514332672,'LgElectr','LG Electronics'),(255723627872256,'CogentHe','Cogent Healthcare Systems Ltd'),(255726479998976,'Tp-LinkT','TP-LINK TECHNOLOGIES CO.,LTD.'),(255745337589760,'PiigabPr','PiiGAB, Processinformation i Got'),(255747115974656,'Htc','HTC Corporation'),(255750521749504,'QuantaCo','Quanta Computer Inc.'),(255752400797696,'FujianLa','Fujian Landi Commercial Equipmen'),(255763272433664,'Toshiba',''),(255788455034880,'SignalPa','Signal Path International / Peac'),(255794310283264,'DeepSeaE','Deep Sea Electronics PLC'),(255825331355648,'Shenzhen','Shenzhen Reecam Tech.Ltd.'),(255862710992896,'Shenzhen','Shenzhen C&D Electronics Co.,Ltd'),(255873884618752,'Cisco','CISCO SYSTEMS, INC.'),(255887440609280,'Cisco','CISCO SYSTEMS, INC.'),(255890879938560,'SinoPrim','Sino Prime-Tech Limited'),(255904905691136,'Sagemcom',''),(255920609165312,'H-Displa','H-Displays (MSC) Bhd'),(255924753137664,'AustcoCo','Austco Communication Systems Pty'),(255961277136896,'Nokia','Nokia Corporation'),(255963709833216,'Micronet','Micronet  LTD'),(255967920914432,'HuaweiTe','Huawei Technologies Co., Ltd'),(255971561570304,'Skyhawke','SkyHawke Technologies, LLC.'),(255984245145600,'MksInstr','MKS Instruments Deutschland GmbH'),(255999428526080,'Ultimate','ULTIMATE Europe Transportation E'),(256025517096960,'ZhuhaiTi','Zhuhai Tianrui Electrical Power '),(256025852641280,'Videohom','VideoHome Technology Corp.'),(256040834695168,'Tp-LinkT','TP-LINK TECHNOLOGIES CO.,LTD.'),(256048535437312,'Prf','PRF Co., Ltd.'),(256051169460224,'Gravotec','GRAVOTECH MARKING SAS'),(256051840548864,'Toshiba',''),(256056856936448,'Energote','Energotest'),(256073835479040,'SamsungE','Samsung Electronics Co.,Ltd'),(256079673950208,'Alcatel-','Alcatel-Lucent'),(256080814800896,'Shenzhen','Shenzhen Kootion Technology Co.,'),(256085092990976,'Is5Commu','iS5 Communications Inc.'),(256095377424384,'DenkoviA','Denkovi Assembly Electroncs LTD'),(256124737552384,'Sagemcom','SAGEMCOM SAS'),(256156815589376,'RftechSr','RFTECH SRL'),(259548464021504,'ItechIns','ITECH INSTRUMENTS SAS'),(259553463631872,'EnanceSo','Enance Source Co., Ltd.	PC clone'),(259558295470080,'Flodesig','FloDesign Wind Turbine Corporati'),(259574770696192,'Biocontr','BioControl AS'),(259584316932096,'Tp-LinkT','TP-LINK TECHNOLOGIES CO., LTD.'),(259597906477056,'BelkinIn','Belkin International Inc.'),(259632232660992,'JiangsuN','JiangSu NanJing University Elect'),(259636091420672,'HuaweiTe','Huawei Technologies Co., Ltd'),(259636812840960,'Intelliv','IntelliVoice Co.,Ltd.'),(259674947452928,'Universi','University of Tokyo'),(259693335281664,'Cisco','CISCO SYSTEMS, INC.'),(259714625568768,'Apple`',''),(259742173757440,'Novelsat',''),(259755410980864,'Institut','Institute 706, The Second Academ'),(259772238528512,'AdlEmbed','ADL Embedded Solutions, Inc.'),(259776365723648,'Awcer','AWCER Ltd.'),(259776634159104,'ZyxelCom','ZyXEL Communications Corporation'),(259778781642752,'Cisco','CISCO SYSTEMS, INC.'),(259786532716544,'TtkSas','TTK SAS'),(259787270914048,'Meinberg','Meinberg Funkuhren GmbH & Co. KG'),(259790693466112,'RedwireL','Redwire, LLC'),(259800743018496,'QihanTec','Qihan Technology Co., Ltd'),(259812453515264,'ZaoNpkRo','ZAO NPK RoTeK'),(259846293159936,'Shanghai','Shanghai XiMei Electronic Techno'),(259853993902080,'HonHaiPr','Hon Hai Precision Ind. Co.,Ltd.'),(259881642754048,'Mitsubis','MITSUBISHI HEAVY INDUSTRIES MECH'),(259907328671744,'Global41','Global411 Internet Services, LLC'),(259913787899904,'EpboardD','ePBoard Design LLC'),(259926337257472,'B&WGroup','B&W Group LTD'),(259951268200448,'ChengduV','Chengdu Volans Technology CO.,LT'),(260019266256896,'JustoneT','Justone Technologies Co., Ltd.'),(260024249090048,'Mei',''),(260049196810240,'RmTech','RM Tech Co., Ltd.'),(260056763334656,'Apple','Apple, Inc.'),(260071258849280,'Tp-LinkT','TP-LINK TECHNOLOGIES CO., LTD.'),(260077265092608,'LenovoMo','Lenovo Mobile Communication Tech'),(260097531969536,'Dlx',''),(260112665018368,'EddyfiNd','Eddyfi NDT Inc'),(260116758659072,'Memmert+','MEMMERT GmbH + Co. KG'),(260131153510400,'2276427O','2276427 Ontario Inc'),(260139391123456,'LufftMes','Lufft Mess- und Regeltechnik Gmb'),(260140817186816,'BeijingR','Beijing Risbo Network Technology'),(260148115275776,'HewlettP','Hewlett Packard'),(260151990812672,'Nokia','Nokia Corporation'),(260166788317184,'EmersonN','Emerson Network Power and Embedd'),(260183129325568,'KemppiOy','Kemppi Oy'),(260208093822976,'Elitegro','ELITEGROUP COMPUTER SYSTEMS CO.,'),(260245054029824,'AcuroNet','Acuro Networks, Inc'),(260263223754752,'ShinanoE','SHINANO E and E Co.Ltd.'),(260290822275072,'Digivoic','Digivoice Tecnologia em Eletroni'),(260296643969024,'FusionEl','FUSION Electronics Ltd'),(260324578033664,'Accuener','Accuenergy (CANADA) Inc'),(260345918652416,'Cisco','CISCO SYSTEMS, INC.'),(260367041167360,'AlliedTe','Allied Telesis, Inc.'),(260378332233728,'Miraerec','MiraeRecognition Co., Ltd.'),(260379171094528,'GeaFarmT','GEA Farm Technologies GmbH'),(260384976011264,'ZhuhaiLi','Zhuhai Liming Industries Co., Lt'),(260417372815360,'Rami',''),(260418094235648,'IrtSa','IRT SA'),(260439250305024,'LampreyN','Lamprey Networks, Inc.'),(260449417297920,'SamsungE','Samsung electronics CO., LTD'),(260453947146240,'Cisco',''),(260469717729280,'Hirschma','Hirschmann Automation'),(260478022451200,'OmntecMf','Omntec mfg. inc'),(260485656084480,'SistemaS','SISTEMA SOLUCOES ELETRONICAS LTD'),(260485823856640,'Sti','STI Ltd'),(260489632284672,'GuangZho','Guang Zhou TRI-SUN Electronics T'),(260489816834048,'DarfonLi','DARFON LIGHTING CORP'),(260515771187200,'Abocom',''),(260525032210432,'Neomonta','NEOMONTANA ELECTRONICS'),(260529947934720,'Nokia','Nokia Corporation'),(260561338105856,'Ims','The IMS Company'),(260568501977088,'AEberle','A. Eberle GmbH & Co. KG'),(260577779777536,'Blueradi','BlueRadios, Inc.'),(263884921372672,'Janz-Con','Janz - Contadores de Energia, SA'),(263892102021120,'Chrontel',''),(263892588560384,'Smartebu','SmarteBuilding'),(263915103584256,'Shandong','Shandong Bittel Electronics Co.,'),(263921193713664,'SamsungE','Samsung Electronics Co.,Ltd'),(263967666601984,'Shenzhen','SHENZHEN FENDA TECHNOLOGY CO., L'),(264003368517632,'LgElectr','LG Electronics'),(264018870665216,'DellPcba','Dell Inc PCBA Test'),(264027158609920,'Cal-Comp','Cal-Comp Electronics & Communica'),(264033802387456,'ShowaDen','SHOWA DENKI CO.,LTD.'),(264037493374976,'OpusHigh','OPUS High Technology Corporation'),(264037543706624,'TalarisS','Talaris (Sweden) AB'),(264043617058816,'Cisco','CISCO SYSTEMS, INC.'),(264047274491904,'DrSigris','Dr. Sigrist AG'),(264051988889600,'MurataMa','Murata Manufactuaring Co.,Ltd.'),(264059572191232,'Cisco',''),(264064806682624,'WaldoNet','Waldo Networks, Inc.'),(264088278007808,'Bi2-Visi','Bi2-Vision'),(264121714999296,'HuikeEle','Huike Electronics (SHENZHEN) CO.'),(264133324832768,'OmegaEle','Omega Elektronik AS'),(264171442667520,'DvnShang','DVN(Shanghai)Ltd.'),(264201339666432,'PyramidC','PYRAMID Computer GmbH'),(264206691598336,'Scientif','Scientific Production Associatio'),(264208973299712,'JtechCom','JTECH Communications, Inc.'),(264216221057024,'Dell','Dell Inc.'),(264224173457408,'Private',''),(264261972525056,'Careview','CareView Communications'),(264269488717824,'SamsungE','Samsung Electronics Co.,Ltd'),(264284521103360,'Dycon','Dycon Limited'),(264285578067968,'Duracell','Duracell Powermat'),(264292322508800,'Getriebe','Getriebebau NORD GmbH and Co. KG'),(264303915565056,'Shenzhen','Shenzhen Egreat Tech Corp.,Ltd'),(264305861722112,'Procurve','ProCurve Networking by HP'),(264320290127872,'PrimaxEl','Primax Electronics Ltd.'),(264330859773952,'Integrat','Integrated Corporation'),(264345741164544,'SamsungE','Samsung Electronics Co.,Ltd'),(264374765748224,'SamsungE','Samsung Electronics Co.,Ltd'),(264379631140864,'Peak-Sys','PEAK-System Technik'),(264395586273280,'Sourcefi','Sourcefire, Inc'),(264397381435392,'Xcellen',''),(264414477418496,'HonHaiPr','Hon Hai Precision Ind. Co.,Ltd.'),(264421406408704,'D-Link','D-Link Corporation'),(264428452839424,'LeopoldK','Leopold Kostal GmbH &Co. KG'),(264439777460224,'IrzAutom','IRZ AUTOMATION TECHNOLOGIES LTD'),(264453098569728,'Zte','zte corporation'),(264484052533248,'Costel','COSTEL.,CO.LTD'),(264496350232576,'Veloclou','VeloCloud Networks'),(264510325653504,'HewlettP','Hewlett Packard'),(264515123937280,'Nxtconec','NxtConect'),(264517455970304,'GarlandT','Garland Technology'),(264555942903808,'Raonthin','RaonThink Inc.'),(264556714655744,'Aerohive','Aerohive Networks Inc'),(264579196125184,'Private',''),(264601727926272,'Gst','GST Co., Ltd.'),(264624276504576,'Hbc-Radi','HBC-radiomatic'),(264627128631296,'Globalsc','Globalscale Technologies, Inc.'),(264631473930240,'Xi3','Xi3 Corp'),(264657914822656,'Apple','Apple, Inc.'),(264668417359872,'PoslabTe','Poslab Technology Co., Ltd.'),(264693599961088,'MaxidPty','MaxID (Pty) Ltd'),(264698582794240,'Sipod','Sipod Inc.'),(264705662779392,'Sony','Sony Corporation'),(264717289390080,'Zhejiang','Zhejiang FeiYue Digital Technolo'),(264718094696448,'Mianyang','Mianyang Netop Telecom Equipment'),(264744132935680,'Leddarte','LeddarTech Inc.'),(264757370159104,'Apple','Apple, Inc.'),(264781764231168,'LinearLl','LINEAR LLC'),(264783274180608,'Apple',''),(264792904302592,'Sensomet','Sensometrix SA'),(264807936688128,'AxemaPas','Axema Passagekontroll AB'),(264821173911552,'RlhIndus','RLH INDUSTRIES,INC.'),(264824193810432,'Yottabyt','Yottabyte'),(264831475122176,'Apple','Apple Inc'),(264838169231360,'Shanghai','Shanghai EDO Technologies Co.,Lt'),(264839377190912,'Shanghai','ShangHai Y&Y Electronics Co., Lt'),(264840316715008,'WistronI','Wistron InfoComm (Kunshan)Co'),(264869609734144,'DrÃ¤gerwe','DrÃ¤gerwerk AG & Co. KG aA'),(264877042040832,'SamsungE','Samsung Electronics Co.,Ltd'),(264897359249408,'Essec',''),(264901201231872,'BilkonBi','Bilkon Bilgisayar Kontrollu Cih.'),(264908130222080,'Vipar','VIPAR GmbH'),(264913616371712,'HonHaiPr','Hon Hai Precision Ind. Co.,Ltd.'),(264923783364608,'Mobitec','Mobitec AB'),(264937976889344,'Adaptrum','Adaptrum Inc.'),(264940493471744,'Whitesky','Whitesky Science & Technology Co'),(264941114228736,'MotionAn','Motion Analysis Corporation'),(264945073651712,'Cisco','CISCO SYSTEMS, INC.'),(264946650710016,'Phorm',''),(264949049851904,'Keebox','KEEBOX, Inc.'),(264956381495296,'Ies','IES GmbH & Co. KG'),(264972101746688,'AcurixNe','Acurix Networks LP'),(268294275727360,'BenextBV','BeNeXt B.V.'),(268299292114944,'Valencet','ValenceTech Limited'),(268330548068352,'Research','Research In Motion'),(268347862155264,'Wavelink',''),(268375276126208,'Shanghai','Shanghai Pateo Electronic Equipm'),(268399502426112,'Apple',''),(268410323730432,'Simon-Ka','Simon-Kaloi Engineering'),(268414165712896,'Yamabish','YAMABISHI Corporation'),(268417235943424,'Cisco',''),(268418578120704,'Cucinial','Cuciniale GmbH'),(268455152451584,'SpectoPa','SPECTO PAINEIS ELETRONICOS LTDA'),(268516540284928,'AbilisSa','Abilis Systems SARL'),(268521690890240,'Shanghai','Shanghai Howell Electronic Co.,L'),(268544977666048,'FagIndus','FAG Industrial Services GmbH'),(268548752539648,'Shenzhen','Shenzhen Gongjin Electronics Co.'),(268549759172608,'BenuNetw','Benu Networks, Inc.'),(268564959330304,'SSResear','S & S Research Inc.'),(268574237130752,'Bnd','BND Co., Ltd.'),(268581166120960,'Portable','Portable Innovation Technology L'),(268586484498432,'NanjingR','Nanjing Rousing Sci. and Tech. I'),(268591282782208,'Amscreen','Amscreen Group Ltd'),(268620089262080,'ActionsS','Actions Semiconductor Co.,Ltd.(C'),(268628377206784,'Telechip','Telechips Inc'),(268633360039936,'Mellanox','Mellanox Technologies, Inc.'),(268642470068224,'Rockwell','Rockwell Automation'),(268648409202688,'Hengbao','HENGBAO Corporation LTD.'),(268648526643200,'HuaweiTe','Huawei Technologies Co., Ltd'),(268649667493888,'NicewayC','Niceway CNC Technology Co.,Ltd.H'),(268659901595648,'BoxxTv','Boxx TV Ltd'),(268692415840256,'CiscoSpv','Cisco SPVTG'),(268693003042816,'DqTechno','DQ Technology Inc.'),(268693372141568,'Panoptic','Panoptic Technology, Inc'),(268707263676416,'Diffon','Diffon Corporation'),(268749055721472,'AsustekC','ASUSTek COMPUTER INC.'),(268752780263424,'Zte','zte corporation'),(268778147414016,'Conversi','Conversion Sound Inc.'),(268788280852480,'Viltechm','Viltechmeda UAB'),(268806131810304,'Woojeon&','Woojeon&Handan'),(268808245739520,'Solidfir','SolidFire, Inc.'),(268810695213056,'SamsungE','Samsung Eletronics Co., Ltd'),(268827187216384,'Cisco','CISCO SYSTEMS, INC.'),(268835844259840,'Canon','CANON INC.'),(268862553587712,'Infoblox',''),(268890873528320,'Nokia','Nokia Corporation'),(268903238336512,'DecisoBV','Deciso B.V.'),(268918119727104,'NexgenSt','NexGen Storage'),(268918203613184,'Countmax','CountMax,  ltd'),(268940852854784,'WeberSch','WEBER Schraubautomaten GmbH'),(268965146263552,'SamsungE','Samsung Electronics'),(268990211424256,'HawaTech','Hawa Technologies Inc'),(269022809554944,'Cisco','CISCO SYSTEMS, INC.'),(269042724110336,'Lightnin','Lightning Telecommunications Tec'),(269051800584192,'Windowma','WindowMaster A/S'),(269059450994688,'YeastarT','Yeastar Technology Co., Ltd.'),(269067520835584,'TimeInte','TIME INTERCONNECT LTD'),(269070607843328,'HonHaiPr','Hon Hai Precision Ind. Co.,Ltd.'),(269094666371072,'ChengduJ','Chengdu jinshi communication Co.'),(269134847803392,'Blackned','blackned GmbH'),(269135871213568,'Shenzhen','Shenzhen Huawei Communication Te'),(269138035474432,'WeyElekt','WEY Elektronik AG'),(269152262553600,'FreeboxS','FREEBOX SA'),(269163721392128,'Vispiron','Vispiron Rotec GmbH'),(269166774845440,'Hewlett-','Hewlett-Packard Company'),(269217056161792,'SamsungE','Samsung Electronics CO., LTD'),(269227021828096,'BeijingC','Beijing CCD Digital Technology C'),(269229387415552,'ZhuhaiJi','Zhuhai Jiahe Communication Techn'),(269248312115200,'DeltaEle','Delta Elektronika BV'),(269272286756864,'SolarPow','Solar Power Technologies, Inc.'),(269287587577856,'Cisco','CISCO SYSTEMS, INC.'),(269295388983296,'Tp-LinkT','TP-LINK TECHNOLOGIES CO., LTD.'),(269317434245120,'Apple',''),(269335872405504,'Nokia','Nokia corporation'),(269351642988544,'Apple',''),(269364007796736,'TexasIns','Texas Instruments'),(272683497422848,'HuaweiTe','Huawei Technologies Co., Ltd'),(272692607451136,'Khomp',''),(272700828286976,'DrsImagi','DRS Imaging and Targeting Soluti'),(272729315999744,'Motorola','Motorola Mobility, Inc.'),(272729617989632,'DatangTe','Datang Telecom communication ter'),(272734500159488,'LgElectr','LG Electronics'),(272738644131840,'ZycastTe','ZyCast Technology Inc.'),(272744398716928,'WistronI','Wistron InfoComm(ZhongShan) Corp'),(272745522790400,'NaturalS','Natural Security SAS'),(272748525912064,'AtopiaLp','Atopia Systems, LP'),(272774782255104,'IntelCor','Intel Corporate'),(272792280891392,'Tp-LinkT','TP-LINK TECHNOLOGIES CO., LTD.'),(272805903990784,'Longdhua','Longdhua(Beijing) Controls Techn'),(272811474026496,'Apple','Apple, Inc'),(272827143946240,'CypressT','Cypress Technology CO., LTD.'),(272866922725376,'JiangsuS','Jiangsu Switter Co., Ltd'),(272880126394368,'Rtw','RTW GmbH & Co. KG'),(272882273878016,'EgaugeLl','eGauge Systems LLC'),(272883565723648,'HonHaiPr','Hon Hai Precision Ind. Co.,Ltd.'),(272887525146624,'Alcatel-','Alcatel-Lucent Telecom Limited'),(272890377273344,'Endeavou','endeavour GmbH'),(272899906732032,'GoodMind','Good Mind Innovation Co., Ltd.'),(272907909464064,'MagentaR','Magenta Research Ltd.'),(272910224719872,'GemtekTe','Gemtek Technology Co., Ltd.'),(272945154883584,'HuaweiTe','Huawei Technologies Co., Ltd'),(272966562611200,'YasudaJo','Yasuda Joho Co.,ltd.'),(272980286373888,'SyntecIn','SYNTEC Incorporation'),(272984581341184,'X2genDig','X2gen Digital Corp. Ltd'),(272990654693376,'Hitachi','Hitachi, Ltd.'),(273019645722624,'Cisco',''),(273024142016512,'Verathon',''),(273028604755968,'DenwaTec','Denwa Technology Corp.'),(273034812325888,'VnlEurop','VNL Europe AB'),(273073097932800,'M-Cube','M-Cube Spa'),(273087610224640,'Nokia','Nokia Corporation'),(273121030438912,'Cisco','CISCO SYSTEMS, INC.'),(273131751079936,'SeibuEle','Seibu Electric Co.,'),(273154802974720,'Arcx','Arcx Inc'),(273168476405760,'GoldmanS','The Goldman Sachs Group, Inc.'),(273172435828736,'Cisco',''),(273188290297856,'Neopis','Neopis Co., Ltd.'),(273208808833024,'FastwelI','FASTWEL INTERNATIONAL CO., LTD. '),(273209211486208,'Motorola','Motorola Mobility, Inc.'),(273209513476096,'AmpedWir','Amped Wireless'),(273233370677248,'Overkiz',''),(273280648871936,'KaishunE','KAISHUN ELECTRONIC TECHNOLOGY CO'),(273288483831808,'Tenebrae','Tenebraex'),(273291000414208,'Comtrend','COMTREND CORPORATION'),(273296453009408,'GoogleFi','Google Fiber, Inc'),(273302358589440,'GlpGerma','GLP German Light Products GmbH'),(273314320744448,'Volans',''),(273330896633856,'Daeshin-','DAESHIN-INFORMATION TECHNOLOGY C'),(273337439748096,'Fortress','Fortress Technology Inc'),(273353411657728,'ControlT','Control Technology Inc.'),(273364870496256,'YazakiEn','YAZAKI Energy System Corporation'),(273367101865984,'DinstarT','Dinstar Technologies Co., Ltd.'),(273408457703424,'Puissanc','PUISSANCE PLUS'),(273411343384576,'AxviewTe','Axview Technology (Shenzhen) Co.'),(273419446779904,'Deltenna','Deltenna Ltd'),(273440535740416,'DellPcba','Dell Inc PCBA Test'),(273458839683072,'Guangzho','Guangzhou CHNAVS Digital Technol'),(273503534186496,'JuniperN','Juniper Networks'),(273505950105600,'Highgate','Highgates Technology'),(273531300478976,'Carefusi','Carefusion'),(273575122567168,'SonyComp','Sony Computer Entertainment Inc.'),(273575407779840,'SamsungE','Samsung Electronics Co.,Ltd'),(273576817065984,'Tp-LinkT','TP-LINK TECHNOLOGIES CO., LTD.'),(273587957137408,'AxanNetw','AXAN Networks'),(273591060922368,'Pumatron','Pumatronix Equipamentos Eletroni'),(273603744497664,'SimmTron','Simm Tronic Limited'),(273605506105344,'RevRitte','REV Ritter GmbH'),(273618927878144,'Ecotech','EcoTech, Inc.'),(273618978209792,'BetaLase','Beta LaserMike'),(273619280199680,'TaishanO','Taishan Online Technology Co., L'),(273620756594688,'PnyTechn','PNY Technologies, INC.'),(273621612232704,'Htc','HTC Corporation'),(273625823313920,'Variscit','Variscite LTD'),(273639479967744,'Zte','ZTE Corporation'),(273662347313152,'Actionte','Actiontec Electronics, Inc'),(273674057809920,'ÎœtechTec','ÂµTech Tecnologia LTDA'),(273681355898880,'EgkerKft','Egker Kft.'),(273684073807872,'Dipl-Mat','Dipl.-Math. Michael Rauch'),(273699559178240,'ArrisGro','ARRIS Group, Inc.'),(273710011383808,'Rackware','RackWare Inc.'),(273711856877568,'OrionNet','Orion Networks International, In'),(273717024260096,'Motorola','Motorola Mobility LLC'),(273719775723520,'G-Lab','G-Lab GmbH'),(273743280603136,'Internat','International Communications Cor'),(273744018800640,'Syn-Tech','SYN-TECH SYSTEMS INC'),(273757709008896,'Santur','Santur Corporation'),(273771348885504,'Reciproc','Reciprocal Labs Corp'),(273772623953920,'Technico','Technico Japan Corporation'),(273775694184448,'Shenzhen','Shenzhen Communication Technolog'),(277077232189440,'ToshibaS','Toshiba Samsung Storage Technolg'),(277084664496128,'Fundacio','FUNDACION TEKNIKER'),(277103891185664,'Cortland','Cortland Research, LLC'),(277113286426624,'PrentkeR','Prentke Romich Company'),(277122044133376,'Motorola','Motorola Solutions Inc.'),(277145213468672,'SonyComp','Sony Computer Entertainment Inc.'),(277148820570112,'ControlS','Control Sistematizado S.A.'),(277152192790528,'Logic3','Logic3 plc'),(277178197475328,'Intercre','InterCreative Co., Ltd'),(277202977423360,'ISmartCi','I Smart Cities HK Ltd'),(277210493616128,'SamsungE','SAMSUNG ELECTRO-MECHANICS CO., L'),(277213295411200,'Eurecam',''),(277225576333312,'HanKyung','Han Kyung I Net Co.,Ltd.'),(277236900954112,'Apple','Apple, Inc.'),(277258728112128,'Connecte','Connected Data, Inc.'),(277275253669888,'LoromInd','Lorom Industrial Co.LTD.'),(277279867404288,'Calxeda','Calxeda, Inc.'),(277307113603072,'Favite','Favite Inc.'),(277308422225920,'Visteon','Visteon corp'),(277350382043136,'HenanLan','Henan Lanxin Technology Co., Ltd'),(277370648920064,'Universa','Universal Audio'),(277371554889728,'SwarcoLe','Swarco LEA d.o.o.'),(277374876778496,'JiangxiS','JIANGXI SHANSHUI OPTOELECTRONIC '),(277390177599488,'HuaweiTe','HUAWEI TECHNOLOGIES CO.,LTD'),(277402206863360,'SunplusT','Sunplus Technology Co., Ltd.'),(277411199451136,'Universa','Universal Global Scientific Indu'),(277422943502336,'SimexSpZ','SIMEX Sp. z o.o.'),(277432573624320,'ControlI','Control iD'),(277459081625600,'ShenZhen','Shen Zhen Shi Xin Zhong Xin Tech'),(277468376203264,'WeibelSc','Weibel Scientific A/S'),(277468409757696,'Mikrobit','MikroBits'),(277489649713152,'Zhejiang','Zhejiang Kangtai Electric Co., L'),(277496092164096,'NecPerso','NEC Personal Products, Ltd'),(277499682488320,'BeijingM','Beijing MDC Telecom'),(277524646985728,'Directed','Directed Perception, Inc'),(277541608751104,'Lxinstru','LXinstruments GmbH'),(277579810471936,'D-LinkIn','D-Link International'),(277583300132864,'Handream','Handreamnet'),(277613381681152,'FciUsaLl','FCI USA LLC'),(277640258781184,'TreiTech','Trei technics'),(277642137829376,'Avaya','Avaya, Inc'),(277676464013312,'Shenzhen','Shenzhen Gongjin Electronics Co.'),(277688929484800,'Pace','Pace plc'),(277694398857216,'Intellig','Intelligent Technology Inc.'),(277714397298688,'Ubivelox',''),(277716393787392,'Technico','Technicolor USA Inc.'),(277735251378176,'Cisco',''),(277762749235200,'Fidus','Fidus Systems Inc'),(277769460121600,'SamsungE','Samsung Electronics'),(277799575224320,'Avaya','Avaya, Inc'),(277805732462592,'Miartech','MIARTECH (SHANGHAI),INC.'),(277820211200000,'QtsNetwo','QTS NETWORKS'),(277830327861248,'Conemtec','Conemtech AB'),(277911177265152,'Atmel','Atmel Corporation'),(277932501106688,'SamsungE','Samsung Electronics Co.,Ltd'),(277938457018368,'Zte','ZTE Corporation'),(277956928733184,'Ascon','Ascon Ltd.'),(277967632596992,'Ibm','IBM Corp'),(277991523352576,'CocaCola','The Coca Cola Company'),(277991590461440,'MessanaA','Messana Air.Ray Conditioning s.r'),(277999224094720,'RobertBo','Robert Bosch GmbH'),(278020044619776,'Enervall','ENERVALLEY CO., LTD'),(278027544035328,'Shenzhen','Shenzhen WeWins wireless Co.,Ltd'),(278045747314688,'SichuanJ','Sichuan Jinwangtong Electronic S'),(278048649773056,'ClayPaky','CLAY PAKY SPA'),(278061937328128,'Nokia','Nokia Corporation'),(278075812085760,'Hangzhou','Hangzhou Lancable Technology Co.'),(278097941233664,'Arrayent',''),(278115456647168,'Optex-Fa','OPTEX-FA CO.,LTD.'),(278129868275712,'ZyxelCom','ZyXEL Communications Corporation'),(278145001324544,'IntelCor','Intel Corporate'),(278154815995904,'Shanghai','Shanghai Baud Data Communication'),(278159178072064,'Cisco','CISCO SYSTEMS, INC.'),(1100518260736,'Auspex-Systems-(',''),(541065216000,'Volkswag','Volkswagen Group of America'),(700062892032,'AbatecGr','abatec group AG'),(963884613632,'UltraEle','Ultra Electronics Limited (AEP N'),(4739680960512,'Adapteva','Adapteva, Inc.'),(13592900403200,'DoliElek','DOLI Elektronik GmbH'),(13860178231296,'Shanghai','Shanghai Magic Mobile Telecommun'),(18028712427520,'CoreBran','Core Brands LLC'),(22178439364608,'Armtel','Armtel Ltd.'),(22294705471488,'Avistel',''),(26809924059136,'Sagemcom','SAGEMCOM SAS'),(26933018492928,'Shenzhen','shenzhen kaism technology Co. Lt'),(31066974846976,'GemaltoM','Gemalto M2M GmbH'),(31111551909888,'SmgEnter','SMG ENTERPRISE, LLC'),(35234955395072,'HuaweiTe','HUAWEI TECHNOLOGIES CO.,LTD'),(35287686184960,'Shenzhen','Shenzhen Sunchip Technology Co.,'),(40015925084160,'CygSunri','CYG SUNRI CO.,LTD.'),(40132174413824,'Westcont','Westcontrol AS'),(44313627066368,'Luminato','Luminator'),(44619056283648,'SamhwaTe','Samhwa Telecom'),(44675897491456,'EtekTech','ETEK TECHNOLOGY (SHENZHEN) CO.,L'),(44782365704192,'SamsungE','Samsung Electronics Co.,Ltd'),(48744590475264,'Gainspee','Gainspeed, Inc.'),(48790610378752,'Pertroni','Pertronic Industries'),(49260741525504,'AqaviCom','Aqavi.com'),(57514964025344,'Io-Power','IO-Power Technology Co., Ltd.'),(57593229737984,'Boeing','The Boeing Company'),(57877888761856,'Terewave','Terewave. Inc.'),(57907081117696,'SamsungE','Samsung Electronics Co.,Ltd'),(61858904014848,'Ingenieu','Ingenieurbuero Stahlkopf'),(61962016784384,'BeijingZ','Beijing Zhongdun Security Techno'),(62164752662528,'OpticonS','Opticon Sensors Europe B.V.'),(62586548649984,'NovatekM','Novatek Microelectronics Corp.'),(66064817848320,'Tescom','TESCOM CO., LTD.'),(66387376603136,'JuniperN','Juniper Networks'),(66485657534464,'HonHaiPr','Hon Hai Precision Ind. Co.,Ltd.'),(75248011575296,'Iffu',''),(83651517743104,'TclTechn','TCL Technoly Electronics (Huizho'),(84438872489984,'Zte','zte corporation'),(88063992659968,'Cisco',''),(88131772612608,'Technart','TECHNART Co.,Ltd'),(88753485905920,'Wi2beTec','wi2be Tecnologia S/A'),(93068904628224,'NscCommu','NSC Communications Siberia Ltd'),(93179164491776,'Pegatron','PEGATRON CORPORATION'),(93438489919488,'Wiseware','WISEWARE, Lda'),(97184808697856,'TplSyste','TPL SYSTEMES'),(97455844622336,'LgElectr','LG Electronics'),(97572949590016,'Sigrand',''),(102106136576000,'Hangzhou','Hangzhou H3C Technologies Co., L'),(105710973091840,'JiangsuZ','Jiangsu Zhongxun Electronic Tech'),(106281918529536,'Merchand','Merchandising Technologies, Inc'),(110095111290880,'NipponDe','Nippon Denki Kagaku Co.,LTD'),(119136839532544,'TclTechn','TCL Technoly Electronics (Huizho'),(123250713559040,'HonHaiPr','Hon Hai Precision Ind. Co.,Ltd.'),(127607152574464,'Optowiz','Optowiz Co., Ltd'),(132325392252928,'HonHaiPr','Hon Hai Precision Ind.Co.,Ltd.'),(132876070813696,'NucomHk','NuCom HK Ltd.'),(136365798850560,'UltraEle','Ultra Electronics, CIS'),(141502411964416,'Elektron','ELEKTRON TECHNOLOGY UK LIMITED'),(145201117003776,'Shanghai','Shanghai GMT Digital Technologie'),(145252438507520,'Shenzhen','Shenzhen Excelsecu Data Technolo'),(149829766348800,'Nokia','Nokia Corporation'),(150051594698752,'GameTech','Game Technologies SA'),(153968319660032,'RemoteSo','Remote Solution'),(154134447652864,'IbaDosim','IBA Dosimetry GmbH'),(158820374413312,'Apple',''),(158851781361664,'Benchmar','Benchmark Electronics Romania SR'),(159094698672128,'Apple',''),(162778539098112,'HimaxTec','Himax Technologies, Inc'),(163261337042944,'Polewall','Polewall Norge AS'),(163686807240704,'WistronI','Wistron InfoComm(Kunshan)Co.,Ltd'),(167736894291968,'NoxusBei','NOXUS(BEIJING) TECHNOLOGY CO.,LT'),(168032827604992,'Shenzhen','Shenzhen Bolutek Technology Co.,'),(172215471439872,'ScleSfe','SCLE SFE'),(172519122272256,'Windusko','Winduskorea co., Ltd'),(176008783200256,'ParrotSa','PARROT SA'),(176231567851520,'HewlettP','Hewlett Packard'),(176743541374976,'SCAdd-Pr','S.C. ADD-PRODUCTION S.R.L.'),(180497074356224,'Shenzhen','Shenzhen YOUHUA Technology Co., '),(180909844201472,'ArkInfos','ARK INFOSOLUTIONS PVT LTD'),(181178329989120,'Cambridg','Cambridge Industries(Group) Co.,'),(185597431906304,'SaabPubl','Saab AB (publ)'),(189460503330816,'Pi-Coral','Pi-Coral Inc'),(189662501011456,'Apple',''),(193538004353024,'LiteonTe','Liteon Technology Corporation'),(194200066850816,'Apple',''),(198179370827776,'Viablewa','Viableware, Inc'),(198634368925696,'Histar',''),(198792175419392,'Prosyst',''),(203308014764032,'Apple',''),(206894664777728,'BeijingH','Beijing Haier IC Design Co.,Ltd'),(207363319529472,'Fiberhom','Fiberhome Telecommunication Tech'),(211266689826816,'Cisco',''),(211336013283328,'A&RTech','A&R TECH'),(211551550177280,'Cisco',''),(211796564639744,'D-LinkIn','D-Link International'),(211958900981760,'CiscoSpv','Cisco SPVTG'),(216137786720256,'Speedyte','Speedytel technology'),(216424828108800,'TercelTe','Tercel technology co.,ltd'),(219990254944256,'SamsungE','Samsung Electronics Co.,Ltd'),(224621974519808,'Fourtec-','Fourtec -Fourier Technologies'),(228888554766336,'Littlebi','littleBits Electronics, Inc.'),(229292550127616,'Skullcan','Skullcandy'),(229341707370496,'Pantech','Pantech Co., Ltd.'),(229372896215040,'Linkcom',''),(233840249405440,'Fiberhom','Fiberhome Telecommunication Tech'),(237662216650752,'Maxtroni','MaxTronic International Co., Ltd'),(242970628456448,'Buffalo','Buffalo Inc.'),(247040915275776,'Bender&A','Bender GmbH &amp; Co.KG'),(247043482189824,'Pluribus','Pluribus Networks, Inc.'),(255104145948672,'Private',''),(256000988807168,'BeijingB','Beijing BenyWave Technology Co.,'),(256108681756672,'Cisco',''),(259629145653248,'VidaboxL','VidaBox LLC'),(259669159313408,'Ypsomed','Ypsomed AG'),(259751183122432,'Performa','PERFORMANCE DESIGNED PRODUCTS, L'),(264450514878464,'AdbBroad','ADB Broadband Italia'),(268690620678144,'MatsufuE','Matsufu Electronics distribution'),(268979104907264,'EagleWor','EAGLE WORLD DEVELOPMENT CO., LIM'),(272770269184000,'Avaya','Avaya, Inc'),(272978138890240,'KonkaGro','Konka Group Co., Ltd.'),(272998841974784,'Innometr','Innometriks Inc'),(272999915716608,'HuaweiTe','HUAWEI TECHNOLOGIES CO.,LTD'),(273042596954112,'EciTelec','ECI Telecom Ltd.'),(273384852160512,'BeijingX','Beijing Xiaomi communications co'),(277083875966976,'Vievu',''),(277197172506624,'V-Zug','V-ZUG AG'),(119269232640,'OpenrbCo','OpenRB.com, Direct SIA'),(119269236736,'Goramo-J','GORAMO - Janusz Gorecki'),(119269240832,'Microsig','MicroSigns Technologies Inc'),(119269244928,'Intellvi','Intellvisions Software Ltd'),(119269253120,'Triax-Hi','TRIAX-HIRSCHMANN Multi-Media Gmb'),(119269257216,'EnergyAw','Energy Aware Technology'),(119269261312,'DalajEle','Dalaj Electro-Telecom'),(119269265408,'SolomonS','Solomon Systech Pte Ltd'),(119269269504,'MercuryH','Mercury HMI Ltd'),(119269277696,'QuantumT','Quantum Technology Sciences, Inc'),(119269281792,'Advanced','Advanced Scientific Concepts, In'),(119269285888,'VigorEle','Vigor Electric Corp'),(119269289984,'Simavita','Simavita Pty Ltd'),(119269294080,'SoftelSa','Softel SA de CV'),(119269298176,'OooNppMe','OOO NPP Mera'),(119269302272,'TokyoCos','Tokyo Cosmos Electric, Inc.'),(119269306368,'ZamirRec','Zamir Recognition Systems Ltd.'),(119269318656,'Energote','Energotechnica OOO NPP Ltd'),(119269322752,'CpacketN','cPacket Networks'),(119269330944,'DunlopCo','Dunlop Systems & Components'),(119269335040,'AbaElect','ABA ELECTRONICS TECHNOLOGY CO.,L'),(119269339136,'Commonwe','Commonwealth Scientific and Indu'),(119269343232,'Coolit','Coolit Systems, Inc.'),(119269347328,'Rose+Her','Rose + Herleth GbR'),(119269355520,'SaturnSo','Saturn Solutions Ltd'),(119269359616,'Momentum','Momentum Data Systems'),(119269363712,'Openpeak','Openpeak, Inc'),(119269367808,'CjscStcS','CJSC STC  SIMOS'),(119269371904,'MagoDiDe','MAGO di Della Mora Walter'),(119269376000,'AnnecyEl','ANNECY ELECTRONIQUE SAS'),(119269380096,'Andersen','andersen lighting GmbH'),(119269384192,'DimepSis','DIMEP Sistemas'),(119269388288,'CameaSpo','CAMEA, spol. s r.o.'),(119269392384,'Stechwin','STECHWIN.CO.LTD.'),(119269396480,'2FranceM','2 FRANCE MARINE'),(119269400576,'Analytic','Analytical Instrument Systems, I'),(119269404672,'SaturnSo','Saturn South Pty Ltd'),(119269408768,'CareEver','Care Everywhere LLC'),(119269412864,'Ddtronik','DDTRONIK Dariusz Dowgiert'),(119269416960,'BettiniS','BETTINI SRL'),(119269421056,'Fibrain','Fibrain Co. Ltd.'),(119269425152,'Octogate','OctoGate it Security Systems Gmb'),(119269429248,'Adixein','ADIXEIN LIMITED'),(119269433344,'OsborneC','Osborne Coinage Co'),(119269437440,'JeSuunni','JE Suunnittelu Oy'),(119269441536,'Intercel','InterCEL Pty Ltd'),(119269445632,'Rtls','RTLS Ltd.'),(119269449728,'LomarSrl','LOMAR SRL'),(119269453824,'ItwReyfl','ITW Reyflex North America'),(119269457920,'SeedInte','SEED International Ltd.'),(119269462016,'EuresysS','EURESYS S.A.'),(119269466112,'Mindmade','MindMade Sp. z o.o.'),(119269470208,'Promixis','Promixis, LLC'),(119269474304,'Xiphos','Xiphos Systems Corp.'),(119269478400,'Rioxo','rioxo GmbH'),(119269482496,'Daylight','Daylight  Solutions, Inc'),(119269486592,'Eltrade','ELTRADE Ltd'),(119269490688,'OooActid','OOO Actidata'),(119269494784,'DesignaE','DesignA Electronics Limited'),(119269498880,'Chamsys','ChamSys Limited'),(119269502976,'Coincide','Coincident, Inc.'),(119269507072,'Zao&Quot','ZAO &quot;RADIUS Avtomatika&quot'),(119269511168,'MarvelDi','Marvel Digital International Lim'),(119269515264,'Trans-Eu','Trans-European Research and Educ'),(119269519360,'PtAmanin','PT. Amanindo Nusapadu'),(119269523456,'Xpossibl','XPossible Technologies Pte Ltd'),(119269527552,'Eurocont','EUROCONTROL S.p.A.'),(119269531648,'CertisTe','Certis Technology International '),(119269535744,'SiliconC','Silicon Controls'),(119269539840,'RhinoCon','Rhino Controls Ltd.'),(119269543936,'EirakuEl','eiraku electric corp.'),(119269548032,'Messung','Messung Systems'),(119269552128,'Orbital','Orbital Systems, Ltd.'),(119269556224,'Teliswit','TeliSwitch Solutions'),(119269560320,'QqNaviga','QQ Navigation AB'),(119269564416,'Engineer','Engineering Center ENERGOSERVICE'),(119269568512,'Metrycom','Metrycom Communications Ltd'),(119269576704,'Lumiplan','LUMIPLAN TRANSPORT'),(119269580800,'ThinkomS','ThinKom Solutions, Inc'),(119269584896,'EreeElec','EREE Electronique'),(119269588992,'Optimeas','optiMEAS GmbH'),(119269593088,'Inpixal',''),(119269597184,'PostecDa','POSTEC DATA SYSTEMS'),(119269601280,'Konzeptp','konzeptpark GmbH'),(119269605376,'Suretrak','Suretrak Global Pty Ltd'),(119269609472,'JscPromi','JSC Prominform'),(119269613568,'Ecomed-C','Ecomed-Complex'),(119269617664,'Klingent','Klingenthaler Musikelektronik Gm'),(119269621760,'Enstech',''),(119269625856,'Scientif','Scientific-Technical Center \"Eps'),(119269629952,'SulaonOy','Sulaon Oy'),(119269634048,'Check-It','Check-It Solutions Inc'),(119269638144,'EnkoraOy','Enkora Oy Ltd'),(119269642240,'PlairMed','Plair Media Inc.'),(119269646336,'Manufact','Manufacturas y transformados AB'),(119269650432,'EmbitSrl','Embit srl'),(119269654528,'HcsKablo','HCS KABLOLAMA SISTEMLERI SAN. ve'),(119269658624,'DatasatD','Datasat Digital Entertainment'),(119269662720,'Ist','IST GmbH'),(119269666816,'Verified','Verified Energy, LLC.'),(119269670912,'LuxconSy','Luxcon System Limited'),(119269675008,'TesElect','TES Electronic Solutions (I) Pvt'),(119269679104,'TwoDimen','Two Dimensional Instruments, LLC'),(119269683200,'LlcEmzio','LLC Emzior'),(119269687296,'SiemensI','Siemens Industries, Inc, Retail '),(119269691392,'CenterFo','Center for E-Commerce Infrastruc'),(119269695488,'OhioSemi','Ohio Semitronics, Inc.'),(119269699584,'Tado','tado GmbH'),(119269703680,'Dynasthe','Dynasthetics'),(119269707776,'Kitron','Kitron GmbH'),(119269711872,'PlairMed','PLAiR Media, Inc'),(119269715968,'Momentum','Momentum Data Systems'),(119269720064,'DonbassS','Donbass Soft Ltd and Co.KG'),(119269724160,'HpiHighP','HPI High Pressure Instrumentatio'),(119269728256,'Servicio','Servicios Electronicos Industria'),(119269732352,'QcoreMed','QCORE Medical'),(119269736448,'Head',''),(119269740544,'Greatcom','Greatcom AG'),(119269744640,'BioMolec','Bio Molecular System Pty Ltd'),(119269748736,'Hitechla','Hitechlab Inc'),(119269752832,'Lumino','LUMINO GmbH'),(119269756928,'Wonatech','WonATech Co., Ltd.'),(119269761024,'TgsGeoph','TGS Geophysical Company (UK) Lim'),(119269765120,'Diwel',''),(119269769216,'AppliedI','Applied Innovations Research LLC'),(119269773312,'OberonMi','Oberon microsystems, Inc.'),(119269777408,'CastGrou','CAST Group of Companies Inc.'),(119269781504,'OnnetTec','Onnet Technologies And Innovatio'),(119269785600,'UabKitro','UAB Kitron'),(119269789696,'Signatur','SIGNATURE CONTROL SYSTEMS, INC.'),(119269793792,'Topicon',''),(119269797888,'Nistica',''),(119269801984,'Triax','Triax A/S'),(119269806080,'EurekSrl','EUREK  SRL'),(119269810176,'Trendpoi','TrendPoint Systems'),(119269814272,'Unilever','Unilever R&amp;D'),(119269818368,'SevenSol','Seven Solutions S.L'),(119269822464,'3greenAp','3green ApS'),(119269826560,'ArnouseD','Arnouse Digital Devices, Corp.'),(119269830656,'AmbientD','Ambient Devices, Inc.'),(119269834752,'Reelyact','reelyActive'),(119269838848,'PrevacSp','PREVAC sp. z o.o.'),(119269842944,'Sanstrea','Sanstreak Corp.'),(119269847040,'Plexstar','Plexstar Inc.'),(119269851136,'Cubic','Cubic Systems, Inc.'),(119269855232,'UabKitro','UAB Kitron'),(119269859328,'Shenzhen','Shenzhen Guang Lian Zhi Tong Lim'),(119269863424,'Yik','YIK Corporation'),(119269867520,'SICESSrl','S.I.C.E.S. srl'),(119269871616,'Navitar','Navitar Inc'),(119269875712,'K+KMesst','K+K Messtechnik GmbH'),(119269879808,'EnteSpZO','ENTE Sp. z o.o.'),(119269883904,'Homersof','HomerSoft sp. z o.o.'),(119269888000,'Hangzhou','Hangzhou Zhiping Technology Co.,'),(119269892096,'HettichB','Hettich Benelux'),(119269896192,'PANetwor','P A Network Laboratory Co.,Ltd'),(119269900288,'RadmorSA','RADMOR S.A.'),(119269904384,'TeslaCon','Tesla Controls'),(119269908480,'BalterSe','Balter Security GmbH'),(119269912576,'LGLElect','L.G.L. Electronics S.p.a.'),(119269916672,'LinkPrec','Link Precision'),(119269920768,'Elektrom','Elektrometal SA'),(119269924864,'Senceive','Senceive Ltd'),(119269933056,'AvnuAlli','AVnu Alliance'),(346852167680,'JmbsDeve','JMBS Developpements'),(346852171776,'Integrat','Integrated Automation Solutions'),(346852175872,'Microsof','Microsoft'),(346852179968,'SciTechn','SCI Technology Inc.'),(346852184064,'GdCalifo','GD California, Inc.'),(346852188160,'ProjectM','Project Management Enterprises, '),(346852192256,'CliveGre','Clive Green & Co. Ltd.'),(346852196352,'Portable','Portable Add-Ons'),(346852200448,'Datakine','Datakinetics Ltd.'),(346852204544,'Tharsys',''),(346852208640,'Io','IO Limited'),(346852212736,'Vbrick','Vbrick Systems Inc.'),(346852216832,'OpusTele','Opus Telecom Inc.'),(346852220928,'Tttech',''),(346852225024,'Xln-T',''),(346852229120,'Moisture','Moisture Systems'),(346852233216,'Bihl+Wie','Bihl + Wiedemann GmbH'),(346852237312,'FlowareS','Floware System Solutions Ltd.'),(346852241408,'SensysTe','Sensys Technologies Inc.'),(346852245504,'Canal+','Canal +'),(346852249600,'LeroyAut','Leroy Automatique Industrielle'),(346852253696,'DspDesig','DSP Design Ltd.'),(346852257792,'HunterTe','Hunter Technology Inc.'),(346852261888,'Cad-Ul','CAD-UL GmbH'),(346852265984,'EmtacTec','Emtac Technology Corp.'),(346852270080,'SkylakeT','Skylake Talix'),(346852274176,'CrossPro','Cross Products Ltd.'),(346852278272,'TadiranS','Tadiran Scopus'),(346852282368,'Princeto','Princeton Gamma Tech'),(346852286464,'Calltech','CallTech International Limited'),(346852290560,'KbsIndus','KBS Industrieelektronik GmbH'),(346852294656,'IconRese','Icon Research Ltd.'),(346852298752,'DrsTechn','DRS Technologies Canada Co.'),(346852302848,'AshlingM','Ashling Microsystems Ltd.'),(346852306944,'Zabacom','Zabacom, Inc.'),(346852311040,'Ipitek',''),(346852315136,'TeracomT','Teracom Telematica Ltda.'),(346852319232,'Abatis','Abatis Systems Corp.'),(346852323328,'Industri','Industrial Control Links'),(346852327424,'FrenschP','The Frensch Corporation (Pty) Lt'),(346852331520,'Grossenb','Grossenbacher Systeme AG'),(346852335616,'Versalog','VersaLogic Corp.'),(346852339712,'NovaEngi','Nova Engineering Inc.'),(346852343808,'Narrowba','Narrowband Telecommunications'),(346852347904,'Innocor','Innocor LTD'),(346852352000,'TurtleMo','Turtle Mountain Corp'),(346852356096,'Sinetica','Sinetica Corp'),(346852360192,'Lockheed','Lockheed Martin Tactical Defense'),(346852364288,'Eloquenc','Eloquence Ltd'),(346852368384,'Motionio',''),(346852372480,'DobleEng','Doble Engineering Company'),(346852376576,'IngBuero','Ing. Buero W. Kanis GmbH'),(346852380672,'AlliantT','Alliant Techsystems, Inc.'),(346852384768,'Arcturus','Arcturus Networks Inc.'),(346852388864,'EISM','E.I.S.M.'),(346852392960,'EtheiraT','Etheira Technologies'),(346852397056,'ApexSign','Apex Signal Corp'),(346852401152,'PllbElet','PLLB Elettronica SPA'),(346852405248,'VnrElect','VNR Electronique SA'),(346852409344,'Brainbox','BrainBoxes Ltd'),(346852413440,'IsdnGate','ISDN Gateway Technology AG'),(346852417536,'MsuUk','MSU UK Ltd'),(346852421632,'Celotek','Celotek Corp'),(346852425728,'Mispo','MiSPO Co., Ltd.'),(346852429824,'DamlerCh','Damler Chrysler Rail System (Sig'),(346852433920,'BEARSolu','B.E.A.R. Solutions (Australasia)'),(346852438016,'Curtis','Curtis, Inc.'),(346852446208,'ChaseMan','Chase Manhattan Bank'),(346852454400,'BRElectr','B. R. Electronics'),(346852458496,'Cybectec','Cybectec Inc.'),(346852462592,'Computer','Computer Concepts Corp'),(346852466688,'TelecomA','Telecom Analysis Systems, LP'),(346852470784,'TecstarD','Tecstar Demo Systems Division'),(346852474880,'NewStand','New Standard Engineering NV'),(346852483072,'Industri','Industrial Electronic Engineers,'),(346852487168,'Luma','Luma Corporation'),(346852491264,'Dataprob','Dataprobe, Inc.'),(346852495360,'JsrUltra','JSR Ultrasonics'),(346852499456,'MayoFoun','Mayo Foundation'),(346852507648,'Optionex','Optionexist Limited'),(346852511744,'SanCastl','San Castle Technologies, Inc.'),(346852515840,'Base2','Base 2'),(346852519936,'LiteF','Lite F GmBH'),(346852524032,'VisionRe','Vision Research, Inc.'),(346852528128,'AustcoCo','Austco Communication Systems Pty'),(346852532224,'Sonifex','Sonifex Ltd'),(346852536320,'Radiomet','Radiometer Medical A/S'),(346852540416,'NortelNe','Nortel Networks PLC (UK)'),(346852544512,'IgnitusC','Ignitus Communications, LLC'),(346852548608,'Diva','DIVA Systems'),(346852552704,'MaldenEl','Malden Electronics Ltd'),(346852560896,'SimpleNe','Simple Network Magic Corporation'),(346852569088,'Ticketma','Ticketmaster Corp'),(346852577280,'CleverDe','Clever Devices, Ltd.'),(346852585472,'Riverlin','Riverlink Computers, Ltd.'),(346852589568,'Seabridg','Seabridge'),(346852593664,'EcElettr','EC Elettronica S.R.L.'),(346852597760,'Unimark',''),(346852601856,'Ncast','NCast Corporation'),(346852605952,'WavecomE','WaveCom Electronics, Inc.'),(346852610048,'Advanced','Advanced Signal Corp.'),(346852614144,'AvtronMa','Avtron Manufacturing Inc.'),(346852618240,'DigitalS','Digital Services Group'),(346852622336,'Katchall','Katchall Technologies Group'),(346852626432,'Netvisio','NetVision Telecom'),(346852630528,'Neuberge','Neuberger Gebaeudeautomation Gmb'),(346852634624,'AlstomSi','Alstom Signalling Ltd.'),(346852638720,'EdgeTech','Edge Tech Co., Ltd.'),(346852642816,'EnttecPt','ENTTEC Pty Ltd.'),(346852646912,'LittonGu','Litton Guidance & Control System'),(346852651008,'SacoSmar','Saco Smartvision Inc.'),(346852655104,'Reselec','Reselec AG'),(346852659200,'FlextelS','Flextel S.p.A'),(346852663296,'Radiotel',''),(346852667392,'TrikonTe','Trikon Technologies Ltd.'),(346852671488,'PllbElet','PLLB elettronica spa'),(346852675584,'CaspianN','Caspian Networks'),(346852679680,'Jl-Tekni','JL-teknik'),(346852683776,'Dunti','Dunti Corporation'),(346852687872,'Aim',''),(346852691968,'Matusche','Matuschek Messtechnik GmbH'),(346852696064,'GfiChron','GFI Chrono Time'),(346852700160,'ArdSa','ARD SA'),(346852704256,'Dialog4S','DIALOG4 System Engineering GmbH'),(346852708352,'Crosspor','Crossport Systems'),(346852712448,'Validyne','Validyne Engineering Corp.'),(346852716544,'MonitorB','Monitor Business Machines Ltd.'),(346852720640,'Telinc','TELINC Corporation'),(346852724736,'FenwalIt','Fenwal Italia S.P.A.'),(346852728832,'RisingEd','Rising Edge Technologies'),(346852732928,'Hyperchi','HYPERCHIP Inc.'),(346852737024,'IpUnity','IP Unity'),(346852741120,'KylinkCo','Kylink Communications Corp.'),(346852745216,'Bsquare',''),(346852749312,'GeneralI','General Industries Argentina'),(346852753408,'Invensys','Invensys Controls Network System'),(346852757504,'Storlogi','StorLogic, Inc.'),(346852761600,'Digitall','DigitAll World Co., Ltd'),(346852765696,'Korealin','KOREALINK'),(346852769792,'Analytic','Analytical Spectral Devices, Inc'),(346852773888,'Seatech',''),(346852777984,'UtronixE','Utronix Elektronikutreckling AB'),(346852782080,'ImvInver','IMV Invertomatic'),(346852786176,'EpelIndu','EPEL Industrial, S.A.'),(346852790272,'CaseInfo','Case Information & Communication'),(346852794368,'NboDevel','NBO Development Center Sekusui C'),(346852798464,'SeffleIn','Seffle Instrument AB'),(346852802560,'RfApplic','RF Applications, Inc.'),(346852806656,'Zelpos',''),(346852810752,'Infinite','Infinitec Networks, Inc.'),(346852814848,'Metawave','MetaWave Vedeo Systems'),(346852818944,'Cynaps',''),(346852823040,'VisableG','Visable Genetics, Inc.'),(346852827136,'JÃ¤gerCom','JÃ¤ger Computergesteuerte Messte'),(346852831232,'Basytec','BaSyTec GmbH'),(346852835328,'BountyPt','Bounty Systems Pty Ltd.'),(346852839424,'Mobiltex','Mobiltex Data Ltd.'),(346852843520,'Arula','Arula Systems, Inc.'),(346852847616,'Watercov','WaterCove Networks'),(346852851712,'KaveriNe','Kaveri Networks'),(346852855808,'RadiantN','Radiant Networks Plc'),(346852859904,'Log-In','Log-In, Inc.'),(346852864000,'Fastware','Fastware.Net, LLC'),(346852868096,'Honeywel','Honeywell GNO'),(346852872192,'BmcMesss','BMC Messsysteme GmbH'),(346852876288,'Zarak','Zarak Systems Corp.'),(346852880384,'LatusLig','Latus Lightworks, Inc.'),(346852884480,'LmiTechn','LMI Technologies, Inc.'),(346852888576,'BeelineN','Beeline Networks, Inc.'),(346852892672,'RFMicroD','R F Micro Devices'),(346852896768,'Smx','SMX Corporation'),(346852900864,'Wavefly','Wavefly Corporation'),(346852904960,'ExtremeC','Extreme Copper, Inc.'),(346852909056,'Apsecure','ApSecure Technologies (Canada), '),(346852913152,'Rymic',''),(346852917248,'LanContr','LAN Controls, Inc.'),(346852921344,'HelmutMa','Helmut Mauell GmbH'),(346852925440,'Pro-Acti','Pro-Active'),(346852929536,'Mazet','MAZet GmbH'),(346852933632,'Infolink','Infolink Software AG'),(346852937728,'Tattile',''),(346852941824,'StellaEl','Stella Electronics & Tagging'),(346852950016,'Imigix','Imigix Ltd.'),(346852954112,'Casabyte',''),(346852958208,'AlchemyS','Alchemy Semiconductor, Inc.'),(346852962304,'Tonbu','Tonbu, Inc.'),(346852966400,'Interepo','InterEpoch Technology, Inc.'),(346852970496,'SaiaBurg','SAIA Burgess Controls AG'),(346852974592,'Advanced','Advanced Medical Information Tec'),(346852978688,'Transcom','TransComm Technology System, Inc'),(346852982784,'Trane','The Trane Company'),(346852986880,'DssNetwo','DSS Networks, Inc.'),(346852990976,'JDRichar','J D Richards'),(346852995072,'Studiel',''),(346852999168,'Alphamed','AlphaMedia Co., Ltd'),(346853003264,'LinetOy','LINET OY'),(346853007360,'RflElect','RFL Electronics, Inc.'),(346853011456,'Pcsc',''),(346853015552,'Telegran','Telegrang AB'),(346853019648,'Renaissa','Renaissance Networking, Inc.'),(346853023744,'RealWorl','Real World Computing Partnership'),(346853027840,'LakeTech','Lake Technology, Ltd.'),(346853031936,'Palm','Palm, Inc.'),(346853036032,'Zelax',''),(346853040128,'IncoStar','Inco Startec GmbH'),(346853044224,'SummitAv','Summit Avionics, Inc.'),(346853048320,'Charlott','Charlotte`s Web Networks'),(346853052416,'LoeweOpt','Loewe Opta GmbH'),(346853056512,'MotionAn','Motion Analysis Corp.'),(346853060608,'Cyberex',''),(346853064704,'Elbit','Elbit Systems Ltd.'),(346853068800,'Interisa','Interisa Electronica, S.A.'),(346853072896,'Frederic','Frederick Engineering'),(346853076992,'Innovati','Innovation Institute, Inc.'),(346853081088,'Emac','EMAC, Inc.'),(346853085184,'Inspirat','Inspiration Technology P/L'),(346853089280,'VisualCi','Visual Circuits Corp.'),(346853093376,'LanexSA','Lanex S.A.'),(346853097472,'CollaboT','Collabo Tec. Co., Ltd.'),(346853101568,'Clearwat','Clearwater Networks'),(346853105664,'Routefre','RouteFree, Inc.'),(346853109760,'CenturyG','Century Geophysical Corp.'),(346853113856,'AudioDes','Audio Design Associates, Inc.'),(346853117952,'Smartmed','Smartmedia LLC'),(346853122048,'Iready','iReady Corporation'),(346853126144,'IrezTech','iREZ Technologies LLC'),(346853130240,'KeithKoe','Keith & Koep GmbH'),(346853134336,'ValleyPr','Valley Products Corporation'),(346853138432,'Industri','Industrial Indexing Systems, Inc'),(346853142528,'MovazNet','Movaz Networks, Inc.'),(346853146624,'VhbTechn','VHB Technologies, Inc.'),(346853150720,'Polyvisi','Polyvision Corporation'),(346853154816,'Kms','KMS Systems, Inc.'),(346853158912,'YoungCom','Young Computer Co., Ltd.'),(346853163008,'Sysnet','Sysnet Co., Ltd.'),(346853167104,'SpectraT','Spectra Technologies Holding Co.'),(346853171200,'CarlBaas','Carl Baasel Lasertechnik GmbH'),(346853175296,'FossNirs','Foss NIRSystems, Inc.'),(346853179392,'TecnintH','Tecnint HTE S.r.L.'),(346853183488,'RavenInd','Raven Industries'),(346853187584,'GeLubriz','GE Lubrizol, LLC'),(346853191680,'Piusys','PIUSYS Co., Ltd.'),(346853195776,'KimmonMa','Kimmon Manufacturing Co., Ltd.'),(346853199872,'Inducomp','Inducomp Corporation'),(346853203968,'EnergyIc','Energy ICT'),(346853208064,'Ipaxs','IPAXS Corporation'),(346853212160,'Corelatu','Corelatus A.B.'),(346853216256,'LaudElec','LAUD Electronic Design AS'),(346853220352,'MillionT','Million Tech Development Ltd.'),(346853224448,'GreenHil','Green Hills Software, Inc.'),(346853228544,'Adescom','Adescom Inc.'),(346853232640,'Lumentis','Lumentis AB'),(346853236736,'Matsuoka',''),(346853240832,'Newher','NewHer Systems'),(346853244928,'BaloghSA','Balogh S.A.'),(346853249024,'ItkDrKas','ITK Dr. Kassen GmbH'),(346853253120,'Quinx','Quinx AG'),(346853257216,'Marekmic','MarekMicro GmbH'),(346853261312,'Photonic','Photonic Bridges, Inc.'),(346853265408,'Implemen','Implementa GmbH'),(346853269504,'Unipower','Unipower AB'),(346853273600,'Percepti','Perceptics Corp.'),(346853277696,'Quescom',''),(346853281792,'Endusis','Endusis Limited'),(346853285888,'Compuwor','Compuworx'),(346853289984,'AceElect','Ace Electronics, Inc.'),(346853294080,'QuestInn','Quest Innovations'),(346853298176,'Vidco','Vidco, Inc.'),(346853302272,'DspDesig','DSP Design, Ltd.'),(346853306368,'Wintegra','Wintegra Ltd.'),(346853310464,'Microbit','Microbit 2.0 AB'),(346853314560,'GlobalOp','Global Opto Communication Tech. '),(346853318656,'Teamaxes','Teamaxess Ticketing GmbH'),(346853322752,'DigitalV','Digital Vision AB'),(346853326848,'Stonefly','Stonefly Networks'),(346853330944,'DestinyN','Destiny Networks, Inc.'),(346853335040,'VolvoCar','Volvo Car Corporation'),(346853339136,'CssIndus','CSS Industrie Computer GmbH'),(346853343232,'Xstore','XStore, Inc.'),(346853347328,'Coe','COE Limited'),(346853351424,'Diva','Diva Systems'),(346853355520,'SeranoaN','Seranoa Networks, Inc.'),(346853359616,'TokaiSof','Tokai Soft Corporation'),(346853363712,'Tecwings','Tecwings GmBh'),(346853367808,'MarvellH','Marvell Hispana S.L.'),(346853371904,'TpaTraff','TPA Traffic & Parking Automation'),(346853376000,'Pycon','Pycon, Inc.'),(346853380096,'Ttpcom','TTPCom Ltd.'),(346853384192,'Symbolic','Symbolic Sound Corp.'),(346853388288,'DongAElt','Dong A Eltek Co., Ltd.'),(346853392384,'DeltaTau','Delta Tau Data Systems, Inc.'),(346853396480,'Megisto','Megisto Systems, Inc.'),(346853400576,'Runcom',''),(346853404672,'Haag-Str','HAAG-STREIT AG'),(346853408768,'USTraffi','U.S. Traffic Corporation'),(346853412864,'InbusEng','InBus Engineering, Inc.'),(346853416960,'ProconEl','Procon Electronics'),(346853421056,'Chipwrig','ChipWrights, Inc.'),(346853425152,'DrsPhotr','DRS Photronics'),(346853429248,'EladSrl','ELAD SRL'),(346853433344,'Tensilic','Tensilica, Inc.'),(346853437440,'UniwellU','Uniwell Systems (UK) Ltd.'),(346853441536,'DelphinT','Delphin Technology AG'),(346853445632,'SrResear','SR Research Ltd.'),(346853449728,'TexCompu','Tex Computer SRL'),(346853453824,'VaisalaO','Vaisala Oyj'),(346853457920,'NbgIndus','NBG Industrial Automation B.V.'),(346853462016,'FormulaO','Formula One Management Ltd.'),(346853466112,'Avermedi','AVerMedia Systems, Inc.'),(346853470208,'SentitoN','Sentito Networks'),(346853474304,'Its','ITS, Inc.'),(346853478400,'TimeTerm','Time Terminal Adductor Group AB'),(346853482496,'Instrume','Instrumeter A/S'),(346853486592,'Aartesys','AARTESYS AG'),(346853490688,'PhytecMe','Phytec Messtechnik GmbH'),(346853494784,'ElcLight','ELC Lighting'),(346853498880,'Apcon','APCON, Inc.'),(346853502976,'Unisur',''),(346853507072,'Alltec','Alltec GmbH'),(346853511168,'Haag-Str','Haag-Streit AG'),(346853515264,'DycecSA','DYCEC, S.A.'),(346853519360,'HecubaEl','HECUBA Elektronik'),(346853523456,'Optibase','Optibase Ltd.'),(346853527552,'Wellink','wellink, Ltd.'),(346853531648,'CorinexG','Corinex Global'),(346853535744,'Telephon','Telephonics Corp.'),(346853539840,'Torse',''),(346853543936,'ReduxCom','Redux Communications Ltd.'),(346853548032,'AirvastT','AirVast Technology Inc.'),(346853552128,'Advanced','Advanced Devices SpA'),(346853556224,'Jostra','Jostra AB'),(346853560320,'EneaReal','Enea Real Time AB'),(346853564416,'Commserv','CommServ Solutions Inc.'),(346853568512,'Ncore','nCore, Inc.'),(346853572608,'Communic','Communication Solutions, Inc.'),(346853576704,'Standard','Standard Comm. Corp.'),(346853580800,'Plextek','Plextek Limited'),(346853584896,'DuneNetw','Dune Networks'),(346853588992,'AoptixTe','Aoptix Technologies'),(346853593088,'Cepheid',''),(346853597184,'Celite','Celite Systems, Inc.'),(346853601280,'Pulsar','Pulsar GmbH'),(346853605376,'Tti-Tele','TTI - Telecom International Ltd.'),(346853609472,'J&BEngin','J&B Engineering Group S.L.'),(346853613568,'Teseda','Teseda Corporation'),(346853617664,'Computer','Computerwise, Inc.'),(346853621760,'AcuniaNV','Acunia N.V.'),(346853625856,'Ipcast',''),(346853629952,'Infineer','Infineer Ltd.'),(346853634048,'Precisio','Precision Filters, Inc.'),(346853638144,'Extremes','ExtremeSpeed Inc.'),(346853642240,'Nordson','Nordson Corp.'),(346853646336,'TimeDoma','Time Domain'),(346853650432,'Mastercl','Masterclock, Inc.'),(346853654528,'BrijingE','Brijing Embedor Embedded Interne'),(346853658624,'PostecDa','Postec Data Systems Ltd.'),(346853662720,'Pmc',''),(346853666816,'DicksonT','Dickson Technologies'),(346853670912,'Taishodo','Taishodo Seiko Co., Ltd.'),(346853675008,'Quantron','Quantronix, Inc.'),(346853679104,'SaetISSR','SAET I.S. S.r.l.'),(346853683200,'Demetec','DeMeTec GmbH'),(346853687296,'N&PTechn','N&P Technologies'),(346853691392,'SeiSPA','Sei S.p.A.'),(346853695488,'Wavium','Wavium AB'),(346853699584,'Unicoi','Unicoi Systems'),(346853703680,'PartnerV','Partner Voxstream A/S'),(346853707776,'Verifibe','Verifiber LLC'),(346853711872,'WolfIndu','WOLF Industrial Systems Inc.'),(346853715968,'Broadsto','Broadstorm Telecom'),(346853720064,'Jeffress','Jeffress Engineering Pty Ltd'),(346853724160,'Cognex','Cognex Corporation'),(346853728256,'BinaryWa','Binary Wave Technologies Inc.'),(346853732352,'PdqManuf','PDQ Manufacturing'),(346853736448,'ZultysTe','Zultys Technologies'),(346853740544,'Task84','Task 84 Spa'),(346853744640,'Wolf-Inf','wolf-inf-tec'),(346853748736,'MixbaalS','Mixbaal S.A. de C.V.'),(346853752832,'HMComput','H M Computing Limited'),(346853756928,'OpticalW','Optical Wireless Link Inc.'),(346853761024,'PantecEn','Pantec Engineering AG'),(346853765120,'CyanTech','Cyan Technology Ltd'),(346853769216,'Dresden-','dresden-elektronik'),(346853773312,'Cc','CC Systems AB'),(346853777408,'BaslerEl','Basler Electric Company'),(346853781504,'Teradyne','Teradyne Inc.'),(346853785600,'Technodr','Technodrive srl'),(346853789696,'CciiPty','CCII Systems (Pty) Ltd'),(346853793792,'SparrEle','SPARR ELECTRONICS LTD'),(346853797888,'MatsuiMf','MATSUI MFG CO.,LTD'),(346853801984,'Goerlitz','Goerlitz AG'),(346853806080,'PartnerV','Partner Voxstream A/S'),(346853810176,'Advanced','Advanced Concepts, Inc.'),(346853814272,'Laserbit','LaserBit Communications Corp.'),(346853818368,'Cominfo',''),(346853822464,'Momentum','Momentum Data Systems'),(346853826560,'Netsynt','Netsynt Spa'),(346853830656,'EpmTecno','EPM Tecnologia e Equipamentos'),(346853834752,'Potstek','PotsTek, Inc'),(346853838848,'Survalen','Survalent Technology Corporation'),(346853842944,'AzioTech','AZIO TECHNOLOGY CO.'),(346853847040,'Wilcoxon','Wilcoxon Research, Inc.'),(346853851136,'ArtecDes','Artec Design'),(346853855232,'Electrex','ELECTREX S.R.L'),(346853859328,'Paltroni','Paltronics, Inc.'),(346853863424,'Fleetwoo','Fleetwood Electronics Ltd'),(346853867520,'ScaData','SCA Data Systems'),(346853871616,'Portalpl','Portalplayer, Inc'),(346853875712,'AbbSwitz','ABB Switzerland Inc'),(346853879808,'TidelEng','Tidel Engineering, L.P.'),(346853883904,'ProtechO','Protech Optronics Co. Ltd.'),(346853888000,'Norco',''),(346853892096,'RfCode','RF Code'),(346853896192,'AlphaBet','Alpha Beta Technologies, Inc.'),(346853900288,'AnovaBro','ANOVA BROADBAND'),(346853904384,'AxotecTe','Axotec Technologies GmbH'),(346853908480,'Bitbox','BitBox Ltd'),(346853912576,'Streamin','Streaming Networks'),(346853916672,'Beckmann','Beckmann+Egle GmbH'),(346853920768,'RemiaSRO','Remia s.r.o.'),(346853924864,'HomeDire','Home Director, Inc'),(346853928960,'PesaSwit','PESA Switching Systems, Inc.'),(346853933056,'BlankomA','BLANKOM Antennentechnik GmbH'),(346853937152,'AxesTech','Axes Technologies'),(346853941248,'SigosSys','SIGOS Systemintegration GmbH'),(346853945344,'DspDesig','DSP DESIGN'),(346853949440,'DspGroup','DSP Group Inc.'),(346853953536,'ThraneTh','Thrane & Thrane A/S'),(346853957632,'Dts','DTS, Inc.'),(346853961728,'MoschipU','MosChip USA'),(346853965824,'Electron','Electronic Systems Development'),(346853969920,'EmcomTec','EmCom Technology Inc.'),(346853974016,'Interzea','INTERZEAG AG'),(346853978112,'EmailMet','Email Metering'),(346853982208,'DinecInt','DINEC International'),(346853986304,'Aioi','AIOI Systems Co., Ltd.'),(346853990400,'SediaEle','Sedia Electronics'),(346853994496,'Internat','International Test & Engineering'),(346853998592,'Willmoni','WillMonius Inc.'),(346854002688,'Infiniti','InfinitiNetworks Inc.'),(346854006784,'Weltroni','Weltronics Corp.'),(346854010880,'TtElectr','TT electronic manufacturing serv'),(346854014976,'PalmSolu','Palm Solutions Group'),(346854019072,'FlanderO','Flander Oy'),(346854023168,'RemcoIta','Remco Italia Spa'),(346854027264,'TwinDeve','TWIN DEVELOPMENT S.A.'),(346854031360,'EuphonyT','Euphony technology CO., LTD.'),(346854035456,'Modas','modas GmbH'),(346854039552,'EverSpZO','EVER Sp. z o.o.'),(346854043648,'Quantumb','quantumBEAM Limited'),(346854047744,'Waveip','WaveIP ltd.'),(346854051840,'IncaaInf','INCAA Informatica Italia  srl'),(346854055936,'DatatekA','Datatek Applications, Inc.'),(346854060032,'Lifetime','LIFETIME MEMORY PRODUCTS, INC.'),(346854064128,'YazakiNo','Yazaki North America, Inc.'),(346854068224,'Benchmar','Benchmark Electronics'),(346854072320,'Shenyang','Shenyang Internet Technology Inc'),(346854076416,'Synopsys',''),(346854080512,'PhaseIvE','Phase IV Engineering Inc.'),(346854084608,'Redpoint','Redpoint Controls'),(346854088704,'Shanghai','shanghai trend intelligent syste'),(346854092800,'PleoraTe','Pleora Technologies Inc.'),(346854096896,'Guardian','Guardian Controls International'),(346854100992,'Edc',''),(346854105088,'GfiChron','GFI Chrono Time'),(346854109184,'AppliedE','Applied Systems Engineering, Inc'),(346854113280,'ImardaNe','Imarda New Zealand Limited'),(346854117376,'PeikerAc','Peiker acustic GmbH & Co. KG'),(346854121472,'Relion','ReliOn Inc.'),(346854125568,'LuleaUni','Lulea University of Technology'),(346854129664,'Cognex','Cognex Corporation'),(346854133760,'Automaat','Automaatiotekniikka Seppo Saari '),(346854137856,'Digitron','DIGITRONIC Automationsanlagen Gm'),(346854141952,'Bluesock','Bluesocket, Inc.'),(346854146048,'Soronti','Soronti, Inc.'),(346854150144,'DorletSA','DORLET S.A.'),(346854154240,'UnitedTr','United Tri-Tech Corporation'),(346854158336,'SmithMet','Smith Meter, Inc.'),(346854162432,'Metrotec','Metrotech'),(346854166528,'RanchNet','Ranch Networks'),(346854170624,'DaveSRL','DAVE S.r.L.'),(346854174720,'DataResp','Data Respons A/S'),(346854178816,'Cosmo','COSMO co.,ltd.'),(346854182912,'Emka-Ele','EMKA-electronic AG'),(346854187008,'PertoPer','Perto PerifÃ©ricos de AutomaÃ§Ã£'),(346854191104,'M2Techno','M2 Technology Pty Ltd'),(346854195200,'ExiWirel','EXI Wireless Systems Inc.'),(346854199296,'SkyCompu','SKY Computers, Inc.'),(346854203392,'TattileS','Tattile srl'),(346854207488,'Radionor','Radionor Communications AS'),(346854211584,'Covia','Covia, Inc'),(346854215680,'AbestCom','Abest Communication Corp.'),(346854219776,'BaeContr','BAE SYSTEMS Controls'),(346854223872,'ArcCrÃ©at','ARC`CrÃ©ations'),(346854227968,'Ultracke','ULTRACKER TECHNOLOGY'),(346854232064,'FrSauter','Fr. Sauter AG'),(346854236160,'SpContro','SP Controls, Inc'),(346854240256,'Willowgl','Willowglen Systems Inc.'),(346854244352,'EddSrl','EDD Srl'),(346854248448,'Southwin','SouthWing S.L.'),(346854252544,'Safetran','Safetran Traffic Systems Inc.'),(346854256640,'ProductD','Product Design Dept., Sohwa Corp'),(346854260736,'Whittier','Whittier Mailing Products, Inc.'),(346854264832,'Olympusn','OlympusNDT'),(346854268928,'AudioRid','Audio Riders Oy'),(346854277120,'AlgodueE','Algodue Elettronica srl'),(346854281216,'Systing',''),(346854285312,'Windmill','Windmill Innovations'),(346854289408,'Solectro','Solectron Ind.Com.Servs.Exportad'),(346854293504,'Nnovia','nNovia, Inc.'),(346854297600,'Lk','LK Ltd'),(346854301696,'FerrariE','Ferrari electronic AG'),(346854305792,'Rafael',''),(346854309888,'Communic','Communication and Telemechanical'),(346854313984,'Varisys','Varisys Ltd'),(346854318080,'PyramidC','PYRAMID Computer Systeme GmbH'),(346854322176,'OmicronE','OMICRON electronics GmbH'),(346854326272,'Innovics','Innovics Wireless Inc'),(346854330368,'Hochschu','Hochschule fÃ¼r Technik, Wirtsch'),(346854334464,'4links','4Links Limited'),(346854338560,'Sysaware','SysAware S.A.R.L.'),(346854342656,'OshimiSy','Oshimi System Design Inc.'),(346854346752,'Voicecom','VoiceCom AG'),(346854350848,'LevelCon','Level Control Systems'),(346854354944,'LinnProd','Linn Products Ltd'),(346854359040,'NansenSA','Nansen S. A. - Instrumentos de P'),(346854363136,'Aeroflex','Aeroflex GmbH'),(346854367232,'Mst','MST SYSTEMS LIMITED'),(346854371328,'GeneralD','General Dynamics Decision System'),(346854375424,'Fracarro','Fracarro Radioindustrie SPA'),(346854379520,'EsgElekt','ESG Elektroniksystem u. Logistik'),(346854383616,'AppliedT','Applied Technologies Associates'),(346854387712,'MonitorB','Monitor Business Machines Ltd'),(346854391808,'Serveron','Serveron Corporation'),(346854395904,'GetingeI','Getinge IT Solutions ApS'),(346854400000,'Imo-Elek','imo-elektronik GmbH'),(346854404096,'Visicont','visicontrol GmbH'),(346854408192,'Pannocom','PANNOCOM Ltd.'),(346854412288,'PigeonPo','Pigeon Point Systems LLC'),(346854416384,'RossVide','Ross Video Limited'),(346854420480,'Intellig','Intelligent Photonics Control'),(346854424576,'Intellig','Intelligent Media Technologies, '),(346854428672,'Eko','eko systems inc.'),(346854432768,'Crescend','Crescendo Networks'),(346854436864,'RieglLas','Riegl Laser Measurement Systems '),(346854440960,'Intrinsi','Intrinsity'),(346854445056,'Asetek','asetek Inc.'),(346854449152,'LordInge','LORD INGENIERIE'),(346854453248,'Htec','HTEC Limited'),(346854457344,'Autotool','AutoTOOLS group Co. Ltd.'),(346854461440,'Legra','Legra Systems, Inc.'),(346854465536,'Simet',''),(346854469632,'Edentree','EdenTree Technologies, Inc.'),(346854473728,'Silverba','Silverback Systems'),(346854477824,'PolimarE','POLIMAR ELEKTRONIK LTD.'),(346854481920,'Jlcooper','JLCooper Electronics'),(346854486016,'Tandata','Tandata Systems Ltd'),(346854490112,'Schwer+K','Schwer+Kopka GmbH'),(346854494208,'StinsCom','Stins Coman'),(346854498304,'ChantryN','Chantry Networks'),(346854502400,'Envara',''),(346854506496,'Wheatsto','Wheatstone Corporation'),(346854510592,'Gauging','Gauging Systems Inc'),(346854514688,'Kallastr','Kallastra Inc.'),(346854518784,'Hallibur','Halliburton - NUMAR'),(346854522880,'Geoquip','Geoquip Ltd'),(346854526976,'Controni','Contronics Automacao Ltda'),(346854531072,'MdsSciex','MDS SCIEX'),(346854535168,'RgbSpect','RGB Spectrum'),(346854539264,'Intec','intec GmbH'),(346854543360,'Hauppaug','Hauppauge Computer Works, Inc.'),(346854547456,'Hardmeie','Hardmeier'),(346854551552,'GradualT','Gradual Tecnologia Ltda.'),(346854555648,'DixtalBi','Dixtal Biomedica Ind. Com. Ltda.'),(346854559744,'Bender','Bender GmbH & Co. KG'),(346854563840,'CdsRail','CDS Rail'),(346854567936,'Azimuth','Azimuth Systems, Inc.'),(346854572032,'Supertel',''),(346854576128,'Mettler-','METTLER-TOLEDO HI-SPEED'),(346854580224,'ScharffW','Scharff Weisberg Systems Integra'),(346854584320,'Macronet','Macronet s.r.l.'),(346854588416,'AcdElekt','ACD Elektronik GmbH'),(346854592512,'DgtSpZOO','DGT Sp. z o.o.'),(346854596608,'Ads-Tec','ads-tec GmbH'),(346854600704,'Dsm-Mess','DSM-Messtechnik GmbH'),(346854604800,'ThalesCo','Thales Communications Ltd'),(346854608896,'Stmicroe','STMicroelectronics (R&D) Ltd'),(346854612992,'Informat','Information Technology Corp.'),(346854617088,'Digicast','Digicast Networks'),(346854621184,'Spacesav','Spacesaver Corporation'),(346854625280,'OmicronC','Omicron Ceti AB'),(346854629376,'Zendex','Zendex Corporation'),(346854633472,'WinfordE','Winford Engineering'),(346854637568,'Softhill','Softhill Technologies Ltd.'),(346854641664,'Rdtech',''),(346854645760,'MiteHrad','MITE Hradec Kralove, s.r.o.'),(346854649856,'Handtman','Handtmann Maschinenfabrik GmbH&C'),(346854653952,'Biotage',''),(346854658048,'TattileS','Tattile Srl'),(346854662144,'Shanghai','Shanghai Gaozhi Science&Technolo'),(346854666240,'VanscoEl','Vansco Electronics Oy'),(346854670336,'Confiden','Confidence Direct Ltd'),(346854674432,'BelikSPR','BELIK S.P.R.L.'),(346854678528,'AtomGike','ATOM GIKEN Co.,Ltd.'),(346854682624,'AllenMar','Allen Martin Conservation Ltd'),(346854686720,'Parabit','Parabit Systems'),(346854690816,'Technisy','Technisyst Pty Ltd'),(346854694912,'FgSynery','FG SYNERYS'),(346854699008,'Continen','Continental Gateway Limited'),(346854703104,'CrystalV','Crystal Vision Ltd'),(346854707200,'DspDesig','DSP DESIGN'),(346854711296,'ZpEngine','ZP Engineering srl'),(346854715392,'DigitalR','Digital Recorders Inc'),(346854719488,'S4Techno','S4 Technology Pty Ltd'),(346854723584,'VlsipTec','VLSIP TECHNOLOGIES INC.'),(346854727680,'VerexTec','Verex Technology'),(346854731776,'Servicio','Servicios Condumex, S. A. de C. '),(346854735872,'FundaciÃ³','FundaciÃ³n TECNALIA Research & I'),(346854739968,'ExtremeE','Extreme Engineering Solutions'),(346854744064,'TielineR','Tieline Research Pty Ltd'),(346854748160,'T/R','T/R Systems, Inc.'),(346854752256,'Replicom','Replicom Ltd.'),(346854756352,'Patlite','PATLITE Corporation'),(346854760448,'MaestroP','Maestro Pty Ltd'),(346854764544,'Linksecu','LinkSecurity A/S'),(346854768640,'Danlaw','Danlaw Inc'),(346854772736,'AlliedTe','ALLIED TELESIS K.K.'),(346854776832,'Analogic','AnaLogic Computers Ltd.'),(346854780928,'AirBroad','Air Broadband Communications, In'),(346854785024,'Agecodag','AGECODAGIS SARL'),(346854789120,'Cabtroni','CabTronix GmbH'),(346854793216,'Telvent',''),(346854797312,'Ansitex','ANSITEX CORP.'),(346854801408,'Micronet','Micronet Ltd.'),(346854805504,'Littwin','Littwin GmbH & Co KG'),(346854809600,'Ateme',''),(346854813696,'TecnewEl','TECNEW Electronics Engineering C'),(346854817792,'Rpm','RPM Systems Corporation'),(346854821888,'Rototype','Rototype S.p.A.'),(346854825984,'RealTime','Real Time Systems'),(346854830080,'OrionTec','Orion Technologies, Incorporated'),(346854834176,'Futaba','Futaba Corporation'),(346854838272,'AxodeSa','AXODE SA'),(346854842368,'TattileS','TATTILE SRL'),(346854846464,'Spellman','Spellman High Voltage Electronic'),(346854850560,'Ebneuro','EBNEURO SPA'),(346854854656,'ChauvinA','CHAUVIN ARNOUX'),(346854858752,'Amirix','AMIRIX Systems'),(346854862848,'IpUnity','IP Unity'),(346854866944,'Epsa','EPSa GmbH'),(346854871040,'Logosol','LOGOSOL, INC.'),(346854875136,'Opvista',''),(346854879232,'Kinetics',''),(346854883328,'HarvadUn','Harvad University'),(346854887424,'Cad-Ul','CAD-UL GmbH'),(346854891520,'PacketTe','Packet Techniques Inc.'),(346854895616,'AcdElekt','ACD Elektronik GmbH'),(346854899712,'2nTeleko','2N TELEKOMUNIKACE a.s.'),(346854903808,'GlobeWir','Globe Wireless'),(346854907904,'SelexCom','SELEX Communications Ltd'),(346854912000,'Baudisch','Baudisch Electronic GmbH'),(346854916096,'Sterling','Sterling Industry Consult GmbH'),(346854920192,'Infineti','Infinetix Corp'),(346854924288,'EpelsaSl','Epelsa, SL'),(346854928384,'West-Com','West-Com Nurse Call Systems, Inc'),(346854932480,'XipherEm','Xipher Embedded Networking'),(346854936576,'SeptierC','Septier Communication Ltd'),(346854940672,'Brannstr','Brannstroms Elektronik AB'),(346854944768,'MicroSys','Micro System Architecturing srl'),(346854948864,'DvtelIsr','DVTel Israel Ltd.'),(346854952960,'DrStaige','Dr. Staiger, Mohilo + Co GmbH'),(346854957056,'DeutaWer','DEUTA Werke GmbH'),(346854961152,'AumInfot','AUM Infotech Private Limited'),(346854965248,'BbiEngin','BBI Engineering, Inc.'),(346854969344,'AbbT&D','ABB T&D Spa'),(346854973440,'QuestRet','Quest Retail Technology Pty Ltd'),(346854977536,'CsaCompu','CSA  Computer & Antriebstechnik '),(346854981632,'TeldaEle','Telda Electronics'),(346854989824,'SmithsDe','Smiths Detection'),(346854993920,'Embedded','Embedded Systems Design'),(346854998016,'Polatis','Polatis Ltd'),(346855002112,'HobbesCo','Hobbes Computer Network Accessor'),(346855006208,'Softier','Softier Inc.'),(346855010304,'Rafi','Rafi GmbH & Co. KG'),(346855014400,'AdmiralS','Admiral Secure Products, Ltd.'),(346855018496,'Richmond','Richmond Sound Design Ltd.'),(346855022592,'NorcoInd','NORCO INDUSTRIAL TECHNOLOGY INC'),(346855026688,'TaInstru','TA Instruments Ltd'),(346855030784,'UsterTec','Uster Technologies AG'),(346855034880,'Storlink','StorLink Semi'),(346855038976,'Lipowsky','Lipowsky Industrie-Elektronik Gm'),(346855043072,'Perax',''),(346855047168,'Magellan','Magellan Technology Pty Ltd'),(346855051264,'StageTec','Stage Tec Entwicklungsgesellscha'),(346855055360,'Smarteye','Smarteye Corporation'),(346855059456,'DigitalS','Digital SP Ltd'),(346855063552,'Invensys','Invensys Energy Systens (NZ) Lim'),(346855067648,'ElmanSrl','Elman srl'),(346855071744,'InitialE','Initial Electronic Security Syst'),(346855075840,'Siliquen','Siliquent Technologies Ltd'),(346855079936,'Selco',''),(346855084032,'RosemanE','Roseman Engineering Ltd.'),(346855088128,'Putercom','PUTERCOM CO., LTD'),(346855092224,'FactsEng','FACTS Engineering LLC'),(346855096320,'Embedded','EMBEDDED TOOLSMITHS'),(346855100416,'Datawind','DataWind Research'),(346855104512,'RossVide','Ross Video Limited'),(346855108608,'DiseÃ±oDe','DiseÃ±o de Sistemas en Silicio S'),(346855112704,'WorthDat','Worth Data, Inc.'),(346855116800,'Miritek','Miritek, Inc.'),(346855120896,'AirnetCo','AIRNET COMMUNICATIONS CORP'),(346855124992,'GerberSc','Gerber Scientific Products, Inc.'),(346855129088,'Integrat','Integrated System Solution Corp.'),(346855133184,'Pixy','PIXY AG'),(346855137280,'WisTechn','WIS Technologies'),(346855141376,'NeoElect','Neo Electronics Ltd'),(346855145472,'Syn-Tech','SYN-TECH SYSTEMS INC'),(346855153664,'PyramidC','PYRAMID Computer GmbH'),(346855157760,'Autotool','AutoTOOLS group Co. Ltd.'),(346855161856,'WienerPl','Wiener, Plein & Baus GmbH'),(346855165952,'WestekTe','Westek Technology Ltd'),(346855170048,'Research','Research Applications'),(346855174144,'Micrel-N','MICREL-NKE'),(346855178240,'BaxterHe','Baxter Healthcare'),(346855182336,'AccessIs','Access IS'),(346855186432,'BallardT','Ballard Technology, Inc.'),(346855190528,'MgIndust','MG Industrieelektronik GmbH'),(346855194624,'Iamba','iamba LTD.'),(346855198720,'Transtec','Transtech DSP'),(346855202816,'Dalsa',''),(346855206912,'Safeview','SafeView, Inc.'),(346855211008,'SMVSyste','S.M.V. Systemelektronik GmbH'),(346855215104,'SriInter','SRI International'),(346855219200,'Qubisoft','QUBIsoft S.r.l.'),(346855223296,'LinggJan','Lingg & Janke OHG'),(346855227392,'ChengduB','CHENGDU  BOOK DIGITAL CO., LTD'),(346855231488,'4rfCommu','4RF Communications Ltd'),(346855235584,'ShfCommu','SHF Communication Technologies A'),(346855239680,'Profline','Profline B.V.'),(346855243776,'Leco','LECO Corporation'),(346855247872,'Geometri','Geometrics, Inc.'),(346855251968,'EurotekS','Eurotek Srl'),(346855256064,'Crossbow','Crossbow Technology, Inc.'),(346855260160,'Efficien','Efficient Channel Coding'),(346855264256,'Adchips',''),(346855268352,'Clifford','Clifford Chance LLP'),(346855272448,'Gillam-F','GILLAM-FEI S.A.'),(346855276544,'Savvycor','SavvyCorp.com Ltd'),(346855280640,'Digilent','Digilent Inc.'),(346855284736,'TornadoM','Tornado Modular Systems, Ltd'),(346855288832,'ArthurIn','Arthur Industries Inc., dba On H'),(346855292928,'Blacklin','Blackline Systems Corporation'),(346855297024,'American','American Microsystems LTD'),(346855301120,'Saab','Saab AB'),(346855305216,'PatriaAd','Patria Advanced Solutions'),(346855309312,'SoredexI','Soredex Instrumentarium Oyj'),(346855313408,'DelphiDi','Delphi Display Systems, Inc.'),(346855317504,'Eurodesi','EuroDesign embedded technologies'),(346855321600,'Ci','CI Systems Ltd.'),(346855325696,'Comerson','COMERSON S.r.l.'),(346855329792,'Symbium','Symbium Corporation'),(346855333888,'NoranTel','Noran Tel Communications Ltd.'),(346855337984,'Uniondig','UNIONDIGITAL.,CO.LTD'),(346855342080,'Fiveco',''),(346855346176,'Rackmast','Rackmaster Systems, Inc.'),(346855350272,'InningsT','Innings Telecom Inc.'),(346855354368,'VxTechno','VX Technologies Inc.'),(346855358464,'Teamlog',''),(346855362560,'Setaram',''),(346855366656,'Obvius',''),(346855370752,'Digicont','Digicontrole Lda'),(346855374848,'Cybertro','CYBERTRON CO., LTD.'),(346855378944,'Comodo',''),(346855383040,'DeseTech','Dese Technologies SL'),(346855387136,'SaiaBurg','SAIA Burgess Controls AG'),(346855391232,'Microbee','MicroBee Systems, Inc'),(346855395328,'IfakSyst','ifak system GmbH'),(346855399424,'Dataline','Dataline AB'),(346855403520,'Cosine','Cosine Systems, Inc.'),(346855407616,'Milmega','Milmega Ltd'),(346855411712,'Invatron','Invatron Systems Corp.'),(346855415808,'ZodiakDa','Zodiak Data Systems'),(346855419904,'Datacon',''),(346855424000,'Casa','Casa Systems Inc.'),(346855428096,'ImardaNe','Imarda New Zealand Limited'),(346855432192,'C3-IlexL','C3-ilex, LLC'),(346855436288,'GeotechI','Geotech Instruments, LLC'),(346855440384,'Dtasenso','DTASENSOR S.p.A.'),(346855444480,'Uxp',''),(346855448576,'BqtSolut','BQT Solutions (Australia) Limite'),(346855452672,'RedRockN','Red Rock Networks'),(346855456768,'Odixion',''),(346855460864,'FederalA','Federal Aviation Administration'),(346855464960,'Navionic','Navionics S.p.A.'),(346855469056,'Dornier','Dornier GmbH'),(346855473152,'ICSElect','I.C.S. Electronics Limited'),(346855477248,'Imax',''),(346855481344,'PhytecMe','PHYTEC Messtechnik GmbH'),(346855485440,'DigitalM','Digital Multimedia Technologies '),(346855489536,'Integrat','Integrated Silicon Solution (Tai'),(346855493632,'ConsensZ','Consens Zeiterfassung GMBH'),(346855497728,'Manusa-G','MANUSA-GEST, S.L.'),(346855501824,'Pultroni','PULTRONICS'),(346855505920,'SiconSRL','Sicon S.r.l.'),(346855510016,'Broadcas','Broadcast Sports Inc'),(346855514112,'PunjabCo','PUNJAB COMMUNICATIONS LTD'),(346855518208,'Radix','Radix Corporation'),(346855522304,'PictureE','Picture Elements, Inc.'),(346855526400,'NimcatNe','Nimcat Networks'),(346855530496,'GoldenRi','Golden River Traffic'),(346855534592,'Eti',''),(346855538688,'Ernitec','Ernitec A/S'),(346855542784,'CegelecS','CEGELEC SUD EST'),(346855546880,'UnitedTe','United Telecoms Ltd'),(346855550976,'Multimed','MultimediaLED'),(346855555072,'Skipjam',''),(346855559168,'GeneralD','General Dynamics Decision System'),(346855563264,'CaTechno','CA Technology, Inc'),(346855567360,'ExysBvba','EXYS bvba'),(346855571456,'Virtu',''),(346855575552,'Novx','Novx Systems'),(346855579648,'StMichae','St. Michael Strategies'),(346855583744,'AbbXiame','ABB Xiamen Switchgear Co. Ltd.'),(346855587840,'Ads-Tec','ads-tec GmbH'),(346855591936,'Act',''),(346855596032,'Biokeysy','biokeysystem'),(346855600128,'RowSeven','Row Seven Ltd'),(346855604224,'Koolspan','KoolSpan, Inc.'),(346855608320,'SsiSchae','SSI Schaefer Peem'),(346855612416,'Nie','NIE Corporation'),(346855616512,'Ecutel','Ecutel Systems, Inc.'),(346855620608,'ChuoElec','Chuo Electric Works Co., LTD.'),(346855624704,'BmkProfe','BMK professional electronics Gmb'),(346855628800,'AbbPower','ABB Power Technologies S.p.A.  U'),(346855632896,'NorthPol','North Pole Engineering, Inc.'),(346855636992,'KinesysP','Kinesys Projects Limited'),(346855641088,'Finesyst','Finesystem Co., Ltd'),(346855645184,'Edixia',''),(346855649280,'Crossing','Crossing Informationssysteme Gmb'),(346855653376,'Advanced','Advanced IP Communications'),(346855657472,'Ihm',''),(346855661568,'BaytechC','Baytech Cinema'),(346855665664,'AthenaSe','Athena Semiconductor'),(346855669760,'Alcea',''),(346855673856,'KramerEl','Kramer Electronics Ltd.'),(346855677952,'Advanced','Advanced Si-Net Co., LTD.'),(346855682048,'VlsipTec','VLSIP TECHNOLOGIES, INC'),(346855686144,'Ratotec','Ratotec GmbH'),(346855690240,'Nettest','NetTest A/S'),(346855694336,'JobinYvo','Jobin Yvon,Inc'),(346855698432,'FImmSRL','F.Imm. S.r.L.'),(346855702528,'DigitalR','Digital Receiver Technology, Inc'),(346855706624,'Contec',''),(346855710720,'AzdPraha','AZD Praha s.r.o.'),(346855714816,'Septentr','Septentrio nv/sa'),(346855718912,'TattileS','TATTILE SRL'),(346855723008,'VishayNo','Vishay Nobel AB'),(346855727104,'Vanguard','Vanguard Technology Corp.'),(346855731200,'CanmaxTe','CANMAX Technology Ltd.'),(346855735296,'AspelSA','ASPEL S.A.'),(346855739392,'AlwaysOn','Always On Wireless'),(346855743488,'Optronic','Optronic Partner pr AB'),(346855747584,'MinervaT','Minerva Technology Inc'),(346855751680,'RiscoGro','RISCO Group'),(346855755776,'OplinkCo','Oplink Communications'),(346855759872,'MinicomA','Minicom Advanced Systems Ltd'),(346855763968,'XimeaSRO','XIMEA s.r.o.'),(346855768064,'EuropeTe','Europe Technologies'),(346855772160,'DigitalA','DIGITAL ART SYSTEM'),(346855776256,'ElvElekt','ELV Elektronik AG'),(346855780352,'Companio','Companion Worlds, inc.'),(346855784448,'OwasysAd','Owasys Advanced Wireless Devices'),(346855788544,'Tir','TIR Systems Ltd.'),(346855792640,'Cleode',''),(346855796736,'XycomVme','Xycom VME'),(346855800832,'Daintree','Daintree Networks Inc'),(346855804928,'ControlL','Control LAN S.A.'),(346855809024,'Ida','IDA Corporation'),(346855813120,'Freescal','freescale semiconductor'),(346855817216,'Modia','MODIA SYSTEMS Co., Ltd'),(346855821312,'Verotrak','VeroTrak Inc.'),(346855825408,'NiSRL','Ni.Co. S.r.l.'),(346855829504,'Foresear','Foresearch'),(346855833600,'Eke-Elec','EKE-Electronics Ltd.'),(346855837696,'Realtime','Realtime Engineering AG'),(346855841792,'Colorado','Colorado vNet'),(346855845888,'IcsElect','ICS Electronics'),(346855849984,'Wireless','Wireless Reading Systems Holding'),(346855854080,'SungjinN','SUNGJIN NEOTECH Co.Ltd.'),(346855858176,'Precisio','Precision System Science Co.,Ltd'),(346855862272,'Inoteska','Inoteska s.r.o.'),(346855866368,'Iee','IEE Inc'),(346855870464,'Exavio','Exavio Inc.'),(346855874560,'Embedtro','Embedtronics Enterprise'),(346855878656,'Interbri','InterBridge,Inc.'),(346855882752,'EpsilonS','EPSILON SRL'),(346855886848,'A&GSoluz','A&G Soluzioni Digitali'),(346855890944,'NordicAl','Nordic Alarm AB'),(346855895040,'TtcTelec','TTC Telecom'),(346855899136,'TcCommun','TC Communications'),(346855903232,'Esensors','Esensors, Inc.'),(346855907328,'PhytecMe','PHYTEC Messtechnik GmbH'),(346855911424,'SysTecEl','SYS TEC electronic GmbH'),(346855915520,'Embedit','Embedit A/S'),(346855919616,'Vidisys','vidisys gmbh'),(346855923712,'Rapidwav','RapidWave Inc.'),(346855927808,'MangoDsp','MANGO DSP Ltd.'),(346855931904,'InhandEl','InHand Electronics, Inc.'),(346855936000,'Advanced','Advanced Micro Controls Inc.'),(346855940096,'OpticalA','Optical Air Data Systems'),(346855944192,'YuyamaMf','YUYAMA MFG. CO., LTD.'),(346855948288,'TiyodaMf','TIYODA MFG CO.,LTD.'),(346855952384,'Digitald','DigitalDeck, Inc.'),(346855956480,'ARGElect','A.R.G ElectroDesign Ltd'),(346855960576,'Isensix',''),(346855964672,'Streetfi','StreetFire Sound Labs, LLC'),(346855968768,'Samsoft',''),(346855972864,'VegasAmu','Vegas Amusement'),(346855976960,'StarLink','Star Link Communication Pvt. Ltd'),(346855981056,'Silvertr','Silvertree Engineering Ltd'),(346855985152,'Labjack','LabJack Corporation'),(346855989248,'Intellid','IntelliDesign Pty Ltd'),(346855993344,'Elektrot','Elektrotechnik & Elektronik Oltm'),(346855997440,'Engim','Engim, Inc.'),(346856001536,'Westroni','Westronic Systems Inc.'),(346856005632,'Networke','Networked Robotics Corporation'),(346856009728,'TaskitRe','taskit Rechnertechnik GmbH'),(346856013824,'Inaccess','InAccess Networks'),(346856017920,'SpirentC','Spirent Communications (Scotland'),(346856022016,'HankukTa','Hankuk Tapi Computer Co., Ltd'),(346856026112,'NorbitOd','Norbit ODM AS'),(346856030208,'Microtar','Microtarget Tecnologia Digital L'),(346856034304,'RdcSpecs','RDC Specstroy-Svyaz Ltd'),(346856038400,'Tennesse','Tennessee Valley Authority'),(346856042496,'MediaLab','Media Lab., Inc.'),(346856046592,'ContrÃ´le','ContrÃ´le Analytique inc.'),(346856050688,'NecTokin','NEC TOKIN Corporation'),(346856054784,'ArecontV','Arecont Vision, LLC'),(346856058880,'Mindspee','Mindspeed Technologies'),(346856062976,'KeithKoe','Keith & Koep GmbH'),(346856067072,'Gilbarco','Gilbarco Autotank AB'),(346856071168,'PhytecMe','PHYTEC Messtechnik GmbH'),(346856075264,'ImagoTec','IMAGO Technologies GmbH'),(346856079360,'Tyzx','Tyzx, Inc.'),(346856083456,'BigbangL','Bigbang L.T.D.'),(346856087552,'PaulySte','Pauly Steuer- und Regelanlagen G'),(346856091648,'AudioPro','Audio Processing Technology Ltd'),(346856095744,'EdaIndus','EDA Industries Srl'),(346856099840,'Microtek','MicroTek Electronics, Inc.'),(346856103936,'Casabyte','Casabyte Inc.'),(346856108032,'4gTechno','4g Technologies, L.P.'),(346856112128,'SyprisEl','Sypris Electronics'),(346856116224,'SiliconO','Silicon Optix Canada Inc.'),(346856120320,'NetOptic','Net Optics'),(346856124416,'SalentTe','Salent Technologies Ltd'),(346856128512,'WheelsOf','Wheels of Zeus Inc.'),(346856132608,'DilaxInt','Dilax Intelcom AG'),(346856136704,'Abb','ABB Inc.'),(346856140800,'Analytic','Analytica GmbH'),(346856144896,'Linkwell','LINKWELL TELESYSTEMS PRIVATE LIM'),(346856148992,'Micro-Me','Micro-Measurements'),(346856153088,'WardLeon','Ward Leonard Electric Company'),(346856157184,'Technova','Technovare Systems, Inc.'),(346856161280,'Micro-Ro','Micro-Robotics Limited'),(346856165376,'Braintro','Braintronics BV'),(346856169472,'AdilecEn','Adilec Enginyeria SL'),(346856173568,'American','American LED-gible Inc.'),(346856177664,'WisnuAnd','Wisnu and Supak Co.Ltd.'),(346856181760,'FlukeBio','Fluke Biomedical, Radiation Mana'),(346856185856,'Comlab','Comlab Inc.'),(346856189952,'TtcTelek','TTC TELEKOMUNIKACE Ltd'),(346856194048,'Key','Key Systems , Inc.'),(346856198144,'BavariaD','Bavaria Digital Technik GmbH'),(346856202240,'M5Data','M5 Data Limited'),(346856206336,'Osmetech','Osmetech Inc.'),(346856210432,'3dPercep','3D perception'),(346856214528,'Elmic','ELMIC GmbH'),(346856218624,'AbbPower','ABB Power Technologies'),(346856222720,'Biode','BiODE Inc.'),(346856226816,'OyStingh','Oy Stinghorn Ltd'),(346856230912,'Neulion','NeuLion Incorporated'),(346856235008,'Sysnova',''),(346856239104,'Csiro-Di','CSIRO - Division of Exploration '),(346856243200,'CueAS','CUE, a.s.'),(346856247296,'Vacon','Vacon Plc'),(346856251392,'Crde',''),(346856255488,'Revoluti','Revolution Education Ltd'),(346856259584,'Conforma','Conformative Systems, Inc.'),(346856263680,'Medavant','MedAvant Healthcare'),(346856267776,'AlroInfo','Alro Information Systems SA'),(346856271872,'IssInter','ISS International'),(346856275968,'Teneros',''),(346856280064,'BoardRoo','The Board Room Inc.'),(346856284160,'Commoca','Commoca, Inc'),(346856288256,'PatIndus','PAT Industries, DBA Pacific Adva'),(346856292352,'MegatecE','megatec electronic GmbH'),(346856296448,'SallandE','Salland Electronics Holding BV'),(346856300544,'Stl','STL GmbH'),(346856304640,'HytecGer','Hytec Geraetebau GmbH'),(346856308736,'McTechno','MC TECHNOLOGY GmbH'),(346856312832,'Phaedrus','Phaedrus Limited'),(346856316928,'Daftdata','dAFTdATA Limited'),(346856321024,'Advantag','Advantage R&D'),(346856325120,'Superna','Superna Ltd'),(346856329216,'Sintium','Sintium Ltd'),(346856333312,'Tumsan',''),(346856337408,'PigeonPo','Pigeon Point Systems LLC'),(346856341504,'Weinberg','Weinberger Deutschland GmbH'),(346856345600,'Hartmann','HARTMANN software GbR'),(346856349696,'Haivisio','HaiVision Systems Inc'),(346856353792,'CastIron','Cast Iron Systems'),(346856357888,'Smartmot','SmartMotor AS'),(346856361984,'Promess','Promess Incorporated'),(346856366080,'NumeronS','Numeron Sp. z o.o.'),(346856370176,'RohdeSch','Rohde & Schwarz Topex SA'),(346856374272,'Nanshanb','NanShanBridge Co.Ltd'),(346856378368,'Guralp','Guralp Systems Limited'),(346856382464,'Corestre','CoreStreet, Ltd'),(346856386560,'AieEtude','AIE Etudes'),(346856390656,'Tern','TERN, Inc.'),(346856394752,'Ktec','KTEC LTD'),(346856398848,'ContecSt','Contec Steuerungstechnik & Autom'),(346856402944,'CenterVo','Center VOSPI JSC'),(346856407040,'AppliedM','Applied Materials UK Ltd'),(346856411136,'AfonicsF','Afonics Fibreoptics Ltd'),(346856415232,'Ads-Tec','ads-tec GmbH'),(346856419328,'Bir','BIR,INC.'),(346856423424,'Grossenb','Grossenbacher Systeme AG'),(346856427520,'Multimes','Multimessage Systems Ltd.'),(346856431616,'TsbSolut','TSB Solutions Inc.'),(346856435712,'Goodrich',''),(346856439808,'Talleres','Talleres de Escoriaza SA'),(346856443904,'Sensotec','SensoTech GmbH'),(346856448000,'SelcoSRL','SELCO s.r.l.'),(346856452096,'Qt','QT systems ab'),(346856456192,'PlaneaOy','Planea Oy'),(346856460288,'MecselOy','Mecsel Oy'),(346856464384,'Bluewate','Bluewater Systems Ltd'),(346856468480,'LogimSof','LogiM GmbH Software und Entwickl'),(346856472576,'Infrasaf','Infrasafe, Inc.'),(346856476672,'Altronic','Altronic, Inc.'),(346856480768,'Videotek','Videotek Sistemas Eletronicos Lt'),(346856484864,'Avionica','Avionica, Inc'),(346856488960,'Boundles','Boundless Technologies'),(346856493056,'Efsys',''),(346856497152,'GekelerM','Gekeler Martina'),(346856501248,'Power-On','Power-One Inc.'),(346856505344,'Metrolab','Metrolab Technology SA'),(346856509440,'Pinnacle','Pinnacle Technology'),(346856513536,'StomSyst','STOM System'),(346856517632,'ScheidtB','Scheidt & Bachmann GmbH'),(346856521728,'Roxar','Roxar A/S'),(346856525824,'Matthews','Matthews Australasia'),(346856529920,'DspDesig','DSP DESIGN'),(346856534016,'VlsipTec','VLSIP TECHNOLOGIES, INC.'),(346856538112,'TrapezeI','Trapeze ITS U.S.A., LLC'),(346856542208,'Argo-Tec','Argo-Tech'),(346856546304,'OelmannE','Oelmann Elektronik GmbH'),(346856550400,'Win4net',''),(346856554496,'ArcomDig','Arcom Digital'),(346856558592,'Octatron','Octatron, Inc.'),(346856562688,'TopwayIn','Topway Industries Ltd.'),(346856566784,'IdetechE','Idetech Europe S.A.'),(346856570880,'Imperati','ImperativeNetworks'),(346856574976,'AdatelTe','ADATEL TELECOMUNICACIONES S.A.'),(346856579072,'Satellit','Satellite Services BV'),(346856583168,'Powerwan','PowerWAN, Inc'),(346856587264,'TelecomP','Telecom Protection Technologies '),(346856591360,'PeletonP','Peleton Photonic Systems'),(346856595456,'Prodesig','ProDesign GmbH'),(346856599552,'A3ip',''),(346856603648,'Ducommun','Ducommun LaBarge Technologies, I'),(346856607744,'AnnArbor','Ann Arbor Sensor Systems LLC'),(346856611840,'Copperco','Coppercom'),(346856615936,'ArvooIma','ARVOO Imaging Products BV'),(346856620032,'Advanced','Advanced Modular Computers Ltd.'),(346856624128,'SammiInf','Sammi Information Systems Co.,Lt'),(346856628224,'PicoComp','Pico Computing, Inc.'),(346856632320,'Pickerin','Pickering Laboratories'),(346856636416,'Offshore','Offshore Systems Ltd'),(346856640512,'Micronic','MICRONIC s.r.o.'),(346856644608,'MicroTec','Micro Technic A-S'),(346856648704,'GrupoEpe','Grupo Epelsa S.L.'),(346856652800,'Comtech','Comtech Systems Inc.'),(346856656896,'BleileDa','BLEILE DATENTECHNIK GmbH'),(346856660992,'Elettron','ELETTRONICA SANTERNO SPA'),(346856665088,'Solace','Solace Systems, Inc.'),(346856669184,'Computim','Computime Systems UK Ltd.'),(346856673280,'Electro-','Electro-Matic Products, Inc.'),(346856677376,'QqTechno','QQ Technology,Inc'),(346856681472,'Kippdata','kippdata GmbH'),(346856685568,'Enconair','Enconair Ecological Chambers Inc'),(346856689664,'Hameg','HAMEG GmbH'),(346856693760,'ScameSis','SCAME SISTEMI s.r.l.'),(346856697856,'Erhardt+','Erhardt + Leimer GmbH'),(346856701952,'BrivoLlc','Brivo Systems, LLC'),(346856706048,'Aircell','AirCell, Inc.'),(346856710144,'DrdcValc','DRDC Valcartier'),(346856714240,'Danbridg','Danbridge'),(346856718336,'HrzData','HRZ data GmbH'),(346856722432,'PhytecMe','PHYTEC Messtechnik GmbH'),(346856726528,'Funkwerk','Funkwerk plettac electronic GmbH'),(346856730624,'MatraEle','Matra Electronique'),(346856734720,'DeisterE','Deister Electronic GmbH'),(346856738816,'DigitalE','Digital Engineering, Inc.'),(346856742912,'Hallibur','Halliburton - Sperry Drilling Se'),(346856747008,'T2cMarke','T2C Marketing AB'),(346856751104,'Vitelnet',''),(346856755200,'TattileS','TATTILE SRL'),(346856759296,'Ct','CT Company'),(346856763392,'Codem','Codem Systems, Inc.'),(346856767488,'XytacSys','XYTAC system technologies'),(346856771584,'Pdts','PDTS GmbH'),(346856775680,'Lonap','LONAP Limited'),(346856779776,'UnitedWe','United Western Technologies'),(346856783872,'NetworkI','Network I/O'),(346856787968,'BipomEle','BiPOM Electronics, Inc.'),(346856792064,'Ise','ISE GmbH'),(346856796160,'Easytech','EASYTECH GmbH'),(346856800256,'Camco','CAMCO GmbH'),(346856804352,'PaulSche','Paul Scherrer Institut (PSI)'),(346856808448,'AvenirTe','Avenir Technologies Inc.'),(346856812544,'Neurowar','Neuroware'),(346856816640,'Cybectec','Cybectec inc.'),(346856820736,'PixtreeT','Pixtree Technologies, inc.'),(346856824832,'Kop','KOP Ltd'),(346856828928,'SensusMe','Sensus Metering Systems Israel'),(346856833024,'Venue1','Venue 1, Inc.'),(346856837120,'Isepos','ISEPOS GmbH'),(346856841216,'AsconSPA','Ascon S.p.a.'),(346856845312,'SevTidsy','SEV Tidsystem AB'),(346856849408,'Metafix','Metafix Inc.'),(346856853504,'Unlimite','Unlimited Bandwidth LLC'),(346856857600,'Efficien','Efficient Channel Coding'),(346856861696,'PitneyBo','Pitney Bowes, Inc'),(346856865792,'Auconet','AUCONET GmbH'),(346856869888,'Wit','WIT Inc'),(346856873984,'EnergieU','Energie Umwelt Systemtechnik Gmb'),(346856878080,'Brit','BRIT Inc.'),(346856882176,'Selkom','SELKOM GmbH'),(346856886272,'Computer','Computer Sciences Corp'),(346856890368,'PriamusS','PRIAMUS SYSTEM TECHNOLOGIES AG'),(346856894464,'Ses',''),(346856898560,'Kooltech','Kooltech LLC'),(346856902656,'PhytecMe','PHYTEC Messtechnik GmbH'),(346856906752,'Safegate','Safegate International AB'),(346856910848,'Eridon','Eridon Corporation'),(346856914944,'DaSistem','DA SISTEMI SPA'),(346856919040,'EreeElec','EREE Electronique'),(346856923136,'MobileMa','Mobile Matrix, Inc.'),(346856927232,'Ads-Tec','ADS-TEC GmbH'),(346856931328,'Uniton','UNITON AG'),(346856935424,'MetronSp','Metron Sp. z o.o.'),(346856939520,'Teledyne','Teledyne Tekmar'),(346856943616,'Dengyosh','DENGYOSHA co.,LTD.'),(346856947712,'Cloanto','Cloanto Corporation'),(346856951808,'FrSauter','Fr. Sauter AG'),(346856955904,'TrafsysA','TRAFSYS AS'),(346856960000,'Artis','Artis GmbH'),(346856964096,'Ultimate','Ultimate Technology, Inc.'),(346856968192,'VazaElek','VAZA Elektronik AB'),(346856972288,'Acutelog','Acutelogic Corporation'),(346856976384,'Advanced','Advanced Driver Information Tech'),(346856980480,'QuartetT','Quartet Technology, Inc.'),(346856984576,'TrelliaN','Trellia Networks'),(346856988672,'TelasicC','TelASIC Communications, Inc.'),(346856992768,'VgContro','vg controls, inc'),(346856996864,'Envisaco','Envisacor Technologies Inc.'),(346857000960,'Critical','Critical Link'),(346857005056,'Armorlin','Armorlink CO .Ltd'),(346857009152,'Gcs','GCS, Inc'),(346857013248,'Advanced','Advanced technologies & Engineer'),(346857017344,'PigeonPo','Pigeon Point Systems LLC'),(346857021440,'Specs','SPECS GmbH'),(346857025536,'ProtiumT','Protium Technologies, Inc.'),(346857029632,'IeeeP160','IEEE P1609 WG'),(346857033728,'Teledyne','Teledyne Monitor Labs'),(346857037824,'BuyangEl','BUYANG ELECTRONICS INDUSTRIAL CO'),(346857041920,'IsegSpez','iseg Spezialelektronik GmbH'),(346857046016,'CyjayaKo','CYJAYA Korea'),(346857050112,'FaberEle','Faber Electronics BV'),(346857054208,'HeinenEl','HEINEN ELEKTRONIK GmbH'),(346857058304,'JvfCommu','JVF Communications Ltd'),(346857062400,'Doramu','Doramu Co.,Ltd.'),(346857066496,'Openpeak','OpenPeak, Inc.'),(346857070592,'Ads-Tec','ads-tec GmbH'),(346857074688,'OrbisOy','Orbis Oy'),(346857078784,'EsmartDi','Esmart Distribution Pte Ltd'),(346857082880,'NsfocusI','Nsfocus Information Technology C'),(346857086976,'TeslaAS','TESLA, a.s.'),(346857091072,'Ansa','ANSA Corporation'),(346857095168,'MatrixAu','Matrix Audio Designs'),(346857099264,'ValleyTe','Valley Tecnologia'),(346857103360,'GeneralR','General Resources Co., LTD.'),(346857107456,'GfiChron','GFI Chrono Time'),(346857111552,'Shenzhen','Shenzhen Hongdian Technologies.,'),(346857115648,'RoseTech','Rose Technologies'),(346857119744,'Mistleto','Mistletoe Technologies'),(346857123840,'Protonic','Protonic Holland'),(346857127936,'SaiaBurg','Saia Burgess Controls AG'),(346857132032,'ArgonSt','Argon ST'),(346857136128,'DigitalD','Digital Dynamics, Inc.'),(346857140224,'Westingh','Westinghouse Rail Systems Ltd'),(346857144320,'Bio-Logi','Bio-logic Systems Corp'),(346857148416,'MovazNet','Movaz Networks, Inc.'),(346857152512,'Elbit','Elbit Systems'),(346857156608,'Quantum3','Quantum3D, Inc.'),(346857160704,'BlackDia','Black Diamond Video, Inc.'),(346857164800,'ExrayBro','eXray Broadband Inc.'),(346857168896,'Rubin','Rubin Ltd.'),(346857172992,'Transbit','Transbit Sp.z o.o.'),(346857177088,'Neets',''),(346857181184,'Scirocco','Scirocco AB'),(346857185280,'YargBiom','Yarg Biometrics Limited'),(346857189376,'Verint','Verint Systems Ltd'),(346857193472,'Impedime','ImpediMed Limited'),(346857197568,'Bixi','Bixi Systems AG'),(346857201664,'OpenDate','Open Date Equipment Limited'),(346857205760,'Ziehl-Ab','Ziehl-Abegg AG'),(346857209856,'RcsEnerg','RCS Energy Management Ltd'),(346857213952,'SlicanSp','SLICAN sp. z o.o.'),(346857218048,'TwowayCa','Twoway CATV SERVICE INC.'),(346857222144,'ElprocSp','ELPROC sp. z o.o.'),(346857226240,'Herholdt','Herholdt Controls srl'),(346857230336,'SebaDesi','SEBA Design Pty Ltd'),(346857234432,'Ingenieu','IngenieurbÃ¼ro Schober'),(346857238528,'DeltaTau','Delta Tau Data Systems, Inc.'),(346857242624,'Avantry','Avantry Ltd.'),(346857246720,'GeSecuri','GE Security Kampro'),(346857250816,'Mediorne','MEDIORNET GmbH'),(346857254912,'AlfingMo','Alfing Montagetechnik GmbH'),(346857259008,'AceElect','Ace Electronics Inc.'),(346857263104,'TruteqWi','Truteq Wireless (PTY) Ltd.'),(346857267200,'GeneralD','General Dynamics C4 Systems'),(346857271296,'ThermoEl','Thermo Electron'),(346857275392,'Telematr','Telematrix'),(346857279488,'SsTeleco','SS Telecoms CC'),(346857283584,'AppliedR','Applied Research Laboratories: U'),(346857287680,'RomteckP','Romteck Pty Ltd'),(346857291776,'Embigenc','Embigence GmbH'),(346857295872,'Sedo','Sedo Systems Ltd'),(346857299968,'Photonic','Photonic Bridges  Inc.'),(346857304064,'Computer','Computerized Elevator Contol'),(346857308160,'SatelSpZ','SATEL sp. z o.o.'),(346857312256,'Seachang','Seachange international'),(346857316352,'Pmc',''),(346857320448,'Mandozzi','Mandozzi Elettronica SA'),(346857324544,'ThalesDe','Thales Defence and Security Syst'),(346857328640,'LabXTech','Lab X Technologies, LLC'),(346857332736,'BeijingC','Beijing Corelogic Communication '),(346857336832,'Creative','Creative Retail Entertainment'),(346857340928,'Medavant','MedAvant Healthcare'),(346857345024,'PacketIs','Packet Island Inc.'),(346857349120,'Tantroni','Tantronic AG'),(346857353216,'Autronic','Autronica Fire & Security'),(346857357312,'O2run',''),(346857361408,'MonroeEl','Monroe Electronics, Inc.'),(346857365504,'RealD','REAL D'),(346857369600,'Waveip','WaveIP Ltd.'),(346857373696,'ProdcoIn','Prodco International Inc.'),(346857377792,'RtdsTech','RTDS Technologies Inc.'),(346857381888,'Cambridg','Cambridge Technology, Inc.'),(346857385984,'BesTechn','BES Technology Group'),(346857390080,'Hwayoung','Hwayoung RF Solution Inc'),(346857394176,'NetworkA','Network Automation mxc AB'),(346857398272,'GemElett','GEM ELETTRONICA Srl'),(346857402368,'Dakty','Dakty GmbH'),(346857406464,'Orenco','Orenco Systems, Inc.'),(346857410560,'IbexUk','IBEX UK Limited'),(346857414656,'Criterio','Criterion Systems Limited'),(346857418752,'Respiron','RESPIRONICS INC.'),(346857422848,'Aphex','Aphex Systems Ltd.'),(346857426944,'Computer','Computerwise, Inc.'),(346857431040,'7+Kft','7+ Kft'),(346857435136,'MicroCon','Micro Connect Pty Ltd'),(346857439232,'Putercom','PUTERCOM ENTERPRISE CO., LTD.'),(346857443328,'Hillcres','Hillcrest Laboratories, Inc.'),(346857447424,'MonitorB','Monitor Business Machines Ltd'),(346857451520,'LogicBea','Logic Beach Inc'),(346857455616,'AirwiseT','AIRWISE TECHNOLOGY CO., LTD.'),(346857459712,'Clearson','Clearsonics Pty. Ltd.'),(346857463808,'Fibresav','Fibresavers Corporation'),(346857467904,'Polystar','Polystar Instruments AB'),(346857472000,'SummitDe','Summit Developmen'),(346857476096,'TecnaSrl','Tecna Srl'),(346857480192,'LinearAc','Linear Acoustic, Inc'),(346857484288,'GenieNet','Genie Network Resource Managemen'),(346857488384,'TadianEl','Tadian Electronics Systems LTD'),(346857492480,'Monaghan','Monaghan Engineering, Inc.'),(346857496576,'SowaElec','SOWA ELECTRIC CO., LTD.'),(346857500672,'SolidSta','Solid State Logic'),(346857504768,'ChristEl','Christ Elektronik GmbH'),(346857508864,'Dbmcorp','DBMCORP, Inc.'),(346857512960,'Speastec','SpeasTech, Inc.'),(346857517056,'BetaLase','Beta Lasermike Ltd'),(346857521152,'Toa','TOA Systems'),(346857525248,'Velux',''),(346857529344,'AlconTec','Alcon Technologies'),(346857533440,'Traquair','Traquair Data Systems, Inc.'),(346857537536,'MccainTr','McCain Traffic Supply'),(346857541632,'ArisTech','ARIS TECHNOLOGIES'),(346857545728,'MarkIvId','Mark IV IDS Corp.'),(346857549824,'AmrdecPr','AMRDEC Prototype Integration Fac'),(346857553920,'MotecPty','Motec Pty Ltd'),(346857558016,'Vastech',''),(346857562112,'AcSRO','AC SYSTEMS, s.r.o.'),(346857566208,'Irtrans',''),(346857570304,'TattileS','tattile srl'),(346857574400,'PhytecMe','Phytec Messtechnik GmbH'),(346857578496,'Omnitron','OMNITRONICS PTY LTD'),(346857582592,'SiconSRL','Sicon s.r.l.'),(346857586688,'VitecMul','VITEC MULTIMEDIA'),(346857590784,'Smartcom','Smartcom-Bulgaria AD'),(346857594880,'DspDesig','DSP DESIGN'),(346857598976,'Gesellsc','Gesellschaft fÃ¼r  Rationalisier'),(346857603072,'Innovati','Innovation, Institute, Inc'),(346857607168,'OrionTec','Orion Technologies, Incorporated'),(346857611264,'Nve','NVE Corporation'),(346857615360,'Nanshanb','NanShanBridge Co.Ltd'),(346857619456,'HyundaiJ','Hyundai J. Comm'),(346857623552,'MmsServi','MMS Servis s.r.o.'),(346857627648,'C2Diagno','C2 DIAGNOSTICS'),(346857631744,'DstContr','DST CONTROL AB'),(346857635840,'Ethertek','EtherTek Circuits'),(346857639936,'Detectio','Detection Technology Inc.'),(346857644032,'ImageCon','Image Control Design Limited'),(346857648128,'Teleks','Teleks Co. Ltd.'),(346857652224,'Marposs','Marposs SPA'),(346857656320,'DigitalC','Digital communications Technolog'),(346857660416,'Honeywel','Honeywell GNO'),(346857664512,'EllipsBV','Ellips B.V.'),(346857668608,'MesureCo','Mesure Controle Commande'),(346857672704,'WavesSys','WAVES SYSTEM'),(346857676800,'Avermedi','AVerMedia Technologies, Inc.'),(346857680896,'DigiSesn','DIGI SESN AG'),(346857684992,'Zetera',''),(346857689088,'Secuinfo','SecuInfo Co., Ltd.'),(346857693184,'Universi','Universidad de Chile Facultad de'),(346857697280,'BlankomA','BLANKOM Antennentechnik GmbH'),(346857701376,'ITWBetap','I.T.W. Betaprint'),(346857705472,'NetsyntS','Netsynt S.p.A.'),(346857709568,'IptcTech','IPTC Tech. Comm. AB'),(346857713664,'Innopsys',''),(346857717760,'Sintecno','Sintecnos srl'),(346857721856,'SilentSy','Silent System'),(346857725952,'Converge','Convergent Design'),(346857730048,'Valtroni','Valtronic SA'),(346857734144,'LjuAutom','LJU Automatisierungstechnik GmbH'),(346857738240,'Innovati','Innovative Neurotroncs'),(346857742336,'Elfiq','Elfiq Inc.'),(346857746432,'AthSyste','ATH system'),(346857750528,'Weinzier','Weinzierl Engineering GmbH'),(346857754624,'ControlA','Control Alternative Solutions, I'),(346857758720,'Freiburg','Freiburger BlickZentrum'),(346857762816,'Netcomse','Netcomsec'),(346857766912,'BedoElek','Bedo Elektronik GmbH'),(346857771008,'FailSafe','Fail Safe Solutions LLC'),(346857775104,'Valde','Valde Systems, Inc.'),(346857779200,'MatrixTe','MATRIX TELECOM PVT. LTD.'),(346857783296,'Ads-Tec','ads-tec GmbH'),(346857787392,'AcdElekt','ACD Elektronik GmbH'),(346857791488,'HanzasEl','HANZAS ELEKTRONIKA, SIA'),(346857795584,'MoogBroa','Moog Broad Reach'),(346857799680,'ProconEl','Procon Electronics'),(346857803776,'SeitecEl','Seitec Elektronik GmbH'),(346857807872,'C21Techn','C21 Technology Limited'),(346857811968,'OrtratSL','ORTRAT, S.L.'),(346857816064,'LastMile','Last Mile Gear'),(346857820160,'Workpowe','WORKPOWER TECNOLOGIA ELETRONICA '),(346857824256,'Ubinetsy','ubinetsys.co..ltd'),(346857828352,'Tess','Tess GmbH'),(346857832448,'Geofocus','GeoFocus, LLC'),(346857836544,'TwinwinT','Twinwin Technplogy Co.,Ltd.'),(346857840640,'GrupoEpe','Grupo Epelsa S.L.'),(346857844736,'DatatonU','Dataton Utvecklings AB'),(346857848832,'Targeted','Targeted Technologies, LLC'),(346857852928,'Computro','Computrol Fuel Systems Inc.'),(346857857024,'Lab-ElEl','LAB-EL ELEKTRONIKA LABORATORYJNA'),(346857861120,'GmaLlc','GMA, LLC'),(346857865216,'EllexMed','Ellex Medical Pty Ltd'),(346857869312,'OberonSe','Oberon Service srl'),(346857873408,'ChellIns','Chell Instruments Ltd'),(346857877504,'Datamicr','DATAMICRO Co., Ltd.'),(346857881600,'Ingenier','IngenierÃ­a AlmudÃƒÂ­ S.L.'),(346857885696,'Solystic',''),(346857889792,'Visi-Tec','Visi-tech Systems Ltd'),(346857893888,'Advanced','Advanced Software Technologies'),(346857897984,'DelphiDi','Delphi Display Systems, Inc.'),(346857902080,'Gastager','Gastager Systemtechnik GmbH'),(346857906176,'PigeonPo','Pigeon Point Systems LLC'),(346857910272,'Ptswitch',''),(346857914368,'Cybersys',''),(346857918464,'SierraVi','Sierra Video Systems'),(346857922560,'DigitalW','Digital Way'),(346857926656,'Orderite','Orderite, Inc.'),(346857930752,'BuyangEl','Buyang Electronics Industrial co'),(346857934848,'Devitech','Devitech ApS'),(346857938944,'Allsun','AllSun A/S'),(346857943040,'JÃ¼ngerAu','JÃ¼nger Audio-Studiotechnik GmbH'),(346857947136,'ToyotaMo','Toyota Motorsport GmbH'),(346857951232,'Wireless','Wireless Cables Inc'),(346857955328,'Genetix','Genetix Ltd'),(346857959424,'Dynalco',''),(346857963520,'FederalE','Federal Electronics'),(346857967616,'HoribaMe','HORIBA MEDICAL'),(346857971712,'DixellSP','Dixell S.p.a.'),(346857975808,'Innovati','Innovative Dynamics GmbH'),(346857979904,'LatticeS','Lattice Semiconductor Corp. (LPA'),(346857984000,'Zao',''),(346857988096,'PennyGil','Penny & Giles Aerospace Ltd'),(346857992192,'XoipPty','XoIP Systems Pty Ltd'),(346857996288,'EmMotors','EM Motorsport Ltd'),(346858000384,'Grosveno','Grosvenor Technology Ltd'),(346858004480,'PalodexG','PaloDEx Group Oy'),(346858008576,'Broadlig','Broadlight'),(346858012672,'PixelVel','Pixel Velocity, Inc.'),(346858016768,'Callpod','Callpod, Inc.'),(346858020864,'Spansion',''),(346858024960,'Nautel','Nautel Limited'),(346858029056,'Bundesam','Bundesamt fÃ¼r Strahlenschutz'),(346858033152,'FenTechn','Fen Technology Limited'),(346858037248,'Multitro','MultiTrode Pty Ltd'),(346858041344,'Sapec',''),(346858045440,'DelsatGr','DELSAT GROUP S.A.'),(346858049536,'DssNetwo','DSS Networks, Inc.'),(346858053632,'Legerity',''),(346858057728,'Ads-Tec','ads-tec GmbH'),(346858061824,'RudolphT','Rudolph Technologies, Inc.'),(346858065920,'Vestfold','Vestfold Butikkdata AS'),(346858070016,'Inet','iNET Systems Inc.'),(346858074112,'LumelSA','LUMEL S.A.'),(346858078208,'FederalS','Federal State Unitary Enterprise'),(346858082304,'EquiposD','Equipos de TelecomunicaciÃ³n  Op'),(346858086400,'PlasticL','Plastic Logic'),(346858090496,'PhytecMe','Phytec Messtechnik GmbH'),(346858094592,'EtapNv','ETAP NV'),(346858098688,'AycTelec','AYC Telecom Ltd'),(346858102784,'Transenn','Transenna AB'),(346858106880,'EatonEle','Eaton Corporation  Electrical Gr'),(346858110976,'Kinemetr','Kinemetrics, Inc.'),(346858115072,'Emcom','Emcom Systems'),(346858119168,'CpsEurop','CPS EUROPE B.V.'),(346858123264,'DorletSA','DORLET S.A.'),(346858127360,'Incotec','INCOTEC GmbH'),(346858131456,'Rosta','Rosta Ltd'),(346858135552,'Syntroni','Syntronic AB'),(346858139648,'HitecomS','HITECOM System'),(346858143744,'Terrasci','Terrascience Systems Ltd.'),(346858147840,'Rafael',''),(346858151936,'KontronB','Kontron (Beijing) Technology Co.'),(346858156032,'Avermedi','AVerMedia Technologies, Inc.'),(346858160128,'Westfali','WestfaliaSurge GmbH'),(346858164224,'TaiwanVi','Taiwan Video & Monitor'),(346858168320,'SaiaBurg','SAIA Burgess Controls AG'),(346858172416,'UnicTech','UNIC TECHNOLOGIES INC'),(346858176512,'Guangzho','Guangzhou Hui Si Information Tec'),(346858180608,'NomusCom','Nomus Comm-Systems'),(346858184704,'CardAcce','Card Access Services Pty Ltd'),(346858188800,'TechimpS','Techimp Systems S.r.l.'),(346858192896,'Pyott-Bo','Pyott-Boone Electronics'),(346858196992,'RLDrake','R. L. Drake Company'),(346858201088,'Intuitiv','Intuitive Surgical'),(346858205184,'KsSystem','KS System GmbH'),(346858209280,'Promik','ProMik GmbH'),(346858213376,'RadiantI','Radiant Imaging, Inc.'),(346858217472,'Technisc','Technische Alternative GmbH'),(346858221568,'InsyncTe','InSync Technology Ltd'),(346858225664,'GeorgiaT','Georgia Tech Research Institute'),(346858229760,'Shenzhen','Shenzhen Quanlong Technique Co.L'),(346858233856,'BuyangEl','Buyang Electronics Industrial Co'),(346858237952,'KoboldSi','Kobold Sistemi s.r.l.'),(346858242048,'Enseo',''),(346858246144,'RadaElec','RADA Electronics Industries Ltd.'),(346858250240,'RokeMano','Roke Manor Research Ltd'),(346858254336,'InnomedM','Innomed Medical Inc'),(346858258432,'Automata','Automata Spa'),(346858262528,'MeucciSo','Meucci Solutions'),(346858266624,'Da-Desig','DA-Design Oy'),(346858270720,'Wexiodis','Wexiodisk AB'),(346858274816,'BuyangEl','Buyang Electronics Industrial Co'),(346858278912,'CannonTe','Cannon Technologies'),(346858283008,'Bioacces','BioAccess Tecnologia em Biometri'),(346858287104,'Synrad','Synrad, Inc.'),(346858291200,'Technifo','TECHNIFOR SAS'),(346858295296,'CrimsonM','Crimson Microsystems, Inc.'),(346858299392,'TonnaEle','TONNA ELECTRONIQUE'),(346858303488,'CegelecS','CEGELEC SUD EST'),(346858307584,'RmMichae','RM Michaelides Software & Elektr'),(346858311680,'Somerdat','SomerData ltd'),(346858315776,'MagalSen','Magal Senstar Inc.'),(346858319872,'Gnutek','Gnutek Ltd.'),(346858323968,'PhytecMe','Phytec Messtechnik GmbH'),(346858328064,'IttiamP','Ittiam Systems (P) Ltd'),(346858332160,'PyramidC','PYRAMID Computer GmbH'),(346858336256,'Computec','Computechnic AG'),(346858340352,'BuyangEl','Buyang Electronics Industrial Co'),(346858344448,'Stresste','Stresstech OY'),(346858348544,'Musatel',''),(346858352640,'EadsTest','EADS TEST & SERVICES'),(346858356736,'Info-Chi','Info-Chip Communications Ltd.'),(346858360832,'MicroTec','Micro Technology Services Inc.'),(346858364928,'MicroEle','Micro Elektronische Producten'),(346858369024,'GarperTe','Garper Telecomunicaciones, S.L.'),(346858373120,'AsisTech','ASiS Technologies Pte Ltd'),(346858377216,'Aquarott','AQUAROTTER A FRANKE COMPANY'),(346858381312,'Condre','Condre Corporation'),(346858385408,'Pikkerto','pikkerton GmbH'),(346858389504,'DiasInfr','DIAS Infrared GmbH'),(346858393600,'Technoma','Technomarine JSC'),(346858397696,'EsemGrÃ¼n','ESEM GrÃ¼nau GmbH & Co. KG'),(346858401792,'PosnetPo','POSNET Polska S.A.'),(346858405888,'Teamproj','TeamProjects BV'),(346858409984,'Genesis','Genesis inc'),(346858414080,'Cambridg','CAMBRIDGE CONSULTANTS LTD'),(346858418176,'Metrolog','Metrologic Group'),(346858422272,'GrupoEpe','Grupo Epelsa S.L.'),(346858426368,'RotharyS','ROTHARY Solutions AG'),(346858430464,'LeaDOO','LEA d.o.o.'),(346858434560,'All-Syst','All-Systems Electronics Pty Ltd'),(346858438656,'Filmligh','FilmLight Limited'),(346858442752,'MegElect','MEG Electronic Inc.'),(346858446848,'Novacomm',''),(346858450944,'GazelleM','Gazelle Monitoring Systems'),(346858455040,'ProtecFi','Protec Fire Detection plc'),(346858459136,'Medavant','MedAvant Healthcare'),(346858463232,'ChauvinA','CHAUVIN ARNOUX'),(346858467328,'Cerus','Cerus Corp'),(346858471424,'HcjbGlob','HCJB Global'),(346858475520,'Swistec','Swistec GmbH'),(346858479616,'Shenzhen','Shenzhen Huazhong Technology Inc'),(346858483712,'TelecomF','Telecom FM'),(346858487808,'SilexInd','Silex Industrial Automation Ltd.'),(346858491904,'Toptech','Toptech Systems, Inc.'),(346858496000,'GradualT','Gradual Tecnologia Ltda.'),(346858500096,'Shanghai','Shanghai QianJin Electronic Equi'),(346858504192,'Identic','IDENTIC AB'),(346858508288,'SiconSRL','Sicon s.r.l.'),(346858512384,'Automati','Automation and Control Technolog'),(346858516480,'Kommunik','Kommunikations- & Sicherheitssys'),(346858520576,'FdtManuf','FDT Manufacturing, LLC'),(346858524672,'Brookhav','Brookhaven National Laboratory'),(346858528768,'Ihp-Gmbh',''),(346858532864,'TattileS','TATTILE SRL'),(346858536960,'SicomAs','SICOM AS'),(346858541056,'AxisElec','Axis Electronics'),(346858545152,'Honeywel','Honeywell'),(346858549248,'Narinet','NARINET, INC.'),(346858553344,'Intergra','Intergrated Security Mfg. Ltd'),(346858557440,'Linkbit','Linkbit, Inc.'),(346858561536,'Communic','Communication Components Inc.'),(346858565632,'NciTechn','NCI Technologies Inc.'),(346858569728,'Testpro','TestPro Systems, Inc.'),(346858573824,'Sutus','Sutus Inc'),(346858577920,'LesterEl','LESTER ELECTRONICS LTD'),(346858582016,'ImagineC','Imagine Communications'),(346858586112,'Harman/B','Harman/Becker Automotive Systems'),(346858590208,'Version-','Version-T'),(346858594304,'2nTeleko','2N TELEKOMUNIKACE a.s.'),(346858598400,'Safeline','SAFELINE SL'),(346858602496,'ComtestN','Comtest Networks'),(346858606592,'Ebneuro','EBNeuro SpA'),(346858610688,'WinsysIn','Winsys Informatica ltda'),(346858614784,'Junglesy','JungleSystem Co., Ltd.'),(346858618880,'DareDeve','DARE Development'),(346858622976,'Macdonal','MacDonald Humfrey (Products) Ltd'),(346858627072,'PrismaEn','Prisma Engineering srl'),(346858631168,'FirstCon','First Control Systems AB'),(346858635264,'Airmatri','AirMatrix, Inc.'),(346858639360,'ProconEl','Procon Electronics'),(346858643456,'TdmIngÃ©n','TDM IngÃ©nierie'),(346858647552,'Qes',''),(346858651648,'AuroraFl','Aurora Flight Sciences'),(346858655744,'Fraunhof','Fraunhofer IIS'),(346858659840,'Rosetech','RoseTechnology A/S'),(346858663936,'RiceUniv','Rice University'),(346858668032,'Sohon','Sohon Inc'),(346858672128,'Shockfis','Shockfish SA'),(346858676224,'Dspace','dSPACE GmbH'),(346858680320,'Omnitrol','Omnitrol Networks, Inc.'),(346858684416,'Hungaroc','HUNGAROCOM Telecommunication Ltd'),(346858688512,'Qstreams','Qstreams Networks Inc.'),(346858692608,'3dsp','3DSP Corporation'),(346858696704,'Powis','Powis Corporation'),(346858700800,'DpictIma','dPict Imaging, Inc.'),(346858704896,'Iders','IDERs Inc'),(346858708992,'T2Commun','T2 Communication Ltd'),(346858713088,'SpeechTe','Speech Technology Center, Ltd.'),(346858717184,'Iac',''),(346858721280,'NeoInfor','NEO Information Systems Co., Ltd'),(346858725376,'StantonT','Stanton Technologies Sdn Bhd'),(346858729472,'Enatel','Enatel Limited'),(346858733568,'PhytecMe','Phytec Messtechnik GmbH'),(346858737664,'Software','The Software Group Limited'),(346858741760,'Trutouch','TRUTOUCH TECHNOLOGIES INC'),(346858745856,'R&DTechn','R&D Technology Solutionz Limited'),(346858749952,'Fidelity','Fidelity Comtech, Inc.'),(346858754048,'Pan-Star','Pan-STARRS'),(346858758144,'Cpqd',''),(346858762240,'Mangodsp',''),(346858766336,'Cis','CIS Corporation'),(346858770432,'TeraInfo','Tera Information System Labs'),(346858774528,'Northern','Northern Power'),(346858778624,'MaLighti','MA Lighting Technology GmbH'),(346858782720,'LiquidBr','Liquid Breaker, LLC'),(346858786816,'Staer','STAER SPA'),(346858790912,'WidecoSw','Wideco Sweden AB'),(346858795008,'DobleEng','Doble Engineering'),(346858799104,'PalodexG','PaloDEx Group Oy'),(346858803200,'PhysikIn','Physik Instrumente (PI) GmbH&Co.'),(346858807296,'LdaAudio','LDA Audio Video Profesional'),(346858811392,'MonytelS','MONYTEL S.A.'),(346858815488,'Openpkg','OpenPKG GmbH'),(346858819584,'DorsettT','Dorsett Technologies, Inc.'),(346858823680,'Hisstema','Hisstema AB'),(346858827776,'Silverbr','Silverbrook Research'),(346858831872,'VtzDOO','VTZ d.o.o.'),(346858835968,'RedfoneC','Redfone Communications LLC'),(346858840064,'Cantion','Cantion A/S'),(346858844160,'Invocon','Invocon, Inc.'),(346858848256,'Izisoft',''),(346858852352,'PCE','P.C.E.'),(346858856448,'AsiaPaci','Asia Pacific Card & System Sdn B'),(346858860544,'Coe','COE Limited'),(346858864640,'WestelWi','Westel Wireless Systems'),(346858868736,'Networks','NetworkSound, Inc'),(346858872832,'XworksNz','Xworks NZ Limited'),(346858881024,'KeithKoe','Keith & Koep GmbH'),(346858885120,'DspDesig','DSP DESIGN'),(346858889216,'AbbXiame','ABB Xiamen Transmission and Dist'),(346858893312,'Flsystem',''),(346858897408,'Desy',''),(346858901504,'DigitekS','DIGITEK S.p.A.'),(346858905600,'Linear','Linear Systems Ltd.'),(346858909696,'Nilan','Nilan A/S'),(346858913792,'NaimAudi','Naim Audio'),(346858917888,'SkylineP','Skyline Products, Inc'),(346858921984,'DdsElett','DDS Elettronica srl'),(346858926080,'FerrariE','Ferrari electronic AG'),(346858930176,'ProtechO','Protech Optronics Co., Ltd.'),(346858934272,'KentonRe','Kenton Research Ltd'),(346858938368,'Eds',''),(346858942464,'ProconxP','ProconX Pty Ltd'),(346858946560,'Ihm',''),(346858950656,'Industri','Industrial Vacuum Systems'),(346858954752,'Cc','CC Systems AB'),(346858958848,'SpartonE','Sparton Electronics'),(346858962944,'Aircell','AirCell, Inc.'),(346858967040,'EsaMesst','ESA  Messtechnik GmbH'),(346858971136,'SaiaBurg','SAIA Burgess Controls AG'),(346858975232,'PhytecMe','Phytec Messtechnik GmbH'),(346858979328,'HoneyNet','Honey Network Research Limited'),(346858983424,'OwasysAd','Owasys Advanced Wireless Devices'),(346858987520,'Commet','Commet AB'),(346858991616,'MeggittS','MEGGITT Safety System'),(346858995712,'ReasonTe','REASON Tecnologia S.A.'),(346858999808,'Datamars','Datamars SA'),(346859003904,'AnnaxAnz','ANNAX Anzeigesysteme GmbH'),(346859008000,'AccessSp','Access Specialties, Inc'),(346859012096,'ElkProdu','Elk Products'),(346859016192,'RfCode','RF Code, Inc.'),(346859020288,'ZhuhaiJi','Zhuhai Jiahe Electronics Co.,LTD'),(346859024384,'Simtek','SIMTEK INC.'),(346859028480,'Isochron','Isochron Inc'),(346859032576,'CxrLarus','CXR Larus Corporation'),(346859036672,'Selco',''),(346859040768,'Bertroni','BERTRONIC SRL'),(346859044864,'GhlBerha','GHL Systems Berhad'),(346859048960,'Interopi','Interopix, Inc.'),(346859053056,'MateMedi','Mate Media Access Technologies'),(346859057152,'TechComm','Tech Comm, Inc.'),(346859061248,'InitelSr','Initel srl'),(346859065344,'Purelink','Purelink Technology, inc.'),(346859069440,'Casabyte','Casabyte Inc.'),(346859073536,'MonarchI','Monarch Instrument'),(346859077632,'NavtechR','Navtech Radar Ltd'),(346859081728,'Bulleten','Bulletendpoints Enterprises Inc'),(346859085824,'Storetec','StoreTech Limited'),(346859089920,'TsienUk','Tsien (UK) Ltd'),(346859094016,'BugLabs','Bug Labs, Inc.'),(346859098112,'Dvation','Dvation.co.,Ltd'),(346859102208,'Ideus','Ideus AB'),(346859106304,'TotalRfL','Total RF, LLC'),(346859110400,'GfpLabSR','GFP Lab S.r.l.'),(346859114496,'Pricol','PRICOL LIMITED'),(346859118592,'CadiScie','Cadi Scientific Pte Ltd'),(346859122688,'Createch','CreaTech Electronics Co.'),(346859126784,'Teletask',''),(346859130880,'FhfFunke','FHF Funke+Huster Fernsig GmbH'),(346859134976,'VictoryC','Victory Concept Industries Ltd.'),(346859139072,'HoerIndu','Hoer GmbH & Co. Industrie-Electr'),(346859143168,'DelcanTe','Delcan Technologies, Inc'),(346859147264,'ArmidaTe','Armida Technologies Corporation'),(346859151360,'Ifox-Ind','Ifox - Industria e Comercio Ltda'),(346859155456,'Software','Softwareentwicklung'),(346859159552,'ThalesUk','Thales UK'),(346859163648,'Heim-BÃ¼r','Heim- & BÃ¼rokommunikation'),(346859167744,'Qualisys','Qualisys AB'),(346859171840,'Nanoradi','Nanoradio AB'),(346859175936,'SmartKey','Smart Key International Limited'),(346859180032,'BurkTech','Burk Technology'),(346859184128,'Edgeware','Edgeware AB'),(346859188224,'4rfCommu','4RF Communications Ltd'),(346859192320,'Somesca',''),(346859196416,'Triumf',''),(346859200512,'Commodas','CommoDaS GmbH'),(346859204608,'SystemLs','System LSI CO.Ltd.'),(346859208704,'EpecOy','Epec Oy'),(346859212800,'Unipo','unipo GmbH'),(346859216896,'FertronC','Fertron Controle e Automacao Ind'),(346859220992,'EleMagSR','Ele.Mag S.r.l.'),(346859225088,'Paraytec','Paraytec Ltd'),(346859229184,'MitronOy','Mitron Oy'),(346859233280,'Estec','ESTEC Co.,Ltd.'),(346859237376,'Optoplan','Optoplan as'),(346859241472,'GlosterS','GLOSTER SANTE EUROPE'),(346859245568,'RadiusSw','RADIUS Sweden AB'),(346859249664,'Hoseotel','HoseoTelnet Inc...'),(346859253760,'Itracs','iTRACS Corporation'),(346859257856,'Rexxon','REXXON GmbH'),(346859261952,'Oerlikon','Oerlikon Contraves AG'),(346859266048,'Medavant','MedAvant Healthcare Solutions'),(346859270144,'Quickcir','QuickCircuit Ltd.'),(346859274240,'B&SMedia','B&S MEDIA CO., LTD.'),(346859278336,'Netami',''),(346859282432,'DynamicH','Dynamic Hearing Pty Ltd'),(346859286528,'StreamPr','Stream Processors'),(346859290624,'WidmerTi','Widmer Time Recorder Co., Inc.'),(346859294720,'Rgm','RGM SPA'),(346859298816,'EmitallS','EMITALL Surveillance S.A,'),(346859302912,'Microway',''),(346859307008,'EdsSyste','EDS Systemtechnik'),(346859311104,'Schnick-','Schnick-Schnack-Systems GmbH'),(346859315200,'Lumistar','Lumistar Incorporated'),(346859319296,'Digisens','DigiSensory technologies Pty Ltd'),(346859323392,'EtaniEle','Etani Electronics Co.,Ltd.'),(346859327488,'BeckerEl','Becker Electronics GmbH'),(346859331584,'AdlElect','ADL Electronics Ltd.'),(346859335680,'MavenirS','Mavenir System, Inc.'),(346859339776,'BlHealth','BL Healthcare, Inc.'),(346859343872,'AjecoOy','Ajeco Oy'),(346859347968,'TechnoFi','Techno Fittings S.r.l.'),(346859352064,'Gebhardt','Gebhardt Ventilatoren GmbH'),(346859356160,'L-3Commu','L-3 Communications Mobile-Vision'),(346859360256,'Zmicro','Zmicro Systems Inc'),(346859364352,'LaserToo','Laser Tools & Technics Corp.'),(346859368448,'QrScienc','QR Sciences Ltd'),(346859372544,'Firsttru','FIRSTTRUST Co.,Ltd.'),(346859376640,'Newonsys','NewOnSys Ltd.'),(346859380736,'PhytecMe','PHYTEC Messtechnik GmbH'),(346859384832,'MirosAs','Miros AS'),(346859388928,'Mangodsp',''),(346859393024,'Boeckele','Boeckeler Instruments, Inc.'),(346859397120,'Lanetco',''),(346859401216,'AxisNetw','Axis Network Technology'),(346859405312,'Anymax',''),(346859409408,'BandoEle','Bando electronic communication C'),(346859413504,'FirstecS','FIRSTEC SA'),(346859417600,'Harrison','Harrison Audio, LLC'),(346859421696,'Netistix','Netistix Technologies Corporatio'),(346859425792,'SechanEl','Sechan Electronics, Inc.'),(346859429888,'Interact','Interactive Electronic Systems'),(346859433984,'Pneumopa','Pneumopartners LaenneXT SA'),(346859438080,'StanleyS','Stanley Security Solutions, Inc.'),(346859442176,'ItsTelec','ITS Telecom'),(346859446272,'LaserEle','Laser Electronics Ltd'),(346859450368,'E3switch','E3Switch LLC'),(346859454464,'Cryogeni','Cryogenic Control Systems, Inc.'),(346859458560,'KitronMi','Kitron Microelectronics AB'),(346859462656,'AvSatcom','AV SatCom AS'),(346859466752,'Infoplan','infoplan GesellschaftfÃ¼r  Infor'),(346859470848,'RvTechno','RV Technology Limited'),(346859474944,'Revox','Revox GmbH'),(346859479040,'Dcn',''),(346859483136,'Waveip',''),(346859487232,'ActeSpZO','Acte Sp. z o.o.'),(346859491328,'SaiaBurg','SAIA Burgess Controls AG'),(346859495424,'BlueOrig','Blue Origin'),(346859499520,'StMichae','St. Michael Strategies Inc.'),(346859503616,'Gem-MedS','GEM-MED SL'),(346859507712,'KeithKoe','Keith & Koep GmbH'),(346859511808,'SpmInstr','SPM Instrument AB'),(346859515904,'SaeIt-Sy','SAE IT-systems GmbH & Co. KG'),(346859520000,'DiniGrou','The Dini Group, La Jolla inc.'),(346859524096,'HauchBac','Hauch & Bach ApS'),(346859528192,'Diodigiw','DioDigiWorks. CO., LTD.'),(346859532288,'DtechLab','DTech Labs Inc'),(346859536384,'SmartekD','Smartek d.o.o.'),(346859540480,'RoVeRLab','RO.VE.R. Laboratories S.p.A'),(346859544576,'Efficien','Efficient Channel Coding'),(346859548672,'BEARSolu','B.E.A.R. Solutions (Australasia)'),(346859552768,'Exertus',''),(346859556864,'Ela-Soft','ela-soft GmbH & Co. KG'),(346859560960,'AudicoOy','AUDICO SYSTEMS OY'),(346859565056,'ZumbachE','Zumbach Electronic AG'),(346859569152,'WhartonE','Wharton Electronics Ltd'),(346859573248,'LinkitSR','LINKIT S.R.L.'),(346859577344,'PasanSa','Pasan SA'),(346859581440,'3dx-Ray','3DX-Ray Limited'),(346859585536,'TEAmSA','T.E.AM., S. A.'),(346859589632,'Riexinge','RIEXINGER Elektronik'),(346859593728,'MitrolSR','MITROL S.R.L.'),(346859597824,'MbConnec','MB Connect Line GmbH'),(346859601920,'IllunisL','illunis LLC'),(346859606016,'Ennovati','ennovatis GmbH'),(346859610112,'LogusBro','Logus Broadband Wireless Solutio'),(346859614208,'AdvaOpti','ADVA Optical Networking'),(346859618304,'Elmec','Elmec Inc.'),(346859622400,'MgSRL','MG s.r.l.'),(346859626496,'AskiIndu','ASKI Industrie Elektronik Ges.m.'),(346859630592,'AscTelec','ASC telecom AG'),(346859634688,'Colorado','Colorado Engineering Inc.'),(346859638784,'Spectrum','Spectrum Communications FZE'),(346859642880,'CentricT','Centric TSolve BV'),(346859646976,'PowerEle','Power Electronics'),(346859651072,'Hsc-Rege','HSC-Regelungstechnik GmbH'),(346859655168,'DspDesig','DSP DESIGN'),(346859659264,'EtaSyste','eta systemi CKB'),(346859663360,'Pelwecky','Pelweckyj Videotechnik GmbH'),(346859667456,'Interdig','InterDigital Canada Ltd'),(346859671552,'SpContro','SP Controls, Inc'),(346859675648,'PhytecMe','Phytec Messtechnik GmbH'),(346859679744,'Sequeste','Sequestered Solutions'),(346859683840,'RichardG','Richard Griessbach Feinmechanik '),(346859687936,'Physical','Physical Acoustics Corporation'),(346859692032,'SncfEimP','SNCF EIM PAYS DE LOIRE'),(346859696128,'Priority','Priority Electronics Ltd'),(346859700224,'HaberKoe','haber & koenig electronics gmbh'),(346859704320,'SpirentC','Spirent Communications'),(346859708416,'Schlumbe','Schlumberger K.K.'),(346859712512,'Cimetric','Cimetrics Research Pty Ltd'),(346859716608,'Cardiome','CardioMEMS Inc.'),(346859720704,'AntLamp','Ant Lamp, Inc'),(346859724800,'Nika','Nika Ltd'),(346859728896,'Teradici','Teradici Corporation'),(346859732992,'MiracomT','Miracom Technology Co., Ltd.'),(346859737088,'TattileS','Tattile srl'),(346859741184,'Naturela','Naturela Ltd.'),(346859745280,'OnAirNet','On Air Networks'),(346859749376,'Simicon',''),(346859753472,'Cryptiri','cryptiris'),(346859757568,'QuantecN','Quantec Networks GmbH'),(346859761664,'Medav','MEDAV GmbH'),(346859765760,'McquayCh','McQuay China'),(346859769856,'Dain',''),(346859773952,'Fantuzzi','Fantuzzi Reggiane'),(346859778048,'Elektro-','Elektro-Top 3000 Ltd.'),(346859782144,'Avonaco','Avonaco Systems, Inc.'),(346859786240,'Acisa',''),(346859790336,'Realtron','Realtronix Company'),(346859794432,'CdsaDamN','CDSA Dam Neck'),(346859798528,'Letechni','Letechnic Ltd'),(346859802624,'Affolter','Affolter Technologies SA'),(346859806720,'MonitorE','MONITOR ELECTRONICS LTD'),(346859810816,'Star-Dun','STAR-Dundee Ltd'),(346859814912,'Saia-Bur','Saia-Burgess Controls AG'),(346859819008,'BeceemCo','Beceem Communications, Inc.'),(346859823104,'Tronico',''),(346859827200,'GermanTe','German Technologies'),(346859831296,'Brightli','Brightlights Intellectual Proper'),(346859835392,'E&SEngin','e&s Engineering & Software GmbH'),(346859839488,'LoberSA','LOBER, S.A.'),(346859843584,'Abb',''),(346859847680,'Abeo','Abeo Corporation'),(346859851776,'TeletekE','Teletek Electronics'),(346859855872,'Chesapea','Chesapeake Sciences Corp'),(346859859968,'ESPTechn','E S P Technologies Ltd'),(346859864064,'Aixsolve','AixSolve GmbH'),(346859868160,'Sequentr','Sequentric Energy Systems, LLC'),(346859872256,'GaislerR','Gaisler Research AB'),(346859876352,'DmtSyste','DMT System S.p.A.'),(346859880448,'StÃ¶rk-Tr','STÃ–RK-TRONIC StÃ¶rk GmbH&Co. KG'),(346859884544,'FluidAna','Fluid Analytics, Inc.'),(346859888640,'Sky-Skan','Sky-Skan, Incorporated'),(346859892736,'BRexroth','B. Rexroth the identity company '),(346859896832,'ArS','AR`S CO., LTD.'),(346859900928,'ElbitOfA','Elbit Systems of America - Fort '),(346859905024,'Assembly','Assembly Contracts Limited'),(346859909120,'Xtendwav','XtendWave'),(346859913216,'Argus-Sp','Argus-Spectrum'),(346859917312,'PhytecMe','Phytec Messtechnik GmbH'),(346859921408,'Guterman','Gutermann Technology GmbH'),(346859925504,'Eid',''),(346859929600,'ControlS','Control Service do Brasil Ltda'),(346859933696,'Bes','BES GmbH'),(346859937792,'Digidriv','Digidrive Audio Limited'),(346859941888,'Putercom','Putercom Enterprise Co., LTD.'),(346859945984,'EfgCzSpo','EFG CZ spol. s r.o.'),(346859950080,'Mobilism','Mobilisme'),(346859954176,'Crinia','Crinia Corporation'),(346859958272,'ControlA','Control and Robotics Solutions'),(346859962368,'CadexEle','Cadex Electronics Inc.'),(346859966464,'ZigbeeAl','ZigBee Alliance'),(346859970560,'IesElekt','IES Elektronikentwicklung'),(346859974656,'PointeCo','Pointe Conception Medical Inc.'),(346859978752,'Geosig','GeoSIG Ltd.'),(346859982848,'Laserdyn','Laserdyne Technologies'),(346859986944,'Integrat','Integrated Security Corporation'),(346859991040,'EuroDisp','Euro Display Srl'),(346859995136,'SungardV','SunGard Vivista'),(346859999232,'CoralTel','Coral Telecom Ltd'),(346860003328,'SmithMet','Smith Meter, Inc'),(346860007424,'ItibiaTe','Itibia Technologies, Inc.'),(346860011520,'AtecSrl','ATEC SRL'),(346860015616,'LincolnI','Lincoln Industrial'),(346860019712,'Cominfo','Cominfo Inc.'),(346860023808,'AcdElekt','ACD Elektronik GmbH'),(346860027904,'IqSoluti','IQ Solutions GmbH & Co. KG'),(346860032000,'Starling','Starling Advanced Communications'),(346860036096,'PhytecMe','Phytec Mestechnik GmbH'),(346860040192,'Norma','NORMA systems GmbH'),(346860044288,'LewisCon','Lewis Controls Inc.'),(346860048384,'IconTime','Icon Time Systems'),(346860052480,'KeithKoe','Keith & Koep GmbH'),(346860056576,'AustcoCo','Austco Communication Systems Pty'),(346860060672,'HosaTech','HOSA TECHNOLOGY, INC.'),(346860064768,'Rosslare','Rosslare Enterprises Limited'),(346860068864,'LevelTel','LEVEL TELECOM'),(346860072960,'OmicronE','OMICRON electronics GmbH'),(346860077056,'Giga-Tro','Giga-tronics, Inc.'),(346860081152,'Telairit','Telairity'),(346860085248,'Globalco','GLOBALCOM ENGINEERING SRL'),(346860089344,'ElmarEle','ELMAR electronic'),(346860093440,'GeSecuri','GE Security-Kampro'),(346860097536,'MSquared','M Squared Lasers Limited'),(346860101632,'Smartro','SMARTRO Co.,Ltd.'),(346860105728,'EnertexB','Enertex Bayern GmbH'),(346860109824,'Comsonic','COMSONICS, INC.'),(346860113920,'Ameli','Ameli Spa'),(346860118016,'DorletSA','DORLET S.A.'),(346860122112,'Tiefenba','Tiefenbach Control Systems GmbH'),(346860126208,'Indefia',''),(346860130304,'Aavd',''),(346860134400,'JmcAmeri','JMC America, LLC'),(346860138496,'Schniewi','Schniewindt GmbH & Co. KG'),(346860142592,'Vital','Vital Systems Inc'),(346860146688,'Miratrek',''),(346860150784,'BenshawC','Benshaw Canada Controls, Inc.'),(346860154880,'ZaoNpc','ZAO NPC'),(346860158976,'Medavant','MedAvant Healthcare'),(346860163072,'FieldDes','Field Design Service'),(346860167168,'RaysatIs','RaySat Israel LTD'),(346860171264,'AbbTrans','ABB Transmission and Distributio'),(346860175360,'CalibreU','Calibre UK LTD'),(346860179456,'QuantumM','Quantum Medical Imaging'),(346860183552,'AsianaId','ASIANA IDT'),(346860187648,'Guidance','Guidance Navigation Limited'),(346860191744,'Integrat','Integrated Design Tools, Inc.'),(346860195840,'DeltaTau','Delta Tau Data Systems, Inc'),(346860199936,'GrupoEpe','Grupo Epelsa S.L.'),(346860204032,'GeneralM','General Microsystems Sdn Bhd'),(346860208128,'IusaSaDe','IUSA SA DE CV'),(346860212224,'TurunTur','Turun Turvatekniikka Oy'),(346860216320,'GlobalTe','Global Tel-Link'),(346860220416,'C2Micros','C2 Microsystems'),(346860224512,'ImpTelek','IMP Telekom'),(346860228608,'Ateme',''),(346860232704,'ADIVideo','A.D.I Video technologies'),(346860236800,'Elmec','Elmec,  Inc.'),(346860240896,'T1Engine','T 1 Engineering'),(346860244992,'Dit-McoI','DIT-MCO International'),(346860249088,'AlstomSc','Alstom (Schweiz) AG'),(346860253184,'TattileS','TATTILE SRL'),(346860257280,'Design20','Design 2000 Pty Ltd'),(346860261376,'Technova','Technovare Systems, Inc.'),(346860265472,'InfodevE','Infodev Electronic Designers Int'),(346860269568,'InraySol','InRay Solutions Ltd.'),(346860273664,'Eidos','EIDOS SPA'),(346860277760,'PromateE','PROMATE ELECTRONIC CO.LTD'),(346860281856,'Powerlin','Powerlinx, Inc.'),(346860285952,'ZoeMedic','Zoe Medical'),(346860290048,'European','European Industrial Electronics '),(346860294144,'PrimaryI','Primary Integration Encorp LLC'),(346860298240,'DsrInfor','DSR Information Technologies Ltd'),(346860302336,'Ast','AST INCORPORATED'),(346860306432,'Mobacon',''),(346860310528,'VentureR','Venture Research Inc.'),(346860314624,'Lyngdorf','Lyngdorf Audio Aps'),(346860318720,'Pyrosequ','Pyrosequencing AB'),(346860322816,'FrSauter','Fr. Sauter AG'),(346860326912,'Bluebell','Bluebell Opticom Limited'),(346860331008,'CedarAud','CEDAR Audio Limited'),(346860335104,'Viewplus','ViewPlus Technologies, Inc.'),(346860339200,'SwecoJap','SWECO JAPS AB'),(346860343296,'Precisio','Precision MicroControl Corporati'),(346860347392,'Aircell','AirCell Inc.'),(346860351488,'Emitech','Emitech Corporation'),(346860355584,'RadarTro','Radar Tronic ltd.'),(346860359680,'PhytecMe','Phytec Messtechnik GmbH'),(346860363776,'Bittital','Bittitalo Oy'),(346860367872,'Highrail','Highrail Systems Limited'),(346860371968,'Wr','WR Systems, Ltd.'),(346860376064,'Deuta-We','Deuta-Werke GmbH'),(346860380160,'Internat','International Mining Technologie'),(346860384256,'Newtec','Newtec A/S'),(346860388352,'Innoscan','InnoScan K/S'),(346860392448,'Volumati','Volumatic Limited'),(346860396544,'Htec','HTEC Limited'),(346860400640,'MuellerE','Mueller Elektronik'),(346860404736,'Aixtrusi','aiXtrusion GmbH'),(346860408832,'LsElektr','LS Elektronik AB'),(346860412928,'CascadeT','Cascade Technologies Ltd'),(346860421120,'C&DTechn','C&D Technologies, Inc'),(346860425216,'ZeltiqAe','Zeltiq Aesthetics, Inc.'),(346860429312,'Digitrol','DIGITROL LTD'),(346860433408,'Progente','Progentech Limited'),(346860437504,'MetaVisi','Meta Vision Systems Ltd.'),(346860441600,'NystromE','Nystrom Engineering'),(346860445696,'EmpirixI','Empirix Italy S.p.A.'),(346860449792,'V2green','V2Green, Inc.'),(346860453888,'MistralS','Mistral Solutions Pvt. Ltd'),(346860457984,'SiconSRL','Sicon s.r.l.'),(346860462080,'MonitorB','Monitor Business Machines Ltd.'),(346860466176,'SesolInd','Sesol Industrial Computer'),(346860470272,'Lyngsoe','Lyngsoe Systems'),(346860474368,'GenesisA','Genesis Automation Inc.'),(346860478464,'NhResear','NH Research'),(346860482560,'GfiChron','GFI Chrono Time'),(346860486656,'NetworkH','Network Harbor, Inc.'),(346860490752,'StuhlReg','STUHL Regelsysteme GmbH'),(346860494848,'Logother','Logotherm Regelsysteme GmbH'),(346860498944,'Sorec',''),(346860503040,'Wireless','Wireless Cables Inc'),(346860507136,'AceCarwa','ACE Carwash Systems'),(346860511232,'Saia-Bur','Saia-Burgess Controls AG'),(346860515328,'Mangodsp',''),(346860519424,'WiseIndu','Wise Industria de TelecomunicaÃ§'),(346860523520,'KarlDung','Karl DUNGS GmbH & Co. KG'),(346860527616,'Automati','AutomationX GmbH'),(346860531712,'QtronPty','Qtron Pty Ltd'),(346860535808,'TisDialo','TIS Dialog LLC'),(346860539904,'Adeneo',''),(346860544000,'Wireless','Wireless Cables Inc.'),(346860548096,'Shenzhen','Shenzhen MaiWei Cable TV Equipme'),(346860552192,'DelphiDi','Delphi Display Systems, Inc.'),(346860556288,'JanusSrl','JANUS srl'),(346860564480,'DbBroadc','dB Broadcast Limited'),(346860568576,'Softswit','SoftSwitching Technologies'),(346860572672,'Multimed','MultimediaLED'),(346860576768,'Cet',''),(346860580864,'Technoma','TECHNOMARK'),(346860584960,'ItbCompu','ITB CompuPhase'),(346860589056,'VarmaEle','Varma Electronics Oy'),(346860593152,'PhytecMe','Phytec Messtechnik GmbH'),(346860597248,'OpenVide','Open Video, Inc.'),(346860601344,'LuxpertT','Luxpert Technologies Co., Ltd.'),(346860605440,'AcubeSRL','Acube Systems s.r.l.'),(346860609536,'BrunoInt','Bruno International Ltd.'),(346860613632,'Selekron','Selekron Microcontrol s.l.'),(346860617728,'Alphion','Alphion Corporation'),(346860621824,'OpenSyst','Open System Solutions Limited'),(346860625920,'FemtoSa','Femto SA'),(346860630016,'Intellef','Intelleflex Corporation'),(346860634112,'Telvent',''),(346860638208,'MicrocDe','microC Design SRL'),(346860642304,'Inteligh','Intelight Inc.'),(346860646400,'OdinTele','Odin TeleSystems Inc'),(346860650496,'Wireless','Wireless Value BV'),(346860654592,'Cabinpla','Cabinplant A/S'),(346860658688,'Infoglob','InfoGLOBAL'),(346860662784,'BrainTec','Brain Tech Co., Ltd'),(346860666880,'Telcom',''),(346860670976,'ItSalux','IT SALUX CO., LTD.'),(346860675072,'Channelo','Channelot Ltd.'),(346860679168,'2nTeleko','2N TELEKOMUNIKACE a.s.'),(346860683264,'TescanSR','TESCAN, s.r.o.'),(346860687360,'MiscoRef','MISCO Refractometer'),(346860691456,'WinnerTe','Winner Technology Co, Ltd.'),(346860695552,'RobotVis','Robot Visual Systems GmbH'),(346860699648,'SmtDOO','SMT d.o.o.'),(346860703744,'Funkwerk','Funkwerk Information Technologie'),(346860707840,'HewiHein','HEWI Heinrich Wilke GmbH'),(346860711936,'EneroSol','Enero Solutions inc.'),(346860716032,'SlicanSp','SLICAN sp. z o.o.'),(346860720128,'Intellec','Intellectronika'),(346860724224,'VdcDispl','VDC Display Systems'),(346860728320,'KeithKoe','Keith & Koep GmbH'),(346860732416,'VitelNet','Vitel Net'),(346860736512,'Elmec','Elmec, Inc.'),(346860740608,'Logicom','LogiCom GmbH'),(346860744704,'Momentum','Momentum Data Systems'),(346860748800,'Compusho','CompuShop Services LLC'),(346860752896,'StJudeMe','St Jude Medical, Inc.'),(346860756992,'S1nn','S1nn GmbH & Co. KG'),(346860761088,'Laserlin','LaserLinc, Inc.'),(346860765184,'Antek','ANTEK GmbH'),(346860769280,'Communic','Communications Laboratories Inc'),(346860773376,'DspDesig','DSP DESIGN'),(346860777472,'Id-Karta','ID-KARTA s.r.o.'),(346860781568,'TProjeMu','T PROJE MUHENDISLIK DIS. TIC. LT'),(346860785664,'ImsRÃ¶ntg','IMS RÃ¶ntgensysteme GmbH'),(346860789760,'Syr-TecE','Syr-Tec Engineering & Marketing'),(346860793856,'OBay','O. Bay AG'),(346860797952,'HemaElec','hema electronic GmbH'),(346860802048,'Beronet','beroNet GmbH'),(346860806144,'KpeSpolS','KPE spol. s r.o.'),(346860810240,'PhytecMe','Phytec Messtechnik GmbH'),(346860814336,'Resident','Residential Control Systems'),(346860818432,'Connecti','Connection Electronics Ltd.'),(346860822528,'QuantumC','Quantum Controls BV'),(346860826624,'Xtensor','Xtensor Systems Inc.'),(346860830720,'ProdigyE','Prodigy Electronics Limited'),(346860834816,'Visualso','VisualSonics Inc.'),(346860838912,'Esp-Plan','ESP-Planning Co.'),(346860843008,'LarsMori','Lars Morich Kommunikationstechni'),(346860847104,'DasaRobo','DASA ROBOT Co., Ltd.'),(346860851200,'DesignAn','Design Analysis Associates, Inc.'),(346860855296,'Keystone','Keystone Electronic Solutions'),(346860859392,'TaskSist','TASK SISTEMAS DE COMPUTACAO LTDA'),(346860863488,'Performa','Performance Motion Devices'),(346860867584,'Bmti',''),(346860871680,'Draco','DRACO SYSTEMS'),(346860875776,'Gamber-J','Gamber-Johnson LLC'),(346860879872,'KKRocky','K.K. Rocky'),(346860883968,'SpjEmbed','SPJ Embedded Technologies Pvt. L'),(346860888064,'Einfochi','eInfochips Ltd.'),(346860892160,'EttusRes','Ettus Research LLC'),(346860896256,'Ratiopla','Ratioplast-Optoelectronics GmbH'),(346860900352,'RohdeSch','Rohde & Schwarz Topex SA'),(346860904448,'Ct','CT Company'),(346860908544,'GrupoEpe','Grupo Epelsa S.L.'),(346860912640,'Wireless','Wireless Acquisition LLC'),(346860916736,'Nuvation',''),(346860920832,'ArtSRL','ART s.r.l.'),(346860924928,'Boreste',''),(346860929024,'BSE','B S E'),(346860933120,'IngKnaus','Ing. Knauseder Mechatronik GmbH'),(346860937216,'Radiomet','Radiometer Medical ApS'),(346860941312,'GeneralD','General Dynamics C4 Systems'),(346860945408,'EutronSP','Eutron S.p.A.'),(346860949504,'Grantron','Grantronics Pty Ltd'),(346860953600,'Elsys','Elsys AG'),(346860957696,'Advanced','Advanced Technology Solutions'),(346860961792,'AtgAutom','ATG Automatisierungstechnik GERA'),(346860965888,'PersyCon','Persy Control Services B.v.'),(346860969984,'SaiaBurg','Saia Burgess Controls AG'),(346860974080,'Syntroni','Syntronics'),(346860978176,'Aethon','Aethon, Inc.'),(346860982272,'Funkwerk','Funkwerk plettac electronic GmbH'),(346860986368,'Usm','USM Systems, Ltd'),(346860990464,'OmbSiste','OMB Sistemas Electronicos S.A.'),(346860994560,'CondigiT','Condigi Televagt A/S'),(346860998656,'TielineR','Tieline Research Pty Ltd'),(346861002752,'HanyangE','HANYANG ELECTRIC CP., LTD'),(346861006848,'B-Plus','b-plus GmbH'),(346861010944,'LogelSRL','LOGEL S.R.L.'),(346861015040,'R-S-IEle','R-S-I Elektrotechnik GmbH & Co. '),(346861019136,'Oliotalo','Oliotalo - Objecthouse Oy'),(346861023232,'Xronet','XRONET Corporation'),(346861027328,'ArcosTec','Arcos Technologies Ltd.'),(346861031424,'PhytecMe','Phytec Messtechnik GmbH'),(346861035520,'Privatqu','Privatquelle Gruber GmbH & CO KG'),(346861039616,'MotionAn','Motion Analysis Corp'),(346861043712,'Acoustic','Acoustic Research Laboratories P'),(346861047808,'Milesys',''),(346861051904,'Spectrum','Spectrum Management, LC'),(346861056000,'Uavnavig','UAVNavigation S.L.'),(346861060096,'Arcontia','Arcontia AB'),(346861064192,'At&TGove','AT&T Government Solutions'),(346861068288,'ScmProdu','SCM PRODUCTS, INC.'),(346861072384,'Optoelet','Optoelettronica Italia S.r.l.'),(346861076480,'Creation','Creation Technologies Chicago'),(346861080576,'Innotran','InnoTrans Communications, Inc.'),(346861084672,'Warecube','WARECUBE,INC.'),(346861088768,'Neocontr','Neocontrol SoluÃ§Ãµes em AutomaÃ'),(346861092864,'IpThinki','IP Thinking A/S'),(346861096960,'Ooo\"Ntk\"','OOO \"NTK \"IMOS\"'),(346861101056,'TransasS','Transas Scandinavia AB'),(346861105152,'Inventis','Inventis Technology Pty Limited'),(346861109248,'Iadea','IADEA CORPORATION'),(346861113344,'AcsMotio','ACS MOTION CONTROL'),(346861117440,'Continen','Continental Electronics Corp.'),(346861121536,'HollisEl','Hollis Electronics Company LLC'),(346861125632,'Z-App','Z-App Systems'),(346861129728,'L3Commun','L3 Communications Nova Engineeri'),(346861133824,'Cardinal','Cardinal Scale Mfg Co'),(346861137920,'KeynoteS','Keynote SIGOS GmbH'),(346861142016,'BaeHÃ¤ggl','BAE Systems HÃ¤gglunds AB'),(346861146112,'AdmiralS','Admiral Secure Products, Ltd.'),(346861150208,'TrakceAS','Trakce a.s.'),(346861154304,'EizoTech','EIZO Technologies GmbH'),(346861158400,'Shockfis','Shockfish SA'),(346861162496,'MarineCo','Marine Communications Limited'),(346861166592,'Blankom',''),(346861170688,'OdfOptro','ODF Optronics, Inc.'),(346861174784,'VeecoPro','Veeco Process Equipment, Inc.'),(346861178880,'InicoTec','Inico Technologies Ltd.'),(346861182976,'NeptuneT','Neptune Technology Group, Inc.'),(346861187072,'SensataT','Sensata Technologies, Inc.'),(346861191168,'Mediana',''),(346861195264,'Systemte','Systemtechnik GmbH'),(346861199360,'Broadcas','Broadcast Electronics'),(346861203456,'Datalink','Datalink Technologies Gateways I'),(346861207552,'Speciali','Specialized Communications Corp.'),(346861211648,'IntuneNe','Intune Networks Limited'),(346861215744,'Uavision','UAVISION Engenharia de Sistemas'),(346861219840,'Rtw','RTW GmbH & Co.KG'),(346861223936,'BaloghTA','BALOGH T.A.G Corporation'),(346861228032,'Mocon','Mocon, Inc.'),(346861232128,'Selco',''),(346861236224,'Pixeye','PIXEYE LTD'),(346861240320,'AltekEle','ALTEK ELECTRONICS'),(346861244416,'Intellig','Intelligent Security Systems'),(346861248512,'AtsElekt','ATS Elektronik GmbH'),(346861252608,'Nanomoti','Nanomotion Ltd.'),(346861256704,'TelsaSRL','Telsa s.r.l'),(346861260800,'ThalesCo','Thales Communications, Inc'),(346861264896,'Desarrol','DESARROLLO DE SISTEMAS INTEGRADO'),(346861268992,'Xelerate','Xelerated'),(346861273088,'BkInnova','BK Innovation, Inc.'),(346861277184,'Ringcube','RingCube Technologies, Inc.'),(346861281280,'Servaind','SERVAIND SA.'),(346861285376,'VtqVidet','VTQ Videtronik GmbH'),(346861289472,'SandarTe','Sandar Telecast AS'),(346861293568,'KeithKoe','Keith & Koep GmbH'),(346861297664,'Shadrins','Shadrinskiy Telefonny Zavod'),(346861301760,'CalnexSo','Calnex Solutions Limited'),(346861305856,'DssNetwo','DSS Networks, Inc.'),(346861309952,'AcdElekt','ACD Elektronik Gmbh'),(346861314048,'FrSauter','Fr. Sauter AG'),(346861318144,'SmtagInt','smtag international ag'),(346861322240,'Honeywel','Honeywell Sensotec'),(346861326336,'MatrixSw','Matrix Switch Corporation'),(346861330432,'Pennsylv','The Pennsylvania State Universit'),(346861334528,'AristoGr','ARISTO Graphic Systeme GmbH & Co'),(346861338624,'SCESRL','S.C.E. s.r.l.'),(346861342720,'HeraeusN','Heraeus Noblelight GmbH'),(346861346816,'AccessCo','Access Control Systems JSC'),(346861350912,'BytePara','Byte Paradigm'),(346861355008,'SoldigIn','Soldig Industria e Comercio de E'),(346861359104,'VortexEn','Vortex Engineering pvt ltd'),(346861363200,'GradualT','Gradual Tecnologia Ltda.'),(346861367296,'TattileS','Tattile srl'),(346861371392,'Pumatron','Pumatronix Equipamentos EletrÃ´n'),(346861375488,'A+SAktua','A+S Aktuatorik und Sensorik GmbH'),(346861379584,'AltairSe','Altair semiconductor Ltd'),(346861383680,'Beonic','Beonic Corporation'),(346861387776,'Lyconsys','LyconSys GmbH & Co.KG'),(346861391872,'Cambridg','Cambridge Sound Management, LLC'),(346861395968,'PhytecMe','Phytec Messtechnik GmbH'),(346861400064,'Gigalinx','GigaLinx Ltd.'),(346861404160,'Saia-Bur','Saia-Burgess Controls AG'),(346861408256,'Bachmann','Bachmann Monitoring GmbH'),(346861412352,'Tti','TTi Ltd'),(346861416448,'Ifam','IFAM GmbH'),(346861420544,'Internet','Internet Protocolo LÃ³gica SL'),(346861424640,'PeekTraf','Peek Traffic Corp'),(346861428736,'Ultravis','UltraVision Security Systems, In'),(346861432832,'PolygonI','Polygon Informatics Ltd.'),(346861436928,'ArrayTec','Array Technologies Inc'),(346861441024,'Industri','Industrial Control and Communica'),(346861445120,'Docutemp','DOCUTEMP, INC'),(346861449216,'DcomNetw','DCOM Network Technology (Pty) Lt'),(346861453312,'Frame','Frame Systems Limited'),(346861457408,'Gimcon',''),(346861461504,'Coherix','Coherix, Inc'),(346861465600,'Dipl-Ing','Dipl.-Ing. W. Nophut GmbH'),(346861469696,'Shenzhen','Shenzhen Pennda Technologies Co.'),(346861473792,'Deutsche','Deutscher Weterdienst'),(346861477888,'Wireless','Wireless Cables Inc'),(346861481984,'BiomÃ©rie','bioMÃ©rieux Italia S.p.A.'),(346861486080,'MacapsIn','MaCaPS International Limited'),(346861490176,'Berthel','Berthel GmbH'),(346861494272,'SandelAv','Sandel Avionics, Inc.'),(346861498368,'MktSyste','MKT Systemtechnik'),(346861502464,'Friedric','Friedrich Kuhnt GmbH'),(346861506560,'Unidata',''),(346861510656,'Ateme',''),(346861514752,'C-ComSat','C-COM Satellite Systems Inc.'),(346861518848,'BalfourB','Balfour Beatty Rail GmbH'),(346861522944,'At-Autom','AT-Automation Technology GmbH'),(346861527040,'Pcsc',''),(346861531136,'Technolo','Technologies Sensio Inc'),(346861535232,'XentrasC','Xentras Communications'),(346861539328,'Detectio','Detection Technologies Ltd.'),(346861543424,'Schneide','Schneider Electric GmbH'),(346861547520,'CurtisDo','Curtis Door Systems Inc'),(346861551616,'Critical','Critical Link'),(346861555712,'Tec5','tec5 AG'),(346861559808,'K-Mac','K-MAC Corp.'),(346861563904,'Tge','TGE Co., Ltd.'),(346861568000,'Rmsd','RMSD LTD'),(346861572096,'Honeywel','Honeywell International'),(346861576192,'TeliumSC','TELIUM s.c.'),(346861580288,'AlfredKu','Alfred Kuhse GmbH'),(346861584384,'Symetric','Symetrics Industries'),(346861588480,'SindomaM','Sindoma MÃ¼h Mim ÃnÃ¾ Elk San T'),(346861592576,'CrossCou','Cross Country Systems AB'),(346861596672,'Luceat',''),(346861600768,'MagorCom','Magor Communications Corp'),(346861604864,'Research','Research Applications Incorp'),(346861608960,'ChinaRai','China Railway Signal & Communica'),(346861613056,'EcoaxisP','EcoAxis Systems Pvt. Ltd.'),(346861617152,'R2sonicL','R2Sonic, LLC'),(346861621248,'LinkComm','Link Communications, Inc'),(346861625344,'Gidel',''),(346861629440,'CristalC','Cristal Controles Ltee'),(346861633536,'CodexDig','Codex Digital Ltd'),(346861637632,'ElisraEl','Elisra Electronic Systems'),(346861641728,'BoardLev','Board Level Limited'),(346861645824,'EOnEsSve','E.ON ES Sverige AB'),(346861649920,'Lss','LSS GmbH'),(346861654016,'EvkDiKer','EVK DI Kerschhaggl GmbH'),(346861658112,'PhytecMe','Phytec Messtechnik GmbH'),(346861662208,'IntegraB','INTEGRA Biosciences AG'),(346861666304,'Autotank','Autotank AB'),(346861670400,'VaporRai','Vapor Rail'),(346861674496,'AssetInt','ASSET InterTech, Inc.'),(346861678592,'SelexSen','Selex Sensors & Airborne Systems'),(346861682688,'Io-Conne','IO-Connect'),(346861686784,'Verint','Verint Systems Ltd.'),(346861690880,'ChkGrids','CHK GridSense P/L'),(346861694976,'Cirtem',''),(346861699072,'DesignLi','Design Lightning Corp'),(346861703168,'Ahv','AHV Systems, Inc.'),(346861707264,'XtoneNet','Xtone Networks'),(346861711360,'Embedded','Embedded Data Systems, LLC'),(346861715456,'Mangodsp',''),(346861719552,'Rosendah','Rosendahl Studiotechnik GmbH'),(346861723648,'Automati','Automation Tec'),(346861727744,'2ncommDe','2NCOMM DESIGN SRL'),(346861731840,'RogueEng','Rogue Engineering Inc.'),(346861735936,'IqueRfid','iQue RFID Technologies BV'),(346861740032,'MetrumSw','Metrum Sweden AB'),(346861744128,'AmicusWi','Amicus Wireless'),(346861748224,'LinkElec','Link Electric & Safety Control C'),(346861752320,'PhbEletr','PHB Eletronica Ltda.'),(346861756416,'DitestFa','DITEST FAHRZEUGDIAGNOSE GMBH'),(346861760512,'AtisGrou','ATIS group s.r.o.'),(346861764608,'Cinetix','Cinetix GmbH'),(346861768704,'FlightDe','Flight Deck Resources'),(346861772800,'RohdeSch','Rohde & Schwarz Topex SA'),(346861776896,'DspDesig','DSP DESIGN'),(346861780992,'Exatrol','Exatrol Corporation'),(346861785088,'Approsof','APProSoftware.com'),(346861789184,'GoannaTe','Goanna Technologies Pty Ltd'),(346861793280,'PhytecMe','Phytec Messtechnik GmbH'),(346861797376,'NetaElek','NETA Elektronik AS'),(346861801472,'KoreaTel','Korea Telecom Internet Solutions'),(346861805568,'Smavis','SMAVIS Inc.'),(346861809664,'Saia-Bur','Saia-Burgess Controls AG'),(346861813760,'Xilar','Xilar Corp.'),(346861817856,'ImageVid','Image Video'),(346861821952,'Margarit','Margaritis Engineering'),(346861826048,'Bigbear',''),(346861830144,'PostecDa','Postec Data Systems Ltd'),(346861834240,'MosaicDy','Mosaic Dynamic Solutions'),(346861838336,'Alphatro','ALPHATRONICS nv'),(346861842432,'Reliatro','Reliatronics Inc.'),(346861846528,'Fracture','FractureCode Corporation'),(346861850624,'Lighting','Lighting Science Group Corporati'),(346861854720,'RcsCommu','RCS Communication Test Systems L'),(346861858816,'TsbSolut','TSB Solutions Inc.'),(346861862912,'Phitek','Phitek Systems Ltd.'),(346861867008,'Rolbit',''),(346861871104,'KeithKoe','Keith & Koep GmbH'),(346861875200,'Quanzhou','QuanZhou TDX Electronics Co., Lt'),(346861879296,'Wireonai','Wireonair A/S'),(346861883392,'Ex-IFlow','Ex-i Flow Measurement Ltd.'),(346861887488,'MegwareC','MEGWARE Computer GmbH'),(346861891584,'Imexhigh','IMEXHIGHWAY cvba'),(346861895680,'Electron','ELECTRONIA'),(346861899776,'Taskit','taskit GmbH'),(346861903872,'Trumedia','TRUMEDIA TECHNOLOGIES'),(346861907968,'PillerEn','Piller engineering Ltd.'),(346861912064,'Temix',''),(346861916160,'C&HTechn','C&H technology  ltd.'),(346861920256,'ZynixOri','Zynix Original Sdn. Bhd.'),(346861924352,'It-Desig','IT-Designers GmbH'),(346861928448,'TeleAndR','Tele and Radio Research Institut'),(346861932544,'ElCASocC','EL.C.A. soc. coop.'),(346861936640,'TechFass','Tech Fass s.r.o.'),(346861940736,'GrupoEpe','Grupo Epelsa S.L.'),(346861944832,'PhytecMe','Phytec Messtechnik GmbH'),(346861948928,'Roessman','Roessmann Engineering'),(346861953024,'SiconSRL','Sicon s.r.l.'),(346861957120,'StratecC','STRATEC Control Systems'),(346861961216,'Sensopti','Sensoptics Ltd'),(346861965312,'Dectris','DECTRIS Ltd.'),(346861969408,'Technoap',''),(346861973504,'AsSolar','AS Solar GmbH'),(346861977600,'Resurgen','Resurgent Health & Medical'),(346861981696,'FullElec','full electronic system'),(346861985792,'Beecube','BEEcube Inc.'),(346861989888,'Metronic','METRONIC APARATURA KONTROLNO - P'),(346861993984,'Kuroneko','kuroneko dennnou kenkyuushitsu'),(346861998080,'Picsolve','Picsolve International Limited'),(346862002176,'Shockfis','Shockfish SA'),(346862006272,'LÃ©cureux','LÃ©cureux SA'),(346862010368,'IqAutoma','IQ Automation GmbH'),(346862014464,'Emitech','Emitech Corporation'),(346862018560,'PcmIndus','PCM Industries'),(346862022656,'Watthour','Watthour Engineering Co., Inc.'),(346862026752,'Bulogics','BuLogics, Inc.'),(346862030848,'GehrkeKo','Gehrke Kommunikationssysteme Gmb'),(346862034944,'Elektrob','Elektrobit Wireless Communicatio'),(346862039040,'Electron','Electronic Media Services Ltd'),(346862043136,'AquaCool','Aqua Cooler Pty Ltd'),(346862047232,'KeeneEle','Keene Electronics Ltd.'),(346862051328,'PeekTraf','Peek Traffic Corporation'),(346862055424,'Varec','Varec Inc.'),(346862059520,'TsujiEle','Tsuji Electronics Co.,Ltd'),(346862063616,'Ipitek',''),(346862067712,'SwitchSc','Switch Science (Panini Keikaku)'),(346862071808,'SystÃ¨mes','SystÃ¨mes Pran'),(346862075904,'Emac','EMAC, INC.'),(346862080000,'PyramidT','Pyramid Technical Consultants'),(346862084096,'SandsIns','SANDS INSTRUMENTATION INDIA PVT '),(346862088192,'Saia-Bur','Saia-Burgess Controls AG'),(346862092288,'LogitalD','LOGITAL DIGITAL MEDIA srl'),(346862096384,'FarSouth','Far South Networks (Pty) Ltd'),(346862100480,'KstTechn','KST Technology Co., Ltd'),(346862104576,'Smartqua','SMARTQUANTUM SA'),(346862108672,'CreaconT','Creacon Technologies B.V.'),(346862112768,'SoehnleP','Soehnle Professional GmbH & Co.K'),(346862116864,'RfIndust','RF Industries'),(346862120960,'C&I','C&I  Co.Ltd'),(346862125056,'DigitalP','Digital Payment Technologies'),(346862129152,'Novotron','Novotronik GmbH'),(346862133248,'TripleRi','Triple Ring Technologies, Inc.'),(346862137344,'BogartEn','Bogart Engineering'),(346862141440,'Atel','Atel Corporation'),(346862145536,'Earnestc','Earnestcom Sdn Bhd'),(346862149632,'Dsci',''),(346862153728,'Joinsoon','Joinsoon Electronics MFG. Co., L'),(346862157824,'PantelIn','Pantel International'),(346862161920,'Psigenic','Psigenics Corporation'),(346862166016,'Mev','MEV Limited'),(346862170112,'Ti2000Te','TI2000 TECNOLOGIA INFORMATICA 20'),(346862174208,'Mgm-Devi','MGM-Devices Oy'),(346862178304,'Mecos','Mecos AG'),(346862182400,'LinkTech','Link Technologies, Inc'),(346862186496,'BelikSPR','BELIK S.P.R.L.'),(346862190592,'KeithKoe','Keith & Koep GmbH'),(346862194688,'Ugl','UGL Limited'),(346862198784,'IdtSound','IDT Sound Processing Corporation'),(346862202880,'Unetconv','UNETCONVERGENCE CO., LTD'),(346862206976,'XafaxNed','Xafax Nederland bv'),(346862211072,'InterCon','Inter Control Hermann KÃ¶hler  E'),(346862215168,'Commerci','Commercial Timesharing Inc.'),(346862219264,'DeproÃ‰le','Depro Ã‰lectronique'),(346862223360,'PhytecMe','Phytec Messtechnik GmbH'),(346862227456,'Cambusti','Cambustion Ltd'),(346862231552,'Miromico','Miromico AG'),(346862235648,'BettiniS','Bettini srl'),(346862239744,'Cats3','CaTs3 Limited'),(346862243840,'Powersen','Powersense A/S'),(346862247936,'EngageTe','Engage Technologies'),(346862252032,'SietronE','Sietron Elektronik'),(346862256128,'Trs','Trs Systems, Inc.'),(346862260224,'ComapSRO','ComAp s.r.o'),(346862264320,'Samsyste','SAMsystems GmbH'),(346862268416,'Computer','Computerwise, Inc.'),(346862272512,'Entwickl','Entwicklung Hard- & Software'),(346862276608,'Conolog','Conolog Corporation'),(346862280704,'Metodo2',''),(346862284800,'ThalesCo','Thales Communications & Security'),(346862288896,'DomisSa','DOMIS SA'),(346862292992,'GeneralD','General Dynamics C4 Systems'),(346862297088,'TekoTele','TEKO TELECOM SpA'),(346862301184,'Electrod','Electrodata Inc.'),(346862305280,'QuestekA','Questek Australia Pty Ltd'),(346862309376,'ChronosT','Chronos Technology Ltd.'),(346862313472,'Esensors','Esensors, Inc.'),(346862317568,'Kress-Ne','KRESS-NET Krzysztof Rutecki'),(346862321664,'Ebru','Ebru GmbH'),(346862325760,'BonHora','Bon Hora GmbH'),(346862329856,'Tempsys',''),(346862333952,'KahlerAu','Kahler Automation'),(346862338048,'EukreaEl','EUKREA ELECTROMATIQUE SARL'),(346862342144,'Telegamm','Telegamma srl'),(346862346240,'Actech',''),(346862350336,'StMichae','St. Michael Strategies'),(346862354432,'SoundPla','Sound Player Systems e.K.'),(346862358528,'Isa-Inte','ISA - Intelligent Sensing Anywhe'),(346862362624,'Connor-W','Connor-Winfield'),(346862366720,'OmicronE','OMICRON electronics GmbH'),(346862370816,'VesterEl','Vester Elektronik GmbH'),(346862374912,'Sensitro','Sensitron Semiconductor'),(346862379008,'XadCommu','Xad Communications Ltd'),(346862383104,'2nTeleko','2N TELEKOMUNIKACE a.s.'),(346862387200,'StuytsEn','Stuyts Engineering Haarlem BV'),(346862391296,'TattileS','Tattile srl'),(346862395392,'TeamEngi','Team Enginers'),(346862399488,'GeSecuri','GE Security-Kampro'),(346862403584,'VitelNet','Vitel Net'),(346862407680,'Scansoni','Scansonic MI GmbH'),(346862411776,'Protroni','Protronic GmbH'),(346862415872,'KumeraDr','Kumera Drives Oy'),(346862419968,'Ethermet','ethermetrics'),(346862424064,'LuminexL','LUMINEX Lighting Control Equipme'),(346862428160,'Esab-Ata','ESAB-ATAS GmbH'),(346862432256,'Nis-Time','NIS-time GmbH'),(346862436352,'Hirotech','Hirotech, Inc'),(346862440448,'UweSchne','Uwe Schneider GmbH'),(346862444544,'RonanEng','Ronan Engineering'),(346862448640,'Intuitiv','Intuitive Surgical, Inc'),(346862452736,'JDittric','J. DITTRICH ELEKTRONIC GmbH & Co'),(346862456832,'Bladeliu','Bladelius Design Group AB'),(346862460928,'Saia-Bur','Saia-Burgess Controls AG'),(346862465024,'Telemetr','Telemetrie Elektronik GmbH'),(346862469120,'First',''),(346862473216,'Netpower','Netpower Labs AB'),(346862477312,'Innovati','Innovation, Institute, Inc'),(346862481408,'Melex','Melex Inc.'),(346862485504,'SamsungH','SAMSUNG HEAVY INDUSTRIES CO.,LTD'),(346862489600,'Cns','CNS Systems, Inc.'),(346862493696,'Neutroni','NEUTRONIK e.K.'),(346862497792,'WalterGr','Walter Grotkasten'),(346862501888,'FtmMarke','FTM Marketing Limited'),(346862505984,'Institut','Institut Dr. Foerster'),(346862510080,'ChauvinA','CHAUVIN ARNOUX'),(346862514176,'Codec','CODEC Co., Ltd.'),(346862518272,'DstSwiss','DST Swiss AG'),(346862522368,'Enreduce','Enreduce Energy Control AB'),(346862526464,'E-ViewsS','E-ViEWS SAFETY SYSTEMS, INC'),(346862530560,'SaiInfor','SAI Informationstechnik'),(346862534656,'PyxisCon','Pyxis Controls WLL'),(346862538752,'Hallibur','Halliburton Far East Pte Ltd'),(346862542848,'KumhoEle','Kumho Electric, Inc.'),(346862546944,'DorletSA','DORLET S.A.'),(346862551040,'Hammock','Hammock Corporation'),(346862555136,'CiemmeSi','Ciemme Sistemi Spa'),(346862559232,'Sismodul','SISMODULAR - Engenharia, Lda'),(346862563328,'AforeSol','AFORE Solutions Inc.'),(346862567424,'RohdeSch','Rohde & Schwarz Topex SA'),(346862571520,'PicellBV','Picell B.V.'),(346862575616,'MichaelS','Michael Stevens & Partners Ltd'),(346862579712,'Woka-Ele','WoKa-Elektronik GmbH'),(346862583808,'Veracity','Veracity UK Ltd'),(346862587904,'IdeasSRL','IDEAS s.r.l.'),(346862592000,'KeithKoe','Keith & Koep GmbH'),(346862596096,'VisionTe','Vision Technologies, Inc.'),(346862600192,'Fsr','FSR Inc.'),(346862604288,'CommexTe','Commex Technologies'),(346862608384,'IonSense','Ion Sense Inc.'),(346862612480,'DaveJone','Dave Jones Design'),(346862616576,'AustcoCo','Austco Communication Systems Pty'),(346862620672,'AbbTrans','ABB Transmission and Distributio'),(346862624768,'TeranexA','Teranex A Division of Silicon Op'),(346862628864,'VillbauK','Villbau Kft.'),(346862632960,'Ectec','ECTEC INC.'),(346862637056,'BittTech','Bitt technology-A Ltd.'),(346862641152,'SpectraE','SPECTRA EMBEDDED SYSTEMS'),(346862645248,'Humphrey','Humphrey Products'),(346862649344,'Technova','Technovare Systems'),(346862653440,'Patronic','Patronics International LTD'),(346862657536,'Referenc','Reference, LLC.'),(346862661632,'EegEnter','EEG Enterprises Inc'),(346862665728,'TpRadio','TP Radio'),(346862669824,'AdgilDes','Adgil Design Inc.'),(346862673920,'CloosSch','Cloos Schweisstechnik GmbH'),(346862678016,'DynonIns','Dynon Instruments'),(346862682112,'Labjack','LabJack Corporation'),(346862686208,'Innovati','Innovative American Technology'),(346862690304,'AcdElekt','ACD Elektronik Gmbh'),(346862694400,'IDSIngeg','I.D.S. Ingegneria Dei Sistemi  S'),(346862698496,'PhytecMe','Phytec Messtechnik GmbH'),(346862702592,'Charlyro','CHARLYROBOT'),(346862706688,'EngicamS','Engicam srl'),(346862710784,'Visualwa','Visualware Inc'),(346862714880,'Essentia','Essential Design & Integration P'),(346862718976,'OjscRawe','OJSC Rawenstvo'),(346862723072,'HceEngin','HCE Engineering S.r.l.'),(346862727168,'Talyst','Talyst, Inc.'),(346862731264,'ElbitOfA','Elbit Systems of America - Talla'),(346862735360,'Industri','Industrial Computing Ltd'),(346862739456,'Baudisch','Baudisch Electronic GmbH'),(346862743552,'WinnersS','Winners Satellite Electronics Co'),(346862747648,'Eoslink',''),(346862751744,'IconTime','Icon Time Systems'),(346862755840,'Ddl',''),(346862759936,'Realtime','Realtime Systems Ltd.'),(346862764032,'Microtec','Microtechnica'),(346862768128,'SamhEngi','SAMH Engineering Services'),(346862772224,'Mamac','MAMAC Systems, Inc.'),(346862776320,'FlightDa','Flight Data Systems Pty Ltd'),(346862780416,'QuorumTe','Quorum Technologies Ltd'),(346862784512,'IsacSrl','ISAC SRL'),(346862788608,'NipponMa','Nippon Manufacturing Service Cor'),(346862792704,'AgilityM','Agility Mfg, Inc.'),(346862796800,'GrupoEpe','Grupo Epelsa S.L.'),(346862800896,'Saia-Bur','Saia-Burgess Controls AG'),(346862804992,'Preferre','Preferred Oil, LLC'),(346862809088,'MeconetE','meconet e. K.'),(346862813184,'KendaEle','KENDA ELECTRONIC SYSTEMS LIMITED'),(346862817280,'Luminex','Luminex Corporation'),(346862821376,'CustomCo','Custom Control Concepts'),(346862825472,'ApriliaR','APRILIA RACING S.R.L.'),(346862829568,'Kws-Elec','KWS-Electronic GmbH'),(346862833664,'Inventur','Inventure Inc.'),(346862837760,'YuyamaMf','Yuyama Mfg. Co., Ltd.'),(346862841856,'Dragonfl','DragonFly Scientific LLC'),(346862845952,'D-Ta','D-TA Systems'),(346862850048,'Coolit','Coolit Systems, Inc.'),(346862854144,'HarrisDe','Harris Designs of NRV, Inc.'),(346862858240,'FujiFirm','Fuji Firmware'),(346862862336,'Casabyte','Casabyte Inc.'),(346862866432,'AppareoL','Appareo Systems, LLC'),(346862870528,'Shenzhen','Shenzhen Shangji electronic Co.L'),(346862874624,'Software','Software Systems Plus'),(346862878720,'TredDisp','Tred Displays'),(346862882816,'Industri','Industrial Data Products Ltd'),(346862886912,'Telecor','Telecor Inc.'),(346862891008,'Ipcontro','IPcontrols GmbH'),(346862895104,'BrÃ¤hlerI','BrÃ¤hler ICS Konferenztechnik AG'),(346862899200,'Owandy',''),(346862903296,'DueviSnc','DUEVI SNC DI MORA E SANTESE'),(346862907392,'LhaCc','LHA Systems CC'),(346862911488,'Mosberge','Mosberger Consulting LLC'),(346862915584,'MeiryoDe','Meiryo Denshi Corp.'),(346862919680,'Realvisi','RealVision Inc.'),(346862923776,'Nks','NKS Co.Ltd.'),(346862927872,'TorcTech','TORC Technologies'),(346862931968,'Sofradir','Sofradir-EC'),(346862936064,'Softroni','Softronics Ltd.'),(346862940160,'Primetec','PRIMETECH ENGINEERING CORP.'),(346862944256,'ThalesOp','Thales Optronics Limited'),(346862948352,'WayneDal','Wayne Dalton Corp.'),(346862952448,'DitronSR','DITRON S.r.l.'),(346862956544,'L-3Commu','L-3 Communications Mobile-Vision'),(346862960640,'Vasonova','VasoNova, Inc.'),(346862964736,'Levelsta','LevelStar LLC.'),(346862968832,'Conduant','Conduant Corporation'),(346862972928,'Deuta','Deuta GmbH'),(346862977024,'I-RedInf','i-RED Infrarot Systeme GmbH'),(346862981120,'Y-Produc','Y-products co.ltd.'),(346862985216,'Von','The VON Corporation'),(346862989312,'QualityD','Quality & Design'),(346862993408,'DiamondP','Diamond Point International (Eur'),(346862997504,'Arrowval','Arrowvale Electronics'),(346863001600,'Reametri','ReaMetrix, Inc.'),(346863005696,'JuiceTec','Juice Technologies, LLC'),(346863009792,'Epl',''),(346863013888,'GspSprac','GSP Sprachtechnologie GmbH'),(346863017984,'Itas','ITAS A/S'),(346863022080,'PhytecMe','Phytec Messtechnik GmbH'),(346863026176,'Jsc\"Comp','JSC \"Component-ASU\"'),(346863030272,'Mecc','MECC CO., LTD.'),(346863034368,'AnsenInv','Ansen Investment Holdings Ltd.'),(346863038464,'AlgaMicr','Alga Microwave Inc'),(346863042560,'ArrowCen','Arrow Central Europe GmbH - Divi'),(346863046656,'FrSauter','Fr. Sauter AG'),(346863050752,'Grossenb','Grossenbacher Systeme AG'),(346863054848,'EmsIndus','EMS Industries'),(346863058944,'Tetronik','tetronik GmbH AEN'),(346863063040,'Mark-O-P','Mark-O-Print GmbH'),(346863067136,'Dvtech',''),(346863071232,'GssAvion','GSS Avionics Limited'),(346863075328,'X-PertPa','X-Pert Paint Mixing Systems'),(346863079424,'Advanced','Advanced Integrated Systems'),(346863083520,'Infocros','Infocrossing'),(346863087616,'Explorer','Explorer Inc.'),(346863091712,'FigmentD','Figment Design Laboratories'),(346863095808,'DtvInnov','DTV Innovations'),(346863099904,'ScreenTe','Screen Technics Pty Limited'),(346863104000,'Saia-Bur','Saia-Burgess Controls AG'),(346863108096,'Reliable','Reliable System Services Corp'),(346863112192,'Purite','Purite Ltd'),(346863116288,'Gamber-J','Gamber-Johnson LLC.'),(346863120384,'KyoeiEng','KYOEI ENGINEERING Co.,Ltd.'),(346863124480,'DspDesig','DSP DESIGN LTD'),(346863128576,'Jtl','JTL Systems Ltd.'),(346863132672,'RoeschWa','Roesch & Walter Industrie-Elektr'),(346863136768,'KeithKoe','Keith & Koep GmbH'),(346863140864,'ApantacL','Apantac LLC'),(346863144960,'Saintron','Saintronic'),(346863149056,'DetnetSo','DetNet South Africa PTY (LTD)'),(346863153152,'OrangeTr','Orange Tree Technologies'),(346863157248,'Pneu-Log','Pneu-Logic Corporation'),(346863161344,'VitelNet','Vitel Net'),(346863165440,'Independ','Independent Project Engineering '),(346863169536,'PhytecMe','Phytec Messtechnik GmbH'),(346863173632,'ArdSa','ARD SA'),(346863177728,'BpcCircu','BPC circuits Ltd'),(346863181824,'Ct','CT Company'),(346863185920,'TechnoSo','Techno Sobi Co. Ltd.'),(346863190016,'LinoManf','Lino Manfrotto +Co spa'),(346863194112,'Joysyste','JOYSYSTEM'),(346863198208,'Limab','LIMAB AB'),(346863202304,'Littlemo','Littlemore Scientific'),(346863206400,'S-Sys',''),(346863210496,'CaTraffi','CA Traffic Ltd'),(346863214592,'AudioEng','Audio Engineering Ltd.'),(346863218688,'Navicron','Navicron Oy'),(346863222784,'RedwireL','Redwire, LLC'),(346863226880,'Frontier','Frontier Electronic Systems Corp'),(346863230976,'BfiIndus','BFI Industrie-Elektronik GmbH & '),(346863235072,'Quantum3','Quantum3D, Inc.'),(346863239168,'STwo','S.two Corporation'),(346863243264,'CeronTec','Ceron Tech Co.,LTD'),(346863247360,'SiconSRL','Sicon s.r.l.'),(346863251456,'SpxDehyd','SPX Dehydration & Filtration'),(346863255552,'Par-Tech','Par-Tech, Inc.'),(346863259648,'Innovaci','INNOVACIONES MicroelectrÃ³nicas '),(346863263744,'FepSrl','FEP SRL'),(346863267840,'Microsys','MICROSYSTEMES'),(346863271936,'Sentry36','Sentry 360 Security'),(346863276032,'Haivisio','Haivision Systems Inc'),(346863280128,'Absolutr','Absolutron. LLC'),(346863284224,'PdqManuf','PDQ Manufacturing  Inc.'),(346863288320,'EberspÃ¤c','EberspÃ¤cher Electronics GmbH & '),(346863292416,'JoehlKoe','Joehl & Koeferli AG'),(346863296512,'ProconEn','Procon Engineering Limited'),(346863300608,'Yellowso','YellowSoft Co., Ltd.'),(346863304704,'SmithMet','Smith Meter, Inc.'),(346863308800,'ElremEle','ELREM ELECTRONIC AG'),(346863312896,'ElpaSas','ELPA sas'),(346863316992,'PeekTraf','Peek Traffic Corporation'),(346863321088,'PsiPrint','PSi Printer Systems internationa'),(346863325184,'TampereU','Tampere University of Technology'),(346863329280,'BassettE','Bassett Electronic Systems ltd'),(346863333376,'EndeasOy','Endeas Oy'),(346863337472,'NexansCa','Nexans Cabling Solutions'),(346863341568,'SanGiorg','SAN GIORGIO S.E.I.N. srl'),(346863345664,'Flexible','Flexible Picture Systems'),(346863349760,'BrsSiste','BRS Sistemas EletrÃ´nicos'),(346863353856,'Visicon','VisiCon GmbH'),(346863357952,'Update','Update Systems Inc.'),(346863362048,'OutlineS','OUTLINE srl'),(346863366144,'SantaBar','Santa Barbara Instrument Group'),(346863370240,'FrakoKon','FRAKO Kondensatoren- und Anlagen'),(346863374336,'Bitmanuf','Bitmanufaktur GmbH'),(346863378432,'Procom','ProCom Systems, Inc.'),(346863382528,'CompaÃ±Ã­a','CompaÃ±Ã­a de Instrumentacion y '),(346863386624,'N3kInfor','n3k Informatik GmbH'),(346863390720,'Mettler-','METTLER-TOLEDO HI-SPEED'),(346863394816,'GygaxEmb','Gygax Embedded Engineering GEE.c'),(346863398912,'Twinfall','Twinfalls Technologies'),(346863403008,'AhmClika','AHM Limited (CLiKAPAD)'),(346863407104,'Showtacl','Showtacle'),(346863411200,'Saia-Bur','Saia-Burgess Controls AG'),(346863415296,'Volantic','Volantic AB'),(346863419392,'Barrick',''),(346863423488,'MonitorB','Monitor Business Machines Ltd.'),(346863427584,'ApLabs','AP Labs'),(346863431680,'MccCompu','MCC Computer Company'),(346863435776,'DsProAud','DS PRO Audio Ltda'),(346863439872,'Daishin-','DAISHIN-DENSHI Co., Ltd'),(346863443968,'OpenxsBV','OpenXS B.V.'),(346863448064,'Diversif','Diversified Control, Inc.'),(346863452160,'OrionTec','Orion Technologies, Incorporated'),(346863456256,'E-Motion','E-Motion System, Inc.'),(346863460352,'Marathon','Marathon Products, Inc.'),(346863464448,'Waveip',''),(346863468544,'Palladio','Palladio Systeme GmbH'),(346863472640,'Steinbei','Steinbeis-Transferzentrum Embedd'),(346863476736,'SoftCont','Soft & Control Technology s.r.o.'),(346863480832,'U-Care','U-CARE INC.'),(346863484928,'Stockery','StockerYale'),(346863489024,'Meshwork','MeshWorks Wireless Oy'),(346863493120,'Chronolo','ChronoLogic Pty. Ltd.'),(346863497216,'SpContro','SP Controls, Inc'),(346863501312,'Geonauti','Geonautics Australia Pty Ltd'),(346863505408,'PhytecMe','Phytec Messtechnik GmbH'),(346863509504,'Rafael',''),(346863513600,'PeekTraf','Peek Traffic Corporation'),(346863517696,'GlobalRa','Global Rainmakers Inc.'),(346863521792,'MightyLu','Mighty Lube Systematic Lubricati'),(346863525888,'Unisenso','Unisensor A/S'),(346863529984,'AirMonit','Air Monitors Ltd'),(346863534080,'Incyma',''),(346863538176,'Elettron','elettrondata srl'),(346863542272,'EssepieS','Essepie Srl'),(346863546368,'GoEngine','GO engineering GmbH'),(346863550464,'Synthese','Synthesechemie Dr. Penth GmbH'),(346863554560,'GeneralD','General Dynamics C4 Sysems'),(346863558656,'Neoptix','Neoptix Inc.'),(346863562752,'Altinex','Altinex, Inc'),(346863566848,'At4Wirel','AT4 wireless.S.A'),(346863570944,'Evercare',''),(346863575040,'PowerMed','Power Medical Interventions'),(346863579136,'Psd',''),(346863583232,'Advanced','Advanced Electronic Designs, Inc'),(346863587328,'AbsGesel','ABS Gesellschaft f. Automatisier'),(346863591424,'VecomUsa','VECOM USA'),(346863595520,'Redwood','Redwood Systems'),(346863599616,'Bit-LabP','Bit-Lab PTY LTD'),(346863603712,'Clearcor','ClearCorp Enterprises, Inc'),(346863607808,'Embedia',''),(346863611904,'Umlogics','UMLogics Corporation'),(346863616000,'FritzPau','Fritz Pauker Ingenieure GmbH'),(346863620096,'3roam',''),(346863624192,'Iptec','IPtec, Inc.'),(346863628288,'National','National CineMedia'),(346863632384,'FrSauter','Fr. Sauter AG'),(346863636480,'GreenGoo','Green Goose'),(346863640576,'AcdElekt','ACD Elektronik Gmbh'),(346863644672,'PalomarP','Palomar Products, Inc.'),(346863648768,'DixellSP','Dixell S.p.A.'),(346863652864,'KramaraS','Kramara s.r.o.'),(346863656960,'Energid',''),(346863661056,'MidwestM','Midwest Microwave Solutions Inc.'),(346863665152,'GlobalSa','Global Satellite Engineering'),(346863669248,'Ingenieu','Ingenieurbuero Bickele und Buehl'),(346863673344,'Absolute','Absolute Fire Solutions Inc.'),(346863681536,'OdusTech','Odus Technologies SA'),(346863685632,'Homescen','HomeScenario, Inc.'),(346863689728,'Trolex','Trolex Limited'),(346863693824,'XobyteLl','XoByte LLC'),(346863697920,'Saia-Bur','Saia-Burgess Controls AG'),(346863702016,'HsrHaral','HSR Harald L. Reuter'),(346863706112,'Master','MASTER CO LTD'),(346863710208,'SpiderTe','Spider Tecnologia Ind. e Com. Lt'),(346863714304,'Ubiquiti','Ubiquiti Networks'),(346863718400,'PolaSRL','POLA s.r.l.'),(346863722496,'Compudes','CompuDesigns, Inc.'),(346863726592,'Fareco',''),(346863730688,'Goerlitz','Goerlitz AG'),(346863734784,'HarperCh','Harper Chalice Group Limited'),(346863738880,'Induther','Indutherm Giesstechnologie GmbH'),(346863742976,'Honeywel','Honeywell'),(346863747072,'SmartbTe','SMARTB TECHNOLOGIES'),(346863751168,'JapanEle','Japan Electronics System, Inc'),(346863755264,'KyabLule','KYAB Lulea AB'),(346863759360,'NaraCont','NARA Controls Inc.'),(346863763456,'MarineEn','Marine Entertainment Systems Ltd'),(346863767552,'ExelSRL','EXEL s.r.l'),(346863771648,'CmElektr','CM Elektronik GmbH'),(346863775744,'MeasyEle','Measy Electronics Co., Ltd.'),(346863779840,'KeithKoe','Keith & Koep GmbH'),(346863783936,'Phototel','PhotoTelesis LP'),(346863788032,'Neothing','Neothings, Inc.'),(346863792128,'ElcoteqD','Elcoteq Design Center Oy'),(346863796224,'Rosslare','Rosslare Enterprises Limited'),(346863800320,'Polytron','Polytron Corporation'),(346863804416,'Elcus',''),(346863808512,'Integrat','Integrated  Control Corp.'),(346863812608,'PhytecMe','Phytec Messtechnik GmbH'),(346863816704,'Telegeni','Telegenix'),(346863820800,'AbbottMe','Abbott Medical Optics'),(346863824896,'ScaSchuc','SCA Schucker GmbH & Co.'),(346863828992,'Five9Net','FIVE9 NETWORK SYSTEMS LLC'),(346863833088,'Phytron-','Phytron-Elektronik GmbH'),(346863837184,'FarsiteC','FarSite Communications Limited'),(346863841280,'RonyoTec','Ronyo Technologies s.r.o.'),(346863845376,'Teledyne','Teledyne Defence Limited'),(346863849472,'Triax','Triax A/S'),(346863853568,'Elko','Elko Systems'),(346863857664,'Ateme',''),(346863861760,'Micromax','Micromax Pty. Ltd.'),(346863865856,'IntegraL','Integra LifeSciences (Ireland) L'),(346863869952,'TrenchAu','Trench Austria GmbH'),(346863874048,'Cosmodat','CosmoData Informatica Ltda.'),(346863878144,'Concepte','Concepteers, LLC'),(346863882240,'DatasatD','Datasat Digital Entertainment'),(346863886336,'Act',''),(346863890432,'Intelliv','IntelliVision Technologies, Corp'),(346863894528,'AppliedM','Applied Micro Electronics \"AME\" '),(346863898624,'ShopSafe','Shop Safe AG'),(346863902720,'ByresSec','Byres Security Inc'),(346863906816,'Numcore','Numcore Ltd'),(346863910912,'Meisol','Meisol co.,ltd'),(346863915008,'Haneron',''),(346863919104,'Crde',''),(346863923200,'Iadea','IAdea Corporation'),(346863927296,'Grenmore','Grenmore Ltd'),(346863931392,'Sixis','siXis, Inc.'),(346863935488,'Nikon','Nikon Systems Inc.'),(346863939584,'Sportvis','Sportvision Inc.'),(346863943680,'Janascar','JanasCard'),(346863947776,'Ams',''),(346863951872,'SageCons','Sage Consultants'),(346863955968,'M-Tronic','M-Tronic Design and Technology G'),(346863960064,'TecnintH','Tecnint HTE SRL'),(346863964160,'TataPowe','Tata Power Company, Strategic El'),(346863968256,'EtmElect','ETM Electromatic Incorporated'),(346863972352,'J-System','J-Systems Inc.'),(346863976448,'Ampcontr','Ampcontrol Pty Ltd'),(346863980544,'Efftroni','Efftronics Systems (P) Ltd'),(346863984640,'Mobileye',''),(346863988736,'McsMicro','MCS MICRONIC Computer Systeme Gm'),(346863992832,'Mtd','MTD GmbH'),(346863996928,'AplexTec','Aplex Technology Inc.'),(346864001024,'Saia-Bur','Saia-Burgess Controls AG'),(346864005120,'Chitose','Chitose Co.,Ltd'),(346864009216,'Electroc','ElectroCom'),(346864013312,'Troll','Troll Systems Corporation'),(346864017408,'Aixcontr','AixControl GmbH'),(346864021504,'SenconUk','Sencon UK Ltd.'),(346864025600,'Selco',''),(346864029696,'Aeroflex','Aeroflex GmbH'),(346864033792,'SmhTechn','SMH Technologies'),(346864037888,'Prodco',''),(346864041984,'ApgCashD','APG Cash Drawer, LLC'),(346864046080,'SanyoEle','SANYO ELECTRONIC INDUSTRIES CO.,'),(346864050176,'SinoviaS','SINOVIA SA'),(346864054272,'PhytecMe','Phytec Messtechnik GmbH'),(346864058368,'RealD','Real D'),(346864062464,'SlicanSp','SLICAN sp. z o.o.'),(346864066560,'GreenCen','GREEN Center s.r.o.'),(346864070656,'Timberli','Timberline Mfg Company'),(346864074752,'AdiVideo','ADI Video Technologies'),(346864078848,'PlitronM','Plitron Manufacturing Inc.'),(346864082944,'Palgiken','Palgiken Co.,Ltd.'),(346864087040,'NorthBri','North Bridge Technologies'),(346864091136,'OooNpfAt','OOO NPF ATIS'),(346864095232,'Nayos','Nayos LTD'),(346864099328,'Measurem','Measurement Technology NW'),(346864103424,'RoVeRLab','RO.VE.R. Laboratories S.p.A'),(346864107520,'FewBauer','FEW Bauer GmbH'),(346864111616,'PeekTraf','Peek Traffic Corporation'),(346864115712,'Deuta-We','Deuta-Werke GmbH'),(346864119808,'Rc','RC Systems Co. Inc.'),(346864123904,'Electron','Electronic Systems Protection, I'),(346864128000,'ThetisSP','Thetis S.p.A.'),(346864132096,'PhytecMe','Phytec Messtechnik GmbH'),(346864136192,'PhytecMe','Phytec Messtechnik GmbH'),(346864140288,'Drinelec',''),(346864144384,'SoundMet','Sound Metrics Corp'),(346864152576,'Ct','CT Company'),(346864156672,'NisshinE','Nisshin Electronics co.,ltd.'),(346864160768,'Digitale','Digitale Analoge COMponenten Wes'),(346864164864,'Advanced','Advanced Desktop Systems Ltd'),(346864168960,'ArkrayKy','ARKRAY, Inc. Kyoto Laboratory'),(346864173056,'AxedJaku','AXED Jakubowski Wojciechowski sp'),(346864177152,'Blankom',''),(346864181248,'ItfFrÃ¶sc','ITF FrÃ¶schl GmbH'),(346864185344,'Kristech',''),(346864189440,'Folink',''),(346864193536,'MitsuyaL','MITSUYA LABORATORIES INC.'),(346864197632,'SchnoorI','Schnoor Industrieelektronik GmbH'),(346864201728,'Quartech','QUARTECH CORPORATION'),(346864205824,'BettiniS','Bettini srl'),(346864209920,'EletechS','ELETECH Srl'),(346864214016,'Naretren','NARETRENDS'),(346864218112,'Enatel',''),(346864222208,'IscreenL','iScreen LLC'),(346864226304,'GhlAdvan','GHL Advanced Technolgy GmbH & Co'),(346864230400,'Tanabiki','TANABIKI Inc.'),(346864234496,'Advanced','Advanced Storage Concepts, Inc.'),(346864238592,'Innovate','Innovate Software Solutions Pvt '),(346864242688,'Silverne','SilverNet'),(346864246784,'Asto',''),(346864250880,'Emac','EMAC, Inc.'),(346864254976,'Gigatron','Gigatronik  KÃ¶ln GmbH'),(346864259072,'EntecEle','ENTEC Electric & Electronic Co.,'),(346864263168,'Micropoi','MicroPoise'),(346864267264,'Fbb',''),(346864271360,'KeithKoe','Keith & Koep GmbH'),(346864275456,'Cemsi',''),(346864279552,'WacIsrae','WAC (Israel) Ltd.'),(346864283648,'Gentec',''),(346864287744,'Naonwork','NAONWORKS Co., Ltd'),(346864291840,'Finnet-S','Finnet-Service Ltd.'),(346864295936,'AbbTrans','ABB Transmission and Distributio'),(346864300032,'EmcPartn','EMC PARTNER AG'),(346864304128,'TritechI','Tritech International Ltd');
INSERT INTO `manufacturers` VALUES (346864308224,'RxMonito','Rx Monitoring Services'),(346864312320,'OnixElec','Onix Electronic Systems Inc'),(346864316416,'Ikerlan',''),(346864320512,'Southwes','Southwest Research Institute'),(346864324608,'Greenlig','Greenlight Innovation Corp.'),(346864328704,'TaloNv','Talo, NV Inc'),(346864332800,'Telventy','Telventy Energia S.A.'),(346864336896,'DaveSrl','Dave srl'),(346864340992,'WVershov','W. Vershoven GmbH'),(346864345088,'Saia-Bur','Saia-Burgess Controls AG'),(346864349184,'Audiosco','AUDIOSCOPE 2K SRL'),(346864353280,'Txtr','txtr GmbH'),(346864357376,'Transtec','Transtechnik GmbH & Co.KG'),(346864361472,'LogicalT','Logical Tools s.r.l.'),(346864365568,'DspDesig','DSP DESIGN LTD'),(346864369664,'CustosMo','CUSTOS MOBILE S.L.'),(346864373760,'Intercel','InterCel Pty Ltd'),(346864377856,'Jomitek',''),(346864381952,'Raumcomp','RaumComputer Entwicklungs- und V'),(346864386048,'PeekTraf','Peek Traffic Corporation'),(346864390144,'SissTech','SISS Technology Inc.'),(346864394240,'Networkf','NetworkFX Communications, LLC'),(346864398336,'IdealTek','iDeal Teknoloji Bilisim Cozumler'),(346864402432,'VitecoVn','VITECO VNPT JSC'),(346864406528,'Predikto','Prediktor AS'),(346864410624,'FiberCon','Fiber Connections Inc.'),(346864414720,'Mangodsp',''),(346864418816,'Gainbrai','Gainbrain'),(346864422912,'Pro4tech',''),(346864427008,'StMichae','St Michael Strategies Inc'),(346864431104,'Climatew','ClimateWell AB (publ)'),(346864435200,'JscElect','JSC Electrical Equipment Factory'),(346864439296,'MroadInf','MROAD INFORMATION SYSTEM'),(346864443392,'QuarchTe','Quarch Technology Ltd'),(346864447488,'GeneralD','General Dynamics C4 Systems'),(346864451584,'Moetroni','MoeTronix'),(346864455680,'Toptech','Toptech Systems, Inc.'),(346864459776,'Systemte','Systemteq Limited'),(346864463872,'GhlBerha','GHL Systems Berhad'),(346864467968,'Impactsy','ImpactSystems'),(346864472064,'ItsTelec','ITS Telecom'),(346864476160,'Onlinepi','Onlinepizza Norden AB'),(346864480256,'PhytecMe','Phytec Messtechnik GmbH'),(346864484352,'GalaxiaE','Galaxia Electronics'),(346864488448,'Sentec','Sentec Ltd'),(346864492544,'XslentEn','XSLENT Energy Technologies LLC'),(346864496640,'PhytecMe','Phytec Messtechnik GmbH'),(346864500736,'Wheatsto','Wheatstone Corporation'),(346864504832,'Toptechn','Toptechnology SRL'),(346864508928,'Mirerota','MireroTack'),(346864513024,'Pts','PTS GmbH'),(346864517120,'Agwtech','AGWTech Ltd'),(346864521216,'Nextmove','Nextmove Technologies'),(346864525312,'Aitecsys','Aitecsystem Co.,Ltd.'),(346864529408,'ArteixoT','ARTEIXO TELECOM'),(346864533504,'VvdnTech','VVDN TECHNOLOGIES PVT. LTD.'),(346864537600,'Highligh','Highlight Parking Systems Ltd'),(346864541696,'TvPortal','TV Portal Co., Ltd.'),(346864545792,'EpikoEle','Epiko, elektronski sistemi d.o.o'),(346864549888,'EdcWifi','EDC wifi'),(346864553984,'AriemTec','Ariem Technologies Pvt Ltd'),(346864558080,'Percello','Percello Ltd.'),(346864562176,'Postjet','Postjet Systems Ltd'),(346864566272,'GlobalSe','Global Security Devices'),(346864570368,'Rf-Embed','RF-Embedded GmbH'),(346864574464,'Bg','BG Systems, Inc.'),(346864578560,'Slat',''),(346864582656,'BAB-Tech','b.a.b-technologie gmbh'),(346864586752,'AmsContr','AMS Controls, Inc.'),(346864590848,'DigitalL','Digital Lumens'),(346864594944,'Gastops','GasTOPS Ltd.'),(346864599040,'SsLlc','SS Systems LLC'),(346864607232,'Evo-TehD','Evo-Teh d.o.o.'),(346864611328,'Euro-Kon','Euro-Konsult Sp. z o.o.'),(346864615424,'Phaedrus','Phaedrus Limited'),(346864619520,'TattileS','TATTILE SRL'),(346864623616,'Converge','Convergent Bioscience Ltd.'),(346864627712,'Jiskoot','Jiskoot Ltd'),(346864631808,'GrupoEpe','Grupo Epelsa S.L.'),(346864635904,'RfCode','RF Code, Inc'),(346864640000,'Docobo','Docobo Ltd'),(346864644096,'Genetec','Genetec Inc.'),(346864648192,'VehicleT','VEHICLE TESTING EQUIPMENT, S.L.'),(346864652288,'Zucchett','ZUCCHETTI SPA'),(346864656384,'Daeyoung','Daeyoung inc.'),(346864660480,'PeekTraf','Peek Traffic Corporation'),(346864664576,'DrsLarue','DRS Laruel Technologies'),(346864668672,'TouchRev','Touch Revolution Inc.'),(346864676864,'Sociedad','SOCIEDAD IBERICA DE CONSTRUCCION'),(346864680960,'Aim',''),(346864685056,'AmaticIn','Amatic Industries GmbH'),(346864689152,'Saia-Bur','Saia-Burgess Controls AG'),(346864693248,'Wanco','Wanco Inc.'),(346864697344,'MonarchI','Monarch Innovative Technologies '),(346864701440,'AilesEle','AILES ELECTRONICS CO., LTD.'),(346864705536,'NolamEmb','NOLAM EMBEDDED SYSTEMS'),(346864709632,'PhytecMe','Phytec Messtechnik GmbH'),(346864713728,'Crtiical','Crtiical Link'),(346864717824,'VitelNet','Vitel Net'),(346864721920,'RohdeSch','Rohde & Schwarz Topex SA'),(346864726016,'EcsSrl','ECS Srl'),(346864730112,'Altronix','Altronix Corporation'),(346864734208,'Ernemann','Ernemann Cine Tec GmbH'),(346864738304,'Ingeteam','Ingeteam Paneles S.A.U.'),(346864742400,'ISASRL','I.S.A. S.r.l.'),(346864746496,'AcdElekt','ACD Elektronik GmbH'),(346864750592,'QuercusT','QUERCUS TECHNOLOGIES, S.L.'),(346864754688,'HanningE','Hanning Elektro-Werke GmbH & Co.'),(346864758784,'Volumati','Volumatic Limited.'),(346864762880,'Sogeme',''),(346864766976,'DopplerL','Doppler Systems LLC'),(346864771072,'AnalogWa','ANALOG WAY'),(346864775168,'CioInfor','CIO Informatique Industrielle'),(346864779264,'Juicebos','juiceboss'),(346864783360,'GlobeWir','Globe Wireless'),(346864787456,'AbbTrans','ABB Transmission and Distributio'),(346864791552,'Prosourc','ProSourcing GmbH'),(346864795648,'Altierre',''),(346864799744,'FrSauter','Fr. SauterAG'),(346864803840,'Avitroni','AVItronic GmbH'),(346864807936,'DycecSA','DYCEC, S.A.'),(346864812032,'KeithKoe','Keith & Koep GmbH'),(346864816128,'ArtAntri','ART Antriebs- und Regeltechnik G'),(346864820224,'OkiDenki','OKI DENKI BOHSAI CO.,LTD.'),(346864824320,'DantecDy','Dantec Dynamics A/S'),(346864828416,'Spectron','Spectronix Corporation'),(346864832512,'Ino-Inst','INO - Institut National d`Optiqu'),(346864836608,'OmicronE','OMICRON electronics GmbH'),(346864840704,'Axis-Shi','Axis-Shield PoC AS'),(346864844800,'Linuxsta','Linuxstamp Designs, LLC'),(346864848896,'Ibercomp','Ibercomp SA'),(346864852992,'Sam','SAM Co., Ltd.'),(346864857088,'Graessli','Graesslin GmbH'),(346864861184,'BectonDi','Becton Dickinson'),(346864865280,'Powerbas','Powerbase Energy Systems Inc.'),(346864869376,'Peperoni','Peperoni-Light'),(346864873472,'Speciali','Specialist Electronics Services '),(346864877568,'SrcCompu','SRC Computers, LLC'),(346864885760,'Audient','Audient Ltd'),(346864889856,'VidiconL','Vidicon LLC'),(346864893952,'Qualneti','Qualnetics Corporation'),(346864902144,'AustcoCo','Austco Communication Systems Pty'),(346864906240,'Qtechnol','Qtechnology A/S'),(346864910336,'Elreha','ELREHA GmbH'),(346864914432,'NewtelEn','Newtel Engineering S.r.l.'),(346864918528,'Realtime','RealTime Systems Ltd'),(346864922624,'Z-App','Z-App Systems, Inc.'),(346864926720,'Bach-Mes','bach-messtechnik gmbh'),(346864930816,'Digitale','Digitale Analoge COMponenten Wes'),(346864934912,'Dismunte','DISMUNTEL SAL'),(346864939008,'ReflexCe','REFLEX CES'),(346864943104,'WagnerGr','Wagner Group GmbH'),(346864947200,'4dTechno','4D Technology Corporation'),(346864951296,'ProconEl','Procon Electronics'),(346864959488,'Kyuhen',''),(346864963584,'Insitu','Insitu, Inc.'),(346864967680,'Set','SET GmbH'),(346864971776,'BEARSolu','B.E.A.R. Solutions (Australasia)'),(346864975872,'Computer','Computer Automation Technology I'),(346864979968,'SecadSa','SECAD SA'),(346864984064,'SiconSRL','Sicon s.r.l.'),(346864988160,'Elektro-','ELEKTRO-AUTOMATIK GmbH & Co. KG'),(346864992256,'ElsistSR','ELSIST S.r.l.'),(346864996352,'PlaElect','PLA ELECTRO APPLIANCES PVT. LTD.'),(346865000448,'Sysacom',''),(346865004544,'Anxebusi','ANXeBusiness Corporation'),(346865008640,'BaeBofor','BAE Systems Bofors AB'),(346865012736,'Comprion','COMPRION GmbH'),(346865016832,'Saia-Bur','Saia-Burgess Controls AG'),(346865020928,'Cammegh','Cammegh Limited'),(346865025024,'BeijingZ','Beijing Zhongherongzhi Elec.&Tec'),(346865029120,'Galvamat','Galvamat & Unican Technologies S'),(346865033216,'Qne','QNE GmbH & Co. KG'),(346865037312,'WeltekTe','Weltek Technologies Co. Ltd.'),(346865041408,'CytekMed','Cytek Media Systems, INC.'),(346865045504,'Elektron','Elektronic Thoma GmbH'),(346865049600,'HerrickT','Herrick Technology Laboratories,'),(346865053696,'RVRElett','R.V.R. elettronica s.p.a.'),(346865057792,'LancierM','Lancier Monitoring GmbH'),(346865061888,'Industri','Industrial Automation Systems'),(346865065984,'Elaso','Elaso AG'),(346865070080,'Powersen','Powersense A/S'),(346865074176,'BeceemCo','Beceem Communications, Inc.'),(346865078272,'InforceC','InForce Computing, Inc.'),(346865082368,'Smartfie','Smartfield, Inc.'),(346865086464,'Eilersen','Eilersen Electric A/S'),(346865090560,'HpcPlatf','HPC Platform'),(346865094656,'Watterot','Watterott electronic'),(346865098752,'SpirentC','Spirent Communications'),(346865102848,'HighSpee','High Speed Design, Inc.'),(346865106944,'Foerster','Foerster-Technik GmbH'),(346865111040,'SkdSyste','SKD System AB'),(346865115136,'Commotiv','Commotive A/S'),(346865119232,'MicroTec','MICRO TECHNICA'),(346865123328,'WavecomE','WAVECOM ELEKTRONIK AG'),(346865127424,'Swemet','SweMet AB'),(346865131520,'Cellplus','CellPlus technologies, Inc.'),(346865135616,'IconTime','Icon Time Systems'),(346865139712,'Integrat','Integration Technologies Limited'),(346865143808,'Haivisio','HaiVision Systems Incorporated'),(346865147904,'ZeusPriv','Zeus Systems Private Limited'),(346865152000,'PotterEl','Potter Electric Signal Company'),(346865156096,'PalSoftw','Pal Software Service Co.,Ltd.'),(346865160192,'MicroI/O','Micro I/O Servicos de Electronic'),(346865164288,'KsBescha','KS Beschallungstechnik GmbH'),(346865168384,'Practica','Practical Control Ltd'),(346865172480,'Broadsof','Broadsoft PacketSmart, Inc.'),(346865176576,'Rebo','REBO CO.,LTD.'),(346865180672,'Electron','ELECTRONICA KELD'),(346865184768,'Sigarden','SiGarden Sp z o.o.'),(346865188864,'DorletSA','DORLET S.A.'),(346865192960,'Deansoft','Deansoft CO., Ltd.'),(346865197056,'Tbs','TBS Holding AG'),(346865201152,'MsbElekt','MSB Elektronik und Geraetebau Gm'),(346865205248,'WilkeTec','Wilke Technology GmbH'),(346865209344,'SequoiaT','Sequoia Technology Group Ltd'),(346865213440,'Quail',''),(346865217536,'Industry','Industry Controls, Inc.'),(346865221632,'Wapice','Wapice Ltd.'),(346865225728,'Rovsing','Rovsing A/S'),(346865229824,'Gridmana','GridManager A/S'),(346865233920,'Aim','AIM Co.,Ltd'),(346865238016,'9solutio','9Solutions Oy'),(346865242112,'Codesyst','CODESYSTEM Co.,Ltd'),(346865246208,'Protonic','Protonic Holland'),(346865250304,'Honeywel','Honeywell'),(346865254400,'Scienlab','Scienlab Electronic Systems GmbH'),(346865258496,'TaeAntri','TAE Antriebstechnik GmbH'),(346865262592,'Buerkert','Buerkert Werke GmbH'),(346865266688,'KinectsS','Kinects Solutions Inc'),(346865270784,'Reko-Vek',''),(346865274880,'OdysseeS','Odyssee Systemes SAS'),(346865278976,'KyoshaIn','Kyosha Industries'),(346865283072,'Gronic','Gronic Systems GmbH'),(346865287168,'Domis',''),(346865291264,'PeekTraf','Peek Traffic Corporation'),(346865295360,'Bruckner','Bruckner & Jarosch Ingenieurgese'),(346865299456,'Leco','LECO Corporation'),(346865303552,'CsiContr','CSI Controles e Sistemas Industr'),(346865307648,'Creative','Creative Micro Design'),(346865311744,'Automate','Automated Media Services, Inc.'),(346865315840,'OcasAs','OCAS AS'),(346865319936,'LanmarkC','Lanmark Controls Inc.'),(346865324032,'Emergenc','Emergency Message Controls LLC'),(346865328128,'SddItg','SDD ITG'),(346865332224,'KeithKoe','Keith & Koep GmbH'),(346865336320,'Reald',''),(346865340416,'MediaTec','Media Technologies Ltd.'),(346865344512,'Emac','EMAC, Inc.'),(346865348608,'SensairP','SENSAIR Pty Ltd'),(346865352704,'IsisEngi','ISIS ENGINEERING, S.A.'),(346865356800,'IpsesSRL','IPSES S.r.l.'),(346865360896,'Cybercra','CyberCraft'),(346865364992,'Mstronic','MSTRONIC CO., LTD.'),(346865369088,'Criticar','Criticare Systems, Inc'),(346865373184,'HjpcDbaP','HJPC Corporation dba Pactron'),(346865377280,'PacompSp','PACOMP Sp. z o.o.'),(346865381376,'SmElectr','Sm electronic co.'),(346865385472,'Saia-Bur','Saia-Burgess Controls AG'),(346865389568,'RadiusSw','Radius Sweden AB'),(346865393664,'RohdeSch','Rohde & Schwarz Topex SA'),(346865397760,'XxterBV','xxter b.v.'),(346865401856,'KieferTe','Kiefer technic GmbH'),(346865405952,'WayneKer','Wayne Kerr Electronics'),(346865410048,'Logical','The Logical Company'),(346865414144,'Ct','CT Company'),(346865418240,'VoxTechn','Vox Technologies'),(346865422336,'Yokowo','YOKOWO CO.,LTD'),(346865426432,'Vidisys','Vidisys GmbH'),(346865430528,'ThermoFi','Thermo Fisher Scientific'),(346865434624,'WithInte','Systems With Intelligence Inc.'),(346865438720,'Intellig','Intelligent Devices'),(346865442816,'DspDesig','DSP DESIGN LTD'),(346865446912,'SaeIt-Sy','SAE IT-systems GmbH & Co. KG'),(346865451008,'Purvis','PURVIS Systems Incorporated'),(346865455104,'PacificC','Pacific Coast Engineering'),(346865459200,'Campbell','Campbell Scientific Canada Corp.'),(346865463296,'FrSauter','Fr. Sauter AG'),(346865467392,'Konsmeta','Konsmetal S.A.'),(346865471488,'ZkCellte','ZK Celltest Inc'),(346865475584,'Moravian','Moravian Instruments'),(346865479680,'Deuta-We','Deuta-Werke GmbH'),(346865483776,'GeaFarmT','GEA Farm Technologies GmbH'),(346865491968,'KrontekP','Krontek Pty Ltd'),(346865496064,'Inotech','inotech GmbH'),(346865500160,'Raith','Raith GmbH'),(346865504256,'MicroTec','Micro Technic A/S'),(346865508352,'DeltaTau','DELTA TAU DATA SYSTEMS'),(346865512448,'Coptonix','Coptonix GmbH'),(346865516544,'CpEletro','CP ELETRONICA SA'),(346865520640,'HiTechEl','Hi Tech Electronics Ltd'),(346865524736,'CodeBlue','CODE BLUE CORPORATION'),(346865528832,'Megacon','Megacon AB'),(346865532928,'WorldTim','World Time Solutions Limited'),(346865537024,'Level3Co','Level 3 Communications'),(346865541120,'Conectai','ConectaIP Tecnologia S.L.'),(346865545216,'Viscount','viscount systems inc.'),(346865549312,'GeneralD','General Dynamics C4S'),(346865553408,'Tecnovum','Tecnovum AG'),(346865557504,'Kdt',''),(346865561600,'ToprootT','TOPROOT Technology Corp. Ltd.,'),(346865569792,'Promess','Promess GmbH'),(346865573888,'SanminaS','SANMINA SHENZHEN'),(346865577984,'Captivea','CaptiveAire Systems Inc.'),(346865582080,'Smartech','Smartech-technology'),(346865586176,'FujiData','FUJI DATA SYSTEM Co.,Ltd.'),(346865590272,'Mac-Gray','Mac-Gray Corporation'),(346865594368,'TaskSist','TASK SISTEMAS DE COMPUTACAO LTDA'),(346865598464,'MmeMuell','MME Mueller Mikroelektronik'),(346865602560,'AcdElekt','ACD Elektronik GmbH'),(346865606656,'Sim2Mult','SIM2 Multimedia S.p.A.'),(346865610752,'Covidenc','Covidence A/S'),(346865614848,'Schraml','SCHRAML GmbH'),(346865618944,'ArcosTec','Arcos Technologies Ltd.'),(346865623040,'Arktan','Arktan Systems'),(346865627136,'Saia-Bur','Saia-Burgess Controls AG'),(346865631232,'It-IsInt','IT-IS International Ltd.'),(346865635328,'NdcInfra','NDC Infrared Engineering, Inc.'),(346865639424,'Taskit','taskit GmbH'),(346865643520,'Rutter','RUTTER INC'),(346865647616,'AbbTrans','ABB Transmission and Distributio'),(346865651712,'KCCShoka','K.C.C. SHOKAI LIMITED'),(346865655808,'AxotecTe','Axotec Technologies GmbH'),(346865659904,'CoreelTe','CoreEL TEchnologies (I) Pvt Ltd'),(346865664000,'Industri','Industrial Control Links, Inc.'),(346865668096,'Satellin','Satellink Inc.'),(346865672192,'SiconSRL','Sicon s.r.l.'),(346865676288,'Industri','Industrial Automatics Design Bur'),(346865680384,'Tektroni','TEKTRONIK'),(346865684480,'Maretron','Maretron, LLP'),(346865688576,'AplicaTe','APLICA TECHNOLOGIES'),(346865692672,'Echola','Echola Systems'),(346865696768,'ThomasBe','Thomas & Betts'),(346865704960,'KeithKoe','Keith & Koep GmbH'),(346865709056,'ToyonRes','Toyon Research Corporation'),(346865713152,'Erhardt+','Erhardt+Leimer GmbH'),(346865717248,'Aeromech','AeroMechanical Services Ltd, FLY'),(346865721344,'Embed-It','EMBED-IT OG'),(346865725440,'Lupatecn','Lupatecnologia e Sistemas Ltda'),(346865729536,'InvisoBV','Inviso B.V.'),(346865733632,'Telgaas','TelGaAs, Inc.'),(346865737728,'WeissRob','Weiss Robotics GmbH & Co. KG'),(346865741824,'DaikenAu','Daiken Automacao Ltda'),(346865745920,'Baudisch','Baudisch Electronic GmbH'),(346865750016,'Aircell','AirCell Inc.'),(346865754112,'EpecOy','Epec Oy'),(346865758208,'ArmourHo','Armour Home Electronics LTD'),(346865762304,'BeksKomm','beks Kommunikacios Technika kft'),(346865766400,'ElbitOfA','Elbit Systems of America'),(346865770496,'GrupoEpe','Grupo Epelsa S.L.'),(346865774592,'NewEmbed','New Embedded Technology'),(346865778688,'TritiumP','Tritium Pty Ltd'),(346865782784,'Airfolc','AIRFOLC,INC.'),(346865786880,'Techlead','Techleader'),(346865790976,'Infrasaf','Infrasafe, Inc.'),(346865795072,'Bodensee','Bodensee Gravitymeter Geosystem '),(346865799168,'Aanderaa','Aanderaa Data Instruments'),(346865803264,'Survalen','SURVALENT TECHNOLOGY CORP'),(346865807360,'PeekelIn','Peekel Instruments B.V.'),(346865811456,'TehamaWi','Tehama Wireless'),(346865819648,'NckResea','nCk Research LLC'),(346865823744,'Iaf','IAF GmbH'),(346865827840,'Reimesch','Reimesch Kommunikationssysteme G'),(346865831936,'Guardtec','Guardtec, Inc.'),(346865836032,'Airpoint','Airpoint Co., Ltd.'),(346865840128,'CodacoEl','CODACO ELECTRONIC s.r.o.'),(346865844224,'JvlIndus','JVL Industri Elektronik'),(346865848320,'DecaCard','DECA Card Engineering GmbH'),(346865852416,'WeinertE','Weinert Engineering GmbH'),(346865856512,'Saia-Bur','Saia-Burgess Controls AG'),(346865860608,'Rosslare','Rosslare Enterprises Ltd.'),(346865864704,'AplexTec','Aplex Technology Inc.'),(346865868800,'TokyoWel','Tokyo Weld Co.,Ltd.'),(346865872896,'GunmaEle','GUNMA ELECTRONICS CO LTD'),(346865876992,'SaetIS','SAET I.S.'),(346865881088,'Msr-Offi','MSR-Office GmbH'),(346865885184,'ImricorM','Imricor Medical Systems, Inc.'),(346865889280,'CueAS','CUE, a.s.'),(346865893376,'Glyn','Glyn GmbH & Co.KG'),(346865897472,'AppliedM','Applied Medical Technologies, In'),(346865901568,'Gillam-F','GILLAM-FEI S.A.'),(346865905664,'Techkon','TECHKON GmbH'),(346865909760,'ReconDyn','Recon Dynamics, LLC'),(346865913856,'MocoMedi','Moco Media Pty Ltd'),(346865917952,'Tobila','Tobila Systems, Inc.'),(346865922048,'OlympusN','Olympus NDT Canada Inc.'),(346865926144,'7+Kft','7+ Kft'),(346865930240,'Innovati','Innovative Circuit Technology'),(346865934336,'EmdeeTec','eMDee Technology, Inc.'),(346865938432,'Blueston','Bluestone Technology GmbH'),(346865942528,'ExproNor','Expro North Sea'),(346865946624,'VafInstr','VAF Instruments BV'),(346865950720,'RchGroup','RCH GROUP'),(346865954816,'FrSauter','Fr.Sauter AG'),(346865958912,'Digitale','Digitale Analoge COMponenten Wes'),(346865963008,'AxibleTe','Axible Technologies'),(346865967104,'Millenni','Millennium Electronics Pty.Ltd.'),(346865971200,'VideoTec','Video Tech Laboratories, Inc.'),(346865975296,'Schneide','Schneider Electric Motion USA'),(346865979392,'CadiScie','CADI SCIENTIFIC PTE LTD'),(346865983488,'RsGesell','RS Gesellschaft fur Informations'),(346865987584,'Key','Key Systems, Inc.'),(346865991680,'ActivFin','ACTIV Financial Systems, Inc.'),(346865995776,'UngavaTe','UNGAVA Technologies Inc.'),(346865999872,'Realtime','RealTime Systems Ltd'),(346866003968,'Maddalen','Maddalena S.p.A'),(346866008064,'GaonTech','GAON TECH corp.'),(346866012160,'Ug','UG Systems GmbH & Co. KG'),(346866016256,'Enatel','Enatel Limited'),(346866020352,'LjtAssoc','LJT & Associates, Inc.'),(346866024448,'KyowaEle','Kyowa Electronics Co.,Ltd.'),(346866028544,'ApexNv','Apex NV'),(346866032640,'Wellsens','WellSense Technologies'),(346866036736,'Gitsn','Gitsn Inc.'),(346866040832,'Assystem','ASSYSTEM France'),(346866044928,'TellabsO','Tellabs Operations Inc.'),(346866049024,'SynatecE','Synatec Electronic GmbH'),(346866053120,'CssLlc','CSS, LLC'),(346866057216,'DemmelPr','demmel products'),(346866061312,'AreaEner','AREA ENERGY, INC.'),(346866065408,'HagenukK','Hagenuk KMT GmbH'),(346866069504,'Dsp4you','DSP4YOU Ltd'),(346866073600,'Saia-Bur','Saia-Burgess Controls AG'),(346866077696,'Technago','Technagon GmbH'),(346866081792,'ThalesNe','Thales Nederland BV'),(346866085888,'RohdeSch','Rohde & Schwarz Topex SA'),(346866089984,'Watermar','Watermark Estate Management Serv'),(346866094080,'SmithMet','Smith Meter, Inc'),(346866098176,'AthSyste','ATH system'),(346866102272,'IndraAus','Indra Australia'),(346866106368,'DalogDia','DALOG Diagnosesysteme GmbH'),(346866110464,'YardneyT','Yardney Technical Products Inc.'),(346866114560,'KeithKoe','Keith & Koep GmbH'),(346866118656,'Secom','SECOM GmbH'),(346866122752,'SolbrigE','Solbrig Electronics, Inc.'),(346866126848,'BettiniS','BETTINI SRL'),(346866130944,'F+DFeinw','F+D Feinwerk- und Drucktechnik G'),(346866135040,'Telemerk','Telemerkki Oy'),(346866139136,'AbtrackS','ABtrack s.r.l.'),(346866143232,'SternaSe','Sterna Security'),(346866147328,'SelexCom','SELEX Communications Limited'),(346866151424,'Hijikata','Hijikata Denki Corp.'),(346866155520,'Nik-Elek','NIK-ELEKTRONIKA Ltd'),(346866159616,'BuancoSy','BUANCO SYSTEM A/S'),(346866163712,'Embedded','Embedded Monitoring Systems Ltd.'),(346866167808,'Infiniti','Infinition Inc.'),(346866171904,'IbetorSL','Ibetor S.L.'),(346866176000,'Globalco','GLOBALCOM ENGINEERING SRL'),(346866180096,'Infinite','infinitec co., ltd.'),(346866184192,'Embedded','Embedded Solution Co., Ltd.'),(346866188288,'NihonKes','Nihon Kessho Koogaku Co., Ltd.'),(346866192384,'System2','system2 GmbH'),(346866196480,'Emac','EMAC, Inc.'),(346866200576,'Dataregi','DATAREGIS S.A.'),(346866204672,'Tv1','TV1 GmbH'),(346866208768,'TxTechno','TX Technology Corp'),(346866212864,'UvaxConc','Uvax Concepts'),(346866216960,'KlingFre','KLING & FREITAG GmbH'),(346866221056,'HispeedD','HiSpeed Data, Inc.'),(346866225152,'GhlBhd','GHL Systems Bhd'),(346866229248,'A&TElect','A&T Corporation, Electrics Group'),(346866233344,'NemecAut','Nemec Automation'),(346866237440,'Alpha','ALPHA Corporation'),(346866241536,'Pro-Digi','Pro-Digital Industria Eletronica'),(346866245632,'BcIllumi','BC Illumination, Inc.'),(346866249728,'ImtronMe','Imtron Messtechnik GmbH'),(346866253824,'CRobHamm','C. Rob. Hammerstein GmbH & Co. K'),(346866257920,'Emac','EMAC, Inc.'),(346866262016,'Scale-Tr','Scale-Tron, Inc.'),(346866266112,'Saia-Bur','Saia-Burgess Controls AG'),(346866270208,'Computec','Computech International'),(346866274304,'Collectr','Collectric AB'),(346866278400,'Telvent',''),(346866282496,'FrSauter','Fr.SauterAG'),(346866286592,'P4qElect','P4Q Electronics'),(346866290688,'DsiRf','DSI RF Systems, Inc.'),(346866294784,'Transbit','Transbit Sp. z o.o.'),(346866298880,'Owita','OWITA GmbH'),(346866302976,'Microcub','Microcubs Systems Pvt Ltd'),(346866307072,'VoltechI','Voltech Instruments'),(346866311168,'LynxTech','LYNX Technik AG'),(346866315264,'HmiTechn','HMI Technologies'),(346866319360,'KeithKoe','Keith & Koep GmbH'),(346866323456,'TattileS','TATTILE SRL'),(346866327552,'AudioAut','Audio Authority Corp'),(346866331648,'Blankom',''),(346866335744,'AbbTrans','ABB Transmission and Distributio'),(346866339840,'Vitec',''),(346866343936,'EcommEra','ECOMM ERA'),(346866348032,'Electrol','Electrolight Shivuk (1994) Ltd.'),(346866352128,'T+AElekt','T+A elektroakustik GmbH & Co KG'),(346866356224,'VisualTe','Visual Telecommunication Network'),(346866360320,'Optolink','OptoLink  Industria e Comercio L'),(346866364416,'SiconSRL','Sicon s.r.l.'),(346866368512,'Irphoton','iRphotonics'),(346866372608,'Cs-Instr','CS-Instruments'),(346866376704,'LsdScien','LSD Science&Technology Co.,Ltd.'),(346866380800,'SyesSrl','Syes srl'),(346866384896,'DumpsEle','Dumps Electronic'),(346866388992,'ChauvinA','CHAUVIN ARNOUX'),(346866393088,'Manz',''),(346866397184,'Axlon','Axlon AB'),(346866401280,'Software','Software Effect Enterprises, Inc'),(346866405376,'Honeywel','Honeywell'),(346866409472,'Contec','CONTEC GmbH'),(346866413568,'ErsElect','ERS electronic GmbH'),(346866417664,'RongShun','Rong Shun Xuan Corp.'),(346866421760,'T-Indust','T-Industry, s.r.o.'),(346866425856,'Saia-Bur','Saia-Burgess Controls AG'),(346866429952,'Intuitiv','Intuitive Surgical, Inc'),(346866434048,'GamberJo','Gamber Johnson LLC'),(346866438144,'MistralS','Mistral Solutions Pvt. Ltd'),(346866446336,'BitwiseC','BitWise Controls'),(346866450432,'Precisio','Precision Remotes'),(346866454528,'Mangodsp',''),(346866458624,'Metratec','metraTec GmbH'),(346866462720,'GeneralD','GENERAL DYNAMICS C4 SYSTEMS'),(346866466816,'Deuta-We','Deuta-Werke GmbH'),(346866470912,'MegatecE','megatec electronic GmbH'),(346866475008,'Manitowo','Manitowoc Ice'),(346866479104,'Capton',''),(346866483200,'Sine','Sine Systems, Inc.'),(346866487296,'TielineR','Tieline Research Pty Ltd'),(346866491392,'MPaul','M & PAUL, INC'),(346866495488,'AplexTec','Aplex Technology Inc.'),(346866499584,'RflElect','RFL Electronics'),(346866503680,'KeithKoe','Keith & Koep GmbH'),(346866507776,'SpangPow','Spang Power Electronics'),(346866511872,'EumigInd','eumig industrie-tv GmbH'),(346866515968,'ImagoTec','IMAGO Technologies GmbH'),(346866520064,'RfCode','RF Code, Inc'),(346866524160,'Software','SoftwareCannery'),(346866528256,'LaudaDrR','LAUDA DR. R. WOBSER GMBH & CO. K'),(346866532352,'ZaoNpc\"K','ZAO NPC \"Kompjuternie Technologi'),(346866536448,'DspDesig','DSP DESIGN LTD'),(346866540544,'Prosoft-','PROSOFT-SYSTEMS LTD'),(346866544640,'SorelMik','SOREL GmbH Mikroelektronik'),(346866548736,'ComsatVe','Comsat VertriebsgmbH'),(346866552832,'PeekTraf','Peek Traffic Corporation'),(346866556928,'MPElectr','M.P. Electronics'),(346866561024,'Esensors','Esensors, Inc.'),(346866565120,'NantesPr','Nantes Systems Private Limited'),(346866569216,'Margento','Margento R&D'),(346866573312,'Withsyst','WITHSYSTEM Co.,Ltd'),(346866577408,'One-Nemo','One-Nemoto Engineering Corporati'),(346866581504,'Security','Security Services Group (SSG)'),(346866585600,'AcruxTec','Acrux Technology Limited'),(346866589696,'TesseraT','TESSERA TECHNOLOGY INC.'),(346866593792,'ZedZiegl','ZED Ziegler Electronic Devices G'),(346866597888,'KeithKoe','Keith & Koep GmbH'),(346866601984,'Saia-Bur','Saia-Burgess Controls AG'),(346866606080,'FluidCom','Fluid Components International'),(346866610176,'AgtHoldi','AGT Holdings Limited'),(346866614272,'T2m2','T2M2 GmbH'),(346866618368,'Kinotong','KinotonGmbH'),(346866622464,'TeleData','Tele Data Control'),(346866626560,'Ct','CT Company'),(346866630656,'Instrume','Instrumentel Limited'),(346866634752,'Dilitron','dilitronics GmbH'),(346866638848,'MecselOy','Mecsel Oy'),(346866642944,'McsEngen','MCS Engenharia ltda'),(346866647040,'IdcSolut','IDC Solutions Pty Ltd'),(346866651136,'Brankamp','Brankamp GmbH'),(346866655232,'Electron','Electronic Applications, Inc.'),(346866659328,'RohdeSch','Rohde & Schwarz Topex SA'),(346866663424,'Systech',''),(346866667520,'FriendSp','Friend Spring Industrial Co., Lt'),(346866671616,'TransasM','Transas Marine International AB'),(346866675712,'TornadoM','Tornado Modular Systems'),(346866679808,'SelexInt','Selex Systems Integration Inc'),(346866683904,'Metrawar','Metraware'),(346866688000,'RbzRobot','rbz robot design s.l.'),(346866692096,'Edixia',''),(346866696192,'VisionCo','Vision  & Control GmbH'),(346866700288,'A&AGener','A&A GENERAL SRL'),(346866704384,'DrsIts','DRS ITS'),(346866708480,'Device','Device GmbH'),(346866712576,'Internet','INTERNET PROTOCOLO LOGICA SL'),(346866716672,'AbbTrans','ABB Transmission and Distributio'),(346866720768,'Sequtec','SEQUTEC INC'),(346866724864,'Breakawa','Breakaway Systems LLC'),(346866728960,'EgsTechn','EGS Technologies Ltd'),(346866733056,'Neets',''),(346866737152,'FrSauter','Fr. Sauter AG'),(346866741248,'Elan','Elan Systems'),(346866745344,'VisualPr','Visual Productions'),(346866749440,'DacomWes','Dacom West GmbH'),(346866753536,'Cerner','Cerner Corporation'),(346866757632,'RuwischK','Ruwisch & Kollegen GmbH'),(346866761728,'Vendnova','VendNovation LLC'),(346866765824,'LeeLaser','Lee Laser'),(346866774016,'Powersen','Powersense A/S'),(346866778112,'KoncarEl','Koncar Electrical Engineering In'),(346866782208,'Saia-Bur','Saia-Burgess Controls AG'),(346866786304,'OceanSon','Ocean Sonics'),(346866790400,'Insevis','INSEVIS GmbH'),(346866794496,'PotterEl','Potter Electric Signal'),(346866798592,'Etherlig','EtherLight'),(346866802688,'HinoEngi','HINO ENGINEERING, INC'),(346866806784,'Combilen','Combilent'),(346866810880,'Tommotek','Tommotek (WA) Pty Ltd.'),(346866814976,'JennySci','Jenny Science AG'),(346866819072,'MacValve','MAC Valves, Inc.'),(346866823168,'BettiniS','BETTINI SRL'),(346866827264,'I-Evo','I-Evo Ltd'),(346866831360,'Wotbox','Wotbox ltd'),(346866835456,'XitekDes','Xitek Design Limited'),(346866839552,'TantalEl','TANTAL ELECTRONICA, SL'),(346866843648,'AplexTec','Aplex Technology Inc.'),(346866847744,'TycoTraf','Tyco Traffic & Transportation'),(346866851840,'Cleversc','Cleverscope'),(346866855936,'IcuScand','ICU Scandinavia Schweiz GmbH'),(346866860032,'SecEngPt','Sec.Eng Systems Pty Ltd'),(346866864128,'Nocosium',''),(346866868224,'EbnerEle','Ebner Electronic GmbH'),(346866872320,'Protagon','Protagon Process Technologies Gm'),(346866876416,'KstTechn','KST Technology'),(346866880512,'Ateme',''),(346866884608,'SiconSRL','Sicon s.r.l.'),(346866888704,'Seartech',''),(346866892800,'YouhoEle','YOUHO ELECTRIC IND.,LTD.'),(346866896896,'Unixmedi','Unixmedia Srl'),(346866900992,'PmacJapa','PMAC JAPAN'),(346866905088,'Trentino','Trentino Systems'),(346866909184,'Radinetw','Radinetworks Co., Ltd'),(346866913280,'RfNeulin','RF Neulink'),(346866917376,'KagoElec','Kago Electronics BV'),(346866921472,'Automati','Automation Assist Japan Company'),(346866925568,'CalixtoP','Calixto Systems Pvt Ltd'),(346866929664,'IhiScube','IHI Scube Co.,Ltd'),(346866933760,'Jetstrea','Jetstream Ltd.'),(346866937856,'GallTank','Gall Tankdatensysteme GmbH'),(346866941952,'AbbTrans','ABB Transmission and Distributio'),(346866946048,'ZoeMedic','Zoe Medical'),(346866950144,'Rosslare','Rosslare Enterprises Limited'),(346866954240,'Embedded','Embedded Labs'),(346866958336,'Saia-Bur','Saia-Burgess Controls AG'),(346866962432,'Holdline','Holdline Tecnologia e Sistemas L'),(346866966528,'Lo-Q','Lo-Q plc'),(346866970624,'Elvees',''),(346866974720,'Divelbis','Divelbiss Corporation'),(346866978816,'NorwiaAs','Norwia AS'),(346866982912,'MichaelR','Michael Riedel Transformatorenba'),(346866987008,'Vitec',''),(346866991104,'DitestFa','DiTEST Fahrzeugdiagnose GmbH'),(346866995200,'AcdElekt','ACD Elektronik GmbH'),(346866999296,'CinetixS','Cinetix s.r.l.'),(346867003392,'ControlS','CONTROL SYSTEMS Srl'),(346867007488,'Teplovod','Teplovodokhran'),(346867011584,'FrSauter','Fr. Sauter AG'),(346867015680,'Rohde&Sc','Rohde&Schwarz Topex SA'),(346867019776,'PlantInt','Plant Integrity Limited'),(346867023872,'EnElectr','EN ElectronicNetwork Hamburg Gmb'),(346867027968,'Funkwerk','Funkwerk IT Karlsfeld GmbH'),(346867032064,'Ds!Ingen','DS! Ingenieurbuero'),(346867036160,'Beam','Beam Ltd'),(346867040256,'Goennhei','Goennheimer Elektronic GmbH'),(346867044352,'Ensis','ENSIS Co., Ltd.'),(346867048448,'Oshoksh','Oshoksh Corporation'),(346867052544,'MoritaTe','Morita Technical Center Company'),(346867056640,'HglDynam','HGL Dynamics'),(346867060736,'Omnica','Omnica Corporation'),(346867064832,'Saia-Bur','Saia-Burgess Controls AG'),(346867068928,'FujiData','FUJI DATA SYSTEM Co., Ltd'),(346867073024,'AesirCop','Aesir Copenhagen'),(346867077120,'Telemetr','Telemetrics Inc.'),(346867085312,'Nanosolu','Nanosolution Inc.'),(346867089408,'GrupoEpe','Grupo Epelsa S.L.'),(346867093504,'Baudisch','Baudisch Electronic GmbH'),(346867097600,'Monnit','Monnit Corp.'),(346867101696,'VisitoSR','VISITO S.R.L.'),(346867105792,'Ecrin','Ecrin Systems'),(346867109888,'HigecoSR','Higeco S.r.l.'),(346867113984,'WingsFor','Wings for Media SL'),(346867118080,'Technica','Technica Engineering GmbH'),(346867122176,'Deuta-We','DEUTA-WERKE GmbH'),(346867126272,'Stichtin','Stichting Sunrise'),(346867130368,'Industre','Industrea Mining Technology'),(346867134464,'EnikaCz','ENIKA.CZ'),(346867138560,'ItwReyfl','ITW Reyflex North America'),(346867142656,'CtfTechn','CTF TECHNOLOGIES DO BRASIL LTDA'),(346867146752,'GhlBhd','GHL Systems Bhd'),(346867150848,'Rohde&Sc','Rohde&Schwarz Topex SA'),(346867154944,'AppliedM','Applied Micro Electronics \"AME\" '),(346867159040,'Pcsc',''),(346867163136,'Institut','Institute For Information Indust'),(346867167232,'WineTech','Wine Technology Marlborough'),(346867171328,'TattileS','Tattile srl'),(346867175424,'MotecPty','Motec Pty Ltd'),(346867179520,'FamasSys','Famas System S.p.A.'),(346867183616,'NextVide','NEXT video systems Hard- and Sof'),(346867187712,'ArcosTec','Arcos Technologies LTD'),(346867191808,'Tti','TTi Ltd'),(346867195904,'Rfengine','RFENGINE CO., LTD.'),(346867200000,'EolaneMo','EOLANE MONTCEAU'),(346867204096,'Agri-Hit','Agri-hitech LLC'),(346867208192,'Saia-Bur','Saia-Burgess Controls AG'),(346867212288,'Futec','FUTEC INC.'),(346867216384,'CaipoAut','CAIPO Automazione Industriale s.'),(346867220480,'Mcopia','MCOPIA Co., Ltd'),(346867224576,'T8','T8 Ltd'),(346867228672,'Orep',''),(346867232768,'PantecEn','Pantec Engineering AG'),(346867236864,'TaiyoSei','TAIYO SEIKI CO.,LTD.'),(346867240960,'DetechEl','Detech Electronics ApS'),(346867245056,'SaeIt-Sy','SAE IT-systems GmbH & Co. KG'),(346867249152,'PrimaSis','Prima sistemi'),(346867253248,'Edgeware','Edgeware AB'),(346867257344,'IbElektr','IB Elektronik GmbH'),(346867261440,'Emac','EMAC, Inc.'),(346867265536,'Critical','Critical Link, LLC'),(346867269632,'Kyoritsu','Kyoritsu Electric Corporation'),(346867273728,'Netmaker',''),(346867277824,'AplexTec','Aplex Technology Inc.'),(346867281920,'SikaTech','Sika Technology AG'),(346867286016,'SamsungE','SAMSUNG Electronics Co.,Ltd.(LED'),(346867290112,'Allerta','Allerta Inc'),(346867294208,'Power-On','Power-One Italia S.p.A'),(346867298304,'LeydenEn','Leyden Engineering'),(346867302400,'DorletSA','DORLET S.A.'),(346867306496,'TrafficN','traffic network solutions s.l'),(346867314688,'AcsMotio','ACS Motion Control Ltd.'),(346867318784,'Will','Will corp.'),(346867322880,'Fsm','FSM AG'),(346867326976,'Embedded','Embedded Solution Bank Co., Ltd.'),(346867331072,'FrSauter','Fr. Sauter AG'),(346867335168,'TaskSist','TASK SISTEMAS DE COMPUTACAO LTDA'),(346867339264,'McsMicro','MCS MICRONIC Computer Systeme Gm'),(346867343360,'Lightel',''),(346867347456,'AtomGike','ATOM GIKEN Co.,Ltd.'),(346867351552,'SpContro','sp controls, inc'),(346867355648,'AelMicro','AEL Microsystems Limited'),(346867359744,'Swarefle','Swareflex GmbH'),(346867363840,'LsContro','LS Control A/S'),(346867367936,'Saia-Bur','Saia-Burgess Controls AG'),(346867372032,'Adaptive','Adaptive Technologies, Inc.'),(346867376128,'XploreTe','Xplore Technologies Corp'),(346867380224,'Witree','Witree Co.,Ltd'),(346867384320,'AbbTrans','ABB Transmission and Distributio'),(346867388416,'CosmoLif','Cosmo Life Co.,Ltd'),(346867392512,'Multisun','Multisuns Corporation'),(346867396608,'LamsonSa','Lamson Safes & Security'),(346867400704,'PivitecL','Pivitec, LLC'),(346867404800,'Proteqse','PROTEQSEN'),(346867408896,'Macronet','Macronet s.r.l.'),(346867412992,'RpaElect','RPA Electronic Solutions, Inc.'),(346867417088,'EpecOy','Epec Oy'),(346867421184,'Systemad','SystemAdvanced Co,Ltd'),(346867425280,'GeneralD','GENERAL DYNAMICS C4 SYSTEMS'),(346867429376,'SttCondi','STT Condigi A/S'),(346867433472,'GsElektr','GS Elektromedizinische Geraete G'),(346867437568,'DspDesig','DSP DESIGN LTD'),(346867441664,'Ct','CT Company'),(346867445760,'Percepti','Perceptive Pixel Inc.'),(346867449856,'Ana-U','ANA-U GmbH'),(346867453952,'DliteCom','Dlite Comercio, Importadora e Se'),(346867458048,'Proyecso','PROYECSON S.A.'),(346867462144,'Arista','Arista Systems Corporation'),(346867466240,'I3Intern','i3 International Inc.'),(346867470336,'UvNetwor','UV Networks, Inc.'),(346867474432,'Solace','Solace Systems'),(346867478528,'Hentsche','Hentschel System GmbH'),(346867482624,'Sparq','SPARQ systems'),(346867486720,'Nicai-Sy','nicai-systems'),(346867490816,'American','American Microsystems, Ltd.'),(346867494912,'Datasoft','DataSoft Corporation'),(346867499008,'RobertBo','Robert Bosch Healthcare, Inc.'),(346867503104,'TexCompu','TEX COMPUTER SRL'),(346867507200,'Thinkrf','ThinkRF Corp'),(346867511296,'Subsea','Subsea Systems, Inc.'),(346867515392,'Head',''),(346867519488,'Aerodata','Aerodata AG'),(346867523584,'Powersen','Powersense A/S'),(346867527680,'Saia-Bur','Saia-Burgess Controls AG'),(346867531776,'MbConnec','MB Connect Line GmbH'),(346867535872,'Mettler-','METTLER-TOLEDO HI-SPEED'),(346867539968,'Bae','BAE Systems'),(346867544064,'Warp9Tec','Warp9 Tech Design, Inc.'),(346867548160,'AliasIp','Alias ip'),(346867552256,'Rohde&Sc','Rohde&Schwarz Topex SA'),(346867556352,'AlyricaN','Alyrica Networks'),(346867560448,'Aircell',''),(346867564544,'PulseCom','Pulse Communication Systems Pvt.'),(346867568640,'PduExper','PDU EXPERT UK LTD'),(346867572736,'OtakiEle','Otaki Electric Corporation'),(346867576832,'ArRf/Mic','AR RF/Microwave Instrumentation'),(346867580928,'WishtekT','Wishtek Technology, Inc.'),(346867585024,'Covidenc','Covidence A/S'),(346867589120,'MonsoonS','Monsoon Solutions, Inc.'),(346867593216,'Saab','Saab AB'),(346867597312,'Dspnor',''),(346867601408,'Alpha-Mo','ALPHA-MOS'),(346867605504,'West-Com','West-Com Nurse Call Systems, Inc'),(346867609600,'Timeterm','TimeTerminal Adductor Group AB'),(346867613696,'DiehlAko','Diehl AKO Stiftung & Co. KG'),(346867617792,'DropletM','Droplet Measurement Technologies'),(346867621888,'GlobalTe','Global Tecnologia LTDA.'),(346867625984,'Civoluti','CIVOLUTION'),(346867630080,'UgmoTech','UgMO Technologies'),(346867634176,'AntGroup','ANT Group s.r.l'),(346867638272,'Ixonos','Ixonos Plc'),(346867642368,'AplexTec','Aplex Technology Inc.'),(346867646464,'LogicalE','Logical Electromechanical Sys In'),(346867650560,'Rsupport','RSUPPORT Co., Ltd.'),(346867654656,'Infronic','INFRONICS SYSTEMS LIMITED'),(346867658752,'LiquidRo','LIQUID ROBOTICS, INC'),(346867662848,'IbernexI','IBERNEX INGENIERIA, S.L.'),(346867666944,'Amsterda','Amsterdam Scientific Instruments'),(346867671040,'BitwiseC','BitWise Controls'),(346867675136,'Fal','FAL Corp'),(346867679232,'Saia-Bur','Saia-Burgess Controls AG'),(346867683328,'PeekTraf','Peek Traffic Corporation'),(346867687424,'EasiiIcA','easii ic adiis'),(346867691520,'TaiwanHi','TAIWAN HIPLUS CORPORATION'),(346867695616,'NipponSy','Nippon Systemware Co.,Ltd.'),(346867699712,'Arcontia','Arcontia Technology AB'),(346867703808,'Klangspe','Klangspektrum GmbH'),(346867707904,'EcoMonit','ECO MONITORING UTILITY SYSTEMS L'),(346867712000,'Tamagawa','TAMAGAWA ELECTRONICS CO.,LTD.'),(346867716096,'RflElect','RFL Electronics Inc.'),(346867720192,'Cat','Cat AB'),(346867724288,'FbtElett','FBT Elettronica spa'),(346867728384,'Avocatio','AVocation Systems, Inc.'),(346867732480,'Plasmatr','Plasmatronics pty ltd'),(346867736576,'JointSto','Joint Stock Company \"Svyaz Ingin'),(346867740672,'BelikSPR','BELIK S.P.R.L.'),(346867744768,'Eyelock','Eyelock Corporation'),(346867748864,'Ebneuro','EBNEURO SPA'),(346867752960,'SmartGri','Smart Grid Networks'),(346867757056,'MonitorB','Monitor Business Machines'),(346867761152,'OsfHansj','osf Hansjuergen Meier GmbH & Co.'),(346867765248,'ProconEl','Procon Electronics'),(346867769344,'SystemIn','System Industrie Electronic GmbH'),(346867773440,'TecnintH','Tecnint HTE Srl'),(346867777536,'Rohde&Sc','Rohde&Schwarz Topex SA'),(346867781632,'CytecZyl','Cytec Zylindertechnik GmbH'),(346867785728,'B:TechAS','B:TECH, a. s.'),(346867789824,'SyesSrl','Syes srl'),(346867793920,'KamachoS','Kamacho Scale Co., Ltd.'),(346867798016,'QuantaSR','QUANTA S.r.l.'),(346867802112,'Position','Positioneering Limited'),(346867806208,'Fibriste','fibrisTerre GmbH'),(346867810304,'YuyamaMf','Yuyama Mfg. Co., Ltd.'),(346867814400,'FutureDe','Future Design Controls, Inc'),(346867818496,'AbbTrans','ABB Transmission and Distributio'),(346867822592,'Idtronic','IDTRONIC GmbH'),(346867826688,'Homaetri','Homaetrix Ltd'),(346867830784,'Saia-Bur','Saia-Burgess Controls AG'),(346867834880,'Specialt','Specialty Microwave Corp'),(346867838976,'SmartPow','Smart Power Electronics GmbH & C'),(346867843072,'RoVeRLab','RO.VE.R. Laboratories S.p.A'),(346867847168,'HumanNet','Human Network Labs, Inc.'),(346867851264,'NetlineC','Netline Communication Technologi'),(346867855360,'Amstella','Amstelland Electronic BV'),(346867859456,'HclTechn','HCL Technologies'),(346867863552,'HoribaAb','HORIBA ABX'),(346867867648,'Predicti','Predictive Sensor Technology'),(346867871744,'NorbitOd','Norbit ODM AS'),(346867879936,'Sanmina',''),(346867884032,'PlrInfor','PLR Information Systems Ltd.'),(346867888128,'Zephyrus','Zephyrus Electronics LTD.'),(346867892224,'SyscomIn','Syscom Instruments'),(346867896320,'MangoDsp','Mango DSP, Inc'),(346867900416,'Bmr',''),(346867904512,'WrenSoun','Wren Sound Systems'),(346867908608,'KinkiRoe','KINKI ROENTGEN INDUSTRIAL CO.,LT'),(346867912704,'EsiVentu','ESI Ventures'),(346867916800,'Micro-Ke','Micro-Key BV'),(346867920896,'IconRese','Icon Research Ltd'),(346867924992,'AplexTec','Aplex Technology Inc.'),(346867929088,'Wheatsto','Wheatstone Corporation'),(346867933184,'HascomIn','HASCOM International Pty Ltd'),(346867937280,'Treehave','Treehaven Technologies, Inc.'),(346867941376,'Skychann','SKYCHANNEL LTD'),(346867945472,'Bluetest','Bluetest AB'),(346867949568,'MicroTec','Micro Technic A/S'),(346867953664,'Aerovisi','AeroVision Avionics, Inc.'),(346867957760,'WincorNi','Wincor Nixdorf Sp. z o.o.'),(346867961856,'Organis','Organis GmbH'),(346867965952,'GeneralI','General Industrial Controls Pvt '),(346867970048,'PacketPl','Packet Plus, Inc.'),(346867974144,'VisionAe','VISION SYSTEMS AERONAUTIC'),(346867978240,'SascalDi','Sascal Displays Ltd'),(346867982336,'PeterHub','Peter Huber KÃ¤ltemaschinenbau G'),(346867986432,'AbbTrans','ABB Transmission and Distributio'),(346867990528,'VitecMul','Vitec Multimedia'),(346867994624,'NetlinkB','Netlink Bilisim Sistemleri San. '),(346867998720,'AquaMana','Aqua Management'),(346868002816,'Saia-Bur','Saia-Burgess Controls AG'),(346868006912,'GeneralD','GENERAL DYNAMICS C4 SYSTEMS'),(346868011008,'Grossenb','Grossenbacher Systeme AG'),(346868015104,'DellOrto','Dell`Orto S.P.A.'),(346868019200,'Verified','Verified Energy, LLC.'),(346868023296,'UnforsIn','Unfors Instruments AB'),(346868027392,'Seitec','SEITEC Co. Ltd'),(346868031488,'HarlandS','Harland Simon plc'),(346868035584,'Electro-','Electro-Motive Diesel'),(346868039680,'Ct','CT Company'),(346868043776,'SamwayEl','Samway Electronic SRL'),(346868047872,'Waveip',''),(346868051968,'Elan','ELAN SYSTEMS'),(346868056064,'VertexAn','Vertex Antennentechnik GmbH'),(346868060160,'Radyne','RADYNE CORPORATION'),(346868064256,'AcdElekt','ACD Elektronik GmbH'),(346868068352,'BioGuard','Bio Guard component & technologi'),(346868072448,'Terratel','Terratel Technology s.r.o.'),(346868076544,'RobertBo','Robert Bosch Healthcare Systems,'),(346868080640,'H&LInstr','H&L Instruments, LLC'),(346868084736,'ArcosTec','Arcos Technologies LTD'),(346868088832,'Miris','Miris AB'),(346868092928,'RuetzTec','Ruetz Technologies GmbH'),(346868097024,'Net4thin','Net4Things'),(346868101120,'AppliedM','Applied Micro Electronics \"AME\" '),(346868105216,'SequipS+','Sequip S+E GmbH'),(346868109312,'GrupoEpe','Grupo Epelsa S.L.'),(346868113408,'Visitech','Visitech AS'),(346868117504,'Rosslare','Rosslare Enterprises Limited'),(346868121600,'Aerocont','AeroControl, Inc.'),(346868125696,'InforceC','Inforce Computing, Inc.'),(346868129792,'Saia-Bur','Saia-Burgess Controls AG'),(346868133888,'TamsFirm','TAMS firmware co.'),(346868137984,'VemcoSpZ','Vemco Sp. z o. o.'),(346868142080,'ProjectS','Project service S.a.s'),(346868146176,'VtronPty','Vtron Pty Ltd'),(346868150272,'DenseiCo','DENSEI COMMUNICATION Inc.'),(346868154368,'Ibworld','iBWorld co.,ltd.'),(346868158464,'Fairydev','FairyDevices Inc.'),(346868162560,'Dspcon',''),(346868166656,'SpecialE','Special Systems Engineering Cent'),(346868170752,'Steinbic','Steinbichler Optotechnik GmbH'),(346868174848,'HustyMSt','HUSTY M.Styczen J.Hupert Sp.J.'),(346868178944,'ReasonTe','Reason Tecnologia S.A.'),(346868183040,'Cadac','cadac,inc.'),(346868187136,'MidasTec','Midas Technology DBA Phoenix Aud'),(346868191232,'GreenIns','Green Instruments A/S'),(346868195328,'Z-App','Z-App Systems, Inc.'),(346868199424,'Supranet',''),(346868203520,'Enistic','Enistic Limited'),(346868207616,'KnowhowI','KNOWHOW INFOCOM INC.'),(346868211712,'Heinzing','Heinzinger electronic GmbH'),(346868215808,'BapPreci','BAP Precision Ltd.'),(346868219904,'Moritex','Moritex Corporation'),(346868224000,'NdcInfra','NDC Infrared Engineering, Inc.'),(346868228096,'Rohde&Sc','Rohde&Schwarz Topex SA'),(346868232192,'BaycomOp','BAYCOM OPTO-ELECTRONICS TECHNOLO'),(346868236288,'HellaGut','Hella Gutmann Solutions GmbH'),(346868240384,'Honeywel','Honeywell International Inc.'),(346868244480,'MonsoonS','Monsoon Solutions, Inc.'),(346868248576,'ReachTec','Reach Technologies Inc.'),(346868252672,'Ieee-Sa',''),(346868256768,'G3Techno','G3 Technologies'),(346868260864,'Sentry36','Sentry 360 Security'),(346868264960,'Saia-Bur','Saia-Burgess Controls AG'),(346868269056,'DspDesig','DSP DESIGN LTD'),(346868273152,'SmartbTe','SMARTB TECHNOLOGIES'),(346868277248,'Y-CamSol','Y-cam Solutions Ltd'),(346868281344,'BoryeuTe','BORYEU TECHNOLOGY CO.,LTD'),(346868285440,'Deckma','Deckma GmbH'),(346868289536,'BrauchEl','Brauch Elektronik GmbH&Co.KG'),(346868293632,'Emac','EMAC, Inc.'),(346868297728,'Triax','Triax A/S'),(346868301824,'ChrissoT','Chrisso Technologies LLC'),(346868305920,'Telebyte','Telebyte Inc.'),(346868310016,'GwtLlc','GWT LLC'),(346868314112,'Celestia','Celestial Audio'),(346868318208,'Newtec','NEWTEC A/S'),(346868322304,'SafePlac','Safe Place Solutions Ltd'),(346868326400,'OfiDba2d','OFI Inc. (dba 2D2C)'),(346868330496,'AlgodueE','Algodue Elettronica Srl'),(346868334592,'ProDesig','Pro Design Electronic GmbH'),(346868338688,'ProDesig','Pro Design Electronic GmbH'),(346868342784,'SmithMet','Smith Meter, Inc.'),(346868346880,'AplexTec','Aplex Technology Inc.'),(346868350976,'NoraltaT','Noralta Technologies Inc'),(346868355072,'RfCode','RF CODE, INC'),(346868359168,'Maxdetec','MaxDeTec AG'),(346868363264,'Deltacas','DELTACAST.TV'),(346868367360,'ThorTech','Thor Technologies Pty Ltd'),(346868371456,'Pumpwell','PumpWell Solutions Ltd.'),(346868375552,'RongJieF','Rong Jie(FuZhou)Electronics Co.,'),(346868379648,'Systemte','SYSTEMTECHNIK GmbH'),(346868383744,'GetsMssS','Gets MSS S.A.'),(346868387840,'TattileS','Tattile SRL'),(346868391936,'C3Llc','C3 LLC'),(346868396032,'McmElect','MCM Electronics'),(346868400128,'Atonomet','Atonometrics, Inc.'),(346868404224,'D-HikeEl','D-Hike Electroncs Technology Co.'),(346868408320,'TruteqWi','TruTeq Wireless (Pty) Ltd'),(346868412416,'DynamicD','Dynamic Design'),(346868416512,'SysTecEl','SYS TEC electronic GmbH'),(346868420608,'Plda',''),(346868424704,'SincairI','Sincair Systems International'),(346868428800,'GspSprac','GSP Sprachtechnologie GmbH'),(346868432896,'DynonIns','Dynon Instruments'),(346868436992,'Enetics','Enetics, Inc.'),(346868441088,'AudioPow','Audio Power Labs'),(346868445184,'VaisalaO','Vaisala Oyj'),(346868449280,'RtcManuf','RTC Manufacturing Inc.'),(346868453376,'CsaEngin','CSA Engineering AG'),(346868457472,'Emac','EMAC, Inc.'),(346868461568,'ComletVe','comlet Verteilte Systeme GmbH'),(346868465664,'Ubstechn','UBSTechnology Co., Ltd'),(346868469760,'Guangdon','GUANGDONG EAST POWER CO.,LTD.'),(346868473856,'Gpo',''),(346868477952,'Computer','Computerwise, Inc.'),(346868482048,'Securete','SecureTech Systems, Inc.'),(346868486144,'Re2','RE2 Inc'),(346868490240,'ConetSol','CONET Solutions GmbH'),(346868494336,'Baudisch','Baudisch Electronic GmbH'),(346868498432,'DigitalB','Digital Barriers'),(346868502528,'TtiThurl','TTi LTD (Thurlby Thandar Instrum'),(346868506624,'Jlcooper','JLCooper Electronics'),(346868510720,'SiconSRL','Sicon s.r.l.'),(346868514816,'Infotech','Infotech North America'),(346868518912,'DrNeuman','Dr. Neumann elektronik GmbH'),(346868523008,'Telvent',''),(346868527104,'NewellTe','NEWELL TECHNOLOGIES LIMITED'),(346868531200,'R&DKomet','R&D KOMETEH'),(346868535296,'Jsc\"Kalu','JSC \"Kaluga Teletypes Manufactur'),(346868539392,'Matsusad','Matsusada Precision Inc.'),(346868543488,'NanjingS','Nanjing SAC Power Grid Automatio'),(346868547584,'AmplusCo','Amplus Communication Pte Ltd'),(346868551680,'N-HandsU','N-Hands GmbH und Co KG'),(346868555776,'Power-On','Power-One'),(346868559872,'XemexNv','Xemex NV'),(346868568064,'Intuitiv','Intuitive Surgical, Inc.'),(346868572160,'HilkomDi','Hilkom digital GmbH'),(346868576256,'Exelis','Exelis Inc.'),(346868580352,'YashSiqu','Yash SiQure Technologies India P'),(346868584448,'HijetPri','Hijet Print d.o.o.'),(346868588544,'Yjsystem',''),(346868592640,'AplexTec','Aplex Technology Inc.'),(346868596736,'AdetelGr','ADETEL GROUP'),(346868600832,'Finishin','Finishing Brands'),(346868604928,'AtiAutom','ATI Automacao Telecomunicacoes e'),(346868609024,'Vremya-C','Vremya-CH JSC'),(346868613120,'Tateishi','Tateishi Kobisha Co.LTD'),(346868617216,'Matelex',''),(346868621312,'PrestonI','Preston Industries dba PolyScien'),(346868625408,'Ct','CT Company'),(346868629504,'Mc-Monit','MC-monitoring SA'),(346868633600,'Assembly','Assembly Contracts Limited'),(346868637696,'Argus-Sp','ARGUS-SPECTRUM'),(346868641792,'PounceCo','Pounce Consulting'),(346868645888,'Techno','TECHNO CO.,LTD.'),(346868649984,'CoralTel','Coral Telecom Ltd'),(346868654080,'ElbitOfA','Elbit Systems of America'),(346868658176,'Acida','ACIDA GmbH'),(346868662272,'LeroySom','Leroy Somer'),(346868666368,'FhfFunke','FHF Funke+Huster Fernsig GmbH'),(346868670464,'SentecEl','senTec Elektronik GmbH'),(346868674560,'Mylogic',''),(346868678656,'Rohde&Sc','Rohde&Schwarz Topex SA'),(346868682752,'MotecPty','Motec Pty Ltd'),(346868686848,'Elta',''),(346868690944,'HsdcSpZO','HSDC Sp. z o.o.'),(346868695040,'Kyowaden','Kyowadensi'),(346868699136,'SakuraSe','Sakura Seiki Co.,Ltd.'),(346868703232,'Critical','Critical Link'),(346868707328,'SercomRe','SERCOM Regeltechniek'),(346868711424,'FarSouth','Far South Networks'),(346868715520,'MehtaTec','Mehta Tech, Inc.'),(346868719616,'Telemisi','Telemisis Ltd'),(346868723712,'Propagat','Propagation Systems Limited'),(346868727808,'Soudroni','Soudronic AG'),(346868731904,'Jinyoung','Jinyoung Contech'),(346868736000,'KoyoElec','KOYO ELECTRIC'),(346868740096,'DintekSh','DINTEK Shanghai Electronic Ltd'),(346868744192,'SimpleSo','Simple Solutions'),(346868748288,'EnyxSa','Enyx SA'),(346868752384,'Autonomi','Autonomic Controls. Inc'),(346868756480,'AsterEle','Aster Electric Co.,Ltd.'),(346868760576,'Insitu','Insitu, Inc.'),(346868764672,'American','American Microsystems, Ltd.'),(346868768768,'CityComp','City Computing Ltd'),(346868772864,'Deuta-We','Deuta-Werke GmbH'),(346868776960,'Ease','Ease Inc.'),(346868781056,'FigmentD','Figment Design Laboratories'),(346868785152,'Elan','ELAN SYSTEMS'),(346868789248,'Security','The Security Center Inc'),(346868793344,'QuercusT','QUERCUS TECHNOLOGIES, S.L.'),(346868797440,'Toptech','Toptech Systems, Inc.'),(346868801536,'PeekTraf','Peek Traffic'),(346868805632,'AcdElekt','ACD Elektronik GmbH'),(346868809728,'Azurtest',''),(346868813824,'Dotocean',''),(346868817920,'Pulsotro','Pulsotronic Anlagentechnik GmbH'),(346868826112,'RttMobil','RTT Mobile Interpretation'),(346868830208,'Scandino','Scandinova Systems AB'),(346868834304,'Exibea','Exibea AB'),(346868838400,'Erhardt+','Erhardt+Leimer GmbH'),(346868842496,'MangoDsp','Mango DSP, Inc.'),(346868846592,'MbConnec','MB Connect Line GmbH'),(346868850688,'BrunelSe','Brunel GmbH Section Communicatio'),(346868854784,'AxibleTe','Axible Technologies'),(346868858880,'FirstSys','First System Technology Co., Ltd'),(346868862976,'LogisolK','LOGISOL Kft.'),(346868867072,'SparksIn','Sparks Instruments SA'),(346868871168,'TaskSist','Task Sistemas de Computacao'),(346868875264,'GeneralD','GENERAL DYNAMICS C4 SYSTEMS'),(346868879360,'DitestFa','DiTEST FAHRZEUGDIAGNOSE GMBH'),(346868883456,'Globalco','GLOBALCOM ENGINEERING SRL'),(346868887552,'ControlS','CONTROL SYSTEMS Srl'),(346868891648,'BurkTech','Burk Technology'),(346868895744,'FlexkomI','Flexkom Internet Pazarlama Bilip'),(346868899840,'BooycoEl','Booyco Electronics'),(346868903936,'HumanInt','Human Intech'),(346868908032,'KstTechn','KST technology'),(346868912128,'Penttech','Penttech AB'),(346868916224,'Nupoint','Nupoint Systems Inc.'),(346868920320,'Sefram',''),(346868924416,'SpirentC','Spirent Communications'),(346868928512,'Touchles','Touchless Biometric Systems AG'),(346868932608,'SensataT','Sensata Technologies'),(346868936704,'Msr-Solu','MSR-Solutions GmbH'),(71297883181056,'Vemotion',''),(71297883185152,'Hangzhou','Hangzhou Chenxiao Technologies C'),(71297883189248,'Alphanav','AlphaNavigation coltd'),(71297883193344,'CrMagnet','CR Magnetics, Inc.'),(71297883197440,'MonarchI','Monarch Instrument'),(71297883201536,'Bactest','Bactest Limited'),(71297883205632,'DigitalA','Digital Audio SA'),(71297883209728,'KaoriInd','Kaori Industria Eletronica Ltda'),(71297883213824,'Clearsit','ClearSite Communications Inc.'),(71297883217920,'SaranaSi','Sarana Sistem Mikro'),(71297883222016,'Aircell',''),(71297883226112,'AplexTec','Aplex Technology Inc.'),(71297883230208,'Huns',''),(71297883234304,'Brightwe','Brightwell Dispensers'),(71297883238400,'DigitalD','DIGITAL DYNAMICS, INC.'),(71297883242496,'ApgCashD','APG CASH DRAWER'),(71297883246592,'FleximSe','Flexim Security Oy'),(71297883250688,'Sencon','Sencon Inc.'),(71297883254784,'GrandeVi','Grande Vitesse Systems'),(71297883258880,'ToniStud','Toni Studio'),(71297883262976,'BitmillS','BITMILL srl'),(71297883267072,'Par-Tech','Par-Tech, Inc.'),(71297883271168,'FrankeAq','Franke Aquarotter GmbH'),(71297883275264,'StaneoSa','STANEO SAS'),(71297883279360,'Nautel','Nautel Limited'),(71297883283456,'MeggittD','MEGGITT DEFENSE SYSTEMS INC.'),(71297883287552,'AudioEnh','Audio Enhancement'),(71297883291648,'Berg',''),(71297883295744,'ScharcoE','Scharco Elektronik GmbH'),(71297883299840,'A2s',''),(71297883303936,'SitepIta','Sitep Italia Spa'),(71297883308032,'EntecEle','ENTEC Electric & Electronic CO.,'),(71297883312128,'SmtDOO','SMT D.O.O.'),(71297883316224,'Digimerg','Digimerge Technology Inc'),(71297883320320,'Shanghai','Shanghai o-solution electronics '),(71297883324416,'Electric','Electrical Geodesics Incorporate'),(71297883328512,'Rosemoun','Rosemount Analytical'),(71297883332608,'Symetric','Symetrics Industries'),(71297883336704,'GrupoEpe','GRUPO EPELSA S.L.'),(71297883340800,'Integrat','Integrated Control Corp.'),(71297883344896,'DeproEle','Depro Electronique'),(71297883348992,'Tinkerfo','Tinkerforge GmbH'),(71297883353088,'Nomatron','Nomatronics'),(71297883357184,'Inventla','InventLab s.c.'),(71297883361280,'ElgamaSi','Elgama Sistemos'),(71297883365376,'Circuite','Circuitec Ind. Equip. Eletr. Ltd'),(71297883369472,'AdvaTech','Adva Technologies'),(71297883373568,'Tecnolog','Tecnologias Plexus'),(71297883377664,'Dommel','Dommel GmbH'),(71297883381760,'BettiniS','BETTINI SRL'),(71297883385856,'ErmesEle','Ermes Elettronica s.r.l.'),(71297883389952,'DacomWes','Dacom West GmbH'),(71297883394048,'Mesotech','Mesotech International, Inc.'),(71297883398144,'Schweers','Schweers informationstechnologie'),(71297883402240,'Software','Software Workshop'),(71297883406336,'SpecialM','Special Measurements Labs LLC'),(71297883410432,'Ci','CI Systems Ltd'),(71297883414528,'SocusNet','Socus networks'),(71297883418624,'Telcomko','Telcomkorea'),(71297883422720,'Computer','Computer System Co.,Ltd'),(71297883426816,'TekelekE','Tekelek Europe Ltd'),(71297883430912,'VishayCe','Vishay Celtron Technologies, Inc'),(71297883435008,'UnisvrGl','UniSVR Global Information Techno'),(71297883439104,'GhlBerha','GHL Systems Berhad'),(71297883443200,'TQMItaca','T.Q.M. Itaca Technology s.r.l.'),(71297883447296,'MangoCom','Mango Communicaitons Inc.'),(71297883451392,'Schulerc','SchulerControl GmbH'),(71297883455488,'AnChenCo','An Chen Computer Co. Ltd.'),(71297883459584,'Genadsys','Genadsystem'),(71297883463680,'Circuitl','Circuitlink Pty Ltd'),(71297883467776,'Dos&Dont','Dos&Donts SRL'),(71297883471872,'GeneralD','GENERAL DYNAMICS C4 SYSTEMS'),(71297883475968,'ThermoFi','Thermo Fisher Scientific'),(71297883480064,'GatewayT','Gateway Technologies SA de CV'),(71297883484160,'VitalTec','Vital Tech Industria e Comercio '),(71297883488256,'Serveron','Serveron Corporation'),(71297883492352,'Machinep','MACHINEPERFORMANCE ApS'),(71297883496448,'Honeywel','Honeywell Aerospace/Intelligent '),(71297883500544,'HaeinS&S','Haein S&S Co., Ltd'),(71297883504640,'AtgUvTec','ATG UV Technology'),(71297883508736,'CsInstru','CS Instruments Asia'),(71297883512832,'DanElect','DAN ELECTRONICS SYSTEM (P) LIMIT'),(71297883516928,'Amantys','Amantys Ltd'),(71297883521024,'Vitec',''),(71297883525120,'Helmholt','Helmholtz Zentrum Dresden Rossen'),(71297883529216,'Group57','GROUP 57'),(71297883533312,'Tammerma','Tammermatic Group Oy'),(71297883537408,'EnergyTe','Energy Team S.p.A.'),(71297883541504,'Colonial','COLONIAL ASSEMBLY and  DESIGN'),(71297883545600,'UltraEle','Ultra Electronics Flightline Sys'),(71297883549696,'DataFlow','Data Flow Systems, Inc.'),(71297883553792,'Rosslare','Rosslare Enterprises Limited'),(71297883557888,'LeicaBio','Leica Biosystems'),(71297883561984,'Inoage','inoage GmbH'),(71297883566080,'Epsa','EPSa GmbH'),(71297883570176,'AplexTec','Aplex Technology Inc.'),(71297883574272,'Cominfo','Cominfo, Inc.'),(71297883578368,'TechSour','Tech Source Inc'),(71297883582464,'Protonic','Protonic Holland'),(71297883586560,'Hipodrom','HIPODROMO DE AGUA CALIENTE, S.A.'),(71297883590656,'Parallel','Parallel Wireless'),(71297883594752,'Teratron','TeraTron GmbH'),(71297883598848,'TronicCo','Tronic Control ltd.'),(71297883602944,'OkiSeate','Oki Seatec Co., Ltd.'),(71297883607040,'Smartcom','Smartcom-Bulgaria AD'),(71297883611136,'Elgris',''),(71297883615232,'BrsSiste','BRS Sistemas Eletronicos'),(71297883619328,'Rohde&Sc','Rohde&Schwarz Topex SA'),(71297883623424,'Broadsof','BroadSoft, INC'),(71297883627520,'C-ComSat','C-COM Satellite Systems Inc.'),(71297883631616,'DorletSa','DORLET SA'),(71297883635712,'JscElect','JSC Electrical Equipment Factory'),(71297883639808,'TattileS','TATTILE SRL'),(71297883643904,'Ct','CT Company'),(71297883648000,'DiamondT','Diamond Technologies, Inc'),(71297883652096,'SphereMe','Sphere Medical Ltd'),(71297883656192,'Teraflop','Teraflops'),(71297883660288,'Internet','INTERNET PROTOCOLO LOGICA SL'),(71297883664384,'ToecTech','TOEC TECHNOLOGY CO.,LTD'),(71297883668480,'Nachi-Fu','NACHI-FUJIKOSHI CORP'),(71297883672576,'Delfisol','DelfiSolutions A/S'),(71297883676672,'4embedde','4embedded'),(71297883680768,'IpsTechn','IPS Technology Limited'),(71297883684864,'Agramkow','Agramkow Fluid Systems A/S'),(71297883688960,'WuxiSine','Wuxi SiNeng New Energy Co., Ltd.'),(71297883693056,'Tescom','TESCOM CORPORATION'),(71297883697152,'Wheatsto','Wheatstone Corporation'),(71297883701248,'Honeywel','Honeywell'),(71297883705344,'SiconSrl','Sicon srl'),(71297883709440,'ArdSa','ard sa'),(71297883713536,'Delopt',''),(71297883717632,'Papendor','Papendorf Software Engineering G'),(71297883721728,'PeekTraf','Peek Traffic Corporation'),(71297883725824,'DspDesig','DSP DESIGN'),(71297883729920,'BestelCh','Bestel China'),(71297883734016,'JelSyste','JEL SYSTEM CO., LTD.'),(71297883738112,'WuhanXin','WUHAN XINGTUXINKE ELECTRONIC CO.'),(71297883742208,'LederEle','Leder Elektronik Design'),(71297883746304,'Meshwork','MeshWorks Wireless Oy'),(71297883750400,'Magnesca','Magnescale Co.,Ltd'),(71297883754496,'BoehmeNa','Boehme Nachrichtentechnik'),(71297883758592,'Lyngsoe','Lyngsoe Systems'),(71297883762688,'Excelita','Excelitas'),(71297883766784,'AxxessId','Axxess Identification Ltd'),(71297883770880,'Kdt',''),(71297883774976,'Wasserba','Wasserbauer GmbH'),(71297883779072,'Sentry36','Sentry 360 Security'),(71297883783168,'NomadDig','Nomad Digital Limited'),(71297883787264,'HeartFor','Heart Force Medical'),(71297883791360,'ComtelEl','Comtel Electronics GmbH'),(71297883795456,'BurtonTe','Burton Technical Services LLC'),(71297883799552,'DaveSrl','Dave Srl'),(71297883803648,'Idcell','idcell co.ltd'),(71297883807744,'Coherent','CoherentPlus Sdn Bhd'),(71297883811840,'TokyoDen','Tokyo Denki Gijutsu Kogyo'),(71297883815936,'KeywareS','Keyware Solutions Inc.'),(71297883820032,'Emac','EMAC, Inc.'),(71297883824128,'Nanopuls','NanoPulse, Inc.'),(71297883828224,'Bascules','Bascules Robbe nv'),(71297883832320,'Quantron','Quantronix, Inc.'),(71297883836416,'AdvalySy','ADVALY SYSTEM Inc.'),(71297883840512,'XemexNv','Xemex NV'),(71297883844608,'Telefran','Telefrank GmbH'),(71297883848704,'ReschEle','Resch Electronic Innovation GmbH'),(71297883852800,'Wooshcom','WooshCom Corporation'),(71297883856896,'AlumbraP','Alumbra Produtos ElÃ©tricos e El'),(71297883860992,'FirstDes','First Design System Inc.'),(71297883865088,'Baudisch','Baudisch Electronic GmbH'),(71297883869184,'ApantacL','Apantac LLC'),(71297883873280,'ThermalI','Thermal Imaging Radar, LLC'),(71297883877376,'EnelDooB','Enel doo Belgrade'),(71297883881472,'Fraunhof','Fraunhofer HHI'),(71297883885568,'SpaceMic','Space Micro'),(71297883889664,'GeneralD','GENERAL DYNAMICS C4 SYSTEMS'),(71297883893760,'Enverv','EnVerv Inc.'),(71297883897856,'Microlog','Micrologic'),(71297883901952,'NanjingT','Nanjing TIANSU Automation Contro'),(71297883906048,'EverTren','Ever Trend Technology Developmen'),(71297883910144,'TWSSrl','T.W.S. srl'),(71297883914240,'Mitsubis','MITSUBISHI ELECTRIC SYSTEM & SER'),(71297883918336,'DataShar','DATA SHARING CONSULTING'),(71297883922432,'Telvent',''),(71297883926528,'AcdElekt','ACD Elektronik GmbH'),(71297883930624,'FerlinTr','Ferlin Trading BV'),(71297883934720,'WxbrSist','WxBR Sistemas de Telecomunicacoe'),(71297883938816,'PchEngin','PCH Engineering A/S'),(71297883942912,'Whiptail',''),(71297883947008,'AplexTec','Aplex Technology Inc.'),(71297883951104,'Icognize','iCOGNIZE GmbH'),(71297883955200,'Manufact','Manufacturing System Insights In'),(71297883959296,'Shenzhen','Shenzhen SETEC Power Co.,Ltd'),(71297883963392,'Act',''),(71297883967488,'XeptoCom','Xepto Computing Inc'),(71297883971584,'ScTechsw','SC Techswarm SRL'),(71297883975680,'ApgCashD','APG CASH DRAWER'),(71297883979776,'Inspired','Inspired Systems'),(71297883983872,'MMElektr','M.M. Elektrolab'),(71297883987968,'Comtime','comtime GmbH'),(71297883992064,'Insensiv','insensiv GmbH'),(71297883996160,'MettlerT','Mettler Toledo Hispeed'),(71297884000256,'Quantafl','QUANTAFLOW'),(71297884004352,'Neutrik','NEUTRIK AG'),(71297884008448,'Relion','ReliOn Inc'),(71297884012544,'Ateme',''),(71297884016640,'LogicalP','Logical Product'),(71297884020736,'EstAnaly','EST Analytical'),(71297884024832,'Clark-Mx','Clark-MXR, Inc.'),(71297884028928,'IcraftOy','Icraft Oy'),(71297884033024,'Cantada','Cantada Inc'),(71297884037120,'Elan','ELAN SYSTEMS'),(71297884041216,'Leco','LECO Corporation'),(71297884045312,'Mitsubis','Mitsubishi Heavy Industries, Ltd'),(71297884049408,'ShimizuE','Shimizu Electric Co., Ltd.'),(71297884053504,'Deskontr','deskontrol electronics'),(71297884057600,'AvantTec','Avant Technologies,Inc'),(71297884061696,'Next!SCS','NEXT! s.c. S.Piela B.Dryja'),(71297884065792,'YukoElec','YUKO ELECTRIC CO.,LTD'),(71297884069888,'Devialet','Devialet SA'),(71297884073984,'TopConne','Top Connect OU'),(71297884078080,'NvsTechn','NVS Technologies Inc'),(71297884082176,'Embed','Embed Limited'),(71297884086272,'VishayNo','Vishay Nobel AB'),(71297884090368,'Xadi','Xadi Inc'),(71297884094464,'Richter',''),(71297884098560,'StvElect','STV Electronic GmbH'),(71297884102656,'KeockoIn','Keocko International'),(71297884106752,'Medigus','Medigus Ltd'),(71297884110848,'Arago','ARAGO SYSTEMS'),(71297884114944,'TritonEl','Triton Electronics LTD'),(71297884119040,'Kyoritsu','Kyoritsu Electric Corp.'),(71297884123136,'Lightsta','LIGHTSTAR'),(71297884127232,'Heitec','HEITEC AG'),(71297884131328,'Hameg','HAMEG GmbH'),(71297884135424,'A-Z-E',''),(71297884139520,'WantechN','WANTECH Networks'),(71297884143616,'Sentry36','Sentry 360 Security'),(71297884147712,'Intellid','IntelliDesign Pty Ltd'),(71297884151808,'SiegmarZ','Siegmar Zander HuSWare'),(71297884155904,'GenesysE','GeneSys Elektronik GmbH'),(71297884160000,'Redwood','Redwood Systems'),(71297884164096,'Grossenb','Grossenbacher Systeme AG'),(71297884168192,'Sigmaphi','SigmaPhi Electronics'),(71297884172288,'Econ','ECON Systems Inc.'),(71297884176384,'MbConnec','MB Connect Line GmbH'),(71297884180480,'CstGroup','CST Group'),(71297884188672,'ComlineE','Comline Elektronik Elektrotechni'),(71297884192768,'BetterPl','Better Place'),(71297884196864,'InvisuaL','Invisua Lighting BV'),(71297884200960,'Marmitek','Marmitek BV'),(71297884205056,'InfomacS','InfoMac Sp. z o. o. Sp. k.'),(71297884209152,'EumigInd','eumig industrie-tv GmbH'),(71297884213248,'Monogram','MONOGRAM technologies ltd'),(71297884217344,'CytechTe','Cytech Technology Pte Ltd'),(71297884221440,'YuyamaMf','YUYAMAã€€MFGï¼Žï¼£ï¼¯ï¼Žï¼Œï¼¬ï¼'),(71297884225536,'TaskSist','TASK SISTEMAS DE COMPUTACAO S.A.'),(71297884229632,'EPGElett','e.p.g. Elettronica Srl'),(71297884233728,'PowerEle','Power Electronics'),(71297884237824,'PeekTraf','Peek Traffic Corporation'),(71297884241920,'ImpleSis','IMPLE SISTEMAS ELETRONICOS EMBAR'),(71297884246016,'TielineR','Tieline Research Pty Ltd'),(71297884250112,'Orbital','Orbital A/S'),(71297884254208,'SmithMet','Smith Meter, Inc'),(71297884258304,'AlphaDes','ALPHA DESIGN CO.,LTD.'),(71297884262400,'Rosslare','Rosslare Enterprises Limited'),(71297884266496,'DavisDer','DAVIS DERBY LIMITED'),(71297884270592,'So-Cool','So-Cool Corporation.'),(71297884274688,'Contrans','Contrans TI sp. z o.o.'),(71297884278784,'Rite-Tec','Rite-Tech Industrial CO., Ltd.'),(71297884282880,'Hks-Proz','HKS-Prozesstechnik GmbH'),(71297884286976,'CavalryS','CAVALRY STORAGE INC'),(71297884291072,'AplexTec','Aplex Technology Inc.'),(71297884295168,'GrupoEpe','Grupo Epelsa S.L.'),(71297884299264,'Hallibur','Halliburton - Sperry Drilling Se'),(71297884303360,'Testbook','Testbook Ltd'),(71297884307456,'GeneralD','GENERAL DYNAMICS C4 SYSTEMS'),(71297884311552,'MesaElec','MESA Electronic GmbH'),(71297884315648,'UniscanL','Uniscan LLC'),(71297884319744,'RcsEnerg','RCS Energy Management Limited'),(71297884323840,'Universi','University of Nebraska -- Lincol'),(71297884327936,'OooGroup','OOO Group of Industrial Technolo'),(71297884332032,'SiconSrl','Sicon srl'),(71297884336128,'Nanotron','nanoTRONIC GmbH'),(71297884340224,'Deuta-We','DEUTA-WERKE GmbH'),(71297884344320,'AcdElekt','ACD Elektronik GmBH'),(71297884348416,'Cemsi','CEMSI, Inc.'),(71297884352512,'KompanPa','KOMPAN Pawel Sokolowski'),(71297884356608,'Objectfa','ObjectFab GmbH'),(71297884360704,'Shanghai','shanghai Anjian Information tech'),(71297884364800,'AtxNetwo','ATX Networks Ltd.'),(71297884368896,'ZaoNpcKo','ZAO NPC  Kompjuternie Technologi'),(71297884372992,'DebugSRL','Debug s.r.l.'),(71297884377088,'Scandyna','Scandyna A/S'),(71297884381184,'Tti','TTI LTD'),(71297884385280,'Lightsta','LIGHTSTAR'),(71297884389376,'AkseSrl','Akse srl'),(71297884393472,'DspDesig','DSP DESIGN'),(71297884397568,'JadpodCo','Jadpod Communication Company Lim'),(71297884401664,'MangoDsp','Mango DSP, Inc.'),(71297884405760,'NspEurop','NSP Europe Ltd'),(71297884409856,'BiotageS','Biotage Sweden AB'),(71297884413952,'Canfield','Canfield Scientific, Inc.'),(71297884422144,'GspSprac','GSP Sprachtechnologie GmbH'),(71297884426240,'Emac','EMAC, INC.'),(71297884430336,'Aerovisi','AeroVision Avionics, Inc'),(71297884434432,'TattileS','Tattile srl'),(71297884438528,'Digitech','digitech GmbH &amp; Co. KG'),(71297884442624,'Globalco','GLOBALCOM ENGINEERING SRL'),(71297884446720,'Devrieco','Devriecom B.V.'),(71297884450816,'GdePolsk','GDE Polska'),(71297884454912,'CalonAss','Calon Associates Limited'),(71297884459008,'WowSyste','WOW System'),(71297884463104,'Supplier','Supplier Ind. e Com de Eletroele'),(71297884467200,'DavinTec','Davin Technologies Co.,Ltd'),(71297884471296,'Shanghai','shanghai anjian Information tech'),(71297884475392,'PermScie','Perm Scientific-Industrial Instr'),(71297884479488,'Hanatech',''),(71297884483584,'Zhejiang','Zhejiang Wellsun Electric Meter '),(71297884487680,'Innotran','InnoTrans Communications, Inc'),(71297884491776,'Key','Key Systems, Inc.'),(71297884495872,'Tetracor','Tetracore, Inc.'),(72746008576,'Rittal-W','RITTAL-WERK RUDOLF LOH GmbH & Co'),(977943920640,'SamsungE','Samsung Electronics Co.,Ltd'),(13400851611648,'Apple','Apple, Inc'),(13528761106432,'Apple','Apple, Inc.'),(18124476776448,'ZyxelCom','ZyXEL Communications Corp'),(22404696899584,'Zte','zte corporation'),(44029253255168,'Apple','Apple, Inc.'),(48865268989952,'Hivemoti','HiveMotion'),(52885643591680,'SamsungE','Samsung Electronics Co.,Ltd'),(53699053355008,'SamsungE','Samsung Electronics Co.,Ltd'),(57570815377408,'CargtHol','Cargt Holdings LLC'),(57760280477696,'Logitech','Logitech Far East'),(97553219584000,'SolemEle','SOLEM Electronique'),(105985314127872,'Radiflow','RADiflow Ltd.'),(127729676582912,'Fujitsu','Fujitsu Limited'),(128250760134656,'Powerlea','Powerleader Science and Technolo'),(128454771081216,'Giga-Byt','GIGA-BYTE TECHNOLOGY CO.,LTD.'),(132255414484992,'Will-Bur','The Will-Burt Company'),(137151291326464,'AeRefuso','AE REFUsol'),(141260098633728,'Shandong','ShanDong Tecsunrise  Co.,Ltd'),(145299465043968,'Alcatel-','Alcatel-Lucent'),(149909072248832,'XtaElect','XTA Electronics Ltd'),(154814814093312,'Actp','ACTP, Inc.'),(158772441907200,'AlphionI','Alphion India Private Limited'),(158987173494784,'ElveesNe','ELVEES NeoTek OJSC'),(159013698273280,'Accutron','Accutron Instruments Inc.'),(163528027668480,'Shenzhen','Shenzhen Coship Electronics Co.,'),(167593734307840,'Zte','zte corporation'),(172306907267072,'HewlettP','Hewlett Packard'),(172329522954240,'ShenZhen','Shen Zhen RND Electronic Co.,LTD'),(198335902253056,'Raytest','raytest GmbH'),(206987358896128,'CodacoEl','Codaco Electronic s.r.o.'),(215674282573824,'Technico','Technicolor USA Inc.'),(224333305741312,'SamsungE','Samsung Electronics Co.,Ltd'),(224790249996288,'Viscount','Viscount Systems Inc.'),(238141256499200,'Apple','Apple, Inc'),(255423919685632,'SamsungE','Samsung Electronics Co.,Ltd'),(268739257827328,'Adonit','Adonit Corp. Ltd.'),(272942185316352,'Softlink','Softlink Automation System Co., '),(278005029011456,'BeijingH','Beijing Hesun Technologies Co.Lt'),(119269937152,'TierraJa','Tierra Japan Co.,Ltd'),(71297884499968,'TokyoDra','Tokyo Drawing Ltd.'),(71297884504064,'Venco',''),(71297884508160,'WeberMar','Weber Marking Systems GmbH');
/*!40000 ALTER TABLE `manufacturers` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `parent`
--

DROP TABLE IF EXISTS `parent`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `parent` (
  `name` varchar(32) NOT NULL COMMENT 'Login name of the parent',
  `password` char(128) NOT NULL COMMENT 'Pass phrase for the parent',
  `description` varchar(128) DEFAULT NULL COMMENT 'Optional description',
  `parent_id` int(11) NOT NULL AUTO_INCREMENT,
  PRIMARY KEY (`parent_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Authentication table for controlling the app';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `parent`
--

LOCK TABLES `parent` WRITE;
/*!40000 ALTER TABLE `parent` DISABLE KEYS */;
INSERT INTO `parent` (name,password,description) VALUES('admin',md5('admin'),'Delete me');
/*!40000 ALTER TABLE `parent` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `reward`
--

DROP TABLE IF EXISTS `reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `reward` (
  `user_id` mediumint(9) NOT NULL COMMENT 'user ID of the little angel',
  `start` datetime NOT NULL COMMENT 'start of the guaranteed device use',
  `end` datetime NOT NULL COMMENT 'All good things must come to an end',
  PRIMARY KEY (`user_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Free use of the devices as a reward';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `reward`
--

--
-- Table structure for table `rules`
--

DROP TABLE IF EXISTS `rules`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `rules` (
  `user_id` mediumint(9) NOT NULL COMMENT 'The user ID of the child with this bedtime rule',
  `night` time NOT NULL COMMENT 'The time to go to bed',
  `morning` time NOT NULL COMMENT 'The time the device is released again',
  `days` tinyint(3) unsigned NOT NULL DEFAULT '254' COMMENT 'Byte flag of the days 0-Mon 7-Sun'
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='The bread and butter';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `settings`
--

DROP TABLE IF EXISTS `settings`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `settings` (
  `variable` varchar(16) NOT NULL COMMENT 'name of the variable - duh',
  `value` varchar(64) NOT NULL COMMENT 'and the free text value',
  PRIMARY KEY (`variable`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Miscellaneous settings for bedtime itself';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `settings`
--

LOCK TABLES `settings` WRITE;
/*!40000 ALTER TABLE `settings` DISABLE KEYS */;
INSERT INTO `settings` VALUES ('weekend','12');
/*!40000 ALTER TABLE `settings` ENABLE KEYS */;
UNLOCK TABLES;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;
